package org.eclipse.xtext.purexbase.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.xtext.purexbase.services.PureXbaseGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
/*******************************************************************************
 * Copyright (c) 2011, 2022 itemis AG (http://www.itemis.eu) and others.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *******************************************************************************/
@SuppressWarnings("all")
public class InternalPureXbaseParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_HEX", "RULE_INT", "RULE_DECIMAL", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'='", "'||'", "'&&'", "'val'", "'+='", "'-='", "'*='", "'/='", "'%='", "'=='", "'!='", "'==='", "'!=='", "'>='", "'>'", "'<'", "'->'", "'..<'", "'..'", "'=>'", "'<>'", "'?:'", "'+'", "'-'", "'*'", "'**'", "'/'", "'%'", "'!'", "'++'", "'--'", "'.'", "'super'", "'false'", "';'", "'try'", "'('", "')'", "'finally'", "':'", "'instanceof'", "'as'", "','", "'#'", "'{'", "'}'", "'['", "']'", "'if'", "'else'", "'switch'", "'default'", "'case'", "'for'", "'while'", "'do'", "'new'", "'null'", "'typeof'", "'throw'", "'return'", "'synchronized'", "'catch'", "'?'", "'extends'", "'&'", "'import'", "'var'", "'::'", "'?.'", "'|'", "'true'", "'static'", "'extension'"
    };
    public static final int RULE_HEX=5;
    public static final int T__50=50;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__59=59;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__55=55;
    public static final int T__56=56;
    public static final int T__13=13;
    public static final int T__57=57;
    public static final int T__14=14;
    public static final int T__58=58;
    public static final int T__51=51;
    public static final int T__52=52;
    public static final int T__53=53;
    public static final int T__54=54;
    public static final int T__60=60;
    public static final int T__61=61;
    public static final int RULE_ID=4;
    public static final int RULE_DECIMAL=7;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=6;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int T__66=66;
    public static final int RULE_ML_COMMENT=9;
    public static final int T__23=23;
    public static final int T__67=67;
    public static final int T__24=24;
    public static final int T__68=68;
    public static final int T__25=25;
    public static final int T__69=69;
    public static final int T__62=62;
    public static final int T__63=63;
    public static final int T__20=20;
    public static final int T__64=64;
    public static final int T__21=21;
    public static final int T__65=65;
    public static final int T__70=70;
    public static final int T__71=71;
    public static final int T__72=72;
    public static final int RULE_STRING=8;
    public static final int RULE_SL_COMMENT=10;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int T__33=33;
    public static final int T__77=77;
    public static final int T__34=34;
    public static final int T__78=78;
    public static final int T__35=35;
    public static final int T__79=79;
    public static final int T__36=36;
    public static final int T__73=73;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__74=74;
    public static final int T__31=31;
    public static final int T__75=75;
    public static final int T__32=32;
    public static final int T__76=76;
    public static final int T__80=80;
    public static final int T__81=81;
    public static final int T__82=82;
    public static final int T__83=83;
    public static final int RULE_WS=11;
    public static final int RULE_ANY_OTHER=12;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__40=40;
    public static final int T__84=84;
    public static final int T__41=41;
    public static final int T__85=85;
    public static final int T__42=42;
    public static final int T__86=86;
    public static final int T__43=43;

    // delegates
    // delegators


        public InternalPureXbaseParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalPureXbaseParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalPureXbaseParser.tokenNames; }
    public String getGrammarFileName() { return "InternalPureXbase.g"; }


    	private PureXbaseGrammarAccess grammarAccess;

    	public void setGrammarAccess(PureXbaseGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleModel"
    // InternalPureXbase.g:59:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // InternalPureXbase.g:60:1: ( ruleModel EOF )
            // InternalPureXbase.g:61:1: ruleModel EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getModelRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleModel();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getModelRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalPureXbase.g:68:1: ruleModel : ( ( rule__Model__Group__0 ) ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:72:2: ( ( ( rule__Model__Group__0 ) ) )
            // InternalPureXbase.g:73:2: ( ( rule__Model__Group__0 ) )
            {
            // InternalPureXbase.g:73:2: ( ( rule__Model__Group__0 ) )
            // InternalPureXbase.g:74:3: ( rule__Model__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getModelAccess().getGroup()); 
            }
            // InternalPureXbase.g:75:3: ( rule__Model__Group__0 )
            // InternalPureXbase.g:75:4: rule__Model__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Model__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getModelAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleSpecialBlockExpression"
    // InternalPureXbase.g:84:1: entryRuleSpecialBlockExpression : ruleSpecialBlockExpression EOF ;
    public final void entryRuleSpecialBlockExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:85:1: ( ruleSpecialBlockExpression EOF )
            // InternalPureXbase.g:86:1: ruleSpecialBlockExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleSpecialBlockExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSpecialBlockExpression"


    // $ANTLR start "ruleSpecialBlockExpression"
    // InternalPureXbase.g:93:1: ruleSpecialBlockExpression : ( ( rule__SpecialBlockExpression__Group__0 ) ) ;
    public final void ruleSpecialBlockExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:97:2: ( ( ( rule__SpecialBlockExpression__Group__0 ) ) )
            // InternalPureXbase.g:98:2: ( ( rule__SpecialBlockExpression__Group__0 ) )
            {
            // InternalPureXbase.g:98:2: ( ( rule__SpecialBlockExpression__Group__0 ) )
            // InternalPureXbase.g:99:3: ( rule__SpecialBlockExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:100:3: ( rule__SpecialBlockExpression__Group__0 )
            // InternalPureXbase.g:100:4: rule__SpecialBlockExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__SpecialBlockExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSpecialBlockExpression"


    // $ANTLR start "entryRuleFeatureCallID"
    // InternalPureXbase.g:109:1: entryRuleFeatureCallID : ruleFeatureCallID EOF ;
    public final void entryRuleFeatureCallID() throws RecognitionException {
        try {
            // InternalPureXbase.g:110:1: ( ruleFeatureCallID EOF )
            // InternalPureXbase.g:111:1: ruleFeatureCallID EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFeatureCallIDRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFeatureCallIDRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleFeatureCallID"


    // $ANTLR start "ruleFeatureCallID"
    // InternalPureXbase.g:118:1: ruleFeatureCallID : ( ruleValidID ) ;
    public final void ruleFeatureCallID() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:122:2: ( ( ruleValidID ) )
            // InternalPureXbase.g:123:2: ( ruleValidID )
            {
            // InternalPureXbase.g:123:2: ( ruleValidID )
            // InternalPureXbase.g:124:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFeatureCallIDAccess().getValidIDParserRuleCall()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFeatureCallIDAccess().getValidIDParserRuleCall()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleFeatureCallID"


    // $ANTLR start "entryRuleXTryCatchFinallyExpression"
    // InternalPureXbase.g:134:1: entryRuleXTryCatchFinallyExpression : ruleXTryCatchFinallyExpression EOF ;
    public final void entryRuleXTryCatchFinallyExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:135:1: ( ruleXTryCatchFinallyExpression EOF )
            // InternalPureXbase.g:136:1: ruleXTryCatchFinallyExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXTryCatchFinallyExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXTryCatchFinallyExpression"


    // $ANTLR start "ruleXTryCatchFinallyExpression"
    // InternalPureXbase.g:143:1: ruleXTryCatchFinallyExpression : ( ( rule__XTryCatchFinallyExpression__Group__0 ) ) ;
    public final void ruleXTryCatchFinallyExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:147:2: ( ( ( rule__XTryCatchFinallyExpression__Group__0 ) ) )
            // InternalPureXbase.g:148:2: ( ( rule__XTryCatchFinallyExpression__Group__0 ) )
            {
            // InternalPureXbase.g:148:2: ( ( rule__XTryCatchFinallyExpression__Group__0 ) )
            // InternalPureXbase.g:149:3: ( rule__XTryCatchFinallyExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:150:3: ( rule__XTryCatchFinallyExpression__Group__0 )
            // InternalPureXbase.g:150:4: rule__XTryCatchFinallyExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXTryCatchFinallyExpression"


    // $ANTLR start "entryRuleInitialisedVariableDeclaration"
    // InternalPureXbase.g:159:1: entryRuleInitialisedVariableDeclaration : ruleInitialisedVariableDeclaration EOF ;
    public final void entryRuleInitialisedVariableDeclaration() throws RecognitionException {
        try {
            // InternalPureXbase.g:160:1: ( ruleInitialisedVariableDeclaration EOF )
            // InternalPureXbase.g:161:1: ruleInitialisedVariableDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleInitialisedVariableDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleInitialisedVariableDeclaration"


    // $ANTLR start "ruleInitialisedVariableDeclaration"
    // InternalPureXbase.g:168:1: ruleInitialisedVariableDeclaration : ( ( rule__InitialisedVariableDeclaration__Group__0 ) ) ;
    public final void ruleInitialisedVariableDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:172:2: ( ( ( rule__InitialisedVariableDeclaration__Group__0 ) ) )
            // InternalPureXbase.g:173:2: ( ( rule__InitialisedVariableDeclaration__Group__0 ) )
            {
            // InternalPureXbase.g:173:2: ( ( rule__InitialisedVariableDeclaration__Group__0 ) )
            // InternalPureXbase.g:174:3: ( rule__InitialisedVariableDeclaration__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getGroup()); 
            }
            // InternalPureXbase.g:175:3: ( rule__InitialisedVariableDeclaration__Group__0 )
            // InternalPureXbase.g:175:4: rule__InitialisedVariableDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleInitialisedVariableDeclaration"


    // $ANTLR start "entryRuleXAssignment"
    // InternalPureXbase.g:184:1: entryRuleXAssignment : ruleXAssignment EOF ;
    public final void entryRuleXAssignment() throws RecognitionException {
        try {
            // InternalPureXbase.g:185:1: ( ruleXAssignment EOF )
            // InternalPureXbase.g:186:1: ruleXAssignment EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAssignment"


    // $ANTLR start "ruleXAssignment"
    // InternalPureXbase.g:193:1: ruleXAssignment : ( ( rule__XAssignment__Alternatives ) ) ;
    public final void ruleXAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:197:2: ( ( ( rule__XAssignment__Alternatives ) ) )
            // InternalPureXbase.g:198:2: ( ( rule__XAssignment__Alternatives ) )
            {
            // InternalPureXbase.g:198:2: ( ( rule__XAssignment__Alternatives ) )
            // InternalPureXbase.g:199:3: ( rule__XAssignment__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:200:3: ( rule__XAssignment__Alternatives )
            // InternalPureXbase.g:200:4: rule__XAssignment__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAssignment"


    // $ANTLR start "entryRuleXConditionalExpression"
    // InternalPureXbase.g:209:1: entryRuleXConditionalExpression : ruleXConditionalExpression EOF ;
    public final void entryRuleXConditionalExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:210:1: ( ruleXConditionalExpression EOF )
            // InternalPureXbase.g:211:1: ruleXConditionalExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXConditionalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXConditionalExpression"


    // $ANTLR start "ruleXConditionalExpression"
    // InternalPureXbase.g:218:1: ruleXConditionalExpression : ( ( rule__XConditionalExpression__Group__0 ) ) ;
    public final void ruleXConditionalExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:222:2: ( ( ( rule__XConditionalExpression__Group__0 ) ) )
            // InternalPureXbase.g:223:2: ( ( rule__XConditionalExpression__Group__0 ) )
            {
            // InternalPureXbase.g:223:2: ( ( rule__XConditionalExpression__Group__0 ) )
            // InternalPureXbase.g:224:3: ( rule__XConditionalExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:225:3: ( rule__XConditionalExpression__Group__0 )
            // InternalPureXbase.g:225:4: rule__XConditionalExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXConditionalExpression"


    // $ANTLR start "entryRuleXExpression"
    // InternalPureXbase.g:234:1: entryRuleXExpression : ruleXExpression EOF ;
    public final void entryRuleXExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:235:1: ( ruleXExpression EOF )
            // InternalPureXbase.g:236:1: ruleXExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXExpression"


    // $ANTLR start "ruleXExpression"
    // InternalPureXbase.g:243:1: ruleXExpression : ( ruleXAssignment ) ;
    public final void ruleXExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:247:2: ( ( ruleXAssignment ) )
            // InternalPureXbase.g:248:2: ( ruleXAssignment )
            {
            // InternalPureXbase.g:248:2: ( ruleXAssignment )
            // InternalPureXbase.g:249:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionAccess().getXAssignmentParserRuleCall()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionAccess().getXAssignmentParserRuleCall()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXExpression"


    // $ANTLR start "entryRuleOpSingleAssign"
    // InternalPureXbase.g:259:1: entryRuleOpSingleAssign : ruleOpSingleAssign EOF ;
    public final void entryRuleOpSingleAssign() throws RecognitionException {
        try {
            // InternalPureXbase.g:260:1: ( ruleOpSingleAssign EOF )
            // InternalPureXbase.g:261:1: ruleOpSingleAssign EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpSingleAssignRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpSingleAssignRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpSingleAssign"


    // $ANTLR start "ruleOpSingleAssign"
    // InternalPureXbase.g:268:1: ruleOpSingleAssign : ( '=' ) ;
    public final void ruleOpSingleAssign() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:272:2: ( ( '=' ) )
            // InternalPureXbase.g:273:2: ( '=' )
            {
            // InternalPureXbase.g:273:2: ( '=' )
            // InternalPureXbase.g:274:3: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpSingleAssignAccess().getEqualsSignKeyword()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpSingleAssignAccess().getEqualsSignKeyword()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpSingleAssign"


    // $ANTLR start "entryRuleOpMultiAssign"
    // InternalPureXbase.g:284:1: entryRuleOpMultiAssign : ruleOpMultiAssign EOF ;
    public final void entryRuleOpMultiAssign() throws RecognitionException {
        try {
            // InternalPureXbase.g:285:1: ( ruleOpMultiAssign EOF )
            // InternalPureXbase.g:286:1: ruleOpMultiAssign EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpMultiAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpMultiAssign"


    // $ANTLR start "ruleOpMultiAssign"
    // InternalPureXbase.g:293:1: ruleOpMultiAssign : ( ( rule__OpMultiAssign__Alternatives ) ) ;
    public final void ruleOpMultiAssign() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:297:2: ( ( ( rule__OpMultiAssign__Alternatives ) ) )
            // InternalPureXbase.g:298:2: ( ( rule__OpMultiAssign__Alternatives ) )
            {
            // InternalPureXbase.g:298:2: ( ( rule__OpMultiAssign__Alternatives ) )
            // InternalPureXbase.g:299:3: ( rule__OpMultiAssign__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:300:3: ( rule__OpMultiAssign__Alternatives )
            // InternalPureXbase.g:300:4: rule__OpMultiAssign__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpMultiAssign"


    // $ANTLR start "entryRuleXOrExpression"
    // InternalPureXbase.g:309:1: entryRuleXOrExpression : ruleXOrExpression EOF ;
    public final void entryRuleXOrExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:310:1: ( ruleXOrExpression EOF )
            // InternalPureXbase.g:311:1: ruleXOrExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXOrExpression"


    // $ANTLR start "ruleXOrExpression"
    // InternalPureXbase.g:318:1: ruleXOrExpression : ( ( rule__XOrExpression__Group__0 ) ) ;
    public final void ruleXOrExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:322:2: ( ( ( rule__XOrExpression__Group__0 ) ) )
            // InternalPureXbase.g:323:2: ( ( rule__XOrExpression__Group__0 ) )
            {
            // InternalPureXbase.g:323:2: ( ( rule__XOrExpression__Group__0 ) )
            // InternalPureXbase.g:324:3: ( rule__XOrExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:325:3: ( rule__XOrExpression__Group__0 )
            // InternalPureXbase.g:325:4: rule__XOrExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXOrExpression"


    // $ANTLR start "entryRuleOpOr"
    // InternalPureXbase.g:334:1: entryRuleOpOr : ruleOpOr EOF ;
    public final void entryRuleOpOr() throws RecognitionException {
        try {
            // InternalPureXbase.g:335:1: ( ruleOpOr EOF )
            // InternalPureXbase.g:336:1: ruleOpOr EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOrRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpOr();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOrRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpOr"


    // $ANTLR start "ruleOpOr"
    // InternalPureXbase.g:343:1: ruleOpOr : ( '||' ) ;
    public final void ruleOpOr() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:347:2: ( ( '||' ) )
            // InternalPureXbase.g:348:2: ( '||' )
            {
            // InternalPureXbase.g:348:2: ( '||' )
            // InternalPureXbase.g:349:3: '||'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOrAccess().getVerticalLineVerticalLineKeyword()); 
            }
            match(input,14,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOrAccess().getVerticalLineVerticalLineKeyword()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpOr"


    // $ANTLR start "entryRuleXAndExpression"
    // InternalPureXbase.g:359:1: entryRuleXAndExpression : ruleXAndExpression EOF ;
    public final void entryRuleXAndExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:360:1: ( ruleXAndExpression EOF )
            // InternalPureXbase.g:361:1: ruleXAndExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAndExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAndExpression"


    // $ANTLR start "ruleXAndExpression"
    // InternalPureXbase.g:368:1: ruleXAndExpression : ( ( rule__XAndExpression__Group__0 ) ) ;
    public final void ruleXAndExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:372:2: ( ( ( rule__XAndExpression__Group__0 ) ) )
            // InternalPureXbase.g:373:2: ( ( rule__XAndExpression__Group__0 ) )
            {
            // InternalPureXbase.g:373:2: ( ( rule__XAndExpression__Group__0 ) )
            // InternalPureXbase.g:374:3: ( rule__XAndExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:375:3: ( rule__XAndExpression__Group__0 )
            // InternalPureXbase.g:375:4: rule__XAndExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAndExpression"


    // $ANTLR start "entryRuleOpAnd"
    // InternalPureXbase.g:384:1: entryRuleOpAnd : ruleOpAnd EOF ;
    public final void entryRuleOpAnd() throws RecognitionException {
        try {
            // InternalPureXbase.g:385:1: ( ruleOpAnd EOF )
            // InternalPureXbase.g:386:1: ruleOpAnd EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAndRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpAnd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAndRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpAnd"


    // $ANTLR start "ruleOpAnd"
    // InternalPureXbase.g:393:1: ruleOpAnd : ( '&&' ) ;
    public final void ruleOpAnd() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:397:2: ( ( '&&' ) )
            // InternalPureXbase.g:398:2: ( '&&' )
            {
            // InternalPureXbase.g:398:2: ( '&&' )
            // InternalPureXbase.g:399:3: '&&'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAndAccess().getAmpersandAmpersandKeyword()); 
            }
            match(input,15,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAndAccess().getAmpersandAmpersandKeyword()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpAnd"


    // $ANTLR start "entryRuleXEqualityExpression"
    // InternalPureXbase.g:409:1: entryRuleXEqualityExpression : ruleXEqualityExpression EOF ;
    public final void entryRuleXEqualityExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:410:1: ( ruleXEqualityExpression EOF )
            // InternalPureXbase.g:411:1: ruleXEqualityExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXEqualityExpression"


    // $ANTLR start "ruleXEqualityExpression"
    // InternalPureXbase.g:418:1: ruleXEqualityExpression : ( ( rule__XEqualityExpression__Group__0 ) ) ;
    public final void ruleXEqualityExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:422:2: ( ( ( rule__XEqualityExpression__Group__0 ) ) )
            // InternalPureXbase.g:423:2: ( ( rule__XEqualityExpression__Group__0 ) )
            {
            // InternalPureXbase.g:423:2: ( ( rule__XEqualityExpression__Group__0 ) )
            // InternalPureXbase.g:424:3: ( rule__XEqualityExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:425:3: ( rule__XEqualityExpression__Group__0 )
            // InternalPureXbase.g:425:4: rule__XEqualityExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXEqualityExpression"


    // $ANTLR start "entryRuleOpEquality"
    // InternalPureXbase.g:434:1: entryRuleOpEquality : ruleOpEquality EOF ;
    public final void entryRuleOpEquality() throws RecognitionException {
        try {
            // InternalPureXbase.g:435:1: ( ruleOpEquality EOF )
            // InternalPureXbase.g:436:1: ruleOpEquality EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpEqualityRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpEquality();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpEqualityRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpEquality"


    // $ANTLR start "ruleOpEquality"
    // InternalPureXbase.g:443:1: ruleOpEquality : ( ( rule__OpEquality__Alternatives ) ) ;
    public final void ruleOpEquality() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:447:2: ( ( ( rule__OpEquality__Alternatives ) ) )
            // InternalPureXbase.g:448:2: ( ( rule__OpEquality__Alternatives ) )
            {
            // InternalPureXbase.g:448:2: ( ( rule__OpEquality__Alternatives ) )
            // InternalPureXbase.g:449:3: ( rule__OpEquality__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpEqualityAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:450:3: ( rule__OpEquality__Alternatives )
            // InternalPureXbase.g:450:4: rule__OpEquality__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpEquality__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpEqualityAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpEquality"


    // $ANTLR start "entryRuleXRelationalExpression"
    // InternalPureXbase.g:459:1: entryRuleXRelationalExpression : ruleXRelationalExpression EOF ;
    public final void entryRuleXRelationalExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:460:1: ( ruleXRelationalExpression EOF )
            // InternalPureXbase.g:461:1: ruleXRelationalExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXRelationalExpression"


    // $ANTLR start "ruleXRelationalExpression"
    // InternalPureXbase.g:468:1: ruleXRelationalExpression : ( ( rule__XRelationalExpression__Group__0 ) ) ;
    public final void ruleXRelationalExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:472:2: ( ( ( rule__XRelationalExpression__Group__0 ) ) )
            // InternalPureXbase.g:473:2: ( ( rule__XRelationalExpression__Group__0 ) )
            {
            // InternalPureXbase.g:473:2: ( ( rule__XRelationalExpression__Group__0 ) )
            // InternalPureXbase.g:474:3: ( rule__XRelationalExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:475:3: ( rule__XRelationalExpression__Group__0 )
            // InternalPureXbase.g:475:4: rule__XRelationalExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXRelationalExpression"


    // $ANTLR start "entryRuleOpCompare"
    // InternalPureXbase.g:484:1: entryRuleOpCompare : ruleOpCompare EOF ;
    public final void entryRuleOpCompare() throws RecognitionException {
        try {
            // InternalPureXbase.g:485:1: ( ruleOpCompare EOF )
            // InternalPureXbase.g:486:1: ruleOpCompare EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpCompare();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpCompare"


    // $ANTLR start "ruleOpCompare"
    // InternalPureXbase.g:493:1: ruleOpCompare : ( ( rule__OpCompare__Alternatives ) ) ;
    public final void ruleOpCompare() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:497:2: ( ( ( rule__OpCompare__Alternatives ) ) )
            // InternalPureXbase.g:498:2: ( ( rule__OpCompare__Alternatives ) )
            {
            // InternalPureXbase.g:498:2: ( ( rule__OpCompare__Alternatives ) )
            // InternalPureXbase.g:499:3: ( rule__OpCompare__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:500:3: ( rule__OpCompare__Alternatives )
            // InternalPureXbase.g:500:4: rule__OpCompare__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpCompare__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpCompare"


    // $ANTLR start "entryRuleXOtherOperatorExpression"
    // InternalPureXbase.g:509:1: entryRuleXOtherOperatorExpression : ruleXOtherOperatorExpression EOF ;
    public final void entryRuleXOtherOperatorExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:510:1: ( ruleXOtherOperatorExpression EOF )
            // InternalPureXbase.g:511:1: ruleXOtherOperatorExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXOtherOperatorExpression"


    // $ANTLR start "ruleXOtherOperatorExpression"
    // InternalPureXbase.g:518:1: ruleXOtherOperatorExpression : ( ( rule__XOtherOperatorExpression__Group__0 ) ) ;
    public final void ruleXOtherOperatorExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:522:2: ( ( ( rule__XOtherOperatorExpression__Group__0 ) ) )
            // InternalPureXbase.g:523:2: ( ( rule__XOtherOperatorExpression__Group__0 ) )
            {
            // InternalPureXbase.g:523:2: ( ( rule__XOtherOperatorExpression__Group__0 ) )
            // InternalPureXbase.g:524:3: ( rule__XOtherOperatorExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:525:3: ( rule__XOtherOperatorExpression__Group__0 )
            // InternalPureXbase.g:525:4: rule__XOtherOperatorExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXOtherOperatorExpression"


    // $ANTLR start "entryRuleOpOther"
    // InternalPureXbase.g:534:1: entryRuleOpOther : ruleOpOther EOF ;
    public final void entryRuleOpOther() throws RecognitionException {
        try {
            // InternalPureXbase.g:535:1: ( ruleOpOther EOF )
            // InternalPureXbase.g:536:1: ruleOpOther EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpOther();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpOther"


    // $ANTLR start "ruleOpOther"
    // InternalPureXbase.g:543:1: ruleOpOther : ( ( rule__OpOther__Alternatives ) ) ;
    public final void ruleOpOther() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:547:2: ( ( ( rule__OpOther__Alternatives ) ) )
            // InternalPureXbase.g:548:2: ( ( rule__OpOther__Alternatives ) )
            {
            // InternalPureXbase.g:548:2: ( ( rule__OpOther__Alternatives ) )
            // InternalPureXbase.g:549:3: ( rule__OpOther__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:550:3: ( rule__OpOther__Alternatives )
            // InternalPureXbase.g:550:4: rule__OpOther__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpOther"


    // $ANTLR start "entryRuleXAdditiveExpression"
    // InternalPureXbase.g:559:1: entryRuleXAdditiveExpression : ruleXAdditiveExpression EOF ;
    public final void entryRuleXAdditiveExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:560:1: ( ruleXAdditiveExpression EOF )
            // InternalPureXbase.g:561:1: ruleXAdditiveExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAdditiveExpression"


    // $ANTLR start "ruleXAdditiveExpression"
    // InternalPureXbase.g:568:1: ruleXAdditiveExpression : ( ( rule__XAdditiveExpression__Group__0 ) ) ;
    public final void ruleXAdditiveExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:572:2: ( ( ( rule__XAdditiveExpression__Group__0 ) ) )
            // InternalPureXbase.g:573:2: ( ( rule__XAdditiveExpression__Group__0 ) )
            {
            // InternalPureXbase.g:573:2: ( ( rule__XAdditiveExpression__Group__0 ) )
            // InternalPureXbase.g:574:3: ( rule__XAdditiveExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:575:3: ( rule__XAdditiveExpression__Group__0 )
            // InternalPureXbase.g:575:4: rule__XAdditiveExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAdditiveExpression"


    // $ANTLR start "entryRuleOpAdd"
    // InternalPureXbase.g:584:1: entryRuleOpAdd : ruleOpAdd EOF ;
    public final void entryRuleOpAdd() throws RecognitionException {
        try {
            // InternalPureXbase.g:585:1: ( ruleOpAdd EOF )
            // InternalPureXbase.g:586:1: ruleOpAdd EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAddRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpAdd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAddRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpAdd"


    // $ANTLR start "ruleOpAdd"
    // InternalPureXbase.g:593:1: ruleOpAdd : ( ( rule__OpAdd__Alternatives ) ) ;
    public final void ruleOpAdd() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:597:2: ( ( ( rule__OpAdd__Alternatives ) ) )
            // InternalPureXbase.g:598:2: ( ( rule__OpAdd__Alternatives ) )
            {
            // InternalPureXbase.g:598:2: ( ( rule__OpAdd__Alternatives ) )
            // InternalPureXbase.g:599:3: ( rule__OpAdd__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAddAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:600:3: ( rule__OpAdd__Alternatives )
            // InternalPureXbase.g:600:4: rule__OpAdd__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpAdd__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAddAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpAdd"


    // $ANTLR start "entryRuleXMultiplicativeExpression"
    // InternalPureXbase.g:609:1: entryRuleXMultiplicativeExpression : ruleXMultiplicativeExpression EOF ;
    public final void entryRuleXMultiplicativeExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:610:1: ( ruleXMultiplicativeExpression EOF )
            // InternalPureXbase.g:611:1: ruleXMultiplicativeExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXMultiplicativeExpression"


    // $ANTLR start "ruleXMultiplicativeExpression"
    // InternalPureXbase.g:618:1: ruleXMultiplicativeExpression : ( ( rule__XMultiplicativeExpression__Group__0 ) ) ;
    public final void ruleXMultiplicativeExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:622:2: ( ( ( rule__XMultiplicativeExpression__Group__0 ) ) )
            // InternalPureXbase.g:623:2: ( ( rule__XMultiplicativeExpression__Group__0 ) )
            {
            // InternalPureXbase.g:623:2: ( ( rule__XMultiplicativeExpression__Group__0 ) )
            // InternalPureXbase.g:624:3: ( rule__XMultiplicativeExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:625:3: ( rule__XMultiplicativeExpression__Group__0 )
            // InternalPureXbase.g:625:4: rule__XMultiplicativeExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXMultiplicativeExpression"


    // $ANTLR start "entryRuleOpMulti"
    // InternalPureXbase.g:634:1: entryRuleOpMulti : ruleOpMulti EOF ;
    public final void entryRuleOpMulti() throws RecognitionException {
        try {
            // InternalPureXbase.g:635:1: ( ruleOpMulti EOF )
            // InternalPureXbase.g:636:1: ruleOpMulti EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpMulti();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpMulti"


    // $ANTLR start "ruleOpMulti"
    // InternalPureXbase.g:643:1: ruleOpMulti : ( ( rule__OpMulti__Alternatives ) ) ;
    public final void ruleOpMulti() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:647:2: ( ( ( rule__OpMulti__Alternatives ) ) )
            // InternalPureXbase.g:648:2: ( ( rule__OpMulti__Alternatives ) )
            {
            // InternalPureXbase.g:648:2: ( ( rule__OpMulti__Alternatives ) )
            // InternalPureXbase.g:649:3: ( rule__OpMulti__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:650:3: ( rule__OpMulti__Alternatives )
            // InternalPureXbase.g:650:4: rule__OpMulti__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpMulti__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpMulti"


    // $ANTLR start "entryRuleXUnaryOperation"
    // InternalPureXbase.g:659:1: entryRuleXUnaryOperation : ruleXUnaryOperation EOF ;
    public final void entryRuleXUnaryOperation() throws RecognitionException {
        try {
            // InternalPureXbase.g:660:1: ( ruleXUnaryOperation EOF )
            // InternalPureXbase.g:661:1: ruleXUnaryOperation EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXUnaryOperation"


    // $ANTLR start "ruleXUnaryOperation"
    // InternalPureXbase.g:668:1: ruleXUnaryOperation : ( ( rule__XUnaryOperation__Alternatives ) ) ;
    public final void ruleXUnaryOperation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:672:2: ( ( ( rule__XUnaryOperation__Alternatives ) ) )
            // InternalPureXbase.g:673:2: ( ( rule__XUnaryOperation__Alternatives ) )
            {
            // InternalPureXbase.g:673:2: ( ( rule__XUnaryOperation__Alternatives ) )
            // InternalPureXbase.g:674:3: ( rule__XUnaryOperation__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:675:3: ( rule__XUnaryOperation__Alternatives )
            // InternalPureXbase.g:675:4: rule__XUnaryOperation__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXUnaryOperation"


    // $ANTLR start "entryRuleOpUnary"
    // InternalPureXbase.g:684:1: entryRuleOpUnary : ruleOpUnary EOF ;
    public final void entryRuleOpUnary() throws RecognitionException {
        try {
            // InternalPureXbase.g:685:1: ( ruleOpUnary EOF )
            // InternalPureXbase.g:686:1: ruleOpUnary EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpUnaryRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpUnary();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpUnaryRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpUnary"


    // $ANTLR start "ruleOpUnary"
    // InternalPureXbase.g:693:1: ruleOpUnary : ( ( rule__OpUnary__Alternatives ) ) ;
    public final void ruleOpUnary() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:697:2: ( ( ( rule__OpUnary__Alternatives ) ) )
            // InternalPureXbase.g:698:2: ( ( rule__OpUnary__Alternatives ) )
            {
            // InternalPureXbase.g:698:2: ( ( rule__OpUnary__Alternatives ) )
            // InternalPureXbase.g:699:3: ( rule__OpUnary__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpUnaryAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:700:3: ( rule__OpUnary__Alternatives )
            // InternalPureXbase.g:700:4: rule__OpUnary__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpUnary__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpUnaryAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpUnary"


    // $ANTLR start "entryRuleXCastedExpression"
    // InternalPureXbase.g:709:1: entryRuleXCastedExpression : ruleXCastedExpression EOF ;
    public final void entryRuleXCastedExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:710:1: ( ruleXCastedExpression EOF )
            // InternalPureXbase.g:711:1: ruleXCastedExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCastedExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCastedExpression"


    // $ANTLR start "ruleXCastedExpression"
    // InternalPureXbase.g:718:1: ruleXCastedExpression : ( ( rule__XCastedExpression__Group__0 ) ) ;
    public final void ruleXCastedExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:722:2: ( ( ( rule__XCastedExpression__Group__0 ) ) )
            // InternalPureXbase.g:723:2: ( ( rule__XCastedExpression__Group__0 ) )
            {
            // InternalPureXbase.g:723:2: ( ( rule__XCastedExpression__Group__0 ) )
            // InternalPureXbase.g:724:3: ( rule__XCastedExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:725:3: ( rule__XCastedExpression__Group__0 )
            // InternalPureXbase.g:725:4: rule__XCastedExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCastedExpression"


    // $ANTLR start "entryRuleXPostfixOperation"
    // InternalPureXbase.g:734:1: entryRuleXPostfixOperation : ruleXPostfixOperation EOF ;
    public final void entryRuleXPostfixOperation() throws RecognitionException {
        try {
            // InternalPureXbase.g:735:1: ( ruleXPostfixOperation EOF )
            // InternalPureXbase.g:736:1: ruleXPostfixOperation EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXPostfixOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXPostfixOperation"


    // $ANTLR start "ruleXPostfixOperation"
    // InternalPureXbase.g:743:1: ruleXPostfixOperation : ( ( rule__XPostfixOperation__Group__0 ) ) ;
    public final void ruleXPostfixOperation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:747:2: ( ( ( rule__XPostfixOperation__Group__0 ) ) )
            // InternalPureXbase.g:748:2: ( ( rule__XPostfixOperation__Group__0 ) )
            {
            // InternalPureXbase.g:748:2: ( ( rule__XPostfixOperation__Group__0 ) )
            // InternalPureXbase.g:749:3: ( rule__XPostfixOperation__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getGroup()); 
            }
            // InternalPureXbase.g:750:3: ( rule__XPostfixOperation__Group__0 )
            // InternalPureXbase.g:750:4: rule__XPostfixOperation__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXPostfixOperation"


    // $ANTLR start "entryRuleOpPostfix"
    // InternalPureXbase.g:759:1: entryRuleOpPostfix : ruleOpPostfix EOF ;
    public final void entryRuleOpPostfix() throws RecognitionException {
        try {
            // InternalPureXbase.g:760:1: ( ruleOpPostfix EOF )
            // InternalPureXbase.g:761:1: ruleOpPostfix EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpPostfixRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpPostfix();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpPostfixRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpPostfix"


    // $ANTLR start "ruleOpPostfix"
    // InternalPureXbase.g:768:1: ruleOpPostfix : ( ( rule__OpPostfix__Alternatives ) ) ;
    public final void ruleOpPostfix() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:772:2: ( ( ( rule__OpPostfix__Alternatives ) ) )
            // InternalPureXbase.g:773:2: ( ( rule__OpPostfix__Alternatives ) )
            {
            // InternalPureXbase.g:773:2: ( ( rule__OpPostfix__Alternatives ) )
            // InternalPureXbase.g:774:3: ( rule__OpPostfix__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpPostfixAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:775:3: ( rule__OpPostfix__Alternatives )
            // InternalPureXbase.g:775:4: rule__OpPostfix__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpPostfix__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpPostfixAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpPostfix"


    // $ANTLR start "entryRuleXMemberFeatureCall"
    // InternalPureXbase.g:784:1: entryRuleXMemberFeatureCall : ruleXMemberFeatureCall EOF ;
    public final void entryRuleXMemberFeatureCall() throws RecognitionException {
        try {
            // InternalPureXbase.g:785:1: ( ruleXMemberFeatureCall EOF )
            // InternalPureXbase.g:786:1: ruleXMemberFeatureCall EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXMemberFeatureCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXMemberFeatureCall"


    // $ANTLR start "ruleXMemberFeatureCall"
    // InternalPureXbase.g:793:1: ruleXMemberFeatureCall : ( ( rule__XMemberFeatureCall__Group__0 ) ) ;
    public final void ruleXMemberFeatureCall() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:797:2: ( ( ( rule__XMemberFeatureCall__Group__0 ) ) )
            // InternalPureXbase.g:798:2: ( ( rule__XMemberFeatureCall__Group__0 ) )
            {
            // InternalPureXbase.g:798:2: ( ( rule__XMemberFeatureCall__Group__0 ) )
            // InternalPureXbase.g:799:3: ( rule__XMemberFeatureCall__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup()); 
            }
            // InternalPureXbase.g:800:3: ( rule__XMemberFeatureCall__Group__0 )
            // InternalPureXbase.g:800:4: rule__XMemberFeatureCall__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXMemberFeatureCall"


    // $ANTLR start "entryRuleXPrimaryExpression"
    // InternalPureXbase.g:809:1: entryRuleXPrimaryExpression : ruleXPrimaryExpression EOF ;
    public final void entryRuleXPrimaryExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:810:1: ( ruleXPrimaryExpression EOF )
            // InternalPureXbase.g:811:1: ruleXPrimaryExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPrimaryExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXPrimaryExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPrimaryExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXPrimaryExpression"


    // $ANTLR start "ruleXPrimaryExpression"
    // InternalPureXbase.g:818:1: ruleXPrimaryExpression : ( ( rule__XPrimaryExpression__Alternatives ) ) ;
    public final void ruleXPrimaryExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:822:2: ( ( ( rule__XPrimaryExpression__Alternatives ) ) )
            // InternalPureXbase.g:823:2: ( ( rule__XPrimaryExpression__Alternatives ) )
            {
            // InternalPureXbase.g:823:2: ( ( rule__XPrimaryExpression__Alternatives ) )
            // InternalPureXbase.g:824:3: ( rule__XPrimaryExpression__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPrimaryExpressionAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:825:3: ( rule__XPrimaryExpression__Alternatives )
            // InternalPureXbase.g:825:4: rule__XPrimaryExpression__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XPrimaryExpression__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPrimaryExpressionAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXPrimaryExpression"


    // $ANTLR start "entryRuleXLiteral"
    // InternalPureXbase.g:834:1: entryRuleXLiteral : ruleXLiteral EOF ;
    public final void entryRuleXLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:835:1: ( ruleXLiteral EOF )
            // InternalPureXbase.g:836:1: ruleXLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXLiteral"


    // $ANTLR start "ruleXLiteral"
    // InternalPureXbase.g:843:1: ruleXLiteral : ( ( rule__XLiteral__Alternatives ) ) ;
    public final void ruleXLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:847:2: ( ( ( rule__XLiteral__Alternatives ) ) )
            // InternalPureXbase.g:848:2: ( ( rule__XLiteral__Alternatives ) )
            {
            // InternalPureXbase.g:848:2: ( ( rule__XLiteral__Alternatives ) )
            // InternalPureXbase.g:849:3: ( rule__XLiteral__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXLiteralAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:850:3: ( rule__XLiteral__Alternatives )
            // InternalPureXbase.g:850:4: rule__XLiteral__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XLiteral__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXLiteralAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXLiteral"


    // $ANTLR start "entryRuleXCollectionLiteral"
    // InternalPureXbase.g:859:1: entryRuleXCollectionLiteral : ruleXCollectionLiteral EOF ;
    public final void entryRuleXCollectionLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:860:1: ( ruleXCollectionLiteral EOF )
            // InternalPureXbase.g:861:1: ruleXCollectionLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCollectionLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCollectionLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCollectionLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCollectionLiteral"


    // $ANTLR start "ruleXCollectionLiteral"
    // InternalPureXbase.g:868:1: ruleXCollectionLiteral : ( ( rule__XCollectionLiteral__Alternatives ) ) ;
    public final void ruleXCollectionLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:872:2: ( ( ( rule__XCollectionLiteral__Alternatives ) ) )
            // InternalPureXbase.g:873:2: ( ( rule__XCollectionLiteral__Alternatives ) )
            {
            // InternalPureXbase.g:873:2: ( ( rule__XCollectionLiteral__Alternatives ) )
            // InternalPureXbase.g:874:3: ( rule__XCollectionLiteral__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCollectionLiteralAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:875:3: ( rule__XCollectionLiteral__Alternatives )
            // InternalPureXbase.g:875:4: rule__XCollectionLiteral__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XCollectionLiteral__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCollectionLiteralAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCollectionLiteral"


    // $ANTLR start "entryRuleXSetLiteral"
    // InternalPureXbase.g:884:1: entryRuleXSetLiteral : ruleXSetLiteral EOF ;
    public final void entryRuleXSetLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:885:1: ( ruleXSetLiteral EOF )
            // InternalPureXbase.g:886:1: ruleXSetLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXSetLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXSetLiteral"


    // $ANTLR start "ruleXSetLiteral"
    // InternalPureXbase.g:893:1: ruleXSetLiteral : ( ( rule__XSetLiteral__Group__0 ) ) ;
    public final void ruleXSetLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:897:2: ( ( ( rule__XSetLiteral__Group__0 ) ) )
            // InternalPureXbase.g:898:2: ( ( rule__XSetLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:898:2: ( ( rule__XSetLiteral__Group__0 ) )
            // InternalPureXbase.g:899:3: ( rule__XSetLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:900:3: ( rule__XSetLiteral__Group__0 )
            // InternalPureXbase.g:900:4: rule__XSetLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXSetLiteral"


    // $ANTLR start "entryRuleXListLiteral"
    // InternalPureXbase.g:909:1: entryRuleXListLiteral : ruleXListLiteral EOF ;
    public final void entryRuleXListLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:910:1: ( ruleXListLiteral EOF )
            // InternalPureXbase.g:911:1: ruleXListLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXListLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXListLiteral"


    // $ANTLR start "ruleXListLiteral"
    // InternalPureXbase.g:918:1: ruleXListLiteral : ( ( rule__XListLiteral__Group__0 ) ) ;
    public final void ruleXListLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:922:2: ( ( ( rule__XListLiteral__Group__0 ) ) )
            // InternalPureXbase.g:923:2: ( ( rule__XListLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:923:2: ( ( rule__XListLiteral__Group__0 ) )
            // InternalPureXbase.g:924:3: ( rule__XListLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:925:3: ( rule__XListLiteral__Group__0 )
            // InternalPureXbase.g:925:4: rule__XListLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXListLiteral"


    // $ANTLR start "entryRuleXClosure"
    // InternalPureXbase.g:934:1: entryRuleXClosure : ruleXClosure EOF ;
    public final void entryRuleXClosure() throws RecognitionException {
        try {
            // InternalPureXbase.g:935:1: ( ruleXClosure EOF )
            // InternalPureXbase.g:936:1: ruleXClosure EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXClosure"


    // $ANTLR start "ruleXClosure"
    // InternalPureXbase.g:943:1: ruleXClosure : ( ( rule__XClosure__Group__0 ) ) ;
    public final void ruleXClosure() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:947:2: ( ( ( rule__XClosure__Group__0 ) ) )
            // InternalPureXbase.g:948:2: ( ( rule__XClosure__Group__0 ) )
            {
            // InternalPureXbase.g:948:2: ( ( rule__XClosure__Group__0 ) )
            // InternalPureXbase.g:949:3: ( rule__XClosure__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup()); 
            }
            // InternalPureXbase.g:950:3: ( rule__XClosure__Group__0 )
            // InternalPureXbase.g:950:4: rule__XClosure__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXClosure"


    // $ANTLR start "entryRuleXExpressionInClosure"
    // InternalPureXbase.g:959:1: entryRuleXExpressionInClosure : ruleXExpressionInClosure EOF ;
    public final void entryRuleXExpressionInClosure() throws RecognitionException {
        try {
            // InternalPureXbase.g:960:1: ( ruleXExpressionInClosure EOF )
            // InternalPureXbase.g:961:1: ruleXExpressionInClosure EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXExpressionInClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXExpressionInClosure"


    // $ANTLR start "ruleXExpressionInClosure"
    // InternalPureXbase.g:968:1: ruleXExpressionInClosure : ( ( rule__XExpressionInClosure__Group__0 ) ) ;
    public final void ruleXExpressionInClosure() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:972:2: ( ( ( rule__XExpressionInClosure__Group__0 ) ) )
            // InternalPureXbase.g:973:2: ( ( rule__XExpressionInClosure__Group__0 ) )
            {
            // InternalPureXbase.g:973:2: ( ( rule__XExpressionInClosure__Group__0 ) )
            // InternalPureXbase.g:974:3: ( rule__XExpressionInClosure__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getGroup()); 
            }
            // InternalPureXbase.g:975:3: ( rule__XExpressionInClosure__Group__0 )
            // InternalPureXbase.g:975:4: rule__XExpressionInClosure__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXExpressionInClosure"


    // $ANTLR start "entryRuleXShortClosure"
    // InternalPureXbase.g:984:1: entryRuleXShortClosure : ruleXShortClosure EOF ;
    public final void entryRuleXShortClosure() throws RecognitionException {
        try {
            // InternalPureXbase.g:985:1: ( ruleXShortClosure EOF )
            // InternalPureXbase.g:986:1: ruleXShortClosure EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXShortClosure"


    // $ANTLR start "ruleXShortClosure"
    // InternalPureXbase.g:993:1: ruleXShortClosure : ( ( rule__XShortClosure__Group__0 ) ) ;
    public final void ruleXShortClosure() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:997:2: ( ( ( rule__XShortClosure__Group__0 ) ) )
            // InternalPureXbase.g:998:2: ( ( rule__XShortClosure__Group__0 ) )
            {
            // InternalPureXbase.g:998:2: ( ( rule__XShortClosure__Group__0 ) )
            // InternalPureXbase.g:999:3: ( rule__XShortClosure__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup()); 
            }
            // InternalPureXbase.g:1000:3: ( rule__XShortClosure__Group__0 )
            // InternalPureXbase.g:1000:4: rule__XShortClosure__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXShortClosure"


    // $ANTLR start "entryRuleXParenthesizedExpression"
    // InternalPureXbase.g:1009:1: entryRuleXParenthesizedExpression : ruleXParenthesizedExpression EOF ;
    public final void entryRuleXParenthesizedExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1010:1: ( ruleXParenthesizedExpression EOF )
            // InternalPureXbase.g:1011:1: ruleXParenthesizedExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXParenthesizedExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXParenthesizedExpression"


    // $ANTLR start "ruleXParenthesizedExpression"
    // InternalPureXbase.g:1018:1: ruleXParenthesizedExpression : ( ( rule__XParenthesizedExpression__Group__0 ) ) ;
    public final void ruleXParenthesizedExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1022:2: ( ( ( rule__XParenthesizedExpression__Group__0 ) ) )
            // InternalPureXbase.g:1023:2: ( ( rule__XParenthesizedExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1023:2: ( ( rule__XParenthesizedExpression__Group__0 ) )
            // InternalPureXbase.g:1024:3: ( rule__XParenthesizedExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1025:3: ( rule__XParenthesizedExpression__Group__0 )
            // InternalPureXbase.g:1025:4: rule__XParenthesizedExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXParenthesizedExpression"


    // $ANTLR start "entryRuleXIfExpression"
    // InternalPureXbase.g:1034:1: entryRuleXIfExpression : ruleXIfExpression EOF ;
    public final void entryRuleXIfExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1035:1: ( ruleXIfExpression EOF )
            // InternalPureXbase.g:1036:1: ruleXIfExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXIfExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXIfExpression"


    // $ANTLR start "ruleXIfExpression"
    // InternalPureXbase.g:1043:1: ruleXIfExpression : ( ( rule__XIfExpression__Group__0 ) ) ;
    public final void ruleXIfExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1047:2: ( ( ( rule__XIfExpression__Group__0 ) ) )
            // InternalPureXbase.g:1048:2: ( ( rule__XIfExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1048:2: ( ( rule__XIfExpression__Group__0 ) )
            // InternalPureXbase.g:1049:3: ( rule__XIfExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1050:3: ( rule__XIfExpression__Group__0 )
            // InternalPureXbase.g:1050:4: rule__XIfExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXIfExpression"


    // $ANTLR start "entryRuleXSwitchExpression"
    // InternalPureXbase.g:1059:1: entryRuleXSwitchExpression : ruleXSwitchExpression EOF ;
    public final void entryRuleXSwitchExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1060:1: ( ruleXSwitchExpression EOF )
            // InternalPureXbase.g:1061:1: ruleXSwitchExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXSwitchExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXSwitchExpression"


    // $ANTLR start "ruleXSwitchExpression"
    // InternalPureXbase.g:1068:1: ruleXSwitchExpression : ( ( rule__XSwitchExpression__Group__0 ) ) ;
    public final void ruleXSwitchExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1072:2: ( ( ( rule__XSwitchExpression__Group__0 ) ) )
            // InternalPureXbase.g:1073:2: ( ( rule__XSwitchExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1073:2: ( ( rule__XSwitchExpression__Group__0 ) )
            // InternalPureXbase.g:1074:3: ( rule__XSwitchExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1075:3: ( rule__XSwitchExpression__Group__0 )
            // InternalPureXbase.g:1075:4: rule__XSwitchExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXSwitchExpression"


    // $ANTLR start "entryRuleXCasePart"
    // InternalPureXbase.g:1084:1: entryRuleXCasePart : ruleXCasePart EOF ;
    public final void entryRuleXCasePart() throws RecognitionException {
        try {
            // InternalPureXbase.g:1085:1: ( ruleXCasePart EOF )
            // InternalPureXbase.g:1086:1: ruleXCasePart EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCasePart();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCasePart"


    // $ANTLR start "ruleXCasePart"
    // InternalPureXbase.g:1093:1: ruleXCasePart : ( ( rule__XCasePart__Group__0 ) ) ;
    public final void ruleXCasePart() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1097:2: ( ( ( rule__XCasePart__Group__0 ) ) )
            // InternalPureXbase.g:1098:2: ( ( rule__XCasePart__Group__0 ) )
            {
            // InternalPureXbase.g:1098:2: ( ( rule__XCasePart__Group__0 ) )
            // InternalPureXbase.g:1099:3: ( rule__XCasePart__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getGroup()); 
            }
            // InternalPureXbase.g:1100:3: ( rule__XCasePart__Group__0 )
            // InternalPureXbase.g:1100:4: rule__XCasePart__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCasePart"


    // $ANTLR start "entryRuleXForLoopExpression"
    // InternalPureXbase.g:1109:1: entryRuleXForLoopExpression : ruleXForLoopExpression EOF ;
    public final void entryRuleXForLoopExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1110:1: ( ruleXForLoopExpression EOF )
            // InternalPureXbase.g:1111:1: ruleXForLoopExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXForLoopExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXForLoopExpression"


    // $ANTLR start "ruleXForLoopExpression"
    // InternalPureXbase.g:1118:1: ruleXForLoopExpression : ( ( rule__XForLoopExpression__Group__0 ) ) ;
    public final void ruleXForLoopExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1122:2: ( ( ( rule__XForLoopExpression__Group__0 ) ) )
            // InternalPureXbase.g:1123:2: ( ( rule__XForLoopExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1123:2: ( ( rule__XForLoopExpression__Group__0 ) )
            // InternalPureXbase.g:1124:3: ( rule__XForLoopExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1125:3: ( rule__XForLoopExpression__Group__0 )
            // InternalPureXbase.g:1125:4: rule__XForLoopExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXForLoopExpression"


    // $ANTLR start "entryRuleXBasicForLoopExpression"
    // InternalPureXbase.g:1134:1: entryRuleXBasicForLoopExpression : ruleXBasicForLoopExpression EOF ;
    public final void entryRuleXBasicForLoopExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1135:1: ( ruleXBasicForLoopExpression EOF )
            // InternalPureXbase.g:1136:1: ruleXBasicForLoopExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXBasicForLoopExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXBasicForLoopExpression"


    // $ANTLR start "ruleXBasicForLoopExpression"
    // InternalPureXbase.g:1143:1: ruleXBasicForLoopExpression : ( ( rule__XBasicForLoopExpression__Group__0 ) ) ;
    public final void ruleXBasicForLoopExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1147:2: ( ( ( rule__XBasicForLoopExpression__Group__0 ) ) )
            // InternalPureXbase.g:1148:2: ( ( rule__XBasicForLoopExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1148:2: ( ( rule__XBasicForLoopExpression__Group__0 ) )
            // InternalPureXbase.g:1149:3: ( rule__XBasicForLoopExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1150:3: ( rule__XBasicForLoopExpression__Group__0 )
            // InternalPureXbase.g:1150:4: rule__XBasicForLoopExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXBasicForLoopExpression"


    // $ANTLR start "entryRuleXWhileExpression"
    // InternalPureXbase.g:1159:1: entryRuleXWhileExpression : ruleXWhileExpression EOF ;
    public final void entryRuleXWhileExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1160:1: ( ruleXWhileExpression EOF )
            // InternalPureXbase.g:1161:1: ruleXWhileExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXWhileExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXWhileExpression"


    // $ANTLR start "ruleXWhileExpression"
    // InternalPureXbase.g:1168:1: ruleXWhileExpression : ( ( rule__XWhileExpression__Group__0 ) ) ;
    public final void ruleXWhileExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1172:2: ( ( ( rule__XWhileExpression__Group__0 ) ) )
            // InternalPureXbase.g:1173:2: ( ( rule__XWhileExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1173:2: ( ( rule__XWhileExpression__Group__0 ) )
            // InternalPureXbase.g:1174:3: ( rule__XWhileExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1175:3: ( rule__XWhileExpression__Group__0 )
            // InternalPureXbase.g:1175:4: rule__XWhileExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXWhileExpression"


    // $ANTLR start "entryRuleXDoWhileExpression"
    // InternalPureXbase.g:1184:1: entryRuleXDoWhileExpression : ruleXDoWhileExpression EOF ;
    public final void entryRuleXDoWhileExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1185:1: ( ruleXDoWhileExpression EOF )
            // InternalPureXbase.g:1186:1: ruleXDoWhileExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXDoWhileExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXDoWhileExpression"


    // $ANTLR start "ruleXDoWhileExpression"
    // InternalPureXbase.g:1193:1: ruleXDoWhileExpression : ( ( rule__XDoWhileExpression__Group__0 ) ) ;
    public final void ruleXDoWhileExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1197:2: ( ( ( rule__XDoWhileExpression__Group__0 ) ) )
            // InternalPureXbase.g:1198:2: ( ( rule__XDoWhileExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1198:2: ( ( rule__XDoWhileExpression__Group__0 ) )
            // InternalPureXbase.g:1199:3: ( rule__XDoWhileExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1200:3: ( rule__XDoWhileExpression__Group__0 )
            // InternalPureXbase.g:1200:4: rule__XDoWhileExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXDoWhileExpression"


    // $ANTLR start "entryRuleXBlockExpression"
    // InternalPureXbase.g:1209:1: entryRuleXBlockExpression : ruleXBlockExpression EOF ;
    public final void entryRuleXBlockExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1210:1: ( ruleXBlockExpression EOF )
            // InternalPureXbase.g:1211:1: ruleXBlockExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXBlockExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXBlockExpression"


    // $ANTLR start "ruleXBlockExpression"
    // InternalPureXbase.g:1218:1: ruleXBlockExpression : ( ( rule__XBlockExpression__Group__0 ) ) ;
    public final void ruleXBlockExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1222:2: ( ( ( rule__XBlockExpression__Group__0 ) ) )
            // InternalPureXbase.g:1223:2: ( ( rule__XBlockExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1223:2: ( ( rule__XBlockExpression__Group__0 ) )
            // InternalPureXbase.g:1224:3: ( rule__XBlockExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1225:3: ( rule__XBlockExpression__Group__0 )
            // InternalPureXbase.g:1225:4: rule__XBlockExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXBlockExpression"


    // $ANTLR start "entryRuleXExpressionOrVarDeclaration"
    // InternalPureXbase.g:1234:1: entryRuleXExpressionOrVarDeclaration : ruleXExpressionOrVarDeclaration EOF ;
    public final void entryRuleXExpressionOrVarDeclaration() throws RecognitionException {
        try {
            // InternalPureXbase.g:1235:1: ( ruleXExpressionOrVarDeclaration EOF )
            // InternalPureXbase.g:1236:1: ruleXExpressionOrVarDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionOrVarDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionOrVarDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXExpressionOrVarDeclaration"


    // $ANTLR start "ruleXExpressionOrVarDeclaration"
    // InternalPureXbase.g:1243:1: ruleXExpressionOrVarDeclaration : ( ( rule__XExpressionOrVarDeclaration__Alternatives ) ) ;
    public final void ruleXExpressionOrVarDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1247:2: ( ( ( rule__XExpressionOrVarDeclaration__Alternatives ) ) )
            // InternalPureXbase.g:1248:2: ( ( rule__XExpressionOrVarDeclaration__Alternatives ) )
            {
            // InternalPureXbase.g:1248:2: ( ( rule__XExpressionOrVarDeclaration__Alternatives ) )
            // InternalPureXbase.g:1249:3: ( rule__XExpressionOrVarDeclaration__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionOrVarDeclarationAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:1250:3: ( rule__XExpressionOrVarDeclaration__Alternatives )
            // InternalPureXbase.g:1250:4: rule__XExpressionOrVarDeclaration__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionOrVarDeclaration__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionOrVarDeclarationAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXExpressionOrVarDeclaration"


    // $ANTLR start "entryRuleXVariableDeclaration"
    // InternalPureXbase.g:1259:1: entryRuleXVariableDeclaration : ruleXVariableDeclaration EOF ;
    public final void entryRuleXVariableDeclaration() throws RecognitionException {
        try {
            // InternalPureXbase.g:1260:1: ( ruleXVariableDeclaration EOF )
            // InternalPureXbase.g:1261:1: ruleXVariableDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXVariableDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXVariableDeclaration"


    // $ANTLR start "ruleXVariableDeclaration"
    // InternalPureXbase.g:1268:1: ruleXVariableDeclaration : ( ( rule__XVariableDeclaration__Group__0 ) ) ;
    public final void ruleXVariableDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1272:2: ( ( ( rule__XVariableDeclaration__Group__0 ) ) )
            // InternalPureXbase.g:1273:2: ( ( rule__XVariableDeclaration__Group__0 ) )
            {
            // InternalPureXbase.g:1273:2: ( ( rule__XVariableDeclaration__Group__0 ) )
            // InternalPureXbase.g:1274:3: ( rule__XVariableDeclaration__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getGroup()); 
            }
            // InternalPureXbase.g:1275:3: ( rule__XVariableDeclaration__Group__0 )
            // InternalPureXbase.g:1275:4: rule__XVariableDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXVariableDeclaration"


    // $ANTLR start "entryRuleJvmFormalParameter"
    // InternalPureXbase.g:1284:1: entryRuleJvmFormalParameter : ruleJvmFormalParameter EOF ;
    public final void entryRuleJvmFormalParameter() throws RecognitionException {
        try {
            // InternalPureXbase.g:1285:1: ( ruleJvmFormalParameter EOF )
            // InternalPureXbase.g:1286:1: ruleJvmFormalParameter EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmFormalParameter"


    // $ANTLR start "ruleJvmFormalParameter"
    // InternalPureXbase.g:1293:1: ruleJvmFormalParameter : ( ( rule__JvmFormalParameter__Group__0 ) ) ;
    public final void ruleJvmFormalParameter() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1297:2: ( ( ( rule__JvmFormalParameter__Group__0 ) ) )
            // InternalPureXbase.g:1298:2: ( ( rule__JvmFormalParameter__Group__0 ) )
            {
            // InternalPureXbase.g:1298:2: ( ( rule__JvmFormalParameter__Group__0 ) )
            // InternalPureXbase.g:1299:3: ( rule__JvmFormalParameter__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getGroup()); 
            }
            // InternalPureXbase.g:1300:3: ( rule__JvmFormalParameter__Group__0 )
            // InternalPureXbase.g:1300:4: rule__JvmFormalParameter__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmFormalParameter"


    // $ANTLR start "entryRuleFullJvmFormalParameter"
    // InternalPureXbase.g:1309:1: entryRuleFullJvmFormalParameter : ruleFullJvmFormalParameter EOF ;
    public final void entryRuleFullJvmFormalParameter() throws RecognitionException {
        try {
            // InternalPureXbase.g:1310:1: ( ruleFullJvmFormalParameter EOF )
            // InternalPureXbase.g:1311:1: ruleFullJvmFormalParameter EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleFullJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleFullJvmFormalParameter"


    // $ANTLR start "ruleFullJvmFormalParameter"
    // InternalPureXbase.g:1318:1: ruleFullJvmFormalParameter : ( ( rule__FullJvmFormalParameter__Group__0 ) ) ;
    public final void ruleFullJvmFormalParameter() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1322:2: ( ( ( rule__FullJvmFormalParameter__Group__0 ) ) )
            // InternalPureXbase.g:1323:2: ( ( rule__FullJvmFormalParameter__Group__0 ) )
            {
            // InternalPureXbase.g:1323:2: ( ( rule__FullJvmFormalParameter__Group__0 ) )
            // InternalPureXbase.g:1324:3: ( rule__FullJvmFormalParameter__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getGroup()); 
            }
            // InternalPureXbase.g:1325:3: ( rule__FullJvmFormalParameter__Group__0 )
            // InternalPureXbase.g:1325:4: rule__FullJvmFormalParameter__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleFullJvmFormalParameter"


    // $ANTLR start "entryRuleXFeatureCall"
    // InternalPureXbase.g:1334:1: entryRuleXFeatureCall : ruleXFeatureCall EOF ;
    public final void entryRuleXFeatureCall() throws RecognitionException {
        try {
            // InternalPureXbase.g:1335:1: ( ruleXFeatureCall EOF )
            // InternalPureXbase.g:1336:1: ruleXFeatureCall EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXFeatureCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXFeatureCall"


    // $ANTLR start "ruleXFeatureCall"
    // InternalPureXbase.g:1343:1: ruleXFeatureCall : ( ( rule__XFeatureCall__Group__0 ) ) ;
    public final void ruleXFeatureCall() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1347:2: ( ( ( rule__XFeatureCall__Group__0 ) ) )
            // InternalPureXbase.g:1348:2: ( ( rule__XFeatureCall__Group__0 ) )
            {
            // InternalPureXbase.g:1348:2: ( ( rule__XFeatureCall__Group__0 ) )
            // InternalPureXbase.g:1349:3: ( rule__XFeatureCall__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup()); 
            }
            // InternalPureXbase.g:1350:3: ( rule__XFeatureCall__Group__0 )
            // InternalPureXbase.g:1350:4: rule__XFeatureCall__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXFeatureCall"


    // $ANTLR start "entryRuleIdOrSuper"
    // InternalPureXbase.g:1359:1: entryRuleIdOrSuper : ruleIdOrSuper EOF ;
    public final void entryRuleIdOrSuper() throws RecognitionException {
        try {
            // InternalPureXbase.g:1360:1: ( ruleIdOrSuper EOF )
            // InternalPureXbase.g:1361:1: ruleIdOrSuper EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getIdOrSuperRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getIdOrSuperRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleIdOrSuper"


    // $ANTLR start "ruleIdOrSuper"
    // InternalPureXbase.g:1368:1: ruleIdOrSuper : ( ( rule__IdOrSuper__Alternatives ) ) ;
    public final void ruleIdOrSuper() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1372:2: ( ( ( rule__IdOrSuper__Alternatives ) ) )
            // InternalPureXbase.g:1373:2: ( ( rule__IdOrSuper__Alternatives ) )
            {
            // InternalPureXbase.g:1373:2: ( ( rule__IdOrSuper__Alternatives ) )
            // InternalPureXbase.g:1374:3: ( rule__IdOrSuper__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getIdOrSuperAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:1375:3: ( rule__IdOrSuper__Alternatives )
            // InternalPureXbase.g:1375:4: rule__IdOrSuper__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__IdOrSuper__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getIdOrSuperAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleIdOrSuper"


    // $ANTLR start "entryRuleXConstructorCall"
    // InternalPureXbase.g:1384:1: entryRuleXConstructorCall : ruleXConstructorCall EOF ;
    public final void entryRuleXConstructorCall() throws RecognitionException {
        try {
            // InternalPureXbase.g:1385:1: ( ruleXConstructorCall EOF )
            // InternalPureXbase.g:1386:1: ruleXConstructorCall EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXConstructorCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXConstructorCall"


    // $ANTLR start "ruleXConstructorCall"
    // InternalPureXbase.g:1393:1: ruleXConstructorCall : ( ( rule__XConstructorCall__Group__0 ) ) ;
    public final void ruleXConstructorCall() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1397:2: ( ( ( rule__XConstructorCall__Group__0 ) ) )
            // InternalPureXbase.g:1398:2: ( ( rule__XConstructorCall__Group__0 ) )
            {
            // InternalPureXbase.g:1398:2: ( ( rule__XConstructorCall__Group__0 ) )
            // InternalPureXbase.g:1399:3: ( rule__XConstructorCall__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup()); 
            }
            // InternalPureXbase.g:1400:3: ( rule__XConstructorCall__Group__0 )
            // InternalPureXbase.g:1400:4: rule__XConstructorCall__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXConstructorCall"


    // $ANTLR start "entryRuleXBooleanLiteral"
    // InternalPureXbase.g:1409:1: entryRuleXBooleanLiteral : ruleXBooleanLiteral EOF ;
    public final void entryRuleXBooleanLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:1410:1: ( ruleXBooleanLiteral EOF )
            // InternalPureXbase.g:1411:1: ruleXBooleanLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXBooleanLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXBooleanLiteral"


    // $ANTLR start "ruleXBooleanLiteral"
    // InternalPureXbase.g:1418:1: ruleXBooleanLiteral : ( ( rule__XBooleanLiteral__Group__0 ) ) ;
    public final void ruleXBooleanLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1422:2: ( ( ( rule__XBooleanLiteral__Group__0 ) ) )
            // InternalPureXbase.g:1423:2: ( ( rule__XBooleanLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:1423:2: ( ( rule__XBooleanLiteral__Group__0 ) )
            // InternalPureXbase.g:1424:3: ( rule__XBooleanLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:1425:3: ( rule__XBooleanLiteral__Group__0 )
            // InternalPureXbase.g:1425:4: rule__XBooleanLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXBooleanLiteral"


    // $ANTLR start "entryRuleXNullLiteral"
    // InternalPureXbase.g:1434:1: entryRuleXNullLiteral : ruleXNullLiteral EOF ;
    public final void entryRuleXNullLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:1435:1: ( ruleXNullLiteral EOF )
            // InternalPureXbase.g:1436:1: ruleXNullLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXNullLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXNullLiteral"


    // $ANTLR start "ruleXNullLiteral"
    // InternalPureXbase.g:1443:1: ruleXNullLiteral : ( ( rule__XNullLiteral__Group__0 ) ) ;
    public final void ruleXNullLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1447:2: ( ( ( rule__XNullLiteral__Group__0 ) ) )
            // InternalPureXbase.g:1448:2: ( ( rule__XNullLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:1448:2: ( ( rule__XNullLiteral__Group__0 ) )
            // InternalPureXbase.g:1449:3: ( rule__XNullLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:1450:3: ( rule__XNullLiteral__Group__0 )
            // InternalPureXbase.g:1450:4: rule__XNullLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XNullLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXNullLiteral"


    // $ANTLR start "entryRuleXNumberLiteral"
    // InternalPureXbase.g:1459:1: entryRuleXNumberLiteral : ruleXNumberLiteral EOF ;
    public final void entryRuleXNumberLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:1460:1: ( ruleXNumberLiteral EOF )
            // InternalPureXbase.g:1461:1: ruleXNumberLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXNumberLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXNumberLiteral"


    // $ANTLR start "ruleXNumberLiteral"
    // InternalPureXbase.g:1468:1: ruleXNumberLiteral : ( ( rule__XNumberLiteral__Group__0 ) ) ;
    public final void ruleXNumberLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1472:2: ( ( ( rule__XNumberLiteral__Group__0 ) ) )
            // InternalPureXbase.g:1473:2: ( ( rule__XNumberLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:1473:2: ( ( rule__XNumberLiteral__Group__0 ) )
            // InternalPureXbase.g:1474:3: ( rule__XNumberLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:1475:3: ( rule__XNumberLiteral__Group__0 )
            // InternalPureXbase.g:1475:4: rule__XNumberLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXNumberLiteral"


    // $ANTLR start "entryRuleXStringLiteral"
    // InternalPureXbase.g:1484:1: entryRuleXStringLiteral : ruleXStringLiteral EOF ;
    public final void entryRuleXStringLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:1485:1: ( ruleXStringLiteral EOF )
            // InternalPureXbase.g:1486:1: ruleXStringLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXStringLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXStringLiteral"


    // $ANTLR start "ruleXStringLiteral"
    // InternalPureXbase.g:1493:1: ruleXStringLiteral : ( ( rule__XStringLiteral__Group__0 ) ) ;
    public final void ruleXStringLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1497:2: ( ( ( rule__XStringLiteral__Group__0 ) ) )
            // InternalPureXbase.g:1498:2: ( ( rule__XStringLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:1498:2: ( ( rule__XStringLiteral__Group__0 ) )
            // InternalPureXbase.g:1499:3: ( rule__XStringLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:1500:3: ( rule__XStringLiteral__Group__0 )
            // InternalPureXbase.g:1500:4: rule__XStringLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXStringLiteral"


    // $ANTLR start "entryRuleXTypeLiteral"
    // InternalPureXbase.g:1509:1: entryRuleXTypeLiteral : ruleXTypeLiteral EOF ;
    public final void entryRuleXTypeLiteral() throws RecognitionException {
        try {
            // InternalPureXbase.g:1510:1: ( ruleXTypeLiteral EOF )
            // InternalPureXbase.g:1511:1: ruleXTypeLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXTypeLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXTypeLiteral"


    // $ANTLR start "ruleXTypeLiteral"
    // InternalPureXbase.g:1518:1: ruleXTypeLiteral : ( ( rule__XTypeLiteral__Group__0 ) ) ;
    public final void ruleXTypeLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1522:2: ( ( ( rule__XTypeLiteral__Group__0 ) ) )
            // InternalPureXbase.g:1523:2: ( ( rule__XTypeLiteral__Group__0 ) )
            {
            // InternalPureXbase.g:1523:2: ( ( rule__XTypeLiteral__Group__0 ) )
            // InternalPureXbase.g:1524:3: ( rule__XTypeLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getGroup()); 
            }
            // InternalPureXbase.g:1525:3: ( rule__XTypeLiteral__Group__0 )
            // InternalPureXbase.g:1525:4: rule__XTypeLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXTypeLiteral"


    // $ANTLR start "entryRuleXThrowExpression"
    // InternalPureXbase.g:1534:1: entryRuleXThrowExpression : ruleXThrowExpression EOF ;
    public final void entryRuleXThrowExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1535:1: ( ruleXThrowExpression EOF )
            // InternalPureXbase.g:1536:1: ruleXThrowExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXThrowExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXThrowExpression"


    // $ANTLR start "ruleXThrowExpression"
    // InternalPureXbase.g:1543:1: ruleXThrowExpression : ( ( rule__XThrowExpression__Group__0 ) ) ;
    public final void ruleXThrowExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1547:2: ( ( ( rule__XThrowExpression__Group__0 ) ) )
            // InternalPureXbase.g:1548:2: ( ( rule__XThrowExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1548:2: ( ( rule__XThrowExpression__Group__0 ) )
            // InternalPureXbase.g:1549:3: ( rule__XThrowExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1550:3: ( rule__XThrowExpression__Group__0 )
            // InternalPureXbase.g:1550:4: rule__XThrowExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXThrowExpression"


    // $ANTLR start "entryRuleXReturnExpression"
    // InternalPureXbase.g:1559:1: entryRuleXReturnExpression : ruleXReturnExpression EOF ;
    public final void entryRuleXReturnExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1560:1: ( ruleXReturnExpression EOF )
            // InternalPureXbase.g:1561:1: ruleXReturnExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXReturnExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXReturnExpression"


    // $ANTLR start "ruleXReturnExpression"
    // InternalPureXbase.g:1568:1: ruleXReturnExpression : ( ( rule__XReturnExpression__Group__0 ) ) ;
    public final void ruleXReturnExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1572:2: ( ( ( rule__XReturnExpression__Group__0 ) ) )
            // InternalPureXbase.g:1573:2: ( ( rule__XReturnExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1573:2: ( ( rule__XReturnExpression__Group__0 ) )
            // InternalPureXbase.g:1574:3: ( rule__XReturnExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1575:3: ( rule__XReturnExpression__Group__0 )
            // InternalPureXbase.g:1575:4: rule__XReturnExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXReturnExpression"


    // $ANTLR start "entryRuleXSynchronizedExpression"
    // InternalPureXbase.g:1584:1: entryRuleXSynchronizedExpression : ruleXSynchronizedExpression EOF ;
    public final void entryRuleXSynchronizedExpression() throws RecognitionException {
        try {
            // InternalPureXbase.g:1585:1: ( ruleXSynchronizedExpression EOF )
            // InternalPureXbase.g:1586:1: ruleXSynchronizedExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXSynchronizedExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXSynchronizedExpression"


    // $ANTLR start "ruleXSynchronizedExpression"
    // InternalPureXbase.g:1593:1: ruleXSynchronizedExpression : ( ( rule__XSynchronizedExpression__Group__0 ) ) ;
    public final void ruleXSynchronizedExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1597:2: ( ( ( rule__XSynchronizedExpression__Group__0 ) ) )
            // InternalPureXbase.g:1598:2: ( ( rule__XSynchronizedExpression__Group__0 ) )
            {
            // InternalPureXbase.g:1598:2: ( ( rule__XSynchronizedExpression__Group__0 ) )
            // InternalPureXbase.g:1599:3: ( rule__XSynchronizedExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getGroup()); 
            }
            // InternalPureXbase.g:1600:3: ( rule__XSynchronizedExpression__Group__0 )
            // InternalPureXbase.g:1600:4: rule__XSynchronizedExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXSynchronizedExpression"


    // $ANTLR start "entryRuleXCatchClause"
    // InternalPureXbase.g:1609:1: entryRuleXCatchClause : ruleXCatchClause EOF ;
    public final void entryRuleXCatchClause() throws RecognitionException {
        try {
            // InternalPureXbase.g:1610:1: ( ruleXCatchClause EOF )
            // InternalPureXbase.g:1611:1: ruleXCatchClause EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCatchClause();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCatchClause"


    // $ANTLR start "ruleXCatchClause"
    // InternalPureXbase.g:1618:1: ruleXCatchClause : ( ( rule__XCatchClause__Group__0 ) ) ;
    public final void ruleXCatchClause() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1622:2: ( ( ( rule__XCatchClause__Group__0 ) ) )
            // InternalPureXbase.g:1623:2: ( ( rule__XCatchClause__Group__0 ) )
            {
            // InternalPureXbase.g:1623:2: ( ( rule__XCatchClause__Group__0 ) )
            // InternalPureXbase.g:1624:3: ( rule__XCatchClause__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getGroup()); 
            }
            // InternalPureXbase.g:1625:3: ( rule__XCatchClause__Group__0 )
            // InternalPureXbase.g:1625:4: rule__XCatchClause__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCatchClause"


    // $ANTLR start "entryRuleQualifiedName"
    // InternalPureXbase.g:1634:1: entryRuleQualifiedName : ruleQualifiedName EOF ;
    public final void entryRuleQualifiedName() throws RecognitionException {
        try {
            // InternalPureXbase.g:1635:1: ( ruleQualifiedName EOF )
            // InternalPureXbase.g:1636:1: ruleQualifiedName EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedName"


    // $ANTLR start "ruleQualifiedName"
    // InternalPureXbase.g:1643:1: ruleQualifiedName : ( ( rule__QualifiedName__Group__0 ) ) ;
    public final void ruleQualifiedName() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1647:2: ( ( ( rule__QualifiedName__Group__0 ) ) )
            // InternalPureXbase.g:1648:2: ( ( rule__QualifiedName__Group__0 ) )
            {
            // InternalPureXbase.g:1648:2: ( ( rule__QualifiedName__Group__0 ) )
            // InternalPureXbase.g:1649:3: ( rule__QualifiedName__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getGroup()); 
            }
            // InternalPureXbase.g:1650:3: ( rule__QualifiedName__Group__0 )
            // InternalPureXbase.g:1650:4: rule__QualifiedName__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedName"


    // $ANTLR start "entryRuleNumber"
    // InternalPureXbase.g:1659:1: entryRuleNumber : ruleNumber EOF ;
    public final void entryRuleNumber() throws RecognitionException {
         
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalPureXbase.g:1663:1: ( ruleNumber EOF )
            // InternalPureXbase.g:1664:1: ruleNumber EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleNumber();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "entryRuleNumber"


    // $ANTLR start "ruleNumber"
    // InternalPureXbase.g:1674:1: ruleNumber : ( ( rule__Number__Alternatives ) ) ;
    public final void ruleNumber() throws RecognitionException {

        		HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();
        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1679:2: ( ( ( rule__Number__Alternatives ) ) )
            // InternalPureXbase.g:1680:2: ( ( rule__Number__Alternatives ) )
            {
            // InternalPureXbase.g:1680:2: ( ( rule__Number__Alternatives ) )
            // InternalPureXbase.g:1681:3: ( rule__Number__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:1682:3: ( rule__Number__Alternatives )
            // InternalPureXbase.g:1682:4: rule__Number__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Number__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);
            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "ruleNumber"


    // $ANTLR start "entryRuleJvmTypeReference"
    // InternalPureXbase.g:1692:1: entryRuleJvmTypeReference : ruleJvmTypeReference EOF ;
    public final void entryRuleJvmTypeReference() throws RecognitionException {
        try {
            // InternalPureXbase.g:1693:1: ( ruleJvmTypeReference EOF )
            // InternalPureXbase.g:1694:1: ruleJvmTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmTypeReference"


    // $ANTLR start "ruleJvmTypeReference"
    // InternalPureXbase.g:1701:1: ruleJvmTypeReference : ( ( rule__JvmTypeReference__Alternatives ) ) ;
    public final void ruleJvmTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1705:2: ( ( ( rule__JvmTypeReference__Alternatives ) ) )
            // InternalPureXbase.g:1706:2: ( ( rule__JvmTypeReference__Alternatives ) )
            {
            // InternalPureXbase.g:1706:2: ( ( rule__JvmTypeReference__Alternatives ) )
            // InternalPureXbase.g:1707:3: ( rule__JvmTypeReference__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:1708:3: ( rule__JvmTypeReference__Alternatives )
            // InternalPureXbase.g:1708:4: rule__JvmTypeReference__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmTypeReference"


    // $ANTLR start "entryRuleArrayBrackets"
    // InternalPureXbase.g:1717:1: entryRuleArrayBrackets : ruleArrayBrackets EOF ;
    public final void entryRuleArrayBrackets() throws RecognitionException {
        try {
            // InternalPureXbase.g:1718:1: ( ruleArrayBrackets EOF )
            // InternalPureXbase.g:1719:1: ruleArrayBrackets EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleArrayBrackets"


    // $ANTLR start "ruleArrayBrackets"
    // InternalPureXbase.g:1726:1: ruleArrayBrackets : ( ( rule__ArrayBrackets__Group__0 ) ) ;
    public final void ruleArrayBrackets() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1730:2: ( ( ( rule__ArrayBrackets__Group__0 ) ) )
            // InternalPureXbase.g:1731:2: ( ( rule__ArrayBrackets__Group__0 ) )
            {
            // InternalPureXbase.g:1731:2: ( ( rule__ArrayBrackets__Group__0 ) )
            // InternalPureXbase.g:1732:3: ( rule__ArrayBrackets__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsAccess().getGroup()); 
            }
            // InternalPureXbase.g:1733:3: ( rule__ArrayBrackets__Group__0 )
            // InternalPureXbase.g:1733:4: rule__ArrayBrackets__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ArrayBrackets__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleArrayBrackets"


    // $ANTLR start "entryRuleXFunctionTypeRef"
    // InternalPureXbase.g:1742:1: entryRuleXFunctionTypeRef : ruleXFunctionTypeRef EOF ;
    public final void entryRuleXFunctionTypeRef() throws RecognitionException {
        try {
            // InternalPureXbase.g:1743:1: ( ruleXFunctionTypeRef EOF )
            // InternalPureXbase.g:1744:1: ruleXFunctionTypeRef EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXFunctionTypeRef();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXFunctionTypeRef"


    // $ANTLR start "ruleXFunctionTypeRef"
    // InternalPureXbase.g:1751:1: ruleXFunctionTypeRef : ( ( rule__XFunctionTypeRef__Group__0 ) ) ;
    public final void ruleXFunctionTypeRef() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1755:2: ( ( ( rule__XFunctionTypeRef__Group__0 ) ) )
            // InternalPureXbase.g:1756:2: ( ( rule__XFunctionTypeRef__Group__0 ) )
            {
            // InternalPureXbase.g:1756:2: ( ( rule__XFunctionTypeRef__Group__0 ) )
            // InternalPureXbase.g:1757:3: ( rule__XFunctionTypeRef__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup()); 
            }
            // InternalPureXbase.g:1758:3: ( rule__XFunctionTypeRef__Group__0 )
            // InternalPureXbase.g:1758:4: rule__XFunctionTypeRef__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXFunctionTypeRef"


    // $ANTLR start "entryRuleJvmParameterizedTypeReference"
    // InternalPureXbase.g:1767:1: entryRuleJvmParameterizedTypeReference : ruleJvmParameterizedTypeReference EOF ;
    public final void entryRuleJvmParameterizedTypeReference() throws RecognitionException {
        try {
            // InternalPureXbase.g:1768:1: ( ruleJvmParameterizedTypeReference EOF )
            // InternalPureXbase.g:1769:1: ruleJvmParameterizedTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmParameterizedTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmParameterizedTypeReference"


    // $ANTLR start "ruleJvmParameterizedTypeReference"
    // InternalPureXbase.g:1776:1: ruleJvmParameterizedTypeReference : ( ( rule__JvmParameterizedTypeReference__Group__0 ) ) ;
    public final void ruleJvmParameterizedTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1780:2: ( ( ( rule__JvmParameterizedTypeReference__Group__0 ) ) )
            // InternalPureXbase.g:1781:2: ( ( rule__JvmParameterizedTypeReference__Group__0 ) )
            {
            // InternalPureXbase.g:1781:2: ( ( rule__JvmParameterizedTypeReference__Group__0 ) )
            // InternalPureXbase.g:1782:3: ( rule__JvmParameterizedTypeReference__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup()); 
            }
            // InternalPureXbase.g:1783:3: ( rule__JvmParameterizedTypeReference__Group__0 )
            // InternalPureXbase.g:1783:4: rule__JvmParameterizedTypeReference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmParameterizedTypeReference"


    // $ANTLR start "entryRuleJvmArgumentTypeReference"
    // InternalPureXbase.g:1792:1: entryRuleJvmArgumentTypeReference : ruleJvmArgumentTypeReference EOF ;
    public final void entryRuleJvmArgumentTypeReference() throws RecognitionException {
        try {
            // InternalPureXbase.g:1793:1: ( ruleJvmArgumentTypeReference EOF )
            // InternalPureXbase.g:1794:1: ruleJvmArgumentTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmArgumentTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmArgumentTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmArgumentTypeReference"


    // $ANTLR start "ruleJvmArgumentTypeReference"
    // InternalPureXbase.g:1801:1: ruleJvmArgumentTypeReference : ( ( rule__JvmArgumentTypeReference__Alternatives ) ) ;
    public final void ruleJvmArgumentTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1805:2: ( ( ( rule__JvmArgumentTypeReference__Alternatives ) ) )
            // InternalPureXbase.g:1806:2: ( ( rule__JvmArgumentTypeReference__Alternatives ) )
            {
            // InternalPureXbase.g:1806:2: ( ( rule__JvmArgumentTypeReference__Alternatives ) )
            // InternalPureXbase.g:1807:3: ( rule__JvmArgumentTypeReference__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmArgumentTypeReferenceAccess().getAlternatives()); 
            }
            // InternalPureXbase.g:1808:3: ( rule__JvmArgumentTypeReference__Alternatives )
            // InternalPureXbase.g:1808:4: rule__JvmArgumentTypeReference__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__JvmArgumentTypeReference__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmArgumentTypeReferenceAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmArgumentTypeReference"


    // $ANTLR start "entryRuleJvmWildcardTypeReference"
    // InternalPureXbase.g:1817:1: entryRuleJvmWildcardTypeReference : ruleJvmWildcardTypeReference EOF ;
    public final void entryRuleJvmWildcardTypeReference() throws RecognitionException {
        try {
            // InternalPureXbase.g:1818:1: ( ruleJvmWildcardTypeReference EOF )
            // InternalPureXbase.g:1819:1: ruleJvmWildcardTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmWildcardTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmWildcardTypeReference"


    // $ANTLR start "ruleJvmWildcardTypeReference"
    // InternalPureXbase.g:1826:1: ruleJvmWildcardTypeReference : ( ( rule__JvmWildcardTypeReference__Group__0 ) ) ;
    public final void ruleJvmWildcardTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1830:2: ( ( ( rule__JvmWildcardTypeReference__Group__0 ) ) )
            // InternalPureXbase.g:1831:2: ( ( rule__JvmWildcardTypeReference__Group__0 ) )
            {
            // InternalPureXbase.g:1831:2: ( ( rule__JvmWildcardTypeReference__Group__0 ) )
            // InternalPureXbase.g:1832:3: ( rule__JvmWildcardTypeReference__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup()); 
            }
            // InternalPureXbase.g:1833:3: ( rule__JvmWildcardTypeReference__Group__0 )
            // InternalPureXbase.g:1833:4: rule__JvmWildcardTypeReference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmWildcardTypeReference"


    // $ANTLR start "entryRuleJvmUpperBound"
    // InternalPureXbase.g:1842:1: entryRuleJvmUpperBound : ruleJvmUpperBound EOF ;
    public final void entryRuleJvmUpperBound() throws RecognitionException {
        try {
            // InternalPureXbase.g:1843:1: ( ruleJvmUpperBound EOF )
            // InternalPureXbase.g:1844:1: ruleJvmUpperBound EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmUpperBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmUpperBound"


    // $ANTLR start "ruleJvmUpperBound"
    // InternalPureXbase.g:1851:1: ruleJvmUpperBound : ( ( rule__JvmUpperBound__Group__0 ) ) ;
    public final void ruleJvmUpperBound() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1855:2: ( ( ( rule__JvmUpperBound__Group__0 ) ) )
            // InternalPureXbase.g:1856:2: ( ( rule__JvmUpperBound__Group__0 ) )
            {
            // InternalPureXbase.g:1856:2: ( ( rule__JvmUpperBound__Group__0 ) )
            // InternalPureXbase.g:1857:3: ( rule__JvmUpperBound__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getGroup()); 
            }
            // InternalPureXbase.g:1858:3: ( rule__JvmUpperBound__Group__0 )
            // InternalPureXbase.g:1858:4: rule__JvmUpperBound__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmUpperBound"


    // $ANTLR start "entryRuleJvmUpperBoundAnded"
    // InternalPureXbase.g:1867:1: entryRuleJvmUpperBoundAnded : ruleJvmUpperBoundAnded EOF ;
    public final void entryRuleJvmUpperBoundAnded() throws RecognitionException {
        try {
            // InternalPureXbase.g:1868:1: ( ruleJvmUpperBoundAnded EOF )
            // InternalPureXbase.g:1869:1: ruleJvmUpperBoundAnded EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmUpperBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmUpperBoundAnded"


    // $ANTLR start "ruleJvmUpperBoundAnded"
    // InternalPureXbase.g:1876:1: ruleJvmUpperBoundAnded : ( ( rule__JvmUpperBoundAnded__Group__0 ) ) ;
    public final void ruleJvmUpperBoundAnded() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1880:2: ( ( ( rule__JvmUpperBoundAnded__Group__0 ) ) )
            // InternalPureXbase.g:1881:2: ( ( rule__JvmUpperBoundAnded__Group__0 ) )
            {
            // InternalPureXbase.g:1881:2: ( ( rule__JvmUpperBoundAnded__Group__0 ) )
            // InternalPureXbase.g:1882:3: ( rule__JvmUpperBoundAnded__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getGroup()); 
            }
            // InternalPureXbase.g:1883:3: ( rule__JvmUpperBoundAnded__Group__0 )
            // InternalPureXbase.g:1883:4: rule__JvmUpperBoundAnded__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmUpperBoundAnded"


    // $ANTLR start "entryRuleJvmLowerBound"
    // InternalPureXbase.g:1892:1: entryRuleJvmLowerBound : ruleJvmLowerBound EOF ;
    public final void entryRuleJvmLowerBound() throws RecognitionException {
        try {
            // InternalPureXbase.g:1893:1: ( ruleJvmLowerBound EOF )
            // InternalPureXbase.g:1894:1: ruleJvmLowerBound EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmLowerBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmLowerBound"


    // $ANTLR start "ruleJvmLowerBound"
    // InternalPureXbase.g:1901:1: ruleJvmLowerBound : ( ( rule__JvmLowerBound__Group__0 ) ) ;
    public final void ruleJvmLowerBound() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1905:2: ( ( ( rule__JvmLowerBound__Group__0 ) ) )
            // InternalPureXbase.g:1906:2: ( ( rule__JvmLowerBound__Group__0 ) )
            {
            // InternalPureXbase.g:1906:2: ( ( rule__JvmLowerBound__Group__0 ) )
            // InternalPureXbase.g:1907:3: ( rule__JvmLowerBound__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getGroup()); 
            }
            // InternalPureXbase.g:1908:3: ( rule__JvmLowerBound__Group__0 )
            // InternalPureXbase.g:1908:4: rule__JvmLowerBound__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmLowerBound"


    // $ANTLR start "entryRuleJvmLowerBoundAnded"
    // InternalPureXbase.g:1917:1: entryRuleJvmLowerBoundAnded : ruleJvmLowerBoundAnded EOF ;
    public final void entryRuleJvmLowerBoundAnded() throws RecognitionException {
        try {
            // InternalPureXbase.g:1918:1: ( ruleJvmLowerBoundAnded EOF )
            // InternalPureXbase.g:1919:1: ruleJvmLowerBoundAnded EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmLowerBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmLowerBoundAnded"


    // $ANTLR start "ruleJvmLowerBoundAnded"
    // InternalPureXbase.g:1926:1: ruleJvmLowerBoundAnded : ( ( rule__JvmLowerBoundAnded__Group__0 ) ) ;
    public final void ruleJvmLowerBoundAnded() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1930:2: ( ( ( rule__JvmLowerBoundAnded__Group__0 ) ) )
            // InternalPureXbase.g:1931:2: ( ( rule__JvmLowerBoundAnded__Group__0 ) )
            {
            // InternalPureXbase.g:1931:2: ( ( rule__JvmLowerBoundAnded__Group__0 ) )
            // InternalPureXbase.g:1932:3: ( rule__JvmLowerBoundAnded__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getGroup()); 
            }
            // InternalPureXbase.g:1933:3: ( rule__JvmLowerBoundAnded__Group__0 )
            // InternalPureXbase.g:1933:4: rule__JvmLowerBoundAnded__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmLowerBoundAnded"


    // $ANTLR start "entryRuleQualifiedNameWithWildcard"
    // InternalPureXbase.g:1942:1: entryRuleQualifiedNameWithWildcard : ruleQualifiedNameWithWildcard EOF ;
    public final void entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        try {
            // InternalPureXbase.g:1943:1: ( ruleQualifiedNameWithWildcard EOF )
            // InternalPureXbase.g:1944:1: ruleQualifiedNameWithWildcard EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleQualifiedNameWithWildcard();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameWithWildcard"


    // $ANTLR start "ruleQualifiedNameWithWildcard"
    // InternalPureXbase.g:1951:1: ruleQualifiedNameWithWildcard : ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) ;
    public final void ruleQualifiedNameWithWildcard() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1955:2: ( ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) )
            // InternalPureXbase.g:1956:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            {
            // InternalPureXbase.g:1956:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            // InternalPureXbase.g:1957:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            }
            // InternalPureXbase.g:1958:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            // InternalPureXbase.g:1958:4: rule__QualifiedNameWithWildcard__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameWithWildcard"


    // $ANTLR start "entryRuleValidID"
    // InternalPureXbase.g:1967:1: entryRuleValidID : ruleValidID EOF ;
    public final void entryRuleValidID() throws RecognitionException {
        try {
            // InternalPureXbase.g:1968:1: ( ruleValidID EOF )
            // InternalPureXbase.g:1969:1: ruleValidID EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getValidIDRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getValidIDRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleValidID"


    // $ANTLR start "ruleValidID"
    // InternalPureXbase.g:1976:1: ruleValidID : ( RULE_ID ) ;
    public final void ruleValidID() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:1980:2: ( ( RULE_ID ) )
            // InternalPureXbase.g:1981:2: ( RULE_ID )
            {
            // InternalPureXbase.g:1981:2: ( RULE_ID )
            // InternalPureXbase.g:1982:3: RULE_ID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getValidIDAccess().getIDTerminalRuleCall()); 
            }
            match(input,RULE_ID,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getValidIDAccess().getIDTerminalRuleCall()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleValidID"


    // $ANTLR start "entryRuleXImportSection"
    // InternalPureXbase.g:1992:1: entryRuleXImportSection : ruleXImportSection EOF ;
    public final void entryRuleXImportSection() throws RecognitionException {
        try {
            // InternalPureXbase.g:1993:1: ( ruleXImportSection EOF )
            // InternalPureXbase.g:1994:1: ruleXImportSection EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportSectionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXImportSection();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportSectionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXImportSection"


    // $ANTLR start "ruleXImportSection"
    // InternalPureXbase.g:2001:1: ruleXImportSection : ( ( ( rule__XImportSection__ImportDeclarationsAssignment ) ) ( ( rule__XImportSection__ImportDeclarationsAssignment )* ) ) ;
    public final void ruleXImportSection() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2005:2: ( ( ( ( rule__XImportSection__ImportDeclarationsAssignment ) ) ( ( rule__XImportSection__ImportDeclarationsAssignment )* ) ) )
            // InternalPureXbase.g:2006:2: ( ( ( rule__XImportSection__ImportDeclarationsAssignment ) ) ( ( rule__XImportSection__ImportDeclarationsAssignment )* ) )
            {
            // InternalPureXbase.g:2006:2: ( ( ( rule__XImportSection__ImportDeclarationsAssignment ) ) ( ( rule__XImportSection__ImportDeclarationsAssignment )* ) )
            // InternalPureXbase.g:2007:3: ( ( rule__XImportSection__ImportDeclarationsAssignment ) ) ( ( rule__XImportSection__ImportDeclarationsAssignment )* )
            {
            // InternalPureXbase.g:2007:3: ( ( rule__XImportSection__ImportDeclarationsAssignment ) )
            // InternalPureXbase.g:2008:4: ( rule__XImportSection__ImportDeclarationsAssignment )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportSectionAccess().getImportDeclarationsAssignment()); 
            }
            // InternalPureXbase.g:2009:4: ( rule__XImportSection__ImportDeclarationsAssignment )
            // InternalPureXbase.g:2009:5: rule__XImportSection__ImportDeclarationsAssignment
            {
            pushFollow(FOLLOW_3);
            rule__XImportSection__ImportDeclarationsAssignment();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportSectionAccess().getImportDeclarationsAssignment()); 
            }

            }

            // InternalPureXbase.g:2012:3: ( ( rule__XImportSection__ImportDeclarationsAssignment )* )
            // InternalPureXbase.g:2013:4: ( rule__XImportSection__ImportDeclarationsAssignment )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportSectionAccess().getImportDeclarationsAssignment()); 
            }
            // InternalPureXbase.g:2014:4: ( rule__XImportSection__ImportDeclarationsAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==79) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalPureXbase.g:2014:5: rule__XImportSection__ImportDeclarationsAssignment
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__XImportSection__ImportDeclarationsAssignment();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportSectionAccess().getImportDeclarationsAssignment()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXImportSection"


    // $ANTLR start "entryRuleXImportDeclaration"
    // InternalPureXbase.g:2024:1: entryRuleXImportDeclaration : ruleXImportDeclaration EOF ;
    public final void entryRuleXImportDeclaration() throws RecognitionException {
        try {
            // InternalPureXbase.g:2025:1: ( ruleXImportDeclaration EOF )
            // InternalPureXbase.g:2026:1: ruleXImportDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXImportDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXImportDeclaration"


    // $ANTLR start "ruleXImportDeclaration"
    // InternalPureXbase.g:2033:1: ruleXImportDeclaration : ( ( rule__XImportDeclaration__Group__0 ) ) ;
    public final void ruleXImportDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2037:2: ( ( ( rule__XImportDeclaration__Group__0 ) ) )
            // InternalPureXbase.g:2038:2: ( ( rule__XImportDeclaration__Group__0 ) )
            {
            // InternalPureXbase.g:2038:2: ( ( rule__XImportDeclaration__Group__0 ) )
            // InternalPureXbase.g:2039:3: ( rule__XImportDeclaration__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getGroup()); 
            }
            // InternalPureXbase.g:2040:3: ( rule__XImportDeclaration__Group__0 )
            // InternalPureXbase.g:2040:4: rule__XImportDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXImportDeclaration"


    // $ANTLR start "entryRuleQualifiedNameInStaticImport"
    // InternalPureXbase.g:2049:1: entryRuleQualifiedNameInStaticImport : ruleQualifiedNameInStaticImport EOF ;
    public final void entryRuleQualifiedNameInStaticImport() throws RecognitionException {
        try {
            // InternalPureXbase.g:2050:1: ( ruleQualifiedNameInStaticImport EOF )
            // InternalPureXbase.g:2051:1: ruleQualifiedNameInStaticImport EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleQualifiedNameInStaticImport();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameInStaticImport"


    // $ANTLR start "ruleQualifiedNameInStaticImport"
    // InternalPureXbase.g:2058:1: ruleQualifiedNameInStaticImport : ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) ) ;
    public final void ruleQualifiedNameInStaticImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2062:2: ( ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) ) )
            // InternalPureXbase.g:2063:2: ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) )
            {
            // InternalPureXbase.g:2063:2: ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) )
            // InternalPureXbase.g:2064:3: ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* )
            {
            // InternalPureXbase.g:2064:3: ( ( rule__QualifiedNameInStaticImport__Group__0 ) )
            // InternalPureXbase.g:2065:4: ( rule__QualifiedNameInStaticImport__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }
            // InternalPureXbase.g:2066:4: ( rule__QualifiedNameInStaticImport__Group__0 )
            // InternalPureXbase.g:2066:5: rule__QualifiedNameInStaticImport__Group__0
            {
            pushFollow(FOLLOW_4);
            rule__QualifiedNameInStaticImport__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }

            }

            // InternalPureXbase.g:2069:3: ( ( rule__QualifiedNameInStaticImport__Group__0 )* )
            // InternalPureXbase.g:2070:4: ( rule__QualifiedNameInStaticImport__Group__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }
            // InternalPureXbase.g:2071:4: ( rule__QualifiedNameInStaticImport__Group__0 )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==RULE_ID) ) {
                    int LA2_2 = input.LA(2);

                    if ( (LA2_2==44) ) {
                        alt2=1;
                    }


                }


                switch (alt2) {
            	case 1 :
            	    // InternalPureXbase.g:2071:5: rule__QualifiedNameInStaticImport__Group__0
            	    {
            	    pushFollow(FOLLOW_4);
            	    rule__QualifiedNameInStaticImport__Group__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameInStaticImport"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Alternatives_2"
    // InternalPureXbase.g:2080:1: rule__XTryCatchFinallyExpression__Alternatives_2 : ( ( ( rule__XTryCatchFinallyExpression__Group_2_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_2_1__0 ) ) );
    public final void rule__XTryCatchFinallyExpression__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2084:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_2_1__0 ) ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==49) ) {
                int LA3_1 = input.LA(2);

                if ( ((LA3_1>=RULE_ID && LA3_1<=RULE_STRING)||LA3_1==28||(LA3_1>=35 && LA3_1<=36)||LA3_1==41||(LA3_1>=45 && LA3_1<=46)||(LA3_1>=48 && LA3_1<=49)||(LA3_1>=56 && LA3_1<=57)||LA3_1==59||LA3_1==61||LA3_1==63||(LA3_1>=66 && LA3_1<=74)||LA3_1==84) ) {
                    alt3=2;
                }
                else if ( (LA3_1==16||LA3_1==80) ) {
                    alt3=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 3, 1, input);

                    throw nvae;
                }
            }
            else if ( ((LA3_0>=RULE_ID && LA3_0<=RULE_STRING)||LA3_0==28||(LA3_0>=35 && LA3_0<=36)||LA3_0==41||(LA3_0>=45 && LA3_0<=46)||LA3_0==48||(LA3_0>=56 && LA3_0<=57)||LA3_0==59||LA3_0==61||LA3_0==63||(LA3_0>=66 && LA3_0<=74)||LA3_0==84) ) {
                alt3=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // InternalPureXbase.g:2085:2: ( ( rule__XTryCatchFinallyExpression__Group_2_0__0 ) )
                    {
                    // InternalPureXbase.g:2085:2: ( ( rule__XTryCatchFinallyExpression__Group_2_0__0 ) )
                    // InternalPureXbase.g:2086:3: ( rule__XTryCatchFinallyExpression__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0()); 
                    }
                    // InternalPureXbase.g:2087:3: ( rule__XTryCatchFinallyExpression__Group_2_0__0 )
                    // InternalPureXbase.g:2087:4: rule__XTryCatchFinallyExpression__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2091:2: ( ( rule__XTryCatchFinallyExpression__Group_2_1__0 ) )
                    {
                    // InternalPureXbase.g:2091:2: ( ( rule__XTryCatchFinallyExpression__Group_2_1__0 ) )
                    // InternalPureXbase.g:2092:3: ( rule__XTryCatchFinallyExpression__Group_2_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1()); 
                    }
                    // InternalPureXbase.g:2093:3: ( rule__XTryCatchFinallyExpression__Group_2_1__0 )
                    // InternalPureXbase.g:2093:4: rule__XTryCatchFinallyExpression__Group_2_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Alternatives_2"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0"
    // InternalPureXbase.g:2101:1: rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 : ( ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 ) ) );
    public final void rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2105:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 ) ) )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==75) ) {
                alt4=1;
            }
            else if ( (LA4_0==51) ) {
                alt4=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // InternalPureXbase.g:2106:2: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 ) )
                    {
                    // InternalPureXbase.g:2106:2: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 ) )
                    // InternalPureXbase.g:2107:3: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6_0_0()); 
                    }
                    // InternalPureXbase.g:2108:3: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 )
                    // InternalPureXbase.g:2108:4: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6_0_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2112:2: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 ) )
                    {
                    // InternalPureXbase.g:2112:2: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 ) )
                    // InternalPureXbase.g:2113:3: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6_0_1()); 
                    }
                    // InternalPureXbase.g:2114:3: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 )
                    // InternalPureXbase.g:2114:4: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6_0_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Alternatives_2_1_1"
    // InternalPureXbase.g:2122:1: rule__XTryCatchFinallyExpression__Alternatives_2_1_1 : ( ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 ) ) );
    public final void rule__XTryCatchFinallyExpression__Alternatives_2_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2126:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 ) ) )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==75) ) {
                alt5=1;
            }
            else if ( (LA5_0==51) ) {
                alt5=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // InternalPureXbase.g:2127:2: ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 ) )
                    {
                    // InternalPureXbase.g:2127:2: ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 ) )
                    // InternalPureXbase.g:2128:3: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1_1_0()); 
                    }
                    // InternalPureXbase.g:2129:3: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 )
                    // InternalPureXbase.g:2129:4: rule__XTryCatchFinallyExpression__Group_2_1_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_1_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2133:2: ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 ) )
                    {
                    // InternalPureXbase.g:2133:2: ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 ) )
                    // InternalPureXbase.g:2134:3: ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1_1_1()); 
                    }
                    // InternalPureXbase.g:2135:3: ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 )
                    // InternalPureXbase.g:2135:4: rule__XTryCatchFinallyExpression__Group_2_1_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_1_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Alternatives_2_1_1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Alternatives_1"
    // InternalPureXbase.g:2143:1: rule__InitialisedVariableDeclaration__Alternatives_1 : ( ( ( rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 ) ) | ( 'val' ) );
    public final void rule__InitialisedVariableDeclaration__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2147:1: ( ( ( rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 ) ) | ( 'val' ) )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==80) ) {
                alt6=1;
            }
            else if ( (LA6_0==16) ) {
                alt6=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // InternalPureXbase.g:2148:2: ( ( rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 ) )
                    {
                    // InternalPureXbase.g:2148:2: ( ( rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 ) )
                    // InternalPureXbase.g:2149:3: ( rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getInitialisedVariableDeclarationAccess().getWriteableAssignment_1_0()); 
                    }
                    // InternalPureXbase.g:2150:3: ( rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 )
                    // InternalPureXbase.g:2150:4: rule__InitialisedVariableDeclaration__WriteableAssignment_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__InitialisedVariableDeclaration__WriteableAssignment_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getInitialisedVariableDeclarationAccess().getWriteableAssignment_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2154:2: ( 'val' )
                    {
                    // InternalPureXbase.g:2154:2: ( 'val' )
                    // InternalPureXbase.g:2155:3: 'val'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getInitialisedVariableDeclarationAccess().getValKeyword_1_1()); 
                    }
                    match(input,16,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getInitialisedVariableDeclarationAccess().getValKeyword_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Alternatives_1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Alternatives_2"
    // InternalPureXbase.g:2164:1: rule__InitialisedVariableDeclaration__Alternatives_2 : ( ( ( rule__InitialisedVariableDeclaration__Group_2_0__0 ) ) | ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_1 ) ) );
    public final void rule__InitialisedVariableDeclaration__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2168:1: ( ( ( rule__InitialisedVariableDeclaration__Group_2_0__0 ) ) | ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_1 ) ) )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==RULE_ID) ) {
                int LA7_1 = input.LA(2);

                if ( (LA7_1==RULE_ID||LA7_1==28||LA7_1==44||LA7_1==59) ) {
                    alt7=1;
                }
                else if ( (LA7_1==13) ) {
                    alt7=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA7_0==32||LA7_0==49) ) {
                alt7=1;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // InternalPureXbase.g:2169:2: ( ( rule__InitialisedVariableDeclaration__Group_2_0__0 ) )
                    {
                    // InternalPureXbase.g:2169:2: ( ( rule__InitialisedVariableDeclaration__Group_2_0__0 ) )
                    // InternalPureXbase.g:2170:3: ( rule__InitialisedVariableDeclaration__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getInitialisedVariableDeclarationAccess().getGroup_2_0()); 
                    }
                    // InternalPureXbase.g:2171:3: ( rule__InitialisedVariableDeclaration__Group_2_0__0 )
                    // InternalPureXbase.g:2171:4: rule__InitialisedVariableDeclaration__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__InitialisedVariableDeclaration__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getInitialisedVariableDeclarationAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2175:2: ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_1 ) )
                    {
                    // InternalPureXbase.g:2175:2: ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_1 ) )
                    // InternalPureXbase.g:2176:3: ( rule__InitialisedVariableDeclaration__NameAssignment_2_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getInitialisedVariableDeclarationAccess().getNameAssignment_2_1()); 
                    }
                    // InternalPureXbase.g:2177:3: ( rule__InitialisedVariableDeclaration__NameAssignment_2_1 )
                    // InternalPureXbase.g:2177:4: rule__InitialisedVariableDeclaration__NameAssignment_2_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__InitialisedVariableDeclaration__NameAssignment_2_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getInitialisedVariableDeclarationAccess().getNameAssignment_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Alternatives_2"


    // $ANTLR start "rule__XAssignment__Alternatives"
    // InternalPureXbase.g:2185:1: rule__XAssignment__Alternatives : ( ( ( rule__XAssignment__Group_0__0 ) ) | ( ( rule__XAssignment__Group_1__0 ) ) );
    public final void rule__XAssignment__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2189:1: ( ( ( rule__XAssignment__Group_0__0 ) ) | ( ( rule__XAssignment__Group_1__0 ) ) )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==RULE_ID) ) {
                int LA8_1 = input.LA(2);

                if ( (LA8_1==13) ) {
                    alt8=1;
                }
                else if ( (LA8_1==EOF||(LA8_1>=RULE_ID && LA8_1<=RULE_STRING)||(LA8_1>=14 && LA8_1<=76)||(LA8_1>=80 && LA8_1<=82)||LA8_1==84) ) {
                    alt8=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 1, input);

                    throw nvae;
                }
            }
            else if ( ((LA8_0>=RULE_HEX && LA8_0<=RULE_STRING)||LA8_0==28||(LA8_0>=35 && LA8_0<=36)||LA8_0==41||(LA8_0>=45 && LA8_0<=46)||(LA8_0>=48 && LA8_0<=49)||(LA8_0>=56 && LA8_0<=57)||LA8_0==59||LA8_0==61||LA8_0==63||(LA8_0>=66 && LA8_0<=74)||LA8_0==84) ) {
                alt8=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // InternalPureXbase.g:2190:2: ( ( rule__XAssignment__Group_0__0 ) )
                    {
                    // InternalPureXbase.g:2190:2: ( ( rule__XAssignment__Group_0__0 ) )
                    // InternalPureXbase.g:2191:3: ( rule__XAssignment__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAssignmentAccess().getGroup_0()); 
                    }
                    // InternalPureXbase.g:2192:3: ( rule__XAssignment__Group_0__0 )
                    // InternalPureXbase.g:2192:4: rule__XAssignment__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAssignment__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAssignmentAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2196:2: ( ( rule__XAssignment__Group_1__0 ) )
                    {
                    // InternalPureXbase.g:2196:2: ( ( rule__XAssignment__Group_1__0 ) )
                    // InternalPureXbase.g:2197:3: ( rule__XAssignment__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAssignmentAccess().getGroup_1()); 
                    }
                    // InternalPureXbase.g:2198:3: ( rule__XAssignment__Group_1__0 )
                    // InternalPureXbase.g:2198:4: rule__XAssignment__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAssignment__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAssignmentAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Alternatives"


    // $ANTLR start "rule__OpMultiAssign__Alternatives"
    // InternalPureXbase.g:2206:1: rule__OpMultiAssign__Alternatives : ( ( '+=' ) | ( '-=' ) | ( '*=' ) | ( '/=' ) | ( '%=' ) | ( ( rule__OpMultiAssign__Group_5__0 ) ) | ( ( rule__OpMultiAssign__Group_6__0 ) ) );
    public final void rule__OpMultiAssign__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2210:1: ( ( '+=' ) | ( '-=' ) | ( '*=' ) | ( '/=' ) | ( '%=' ) | ( ( rule__OpMultiAssign__Group_5__0 ) ) | ( ( rule__OpMultiAssign__Group_6__0 ) ) )
            int alt9=7;
            switch ( input.LA(1) ) {
            case 17:
                {
                alt9=1;
                }
                break;
            case 18:
                {
                alt9=2;
                }
                break;
            case 19:
                {
                alt9=3;
                }
                break;
            case 20:
                {
                alt9=4;
                }
                break;
            case 21:
                {
                alt9=5;
                }
                break;
            case 28:
                {
                alt9=6;
                }
                break;
            case 27:
                {
                alt9=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // InternalPureXbase.g:2211:2: ( '+=' )
                    {
                    // InternalPureXbase.g:2211:2: ( '+=' )
                    // InternalPureXbase.g:2212:3: '+='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getPlusSignEqualsSignKeyword_0()); 
                    }
                    match(input,17,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getPlusSignEqualsSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2217:2: ( '-=' )
                    {
                    // InternalPureXbase.g:2217:2: ( '-=' )
                    // InternalPureXbase.g:2218:3: '-='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getHyphenMinusEqualsSignKeyword_1()); 
                    }
                    match(input,18,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getHyphenMinusEqualsSignKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2223:2: ( '*=' )
                    {
                    // InternalPureXbase.g:2223:2: ( '*=' )
                    // InternalPureXbase.g:2224:3: '*='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getAsteriskEqualsSignKeyword_2()); 
                    }
                    match(input,19,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getAsteriskEqualsSignKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2229:2: ( '/=' )
                    {
                    // InternalPureXbase.g:2229:2: ( '/=' )
                    // InternalPureXbase.g:2230:3: '/='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getSolidusEqualsSignKeyword_3()); 
                    }
                    match(input,20,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getSolidusEqualsSignKeyword_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalPureXbase.g:2235:2: ( '%=' )
                    {
                    // InternalPureXbase.g:2235:2: ( '%=' )
                    // InternalPureXbase.g:2236:3: '%='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getPercentSignEqualsSignKeyword_4()); 
                    }
                    match(input,21,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getPercentSignEqualsSignKeyword_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalPureXbase.g:2241:2: ( ( rule__OpMultiAssign__Group_5__0 ) )
                    {
                    // InternalPureXbase.g:2241:2: ( ( rule__OpMultiAssign__Group_5__0 ) )
                    // InternalPureXbase.g:2242:3: ( rule__OpMultiAssign__Group_5__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getGroup_5()); 
                    }
                    // InternalPureXbase.g:2243:3: ( rule__OpMultiAssign__Group_5__0 )
                    // InternalPureXbase.g:2243:4: rule__OpMultiAssign__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpMultiAssign__Group_5__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getGroup_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalPureXbase.g:2247:2: ( ( rule__OpMultiAssign__Group_6__0 ) )
                    {
                    // InternalPureXbase.g:2247:2: ( ( rule__OpMultiAssign__Group_6__0 ) )
                    // InternalPureXbase.g:2248:3: ( rule__OpMultiAssign__Group_6__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getGroup_6()); 
                    }
                    // InternalPureXbase.g:2249:3: ( rule__OpMultiAssign__Group_6__0 )
                    // InternalPureXbase.g:2249:4: rule__OpMultiAssign__Group_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpMultiAssign__Group_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getGroup_6()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Alternatives"


    // $ANTLR start "rule__OpEquality__Alternatives"
    // InternalPureXbase.g:2257:1: rule__OpEquality__Alternatives : ( ( '==' ) | ( '!=' ) | ( '===' ) | ( '!==' ) );
    public final void rule__OpEquality__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2261:1: ( ( '==' ) | ( '!=' ) | ( '===' ) | ( '!==' ) )
            int alt10=4;
            switch ( input.LA(1) ) {
            case 22:
                {
                alt10=1;
                }
                break;
            case 23:
                {
                alt10=2;
                }
                break;
            case 24:
                {
                alt10=3;
                }
                break;
            case 25:
                {
                alt10=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }

            switch (alt10) {
                case 1 :
                    // InternalPureXbase.g:2262:2: ( '==' )
                    {
                    // InternalPureXbase.g:2262:2: ( '==' )
                    // InternalPureXbase.g:2263:3: '=='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignKeyword_0()); 
                    }
                    match(input,22,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2268:2: ( '!=' )
                    {
                    // InternalPureXbase.g:2268:2: ( '!=' )
                    // InternalPureXbase.g:2269:3: '!='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignKeyword_1()); 
                    }
                    match(input,23,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2274:2: ( '===' )
                    {
                    // InternalPureXbase.g:2274:2: ( '===' )
                    // InternalPureXbase.g:2275:3: '==='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignEqualsSignKeyword_2()); 
                    }
                    match(input,24,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignEqualsSignKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2280:2: ( '!==' )
                    {
                    // InternalPureXbase.g:2280:2: ( '!==' )
                    // InternalPureXbase.g:2281:3: '!=='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignEqualsSignKeyword_3()); 
                    }
                    match(input,25,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignEqualsSignKeyword_3()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpEquality__Alternatives"


    // $ANTLR start "rule__XRelationalExpression__Alternatives_1"
    // InternalPureXbase.g:2290:1: rule__XRelationalExpression__Alternatives_1 : ( ( ( rule__XRelationalExpression__Group_1_0__0 ) ) | ( ( rule__XRelationalExpression__Group_1_1__0 ) ) );
    public final void rule__XRelationalExpression__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2294:1: ( ( ( rule__XRelationalExpression__Group_1_0__0 ) ) | ( ( rule__XRelationalExpression__Group_1_1__0 ) ) )
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==53) ) {
                alt11=1;
            }
            else if ( ((LA11_0>=26 && LA11_0<=28)) ) {
                alt11=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 11, 0, input);

                throw nvae;
            }
            switch (alt11) {
                case 1 :
                    // InternalPureXbase.g:2295:2: ( ( rule__XRelationalExpression__Group_1_0__0 ) )
                    {
                    // InternalPureXbase.g:2295:2: ( ( rule__XRelationalExpression__Group_1_0__0 ) )
                    // InternalPureXbase.g:2296:3: ( rule__XRelationalExpression__Group_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0()); 
                    }
                    // InternalPureXbase.g:2297:3: ( rule__XRelationalExpression__Group_1_0__0 )
                    // InternalPureXbase.g:2297:4: rule__XRelationalExpression__Group_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XRelationalExpression__Group_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2301:2: ( ( rule__XRelationalExpression__Group_1_1__0 ) )
                    {
                    // InternalPureXbase.g:2301:2: ( ( rule__XRelationalExpression__Group_1_1__0 ) )
                    // InternalPureXbase.g:2302:3: ( rule__XRelationalExpression__Group_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1()); 
                    }
                    // InternalPureXbase.g:2303:3: ( rule__XRelationalExpression__Group_1_1__0 )
                    // InternalPureXbase.g:2303:4: rule__XRelationalExpression__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XRelationalExpression__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Alternatives_1"


    // $ANTLR start "rule__OpCompare__Alternatives"
    // InternalPureXbase.g:2311:1: rule__OpCompare__Alternatives : ( ( '>=' ) | ( ( rule__OpCompare__Group_1__0 ) ) | ( '>' ) | ( '<' ) );
    public final void rule__OpCompare__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2315:1: ( ( '>=' ) | ( ( rule__OpCompare__Group_1__0 ) ) | ( '>' ) | ( '<' ) )
            int alt12=4;
            switch ( input.LA(1) ) {
            case 26:
                {
                alt12=1;
                }
                break;
            case 28:
                {
                int LA12_2 = input.LA(2);

                if ( (LA12_2==EOF||(LA12_2>=RULE_ID && LA12_2<=RULE_STRING)||LA12_2==28||(LA12_2>=35 && LA12_2<=36)||LA12_2==41||(LA12_2>=45 && LA12_2<=46)||(LA12_2>=48 && LA12_2<=49)||(LA12_2>=56 && LA12_2<=57)||LA12_2==59||LA12_2==61||LA12_2==63||(LA12_2>=66 && LA12_2<=74)||LA12_2==84) ) {
                    alt12=4;
                }
                else if ( (LA12_2==13) ) {
                    alt12=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 12, 2, input);

                    throw nvae;
                }
                }
                break;
            case 27:
                {
                alt12=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;
            }

            switch (alt12) {
                case 1 :
                    // InternalPureXbase.g:2316:2: ( '>=' )
                    {
                    // InternalPureXbase.g:2316:2: ( '>=' )
                    // InternalPureXbase.g:2317:3: '>='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getGreaterThanSignEqualsSignKeyword_0()); 
                    }
                    match(input,26,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getGreaterThanSignEqualsSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2322:2: ( ( rule__OpCompare__Group_1__0 ) )
                    {
                    // InternalPureXbase.g:2322:2: ( ( rule__OpCompare__Group_1__0 ) )
                    // InternalPureXbase.g:2323:3: ( rule__OpCompare__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getGroup_1()); 
                    }
                    // InternalPureXbase.g:2324:3: ( rule__OpCompare__Group_1__0 )
                    // InternalPureXbase.g:2324:4: rule__OpCompare__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpCompare__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2328:2: ( '>' )
                    {
                    // InternalPureXbase.g:2328:2: ( '>' )
                    // InternalPureXbase.g:2329:3: '>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getGreaterThanSignKeyword_2()); 
                    }
                    match(input,27,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getGreaterThanSignKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2334:2: ( '<' )
                    {
                    // InternalPureXbase.g:2334:2: ( '<' )
                    // InternalPureXbase.g:2335:3: '<'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_3()); 
                    }
                    match(input,28,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_3()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Alternatives"


    // $ANTLR start "rule__OpOther__Alternatives"
    // InternalPureXbase.g:2344:1: rule__OpOther__Alternatives : ( ( '->' ) | ( '..<' ) | ( ( rule__OpOther__Group_2__0 ) ) | ( '..' ) | ( '=>' ) | ( ( rule__OpOther__Group_5__0 ) ) | ( ( rule__OpOther__Group_6__0 ) ) | ( '<>' ) | ( '?:' ) );
    public final void rule__OpOther__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2348:1: ( ( '->' ) | ( '..<' ) | ( ( rule__OpOther__Group_2__0 ) ) | ( '..' ) | ( '=>' ) | ( ( rule__OpOther__Group_5__0 ) ) | ( ( rule__OpOther__Group_6__0 ) ) | ( '<>' ) | ( '?:' ) )
            int alt13=9;
            alt13 = dfa13.predict(input);
            switch (alt13) {
                case 1 :
                    // InternalPureXbase.g:2349:2: ( '->' )
                    {
                    // InternalPureXbase.g:2349:2: ( '->' )
                    // InternalPureXbase.g:2350:3: '->'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getHyphenMinusGreaterThanSignKeyword_0()); 
                    }
                    match(input,29,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getHyphenMinusGreaterThanSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2355:2: ( '..<' )
                    {
                    // InternalPureXbase.g:2355:2: ( '..<' )
                    // InternalPureXbase.g:2356:3: '..<'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getFullStopFullStopLessThanSignKeyword_1()); 
                    }
                    match(input,30,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getFullStopFullStopLessThanSignKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2361:2: ( ( rule__OpOther__Group_2__0 ) )
                    {
                    // InternalPureXbase.g:2361:2: ( ( rule__OpOther__Group_2__0 ) )
                    // InternalPureXbase.g:2362:3: ( rule__OpOther__Group_2__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_2()); 
                    }
                    // InternalPureXbase.g:2363:3: ( rule__OpOther__Group_2__0 )
                    // InternalPureXbase.g:2363:4: rule__OpOther__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2367:2: ( '..' )
                    {
                    // InternalPureXbase.g:2367:2: ( '..' )
                    // InternalPureXbase.g:2368:3: '..'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_3()); 
                    }
                    match(input,31,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalPureXbase.g:2373:2: ( '=>' )
                    {
                    // InternalPureXbase.g:2373:2: ( '=>' )
                    // InternalPureXbase.g:2374:3: '=>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_4()); 
                    }
                    match(input,32,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalPureXbase.g:2379:2: ( ( rule__OpOther__Group_5__0 ) )
                    {
                    // InternalPureXbase.g:2379:2: ( ( rule__OpOther__Group_5__0 ) )
                    // InternalPureXbase.g:2380:3: ( rule__OpOther__Group_5__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_5()); 
                    }
                    // InternalPureXbase.g:2381:3: ( rule__OpOther__Group_5__0 )
                    // InternalPureXbase.g:2381:4: rule__OpOther__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_5__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalPureXbase.g:2385:2: ( ( rule__OpOther__Group_6__0 ) )
                    {
                    // InternalPureXbase.g:2385:2: ( ( rule__OpOther__Group_6__0 ) )
                    // InternalPureXbase.g:2386:3: ( rule__OpOther__Group_6__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_6()); 
                    }
                    // InternalPureXbase.g:2387:3: ( rule__OpOther__Group_6__0 )
                    // InternalPureXbase.g:2387:4: rule__OpOther__Group_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_6()); 
                    }

                    }


                    }
                    break;
                case 8 :
                    // InternalPureXbase.g:2391:2: ( '<>' )
                    {
                    // InternalPureXbase.g:2391:2: ( '<>' )
                    // InternalPureXbase.g:2392:3: '<>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getLessThanSignGreaterThanSignKeyword_7()); 
                    }
                    match(input,33,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getLessThanSignGreaterThanSignKeyword_7()); 
                    }

                    }


                    }
                    break;
                case 9 :
                    // InternalPureXbase.g:2397:2: ( '?:' )
                    {
                    // InternalPureXbase.g:2397:2: ( '?:' )
                    // InternalPureXbase.g:2398:3: '?:'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getQuestionMarkColonKeyword_8()); 
                    }
                    match(input,34,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getQuestionMarkColonKeyword_8()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Alternatives"


    // $ANTLR start "rule__OpOther__Alternatives_5_1"
    // InternalPureXbase.g:2407:1: rule__OpOther__Alternatives_5_1 : ( ( ( rule__OpOther__Group_5_1_0__0 ) ) | ( '>' ) );
    public final void rule__OpOther__Alternatives_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2411:1: ( ( ( rule__OpOther__Group_5_1_0__0 ) ) | ( '>' ) )
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==27) ) {
                int LA14_1 = input.LA(2);

                if ( (LA14_1==EOF||(LA14_1>=RULE_ID && LA14_1<=RULE_STRING)||LA14_1==28||(LA14_1>=35 && LA14_1<=36)||LA14_1==41||(LA14_1>=45 && LA14_1<=46)||(LA14_1>=48 && LA14_1<=49)||(LA14_1>=56 && LA14_1<=57)||LA14_1==59||LA14_1==61||LA14_1==63||(LA14_1>=66 && LA14_1<=74)||LA14_1==84) ) {
                    alt14=2;
                }
                else if ( (LA14_1==27) ) {
                    alt14=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 14, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;
            }
            switch (alt14) {
                case 1 :
                    // InternalPureXbase.g:2412:2: ( ( rule__OpOther__Group_5_1_0__0 ) )
                    {
                    // InternalPureXbase.g:2412:2: ( ( rule__OpOther__Group_5_1_0__0 ) )
                    // InternalPureXbase.g:2413:3: ( rule__OpOther__Group_5_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_5_1_0()); 
                    }
                    // InternalPureXbase.g:2414:3: ( rule__OpOther__Group_5_1_0__0 )
                    // InternalPureXbase.g:2414:4: rule__OpOther__Group_5_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_5_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_5_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2418:2: ( '>' )
                    {
                    // InternalPureXbase.g:2418:2: ( '>' )
                    // InternalPureXbase.g:2419:3: '>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_1()); 
                    }
                    match(input,27,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Alternatives_5_1"


    // $ANTLR start "rule__OpOther__Alternatives_6_1"
    // InternalPureXbase.g:2428:1: rule__OpOther__Alternatives_6_1 : ( ( ( rule__OpOther__Group_6_1_0__0 ) ) | ( '<' ) | ( '=>' ) );
    public final void rule__OpOther__Alternatives_6_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2432:1: ( ( ( rule__OpOther__Group_6_1_0__0 ) ) | ( '<' ) | ( '=>' ) )
            int alt15=3;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==28) ) {
                int LA15_1 = input.LA(2);

                if ( (synpred31_InternalPureXbase()) ) {
                    alt15=1;
                }
                else if ( (synpred32_InternalPureXbase()) ) {
                    alt15=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 15, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA15_0==32) ) {
                alt15=3;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 15, 0, input);

                throw nvae;
            }
            switch (alt15) {
                case 1 :
                    // InternalPureXbase.g:2433:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
                    {
                    // InternalPureXbase.g:2433:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
                    // InternalPureXbase.g:2434:3: ( rule__OpOther__Group_6_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_6_1_0()); 
                    }
                    // InternalPureXbase.g:2435:3: ( rule__OpOther__Group_6_1_0__0 )
                    // InternalPureXbase.g:2435:4: rule__OpOther__Group_6_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_6_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_6_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2439:2: ( '<' )
                    {
                    // InternalPureXbase.g:2439:2: ( '<' )
                    // InternalPureXbase.g:2440:3: '<'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1()); 
                    }
                    match(input,28,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2445:2: ( '=>' )
                    {
                    // InternalPureXbase.g:2445:2: ( '=>' )
                    // InternalPureXbase.g:2446:3: '=>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_6_1_2()); 
                    }
                    match(input,32,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_6_1_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Alternatives_6_1"


    // $ANTLR start "rule__OpAdd__Alternatives"
    // InternalPureXbase.g:2455:1: rule__OpAdd__Alternatives : ( ( '+' ) | ( '-' ) );
    public final void rule__OpAdd__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2459:1: ( ( '+' ) | ( '-' ) )
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==35) ) {
                alt16=1;
            }
            else if ( (LA16_0==36) ) {
                alt16=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 16, 0, input);

                throw nvae;
            }
            switch (alt16) {
                case 1 :
                    // InternalPureXbase.g:2460:2: ( '+' )
                    {
                    // InternalPureXbase.g:2460:2: ( '+' )
                    // InternalPureXbase.g:2461:3: '+'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpAddAccess().getPlusSignKeyword_0()); 
                    }
                    match(input,35,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpAddAccess().getPlusSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2466:2: ( '-' )
                    {
                    // InternalPureXbase.g:2466:2: ( '-' )
                    // InternalPureXbase.g:2467:3: '-'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpAddAccess().getHyphenMinusKeyword_1()); 
                    }
                    match(input,36,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpAddAccess().getHyphenMinusKeyword_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpAdd__Alternatives"


    // $ANTLR start "rule__OpMulti__Alternatives"
    // InternalPureXbase.g:2476:1: rule__OpMulti__Alternatives : ( ( '*' ) | ( '**' ) | ( '/' ) | ( '%' ) );
    public final void rule__OpMulti__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2480:1: ( ( '*' ) | ( '**' ) | ( '/' ) | ( '%' ) )
            int alt17=4;
            switch ( input.LA(1) ) {
            case 37:
                {
                alt17=1;
                }
                break;
            case 38:
                {
                alt17=2;
                }
                break;
            case 39:
                {
                alt17=3;
                }
                break;
            case 40:
                {
                alt17=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }

            switch (alt17) {
                case 1 :
                    // InternalPureXbase.g:2481:2: ( '*' )
                    {
                    // InternalPureXbase.g:2481:2: ( '*' )
                    // InternalPureXbase.g:2482:3: '*'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getAsteriskKeyword_0()); 
                    }
                    match(input,37,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getAsteriskKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2487:2: ( '**' )
                    {
                    // InternalPureXbase.g:2487:2: ( '**' )
                    // InternalPureXbase.g:2488:3: '**'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getAsteriskAsteriskKeyword_1()); 
                    }
                    match(input,38,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getAsteriskAsteriskKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2493:2: ( '/' )
                    {
                    // InternalPureXbase.g:2493:2: ( '/' )
                    // InternalPureXbase.g:2494:3: '/'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getSolidusKeyword_2()); 
                    }
                    match(input,39,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getSolidusKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2499:2: ( '%' )
                    {
                    // InternalPureXbase.g:2499:2: ( '%' )
                    // InternalPureXbase.g:2500:3: '%'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getPercentSignKeyword_3()); 
                    }
                    match(input,40,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getPercentSignKeyword_3()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMulti__Alternatives"


    // $ANTLR start "rule__XUnaryOperation__Alternatives"
    // InternalPureXbase.g:2509:1: rule__XUnaryOperation__Alternatives : ( ( ( rule__XUnaryOperation__Group_0__0 ) ) | ( ruleXCastedExpression ) );
    public final void rule__XUnaryOperation__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2513:1: ( ( ( rule__XUnaryOperation__Group_0__0 ) ) | ( ruleXCastedExpression ) )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( ((LA18_0>=35 && LA18_0<=36)||LA18_0==41) ) {
                alt18=1;
            }
            else if ( ((LA18_0>=RULE_ID && LA18_0<=RULE_STRING)||LA18_0==28||(LA18_0>=45 && LA18_0<=46)||(LA18_0>=48 && LA18_0<=49)||(LA18_0>=56 && LA18_0<=57)||LA18_0==59||LA18_0==61||LA18_0==63||(LA18_0>=66 && LA18_0<=74)||LA18_0==84) ) {
                alt18=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // InternalPureXbase.g:2514:2: ( ( rule__XUnaryOperation__Group_0__0 ) )
                    {
                    // InternalPureXbase.g:2514:2: ( ( rule__XUnaryOperation__Group_0__0 ) )
                    // InternalPureXbase.g:2515:3: ( rule__XUnaryOperation__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXUnaryOperationAccess().getGroup_0()); 
                    }
                    // InternalPureXbase.g:2516:3: ( rule__XUnaryOperation__Group_0__0 )
                    // InternalPureXbase.g:2516:4: rule__XUnaryOperation__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XUnaryOperation__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXUnaryOperationAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2520:2: ( ruleXCastedExpression )
                    {
                    // InternalPureXbase.g:2520:2: ( ruleXCastedExpression )
                    // InternalPureXbase.g:2521:3: ruleXCastedExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXUnaryOperationAccess().getXCastedExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXCastedExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXUnaryOperationAccess().getXCastedExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Alternatives"


    // $ANTLR start "rule__OpUnary__Alternatives"
    // InternalPureXbase.g:2530:1: rule__OpUnary__Alternatives : ( ( '!' ) | ( '-' ) | ( '+' ) );
    public final void rule__OpUnary__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2534:1: ( ( '!' ) | ( '-' ) | ( '+' ) )
            int alt19=3;
            switch ( input.LA(1) ) {
            case 41:
                {
                alt19=1;
                }
                break;
            case 36:
                {
                alt19=2;
                }
                break;
            case 35:
                {
                alt19=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }

            switch (alt19) {
                case 1 :
                    // InternalPureXbase.g:2535:2: ( '!' )
                    {
                    // InternalPureXbase.g:2535:2: ( '!' )
                    // InternalPureXbase.g:2536:3: '!'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpUnaryAccess().getExclamationMarkKeyword_0()); 
                    }
                    match(input,41,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpUnaryAccess().getExclamationMarkKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2541:2: ( '-' )
                    {
                    // InternalPureXbase.g:2541:2: ( '-' )
                    // InternalPureXbase.g:2542:3: '-'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpUnaryAccess().getHyphenMinusKeyword_1()); 
                    }
                    match(input,36,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpUnaryAccess().getHyphenMinusKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2547:2: ( '+' )
                    {
                    // InternalPureXbase.g:2547:2: ( '+' )
                    // InternalPureXbase.g:2548:3: '+'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpUnaryAccess().getPlusSignKeyword_2()); 
                    }
                    match(input,35,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpUnaryAccess().getPlusSignKeyword_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpUnary__Alternatives"


    // $ANTLR start "rule__OpPostfix__Alternatives"
    // InternalPureXbase.g:2557:1: rule__OpPostfix__Alternatives : ( ( '++' ) | ( '--' ) );
    public final void rule__OpPostfix__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2561:1: ( ( '++' ) | ( '--' ) )
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==42) ) {
                alt20=1;
            }
            else if ( (LA20_0==43) ) {
                alt20=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }
            switch (alt20) {
                case 1 :
                    // InternalPureXbase.g:2562:2: ( '++' )
                    {
                    // InternalPureXbase.g:2562:2: ( '++' )
                    // InternalPureXbase.g:2563:3: '++'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpPostfixAccess().getPlusSignPlusSignKeyword_0()); 
                    }
                    match(input,42,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpPostfixAccess().getPlusSignPlusSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2568:2: ( '--' )
                    {
                    // InternalPureXbase.g:2568:2: ( '--' )
                    // InternalPureXbase.g:2569:3: '--'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpPostfixAccess().getHyphenMinusHyphenMinusKeyword_1()); 
                    }
                    match(input,43,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpPostfixAccess().getHyphenMinusHyphenMinusKeyword_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpPostfix__Alternatives"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1"
    // InternalPureXbase.g:2578:1: rule__XMemberFeatureCall__Alternatives_1 : ( ( ( rule__XMemberFeatureCall__Group_1_0__0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1__0 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2582:1: ( ( ( rule__XMemberFeatureCall__Group_1_0__0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1__0 ) ) )
            int alt21=2;
            switch ( input.LA(1) ) {
            case 44:
                {
                int LA21_1 = input.LA(2);

                if ( (LA21_1==RULE_ID) ) {
                    int LA21_4 = input.LA(3);

                    if ( (LA21_4==13) ) {
                        alt21=1;
                    }
                    else if ( (LA21_4==EOF||(LA21_4>=RULE_ID && LA21_4<=RULE_STRING)||(LA21_4>=14 && LA21_4<=76)||(LA21_4>=80 && LA21_4<=82)||LA21_4==84) ) {
                        alt21=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return ;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 21, 4, input);

                        throw nvae;
                    }
                }
                else if ( (LA21_1==28||LA21_1==45) ) {
                    alt21=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 21, 1, input);

                    throw nvae;
                }
                }
                break;
            case 81:
                {
                int LA21_2 = input.LA(2);

                if ( (LA21_2==28||LA21_2==45) ) {
                    alt21=2;
                }
                else if ( (LA21_2==RULE_ID) ) {
                    int LA21_4 = input.LA(3);

                    if ( (LA21_4==13) ) {
                        alt21=1;
                    }
                    else if ( (LA21_4==EOF||(LA21_4>=RULE_ID && LA21_4<=RULE_STRING)||(LA21_4>=14 && LA21_4<=76)||(LA21_4>=80 && LA21_4<=82)||LA21_4==84) ) {
                        alt21=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return ;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 21, 4, input);

                        throw nvae;
                    }
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 21, 2, input);

                    throw nvae;
                }
                }
                break;
            case 82:
                {
                alt21=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;
            }

            switch (alt21) {
                case 1 :
                    // InternalPureXbase.g:2583:2: ( ( rule__XMemberFeatureCall__Group_1_0__0 ) )
                    {
                    // InternalPureXbase.g:2583:2: ( ( rule__XMemberFeatureCall__Group_1_0__0 ) )
                    // InternalPureXbase.g:2584:3: ( rule__XMemberFeatureCall__Group_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0()); 
                    }
                    // InternalPureXbase.g:2585:3: ( rule__XMemberFeatureCall__Group_1_0__0 )
                    // InternalPureXbase.g:2585:4: rule__XMemberFeatureCall__Group_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2589:2: ( ( rule__XMemberFeatureCall__Group_1_1__0 ) )
                    {
                    // InternalPureXbase.g:2589:2: ( ( rule__XMemberFeatureCall__Group_1_1__0 ) )
                    // InternalPureXbase.g:2590:3: ( rule__XMemberFeatureCall__Group_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1()); 
                    }
                    // InternalPureXbase.g:2591:3: ( rule__XMemberFeatureCall__Group_1_1__0 )
                    // InternalPureXbase.g:2591:4: rule__XMemberFeatureCall__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1_0_0_0_1"
    // InternalPureXbase.g:2599:1: rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 : ( ( '.' ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1_0_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2603:1: ( ( '.' ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) ) )
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==44) ) {
                alt22=1;
            }
            else if ( (LA22_0==81) ) {
                alt22=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 22, 0, input);

                throw nvae;
            }
            switch (alt22) {
                case 1 :
                    // InternalPureXbase.g:2604:2: ( '.' )
                    {
                    // InternalPureXbase.g:2604:2: ( '.' )
                    // InternalPureXbase.g:2605:3: '.'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_0_0_0_1_0()); 
                    }
                    match(input,44,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_0_0_0_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2610:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) )
                    {
                    // InternalPureXbase.g:2610:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) )
                    // InternalPureXbase.g:2611:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_0_0_0_1_1()); 
                    }
                    // InternalPureXbase.g:2612:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 )
                    // InternalPureXbase.g:2612:4: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_0_0_0_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1_0_0_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1_1_0_0_1"
    // InternalPureXbase.g:2620:1: rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 : ( ( '.' ) | ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2624:1: ( ( '.' ) | ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) ) )
            int alt23=3;
            switch ( input.LA(1) ) {
            case 44:
                {
                alt23=1;
                }
                break;
            case 82:
                {
                alt23=2;
                }
                break;
            case 81:
                {
                alt23=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }

            switch (alt23) {
                case 1 :
                    // InternalPureXbase.g:2625:2: ( '.' )
                    {
                    // InternalPureXbase.g:2625:2: ( '.' )
                    // InternalPureXbase.g:2626:3: '.'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_1_0_0_1_0()); 
                    }
                    match(input,44,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_1_0_0_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2631:2: ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) )
                    {
                    // InternalPureXbase.g:2631:2: ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) )
                    // InternalPureXbase.g:2632:3: ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getNullSafeAssignment_1_1_0_0_1_1()); 
                    }
                    // InternalPureXbase.g:2633:3: ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 )
                    // InternalPureXbase.g:2633:4: rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getNullSafeAssignment_1_1_0_0_1_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2637:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) )
                    {
                    // InternalPureXbase.g:2637:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) )
                    // InternalPureXbase.g:2638:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_1_0_0_1_2()); 
                    }
                    // InternalPureXbase.g:2639:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 )
                    // InternalPureXbase.g:2639:4: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_1_0_0_1_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1_1_0_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1_1_3_1"
    // InternalPureXbase.g:2647:1: rule__XMemberFeatureCall__Alternatives_1_1_3_1 : ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1_1_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2651:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) ) )
            int alt24=2;
            alt24 = dfa24.predict(input);
            switch (alt24) {
                case 1 :
                    // InternalPureXbase.g:2652:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
                    {
                    // InternalPureXbase.g:2652:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
                    // InternalPureXbase.g:2653:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_0()); 
                    }
                    // InternalPureXbase.g:2654:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
                    // InternalPureXbase.g:2654:4: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2658:2: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) )
                    {
                    // InternalPureXbase.g:2658:2: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) )
                    // InternalPureXbase.g:2659:3: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1()); 
                    }
                    // InternalPureXbase.g:2660:3: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 )
                    // InternalPureXbase.g:2660:4: rule__XMemberFeatureCall__Group_1_1_3_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1_3_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1_1_3_1"


    // $ANTLR start "rule__XPrimaryExpression__Alternatives"
    // InternalPureXbase.g:2668:1: rule__XPrimaryExpression__Alternatives : ( ( ruleXConstructorCall ) | ( ruleXBlockExpression ) | ( ruleXSwitchExpression ) | ( ( ruleXSynchronizedExpression ) ) | ( ruleXFeatureCall ) | ( ruleXLiteral ) | ( ruleXIfExpression ) | ( ( ruleXForLoopExpression ) ) | ( ruleXBasicForLoopExpression ) | ( ruleXWhileExpression ) | ( ruleXDoWhileExpression ) | ( ruleXThrowExpression ) | ( ruleXReturnExpression ) | ( ruleXTryCatchFinallyExpression ) | ( ruleXParenthesizedExpression ) );
    public final void rule__XPrimaryExpression__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2672:1: ( ( ruleXConstructorCall ) | ( ruleXBlockExpression ) | ( ruleXSwitchExpression ) | ( ( ruleXSynchronizedExpression ) ) | ( ruleXFeatureCall ) | ( ruleXLiteral ) | ( ruleXIfExpression ) | ( ( ruleXForLoopExpression ) ) | ( ruleXBasicForLoopExpression ) | ( ruleXWhileExpression ) | ( ruleXDoWhileExpression ) | ( ruleXThrowExpression ) | ( ruleXReturnExpression ) | ( ruleXTryCatchFinallyExpression ) | ( ruleXParenthesizedExpression ) )
            int alt25=15;
            alt25 = dfa25.predict(input);
            switch (alt25) {
                case 1 :
                    // InternalPureXbase.g:2673:2: ( ruleXConstructorCall )
                    {
                    // InternalPureXbase.g:2673:2: ( ruleXConstructorCall )
                    // InternalPureXbase.g:2674:3: ruleXConstructorCall
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXConstructorCallParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXConstructorCall();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXConstructorCallParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2679:2: ( ruleXBlockExpression )
                    {
                    // InternalPureXbase.g:2679:2: ( ruleXBlockExpression )
                    // InternalPureXbase.g:2680:3: ruleXBlockExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXBlockExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXBlockExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXBlockExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2685:2: ( ruleXSwitchExpression )
                    {
                    // InternalPureXbase.g:2685:2: ( ruleXSwitchExpression )
                    // InternalPureXbase.g:2686:3: ruleXSwitchExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXSwitchExpressionParserRuleCall_2()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXSwitchExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXSwitchExpressionParserRuleCall_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2691:2: ( ( ruleXSynchronizedExpression ) )
                    {
                    // InternalPureXbase.g:2691:2: ( ( ruleXSynchronizedExpression ) )
                    // InternalPureXbase.g:2692:3: ( ruleXSynchronizedExpression )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXSynchronizedExpressionParserRuleCall_3()); 
                    }
                    // InternalPureXbase.g:2693:3: ( ruleXSynchronizedExpression )
                    // InternalPureXbase.g:2693:4: ruleXSynchronizedExpression
                    {
                    pushFollow(FOLLOW_2);
                    ruleXSynchronizedExpression();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXSynchronizedExpressionParserRuleCall_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalPureXbase.g:2697:2: ( ruleXFeatureCall )
                    {
                    // InternalPureXbase.g:2697:2: ( ruleXFeatureCall )
                    // InternalPureXbase.g:2698:3: ruleXFeatureCall
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXFeatureCallParserRuleCall_4()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXFeatureCall();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXFeatureCallParserRuleCall_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalPureXbase.g:2703:2: ( ruleXLiteral )
                    {
                    // InternalPureXbase.g:2703:2: ( ruleXLiteral )
                    // InternalPureXbase.g:2704:3: ruleXLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXLiteralParserRuleCall_5()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXLiteralParserRuleCall_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalPureXbase.g:2709:2: ( ruleXIfExpression )
                    {
                    // InternalPureXbase.g:2709:2: ( ruleXIfExpression )
                    // InternalPureXbase.g:2710:3: ruleXIfExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXIfExpressionParserRuleCall_6()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXIfExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXIfExpressionParserRuleCall_6()); 
                    }

                    }


                    }
                    break;
                case 8 :
                    // InternalPureXbase.g:2715:2: ( ( ruleXForLoopExpression ) )
                    {
                    // InternalPureXbase.g:2715:2: ( ( ruleXForLoopExpression ) )
                    // InternalPureXbase.g:2716:3: ( ruleXForLoopExpression )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7()); 
                    }
                    // InternalPureXbase.g:2717:3: ( ruleXForLoopExpression )
                    // InternalPureXbase.g:2717:4: ruleXForLoopExpression
                    {
                    pushFollow(FOLLOW_2);
                    ruleXForLoopExpression();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7()); 
                    }

                    }


                    }
                    break;
                case 9 :
                    // InternalPureXbase.g:2721:2: ( ruleXBasicForLoopExpression )
                    {
                    // InternalPureXbase.g:2721:2: ( ruleXBasicForLoopExpression )
                    // InternalPureXbase.g:2722:3: ruleXBasicForLoopExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXBasicForLoopExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8()); 
                    }

                    }


                    }
                    break;
                case 10 :
                    // InternalPureXbase.g:2727:2: ( ruleXWhileExpression )
                    {
                    // InternalPureXbase.g:2727:2: ( ruleXWhileExpression )
                    // InternalPureXbase.g:2728:3: ruleXWhileExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXWhileExpressionParserRuleCall_9()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXWhileExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXWhileExpressionParserRuleCall_9()); 
                    }

                    }


                    }
                    break;
                case 11 :
                    // InternalPureXbase.g:2733:2: ( ruleXDoWhileExpression )
                    {
                    // InternalPureXbase.g:2733:2: ( ruleXDoWhileExpression )
                    // InternalPureXbase.g:2734:3: ruleXDoWhileExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXDoWhileExpressionParserRuleCall_10()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXDoWhileExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXDoWhileExpressionParserRuleCall_10()); 
                    }

                    }


                    }
                    break;
                case 12 :
                    // InternalPureXbase.g:2739:2: ( ruleXThrowExpression )
                    {
                    // InternalPureXbase.g:2739:2: ( ruleXThrowExpression )
                    // InternalPureXbase.g:2740:3: ruleXThrowExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXThrowExpressionParserRuleCall_11()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXThrowExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXThrowExpressionParserRuleCall_11()); 
                    }

                    }


                    }
                    break;
                case 13 :
                    // InternalPureXbase.g:2745:2: ( ruleXReturnExpression )
                    {
                    // InternalPureXbase.g:2745:2: ( ruleXReturnExpression )
                    // InternalPureXbase.g:2746:3: ruleXReturnExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXReturnExpressionParserRuleCall_12()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXReturnExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXReturnExpressionParserRuleCall_12()); 
                    }

                    }


                    }
                    break;
                case 14 :
                    // InternalPureXbase.g:2751:2: ( ruleXTryCatchFinallyExpression )
                    {
                    // InternalPureXbase.g:2751:2: ( ruleXTryCatchFinallyExpression )
                    // InternalPureXbase.g:2752:3: ruleXTryCatchFinallyExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXTryCatchFinallyExpressionParserRuleCall_13()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXTryCatchFinallyExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXTryCatchFinallyExpressionParserRuleCall_13()); 
                    }

                    }


                    }
                    break;
                case 15 :
                    // InternalPureXbase.g:2757:2: ( ruleXParenthesizedExpression )
                    {
                    // InternalPureXbase.g:2757:2: ( ruleXParenthesizedExpression )
                    // InternalPureXbase.g:2758:3: ruleXParenthesizedExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXParenthesizedExpressionParserRuleCall_14()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXParenthesizedExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXParenthesizedExpressionParserRuleCall_14()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPrimaryExpression__Alternatives"


    // $ANTLR start "rule__XLiteral__Alternatives"
    // InternalPureXbase.g:2767:1: rule__XLiteral__Alternatives : ( ( ruleXCollectionLiteral ) | ( ( ruleXClosure ) ) | ( ruleXBooleanLiteral ) | ( ruleXNumberLiteral ) | ( ruleXNullLiteral ) | ( ruleXStringLiteral ) | ( ruleXTypeLiteral ) );
    public final void rule__XLiteral__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2771:1: ( ( ruleXCollectionLiteral ) | ( ( ruleXClosure ) ) | ( ruleXBooleanLiteral ) | ( ruleXNumberLiteral ) | ( ruleXNullLiteral ) | ( ruleXStringLiteral ) | ( ruleXTypeLiteral ) )
            int alt26=7;
            switch ( input.LA(1) ) {
            case 56:
                {
                alt26=1;
                }
                break;
            case 59:
                {
                alt26=2;
                }
                break;
            case 46:
            case 84:
                {
                alt26=3;
                }
                break;
            case RULE_HEX:
            case RULE_INT:
            case RULE_DECIMAL:
                {
                alt26=4;
                }
                break;
            case 70:
                {
                alt26=5;
                }
                break;
            case RULE_STRING:
                {
                alt26=6;
                }
                break;
            case 71:
                {
                alt26=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }

            switch (alt26) {
                case 1 :
                    // InternalPureXbase.g:2772:2: ( ruleXCollectionLiteral )
                    {
                    // InternalPureXbase.g:2772:2: ( ruleXCollectionLiteral )
                    // InternalPureXbase.g:2773:3: ruleXCollectionLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXCollectionLiteralParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXCollectionLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXCollectionLiteralParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2778:2: ( ( ruleXClosure ) )
                    {
                    // InternalPureXbase.g:2778:2: ( ( ruleXClosure ) )
                    // InternalPureXbase.g:2779:3: ( ruleXClosure )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXClosureParserRuleCall_1()); 
                    }
                    // InternalPureXbase.g:2780:3: ( ruleXClosure )
                    // InternalPureXbase.g:2780:4: ruleXClosure
                    {
                    pushFollow(FOLLOW_2);
                    ruleXClosure();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXClosureParserRuleCall_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:2784:2: ( ruleXBooleanLiteral )
                    {
                    // InternalPureXbase.g:2784:2: ( ruleXBooleanLiteral )
                    // InternalPureXbase.g:2785:3: ruleXBooleanLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXBooleanLiteralParserRuleCall_2()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXBooleanLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXBooleanLiteralParserRuleCall_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalPureXbase.g:2790:2: ( ruleXNumberLiteral )
                    {
                    // InternalPureXbase.g:2790:2: ( ruleXNumberLiteral )
                    // InternalPureXbase.g:2791:3: ruleXNumberLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXNumberLiteralParserRuleCall_3()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXNumberLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXNumberLiteralParserRuleCall_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalPureXbase.g:2796:2: ( ruleXNullLiteral )
                    {
                    // InternalPureXbase.g:2796:2: ( ruleXNullLiteral )
                    // InternalPureXbase.g:2797:3: ruleXNullLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXNullLiteralParserRuleCall_4()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXNullLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXNullLiteralParserRuleCall_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalPureXbase.g:2802:2: ( ruleXStringLiteral )
                    {
                    // InternalPureXbase.g:2802:2: ( ruleXStringLiteral )
                    // InternalPureXbase.g:2803:3: ruleXStringLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXStringLiteralParserRuleCall_5()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXStringLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXStringLiteralParserRuleCall_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalPureXbase.g:2808:2: ( ruleXTypeLiteral )
                    {
                    // InternalPureXbase.g:2808:2: ( ruleXTypeLiteral )
                    // InternalPureXbase.g:2809:3: ruleXTypeLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXTypeLiteralParserRuleCall_6()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXTypeLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXTypeLiteralParserRuleCall_6()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XLiteral__Alternatives"


    // $ANTLR start "rule__XCollectionLiteral__Alternatives"
    // InternalPureXbase.g:2818:1: rule__XCollectionLiteral__Alternatives : ( ( ruleXSetLiteral ) | ( ruleXListLiteral ) );
    public final void rule__XCollectionLiteral__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2822:1: ( ( ruleXSetLiteral ) | ( ruleXListLiteral ) )
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==56) ) {
                int LA27_1 = input.LA(2);

                if ( (LA27_1==57) ) {
                    alt27=1;
                }
                else if ( (LA27_1==59) ) {
                    alt27=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 27, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;
            }
            switch (alt27) {
                case 1 :
                    // InternalPureXbase.g:2823:2: ( ruleXSetLiteral )
                    {
                    // InternalPureXbase.g:2823:2: ( ruleXSetLiteral )
                    // InternalPureXbase.g:2824:3: ruleXSetLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCollectionLiteralAccess().getXSetLiteralParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXSetLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCollectionLiteralAccess().getXSetLiteralParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2829:2: ( ruleXListLiteral )
                    {
                    // InternalPureXbase.g:2829:2: ( ruleXListLiteral )
                    // InternalPureXbase.g:2830:3: ruleXListLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCollectionLiteralAccess().getXListLiteralParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXListLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCollectionLiteralAccess().getXListLiteralParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCollectionLiteral__Alternatives"


    // $ANTLR start "rule__XSwitchExpression__Alternatives_2"
    // InternalPureXbase.g:2839:1: rule__XSwitchExpression__Alternatives_2 : ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) | ( ( rule__XSwitchExpression__Group_2_1__0 ) ) );
    public final void rule__XSwitchExpression__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2843:1: ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) | ( ( rule__XSwitchExpression__Group_2_1__0 ) ) )
            int alt28=2;
            alt28 = dfa28.predict(input);
            switch (alt28) {
                case 1 :
                    // InternalPureXbase.g:2844:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
                    {
                    // InternalPureXbase.g:2844:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
                    // InternalPureXbase.g:2845:3: ( rule__XSwitchExpression__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0()); 
                    }
                    // InternalPureXbase.g:2846:3: ( rule__XSwitchExpression__Group_2_0__0 )
                    // InternalPureXbase.g:2846:4: rule__XSwitchExpression__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2850:2: ( ( rule__XSwitchExpression__Group_2_1__0 ) )
                    {
                    // InternalPureXbase.g:2850:2: ( ( rule__XSwitchExpression__Group_2_1__0 ) )
                    // InternalPureXbase.g:2851:3: ( rule__XSwitchExpression__Group_2_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1()); 
                    }
                    // InternalPureXbase.g:2852:3: ( rule__XSwitchExpression__Group_2_1__0 )
                    // InternalPureXbase.g:2852:4: rule__XSwitchExpression__Group_2_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_2_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Alternatives_2"


    // $ANTLR start "rule__XCasePart__Alternatives_3"
    // InternalPureXbase.g:2860:1: rule__XCasePart__Alternatives_3 : ( ( ( rule__XCasePart__Group_3_0__0 ) ) | ( ( rule__XCasePart__FallThroughAssignment_3_1 ) ) );
    public final void rule__XCasePart__Alternatives_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2864:1: ( ( ( rule__XCasePart__Group_3_0__0 ) ) | ( ( rule__XCasePart__FallThroughAssignment_3_1 ) ) )
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==52) ) {
                alt29=1;
            }
            else if ( (LA29_0==55) ) {
                alt29=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;
            }
            switch (alt29) {
                case 1 :
                    // InternalPureXbase.g:2865:2: ( ( rule__XCasePart__Group_3_0__0 ) )
                    {
                    // InternalPureXbase.g:2865:2: ( ( rule__XCasePart__Group_3_0__0 ) )
                    // InternalPureXbase.g:2866:3: ( rule__XCasePart__Group_3_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCasePartAccess().getGroup_3_0()); 
                    }
                    // InternalPureXbase.g:2867:3: ( rule__XCasePart__Group_3_0__0 )
                    // InternalPureXbase.g:2867:4: rule__XCasePart__Group_3_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__Group_3_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCasePartAccess().getGroup_3_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2871:2: ( ( rule__XCasePart__FallThroughAssignment_3_1 ) )
                    {
                    // InternalPureXbase.g:2871:2: ( ( rule__XCasePart__FallThroughAssignment_3_1 ) )
                    // InternalPureXbase.g:2872:3: ( rule__XCasePart__FallThroughAssignment_3_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCasePartAccess().getFallThroughAssignment_3_1()); 
                    }
                    // InternalPureXbase.g:2873:3: ( rule__XCasePart__FallThroughAssignment_3_1 )
                    // InternalPureXbase.g:2873:4: rule__XCasePart__FallThroughAssignment_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__FallThroughAssignment_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCasePartAccess().getFallThroughAssignment_3_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Alternatives_3"


    // $ANTLR start "rule__XExpressionOrVarDeclaration__Alternatives"
    // InternalPureXbase.g:2881:1: rule__XExpressionOrVarDeclaration__Alternatives : ( ( ruleXVariableDeclaration ) | ( ruleXExpression ) );
    public final void rule__XExpressionOrVarDeclaration__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2885:1: ( ( ruleXVariableDeclaration ) | ( ruleXExpression ) )
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==16||LA30_0==80) ) {
                alt30=1;
            }
            else if ( ((LA30_0>=RULE_ID && LA30_0<=RULE_STRING)||LA30_0==28||(LA30_0>=35 && LA30_0<=36)||LA30_0==41||(LA30_0>=45 && LA30_0<=46)||(LA30_0>=48 && LA30_0<=49)||(LA30_0>=56 && LA30_0<=57)||LA30_0==59||LA30_0==61||LA30_0==63||(LA30_0>=66 && LA30_0<=74)||LA30_0==84) ) {
                alt30=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 30, 0, input);

                throw nvae;
            }
            switch (alt30) {
                case 1 :
                    // InternalPureXbase.g:2886:2: ( ruleXVariableDeclaration )
                    {
                    // InternalPureXbase.g:2886:2: ( ruleXVariableDeclaration )
                    // InternalPureXbase.g:2887:3: ruleXVariableDeclaration
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXExpressionOrVarDeclarationAccess().getXVariableDeclarationParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXVariableDeclaration();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXExpressionOrVarDeclarationAccess().getXVariableDeclarationParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2892:2: ( ruleXExpression )
                    {
                    // InternalPureXbase.g:2892:2: ( ruleXExpression )
                    // InternalPureXbase.g:2893:3: ruleXExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXExpressionOrVarDeclarationAccess().getXExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXExpressionOrVarDeclarationAccess().getXExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionOrVarDeclaration__Alternatives"


    // $ANTLR start "rule__XVariableDeclaration__Alternatives_1"
    // InternalPureXbase.g:2902:1: rule__XVariableDeclaration__Alternatives_1 : ( ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) ) | ( 'val' ) );
    public final void rule__XVariableDeclaration__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2906:1: ( ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) ) | ( 'val' ) )
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==80) ) {
                alt31=1;
            }
            else if ( (LA31_0==16) ) {
                alt31=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 31, 0, input);

                throw nvae;
            }
            switch (alt31) {
                case 1 :
                    // InternalPureXbase.g:2907:2: ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) )
                    {
                    // InternalPureXbase.g:2907:2: ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) )
                    // InternalPureXbase.g:2908:3: ( rule__XVariableDeclaration__WriteableAssignment_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getWriteableAssignment_1_0()); 
                    }
                    // InternalPureXbase.g:2909:3: ( rule__XVariableDeclaration__WriteableAssignment_1_0 )
                    // InternalPureXbase.g:2909:4: rule__XVariableDeclaration__WriteableAssignment_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__WriteableAssignment_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getWriteableAssignment_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2913:2: ( 'val' )
                    {
                    // InternalPureXbase.g:2913:2: ( 'val' )
                    // InternalPureXbase.g:2914:3: 'val'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getValKeyword_1_1()); 
                    }
                    match(input,16,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getValKeyword_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Alternatives_1"


    // $ANTLR start "rule__XVariableDeclaration__Alternatives_2"
    // InternalPureXbase.g:2923:1: rule__XVariableDeclaration__Alternatives_2 : ( ( ( rule__XVariableDeclaration__Group_2_0__0 ) ) | ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) ) );
    public final void rule__XVariableDeclaration__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2927:1: ( ( ( rule__XVariableDeclaration__Group_2_0__0 ) ) | ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) ) )
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==RULE_ID) ) {
                int LA32_1 = input.LA(2);

                if ( (synpred71_InternalPureXbase()) ) {
                    alt32=1;
                }
                else if ( (true) ) {
                    alt32=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 32, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA32_0==32||LA32_0==49) ) {
                alt32=1;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;
            }
            switch (alt32) {
                case 1 :
                    // InternalPureXbase.g:2928:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
                    {
                    // InternalPureXbase.g:2928:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
                    // InternalPureXbase.g:2929:3: ( rule__XVariableDeclaration__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0()); 
                    }
                    // InternalPureXbase.g:2930:3: ( rule__XVariableDeclaration__Group_2_0__0 )
                    // InternalPureXbase.g:2930:4: rule__XVariableDeclaration__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2934:2: ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) )
                    {
                    // InternalPureXbase.g:2934:2: ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) )
                    // InternalPureXbase.g:2935:3: ( rule__XVariableDeclaration__NameAssignment_2_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_1()); 
                    }
                    // InternalPureXbase.g:2936:3: ( rule__XVariableDeclaration__NameAssignment_2_1 )
                    // InternalPureXbase.g:2936:4: rule__XVariableDeclaration__NameAssignment_2_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__NameAssignment_2_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Alternatives_2"


    // $ANTLR start "rule__XFeatureCall__Alternatives_3_1"
    // InternalPureXbase.g:2944:1: rule__XFeatureCall__Alternatives_3_1 : ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) | ( ( rule__XFeatureCall__Group_3_1_1__0 ) ) );
    public final void rule__XFeatureCall__Alternatives_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2948:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) | ( ( rule__XFeatureCall__Group_3_1_1__0 ) ) )
            int alt33=2;
            alt33 = dfa33.predict(input);
            switch (alt33) {
                case 1 :
                    // InternalPureXbase.g:2949:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
                    {
                    // InternalPureXbase.g:2949:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
                    // InternalPureXbase.g:2950:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_0()); 
                    }
                    // InternalPureXbase.g:2951:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
                    // InternalPureXbase.g:2951:4: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2955:2: ( ( rule__XFeatureCall__Group_3_1_1__0 ) )
                    {
                    // InternalPureXbase.g:2955:2: ( ( rule__XFeatureCall__Group_3_1_1__0 ) )
                    // InternalPureXbase.g:2956:3: ( rule__XFeatureCall__Group_3_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1()); 
                    }
                    // InternalPureXbase.g:2957:3: ( rule__XFeatureCall__Group_3_1_1__0 )
                    // InternalPureXbase.g:2957:4: rule__XFeatureCall__Group_3_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Group_3_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Alternatives_3_1"


    // $ANTLR start "rule__IdOrSuper__Alternatives"
    // InternalPureXbase.g:2965:1: rule__IdOrSuper__Alternatives : ( ( ruleFeatureCallID ) | ( 'super' ) );
    public final void rule__IdOrSuper__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2969:1: ( ( ruleFeatureCallID ) | ( 'super' ) )
            int alt34=2;
            int LA34_0 = input.LA(1);

            if ( (LA34_0==RULE_ID) ) {
                alt34=1;
            }
            else if ( (LA34_0==45) ) {
                alt34=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 34, 0, input);

                throw nvae;
            }
            switch (alt34) {
                case 1 :
                    // InternalPureXbase.g:2970:2: ( ruleFeatureCallID )
                    {
                    // InternalPureXbase.g:2970:2: ( ruleFeatureCallID )
                    // InternalPureXbase.g:2971:3: ruleFeatureCallID
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getIdOrSuperAccess().getFeatureCallIDParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleFeatureCallID();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getIdOrSuperAccess().getFeatureCallIDParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2976:2: ( 'super' )
                    {
                    // InternalPureXbase.g:2976:2: ( 'super' )
                    // InternalPureXbase.g:2977:3: 'super'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getIdOrSuperAccess().getSuperKeyword_1()); 
                    }
                    match(input,45,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getIdOrSuperAccess().getSuperKeyword_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__IdOrSuper__Alternatives"


    // $ANTLR start "rule__XConstructorCall__Alternatives_4_1"
    // InternalPureXbase.g:2986:1: rule__XConstructorCall__Alternatives_4_1 : ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) | ( ( rule__XConstructorCall__Group_4_1_1__0 ) ) );
    public final void rule__XConstructorCall__Alternatives_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:2990:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) | ( ( rule__XConstructorCall__Group_4_1_1__0 ) ) )
            int alt35=2;
            alt35 = dfa35.predict(input);
            switch (alt35) {
                case 1 :
                    // InternalPureXbase.g:2991:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
                    {
                    // InternalPureXbase.g:2991:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
                    // InternalPureXbase.g:2992:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_0()); 
                    }
                    // InternalPureXbase.g:2993:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
                    // InternalPureXbase.g:2993:4: rule__XConstructorCall__ArgumentsAssignment_4_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__ArgumentsAssignment_4_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:2997:2: ( ( rule__XConstructorCall__Group_4_1_1__0 ) )
                    {
                    // InternalPureXbase.g:2997:2: ( ( rule__XConstructorCall__Group_4_1_1__0 ) )
                    // InternalPureXbase.g:2998:3: ( rule__XConstructorCall__Group_4_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1()); 
                    }
                    // InternalPureXbase.g:2999:3: ( rule__XConstructorCall__Group_4_1_1__0 )
                    // InternalPureXbase.g:2999:4: rule__XConstructorCall__Group_4_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Group_4_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Alternatives_4_1"


    // $ANTLR start "rule__XBooleanLiteral__Alternatives_1"
    // InternalPureXbase.g:3007:1: rule__XBooleanLiteral__Alternatives_1 : ( ( 'false' ) | ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) ) );
    public final void rule__XBooleanLiteral__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3011:1: ( ( 'false' ) | ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) ) )
            int alt36=2;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==46) ) {
                alt36=1;
            }
            else if ( (LA36_0==84) ) {
                alt36=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }
            switch (alt36) {
                case 1 :
                    // InternalPureXbase.g:3012:2: ( 'false' )
                    {
                    // InternalPureXbase.g:3012:2: ( 'false' )
                    // InternalPureXbase.g:3013:3: 'false'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXBooleanLiteralAccess().getFalseKeyword_1_0()); 
                    }
                    match(input,46,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXBooleanLiteralAccess().getFalseKeyword_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3018:2: ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) )
                    {
                    // InternalPureXbase.g:3018:2: ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) )
                    // InternalPureXbase.g:3019:3: ( rule__XBooleanLiteral__IsTrueAssignment_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXBooleanLiteralAccess().getIsTrueAssignment_1_1()); 
                    }
                    // InternalPureXbase.g:3020:3: ( rule__XBooleanLiteral__IsTrueAssignment_1_1 )
                    // InternalPureXbase.g:3020:4: rule__XBooleanLiteral__IsTrueAssignment_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBooleanLiteral__IsTrueAssignment_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXBooleanLiteralAccess().getIsTrueAssignment_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Alternatives_1"


    // $ANTLR start "rule__Number__Alternatives"
    // InternalPureXbase.g:3028:1: rule__Number__Alternatives : ( ( RULE_HEX ) | ( ( rule__Number__Group_1__0 ) ) );
    public final void rule__Number__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3032:1: ( ( RULE_HEX ) | ( ( rule__Number__Group_1__0 ) ) )
            int alt37=2;
            int LA37_0 = input.LA(1);

            if ( (LA37_0==RULE_HEX) ) {
                alt37=1;
            }
            else if ( ((LA37_0>=RULE_INT && LA37_0<=RULE_DECIMAL)) ) {
                alt37=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 37, 0, input);

                throw nvae;
            }
            switch (alt37) {
                case 1 :
                    // InternalPureXbase.g:3033:2: ( RULE_HEX )
                    {
                    // InternalPureXbase.g:3033:2: ( RULE_HEX )
                    // InternalPureXbase.g:3034:3: RULE_HEX
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getHEXTerminalRuleCall_0()); 
                    }
                    match(input,RULE_HEX,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getHEXTerminalRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3039:2: ( ( rule__Number__Group_1__0 ) )
                    {
                    // InternalPureXbase.g:3039:2: ( ( rule__Number__Group_1__0 ) )
                    // InternalPureXbase.g:3040:3: ( rule__Number__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getGroup_1()); 
                    }
                    // InternalPureXbase.g:3041:3: ( rule__Number__Group_1__0 )
                    // InternalPureXbase.g:3041:4: rule__Number__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Number__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Alternatives"


    // $ANTLR start "rule__Number__Alternatives_1_0"
    // InternalPureXbase.g:3049:1: rule__Number__Alternatives_1_0 : ( ( RULE_INT ) | ( RULE_DECIMAL ) );
    public final void rule__Number__Alternatives_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3053:1: ( ( RULE_INT ) | ( RULE_DECIMAL ) )
            int alt38=2;
            int LA38_0 = input.LA(1);

            if ( (LA38_0==RULE_INT) ) {
                alt38=1;
            }
            else if ( (LA38_0==RULE_DECIMAL) ) {
                alt38=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 38, 0, input);

                throw nvae;
            }
            switch (alt38) {
                case 1 :
                    // InternalPureXbase.g:3054:2: ( RULE_INT )
                    {
                    // InternalPureXbase.g:3054:2: ( RULE_INT )
                    // InternalPureXbase.g:3055:3: RULE_INT
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_0_0()); 
                    }
                    match(input,RULE_INT,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_0_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3060:2: ( RULE_DECIMAL )
                    {
                    // InternalPureXbase.g:3060:2: ( RULE_DECIMAL )
                    // InternalPureXbase.g:3061:3: RULE_DECIMAL
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_0_1()); 
                    }
                    match(input,RULE_DECIMAL,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_0_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Alternatives_1_0"


    // $ANTLR start "rule__Number__Alternatives_1_1_1"
    // InternalPureXbase.g:3070:1: rule__Number__Alternatives_1_1_1 : ( ( RULE_INT ) | ( RULE_DECIMAL ) );
    public final void rule__Number__Alternatives_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3074:1: ( ( RULE_INT ) | ( RULE_DECIMAL ) )
            int alt39=2;
            int LA39_0 = input.LA(1);

            if ( (LA39_0==RULE_INT) ) {
                alt39=1;
            }
            else if ( (LA39_0==RULE_DECIMAL) ) {
                alt39=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 39, 0, input);

                throw nvae;
            }
            switch (alt39) {
                case 1 :
                    // InternalPureXbase.g:3075:2: ( RULE_INT )
                    {
                    // InternalPureXbase.g:3075:2: ( RULE_INT )
                    // InternalPureXbase.g:3076:3: RULE_INT
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_1_1_0()); 
                    }
                    match(input,RULE_INT,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_1_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3081:2: ( RULE_DECIMAL )
                    {
                    // InternalPureXbase.g:3081:2: ( RULE_DECIMAL )
                    // InternalPureXbase.g:3082:3: RULE_DECIMAL
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_1_1_1()); 
                    }
                    match(input,RULE_DECIMAL,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_1_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Alternatives_1_1_1"


    // $ANTLR start "rule__JvmTypeReference__Alternatives"
    // InternalPureXbase.g:3091:1: rule__JvmTypeReference__Alternatives : ( ( ( rule__JvmTypeReference__Group_0__0 ) ) | ( ruleXFunctionTypeRef ) );
    public final void rule__JvmTypeReference__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3095:1: ( ( ( rule__JvmTypeReference__Group_0__0 ) ) | ( ruleXFunctionTypeRef ) )
            int alt40=2;
            int LA40_0 = input.LA(1);

            if ( (LA40_0==RULE_ID) ) {
                alt40=1;
            }
            else if ( (LA40_0==32||LA40_0==49) ) {
                alt40=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 40, 0, input);

                throw nvae;
            }
            switch (alt40) {
                case 1 :
                    // InternalPureXbase.g:3096:2: ( ( rule__JvmTypeReference__Group_0__0 ) )
                    {
                    // InternalPureXbase.g:3096:2: ( ( rule__JvmTypeReference__Group_0__0 ) )
                    // InternalPureXbase.g:3097:3: ( rule__JvmTypeReference__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmTypeReferenceAccess().getGroup_0()); 
                    }
                    // InternalPureXbase.g:3098:3: ( rule__JvmTypeReference__Group_0__0 )
                    // InternalPureXbase.g:3098:4: rule__JvmTypeReference__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmTypeReference__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmTypeReferenceAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3102:2: ( ruleXFunctionTypeRef )
                    {
                    // InternalPureXbase.g:3102:2: ( ruleXFunctionTypeRef )
                    // InternalPureXbase.g:3103:3: ruleXFunctionTypeRef
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmTypeReferenceAccess().getXFunctionTypeRefParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXFunctionTypeRef();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmTypeReferenceAccess().getXFunctionTypeRefParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Alternatives"


    // $ANTLR start "rule__JvmArgumentTypeReference__Alternatives"
    // InternalPureXbase.g:3112:1: rule__JvmArgumentTypeReference__Alternatives : ( ( ruleJvmTypeReference ) | ( ruleJvmWildcardTypeReference ) );
    public final void rule__JvmArgumentTypeReference__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3116:1: ( ( ruleJvmTypeReference ) | ( ruleJvmWildcardTypeReference ) )
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==RULE_ID||LA41_0==32||LA41_0==49) ) {
                alt41=1;
            }
            else if ( (LA41_0==76) ) {
                alt41=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 41, 0, input);

                throw nvae;
            }
            switch (alt41) {
                case 1 :
                    // InternalPureXbase.g:3117:2: ( ruleJvmTypeReference )
                    {
                    // InternalPureXbase.g:3117:2: ( ruleJvmTypeReference )
                    // InternalPureXbase.g:3118:3: ruleJvmTypeReference
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmTypeReferenceParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleJvmTypeReference();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmTypeReferenceParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3123:2: ( ruleJvmWildcardTypeReference )
                    {
                    // InternalPureXbase.g:3123:2: ( ruleJvmWildcardTypeReference )
                    // InternalPureXbase.g:3124:3: ruleJvmWildcardTypeReference
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmWildcardTypeReferenceParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleJvmWildcardTypeReference();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmWildcardTypeReferenceParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmArgumentTypeReference__Alternatives"


    // $ANTLR start "rule__JvmWildcardTypeReference__Alternatives_2"
    // InternalPureXbase.g:3133:1: rule__JvmWildcardTypeReference__Alternatives_2 : ( ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) ) | ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) ) );
    public final void rule__JvmWildcardTypeReference__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3137:1: ( ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) ) | ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) ) )
            int alt42=2;
            int LA42_0 = input.LA(1);

            if ( (LA42_0==77) ) {
                alt42=1;
            }
            else if ( (LA42_0==45) ) {
                alt42=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }
            switch (alt42) {
                case 1 :
                    // InternalPureXbase.g:3138:2: ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) )
                    {
                    // InternalPureXbase.g:3138:2: ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) )
                    // InternalPureXbase.g:3139:3: ( rule__JvmWildcardTypeReference__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_0()); 
                    }
                    // InternalPureXbase.g:3140:3: ( rule__JvmWildcardTypeReference__Group_2_0__0 )
                    // InternalPureXbase.g:3140:4: rule__JvmWildcardTypeReference__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmWildcardTypeReference__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3144:2: ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) )
                    {
                    // InternalPureXbase.g:3144:2: ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) )
                    // InternalPureXbase.g:3145:3: ( rule__JvmWildcardTypeReference__Group_2_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_1()); 
                    }
                    // InternalPureXbase.g:3146:3: ( rule__JvmWildcardTypeReference__Group_2_1__0 )
                    // InternalPureXbase.g:3146:4: rule__JvmWildcardTypeReference__Group_2_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmWildcardTypeReference__Group_2_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Alternatives_2"


    // $ANTLR start "rule__XImportDeclaration__Alternatives_1"
    // InternalPureXbase.g:3154:1: rule__XImportDeclaration__Alternatives_1 : ( ( ( rule__XImportDeclaration__Group_1_0__0 ) ) | ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) ) | ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) ) );
    public final void rule__XImportDeclaration__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3158:1: ( ( ( rule__XImportDeclaration__Group_1_0__0 ) ) | ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) ) | ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) ) )
            int alt43=3;
            alt43 = dfa43.predict(input);
            switch (alt43) {
                case 1 :
                    // InternalPureXbase.g:3159:2: ( ( rule__XImportDeclaration__Group_1_0__0 ) )
                    {
                    // InternalPureXbase.g:3159:2: ( ( rule__XImportDeclaration__Group_1_0__0 ) )
                    // InternalPureXbase.g:3160:3: ( rule__XImportDeclaration__Group_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getGroup_1_0()); 
                    }
                    // InternalPureXbase.g:3161:3: ( rule__XImportDeclaration__Group_1_0__0 )
                    // InternalPureXbase.g:3161:4: rule__XImportDeclaration__Group_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__Group_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getGroup_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3165:2: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) )
                    {
                    // InternalPureXbase.g:3165:2: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) )
                    // InternalPureXbase.g:3166:3: ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_1()); 
                    }
                    // InternalPureXbase.g:3167:3: ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 )
                    // InternalPureXbase.g:3167:4: rule__XImportDeclaration__ImportedTypeAssignment_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__ImportedTypeAssignment_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalPureXbase.g:3171:2: ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) )
                    {
                    // InternalPureXbase.g:3171:2: ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) )
                    // InternalPureXbase.g:3172:3: ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceAssignment_1_2()); 
                    }
                    // InternalPureXbase.g:3173:3: ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 )
                    // InternalPureXbase.g:3173:4: rule__XImportDeclaration__ImportedNamespaceAssignment_1_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__ImportedNamespaceAssignment_1_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceAssignment_1_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Alternatives_1"


    // $ANTLR start "rule__XImportDeclaration__Alternatives_1_0_3"
    // InternalPureXbase.g:3181:1: rule__XImportDeclaration__Alternatives_1_0_3 : ( ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) ) | ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) ) );
    public final void rule__XImportDeclaration__Alternatives_1_0_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3185:1: ( ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) ) | ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) ) )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==37) ) {
                alt44=1;
            }
            else if ( (LA44_0==RULE_ID) ) {
                alt44=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;
            }
            switch (alt44) {
                case 1 :
                    // InternalPureXbase.g:3186:2: ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) )
                    {
                    // InternalPureXbase.g:3186:2: ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) )
                    // InternalPureXbase.g:3187:3: ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getWildcardAssignment_1_0_3_0()); 
                    }
                    // InternalPureXbase.g:3188:3: ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 )
                    // InternalPureXbase.g:3188:4: rule__XImportDeclaration__WildcardAssignment_1_0_3_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__WildcardAssignment_1_0_3_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getWildcardAssignment_1_0_3_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalPureXbase.g:3192:2: ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) )
                    {
                    // InternalPureXbase.g:3192:2: ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) )
                    // InternalPureXbase.g:3193:3: ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getMemberNameAssignment_1_0_3_1()); 
                    }
                    // InternalPureXbase.g:3194:3: ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 )
                    // InternalPureXbase.g:3194:4: rule__XImportDeclaration__MemberNameAssignment_1_0_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__MemberNameAssignment_1_0_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getMemberNameAssignment_1_0_3_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Alternatives_1_0_3"


    // $ANTLR start "rule__Model__Group__0"
    // InternalPureXbase.g:3202:1: rule__Model__Group__0 : rule__Model__Group__0__Impl rule__Model__Group__1 ;
    public final void rule__Model__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3206:1: ( rule__Model__Group__0__Impl rule__Model__Group__1 )
            // InternalPureXbase.g:3207:2: rule__Model__Group__0__Impl rule__Model__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__Model__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__Model__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__0"


    // $ANTLR start "rule__Model__Group__0__Impl"
    // InternalPureXbase.g:3214:1: rule__Model__Group__0__Impl : ( ( rule__Model__ImportSectionAssignment_0 )? ) ;
    public final void rule__Model__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3218:1: ( ( ( rule__Model__ImportSectionAssignment_0 )? ) )
            // InternalPureXbase.g:3219:1: ( ( rule__Model__ImportSectionAssignment_0 )? )
            {
            // InternalPureXbase.g:3219:1: ( ( rule__Model__ImportSectionAssignment_0 )? )
            // InternalPureXbase.g:3220:2: ( rule__Model__ImportSectionAssignment_0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getModelAccess().getImportSectionAssignment_0()); 
            }
            // InternalPureXbase.g:3221:2: ( rule__Model__ImportSectionAssignment_0 )?
            int alt45=2;
            int LA45_0 = input.LA(1);

            if ( (LA45_0==79) ) {
                alt45=1;
            }
            switch (alt45) {
                case 1 :
                    // InternalPureXbase.g:3221:3: rule__Model__ImportSectionAssignment_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Model__ImportSectionAssignment_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getModelAccess().getImportSectionAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__0__Impl"


    // $ANTLR start "rule__Model__Group__1"
    // InternalPureXbase.g:3229:1: rule__Model__Group__1 : rule__Model__Group__1__Impl ;
    public final void rule__Model__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3233:1: ( rule__Model__Group__1__Impl )
            // InternalPureXbase.g:3234:2: rule__Model__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Model__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__1"


    // $ANTLR start "rule__Model__Group__1__Impl"
    // InternalPureXbase.g:3240:1: rule__Model__Group__1__Impl : ( ( rule__Model__BlockAssignment_1 ) ) ;
    public final void rule__Model__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3244:1: ( ( ( rule__Model__BlockAssignment_1 ) ) )
            // InternalPureXbase.g:3245:1: ( ( rule__Model__BlockAssignment_1 ) )
            {
            // InternalPureXbase.g:3245:1: ( ( rule__Model__BlockAssignment_1 ) )
            // InternalPureXbase.g:3246:2: ( rule__Model__BlockAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getModelAccess().getBlockAssignment_1()); 
            }
            // InternalPureXbase.g:3247:2: ( rule__Model__BlockAssignment_1 )
            // InternalPureXbase.g:3247:3: rule__Model__BlockAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Model__BlockAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getModelAccess().getBlockAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__Group__1__Impl"


    // $ANTLR start "rule__SpecialBlockExpression__Group__0"
    // InternalPureXbase.g:3256:1: rule__SpecialBlockExpression__Group__0 : rule__SpecialBlockExpression__Group__0__Impl rule__SpecialBlockExpression__Group__1 ;
    public final void rule__SpecialBlockExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3260:1: ( rule__SpecialBlockExpression__Group__0__Impl rule__SpecialBlockExpression__Group__1 )
            // InternalPureXbase.g:3261:2: rule__SpecialBlockExpression__Group__0__Impl rule__SpecialBlockExpression__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__SpecialBlockExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__SpecialBlockExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group__0"


    // $ANTLR start "rule__SpecialBlockExpression__Group__0__Impl"
    // InternalPureXbase.g:3268:1: rule__SpecialBlockExpression__Group__0__Impl : ( () ) ;
    public final void rule__SpecialBlockExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3272:1: ( ( () ) )
            // InternalPureXbase.g:3273:1: ( () )
            {
            // InternalPureXbase.g:3273:1: ( () )
            // InternalPureXbase.g:3274:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionAccess().getXBlockExpressionAction_0()); 
            }
            // InternalPureXbase.g:3275:2: ()
            // InternalPureXbase.g:3275:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionAccess().getXBlockExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group__0__Impl"


    // $ANTLR start "rule__SpecialBlockExpression__Group__1"
    // InternalPureXbase.g:3283:1: rule__SpecialBlockExpression__Group__1 : rule__SpecialBlockExpression__Group__1__Impl ;
    public final void rule__SpecialBlockExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3287:1: ( rule__SpecialBlockExpression__Group__1__Impl )
            // InternalPureXbase.g:3288:2: rule__SpecialBlockExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SpecialBlockExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group__1"


    // $ANTLR start "rule__SpecialBlockExpression__Group__1__Impl"
    // InternalPureXbase.g:3294:1: rule__SpecialBlockExpression__Group__1__Impl : ( ( rule__SpecialBlockExpression__Group_1__0 )* ) ;
    public final void rule__SpecialBlockExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3298:1: ( ( ( rule__SpecialBlockExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:3299:1: ( ( rule__SpecialBlockExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:3299:1: ( ( rule__SpecialBlockExpression__Group_1__0 )* )
            // InternalPureXbase.g:3300:2: ( rule__SpecialBlockExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:3301:2: ( rule__SpecialBlockExpression__Group_1__0 )*
            loop46:
            do {
                int alt46=2;
                int LA46_0 = input.LA(1);

                if ( ((LA46_0>=RULE_ID && LA46_0<=RULE_STRING)||LA46_0==16||LA46_0==28||(LA46_0>=35 && LA46_0<=36)||LA46_0==41||(LA46_0>=45 && LA46_0<=46)||(LA46_0>=48 && LA46_0<=49)||(LA46_0>=56 && LA46_0<=57)||LA46_0==59||LA46_0==61||LA46_0==63||(LA46_0>=66 && LA46_0<=74)||LA46_0==80||LA46_0==84) ) {
                    alt46=1;
                }


                switch (alt46) {
            	case 1 :
            	    // InternalPureXbase.g:3301:3: rule__SpecialBlockExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_6);
            	    rule__SpecialBlockExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop46;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group__1__Impl"


    // $ANTLR start "rule__SpecialBlockExpression__Group_1__0"
    // InternalPureXbase.g:3310:1: rule__SpecialBlockExpression__Group_1__0 : rule__SpecialBlockExpression__Group_1__0__Impl rule__SpecialBlockExpression__Group_1__1 ;
    public final void rule__SpecialBlockExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3314:1: ( rule__SpecialBlockExpression__Group_1__0__Impl rule__SpecialBlockExpression__Group_1__1 )
            // InternalPureXbase.g:3315:2: rule__SpecialBlockExpression__Group_1__0__Impl rule__SpecialBlockExpression__Group_1__1
            {
            pushFollow(FOLLOW_7);
            rule__SpecialBlockExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__SpecialBlockExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group_1__0"


    // $ANTLR start "rule__SpecialBlockExpression__Group_1__0__Impl"
    // InternalPureXbase.g:3322:1: rule__SpecialBlockExpression__Group_1__0__Impl : ( ( rule__SpecialBlockExpression__ExpressionsAssignment_1_0 ) ) ;
    public final void rule__SpecialBlockExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3326:1: ( ( ( rule__SpecialBlockExpression__ExpressionsAssignment_1_0 ) ) )
            // InternalPureXbase.g:3327:1: ( ( rule__SpecialBlockExpression__ExpressionsAssignment_1_0 ) )
            {
            // InternalPureXbase.g:3327:1: ( ( rule__SpecialBlockExpression__ExpressionsAssignment_1_0 ) )
            // InternalPureXbase.g:3328:2: ( rule__SpecialBlockExpression__ExpressionsAssignment_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionAccess().getExpressionsAssignment_1_0()); 
            }
            // InternalPureXbase.g:3329:2: ( rule__SpecialBlockExpression__ExpressionsAssignment_1_0 )
            // InternalPureXbase.g:3329:3: rule__SpecialBlockExpression__ExpressionsAssignment_1_0
            {
            pushFollow(FOLLOW_2);
            rule__SpecialBlockExpression__ExpressionsAssignment_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionAccess().getExpressionsAssignment_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group_1__0__Impl"


    // $ANTLR start "rule__SpecialBlockExpression__Group_1__1"
    // InternalPureXbase.g:3337:1: rule__SpecialBlockExpression__Group_1__1 : rule__SpecialBlockExpression__Group_1__1__Impl ;
    public final void rule__SpecialBlockExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3341:1: ( rule__SpecialBlockExpression__Group_1__1__Impl )
            // InternalPureXbase.g:3342:2: rule__SpecialBlockExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SpecialBlockExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group_1__1"


    // $ANTLR start "rule__SpecialBlockExpression__Group_1__1__Impl"
    // InternalPureXbase.g:3348:1: rule__SpecialBlockExpression__Group_1__1__Impl : ( ( ';' )? ) ;
    public final void rule__SpecialBlockExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3352:1: ( ( ( ';' )? ) )
            // InternalPureXbase.g:3353:1: ( ( ';' )? )
            {
            // InternalPureXbase.g:3353:1: ( ( ';' )? )
            // InternalPureXbase.g:3354:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionAccess().getSemicolonKeyword_1_1()); 
            }
            // InternalPureXbase.g:3355:2: ( ';' )?
            int alt47=2;
            int LA47_0 = input.LA(1);

            if ( (LA47_0==47) ) {
                alt47=1;
            }
            switch (alt47) {
                case 1 :
                    // InternalPureXbase.g:3355:3: ';'
                    {
                    match(input,47,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionAccess().getSemicolonKeyword_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__0"
    // InternalPureXbase.g:3364:1: rule__XTryCatchFinallyExpression__Group__0 : rule__XTryCatchFinallyExpression__Group__0__Impl rule__XTryCatchFinallyExpression__Group__1 ;
    public final void rule__XTryCatchFinallyExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3368:1: ( rule__XTryCatchFinallyExpression__Group__0__Impl rule__XTryCatchFinallyExpression__Group__1 )
            // InternalPureXbase.g:3369:2: rule__XTryCatchFinallyExpression__Group__0__Impl rule__XTryCatchFinallyExpression__Group__1
            {
            pushFollow(FOLLOW_8);
            rule__XTryCatchFinallyExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__0__Impl"
    // InternalPureXbase.g:3376:1: rule__XTryCatchFinallyExpression__Group__0__Impl : ( () ) ;
    public final void rule__XTryCatchFinallyExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3380:1: ( ( () ) )
            // InternalPureXbase.g:3381:1: ( () )
            {
            // InternalPureXbase.g:3381:1: ( () )
            // InternalPureXbase.g:3382:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getXTryCatchFinallyExpressionAction_0()); 
            }
            // InternalPureXbase.g:3383:2: ()
            // InternalPureXbase.g:3383:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getXTryCatchFinallyExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__1"
    // InternalPureXbase.g:3391:1: rule__XTryCatchFinallyExpression__Group__1 : rule__XTryCatchFinallyExpression__Group__1__Impl rule__XTryCatchFinallyExpression__Group__2 ;
    public final void rule__XTryCatchFinallyExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3395:1: ( rule__XTryCatchFinallyExpression__Group__1__Impl rule__XTryCatchFinallyExpression__Group__2 )
            // InternalPureXbase.g:3396:2: rule__XTryCatchFinallyExpression__Group__1__Impl rule__XTryCatchFinallyExpression__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__XTryCatchFinallyExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__1__Impl"
    // InternalPureXbase.g:3403:1: rule__XTryCatchFinallyExpression__Group__1__Impl : ( 'try' ) ;
    public final void rule__XTryCatchFinallyExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3407:1: ( ( 'try' ) )
            // InternalPureXbase.g:3408:1: ( 'try' )
            {
            // InternalPureXbase.g:3408:1: ( 'try' )
            // InternalPureXbase.g:3409:2: 'try'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getTryKeyword_1()); 
            }
            match(input,48,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getTryKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__2"
    // InternalPureXbase.g:3418:1: rule__XTryCatchFinallyExpression__Group__2 : rule__XTryCatchFinallyExpression__Group__2__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3422:1: ( rule__XTryCatchFinallyExpression__Group__2__Impl )
            // InternalPureXbase.g:3423:2: rule__XTryCatchFinallyExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__2"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__2__Impl"
    // InternalPureXbase.g:3429:1: rule__XTryCatchFinallyExpression__Group__2__Impl : ( ( rule__XTryCatchFinallyExpression__Alternatives_2 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3433:1: ( ( ( rule__XTryCatchFinallyExpression__Alternatives_2 ) ) )
            // InternalPureXbase.g:3434:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_2 ) )
            {
            // InternalPureXbase.g:3434:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_2 ) )
            // InternalPureXbase.g:3435:2: ( rule__XTryCatchFinallyExpression__Alternatives_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_2()); 
            }
            // InternalPureXbase.g:3436:2: ( rule__XTryCatchFinallyExpression__Alternatives_2 )
            // InternalPureXbase.g:3436:3: rule__XTryCatchFinallyExpression__Alternatives_2
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Alternatives_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__2__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__0"
    // InternalPureXbase.g:3445:1: rule__XTryCatchFinallyExpression__Group_2_0__0 : rule__XTryCatchFinallyExpression__Group_2_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_0__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3449:1: ( rule__XTryCatchFinallyExpression__Group_2_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_0__1 )
            // InternalPureXbase.g:3450:2: rule__XTryCatchFinallyExpression__Group_2_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_0__1
            {
            pushFollow(FOLLOW_9);
            rule__XTryCatchFinallyExpression__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__0__Impl"
    // InternalPureXbase.g:3457:1: rule__XTryCatchFinallyExpression__Group_2_0__0__Impl : ( '(' ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3461:1: ( ( '(' ) )
            // InternalPureXbase.g:3462:1: ( '(' )
            {
            // InternalPureXbase.g:3462:1: ( '(' )
            // InternalPureXbase.g:3463:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getLeftParenthesisKeyword_2_0_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getLeftParenthesisKeyword_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__1"
    // InternalPureXbase.g:3472:1: rule__XTryCatchFinallyExpression__Group_2_0__1 : rule__XTryCatchFinallyExpression__Group_2_0__1__Impl rule__XTryCatchFinallyExpression__Group_2_0__2 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3476:1: ( rule__XTryCatchFinallyExpression__Group_2_0__1__Impl rule__XTryCatchFinallyExpression__Group_2_0__2 )
            // InternalPureXbase.g:3477:2: rule__XTryCatchFinallyExpression__Group_2_0__1__Impl rule__XTryCatchFinallyExpression__Group_2_0__2
            {
            pushFollow(FOLLOW_10);
            rule__XTryCatchFinallyExpression__Group_2_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__1__Impl"
    // InternalPureXbase.g:3484:1: rule__XTryCatchFinallyExpression__Group_2_0__1__Impl : ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3488:1: ( ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 ) ) )
            // InternalPureXbase.g:3489:1: ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 ) )
            {
            // InternalPureXbase.g:3489:1: ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 ) )
            // InternalPureXbase.g:3490:2: ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesAssignment_2_0_1()); 
            }
            // InternalPureXbase.g:3491:2: ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 )
            // InternalPureXbase.g:3491:3: rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesAssignment_2_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__2"
    // InternalPureXbase.g:3499:1: rule__XTryCatchFinallyExpression__Group_2_0__2 : rule__XTryCatchFinallyExpression__Group_2_0__2__Impl rule__XTryCatchFinallyExpression__Group_2_0__3 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3503:1: ( rule__XTryCatchFinallyExpression__Group_2_0__2__Impl rule__XTryCatchFinallyExpression__Group_2_0__3 )
            // InternalPureXbase.g:3504:2: rule__XTryCatchFinallyExpression__Group_2_0__2__Impl rule__XTryCatchFinallyExpression__Group_2_0__3
            {
            pushFollow(FOLLOW_10);
            rule__XTryCatchFinallyExpression__Group_2_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__2"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__2__Impl"
    // InternalPureXbase.g:3511:1: rule__XTryCatchFinallyExpression__Group_2_0__2__Impl : ( ( rule__XTryCatchFinallyExpression__Group_2_0_2__0 )* ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3515:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_0_2__0 )* ) )
            // InternalPureXbase.g:3516:1: ( ( rule__XTryCatchFinallyExpression__Group_2_0_2__0 )* )
            {
            // InternalPureXbase.g:3516:1: ( ( rule__XTryCatchFinallyExpression__Group_2_0_2__0 )* )
            // InternalPureXbase.g:3517:2: ( rule__XTryCatchFinallyExpression__Group_2_0_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_2()); 
            }
            // InternalPureXbase.g:3518:2: ( rule__XTryCatchFinallyExpression__Group_2_0_2__0 )*
            loop48:
            do {
                int alt48=2;
                int LA48_0 = input.LA(1);

                if ( (LA48_0==47) ) {
                    int LA48_1 = input.LA(2);

                    if ( (LA48_1==16||LA48_1==80) ) {
                        alt48=1;
                    }


                }


                switch (alt48) {
            	case 1 :
            	    // InternalPureXbase.g:3518:3: rule__XTryCatchFinallyExpression__Group_2_0_2__0
            	    {
            	    pushFollow(FOLLOW_11);
            	    rule__XTryCatchFinallyExpression__Group_2_0_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop48;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__2__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__3"
    // InternalPureXbase.g:3526:1: rule__XTryCatchFinallyExpression__Group_2_0__3 : rule__XTryCatchFinallyExpression__Group_2_0__3__Impl rule__XTryCatchFinallyExpression__Group_2_0__4 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3530:1: ( rule__XTryCatchFinallyExpression__Group_2_0__3__Impl rule__XTryCatchFinallyExpression__Group_2_0__4 )
            // InternalPureXbase.g:3531:2: rule__XTryCatchFinallyExpression__Group_2_0__3__Impl rule__XTryCatchFinallyExpression__Group_2_0__4
            {
            pushFollow(FOLLOW_10);
            rule__XTryCatchFinallyExpression__Group_2_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__3"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__3__Impl"
    // InternalPureXbase.g:3538:1: rule__XTryCatchFinallyExpression__Group_2_0__3__Impl : ( ( ';' )? ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3542:1: ( ( ( ';' )? ) )
            // InternalPureXbase.g:3543:1: ( ( ';' )? )
            {
            // InternalPureXbase.g:3543:1: ( ( ';' )? )
            // InternalPureXbase.g:3544:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getSemicolonKeyword_2_0_3()); 
            }
            // InternalPureXbase.g:3545:2: ( ';' )?
            int alt49=2;
            int LA49_0 = input.LA(1);

            if ( (LA49_0==47) ) {
                alt49=1;
            }
            switch (alt49) {
                case 1 :
                    // InternalPureXbase.g:3545:3: ';'
                    {
                    match(input,47,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getSemicolonKeyword_2_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__3__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__4"
    // InternalPureXbase.g:3553:1: rule__XTryCatchFinallyExpression__Group_2_0__4 : rule__XTryCatchFinallyExpression__Group_2_0__4__Impl rule__XTryCatchFinallyExpression__Group_2_0__5 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3557:1: ( rule__XTryCatchFinallyExpression__Group_2_0__4__Impl rule__XTryCatchFinallyExpression__Group_2_0__5 )
            // InternalPureXbase.g:3558:2: rule__XTryCatchFinallyExpression__Group_2_0__4__Impl rule__XTryCatchFinallyExpression__Group_2_0__5
            {
            pushFollow(FOLLOW_5);
            rule__XTryCatchFinallyExpression__Group_2_0__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__4"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__4__Impl"
    // InternalPureXbase.g:3565:1: rule__XTryCatchFinallyExpression__Group_2_0__4__Impl : ( ')' ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3569:1: ( ( ')' ) )
            // InternalPureXbase.g:3570:1: ( ')' )
            {
            // InternalPureXbase.g:3570:1: ( ')' )
            // InternalPureXbase.g:3571:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getRightParenthesisKeyword_2_0_4()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getRightParenthesisKeyword_2_0_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__4__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__5"
    // InternalPureXbase.g:3580:1: rule__XTryCatchFinallyExpression__Group_2_0__5 : rule__XTryCatchFinallyExpression__Group_2_0__5__Impl rule__XTryCatchFinallyExpression__Group_2_0__6 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3584:1: ( rule__XTryCatchFinallyExpression__Group_2_0__5__Impl rule__XTryCatchFinallyExpression__Group_2_0__6 )
            // InternalPureXbase.g:3585:2: rule__XTryCatchFinallyExpression__Group_2_0__5__Impl rule__XTryCatchFinallyExpression__Group_2_0__6
            {
            pushFollow(FOLLOW_12);
            rule__XTryCatchFinallyExpression__Group_2_0__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__5"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__5__Impl"
    // InternalPureXbase.g:3592:1: rule__XTryCatchFinallyExpression__Group_2_0__5__Impl : ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3596:1: ( ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 ) ) )
            // InternalPureXbase.g:3597:1: ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 ) )
            {
            // InternalPureXbase.g:3597:1: ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 ) )
            // InternalPureXbase.g:3598:2: ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionAssignment_2_0_5()); 
            }
            // InternalPureXbase.g:3599:2: ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 )
            // InternalPureXbase.g:3599:3: rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionAssignment_2_0_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__5__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__6"
    // InternalPureXbase.g:3607:1: rule__XTryCatchFinallyExpression__Group_2_0__6 : rule__XTryCatchFinallyExpression__Group_2_0__6__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3611:1: ( rule__XTryCatchFinallyExpression__Group_2_0__6__Impl )
            // InternalPureXbase.g:3612:2: rule__XTryCatchFinallyExpression__Group_2_0__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__6"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0__6__Impl"
    // InternalPureXbase.g:3618:1: rule__XTryCatchFinallyExpression__Group_2_0__6__Impl : ( ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )? ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3622:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )? ) )
            // InternalPureXbase.g:3623:1: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )? )
            {
            // InternalPureXbase.g:3623:1: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )? )
            // InternalPureXbase.g:3624:2: ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6()); 
            }
            // InternalPureXbase.g:3625:2: ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )?
            int alt50=2;
            int LA50_0 = input.LA(1);

            if ( (LA50_0==75) ) {
                int LA50_1 = input.LA(2);

                if ( (synpred90_InternalPureXbase()) ) {
                    alt50=1;
                }
            }
            else if ( (LA50_0==51) ) {
                int LA50_2 = input.LA(2);

                if ( (synpred90_InternalPureXbase()) ) {
                    alt50=1;
                }
            }
            switch (alt50) {
                case 1 :
                    // InternalPureXbase.g:3625:3: rule__XTryCatchFinallyExpression__Group_2_0_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_0_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0__6__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_2__0"
    // InternalPureXbase.g:3634:1: rule__XTryCatchFinallyExpression__Group_2_0_2__0 : rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_2__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3638:1: ( rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_2__1 )
            // InternalPureXbase.g:3639:2: rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_2__1
            {
            pushFollow(FOLLOW_9);
            rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_2__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl"
    // InternalPureXbase.g:3646:1: rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl : ( ';' ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3650:1: ( ( ';' ) )
            // InternalPureXbase.g:3651:1: ( ';' )
            {
            // InternalPureXbase.g:3651:1: ( ';' )
            // InternalPureXbase.g:3652:2: ';'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getSemicolonKeyword_2_0_2_0()); 
            }
            match(input,47,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getSemicolonKeyword_2_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_2__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_2__1"
    // InternalPureXbase.g:3661:1: rule__XTryCatchFinallyExpression__Group_2_0_2__1 : rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3665:1: ( rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl )
            // InternalPureXbase.g:3666:2: rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_2__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl"
    // InternalPureXbase.g:3672:1: rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl : ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3676:1: ( ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 ) ) )
            // InternalPureXbase.g:3677:1: ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 ) )
            {
            // InternalPureXbase.g:3677:1: ( ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 ) )
            // InternalPureXbase.g:3678:2: ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesAssignment_2_0_2_1()); 
            }
            // InternalPureXbase.g:3679:2: ( rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 )
            // InternalPureXbase.g:3679:3: rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesAssignment_2_0_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_2__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6__0"
    // InternalPureXbase.g:3688:1: rule__XTryCatchFinallyExpression__Group_2_0_6__0 : rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3692:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl )
            // InternalPureXbase.g:3693:2: rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl"
    // InternalPureXbase.g:3699:1: rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl : ( ( rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3703:1: ( ( ( rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 ) ) )
            // InternalPureXbase.g:3704:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 ) )
            {
            // InternalPureXbase.g:3704:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 ) )
            // InternalPureXbase.g:3705:2: ( rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_2_0_6_0()); 
            }
            // InternalPureXbase.g:3706:2: ( rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0 )
            // InternalPureXbase.g:3706:3: rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Alternatives_2_0_6_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_2_0_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0"
    // InternalPureXbase.g:3715:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0 : rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3719:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1 )
            // InternalPureXbase.g:3720:2: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1
            {
            pushFollow(FOLLOW_13);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl"
    // InternalPureXbase.g:3727:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl : ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )* ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3731:1: ( ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )* ) ) )
            // InternalPureXbase.g:3732:1: ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )* ) )
            {
            // InternalPureXbase.g:3732:1: ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )* ) )
            // InternalPureXbase.g:3733:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )* )
            {
            // InternalPureXbase.g:3733:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 ) )
            // InternalPureXbase.g:3734:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_0_6_0_0_0()); 
            }
            // InternalPureXbase.g:3735:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )
            // InternalPureXbase.g:3735:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0
            {
            pushFollow(FOLLOW_14);
            rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_0_6_0_0_0()); 
            }

            }

            // InternalPureXbase.g:3738:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )* )
            // InternalPureXbase.g:3739:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_0_6_0_0_0()); 
            }
            // InternalPureXbase.g:3740:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )*
            loop51:
            do {
                int alt51=2;
                int LA51_0 = input.LA(1);

                if ( (LA51_0==75) ) {
                    int LA51_2 = input.LA(2);

                    if ( (synpred91_InternalPureXbase()) ) {
                        alt51=1;
                    }


                }


                switch (alt51) {
            	case 1 :
            	    // InternalPureXbase.g:3740:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0
            	    {
            	    pushFollow(FOLLOW_14);
            	    rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_0_6_0_0_0()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1"
    // InternalPureXbase.g:3749:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1 : rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3753:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl )
            // InternalPureXbase.g:3754:2: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl"
    // InternalPureXbase.g:3760:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl : ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )? ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3764:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )? ) )
            // InternalPureXbase.g:3765:1: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )? )
            {
            // InternalPureXbase.g:3765:1: ( ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )? )
            // InternalPureXbase.g:3766:2: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6_0_0_1()); 
            }
            // InternalPureXbase.g:3767:2: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )?
            int alt52=2;
            int LA52_0 = input.LA(1);

            if ( (LA52_0==51) ) {
                int LA52_1 = input.LA(2);

                if ( (synpred92_InternalPureXbase()) ) {
                    alt52=1;
                }
            }
            switch (alt52) {
                case 1 :
                    // InternalPureXbase.g:3767:3: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_0_6_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0"
    // InternalPureXbase.g:3776:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 : rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3780:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1 )
            // InternalPureXbase.g:3781:2: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl"
    // InternalPureXbase.g:3788:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl : ( ( 'finally' ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3792:1: ( ( ( 'finally' ) ) )
            // InternalPureXbase.g:3793:1: ( ( 'finally' ) )
            {
            // InternalPureXbase.g:3793:1: ( ( 'finally' ) )
            // InternalPureXbase.g:3794:2: ( 'finally' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_0_6_0_0_1_0()); 
            }
            // InternalPureXbase.g:3795:2: ( 'finally' )
            // InternalPureXbase.g:3795:3: 'finally'
            {
            match(input,51,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_0_6_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1"
    // InternalPureXbase.g:3803:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1 : rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3807:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl )
            // InternalPureXbase.g:3808:2: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl"
    // InternalPureXbase.g:3814:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3818:1: ( ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 ) ) )
            // InternalPureXbase.g:3819:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 ) )
            {
            // InternalPureXbase.g:3819:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 ) )
            // InternalPureXbase.g:3820:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_0_6_0_0_1_1()); 
            }
            // InternalPureXbase.g:3821:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 )
            // InternalPureXbase.g:3821:3: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_0_6_0_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0"
    // InternalPureXbase.g:3830:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0 : rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3834:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1 )
            // InternalPureXbase.g:3835:2: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl"
    // InternalPureXbase.g:3842:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl : ( 'finally' ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3846:1: ( ( 'finally' ) )
            // InternalPureXbase.g:3847:1: ( 'finally' )
            {
            // InternalPureXbase.g:3847:1: ( 'finally' )
            // InternalPureXbase.g:3848:2: 'finally'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_0_6_0_1_0()); 
            }
            match(input,51,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_0_6_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1"
    // InternalPureXbase.g:3857:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1 : rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3861:1: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl )
            // InternalPureXbase.g:3862:2: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl"
    // InternalPureXbase.g:3868:1: rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3872:1: ( ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 ) ) )
            // InternalPureXbase.g:3873:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 ) )
            {
            // InternalPureXbase.g:3873:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 ) )
            // InternalPureXbase.g:3874:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_0_6_0_1_1()); 
            }
            // InternalPureXbase.g:3875:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 )
            // InternalPureXbase.g:3875:3: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_0_6_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_0_6_0_1__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1__0"
    // InternalPureXbase.g:3884:1: rule__XTryCatchFinallyExpression__Group_2_1__0 : rule__XTryCatchFinallyExpression__Group_2_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3888:1: ( rule__XTryCatchFinallyExpression__Group_2_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1__1 )
            // InternalPureXbase.g:3889:2: rule__XTryCatchFinallyExpression__Group_2_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1__1
            {
            pushFollow(FOLLOW_12);
            rule__XTryCatchFinallyExpression__Group_2_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1__0__Impl"
    // InternalPureXbase.g:3896:1: rule__XTryCatchFinallyExpression__Group_2_1__0__Impl : ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3900:1: ( ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 ) ) )
            // InternalPureXbase.g:3901:1: ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 ) )
            {
            // InternalPureXbase.g:3901:1: ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 ) )
            // InternalPureXbase.g:3902:2: ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionAssignment_2_1_0()); 
            }
            // InternalPureXbase.g:3903:2: ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 )
            // InternalPureXbase.g:3903:3: rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionAssignment_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1__1"
    // InternalPureXbase.g:3911:1: rule__XTryCatchFinallyExpression__Group_2_1__1 : rule__XTryCatchFinallyExpression__Group_2_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3915:1: ( rule__XTryCatchFinallyExpression__Group_2_1__1__Impl )
            // InternalPureXbase.g:3916:2: rule__XTryCatchFinallyExpression__Group_2_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1__1__Impl"
    // InternalPureXbase.g:3922:1: rule__XTryCatchFinallyExpression__Group_2_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__Alternatives_2_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3926:1: ( ( ( rule__XTryCatchFinallyExpression__Alternatives_2_1_1 ) ) )
            // InternalPureXbase.g:3927:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_2_1_1 ) )
            {
            // InternalPureXbase.g:3927:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_2_1_1 ) )
            // InternalPureXbase.g:3928:2: ( rule__XTryCatchFinallyExpression__Alternatives_2_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_2_1_1()); 
            }
            // InternalPureXbase.g:3929:2: ( rule__XTryCatchFinallyExpression__Alternatives_2_1_1 )
            // InternalPureXbase.g:3929:3: rule__XTryCatchFinallyExpression__Alternatives_2_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Alternatives_2_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_2_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0__0"
    // InternalPureXbase.g:3938:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0__0 : rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_0__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3942:1: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_0__1 )
            // InternalPureXbase.g:3943:2: rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_0__1
            {
            pushFollow(FOLLOW_13);
            rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl"
    // InternalPureXbase.g:3950:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl : ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )* ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3954:1: ( ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )* ) ) )
            // InternalPureXbase.g:3955:1: ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )* ) )
            {
            // InternalPureXbase.g:3955:1: ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )* ) )
            // InternalPureXbase.g:3956:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )* )
            {
            // InternalPureXbase.g:3956:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 ) )
            // InternalPureXbase.g:3957:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_1_1_0_0()); 
            }
            // InternalPureXbase.g:3958:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )
            // InternalPureXbase.g:3958:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0
            {
            pushFollow(FOLLOW_14);
            rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_1_1_0_0()); 
            }

            }

            // InternalPureXbase.g:3961:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )* )
            // InternalPureXbase.g:3962:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_1_1_0_0()); 
            }
            // InternalPureXbase.g:3963:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )*
            loop53:
            do {
                int alt53=2;
                int LA53_0 = input.LA(1);

                if ( (LA53_0==75) ) {
                    int LA53_2 = input.LA(2);

                    if ( (synpred93_InternalPureXbase()) ) {
                        alt53=1;
                    }


                }


                switch (alt53) {
            	case 1 :
            	    // InternalPureXbase.g:3963:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0
            	    {
            	    pushFollow(FOLLOW_14);
            	    rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop53;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_2_1_1_0_0()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0__1"
    // InternalPureXbase.g:3972:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0__1 : rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3976:1: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl )
            // InternalPureXbase.g:3977:2: rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl"
    // InternalPureXbase.g:3983:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl : ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )? ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:3987:1: ( ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )? ) )
            // InternalPureXbase.g:3988:1: ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )? )
            {
            // InternalPureXbase.g:3988:1: ( ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )? )
            // InternalPureXbase.g:3989:2: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1_1_0_1()); 
            }
            // InternalPureXbase.g:3990:2: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )?
            int alt54=2;
            int LA54_0 = input.LA(1);

            if ( (LA54_0==51) ) {
                int LA54_1 = input.LA(2);

                if ( (synpred94_InternalPureXbase()) ) {
                    alt54=1;
                }
            }
            switch (alt54) {
                case 1 :
                    // InternalPureXbase.g:3990:3: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_2_1_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0"
    // InternalPureXbase.g:3999:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 : rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4003:1: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1 )
            // InternalPureXbase.g:4004:2: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl"
    // InternalPureXbase.g:4011:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl : ( ( 'finally' ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4015:1: ( ( ( 'finally' ) ) )
            // InternalPureXbase.g:4016:1: ( ( 'finally' ) )
            {
            // InternalPureXbase.g:4016:1: ( ( 'finally' ) )
            // InternalPureXbase.g:4017:2: ( 'finally' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_1_1_0_1_0()); 
            }
            // InternalPureXbase.g:4018:2: ( 'finally' )
            // InternalPureXbase.g:4018:3: 'finally'
            {
            match(input,51,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_1_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1"
    // InternalPureXbase.g:4026:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1 : rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4030:1: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl )
            // InternalPureXbase.g:4031:2: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl"
    // InternalPureXbase.g:4037:1: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4041:1: ( ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 ) ) )
            // InternalPureXbase.g:4042:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 ) )
            {
            // InternalPureXbase.g:4042:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 ) )
            // InternalPureXbase.g:4043:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_1_1_0_1_1()); 
            }
            // InternalPureXbase.g:4044:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 )
            // InternalPureXbase.g:4044:3: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_1_1_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_1__0"
    // InternalPureXbase.g:4053:1: rule__XTryCatchFinallyExpression__Group_2_1_1_1__0 : rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4057:1: ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_1__1 )
            // InternalPureXbase.g:4058:2: rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl rule__XTryCatchFinallyExpression__Group_2_1_1_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl"
    // InternalPureXbase.g:4065:1: rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl : ( 'finally' ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4069:1: ( ( 'finally' ) )
            // InternalPureXbase.g:4070:1: ( 'finally' )
            {
            // InternalPureXbase.g:4070:1: ( 'finally' )
            // InternalPureXbase.g:4071:2: 'finally'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_1_1_1_0()); 
            }
            match(input,51,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_2_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_1__1"
    // InternalPureXbase.g:4080:1: rule__XTryCatchFinallyExpression__Group_2_1_1_1__1 : rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4084:1: ( rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl )
            // InternalPureXbase.g:4085:2: rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl"
    // InternalPureXbase.g:4091:1: rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4095:1: ( ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 ) ) )
            // InternalPureXbase.g:4096:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 ) )
            {
            // InternalPureXbase.g:4096:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 ) )
            // InternalPureXbase.g:4097:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_1_1_1_1()); 
            }
            // InternalPureXbase.g:4098:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 )
            // InternalPureXbase.g:4098:3: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_2_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_2_1_1_1__1__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__0"
    // InternalPureXbase.g:4107:1: rule__InitialisedVariableDeclaration__Group__0 : rule__InitialisedVariableDeclaration__Group__0__Impl rule__InitialisedVariableDeclaration__Group__1 ;
    public final void rule__InitialisedVariableDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4111:1: ( rule__InitialisedVariableDeclaration__Group__0__Impl rule__InitialisedVariableDeclaration__Group__1 )
            // InternalPureXbase.g:4112:2: rule__InitialisedVariableDeclaration__Group__0__Impl rule__InitialisedVariableDeclaration__Group__1
            {
            pushFollow(FOLLOW_9);
            rule__InitialisedVariableDeclaration__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__0"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__0__Impl"
    // InternalPureXbase.g:4119:1: rule__InitialisedVariableDeclaration__Group__0__Impl : ( () ) ;
    public final void rule__InitialisedVariableDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4123:1: ( ( () ) )
            // InternalPureXbase.g:4124:1: ( () )
            {
            // InternalPureXbase.g:4124:1: ( () )
            // InternalPureXbase.g:4125:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getXVariableDeclarationAction_0()); 
            }
            // InternalPureXbase.g:4126:2: ()
            // InternalPureXbase.g:4126:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getXVariableDeclarationAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__0__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__1"
    // InternalPureXbase.g:4134:1: rule__InitialisedVariableDeclaration__Group__1 : rule__InitialisedVariableDeclaration__Group__1__Impl rule__InitialisedVariableDeclaration__Group__2 ;
    public final void rule__InitialisedVariableDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4138:1: ( rule__InitialisedVariableDeclaration__Group__1__Impl rule__InitialisedVariableDeclaration__Group__2 )
            // InternalPureXbase.g:4139:2: rule__InitialisedVariableDeclaration__Group__1__Impl rule__InitialisedVariableDeclaration__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__InitialisedVariableDeclaration__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__1__Impl"
    // InternalPureXbase.g:4146:1: rule__InitialisedVariableDeclaration__Group__1__Impl : ( ( rule__InitialisedVariableDeclaration__Alternatives_1 ) ) ;
    public final void rule__InitialisedVariableDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4150:1: ( ( ( rule__InitialisedVariableDeclaration__Alternatives_1 ) ) )
            // InternalPureXbase.g:4151:1: ( ( rule__InitialisedVariableDeclaration__Alternatives_1 ) )
            {
            // InternalPureXbase.g:4151:1: ( ( rule__InitialisedVariableDeclaration__Alternatives_1 ) )
            // InternalPureXbase.g:4152:2: ( rule__InitialisedVariableDeclaration__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getAlternatives_1()); 
            }
            // InternalPureXbase.g:4153:2: ( rule__InitialisedVariableDeclaration__Alternatives_1 )
            // InternalPureXbase.g:4153:3: rule__InitialisedVariableDeclaration__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__1__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__2"
    // InternalPureXbase.g:4161:1: rule__InitialisedVariableDeclaration__Group__2 : rule__InitialisedVariableDeclaration__Group__2__Impl rule__InitialisedVariableDeclaration__Group__3 ;
    public final void rule__InitialisedVariableDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4165:1: ( rule__InitialisedVariableDeclaration__Group__2__Impl rule__InitialisedVariableDeclaration__Group__3 )
            // InternalPureXbase.g:4166:2: rule__InitialisedVariableDeclaration__Group__2__Impl rule__InitialisedVariableDeclaration__Group__3
            {
            pushFollow(FOLLOW_16);
            rule__InitialisedVariableDeclaration__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__2"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__2__Impl"
    // InternalPureXbase.g:4173:1: rule__InitialisedVariableDeclaration__Group__2__Impl : ( ( rule__InitialisedVariableDeclaration__Alternatives_2 ) ) ;
    public final void rule__InitialisedVariableDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4177:1: ( ( ( rule__InitialisedVariableDeclaration__Alternatives_2 ) ) )
            // InternalPureXbase.g:4178:1: ( ( rule__InitialisedVariableDeclaration__Alternatives_2 ) )
            {
            // InternalPureXbase.g:4178:1: ( ( rule__InitialisedVariableDeclaration__Alternatives_2 ) )
            // InternalPureXbase.g:4179:2: ( rule__InitialisedVariableDeclaration__Alternatives_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getAlternatives_2()); 
            }
            // InternalPureXbase.g:4180:2: ( rule__InitialisedVariableDeclaration__Alternatives_2 )
            // InternalPureXbase.g:4180:3: rule__InitialisedVariableDeclaration__Alternatives_2
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Alternatives_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__2__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__3"
    // InternalPureXbase.g:4188:1: rule__InitialisedVariableDeclaration__Group__3 : rule__InitialisedVariableDeclaration__Group__3__Impl rule__InitialisedVariableDeclaration__Group__4 ;
    public final void rule__InitialisedVariableDeclaration__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4192:1: ( rule__InitialisedVariableDeclaration__Group__3__Impl rule__InitialisedVariableDeclaration__Group__4 )
            // InternalPureXbase.g:4193:2: rule__InitialisedVariableDeclaration__Group__3__Impl rule__InitialisedVariableDeclaration__Group__4
            {
            pushFollow(FOLLOW_5);
            rule__InitialisedVariableDeclaration__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__3"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__3__Impl"
    // InternalPureXbase.g:4200:1: rule__InitialisedVariableDeclaration__Group__3__Impl : ( '=' ) ;
    public final void rule__InitialisedVariableDeclaration__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4204:1: ( ( '=' ) )
            // InternalPureXbase.g:4205:1: ( '=' )
            {
            // InternalPureXbase.g:4205:1: ( '=' )
            // InternalPureXbase.g:4206:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getEqualsSignKeyword_3()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getEqualsSignKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__3__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__4"
    // InternalPureXbase.g:4215:1: rule__InitialisedVariableDeclaration__Group__4 : rule__InitialisedVariableDeclaration__Group__4__Impl ;
    public final void rule__InitialisedVariableDeclaration__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4219:1: ( rule__InitialisedVariableDeclaration__Group__4__Impl )
            // InternalPureXbase.g:4220:2: rule__InitialisedVariableDeclaration__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__4"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group__4__Impl"
    // InternalPureXbase.g:4226:1: rule__InitialisedVariableDeclaration__Group__4__Impl : ( ( rule__InitialisedVariableDeclaration__RightAssignment_4 ) ) ;
    public final void rule__InitialisedVariableDeclaration__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4230:1: ( ( ( rule__InitialisedVariableDeclaration__RightAssignment_4 ) ) )
            // InternalPureXbase.g:4231:1: ( ( rule__InitialisedVariableDeclaration__RightAssignment_4 ) )
            {
            // InternalPureXbase.g:4231:1: ( ( rule__InitialisedVariableDeclaration__RightAssignment_4 ) )
            // InternalPureXbase.g:4232:2: ( rule__InitialisedVariableDeclaration__RightAssignment_4 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getRightAssignment_4()); 
            }
            // InternalPureXbase.g:4233:2: ( rule__InitialisedVariableDeclaration__RightAssignment_4 )
            // InternalPureXbase.g:4233:3: rule__InitialisedVariableDeclaration__RightAssignment_4
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__RightAssignment_4();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getRightAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group__4__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group_2_0__0"
    // InternalPureXbase.g:4242:1: rule__InitialisedVariableDeclaration__Group_2_0__0 : rule__InitialisedVariableDeclaration__Group_2_0__0__Impl ;
    public final void rule__InitialisedVariableDeclaration__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4246:1: ( rule__InitialisedVariableDeclaration__Group_2_0__0__Impl )
            // InternalPureXbase.g:4247:2: rule__InitialisedVariableDeclaration__Group_2_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group_2_0__0"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group_2_0__0__Impl"
    // InternalPureXbase.g:4253:1: rule__InitialisedVariableDeclaration__Group_2_0__0__Impl : ( ( rule__InitialisedVariableDeclaration__Group_2_0_0__0 ) ) ;
    public final void rule__InitialisedVariableDeclaration__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4257:1: ( ( ( rule__InitialisedVariableDeclaration__Group_2_0_0__0 ) ) )
            // InternalPureXbase.g:4258:1: ( ( rule__InitialisedVariableDeclaration__Group_2_0_0__0 ) )
            {
            // InternalPureXbase.g:4258:1: ( ( rule__InitialisedVariableDeclaration__Group_2_0_0__0 ) )
            // InternalPureXbase.g:4259:2: ( rule__InitialisedVariableDeclaration__Group_2_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getGroup_2_0_0()); 
            }
            // InternalPureXbase.g:4260:2: ( rule__InitialisedVariableDeclaration__Group_2_0_0__0 )
            // InternalPureXbase.g:4260:3: rule__InitialisedVariableDeclaration__Group_2_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group_2_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getGroup_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group_2_0__0__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group_2_0_0__0"
    // InternalPureXbase.g:4269:1: rule__InitialisedVariableDeclaration__Group_2_0_0__0 : rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl rule__InitialisedVariableDeclaration__Group_2_0_0__1 ;
    public final void rule__InitialisedVariableDeclaration__Group_2_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4273:1: ( rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl rule__InitialisedVariableDeclaration__Group_2_0_0__1 )
            // InternalPureXbase.g:4274:2: rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl rule__InitialisedVariableDeclaration__Group_2_0_0__1
            {
            pushFollow(FOLLOW_17);
            rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group_2_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group_2_0_0__0"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl"
    // InternalPureXbase.g:4281:1: rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl : ( ( rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 ) ) ;
    public final void rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4285:1: ( ( ( rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 ) ) )
            // InternalPureXbase.g:4286:1: ( ( rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 ) )
            {
            // InternalPureXbase.g:4286:1: ( ( rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 ) )
            // InternalPureXbase.g:4287:2: ( rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getTypeAssignment_2_0_0_0()); 
            }
            // InternalPureXbase.g:4288:2: ( rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 )
            // InternalPureXbase.g:4288:3: rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getTypeAssignment_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group_2_0_0__0__Impl"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group_2_0_0__1"
    // InternalPureXbase.g:4296:1: rule__InitialisedVariableDeclaration__Group_2_0_0__1 : rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl ;
    public final void rule__InitialisedVariableDeclaration__Group_2_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4300:1: ( rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl )
            // InternalPureXbase.g:4301:2: rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group_2_0_0__1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl"
    // InternalPureXbase.g:4307:1: rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl : ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 ) ) ;
    public final void rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4311:1: ( ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 ) ) )
            // InternalPureXbase.g:4312:1: ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 ) )
            {
            // InternalPureXbase.g:4312:1: ( ( rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 ) )
            // InternalPureXbase.g:4313:2: ( rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getNameAssignment_2_0_0_1()); 
            }
            // InternalPureXbase.g:4314:2: ( rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 )
            // InternalPureXbase.g:4314:3: rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getNameAssignment_2_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__Group_2_0_0__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__0"
    // InternalPureXbase.g:4323:1: rule__XAssignment__Group_0__0 : rule__XAssignment__Group_0__0__Impl rule__XAssignment__Group_0__1 ;
    public final void rule__XAssignment__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4327:1: ( rule__XAssignment__Group_0__0__Impl rule__XAssignment__Group_0__1 )
            // InternalPureXbase.g:4328:2: rule__XAssignment__Group_0__0__Impl rule__XAssignment__Group_0__1
            {
            pushFollow(FOLLOW_17);
            rule__XAssignment__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__0"


    // $ANTLR start "rule__XAssignment__Group_0__0__Impl"
    // InternalPureXbase.g:4335:1: rule__XAssignment__Group_0__0__Impl : ( () ) ;
    public final void rule__XAssignment__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4339:1: ( ( () ) )
            // InternalPureXbase.g:4340:1: ( () )
            {
            // InternalPureXbase.g:4340:1: ( () )
            // InternalPureXbase.g:4341:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getXAssignmentAction_0_0()); 
            }
            // InternalPureXbase.g:4342:2: ()
            // InternalPureXbase.g:4342:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getXAssignmentAction_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__1"
    // InternalPureXbase.g:4350:1: rule__XAssignment__Group_0__1 : rule__XAssignment__Group_0__1__Impl rule__XAssignment__Group_0__2 ;
    public final void rule__XAssignment__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4354:1: ( rule__XAssignment__Group_0__1__Impl rule__XAssignment__Group_0__2 )
            // InternalPureXbase.g:4355:2: rule__XAssignment__Group_0__1__Impl rule__XAssignment__Group_0__2
            {
            pushFollow(FOLLOW_16);
            rule__XAssignment__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__1"


    // $ANTLR start "rule__XAssignment__Group_0__1__Impl"
    // InternalPureXbase.g:4362:1: rule__XAssignment__Group_0__1__Impl : ( ( rule__XAssignment__FeatureAssignment_0_1 ) ) ;
    public final void rule__XAssignment__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4366:1: ( ( ( rule__XAssignment__FeatureAssignment_0_1 ) ) )
            // InternalPureXbase.g:4367:1: ( ( rule__XAssignment__FeatureAssignment_0_1 ) )
            {
            // InternalPureXbase.g:4367:1: ( ( rule__XAssignment__FeatureAssignment_0_1 ) )
            // InternalPureXbase.g:4368:2: ( rule__XAssignment__FeatureAssignment_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureAssignment_0_1()); 
            }
            // InternalPureXbase.g:4369:2: ( rule__XAssignment__FeatureAssignment_0_1 )
            // InternalPureXbase.g:4369:3: rule__XAssignment__FeatureAssignment_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__FeatureAssignment_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureAssignment_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__2"
    // InternalPureXbase.g:4377:1: rule__XAssignment__Group_0__2 : rule__XAssignment__Group_0__2__Impl rule__XAssignment__Group_0__3 ;
    public final void rule__XAssignment__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4381:1: ( rule__XAssignment__Group_0__2__Impl rule__XAssignment__Group_0__3 )
            // InternalPureXbase.g:4382:2: rule__XAssignment__Group_0__2__Impl rule__XAssignment__Group_0__3
            {
            pushFollow(FOLLOW_5);
            rule__XAssignment__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__2"


    // $ANTLR start "rule__XAssignment__Group_0__2__Impl"
    // InternalPureXbase.g:4389:1: rule__XAssignment__Group_0__2__Impl : ( ruleOpSingleAssign ) ;
    public final void rule__XAssignment__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4393:1: ( ( ruleOpSingleAssign ) )
            // InternalPureXbase.g:4394:1: ( ruleOpSingleAssign )
            {
            // InternalPureXbase.g:4394:1: ( ruleOpSingleAssign )
            // InternalPureXbase.g:4395:2: ruleOpSingleAssign
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getOpSingleAssignParserRuleCall_0_2()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getOpSingleAssignParserRuleCall_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__2__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__3"
    // InternalPureXbase.g:4404:1: rule__XAssignment__Group_0__3 : rule__XAssignment__Group_0__3__Impl ;
    public final void rule__XAssignment__Group_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4408:1: ( rule__XAssignment__Group_0__3__Impl )
            // InternalPureXbase.g:4409:2: rule__XAssignment__Group_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__3"


    // $ANTLR start "rule__XAssignment__Group_0__3__Impl"
    // InternalPureXbase.g:4415:1: rule__XAssignment__Group_0__3__Impl : ( ( rule__XAssignment__ValueAssignment_0_3 ) ) ;
    public final void rule__XAssignment__Group_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4419:1: ( ( ( rule__XAssignment__ValueAssignment_0_3 ) ) )
            // InternalPureXbase.g:4420:1: ( ( rule__XAssignment__ValueAssignment_0_3 ) )
            {
            // InternalPureXbase.g:4420:1: ( ( rule__XAssignment__ValueAssignment_0_3 ) )
            // InternalPureXbase.g:4421:2: ( rule__XAssignment__ValueAssignment_0_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getValueAssignment_0_3()); 
            }
            // InternalPureXbase.g:4422:2: ( rule__XAssignment__ValueAssignment_0_3 )
            // InternalPureXbase.g:4422:3: rule__XAssignment__ValueAssignment_0_3
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__ValueAssignment_0_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getValueAssignment_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__3__Impl"


    // $ANTLR start "rule__XAssignment__Group_1__0"
    // InternalPureXbase.g:4431:1: rule__XAssignment__Group_1__0 : rule__XAssignment__Group_1__0__Impl rule__XAssignment__Group_1__1 ;
    public final void rule__XAssignment__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4435:1: ( rule__XAssignment__Group_1__0__Impl rule__XAssignment__Group_1__1 )
            // InternalPureXbase.g:4436:2: rule__XAssignment__Group_1__0__Impl rule__XAssignment__Group_1__1
            {
            pushFollow(FOLLOW_18);
            rule__XAssignment__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__0"


    // $ANTLR start "rule__XAssignment__Group_1__0__Impl"
    // InternalPureXbase.g:4443:1: rule__XAssignment__Group_1__0__Impl : ( ruleXConditionalExpression ) ;
    public final void rule__XAssignment__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4447:1: ( ( ruleXConditionalExpression ) )
            // InternalPureXbase.g:4448:1: ( ruleXConditionalExpression )
            {
            // InternalPureXbase.g:4448:1: ( ruleXConditionalExpression )
            // InternalPureXbase.g:4449:2: ruleXConditionalExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getXConditionalExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXConditionalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getXConditionalExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1__1"
    // InternalPureXbase.g:4458:1: rule__XAssignment__Group_1__1 : rule__XAssignment__Group_1__1__Impl ;
    public final void rule__XAssignment__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4462:1: ( rule__XAssignment__Group_1__1__Impl )
            // InternalPureXbase.g:4463:2: rule__XAssignment__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__1"


    // $ANTLR start "rule__XAssignment__Group_1__1__Impl"
    // InternalPureXbase.g:4469:1: rule__XAssignment__Group_1__1__Impl : ( ( rule__XAssignment__Group_1_1__0 )? ) ;
    public final void rule__XAssignment__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4473:1: ( ( ( rule__XAssignment__Group_1_1__0 )? ) )
            // InternalPureXbase.g:4474:1: ( ( rule__XAssignment__Group_1_1__0 )? )
            {
            // InternalPureXbase.g:4474:1: ( ( rule__XAssignment__Group_1_1__0 )? )
            // InternalPureXbase.g:4475:2: ( rule__XAssignment__Group_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getGroup_1_1()); 
            }
            // InternalPureXbase.g:4476:2: ( rule__XAssignment__Group_1_1__0 )?
            int alt55=2;
            alt55 = dfa55.predict(input);
            switch (alt55) {
                case 1 :
                    // InternalPureXbase.g:4476:3: rule__XAssignment__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAssignment__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getGroup_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1__0"
    // InternalPureXbase.g:4485:1: rule__XAssignment__Group_1_1__0 : rule__XAssignment__Group_1_1__0__Impl rule__XAssignment__Group_1_1__1 ;
    public final void rule__XAssignment__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4489:1: ( rule__XAssignment__Group_1_1__0__Impl rule__XAssignment__Group_1_1__1 )
            // InternalPureXbase.g:4490:2: rule__XAssignment__Group_1_1__0__Impl rule__XAssignment__Group_1_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XAssignment__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__0"


    // $ANTLR start "rule__XAssignment__Group_1_1__0__Impl"
    // InternalPureXbase.g:4497:1: rule__XAssignment__Group_1_1__0__Impl : ( ( rule__XAssignment__Group_1_1_0__0 ) ) ;
    public final void rule__XAssignment__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4501:1: ( ( ( rule__XAssignment__Group_1_1_0__0 ) ) )
            // InternalPureXbase.g:4502:1: ( ( rule__XAssignment__Group_1_1_0__0 ) )
            {
            // InternalPureXbase.g:4502:1: ( ( rule__XAssignment__Group_1_1_0__0 ) )
            // InternalPureXbase.g:4503:2: ( rule__XAssignment__Group_1_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getGroup_1_1_0()); 
            }
            // InternalPureXbase.g:4504:2: ( rule__XAssignment__Group_1_1_0__0 )
            // InternalPureXbase.g:4504:3: rule__XAssignment__Group_1_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getGroup_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1__1"
    // InternalPureXbase.g:4512:1: rule__XAssignment__Group_1_1__1 : rule__XAssignment__Group_1_1__1__Impl ;
    public final void rule__XAssignment__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4516:1: ( rule__XAssignment__Group_1_1__1__Impl )
            // InternalPureXbase.g:4517:2: rule__XAssignment__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__1"


    // $ANTLR start "rule__XAssignment__Group_1_1__1__Impl"
    // InternalPureXbase.g:4523:1: rule__XAssignment__Group_1_1__1__Impl : ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) ) ;
    public final void rule__XAssignment__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4527:1: ( ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) ) )
            // InternalPureXbase.g:4528:1: ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) )
            {
            // InternalPureXbase.g:4528:1: ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) )
            // InternalPureXbase.g:4529:2: ( rule__XAssignment__RightOperandAssignment_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getRightOperandAssignment_1_1_1()); 
            }
            // InternalPureXbase.g:4530:2: ( rule__XAssignment__RightOperandAssignment_1_1_1 )
            // InternalPureXbase.g:4530:3: rule__XAssignment__RightOperandAssignment_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__RightOperandAssignment_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getRightOperandAssignment_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1_0__0"
    // InternalPureXbase.g:4539:1: rule__XAssignment__Group_1_1_0__0 : rule__XAssignment__Group_1_1_0__0__Impl ;
    public final void rule__XAssignment__Group_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4543:1: ( rule__XAssignment__Group_1_1_0__0__Impl )
            // InternalPureXbase.g:4544:2: rule__XAssignment__Group_1_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0__0"


    // $ANTLR start "rule__XAssignment__Group_1_1_0__0__Impl"
    // InternalPureXbase.g:4550:1: rule__XAssignment__Group_1_1_0__0__Impl : ( ( rule__XAssignment__Group_1_1_0_0__0 ) ) ;
    public final void rule__XAssignment__Group_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4554:1: ( ( ( rule__XAssignment__Group_1_1_0_0__0 ) ) )
            // InternalPureXbase.g:4555:1: ( ( rule__XAssignment__Group_1_1_0_0__0 ) )
            {
            // InternalPureXbase.g:4555:1: ( ( rule__XAssignment__Group_1_1_0_0__0 ) )
            // InternalPureXbase.g:4556:2: ( rule__XAssignment__Group_1_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getGroup_1_1_0_0()); 
            }
            // InternalPureXbase.g:4557:2: ( rule__XAssignment__Group_1_1_0_0__0 )
            // InternalPureXbase.g:4557:3: rule__XAssignment__Group_1_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getGroup_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__0"
    // InternalPureXbase.g:4566:1: rule__XAssignment__Group_1_1_0_0__0 : rule__XAssignment__Group_1_1_0_0__0__Impl rule__XAssignment__Group_1_1_0_0__1 ;
    public final void rule__XAssignment__Group_1_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4570:1: ( rule__XAssignment__Group_1_1_0_0__0__Impl rule__XAssignment__Group_1_1_0_0__1 )
            // InternalPureXbase.g:4571:2: rule__XAssignment__Group_1_1_0_0__0__Impl rule__XAssignment__Group_1_1_0_0__1
            {
            pushFollow(FOLLOW_18);
            rule__XAssignment__Group_1_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__0"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__0__Impl"
    // InternalPureXbase.g:4578:1: rule__XAssignment__Group_1_1_0_0__0__Impl : ( () ) ;
    public final void rule__XAssignment__Group_1_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4582:1: ( ( () ) )
            // InternalPureXbase.g:4583:1: ( () )
            {
            // InternalPureXbase.g:4583:1: ( () )
            // InternalPureXbase.g:4584:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }
            // InternalPureXbase.g:4585:2: ()
            // InternalPureXbase.g:4585:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__1"
    // InternalPureXbase.g:4593:1: rule__XAssignment__Group_1_1_0_0__1 : rule__XAssignment__Group_1_1_0_0__1__Impl ;
    public final void rule__XAssignment__Group_1_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4597:1: ( rule__XAssignment__Group_1_1_0_0__1__Impl )
            // InternalPureXbase.g:4598:2: rule__XAssignment__Group_1_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__1"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__1__Impl"
    // InternalPureXbase.g:4604:1: rule__XAssignment__Group_1_1_0_0__1__Impl : ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) ) ;
    public final void rule__XAssignment__Group_1_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4608:1: ( ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) ) )
            // InternalPureXbase.g:4609:1: ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) )
            {
            // InternalPureXbase.g:4609:1: ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) )
            // InternalPureXbase.g:4610:2: ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureAssignment_1_1_0_0_1()); 
            }
            // InternalPureXbase.g:4611:2: ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 )
            // InternalPureXbase.g:4611:3: rule__XAssignment__FeatureAssignment_1_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__FeatureAssignment_1_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureAssignment_1_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__1__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group__0"
    // InternalPureXbase.g:4620:1: rule__XConditionalExpression__Group__0 : rule__XConditionalExpression__Group__0__Impl rule__XConditionalExpression__Group__1 ;
    public final void rule__XConditionalExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4624:1: ( rule__XConditionalExpression__Group__0__Impl rule__XConditionalExpression__Group__1 )
            // InternalPureXbase.g:4625:2: rule__XConditionalExpression__Group__0__Impl rule__XConditionalExpression__Group__1
            {
            pushFollow(FOLLOW_19);
            rule__XConditionalExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group__0"


    // $ANTLR start "rule__XConditionalExpression__Group__0__Impl"
    // InternalPureXbase.g:4632:1: rule__XConditionalExpression__Group__0__Impl : ( ruleXOrExpression ) ;
    public final void rule__XConditionalExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4636:1: ( ( ruleXOrExpression ) )
            // InternalPureXbase.g:4637:1: ( ruleXOrExpression )
            {
            // InternalPureXbase.g:4637:1: ( ruleXOrExpression )
            // InternalPureXbase.g:4638:2: ruleXOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getXOrExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getXOrExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group__0__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group__1"
    // InternalPureXbase.g:4647:1: rule__XConditionalExpression__Group__1 : rule__XConditionalExpression__Group__1__Impl ;
    public final void rule__XConditionalExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4651:1: ( rule__XConditionalExpression__Group__1__Impl )
            // InternalPureXbase.g:4652:2: rule__XConditionalExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group__1"


    // $ANTLR start "rule__XConditionalExpression__Group__1__Impl"
    // InternalPureXbase.g:4658:1: rule__XConditionalExpression__Group__1__Impl : ( ( rule__XConditionalExpression__Group_1__0 )? ) ;
    public final void rule__XConditionalExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4662:1: ( ( ( rule__XConditionalExpression__Group_1__0 )? ) )
            // InternalPureXbase.g:4663:1: ( ( rule__XConditionalExpression__Group_1__0 )? )
            {
            // InternalPureXbase.g:4663:1: ( ( rule__XConditionalExpression__Group_1__0 )? )
            // InternalPureXbase.g:4664:2: ( rule__XConditionalExpression__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:4665:2: ( rule__XConditionalExpression__Group_1__0 )?
            int alt56=2;
            int LA56_0 = input.LA(1);

            if ( (LA56_0==76) ) {
                int LA56_1 = input.LA(2);

                if ( (synpred96_InternalPureXbase()) ) {
                    alt56=1;
                }
            }
            switch (alt56) {
                case 1 :
                    // InternalPureXbase.g:4665:3: rule__XConditionalExpression__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConditionalExpression__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group__1__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1__0"
    // InternalPureXbase.g:4674:1: rule__XConditionalExpression__Group_1__0 : rule__XConditionalExpression__Group_1__0__Impl rule__XConditionalExpression__Group_1__1 ;
    public final void rule__XConditionalExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4678:1: ( rule__XConditionalExpression__Group_1__0__Impl rule__XConditionalExpression__Group_1__1 )
            // InternalPureXbase.g:4679:2: rule__XConditionalExpression__Group_1__0__Impl rule__XConditionalExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XConditionalExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1__0"


    // $ANTLR start "rule__XConditionalExpression__Group_1__0__Impl"
    // InternalPureXbase.g:4686:1: rule__XConditionalExpression__Group_1__0__Impl : ( ( rule__XConditionalExpression__Group_1_0__0 ) ) ;
    public final void rule__XConditionalExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4690:1: ( ( ( rule__XConditionalExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:4691:1: ( ( rule__XConditionalExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:4691:1: ( ( rule__XConditionalExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:4692:2: ( rule__XConditionalExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:4693:2: ( rule__XConditionalExpression__Group_1_0__0 )
            // InternalPureXbase.g:4693:3: rule__XConditionalExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1__1"
    // InternalPureXbase.g:4701:1: rule__XConditionalExpression__Group_1__1 : rule__XConditionalExpression__Group_1__1__Impl rule__XConditionalExpression__Group_1__2 ;
    public final void rule__XConditionalExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4705:1: ( rule__XConditionalExpression__Group_1__1__Impl rule__XConditionalExpression__Group_1__2 )
            // InternalPureXbase.g:4706:2: rule__XConditionalExpression__Group_1__1__Impl rule__XConditionalExpression__Group_1__2
            {
            pushFollow(FOLLOW_20);
            rule__XConditionalExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1__1"


    // $ANTLR start "rule__XConditionalExpression__Group_1__1__Impl"
    // InternalPureXbase.g:4713:1: rule__XConditionalExpression__Group_1__1__Impl : ( ( rule__XConditionalExpression__ThenAssignment_1_1 ) ) ;
    public final void rule__XConditionalExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4717:1: ( ( ( rule__XConditionalExpression__ThenAssignment_1_1 ) ) )
            // InternalPureXbase.g:4718:1: ( ( rule__XConditionalExpression__ThenAssignment_1_1 ) )
            {
            // InternalPureXbase.g:4718:1: ( ( rule__XConditionalExpression__ThenAssignment_1_1 ) )
            // InternalPureXbase.g:4719:2: ( rule__XConditionalExpression__ThenAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getThenAssignment_1_1()); 
            }
            // InternalPureXbase.g:4720:2: ( rule__XConditionalExpression__ThenAssignment_1_1 )
            // InternalPureXbase.g:4720:3: rule__XConditionalExpression__ThenAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__ThenAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getThenAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1__2"
    // InternalPureXbase.g:4728:1: rule__XConditionalExpression__Group_1__2 : rule__XConditionalExpression__Group_1__2__Impl ;
    public final void rule__XConditionalExpression__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4732:1: ( rule__XConditionalExpression__Group_1__2__Impl )
            // InternalPureXbase.g:4733:2: rule__XConditionalExpression__Group_1__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1__2"


    // $ANTLR start "rule__XConditionalExpression__Group_1__2__Impl"
    // InternalPureXbase.g:4739:1: rule__XConditionalExpression__Group_1__2__Impl : ( ( rule__XConditionalExpression__Group_1_2__0 )? ) ;
    public final void rule__XConditionalExpression__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4743:1: ( ( ( rule__XConditionalExpression__Group_1_2__0 )? ) )
            // InternalPureXbase.g:4744:1: ( ( rule__XConditionalExpression__Group_1_2__0 )? )
            {
            // InternalPureXbase.g:4744:1: ( ( rule__XConditionalExpression__Group_1_2__0 )? )
            // InternalPureXbase.g:4745:2: ( rule__XConditionalExpression__Group_1_2__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getGroup_1_2()); 
            }
            // InternalPureXbase.g:4746:2: ( rule__XConditionalExpression__Group_1_2__0 )?
            int alt57=2;
            int LA57_0 = input.LA(1);

            if ( (LA57_0==52) ) {
                int LA57_1 = input.LA(2);

                if ( (synpred97_InternalPureXbase()) ) {
                    alt57=1;
                }
            }
            switch (alt57) {
                case 1 :
                    // InternalPureXbase.g:4746:3: rule__XConditionalExpression__Group_1_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConditionalExpression__Group_1_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getGroup_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1__2__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1_0__0"
    // InternalPureXbase.g:4755:1: rule__XConditionalExpression__Group_1_0__0 : rule__XConditionalExpression__Group_1_0__0__Impl ;
    public final void rule__XConditionalExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4759:1: ( rule__XConditionalExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:4760:2: rule__XConditionalExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_0__0"


    // $ANTLR start "rule__XConditionalExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:4766:1: rule__XConditionalExpression__Group_1_0__0__Impl : ( ( rule__XConditionalExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XConditionalExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4770:1: ( ( ( rule__XConditionalExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:4771:1: ( ( rule__XConditionalExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:4771:1: ( ( rule__XConditionalExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:4772:2: ( rule__XConditionalExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:4773:2: ( rule__XConditionalExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:4773:3: rule__XConditionalExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1_0_0__0"
    // InternalPureXbase.g:4782:1: rule__XConditionalExpression__Group_1_0_0__0 : rule__XConditionalExpression__Group_1_0_0__0__Impl rule__XConditionalExpression__Group_1_0_0__1 ;
    public final void rule__XConditionalExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4786:1: ( rule__XConditionalExpression__Group_1_0_0__0__Impl rule__XConditionalExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:4787:2: rule__XConditionalExpression__Group_1_0_0__0__Impl rule__XConditionalExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_19);
            rule__XConditionalExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XConditionalExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:4794:1: rule__XConditionalExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XConditionalExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4798:1: ( ( () ) )
            // InternalPureXbase.g:4799:1: ( () )
            {
            // InternalPureXbase.g:4799:1: ( () )
            // InternalPureXbase.g:4800:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getXIfExpressionIfAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:4801:2: ()
            // InternalPureXbase.g:4801:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getXIfExpressionIfAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1_0_0__1"
    // InternalPureXbase.g:4809:1: rule__XConditionalExpression__Group_1_0_0__1 : rule__XConditionalExpression__Group_1_0_0__1__Impl ;
    public final void rule__XConditionalExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4813:1: ( rule__XConditionalExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:4814:2: rule__XConditionalExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XConditionalExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:4820:1: rule__XConditionalExpression__Group_1_0_0__1__Impl : ( ( rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 ) ) ;
    public final void rule__XConditionalExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4824:1: ( ( ( rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:4825:1: ( ( rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:4825:1: ( ( rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:4826:2: ( rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getConditionalExpressionAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:4827:2: ( rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 )
            // InternalPureXbase.g:4827:3: rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getConditionalExpressionAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1_2__0"
    // InternalPureXbase.g:4836:1: rule__XConditionalExpression__Group_1_2__0 : rule__XConditionalExpression__Group_1_2__0__Impl rule__XConditionalExpression__Group_1_2__1 ;
    public final void rule__XConditionalExpression__Group_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4840:1: ( rule__XConditionalExpression__Group_1_2__0__Impl rule__XConditionalExpression__Group_1_2__1 )
            // InternalPureXbase.g:4841:2: rule__XConditionalExpression__Group_1_2__0__Impl rule__XConditionalExpression__Group_1_2__1
            {
            pushFollow(FOLLOW_5);
            rule__XConditionalExpression__Group_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_2__0"


    // $ANTLR start "rule__XConditionalExpression__Group_1_2__0__Impl"
    // InternalPureXbase.g:4848:1: rule__XConditionalExpression__Group_1_2__0__Impl : ( ( ':' ) ) ;
    public final void rule__XConditionalExpression__Group_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4852:1: ( ( ( ':' ) ) )
            // InternalPureXbase.g:4853:1: ( ( ':' ) )
            {
            // InternalPureXbase.g:4853:1: ( ( ':' ) )
            // InternalPureXbase.g:4854:2: ( ':' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getColonKeyword_1_2_0()); 
            }
            // InternalPureXbase.g:4855:2: ( ':' )
            // InternalPureXbase.g:4855:3: ':'
            {
            match(input,52,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getColonKeyword_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_2__0__Impl"


    // $ANTLR start "rule__XConditionalExpression__Group_1_2__1"
    // InternalPureXbase.g:4863:1: rule__XConditionalExpression__Group_1_2__1 : rule__XConditionalExpression__Group_1_2__1__Impl ;
    public final void rule__XConditionalExpression__Group_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4867:1: ( rule__XConditionalExpression__Group_1_2__1__Impl )
            // InternalPureXbase.g:4868:2: rule__XConditionalExpression__Group_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__Group_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_2__1"


    // $ANTLR start "rule__XConditionalExpression__Group_1_2__1__Impl"
    // InternalPureXbase.g:4874:1: rule__XConditionalExpression__Group_1_2__1__Impl : ( ( rule__XConditionalExpression__ElseAssignment_1_2_1 ) ) ;
    public final void rule__XConditionalExpression__Group_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4878:1: ( ( ( rule__XConditionalExpression__ElseAssignment_1_2_1 ) ) )
            // InternalPureXbase.g:4879:1: ( ( rule__XConditionalExpression__ElseAssignment_1_2_1 ) )
            {
            // InternalPureXbase.g:4879:1: ( ( rule__XConditionalExpression__ElseAssignment_1_2_1 ) )
            // InternalPureXbase.g:4880:2: ( rule__XConditionalExpression__ElseAssignment_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getElseAssignment_1_2_1()); 
            }
            // InternalPureXbase.g:4881:2: ( rule__XConditionalExpression__ElseAssignment_1_2_1 )
            // InternalPureXbase.g:4881:3: rule__XConditionalExpression__ElseAssignment_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XConditionalExpression__ElseAssignment_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getElseAssignment_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__Group_1_2__1__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_5__0"
    // InternalPureXbase.g:4890:1: rule__OpMultiAssign__Group_5__0 : rule__OpMultiAssign__Group_5__0__Impl rule__OpMultiAssign__Group_5__1 ;
    public final void rule__OpMultiAssign__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4894:1: ( rule__OpMultiAssign__Group_5__0__Impl rule__OpMultiAssign__Group_5__1 )
            // InternalPureXbase.g:4895:2: rule__OpMultiAssign__Group_5__0__Impl rule__OpMultiAssign__Group_5__1
            {
            pushFollow(FOLLOW_21);
            rule__OpMultiAssign__Group_5__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_5__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__0"


    // $ANTLR start "rule__OpMultiAssign__Group_5__0__Impl"
    // InternalPureXbase.g:4902:1: rule__OpMultiAssign__Group_5__0__Impl : ( '<' ) ;
    public final void rule__OpMultiAssign__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4906:1: ( ( '<' ) )
            // InternalPureXbase.g:4907:1: ( '<' )
            {
            // InternalPureXbase.g:4907:1: ( '<' )
            // InternalPureXbase.g:4908:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_0()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__0__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_5__1"
    // InternalPureXbase.g:4917:1: rule__OpMultiAssign__Group_5__1 : rule__OpMultiAssign__Group_5__1__Impl rule__OpMultiAssign__Group_5__2 ;
    public final void rule__OpMultiAssign__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4921:1: ( rule__OpMultiAssign__Group_5__1__Impl rule__OpMultiAssign__Group_5__2 )
            // InternalPureXbase.g:4922:2: rule__OpMultiAssign__Group_5__1__Impl rule__OpMultiAssign__Group_5__2
            {
            pushFollow(FOLLOW_16);
            rule__OpMultiAssign__Group_5__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_5__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__1"


    // $ANTLR start "rule__OpMultiAssign__Group_5__1__Impl"
    // InternalPureXbase.g:4929:1: rule__OpMultiAssign__Group_5__1__Impl : ( '<' ) ;
    public final void rule__OpMultiAssign__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4933:1: ( ( '<' ) )
            // InternalPureXbase.g:4934:1: ( '<' )
            {
            // InternalPureXbase.g:4934:1: ( '<' )
            // InternalPureXbase.g:4935:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_1()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__1__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_5__2"
    // InternalPureXbase.g:4944:1: rule__OpMultiAssign__Group_5__2 : rule__OpMultiAssign__Group_5__2__Impl ;
    public final void rule__OpMultiAssign__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4948:1: ( rule__OpMultiAssign__Group_5__2__Impl )
            // InternalPureXbase.g:4949:2: rule__OpMultiAssign__Group_5__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_5__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__2"


    // $ANTLR start "rule__OpMultiAssign__Group_5__2__Impl"
    // InternalPureXbase.g:4955:1: rule__OpMultiAssign__Group_5__2__Impl : ( '=' ) ;
    public final void rule__OpMultiAssign__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4959:1: ( ( '=' ) )
            // InternalPureXbase.g:4960:1: ( '=' )
            {
            // InternalPureXbase.g:4960:1: ( '=' )
            // InternalPureXbase.g:4961:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getEqualsSignKeyword_5_2()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getEqualsSignKeyword_5_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__2__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_6__0"
    // InternalPureXbase.g:4971:1: rule__OpMultiAssign__Group_6__0 : rule__OpMultiAssign__Group_6__0__Impl rule__OpMultiAssign__Group_6__1 ;
    public final void rule__OpMultiAssign__Group_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4975:1: ( rule__OpMultiAssign__Group_6__0__Impl rule__OpMultiAssign__Group_6__1 )
            // InternalPureXbase.g:4976:2: rule__OpMultiAssign__Group_6__0__Impl rule__OpMultiAssign__Group_6__1
            {
            pushFollow(FOLLOW_22);
            rule__OpMultiAssign__Group_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_6__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__0"


    // $ANTLR start "rule__OpMultiAssign__Group_6__0__Impl"
    // InternalPureXbase.g:4983:1: rule__OpMultiAssign__Group_6__0__Impl : ( '>' ) ;
    public final void rule__OpMultiAssign__Group_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:4987:1: ( ( '>' ) )
            // InternalPureXbase.g:4988:1: ( '>' )
            {
            // InternalPureXbase.g:4988:1: ( '>' )
            // InternalPureXbase.g:4989:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__0__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_6__1"
    // InternalPureXbase.g:4998:1: rule__OpMultiAssign__Group_6__1 : rule__OpMultiAssign__Group_6__1__Impl rule__OpMultiAssign__Group_6__2 ;
    public final void rule__OpMultiAssign__Group_6__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5002:1: ( rule__OpMultiAssign__Group_6__1__Impl rule__OpMultiAssign__Group_6__2 )
            // InternalPureXbase.g:5003:2: rule__OpMultiAssign__Group_6__1__Impl rule__OpMultiAssign__Group_6__2
            {
            pushFollow(FOLLOW_22);
            rule__OpMultiAssign__Group_6__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_6__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__1"


    // $ANTLR start "rule__OpMultiAssign__Group_6__1__Impl"
    // InternalPureXbase.g:5010:1: rule__OpMultiAssign__Group_6__1__Impl : ( ( '>' )? ) ;
    public final void rule__OpMultiAssign__Group_6__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5014:1: ( ( ( '>' )? ) )
            // InternalPureXbase.g:5015:1: ( ( '>' )? )
            {
            // InternalPureXbase.g:5015:1: ( ( '>' )? )
            // InternalPureXbase.g:5016:2: ( '>' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_1()); 
            }
            // InternalPureXbase.g:5017:2: ( '>' )?
            int alt58=2;
            int LA58_0 = input.LA(1);

            if ( (LA58_0==27) ) {
                alt58=1;
            }
            switch (alt58) {
                case 1 :
                    // InternalPureXbase.g:5017:3: '>'
                    {
                    match(input,27,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__1__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_6__2"
    // InternalPureXbase.g:5025:1: rule__OpMultiAssign__Group_6__2 : rule__OpMultiAssign__Group_6__2__Impl ;
    public final void rule__OpMultiAssign__Group_6__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5029:1: ( rule__OpMultiAssign__Group_6__2__Impl )
            // InternalPureXbase.g:5030:2: rule__OpMultiAssign__Group_6__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_6__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__2"


    // $ANTLR start "rule__OpMultiAssign__Group_6__2__Impl"
    // InternalPureXbase.g:5036:1: rule__OpMultiAssign__Group_6__2__Impl : ( '>=' ) ;
    public final void rule__OpMultiAssign__Group_6__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5040:1: ( ( '>=' ) )
            // InternalPureXbase.g:5041:1: ( '>=' )
            {
            // InternalPureXbase.g:5041:1: ( '>=' )
            // InternalPureXbase.g:5042:2: '>='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignEqualsSignKeyword_6_2()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignEqualsSignKeyword_6_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__2__Impl"


    // $ANTLR start "rule__XOrExpression__Group__0"
    // InternalPureXbase.g:5052:1: rule__XOrExpression__Group__0 : rule__XOrExpression__Group__0__Impl rule__XOrExpression__Group__1 ;
    public final void rule__XOrExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5056:1: ( rule__XOrExpression__Group__0__Impl rule__XOrExpression__Group__1 )
            // InternalPureXbase.g:5057:2: rule__XOrExpression__Group__0__Impl rule__XOrExpression__Group__1
            {
            pushFollow(FOLLOW_23);
            rule__XOrExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__0"


    // $ANTLR start "rule__XOrExpression__Group__0__Impl"
    // InternalPureXbase.g:5064:1: rule__XOrExpression__Group__0__Impl : ( ruleXAndExpression ) ;
    public final void rule__XOrExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5068:1: ( ( ruleXAndExpression ) )
            // InternalPureXbase.g:5069:1: ( ruleXAndExpression )
            {
            // InternalPureXbase.g:5069:1: ( ruleXAndExpression )
            // InternalPureXbase.g:5070:2: ruleXAndExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getXAndExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAndExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getXAndExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group__1"
    // InternalPureXbase.g:5079:1: rule__XOrExpression__Group__1 : rule__XOrExpression__Group__1__Impl ;
    public final void rule__XOrExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5083:1: ( rule__XOrExpression__Group__1__Impl )
            // InternalPureXbase.g:5084:2: rule__XOrExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__1"


    // $ANTLR start "rule__XOrExpression__Group__1__Impl"
    // InternalPureXbase.g:5090:1: rule__XOrExpression__Group__1__Impl : ( ( rule__XOrExpression__Group_1__0 )* ) ;
    public final void rule__XOrExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5094:1: ( ( ( rule__XOrExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:5095:1: ( ( rule__XOrExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:5095:1: ( ( rule__XOrExpression__Group_1__0 )* )
            // InternalPureXbase.g:5096:2: ( rule__XOrExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:5097:2: ( rule__XOrExpression__Group_1__0 )*
            loop59:
            do {
                int alt59=2;
                int LA59_0 = input.LA(1);

                if ( (LA59_0==14) ) {
                    int LA59_2 = input.LA(2);

                    if ( (synpred99_InternalPureXbase()) ) {
                        alt59=1;
                    }


                }


                switch (alt59) {
            	case 1 :
            	    // InternalPureXbase.g:5097:3: rule__XOrExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_24);
            	    rule__XOrExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop59;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__1__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1__0"
    // InternalPureXbase.g:5106:1: rule__XOrExpression__Group_1__0 : rule__XOrExpression__Group_1__0__Impl rule__XOrExpression__Group_1__1 ;
    public final void rule__XOrExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5110:1: ( rule__XOrExpression__Group_1__0__Impl rule__XOrExpression__Group_1__1 )
            // InternalPureXbase.g:5111:2: rule__XOrExpression__Group_1__0__Impl rule__XOrExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XOrExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__0"


    // $ANTLR start "rule__XOrExpression__Group_1__0__Impl"
    // InternalPureXbase.g:5118:1: rule__XOrExpression__Group_1__0__Impl : ( ( rule__XOrExpression__Group_1_0__0 ) ) ;
    public final void rule__XOrExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5122:1: ( ( ( rule__XOrExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:5123:1: ( ( rule__XOrExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:5123:1: ( ( rule__XOrExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:5124:2: ( rule__XOrExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:5125:2: ( rule__XOrExpression__Group_1_0__0 )
            // InternalPureXbase.g:5125:3: rule__XOrExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1__1"
    // InternalPureXbase.g:5133:1: rule__XOrExpression__Group_1__1 : rule__XOrExpression__Group_1__1__Impl ;
    public final void rule__XOrExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5137:1: ( rule__XOrExpression__Group_1__1__Impl )
            // InternalPureXbase.g:5138:2: rule__XOrExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__1"


    // $ANTLR start "rule__XOrExpression__Group_1__1__Impl"
    // InternalPureXbase.g:5144:1: rule__XOrExpression__Group_1__1__Impl : ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XOrExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5148:1: ( ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) ) )
            // InternalPureXbase.g:5149:1: ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalPureXbase.g:5149:1: ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) )
            // InternalPureXbase.g:5150:2: ( rule__XOrExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalPureXbase.g:5151:2: ( rule__XOrExpression__RightOperandAssignment_1_1 )
            // InternalPureXbase.g:5151:3: rule__XOrExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1_0__0"
    // InternalPureXbase.g:5160:1: rule__XOrExpression__Group_1_0__0 : rule__XOrExpression__Group_1_0__0__Impl ;
    public final void rule__XOrExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5164:1: ( rule__XOrExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:5165:2: rule__XOrExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0__0"


    // $ANTLR start "rule__XOrExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:5171:1: rule__XOrExpression__Group_1_0__0__Impl : ( ( rule__XOrExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XOrExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5175:1: ( ( ( rule__XOrExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:5176:1: ( ( rule__XOrExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:5176:1: ( ( rule__XOrExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:5177:2: ( rule__XOrExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:5178:2: ( rule__XOrExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:5178:3: rule__XOrExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__0"
    // InternalPureXbase.g:5187:1: rule__XOrExpression__Group_1_0_0__0 : rule__XOrExpression__Group_1_0_0__0__Impl rule__XOrExpression__Group_1_0_0__1 ;
    public final void rule__XOrExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5191:1: ( rule__XOrExpression__Group_1_0_0__0__Impl rule__XOrExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:5192:2: rule__XOrExpression__Group_1_0_0__0__Impl rule__XOrExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_23);
            rule__XOrExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:5199:1: rule__XOrExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XOrExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5203:1: ( ( () ) )
            // InternalPureXbase.g:5204:1: ( () )
            {
            // InternalPureXbase.g:5204:1: ( () )
            // InternalPureXbase.g:5205:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:5206:2: ()
            // InternalPureXbase.g:5206:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__1"
    // InternalPureXbase.g:5214:1: rule__XOrExpression__Group_1_0_0__1 : rule__XOrExpression__Group_1_0_0__1__Impl ;
    public final void rule__XOrExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5218:1: ( rule__XOrExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:5219:2: rule__XOrExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:5225:1: rule__XOrExpression__Group_1_0_0__1__Impl : ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XOrExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5229:1: ( ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:5230:1: ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:5230:1: ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:5231:2: ( rule__XOrExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:5232:2: ( rule__XOrExpression__FeatureAssignment_1_0_0_1 )
            // InternalPureXbase.g:5232:3: rule__XOrExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XAndExpression__Group__0"
    // InternalPureXbase.g:5241:1: rule__XAndExpression__Group__0 : rule__XAndExpression__Group__0__Impl rule__XAndExpression__Group__1 ;
    public final void rule__XAndExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5245:1: ( rule__XAndExpression__Group__0__Impl rule__XAndExpression__Group__1 )
            // InternalPureXbase.g:5246:2: rule__XAndExpression__Group__0__Impl rule__XAndExpression__Group__1
            {
            pushFollow(FOLLOW_25);
            rule__XAndExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__0"


    // $ANTLR start "rule__XAndExpression__Group__0__Impl"
    // InternalPureXbase.g:5253:1: rule__XAndExpression__Group__0__Impl : ( ruleXEqualityExpression ) ;
    public final void rule__XAndExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5257:1: ( ( ruleXEqualityExpression ) )
            // InternalPureXbase.g:5258:1: ( ruleXEqualityExpression )
            {
            // InternalPureXbase.g:5258:1: ( ruleXEqualityExpression )
            // InternalPureXbase.g:5259:2: ruleXEqualityExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getXEqualityExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getXEqualityExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group__1"
    // InternalPureXbase.g:5268:1: rule__XAndExpression__Group__1 : rule__XAndExpression__Group__1__Impl ;
    public final void rule__XAndExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5272:1: ( rule__XAndExpression__Group__1__Impl )
            // InternalPureXbase.g:5273:2: rule__XAndExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__1"


    // $ANTLR start "rule__XAndExpression__Group__1__Impl"
    // InternalPureXbase.g:5279:1: rule__XAndExpression__Group__1__Impl : ( ( rule__XAndExpression__Group_1__0 )* ) ;
    public final void rule__XAndExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5283:1: ( ( ( rule__XAndExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:5284:1: ( ( rule__XAndExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:5284:1: ( ( rule__XAndExpression__Group_1__0 )* )
            // InternalPureXbase.g:5285:2: ( rule__XAndExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:5286:2: ( rule__XAndExpression__Group_1__0 )*
            loop60:
            do {
                int alt60=2;
                int LA60_0 = input.LA(1);

                if ( (LA60_0==15) ) {
                    int LA60_2 = input.LA(2);

                    if ( (synpred100_InternalPureXbase()) ) {
                        alt60=1;
                    }


                }


                switch (alt60) {
            	case 1 :
            	    // InternalPureXbase.g:5286:3: rule__XAndExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_26);
            	    rule__XAndExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop60;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__1__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1__0"
    // InternalPureXbase.g:5295:1: rule__XAndExpression__Group_1__0 : rule__XAndExpression__Group_1__0__Impl rule__XAndExpression__Group_1__1 ;
    public final void rule__XAndExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5299:1: ( rule__XAndExpression__Group_1__0__Impl rule__XAndExpression__Group_1__1 )
            // InternalPureXbase.g:5300:2: rule__XAndExpression__Group_1__0__Impl rule__XAndExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XAndExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__0"


    // $ANTLR start "rule__XAndExpression__Group_1__0__Impl"
    // InternalPureXbase.g:5307:1: rule__XAndExpression__Group_1__0__Impl : ( ( rule__XAndExpression__Group_1_0__0 ) ) ;
    public final void rule__XAndExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5311:1: ( ( ( rule__XAndExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:5312:1: ( ( rule__XAndExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:5312:1: ( ( rule__XAndExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:5313:2: ( rule__XAndExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:5314:2: ( rule__XAndExpression__Group_1_0__0 )
            // InternalPureXbase.g:5314:3: rule__XAndExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1__1"
    // InternalPureXbase.g:5322:1: rule__XAndExpression__Group_1__1 : rule__XAndExpression__Group_1__1__Impl ;
    public final void rule__XAndExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5326:1: ( rule__XAndExpression__Group_1__1__Impl )
            // InternalPureXbase.g:5327:2: rule__XAndExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__1"


    // $ANTLR start "rule__XAndExpression__Group_1__1__Impl"
    // InternalPureXbase.g:5333:1: rule__XAndExpression__Group_1__1__Impl : ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XAndExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5337:1: ( ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) ) )
            // InternalPureXbase.g:5338:1: ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalPureXbase.g:5338:1: ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) )
            // InternalPureXbase.g:5339:2: ( rule__XAndExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalPureXbase.g:5340:2: ( rule__XAndExpression__RightOperandAssignment_1_1 )
            // InternalPureXbase.g:5340:3: rule__XAndExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1_0__0"
    // InternalPureXbase.g:5349:1: rule__XAndExpression__Group_1_0__0 : rule__XAndExpression__Group_1_0__0__Impl ;
    public final void rule__XAndExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5353:1: ( rule__XAndExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:5354:2: rule__XAndExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0__0"


    // $ANTLR start "rule__XAndExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:5360:1: rule__XAndExpression__Group_1_0__0__Impl : ( ( rule__XAndExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XAndExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5364:1: ( ( ( rule__XAndExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:5365:1: ( ( rule__XAndExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:5365:1: ( ( rule__XAndExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:5366:2: ( rule__XAndExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:5367:2: ( rule__XAndExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:5367:3: rule__XAndExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__0"
    // InternalPureXbase.g:5376:1: rule__XAndExpression__Group_1_0_0__0 : rule__XAndExpression__Group_1_0_0__0__Impl rule__XAndExpression__Group_1_0_0__1 ;
    public final void rule__XAndExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5380:1: ( rule__XAndExpression__Group_1_0_0__0__Impl rule__XAndExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:5381:2: rule__XAndExpression__Group_1_0_0__0__Impl rule__XAndExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_25);
            rule__XAndExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:5388:1: rule__XAndExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XAndExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5392:1: ( ( () ) )
            // InternalPureXbase.g:5393:1: ( () )
            {
            // InternalPureXbase.g:5393:1: ( () )
            // InternalPureXbase.g:5394:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:5395:2: ()
            // InternalPureXbase.g:5395:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__1"
    // InternalPureXbase.g:5403:1: rule__XAndExpression__Group_1_0_0__1 : rule__XAndExpression__Group_1_0_0__1__Impl ;
    public final void rule__XAndExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5407:1: ( rule__XAndExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:5408:2: rule__XAndExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:5414:1: rule__XAndExpression__Group_1_0_0__1__Impl : ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XAndExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5418:1: ( ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:5419:1: ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:5419:1: ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:5420:2: ( rule__XAndExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:5421:2: ( rule__XAndExpression__FeatureAssignment_1_0_0_1 )
            // InternalPureXbase.g:5421:3: rule__XAndExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group__0"
    // InternalPureXbase.g:5430:1: rule__XEqualityExpression__Group__0 : rule__XEqualityExpression__Group__0__Impl rule__XEqualityExpression__Group__1 ;
    public final void rule__XEqualityExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5434:1: ( rule__XEqualityExpression__Group__0__Impl rule__XEqualityExpression__Group__1 )
            // InternalPureXbase.g:5435:2: rule__XEqualityExpression__Group__0__Impl rule__XEqualityExpression__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__XEqualityExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__0"


    // $ANTLR start "rule__XEqualityExpression__Group__0__Impl"
    // InternalPureXbase.g:5442:1: rule__XEqualityExpression__Group__0__Impl : ( ruleXRelationalExpression ) ;
    public final void rule__XEqualityExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5446:1: ( ( ruleXRelationalExpression ) )
            // InternalPureXbase.g:5447:1: ( ruleXRelationalExpression )
            {
            // InternalPureXbase.g:5447:1: ( ruleXRelationalExpression )
            // InternalPureXbase.g:5448:2: ruleXRelationalExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getXRelationalExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getXRelationalExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group__1"
    // InternalPureXbase.g:5457:1: rule__XEqualityExpression__Group__1 : rule__XEqualityExpression__Group__1__Impl ;
    public final void rule__XEqualityExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5461:1: ( rule__XEqualityExpression__Group__1__Impl )
            // InternalPureXbase.g:5462:2: rule__XEqualityExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__1"


    // $ANTLR start "rule__XEqualityExpression__Group__1__Impl"
    // InternalPureXbase.g:5468:1: rule__XEqualityExpression__Group__1__Impl : ( ( rule__XEqualityExpression__Group_1__0 )* ) ;
    public final void rule__XEqualityExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5472:1: ( ( ( rule__XEqualityExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:5473:1: ( ( rule__XEqualityExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:5473:1: ( ( rule__XEqualityExpression__Group_1__0 )* )
            // InternalPureXbase.g:5474:2: ( rule__XEqualityExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:5475:2: ( rule__XEqualityExpression__Group_1__0 )*
            loop61:
            do {
                int alt61=2;
                switch ( input.LA(1) ) {
                case 22:
                    {
                    int LA61_2 = input.LA(2);

                    if ( (synpred101_InternalPureXbase()) ) {
                        alt61=1;
                    }


                    }
                    break;
                case 23:
                    {
                    int LA61_3 = input.LA(2);

                    if ( (synpred101_InternalPureXbase()) ) {
                        alt61=1;
                    }


                    }
                    break;
                case 24:
                    {
                    int LA61_4 = input.LA(2);

                    if ( (synpred101_InternalPureXbase()) ) {
                        alt61=1;
                    }


                    }
                    break;
                case 25:
                    {
                    int LA61_5 = input.LA(2);

                    if ( (synpred101_InternalPureXbase()) ) {
                        alt61=1;
                    }


                    }
                    break;

                }

                switch (alt61) {
            	case 1 :
            	    // InternalPureXbase.g:5475:3: rule__XEqualityExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_28);
            	    rule__XEqualityExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop61;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__1__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1__0"
    // InternalPureXbase.g:5484:1: rule__XEqualityExpression__Group_1__0 : rule__XEqualityExpression__Group_1__0__Impl rule__XEqualityExpression__Group_1__1 ;
    public final void rule__XEqualityExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5488:1: ( rule__XEqualityExpression__Group_1__0__Impl rule__XEqualityExpression__Group_1__1 )
            // InternalPureXbase.g:5489:2: rule__XEqualityExpression__Group_1__0__Impl rule__XEqualityExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XEqualityExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__0"


    // $ANTLR start "rule__XEqualityExpression__Group_1__0__Impl"
    // InternalPureXbase.g:5496:1: rule__XEqualityExpression__Group_1__0__Impl : ( ( rule__XEqualityExpression__Group_1_0__0 ) ) ;
    public final void rule__XEqualityExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5500:1: ( ( ( rule__XEqualityExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:5501:1: ( ( rule__XEqualityExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:5501:1: ( ( rule__XEqualityExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:5502:2: ( rule__XEqualityExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:5503:2: ( rule__XEqualityExpression__Group_1_0__0 )
            // InternalPureXbase.g:5503:3: rule__XEqualityExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1__1"
    // InternalPureXbase.g:5511:1: rule__XEqualityExpression__Group_1__1 : rule__XEqualityExpression__Group_1__1__Impl ;
    public final void rule__XEqualityExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5515:1: ( rule__XEqualityExpression__Group_1__1__Impl )
            // InternalPureXbase.g:5516:2: rule__XEqualityExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__1"


    // $ANTLR start "rule__XEqualityExpression__Group_1__1__Impl"
    // InternalPureXbase.g:5522:1: rule__XEqualityExpression__Group_1__1__Impl : ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XEqualityExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5526:1: ( ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) ) )
            // InternalPureXbase.g:5527:1: ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalPureXbase.g:5527:1: ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) )
            // InternalPureXbase.g:5528:2: ( rule__XEqualityExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalPureXbase.g:5529:2: ( rule__XEqualityExpression__RightOperandAssignment_1_1 )
            // InternalPureXbase.g:5529:3: rule__XEqualityExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0__0"
    // InternalPureXbase.g:5538:1: rule__XEqualityExpression__Group_1_0__0 : rule__XEqualityExpression__Group_1_0__0__Impl ;
    public final void rule__XEqualityExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5542:1: ( rule__XEqualityExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:5543:2: rule__XEqualityExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0__0"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:5549:1: rule__XEqualityExpression__Group_1_0__0__Impl : ( ( rule__XEqualityExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XEqualityExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5553:1: ( ( ( rule__XEqualityExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:5554:1: ( ( rule__XEqualityExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:5554:1: ( ( rule__XEqualityExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:5555:2: ( rule__XEqualityExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:5556:2: ( rule__XEqualityExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:5556:3: rule__XEqualityExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__0"
    // InternalPureXbase.g:5565:1: rule__XEqualityExpression__Group_1_0_0__0 : rule__XEqualityExpression__Group_1_0_0__0__Impl rule__XEqualityExpression__Group_1_0_0__1 ;
    public final void rule__XEqualityExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5569:1: ( rule__XEqualityExpression__Group_1_0_0__0__Impl rule__XEqualityExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:5570:2: rule__XEqualityExpression__Group_1_0_0__0__Impl rule__XEqualityExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_27);
            rule__XEqualityExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:5577:1: rule__XEqualityExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XEqualityExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5581:1: ( ( () ) )
            // InternalPureXbase.g:5582:1: ( () )
            {
            // InternalPureXbase.g:5582:1: ( () )
            // InternalPureXbase.g:5583:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:5584:2: ()
            // InternalPureXbase.g:5584:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__1"
    // InternalPureXbase.g:5592:1: rule__XEqualityExpression__Group_1_0_0__1 : rule__XEqualityExpression__Group_1_0_0__1__Impl ;
    public final void rule__XEqualityExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5596:1: ( rule__XEqualityExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:5597:2: rule__XEqualityExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:5603:1: rule__XEqualityExpression__Group_1_0_0__1__Impl : ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XEqualityExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5607:1: ( ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:5608:1: ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:5608:1: ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:5609:2: ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:5610:2: ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 )
            // InternalPureXbase.g:5610:3: rule__XEqualityExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group__0"
    // InternalPureXbase.g:5619:1: rule__XRelationalExpression__Group__0 : rule__XRelationalExpression__Group__0__Impl rule__XRelationalExpression__Group__1 ;
    public final void rule__XRelationalExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5623:1: ( rule__XRelationalExpression__Group__0__Impl rule__XRelationalExpression__Group__1 )
            // InternalPureXbase.g:5624:2: rule__XRelationalExpression__Group__0__Impl rule__XRelationalExpression__Group__1
            {
            pushFollow(FOLLOW_29);
            rule__XRelationalExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__0"


    // $ANTLR start "rule__XRelationalExpression__Group__0__Impl"
    // InternalPureXbase.g:5631:1: rule__XRelationalExpression__Group__0__Impl : ( ruleXOtherOperatorExpression ) ;
    public final void rule__XRelationalExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5635:1: ( ( ruleXOtherOperatorExpression ) )
            // InternalPureXbase.g:5636:1: ( ruleXOtherOperatorExpression )
            {
            // InternalPureXbase.g:5636:1: ( ruleXOtherOperatorExpression )
            // InternalPureXbase.g:5637:2: ruleXOtherOperatorExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getXOtherOperatorExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getXOtherOperatorExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group__1"
    // InternalPureXbase.g:5646:1: rule__XRelationalExpression__Group__1 : rule__XRelationalExpression__Group__1__Impl ;
    public final void rule__XRelationalExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5650:1: ( rule__XRelationalExpression__Group__1__Impl )
            // InternalPureXbase.g:5651:2: rule__XRelationalExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__1"


    // $ANTLR start "rule__XRelationalExpression__Group__1__Impl"
    // InternalPureXbase.g:5657:1: rule__XRelationalExpression__Group__1__Impl : ( ( rule__XRelationalExpression__Alternatives_1 )* ) ;
    public final void rule__XRelationalExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5661:1: ( ( ( rule__XRelationalExpression__Alternatives_1 )* ) )
            // InternalPureXbase.g:5662:1: ( ( rule__XRelationalExpression__Alternatives_1 )* )
            {
            // InternalPureXbase.g:5662:1: ( ( rule__XRelationalExpression__Alternatives_1 )* )
            // InternalPureXbase.g:5663:2: ( rule__XRelationalExpression__Alternatives_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getAlternatives_1()); 
            }
            // InternalPureXbase.g:5664:2: ( rule__XRelationalExpression__Alternatives_1 )*
            loop62:
            do {
                int alt62=2;
                switch ( input.LA(1) ) {
                case 28:
                    {
                    int LA62_2 = input.LA(2);

                    if ( (synpred102_InternalPureXbase()) ) {
                        alt62=1;
                    }


                    }
                    break;
                case 27:
                    {
                    int LA62_3 = input.LA(2);

                    if ( (synpred102_InternalPureXbase()) ) {
                        alt62=1;
                    }


                    }
                    break;
                case 53:
                    {
                    int LA62_4 = input.LA(2);

                    if ( (synpred102_InternalPureXbase()) ) {
                        alt62=1;
                    }


                    }
                    break;
                case 26:
                    {
                    int LA62_5 = input.LA(2);

                    if ( (synpred102_InternalPureXbase()) ) {
                        alt62=1;
                    }


                    }
                    break;

                }

                switch (alt62) {
            	case 1 :
            	    // InternalPureXbase.g:5664:3: rule__XRelationalExpression__Alternatives_1
            	    {
            	    pushFollow(FOLLOW_30);
            	    rule__XRelationalExpression__Alternatives_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop62;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__0"
    // InternalPureXbase.g:5673:1: rule__XRelationalExpression__Group_1_0__0 : rule__XRelationalExpression__Group_1_0__0__Impl rule__XRelationalExpression__Group_1_0__1 ;
    public final void rule__XRelationalExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5677:1: ( rule__XRelationalExpression__Group_1_0__0__Impl rule__XRelationalExpression__Group_1_0__1 )
            // InternalPureXbase.g:5678:2: rule__XRelationalExpression__Group_1_0__0__Impl rule__XRelationalExpression__Group_1_0__1
            {
            pushFollow(FOLLOW_15);
            rule__XRelationalExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:5685:1: rule__XRelationalExpression__Group_1_0__0__Impl : ( ( rule__XRelationalExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5689:1: ( ( ( rule__XRelationalExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:5690:1: ( ( rule__XRelationalExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:5690:1: ( ( rule__XRelationalExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:5691:2: ( rule__XRelationalExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:5692:2: ( rule__XRelationalExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:5692:3: rule__XRelationalExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__1"
    // InternalPureXbase.g:5700:1: rule__XRelationalExpression__Group_1_0__1 : rule__XRelationalExpression__Group_1_0__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5704:1: ( rule__XRelationalExpression__Group_1_0__1__Impl )
            // InternalPureXbase.g:5705:2: rule__XRelationalExpression__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__1__Impl"
    // InternalPureXbase.g:5711:1: rule__XRelationalExpression__Group_1_0__1__Impl : ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) ) ;
    public final void rule__XRelationalExpression__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5715:1: ( ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) ) )
            // InternalPureXbase.g:5716:1: ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) )
            {
            // InternalPureXbase.g:5716:1: ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) )
            // InternalPureXbase.g:5717:2: ( rule__XRelationalExpression__TypeAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getTypeAssignment_1_0_1()); 
            }
            // InternalPureXbase.g:5718:2: ( rule__XRelationalExpression__TypeAssignment_1_0_1 )
            // InternalPureXbase.g:5718:3: rule__XRelationalExpression__TypeAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__TypeAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getTypeAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0__0"
    // InternalPureXbase.g:5727:1: rule__XRelationalExpression__Group_1_0_0__0 : rule__XRelationalExpression__Group_1_0_0__0__Impl ;
    public final void rule__XRelationalExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5731:1: ( rule__XRelationalExpression__Group_1_0_0__0__Impl )
            // InternalPureXbase.g:5732:2: rule__XRelationalExpression__Group_1_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:5738:1: rule__XRelationalExpression__Group_1_0_0__0__Impl : ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5742:1: ( ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) ) )
            // InternalPureXbase.g:5743:1: ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) )
            {
            // InternalPureXbase.g:5743:1: ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) )
            // InternalPureXbase.g:5744:2: ( rule__XRelationalExpression__Group_1_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0_0()); 
            }
            // InternalPureXbase.g:5745:2: ( rule__XRelationalExpression__Group_1_0_0_0__0 )
            // InternalPureXbase.g:5745:3: rule__XRelationalExpression__Group_1_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__0"
    // InternalPureXbase.g:5754:1: rule__XRelationalExpression__Group_1_0_0_0__0 : rule__XRelationalExpression__Group_1_0_0_0__0__Impl rule__XRelationalExpression__Group_1_0_0_0__1 ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5758:1: ( rule__XRelationalExpression__Group_1_0_0_0__0__Impl rule__XRelationalExpression__Group_1_0_0_0__1 )
            // InternalPureXbase.g:5759:2: rule__XRelationalExpression__Group_1_0_0_0__0__Impl rule__XRelationalExpression__Group_1_0_0_0__1
            {
            pushFollow(FOLLOW_31);
            rule__XRelationalExpression__Group_1_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__0__Impl"
    // InternalPureXbase.g:5766:1: rule__XRelationalExpression__Group_1_0_0_0__0__Impl : ( () ) ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5770:1: ( ( () ) )
            // InternalPureXbase.g:5771:1: ( () )
            {
            // InternalPureXbase.g:5771:1: ( () )
            // InternalPureXbase.g:5772:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getXInstanceOfExpressionExpressionAction_1_0_0_0_0()); 
            }
            // InternalPureXbase.g:5773:2: ()
            // InternalPureXbase.g:5773:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getXInstanceOfExpressionExpressionAction_1_0_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__1"
    // InternalPureXbase.g:5781:1: rule__XRelationalExpression__Group_1_0_0_0__1 : rule__XRelationalExpression__Group_1_0_0_0__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5785:1: ( rule__XRelationalExpression__Group_1_0_0_0__1__Impl )
            // InternalPureXbase.g:5786:2: rule__XRelationalExpression__Group_1_0_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__1__Impl"
    // InternalPureXbase.g:5792:1: rule__XRelationalExpression__Group_1_0_0_0__1__Impl : ( 'instanceof' ) ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5796:1: ( ( 'instanceof' ) )
            // InternalPureXbase.g:5797:1: ( 'instanceof' )
            {
            // InternalPureXbase.g:5797:1: ( 'instanceof' )
            // InternalPureXbase.g:5798:2: 'instanceof'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getInstanceofKeyword_1_0_0_0_1()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getInstanceofKeyword_1_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__0"
    // InternalPureXbase.g:5808:1: rule__XRelationalExpression__Group_1_1__0 : rule__XRelationalExpression__Group_1_1__0__Impl rule__XRelationalExpression__Group_1_1__1 ;
    public final void rule__XRelationalExpression__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5812:1: ( rule__XRelationalExpression__Group_1_1__0__Impl rule__XRelationalExpression__Group_1_1__1 )
            // InternalPureXbase.g:5813:2: rule__XRelationalExpression__Group_1_1__0__Impl rule__XRelationalExpression__Group_1_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XRelationalExpression__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__0__Impl"
    // InternalPureXbase.g:5820:1: rule__XRelationalExpression__Group_1_1__0__Impl : ( ( rule__XRelationalExpression__Group_1_1_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5824:1: ( ( ( rule__XRelationalExpression__Group_1_1_0__0 ) ) )
            // InternalPureXbase.g:5825:1: ( ( rule__XRelationalExpression__Group_1_1_0__0 ) )
            {
            // InternalPureXbase.g:5825:1: ( ( rule__XRelationalExpression__Group_1_1_0__0 ) )
            // InternalPureXbase.g:5826:2: ( rule__XRelationalExpression__Group_1_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0()); 
            }
            // InternalPureXbase.g:5827:2: ( rule__XRelationalExpression__Group_1_1_0__0 )
            // InternalPureXbase.g:5827:3: rule__XRelationalExpression__Group_1_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__1"
    // InternalPureXbase.g:5835:1: rule__XRelationalExpression__Group_1_1__1 : rule__XRelationalExpression__Group_1_1__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5839:1: ( rule__XRelationalExpression__Group_1_1__1__Impl )
            // InternalPureXbase.g:5840:2: rule__XRelationalExpression__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__1__Impl"
    // InternalPureXbase.g:5846:1: rule__XRelationalExpression__Group_1_1__1__Impl : ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5850:1: ( ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) ) )
            // InternalPureXbase.g:5851:1: ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) )
            {
            // InternalPureXbase.g:5851:1: ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) )
            // InternalPureXbase.g:5852:2: ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getRightOperandAssignment_1_1_1()); 
            }
            // InternalPureXbase.g:5853:2: ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 )
            // InternalPureXbase.g:5853:3: rule__XRelationalExpression__RightOperandAssignment_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__RightOperandAssignment_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getRightOperandAssignment_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0__0"
    // InternalPureXbase.g:5862:1: rule__XRelationalExpression__Group_1_1_0__0 : rule__XRelationalExpression__Group_1_1_0__0__Impl ;
    public final void rule__XRelationalExpression__Group_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5866:1: ( rule__XRelationalExpression__Group_1_1_0__0__Impl )
            // InternalPureXbase.g:5867:2: rule__XRelationalExpression__Group_1_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0__0__Impl"
    // InternalPureXbase.g:5873:1: rule__XRelationalExpression__Group_1_1_0__0__Impl : ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5877:1: ( ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) ) )
            // InternalPureXbase.g:5878:1: ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) )
            {
            // InternalPureXbase.g:5878:1: ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) )
            // InternalPureXbase.g:5879:2: ( rule__XRelationalExpression__Group_1_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0_0()); 
            }
            // InternalPureXbase.g:5880:2: ( rule__XRelationalExpression__Group_1_1_0_0__0 )
            // InternalPureXbase.g:5880:3: rule__XRelationalExpression__Group_1_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__0"
    // InternalPureXbase.g:5889:1: rule__XRelationalExpression__Group_1_1_0_0__0 : rule__XRelationalExpression__Group_1_1_0_0__0__Impl rule__XRelationalExpression__Group_1_1_0_0__1 ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5893:1: ( rule__XRelationalExpression__Group_1_1_0_0__0__Impl rule__XRelationalExpression__Group_1_1_0_0__1 )
            // InternalPureXbase.g:5894:2: rule__XRelationalExpression__Group_1_1_0_0__0__Impl rule__XRelationalExpression__Group_1_1_0_0__1
            {
            pushFollow(FOLLOW_29);
            rule__XRelationalExpression__Group_1_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__0__Impl"
    // InternalPureXbase.g:5901:1: rule__XRelationalExpression__Group_1_1_0_0__0__Impl : ( () ) ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5905:1: ( ( () ) )
            // InternalPureXbase.g:5906:1: ( () )
            {
            // InternalPureXbase.g:5906:1: ( () )
            // InternalPureXbase.g:5907:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }
            // InternalPureXbase.g:5908:2: ()
            // InternalPureXbase.g:5908:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__1"
    // InternalPureXbase.g:5916:1: rule__XRelationalExpression__Group_1_1_0_0__1 : rule__XRelationalExpression__Group_1_1_0_0__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5920:1: ( rule__XRelationalExpression__Group_1_1_0_0__1__Impl )
            // InternalPureXbase.g:5921:2: rule__XRelationalExpression__Group_1_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__1__Impl"
    // InternalPureXbase.g:5927:1: rule__XRelationalExpression__Group_1_1_0_0__1__Impl : ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5931:1: ( ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) ) )
            // InternalPureXbase.g:5932:1: ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) )
            {
            // InternalPureXbase.g:5932:1: ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) )
            // InternalPureXbase.g:5933:2: ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getFeatureAssignment_1_1_0_0_1()); 
            }
            // InternalPureXbase.g:5934:2: ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 )
            // InternalPureXbase.g:5934:3: rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getFeatureAssignment_1_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__1__Impl"


    // $ANTLR start "rule__OpCompare__Group_1__0"
    // InternalPureXbase.g:5943:1: rule__OpCompare__Group_1__0 : rule__OpCompare__Group_1__0__Impl rule__OpCompare__Group_1__1 ;
    public final void rule__OpCompare__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5947:1: ( rule__OpCompare__Group_1__0__Impl rule__OpCompare__Group_1__1 )
            // InternalPureXbase.g:5948:2: rule__OpCompare__Group_1__0__Impl rule__OpCompare__Group_1__1
            {
            pushFollow(FOLLOW_16);
            rule__OpCompare__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpCompare__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__0"


    // $ANTLR start "rule__OpCompare__Group_1__0__Impl"
    // InternalPureXbase.g:5955:1: rule__OpCompare__Group_1__0__Impl : ( '<' ) ;
    public final void rule__OpCompare__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5959:1: ( ( '<' ) )
            // InternalPureXbase.g:5960:1: ( '<' )
            {
            // InternalPureXbase.g:5960:1: ( '<' )
            // InternalPureXbase.g:5961:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_1_0()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__0__Impl"


    // $ANTLR start "rule__OpCompare__Group_1__1"
    // InternalPureXbase.g:5970:1: rule__OpCompare__Group_1__1 : rule__OpCompare__Group_1__1__Impl ;
    public final void rule__OpCompare__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5974:1: ( rule__OpCompare__Group_1__1__Impl )
            // InternalPureXbase.g:5975:2: rule__OpCompare__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpCompare__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__1"


    // $ANTLR start "rule__OpCompare__Group_1__1__Impl"
    // InternalPureXbase.g:5981:1: rule__OpCompare__Group_1__1__Impl : ( '=' ) ;
    public final void rule__OpCompare__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:5985:1: ( ( '=' ) )
            // InternalPureXbase.g:5986:1: ( '=' )
            {
            // InternalPureXbase.g:5986:1: ( '=' )
            // InternalPureXbase.g:5987:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareAccess().getEqualsSignKeyword_1_1()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareAccess().getEqualsSignKeyword_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__1__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__0"
    // InternalPureXbase.g:5997:1: rule__XOtherOperatorExpression__Group__0 : rule__XOtherOperatorExpression__Group__0__Impl rule__XOtherOperatorExpression__Group__1 ;
    public final void rule__XOtherOperatorExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6001:1: ( rule__XOtherOperatorExpression__Group__0__Impl rule__XOtherOperatorExpression__Group__1 )
            // InternalPureXbase.g:6002:2: rule__XOtherOperatorExpression__Group__0__Impl rule__XOtherOperatorExpression__Group__1
            {
            pushFollow(FOLLOW_32);
            rule__XOtherOperatorExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__0__Impl"
    // InternalPureXbase.g:6009:1: rule__XOtherOperatorExpression__Group__0__Impl : ( ruleXAdditiveExpression ) ;
    public final void rule__XOtherOperatorExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6013:1: ( ( ruleXAdditiveExpression ) )
            // InternalPureXbase.g:6014:1: ( ruleXAdditiveExpression )
            {
            // InternalPureXbase.g:6014:1: ( ruleXAdditiveExpression )
            // InternalPureXbase.g:6015:2: ruleXAdditiveExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getXAdditiveExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getXAdditiveExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__1"
    // InternalPureXbase.g:6024:1: rule__XOtherOperatorExpression__Group__1 : rule__XOtherOperatorExpression__Group__1__Impl ;
    public final void rule__XOtherOperatorExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6028:1: ( rule__XOtherOperatorExpression__Group__1__Impl )
            // InternalPureXbase.g:6029:2: rule__XOtherOperatorExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__1"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__1__Impl"
    // InternalPureXbase.g:6035:1: rule__XOtherOperatorExpression__Group__1__Impl : ( ( rule__XOtherOperatorExpression__Group_1__0 )* ) ;
    public final void rule__XOtherOperatorExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6039:1: ( ( ( rule__XOtherOperatorExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:6040:1: ( ( rule__XOtherOperatorExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:6040:1: ( ( rule__XOtherOperatorExpression__Group_1__0 )* )
            // InternalPureXbase.g:6041:2: ( rule__XOtherOperatorExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:6042:2: ( rule__XOtherOperatorExpression__Group_1__0 )*
            loop63:
            do {
                int alt63=2;
                alt63 = dfa63.predict(input);
                switch (alt63) {
            	case 1 :
            	    // InternalPureXbase.g:6042:3: rule__XOtherOperatorExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_33);
            	    rule__XOtherOperatorExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop63;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__1__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__0"
    // InternalPureXbase.g:6051:1: rule__XOtherOperatorExpression__Group_1__0 : rule__XOtherOperatorExpression__Group_1__0__Impl rule__XOtherOperatorExpression__Group_1__1 ;
    public final void rule__XOtherOperatorExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6055:1: ( rule__XOtherOperatorExpression__Group_1__0__Impl rule__XOtherOperatorExpression__Group_1__1 )
            // InternalPureXbase.g:6056:2: rule__XOtherOperatorExpression__Group_1__0__Impl rule__XOtherOperatorExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XOtherOperatorExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__0__Impl"
    // InternalPureXbase.g:6063:1: rule__XOtherOperatorExpression__Group_1__0__Impl : ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6067:1: ( ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:6068:1: ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:6068:1: ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:6069:2: ( rule__XOtherOperatorExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:6070:2: ( rule__XOtherOperatorExpression__Group_1_0__0 )
            // InternalPureXbase.g:6070:3: rule__XOtherOperatorExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__1"
    // InternalPureXbase.g:6078:1: rule__XOtherOperatorExpression__Group_1__1 : rule__XOtherOperatorExpression__Group_1__1__Impl ;
    public final void rule__XOtherOperatorExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6082:1: ( rule__XOtherOperatorExpression__Group_1__1__Impl )
            // InternalPureXbase.g:6083:2: rule__XOtherOperatorExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__1"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__1__Impl"
    // InternalPureXbase.g:6089:1: rule__XOtherOperatorExpression__Group_1__1__Impl : ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6093:1: ( ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) ) )
            // InternalPureXbase.g:6094:1: ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalPureXbase.g:6094:1: ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) )
            // InternalPureXbase.g:6095:2: ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalPureXbase.g:6096:2: ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 )
            // InternalPureXbase.g:6096:3: rule__XOtherOperatorExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0__0"
    // InternalPureXbase.g:6105:1: rule__XOtherOperatorExpression__Group_1_0__0 : rule__XOtherOperatorExpression__Group_1_0__0__Impl ;
    public final void rule__XOtherOperatorExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6109:1: ( rule__XOtherOperatorExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:6110:2: rule__XOtherOperatorExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:6116:1: rule__XOtherOperatorExpression__Group_1_0__0__Impl : ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6120:1: ( ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:6121:1: ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:6121:1: ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:6122:2: ( rule__XOtherOperatorExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:6123:2: ( rule__XOtherOperatorExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:6123:3: rule__XOtherOperatorExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__0"
    // InternalPureXbase.g:6132:1: rule__XOtherOperatorExpression__Group_1_0_0__0 : rule__XOtherOperatorExpression__Group_1_0_0__0__Impl rule__XOtherOperatorExpression__Group_1_0_0__1 ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6136:1: ( rule__XOtherOperatorExpression__Group_1_0_0__0__Impl rule__XOtherOperatorExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:6137:2: rule__XOtherOperatorExpression__Group_1_0_0__0__Impl rule__XOtherOperatorExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_32);
            rule__XOtherOperatorExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:6144:1: rule__XOtherOperatorExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6148:1: ( ( () ) )
            // InternalPureXbase.g:6149:1: ( () )
            {
            // InternalPureXbase.g:6149:1: ( () )
            // InternalPureXbase.g:6150:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:6151:2: ()
            // InternalPureXbase.g:6151:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__1"
    // InternalPureXbase.g:6159:1: rule__XOtherOperatorExpression__Group_1_0_0__1 : rule__XOtherOperatorExpression__Group_1_0_0__1__Impl ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6163:1: ( rule__XOtherOperatorExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:6164:2: rule__XOtherOperatorExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:6170:1: rule__XOtherOperatorExpression__Group_1_0_0__1__Impl : ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6174:1: ( ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:6175:1: ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:6175:1: ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:6176:2: ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:6177:2: ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 )
            // InternalPureXbase.g:6177:3: rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__OpOther__Group_2__0"
    // InternalPureXbase.g:6186:1: rule__OpOther__Group_2__0 : rule__OpOther__Group_2__0__Impl rule__OpOther__Group_2__1 ;
    public final void rule__OpOther__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6190:1: ( rule__OpOther__Group_2__0__Impl rule__OpOther__Group_2__1 )
            // InternalPureXbase.g:6191:2: rule__OpOther__Group_2__0__Impl rule__OpOther__Group_2__1
            {
            pushFollow(FOLLOW_34);
            rule__OpOther__Group_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__0"


    // $ANTLR start "rule__OpOther__Group_2__0__Impl"
    // InternalPureXbase.g:6198:1: rule__OpOther__Group_2__0__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6202:1: ( ( '>' ) )
            // InternalPureXbase.g:6203:1: ( '>' )
            {
            // InternalPureXbase.g:6203:1: ( '>' )
            // InternalPureXbase.g:6204:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_2_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__0__Impl"


    // $ANTLR start "rule__OpOther__Group_2__1"
    // InternalPureXbase.g:6213:1: rule__OpOther__Group_2__1 : rule__OpOther__Group_2__1__Impl ;
    public final void rule__OpOther__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6217:1: ( rule__OpOther__Group_2__1__Impl )
            // InternalPureXbase.g:6218:2: rule__OpOther__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__1"


    // $ANTLR start "rule__OpOther__Group_2__1__Impl"
    // InternalPureXbase.g:6224:1: rule__OpOther__Group_2__1__Impl : ( '..' ) ;
    public final void rule__OpOther__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6228:1: ( ( '..' ) )
            // InternalPureXbase.g:6229:1: ( '..' )
            {
            // InternalPureXbase.g:6229:1: ( '..' )
            // InternalPureXbase.g:6230:2: '..'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_2_1()); 
            }
            match(input,31,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__1__Impl"


    // $ANTLR start "rule__OpOther__Group_5__0"
    // InternalPureXbase.g:6240:1: rule__OpOther__Group_5__0 : rule__OpOther__Group_5__0__Impl rule__OpOther__Group_5__1 ;
    public final void rule__OpOther__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6244:1: ( rule__OpOther__Group_5__0__Impl rule__OpOther__Group_5__1 )
            // InternalPureXbase.g:6245:2: rule__OpOther__Group_5__0__Impl rule__OpOther__Group_5__1
            {
            pushFollow(FOLLOW_35);
            rule__OpOther__Group_5__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__0"


    // $ANTLR start "rule__OpOther__Group_5__0__Impl"
    // InternalPureXbase.g:6252:1: rule__OpOther__Group_5__0__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6256:1: ( ( '>' ) )
            // InternalPureXbase.g:6257:1: ( '>' )
            {
            // InternalPureXbase.g:6257:1: ( '>' )
            // InternalPureXbase.g:6258:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__0__Impl"


    // $ANTLR start "rule__OpOther__Group_5__1"
    // InternalPureXbase.g:6267:1: rule__OpOther__Group_5__1 : rule__OpOther__Group_5__1__Impl ;
    public final void rule__OpOther__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6271:1: ( rule__OpOther__Group_5__1__Impl )
            // InternalPureXbase.g:6272:2: rule__OpOther__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__1"


    // $ANTLR start "rule__OpOther__Group_5__1__Impl"
    // InternalPureXbase.g:6278:1: rule__OpOther__Group_5__1__Impl : ( ( rule__OpOther__Alternatives_5_1 ) ) ;
    public final void rule__OpOther__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6282:1: ( ( ( rule__OpOther__Alternatives_5_1 ) ) )
            // InternalPureXbase.g:6283:1: ( ( rule__OpOther__Alternatives_5_1 ) )
            {
            // InternalPureXbase.g:6283:1: ( ( rule__OpOther__Alternatives_5_1 ) )
            // InternalPureXbase.g:6284:2: ( rule__OpOther__Alternatives_5_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getAlternatives_5_1()); 
            }
            // InternalPureXbase.g:6285:2: ( rule__OpOther__Alternatives_5_1 )
            // InternalPureXbase.g:6285:3: rule__OpOther__Alternatives_5_1
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Alternatives_5_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getAlternatives_5_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__1__Impl"


    // $ANTLR start "rule__OpOther__Group_5_1_0__0"
    // InternalPureXbase.g:6294:1: rule__OpOther__Group_5_1_0__0 : rule__OpOther__Group_5_1_0__0__Impl ;
    public final void rule__OpOther__Group_5_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6298:1: ( rule__OpOther__Group_5_1_0__0__Impl )
            // InternalPureXbase.g:6299:2: rule__OpOther__Group_5_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0__0"


    // $ANTLR start "rule__OpOther__Group_5_1_0__0__Impl"
    // InternalPureXbase.g:6305:1: rule__OpOther__Group_5_1_0__0__Impl : ( ( rule__OpOther__Group_5_1_0_0__0 ) ) ;
    public final void rule__OpOther__Group_5_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6309:1: ( ( ( rule__OpOther__Group_5_1_0_0__0 ) ) )
            // InternalPureXbase.g:6310:1: ( ( rule__OpOther__Group_5_1_0_0__0 ) )
            {
            // InternalPureXbase.g:6310:1: ( ( rule__OpOther__Group_5_1_0_0__0 ) )
            // InternalPureXbase.g:6311:2: ( rule__OpOther__Group_5_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGroup_5_1_0_0()); 
            }
            // InternalPureXbase.g:6312:2: ( rule__OpOther__Group_5_1_0_0__0 )
            // InternalPureXbase.g:6312:3: rule__OpOther__Group_5_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGroup_5_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__0"
    // InternalPureXbase.g:6321:1: rule__OpOther__Group_5_1_0_0__0 : rule__OpOther__Group_5_1_0_0__0__Impl rule__OpOther__Group_5_1_0_0__1 ;
    public final void rule__OpOther__Group_5_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6325:1: ( rule__OpOther__Group_5_1_0_0__0__Impl rule__OpOther__Group_5_1_0_0__1 )
            // InternalPureXbase.g:6326:2: rule__OpOther__Group_5_1_0_0__0__Impl rule__OpOther__Group_5_1_0_0__1
            {
            pushFollow(FOLLOW_35);
            rule__OpOther__Group_5_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__0"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__0__Impl"
    // InternalPureXbase.g:6333:1: rule__OpOther__Group_5_1_0_0__0__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_5_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6337:1: ( ( '>' ) )
            // InternalPureXbase.g:6338:1: ( '>' )
            {
            // InternalPureXbase.g:6338:1: ( '>' )
            // InternalPureXbase.g:6339:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__1"
    // InternalPureXbase.g:6348:1: rule__OpOther__Group_5_1_0_0__1 : rule__OpOther__Group_5_1_0_0__1__Impl ;
    public final void rule__OpOther__Group_5_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6352:1: ( rule__OpOther__Group_5_1_0_0__1__Impl )
            // InternalPureXbase.g:6353:2: rule__OpOther__Group_5_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__1"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__1__Impl"
    // InternalPureXbase.g:6359:1: rule__OpOther__Group_5_1_0_0__1__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_5_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6363:1: ( ( '>' ) )
            // InternalPureXbase.g:6364:1: ( '>' )
            {
            // InternalPureXbase.g:6364:1: ( '>' )
            // InternalPureXbase.g:6365:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_1()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__1__Impl"


    // $ANTLR start "rule__OpOther__Group_6__0"
    // InternalPureXbase.g:6375:1: rule__OpOther__Group_6__0 : rule__OpOther__Group_6__0__Impl rule__OpOther__Group_6__1 ;
    public final void rule__OpOther__Group_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6379:1: ( rule__OpOther__Group_6__0__Impl rule__OpOther__Group_6__1 )
            // InternalPureXbase.g:6380:2: rule__OpOther__Group_6__0__Impl rule__OpOther__Group_6__1
            {
            pushFollow(FOLLOW_36);
            rule__OpOther__Group_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__0"


    // $ANTLR start "rule__OpOther__Group_6__0__Impl"
    // InternalPureXbase.g:6387:1: rule__OpOther__Group_6__0__Impl : ( '<' ) ;
    public final void rule__OpOther__Group_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6391:1: ( ( '<' ) )
            // InternalPureXbase.g:6392:1: ( '<' )
            {
            // InternalPureXbase.g:6392:1: ( '<' )
            // InternalPureXbase.g:6393:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_0()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__0__Impl"


    // $ANTLR start "rule__OpOther__Group_6__1"
    // InternalPureXbase.g:6402:1: rule__OpOther__Group_6__1 : rule__OpOther__Group_6__1__Impl ;
    public final void rule__OpOther__Group_6__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6406:1: ( rule__OpOther__Group_6__1__Impl )
            // InternalPureXbase.g:6407:2: rule__OpOther__Group_6__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__1"


    // $ANTLR start "rule__OpOther__Group_6__1__Impl"
    // InternalPureXbase.g:6413:1: rule__OpOther__Group_6__1__Impl : ( ( rule__OpOther__Alternatives_6_1 ) ) ;
    public final void rule__OpOther__Group_6__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6417:1: ( ( ( rule__OpOther__Alternatives_6_1 ) ) )
            // InternalPureXbase.g:6418:1: ( ( rule__OpOther__Alternatives_6_1 ) )
            {
            // InternalPureXbase.g:6418:1: ( ( rule__OpOther__Alternatives_6_1 ) )
            // InternalPureXbase.g:6419:2: ( rule__OpOther__Alternatives_6_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getAlternatives_6_1()); 
            }
            // InternalPureXbase.g:6420:2: ( rule__OpOther__Alternatives_6_1 )
            // InternalPureXbase.g:6420:3: rule__OpOther__Alternatives_6_1
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Alternatives_6_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getAlternatives_6_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__1__Impl"


    // $ANTLR start "rule__OpOther__Group_6_1_0__0"
    // InternalPureXbase.g:6429:1: rule__OpOther__Group_6_1_0__0 : rule__OpOther__Group_6_1_0__0__Impl ;
    public final void rule__OpOther__Group_6_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6433:1: ( rule__OpOther__Group_6_1_0__0__Impl )
            // InternalPureXbase.g:6434:2: rule__OpOther__Group_6_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0__0"


    // $ANTLR start "rule__OpOther__Group_6_1_0__0__Impl"
    // InternalPureXbase.g:6440:1: rule__OpOther__Group_6_1_0__0__Impl : ( ( rule__OpOther__Group_6_1_0_0__0 ) ) ;
    public final void rule__OpOther__Group_6_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6444:1: ( ( ( rule__OpOther__Group_6_1_0_0__0 ) ) )
            // InternalPureXbase.g:6445:1: ( ( rule__OpOther__Group_6_1_0_0__0 ) )
            {
            // InternalPureXbase.g:6445:1: ( ( rule__OpOther__Group_6_1_0_0__0 ) )
            // InternalPureXbase.g:6446:2: ( rule__OpOther__Group_6_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGroup_6_1_0_0()); 
            }
            // InternalPureXbase.g:6447:2: ( rule__OpOther__Group_6_1_0_0__0 )
            // InternalPureXbase.g:6447:3: rule__OpOther__Group_6_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGroup_6_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__0"
    // InternalPureXbase.g:6456:1: rule__OpOther__Group_6_1_0_0__0 : rule__OpOther__Group_6_1_0_0__0__Impl rule__OpOther__Group_6_1_0_0__1 ;
    public final void rule__OpOther__Group_6_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6460:1: ( rule__OpOther__Group_6_1_0_0__0__Impl rule__OpOther__Group_6_1_0_0__1 )
            // InternalPureXbase.g:6461:2: rule__OpOther__Group_6_1_0_0__0__Impl rule__OpOther__Group_6_1_0_0__1
            {
            pushFollow(FOLLOW_21);
            rule__OpOther__Group_6_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__0"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__0__Impl"
    // InternalPureXbase.g:6468:1: rule__OpOther__Group_6_1_0_0__0__Impl : ( '<' ) ;
    public final void rule__OpOther__Group_6_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6472:1: ( ( '<' ) )
            // InternalPureXbase.g:6473:1: ( '<' )
            {
            // InternalPureXbase.g:6473:1: ( '<' )
            // InternalPureXbase.g:6474:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_0()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__1"
    // InternalPureXbase.g:6483:1: rule__OpOther__Group_6_1_0_0__1 : rule__OpOther__Group_6_1_0_0__1__Impl ;
    public final void rule__OpOther__Group_6_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6487:1: ( rule__OpOther__Group_6_1_0_0__1__Impl )
            // InternalPureXbase.g:6488:2: rule__OpOther__Group_6_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__1"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__1__Impl"
    // InternalPureXbase.g:6494:1: rule__OpOther__Group_6_1_0_0__1__Impl : ( '<' ) ;
    public final void rule__OpOther__Group_6_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6498:1: ( ( '<' ) )
            // InternalPureXbase.g:6499:1: ( '<' )
            {
            // InternalPureXbase.g:6499:1: ( '<' )
            // InternalPureXbase.g:6500:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_1()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__1__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group__0"
    // InternalPureXbase.g:6510:1: rule__XAdditiveExpression__Group__0 : rule__XAdditiveExpression__Group__0__Impl rule__XAdditiveExpression__Group__1 ;
    public final void rule__XAdditiveExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6514:1: ( rule__XAdditiveExpression__Group__0__Impl rule__XAdditiveExpression__Group__1 )
            // InternalPureXbase.g:6515:2: rule__XAdditiveExpression__Group__0__Impl rule__XAdditiveExpression__Group__1
            {
            pushFollow(FOLLOW_37);
            rule__XAdditiveExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__0"


    // $ANTLR start "rule__XAdditiveExpression__Group__0__Impl"
    // InternalPureXbase.g:6522:1: rule__XAdditiveExpression__Group__0__Impl : ( ruleXMultiplicativeExpression ) ;
    public final void rule__XAdditiveExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6526:1: ( ( ruleXMultiplicativeExpression ) )
            // InternalPureXbase.g:6527:1: ( ruleXMultiplicativeExpression )
            {
            // InternalPureXbase.g:6527:1: ( ruleXMultiplicativeExpression )
            // InternalPureXbase.g:6528:2: ruleXMultiplicativeExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getXMultiplicativeExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getXMultiplicativeExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group__1"
    // InternalPureXbase.g:6537:1: rule__XAdditiveExpression__Group__1 : rule__XAdditiveExpression__Group__1__Impl ;
    public final void rule__XAdditiveExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6541:1: ( rule__XAdditiveExpression__Group__1__Impl )
            // InternalPureXbase.g:6542:2: rule__XAdditiveExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__1"


    // $ANTLR start "rule__XAdditiveExpression__Group__1__Impl"
    // InternalPureXbase.g:6548:1: rule__XAdditiveExpression__Group__1__Impl : ( ( rule__XAdditiveExpression__Group_1__0 )* ) ;
    public final void rule__XAdditiveExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6552:1: ( ( ( rule__XAdditiveExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:6553:1: ( ( rule__XAdditiveExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:6553:1: ( ( rule__XAdditiveExpression__Group_1__0 )* )
            // InternalPureXbase.g:6554:2: ( rule__XAdditiveExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:6555:2: ( rule__XAdditiveExpression__Group_1__0 )*
            loop64:
            do {
                int alt64=2;
                int LA64_0 = input.LA(1);

                if ( (LA64_0==36) ) {
                    int LA64_2 = input.LA(2);

                    if ( (synpred104_InternalPureXbase()) ) {
                        alt64=1;
                    }


                }
                else if ( (LA64_0==35) ) {
                    int LA64_3 = input.LA(2);

                    if ( (synpred104_InternalPureXbase()) ) {
                        alt64=1;
                    }


                }


                switch (alt64) {
            	case 1 :
            	    // InternalPureXbase.g:6555:3: rule__XAdditiveExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_38);
            	    rule__XAdditiveExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop64;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__1__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__0"
    // InternalPureXbase.g:6564:1: rule__XAdditiveExpression__Group_1__0 : rule__XAdditiveExpression__Group_1__0__Impl rule__XAdditiveExpression__Group_1__1 ;
    public final void rule__XAdditiveExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6568:1: ( rule__XAdditiveExpression__Group_1__0__Impl rule__XAdditiveExpression__Group_1__1 )
            // InternalPureXbase.g:6569:2: rule__XAdditiveExpression__Group_1__0__Impl rule__XAdditiveExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XAdditiveExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__0"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__0__Impl"
    // InternalPureXbase.g:6576:1: rule__XAdditiveExpression__Group_1__0__Impl : ( ( rule__XAdditiveExpression__Group_1_0__0 ) ) ;
    public final void rule__XAdditiveExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6580:1: ( ( ( rule__XAdditiveExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:6581:1: ( ( rule__XAdditiveExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:6581:1: ( ( rule__XAdditiveExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:6582:2: ( rule__XAdditiveExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:6583:2: ( rule__XAdditiveExpression__Group_1_0__0 )
            // InternalPureXbase.g:6583:3: rule__XAdditiveExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__1"
    // InternalPureXbase.g:6591:1: rule__XAdditiveExpression__Group_1__1 : rule__XAdditiveExpression__Group_1__1__Impl ;
    public final void rule__XAdditiveExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6595:1: ( rule__XAdditiveExpression__Group_1__1__Impl )
            // InternalPureXbase.g:6596:2: rule__XAdditiveExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__1"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__1__Impl"
    // InternalPureXbase.g:6602:1: rule__XAdditiveExpression__Group_1__1__Impl : ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XAdditiveExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6606:1: ( ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) ) )
            // InternalPureXbase.g:6607:1: ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalPureXbase.g:6607:1: ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) )
            // InternalPureXbase.g:6608:2: ( rule__XAdditiveExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalPureXbase.g:6609:2: ( rule__XAdditiveExpression__RightOperandAssignment_1_1 )
            // InternalPureXbase.g:6609:3: rule__XAdditiveExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0__0"
    // InternalPureXbase.g:6618:1: rule__XAdditiveExpression__Group_1_0__0 : rule__XAdditiveExpression__Group_1_0__0__Impl ;
    public final void rule__XAdditiveExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6622:1: ( rule__XAdditiveExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:6623:2: rule__XAdditiveExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0__0"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:6629:1: rule__XAdditiveExpression__Group_1_0__0__Impl : ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XAdditiveExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6633:1: ( ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:6634:1: ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:6634:1: ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:6635:2: ( rule__XAdditiveExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:6636:2: ( rule__XAdditiveExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:6636:3: rule__XAdditiveExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__0"
    // InternalPureXbase.g:6645:1: rule__XAdditiveExpression__Group_1_0_0__0 : rule__XAdditiveExpression__Group_1_0_0__0__Impl rule__XAdditiveExpression__Group_1_0_0__1 ;
    public final void rule__XAdditiveExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6649:1: ( rule__XAdditiveExpression__Group_1_0_0__0__Impl rule__XAdditiveExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:6650:2: rule__XAdditiveExpression__Group_1_0_0__0__Impl rule__XAdditiveExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_37);
            rule__XAdditiveExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:6657:1: rule__XAdditiveExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XAdditiveExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6661:1: ( ( () ) )
            // InternalPureXbase.g:6662:1: ( () )
            {
            // InternalPureXbase.g:6662:1: ( () )
            // InternalPureXbase.g:6663:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:6664:2: ()
            // InternalPureXbase.g:6664:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__1"
    // InternalPureXbase.g:6672:1: rule__XAdditiveExpression__Group_1_0_0__1 : rule__XAdditiveExpression__Group_1_0_0__1__Impl ;
    public final void rule__XAdditiveExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6676:1: ( rule__XAdditiveExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:6677:2: rule__XAdditiveExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:6683:1: rule__XAdditiveExpression__Group_1_0_0__1__Impl : ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XAdditiveExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6687:1: ( ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:6688:1: ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:6688:1: ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:6689:2: ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:6690:2: ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 )
            // InternalPureXbase.g:6690:3: rule__XAdditiveExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__0"
    // InternalPureXbase.g:6699:1: rule__XMultiplicativeExpression__Group__0 : rule__XMultiplicativeExpression__Group__0__Impl rule__XMultiplicativeExpression__Group__1 ;
    public final void rule__XMultiplicativeExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6703:1: ( rule__XMultiplicativeExpression__Group__0__Impl rule__XMultiplicativeExpression__Group__1 )
            // InternalPureXbase.g:6704:2: rule__XMultiplicativeExpression__Group__0__Impl rule__XMultiplicativeExpression__Group__1
            {
            pushFollow(FOLLOW_39);
            rule__XMultiplicativeExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__0__Impl"
    // InternalPureXbase.g:6711:1: rule__XMultiplicativeExpression__Group__0__Impl : ( ruleXUnaryOperation ) ;
    public final void rule__XMultiplicativeExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6715:1: ( ( ruleXUnaryOperation ) )
            // InternalPureXbase.g:6716:1: ( ruleXUnaryOperation )
            {
            // InternalPureXbase.g:6716:1: ( ruleXUnaryOperation )
            // InternalPureXbase.g:6717:2: ruleXUnaryOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getXUnaryOperationParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getXUnaryOperationParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__1"
    // InternalPureXbase.g:6726:1: rule__XMultiplicativeExpression__Group__1 : rule__XMultiplicativeExpression__Group__1__Impl ;
    public final void rule__XMultiplicativeExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6730:1: ( rule__XMultiplicativeExpression__Group__1__Impl )
            // InternalPureXbase.g:6731:2: rule__XMultiplicativeExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__1"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__1__Impl"
    // InternalPureXbase.g:6737:1: rule__XMultiplicativeExpression__Group__1__Impl : ( ( rule__XMultiplicativeExpression__Group_1__0 )* ) ;
    public final void rule__XMultiplicativeExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6741:1: ( ( ( rule__XMultiplicativeExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:6742:1: ( ( rule__XMultiplicativeExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:6742:1: ( ( rule__XMultiplicativeExpression__Group_1__0 )* )
            // InternalPureXbase.g:6743:2: ( rule__XMultiplicativeExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:6744:2: ( rule__XMultiplicativeExpression__Group_1__0 )*
            loop65:
            do {
                int alt65=2;
                switch ( input.LA(1) ) {
                case 37:
                    {
                    int LA65_2 = input.LA(2);

                    if ( (synpred105_InternalPureXbase()) ) {
                        alt65=1;
                    }


                    }
                    break;
                case 38:
                    {
                    int LA65_3 = input.LA(2);

                    if ( (synpred105_InternalPureXbase()) ) {
                        alt65=1;
                    }


                    }
                    break;
                case 39:
                    {
                    int LA65_4 = input.LA(2);

                    if ( (synpred105_InternalPureXbase()) ) {
                        alt65=1;
                    }


                    }
                    break;
                case 40:
                    {
                    int LA65_5 = input.LA(2);

                    if ( (synpred105_InternalPureXbase()) ) {
                        alt65=1;
                    }


                    }
                    break;

                }

                switch (alt65) {
            	case 1 :
            	    // InternalPureXbase.g:6744:3: rule__XMultiplicativeExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_40);
            	    rule__XMultiplicativeExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop65;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__1__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__0"
    // InternalPureXbase.g:6753:1: rule__XMultiplicativeExpression__Group_1__0 : rule__XMultiplicativeExpression__Group_1__0__Impl rule__XMultiplicativeExpression__Group_1__1 ;
    public final void rule__XMultiplicativeExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6757:1: ( rule__XMultiplicativeExpression__Group_1__0__Impl rule__XMultiplicativeExpression__Group_1__1 )
            // InternalPureXbase.g:6758:2: rule__XMultiplicativeExpression__Group_1__0__Impl rule__XMultiplicativeExpression__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XMultiplicativeExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__0__Impl"
    // InternalPureXbase.g:6765:1: rule__XMultiplicativeExpression__Group_1__0__Impl : ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6769:1: ( ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:6770:1: ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:6770:1: ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:6771:2: ( rule__XMultiplicativeExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:6772:2: ( rule__XMultiplicativeExpression__Group_1_0__0 )
            // InternalPureXbase.g:6772:3: rule__XMultiplicativeExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__1"
    // InternalPureXbase.g:6780:1: rule__XMultiplicativeExpression__Group_1__1 : rule__XMultiplicativeExpression__Group_1__1__Impl ;
    public final void rule__XMultiplicativeExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6784:1: ( rule__XMultiplicativeExpression__Group_1__1__Impl )
            // InternalPureXbase.g:6785:2: rule__XMultiplicativeExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__1"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__1__Impl"
    // InternalPureXbase.g:6791:1: rule__XMultiplicativeExpression__Group_1__1__Impl : ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6795:1: ( ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) ) )
            // InternalPureXbase.g:6796:1: ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalPureXbase.g:6796:1: ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) )
            // InternalPureXbase.g:6797:2: ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalPureXbase.g:6798:2: ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 )
            // InternalPureXbase.g:6798:3: rule__XMultiplicativeExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0__0"
    // InternalPureXbase.g:6807:1: rule__XMultiplicativeExpression__Group_1_0__0 : rule__XMultiplicativeExpression__Group_1_0__0__Impl ;
    public final void rule__XMultiplicativeExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6811:1: ( rule__XMultiplicativeExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:6812:2: rule__XMultiplicativeExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:6818:1: rule__XMultiplicativeExpression__Group_1_0__0__Impl : ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6822:1: ( ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:6823:1: ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:6823:1: ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:6824:2: ( rule__XMultiplicativeExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:6825:2: ( rule__XMultiplicativeExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:6825:3: rule__XMultiplicativeExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__0"
    // InternalPureXbase.g:6834:1: rule__XMultiplicativeExpression__Group_1_0_0__0 : rule__XMultiplicativeExpression__Group_1_0_0__0__Impl rule__XMultiplicativeExpression__Group_1_0_0__1 ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6838:1: ( rule__XMultiplicativeExpression__Group_1_0_0__0__Impl rule__XMultiplicativeExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:6839:2: rule__XMultiplicativeExpression__Group_1_0_0__0__Impl rule__XMultiplicativeExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_39);
            rule__XMultiplicativeExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:6846:1: rule__XMultiplicativeExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6850:1: ( ( () ) )
            // InternalPureXbase.g:6851:1: ( () )
            {
            // InternalPureXbase.g:6851:1: ( () )
            // InternalPureXbase.g:6852:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:6853:2: ()
            // InternalPureXbase.g:6853:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__1"
    // InternalPureXbase.g:6861:1: rule__XMultiplicativeExpression__Group_1_0_0__1 : rule__XMultiplicativeExpression__Group_1_0_0__1__Impl ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6865:1: ( rule__XMultiplicativeExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:6866:2: rule__XMultiplicativeExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:6872:1: rule__XMultiplicativeExpression__Group_1_0_0__1__Impl : ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6876:1: ( ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalPureXbase.g:6877:1: ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalPureXbase.g:6877:1: ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalPureXbase.g:6878:2: ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalPureXbase.g:6879:2: ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 )
            // InternalPureXbase.g:6879:3: rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XUnaryOperation__Group_0__0"
    // InternalPureXbase.g:6888:1: rule__XUnaryOperation__Group_0__0 : rule__XUnaryOperation__Group_0__0__Impl rule__XUnaryOperation__Group_0__1 ;
    public final void rule__XUnaryOperation__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6892:1: ( rule__XUnaryOperation__Group_0__0__Impl rule__XUnaryOperation__Group_0__1 )
            // InternalPureXbase.g:6893:2: rule__XUnaryOperation__Group_0__0__Impl rule__XUnaryOperation__Group_0__1
            {
            pushFollow(FOLLOW_41);
            rule__XUnaryOperation__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__0"


    // $ANTLR start "rule__XUnaryOperation__Group_0__0__Impl"
    // InternalPureXbase.g:6900:1: rule__XUnaryOperation__Group_0__0__Impl : ( () ) ;
    public final void rule__XUnaryOperation__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6904:1: ( ( () ) )
            // InternalPureXbase.g:6905:1: ( () )
            {
            // InternalPureXbase.g:6905:1: ( () )
            // InternalPureXbase.g:6906:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getXUnaryOperationAction_0_0()); 
            }
            // InternalPureXbase.g:6907:2: ()
            // InternalPureXbase.g:6907:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getXUnaryOperationAction_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__0__Impl"


    // $ANTLR start "rule__XUnaryOperation__Group_0__1"
    // InternalPureXbase.g:6915:1: rule__XUnaryOperation__Group_0__1 : rule__XUnaryOperation__Group_0__1__Impl rule__XUnaryOperation__Group_0__2 ;
    public final void rule__XUnaryOperation__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6919:1: ( rule__XUnaryOperation__Group_0__1__Impl rule__XUnaryOperation__Group_0__2 )
            // InternalPureXbase.g:6920:2: rule__XUnaryOperation__Group_0__1__Impl rule__XUnaryOperation__Group_0__2
            {
            pushFollow(FOLLOW_5);
            rule__XUnaryOperation__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__1"


    // $ANTLR start "rule__XUnaryOperation__Group_0__1__Impl"
    // InternalPureXbase.g:6927:1: rule__XUnaryOperation__Group_0__1__Impl : ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) ) ;
    public final void rule__XUnaryOperation__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6931:1: ( ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) ) )
            // InternalPureXbase.g:6932:1: ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) )
            {
            // InternalPureXbase.g:6932:1: ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) )
            // InternalPureXbase.g:6933:2: ( rule__XUnaryOperation__FeatureAssignment_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getFeatureAssignment_0_1()); 
            }
            // InternalPureXbase.g:6934:2: ( rule__XUnaryOperation__FeatureAssignment_0_1 )
            // InternalPureXbase.g:6934:3: rule__XUnaryOperation__FeatureAssignment_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__FeatureAssignment_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getFeatureAssignment_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__1__Impl"


    // $ANTLR start "rule__XUnaryOperation__Group_0__2"
    // InternalPureXbase.g:6942:1: rule__XUnaryOperation__Group_0__2 : rule__XUnaryOperation__Group_0__2__Impl ;
    public final void rule__XUnaryOperation__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6946:1: ( rule__XUnaryOperation__Group_0__2__Impl )
            // InternalPureXbase.g:6947:2: rule__XUnaryOperation__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__2"


    // $ANTLR start "rule__XUnaryOperation__Group_0__2__Impl"
    // InternalPureXbase.g:6953:1: rule__XUnaryOperation__Group_0__2__Impl : ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) ) ;
    public final void rule__XUnaryOperation__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6957:1: ( ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) ) )
            // InternalPureXbase.g:6958:1: ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) )
            {
            // InternalPureXbase.g:6958:1: ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) )
            // InternalPureXbase.g:6959:2: ( rule__XUnaryOperation__OperandAssignment_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getOperandAssignment_0_2()); 
            }
            // InternalPureXbase.g:6960:2: ( rule__XUnaryOperation__OperandAssignment_0_2 )
            // InternalPureXbase.g:6960:3: rule__XUnaryOperation__OperandAssignment_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__OperandAssignment_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getOperandAssignment_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__2__Impl"


    // $ANTLR start "rule__XCastedExpression__Group__0"
    // InternalPureXbase.g:6969:1: rule__XCastedExpression__Group__0 : rule__XCastedExpression__Group__0__Impl rule__XCastedExpression__Group__1 ;
    public final void rule__XCastedExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6973:1: ( rule__XCastedExpression__Group__0__Impl rule__XCastedExpression__Group__1 )
            // InternalPureXbase.g:6974:2: rule__XCastedExpression__Group__0__Impl rule__XCastedExpression__Group__1
            {
            pushFollow(FOLLOW_42);
            rule__XCastedExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__0"


    // $ANTLR start "rule__XCastedExpression__Group__0__Impl"
    // InternalPureXbase.g:6981:1: rule__XCastedExpression__Group__0__Impl : ( ruleXPostfixOperation ) ;
    public final void rule__XCastedExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:6985:1: ( ( ruleXPostfixOperation ) )
            // InternalPureXbase.g:6986:1: ( ruleXPostfixOperation )
            {
            // InternalPureXbase.g:6986:1: ( ruleXPostfixOperation )
            // InternalPureXbase.g:6987:2: ruleXPostfixOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getXPostfixOperationParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXPostfixOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getXPostfixOperationParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group__1"
    // InternalPureXbase.g:6996:1: rule__XCastedExpression__Group__1 : rule__XCastedExpression__Group__1__Impl ;
    public final void rule__XCastedExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7000:1: ( rule__XCastedExpression__Group__1__Impl )
            // InternalPureXbase.g:7001:2: rule__XCastedExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__1"


    // $ANTLR start "rule__XCastedExpression__Group__1__Impl"
    // InternalPureXbase.g:7007:1: rule__XCastedExpression__Group__1__Impl : ( ( rule__XCastedExpression__Group_1__0 )* ) ;
    public final void rule__XCastedExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7011:1: ( ( ( rule__XCastedExpression__Group_1__0 )* ) )
            // InternalPureXbase.g:7012:1: ( ( rule__XCastedExpression__Group_1__0 )* )
            {
            // InternalPureXbase.g:7012:1: ( ( rule__XCastedExpression__Group_1__0 )* )
            // InternalPureXbase.g:7013:2: ( rule__XCastedExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:7014:2: ( rule__XCastedExpression__Group_1__0 )*
            loop66:
            do {
                int alt66=2;
                int LA66_0 = input.LA(1);

                if ( (LA66_0==54) ) {
                    int LA66_2 = input.LA(2);

                    if ( (synpred106_InternalPureXbase()) ) {
                        alt66=1;
                    }


                }


                switch (alt66) {
            	case 1 :
            	    // InternalPureXbase.g:7014:3: rule__XCastedExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_43);
            	    rule__XCastedExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop66;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__1__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1__0"
    // InternalPureXbase.g:7023:1: rule__XCastedExpression__Group_1__0 : rule__XCastedExpression__Group_1__0__Impl rule__XCastedExpression__Group_1__1 ;
    public final void rule__XCastedExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7027:1: ( rule__XCastedExpression__Group_1__0__Impl rule__XCastedExpression__Group_1__1 )
            // InternalPureXbase.g:7028:2: rule__XCastedExpression__Group_1__0__Impl rule__XCastedExpression__Group_1__1
            {
            pushFollow(FOLLOW_15);
            rule__XCastedExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__0"


    // $ANTLR start "rule__XCastedExpression__Group_1__0__Impl"
    // InternalPureXbase.g:7035:1: rule__XCastedExpression__Group_1__0__Impl : ( ( rule__XCastedExpression__Group_1_0__0 ) ) ;
    public final void rule__XCastedExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7039:1: ( ( ( rule__XCastedExpression__Group_1_0__0 ) ) )
            // InternalPureXbase.g:7040:1: ( ( rule__XCastedExpression__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:7040:1: ( ( rule__XCastedExpression__Group_1_0__0 ) )
            // InternalPureXbase.g:7041:2: ( rule__XCastedExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:7042:2: ( rule__XCastedExpression__Group_1_0__0 )
            // InternalPureXbase.g:7042:3: rule__XCastedExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1__1"
    // InternalPureXbase.g:7050:1: rule__XCastedExpression__Group_1__1 : rule__XCastedExpression__Group_1__1__Impl ;
    public final void rule__XCastedExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7054:1: ( rule__XCastedExpression__Group_1__1__Impl )
            // InternalPureXbase.g:7055:2: rule__XCastedExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__1"


    // $ANTLR start "rule__XCastedExpression__Group_1__1__Impl"
    // InternalPureXbase.g:7061:1: rule__XCastedExpression__Group_1__1__Impl : ( ( rule__XCastedExpression__TypeAssignment_1_1 ) ) ;
    public final void rule__XCastedExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7065:1: ( ( ( rule__XCastedExpression__TypeAssignment_1_1 ) ) )
            // InternalPureXbase.g:7066:1: ( ( rule__XCastedExpression__TypeAssignment_1_1 ) )
            {
            // InternalPureXbase.g:7066:1: ( ( rule__XCastedExpression__TypeAssignment_1_1 ) )
            // InternalPureXbase.g:7067:2: ( rule__XCastedExpression__TypeAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getTypeAssignment_1_1()); 
            }
            // InternalPureXbase.g:7068:2: ( rule__XCastedExpression__TypeAssignment_1_1 )
            // InternalPureXbase.g:7068:3: rule__XCastedExpression__TypeAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__TypeAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getTypeAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1_0__0"
    // InternalPureXbase.g:7077:1: rule__XCastedExpression__Group_1_0__0 : rule__XCastedExpression__Group_1_0__0__Impl ;
    public final void rule__XCastedExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7081:1: ( rule__XCastedExpression__Group_1_0__0__Impl )
            // InternalPureXbase.g:7082:2: rule__XCastedExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0__0"


    // $ANTLR start "rule__XCastedExpression__Group_1_0__0__Impl"
    // InternalPureXbase.g:7088:1: rule__XCastedExpression__Group_1_0__0__Impl : ( ( rule__XCastedExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XCastedExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7092:1: ( ( ( rule__XCastedExpression__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:7093:1: ( ( rule__XCastedExpression__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:7093:1: ( ( rule__XCastedExpression__Group_1_0_0__0 ) )
            // InternalPureXbase.g:7094:2: ( rule__XCastedExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:7095:2: ( rule__XCastedExpression__Group_1_0_0__0 )
            // InternalPureXbase.g:7095:3: rule__XCastedExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__0"
    // InternalPureXbase.g:7104:1: rule__XCastedExpression__Group_1_0_0__0 : rule__XCastedExpression__Group_1_0_0__0__Impl rule__XCastedExpression__Group_1_0_0__1 ;
    public final void rule__XCastedExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7108:1: ( rule__XCastedExpression__Group_1_0_0__0__Impl rule__XCastedExpression__Group_1_0_0__1 )
            // InternalPureXbase.g:7109:2: rule__XCastedExpression__Group_1_0_0__0__Impl rule__XCastedExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_42);
            rule__XCastedExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:7116:1: rule__XCastedExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XCastedExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7120:1: ( ( () ) )
            // InternalPureXbase.g:7121:1: ( () )
            {
            // InternalPureXbase.g:7121:1: ( () )
            // InternalPureXbase.g:7122:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getXCastedExpressionTargetAction_1_0_0_0()); 
            }
            // InternalPureXbase.g:7123:2: ()
            // InternalPureXbase.g:7123:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getXCastedExpressionTargetAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__1"
    // InternalPureXbase.g:7131:1: rule__XCastedExpression__Group_1_0_0__1 : rule__XCastedExpression__Group_1_0_0__1__Impl ;
    public final void rule__XCastedExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7135:1: ( rule__XCastedExpression__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:7136:2: rule__XCastedExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:7142:1: rule__XCastedExpression__Group_1_0_0__1__Impl : ( 'as' ) ;
    public final void rule__XCastedExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7146:1: ( ( 'as' ) )
            // InternalPureXbase.g:7147:1: ( 'as' )
            {
            // InternalPureXbase.g:7147:1: ( 'as' )
            // InternalPureXbase.g:7148:2: 'as'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getAsKeyword_1_0_0_1()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getAsKeyword_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group__0"
    // InternalPureXbase.g:7158:1: rule__XPostfixOperation__Group__0 : rule__XPostfixOperation__Group__0__Impl rule__XPostfixOperation__Group__1 ;
    public final void rule__XPostfixOperation__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7162:1: ( rule__XPostfixOperation__Group__0__Impl rule__XPostfixOperation__Group__1 )
            // InternalPureXbase.g:7163:2: rule__XPostfixOperation__Group__0__Impl rule__XPostfixOperation__Group__1
            {
            pushFollow(FOLLOW_44);
            rule__XPostfixOperation__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__0"


    // $ANTLR start "rule__XPostfixOperation__Group__0__Impl"
    // InternalPureXbase.g:7170:1: rule__XPostfixOperation__Group__0__Impl : ( ruleXMemberFeatureCall ) ;
    public final void rule__XPostfixOperation__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7174:1: ( ( ruleXMemberFeatureCall ) )
            // InternalPureXbase.g:7175:1: ( ruleXMemberFeatureCall )
            {
            // InternalPureXbase.g:7175:1: ( ruleXMemberFeatureCall )
            // InternalPureXbase.g:7176:2: ruleXMemberFeatureCall
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getXMemberFeatureCallParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXMemberFeatureCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getXMemberFeatureCallParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__0__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group__1"
    // InternalPureXbase.g:7185:1: rule__XPostfixOperation__Group__1 : rule__XPostfixOperation__Group__1__Impl ;
    public final void rule__XPostfixOperation__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7189:1: ( rule__XPostfixOperation__Group__1__Impl )
            // InternalPureXbase.g:7190:2: rule__XPostfixOperation__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__1"


    // $ANTLR start "rule__XPostfixOperation__Group__1__Impl"
    // InternalPureXbase.g:7196:1: rule__XPostfixOperation__Group__1__Impl : ( ( rule__XPostfixOperation__Group_1__0 )? ) ;
    public final void rule__XPostfixOperation__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7200:1: ( ( ( rule__XPostfixOperation__Group_1__0 )? ) )
            // InternalPureXbase.g:7201:1: ( ( rule__XPostfixOperation__Group_1__0 )? )
            {
            // InternalPureXbase.g:7201:1: ( ( rule__XPostfixOperation__Group_1__0 )? )
            // InternalPureXbase.g:7202:2: ( rule__XPostfixOperation__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:7203:2: ( rule__XPostfixOperation__Group_1__0 )?
            int alt67=2;
            int LA67_0 = input.LA(1);

            if ( (LA67_0==42) ) {
                int LA67_1 = input.LA(2);

                if ( (synpred107_InternalPureXbase()) ) {
                    alt67=1;
                }
            }
            else if ( (LA67_0==43) ) {
                int LA67_2 = input.LA(2);

                if ( (synpred107_InternalPureXbase()) ) {
                    alt67=1;
                }
            }
            switch (alt67) {
                case 1 :
                    // InternalPureXbase.g:7203:3: rule__XPostfixOperation__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XPostfixOperation__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__1__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group_1__0"
    // InternalPureXbase.g:7212:1: rule__XPostfixOperation__Group_1__0 : rule__XPostfixOperation__Group_1__0__Impl ;
    public final void rule__XPostfixOperation__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7216:1: ( rule__XPostfixOperation__Group_1__0__Impl )
            // InternalPureXbase.g:7217:2: rule__XPostfixOperation__Group_1__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1__0"


    // $ANTLR start "rule__XPostfixOperation__Group_1__0__Impl"
    // InternalPureXbase.g:7223:1: rule__XPostfixOperation__Group_1__0__Impl : ( ( rule__XPostfixOperation__Group_1_0__0 ) ) ;
    public final void rule__XPostfixOperation__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7227:1: ( ( ( rule__XPostfixOperation__Group_1_0__0 ) ) )
            // InternalPureXbase.g:7228:1: ( ( rule__XPostfixOperation__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:7228:1: ( ( rule__XPostfixOperation__Group_1_0__0 ) )
            // InternalPureXbase.g:7229:2: ( rule__XPostfixOperation__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:7230:2: ( rule__XPostfixOperation__Group_1_0__0 )
            // InternalPureXbase.g:7230:3: rule__XPostfixOperation__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1__0__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__0"
    // InternalPureXbase.g:7239:1: rule__XPostfixOperation__Group_1_0__0 : rule__XPostfixOperation__Group_1_0__0__Impl rule__XPostfixOperation__Group_1_0__1 ;
    public final void rule__XPostfixOperation__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7243:1: ( rule__XPostfixOperation__Group_1_0__0__Impl rule__XPostfixOperation__Group_1_0__1 )
            // InternalPureXbase.g:7244:2: rule__XPostfixOperation__Group_1_0__0__Impl rule__XPostfixOperation__Group_1_0__1
            {
            pushFollow(FOLLOW_44);
            rule__XPostfixOperation__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__0"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__0__Impl"
    // InternalPureXbase.g:7251:1: rule__XPostfixOperation__Group_1_0__0__Impl : ( () ) ;
    public final void rule__XPostfixOperation__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7255:1: ( ( () ) )
            // InternalPureXbase.g:7256:1: ( () )
            {
            // InternalPureXbase.g:7256:1: ( () )
            // InternalPureXbase.g:7257:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getXPostfixOperationOperandAction_1_0_0()); 
            }
            // InternalPureXbase.g:7258:2: ()
            // InternalPureXbase.g:7258:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getXPostfixOperationOperandAction_1_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__0__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__1"
    // InternalPureXbase.g:7266:1: rule__XPostfixOperation__Group_1_0__1 : rule__XPostfixOperation__Group_1_0__1__Impl ;
    public final void rule__XPostfixOperation__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7270:1: ( rule__XPostfixOperation__Group_1_0__1__Impl )
            // InternalPureXbase.g:7271:2: rule__XPostfixOperation__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__1"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__1__Impl"
    // InternalPureXbase.g:7277:1: rule__XPostfixOperation__Group_1_0__1__Impl : ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) ) ;
    public final void rule__XPostfixOperation__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7281:1: ( ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) ) )
            // InternalPureXbase.g:7282:1: ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) )
            {
            // InternalPureXbase.g:7282:1: ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) )
            // InternalPureXbase.g:7283:2: ( rule__XPostfixOperation__FeatureAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getFeatureAssignment_1_0_1()); 
            }
            // InternalPureXbase.g:7284:2: ( rule__XPostfixOperation__FeatureAssignment_1_0_1 )
            // InternalPureXbase.g:7284:3: rule__XPostfixOperation__FeatureAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__FeatureAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getFeatureAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group__0"
    // InternalPureXbase.g:7293:1: rule__XMemberFeatureCall__Group__0 : rule__XMemberFeatureCall__Group__0__Impl rule__XMemberFeatureCall__Group__1 ;
    public final void rule__XMemberFeatureCall__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7297:1: ( rule__XMemberFeatureCall__Group__0__Impl rule__XMemberFeatureCall__Group__1 )
            // InternalPureXbase.g:7298:2: rule__XMemberFeatureCall__Group__0__Impl rule__XMemberFeatureCall__Group__1
            {
            pushFollow(FOLLOW_45);
            rule__XMemberFeatureCall__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group__0__Impl"
    // InternalPureXbase.g:7305:1: rule__XMemberFeatureCall__Group__0__Impl : ( ruleXPrimaryExpression ) ;
    public final void rule__XMemberFeatureCall__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7309:1: ( ( ruleXPrimaryExpression ) )
            // InternalPureXbase.g:7310:1: ( ruleXPrimaryExpression )
            {
            // InternalPureXbase.g:7310:1: ( ruleXPrimaryExpression )
            // InternalPureXbase.g:7311:2: ruleXPrimaryExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getXPrimaryExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXPrimaryExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getXPrimaryExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group__1"
    // InternalPureXbase.g:7320:1: rule__XMemberFeatureCall__Group__1 : rule__XMemberFeatureCall__Group__1__Impl ;
    public final void rule__XMemberFeatureCall__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7324:1: ( rule__XMemberFeatureCall__Group__1__Impl )
            // InternalPureXbase.g:7325:2: rule__XMemberFeatureCall__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group__1__Impl"
    // InternalPureXbase.g:7331:1: rule__XMemberFeatureCall__Group__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1 )* ) ;
    public final void rule__XMemberFeatureCall__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7335:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1 )* ) )
            // InternalPureXbase.g:7336:1: ( ( rule__XMemberFeatureCall__Alternatives_1 )* )
            {
            // InternalPureXbase.g:7336:1: ( ( rule__XMemberFeatureCall__Alternatives_1 )* )
            // InternalPureXbase.g:7337:2: ( rule__XMemberFeatureCall__Alternatives_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1()); 
            }
            // InternalPureXbase.g:7338:2: ( rule__XMemberFeatureCall__Alternatives_1 )*
            loop68:
            do {
                int alt68=2;
                switch ( input.LA(1) ) {
                case 44:
                    {
                    int LA68_2 = input.LA(2);

                    if ( (synpred108_InternalPureXbase()) ) {
                        alt68=1;
                    }


                    }
                    break;
                case 81:
                    {
                    int LA68_3 = input.LA(2);

                    if ( (synpred108_InternalPureXbase()) ) {
                        alt68=1;
                    }


                    }
                    break;
                case 82:
                    {
                    int LA68_4 = input.LA(2);

                    if ( (synpred108_InternalPureXbase()) ) {
                        alt68=1;
                    }


                    }
                    break;

                }

                switch (alt68) {
            	case 1 :
            	    // InternalPureXbase.g:7338:3: rule__XMemberFeatureCall__Alternatives_1
            	    {
            	    pushFollow(FOLLOW_46);
            	    rule__XMemberFeatureCall__Alternatives_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop68;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__0"
    // InternalPureXbase.g:7347:1: rule__XMemberFeatureCall__Group_1_0__0 : rule__XMemberFeatureCall__Group_1_0__0__Impl rule__XMemberFeatureCall__Group_1_0__1 ;
    public final void rule__XMemberFeatureCall__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7351:1: ( rule__XMemberFeatureCall__Group_1_0__0__Impl rule__XMemberFeatureCall__Group_1_0__1 )
            // InternalPureXbase.g:7352:2: rule__XMemberFeatureCall__Group_1_0__0__Impl rule__XMemberFeatureCall__Group_1_0__1
            {
            pushFollow(FOLLOW_5);
            rule__XMemberFeatureCall__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__0__Impl"
    // InternalPureXbase.g:7359:1: rule__XMemberFeatureCall__Group_1_0__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7363:1: ( ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) ) )
            // InternalPureXbase.g:7364:1: ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) )
            {
            // InternalPureXbase.g:7364:1: ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) )
            // InternalPureXbase.g:7365:2: ( rule__XMemberFeatureCall__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:7366:2: ( rule__XMemberFeatureCall__Group_1_0_0__0 )
            // InternalPureXbase.g:7366:3: rule__XMemberFeatureCall__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__1"
    // InternalPureXbase.g:7374:1: rule__XMemberFeatureCall__Group_1_0__1 : rule__XMemberFeatureCall__Group_1_0__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7378:1: ( rule__XMemberFeatureCall__Group_1_0__1__Impl )
            // InternalPureXbase.g:7379:2: rule__XMemberFeatureCall__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__1__Impl"
    // InternalPureXbase.g:7385:1: rule__XMemberFeatureCall__Group_1_0__1__Impl : ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7389:1: ( ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) ) )
            // InternalPureXbase.g:7390:1: ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) )
            {
            // InternalPureXbase.g:7390:1: ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) )
            // InternalPureXbase.g:7391:2: ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getValueAssignment_1_0_1()); 
            }
            // InternalPureXbase.g:7392:2: ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 )
            // InternalPureXbase.g:7392:3: rule__XMemberFeatureCall__ValueAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__ValueAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getValueAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0__0"
    // InternalPureXbase.g:7401:1: rule__XMemberFeatureCall__Group_1_0_0__0 : rule__XMemberFeatureCall__Group_1_0_0__0__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7405:1: ( rule__XMemberFeatureCall__Group_1_0_0__0__Impl )
            // InternalPureXbase.g:7406:2: rule__XMemberFeatureCall__Group_1_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:7412:1: rule__XMemberFeatureCall__Group_1_0_0__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7416:1: ( ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) ) )
            // InternalPureXbase.g:7417:1: ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) )
            {
            // InternalPureXbase.g:7417:1: ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) )
            // InternalPureXbase.g:7418:2: ( rule__XMemberFeatureCall__Group_1_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0_0()); 
            }
            // InternalPureXbase.g:7419:2: ( rule__XMemberFeatureCall__Group_1_0_0_0__0 )
            // InternalPureXbase.g:7419:3: rule__XMemberFeatureCall__Group_1_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__0"
    // InternalPureXbase.g:7428:1: rule__XMemberFeatureCall__Group_1_0_0_0__0 : rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl rule__XMemberFeatureCall__Group_1_0_0_0__1 ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7432:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl rule__XMemberFeatureCall__Group_1_0_0_0__1 )
            // InternalPureXbase.g:7433:2: rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl rule__XMemberFeatureCall__Group_1_0_0_0__1
            {
            pushFollow(FOLLOW_47);
            rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl"
    // InternalPureXbase.g:7440:1: rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl : ( () ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7444:1: ( ( () ) )
            // InternalPureXbase.g:7445:1: ( () )
            {
            // InternalPureXbase.g:7445:1: ( () )
            // InternalPureXbase.g:7446:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getXAssignmentAssignableAction_1_0_0_0_0()); 
            }
            // InternalPureXbase.g:7447:2: ()
            // InternalPureXbase.g:7447:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getXAssignmentAssignableAction_1_0_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__1"
    // InternalPureXbase.g:7455:1: rule__XMemberFeatureCall__Group_1_0_0_0__1 : rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl rule__XMemberFeatureCall__Group_1_0_0_0__2 ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7459:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl rule__XMemberFeatureCall__Group_1_0_0_0__2 )
            // InternalPureXbase.g:7460:2: rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl rule__XMemberFeatureCall__Group_1_0_0_0__2
            {
            pushFollow(FOLLOW_17);
            rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl"
    // InternalPureXbase.g:7467:1: rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7471:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) ) )
            // InternalPureXbase.g:7472:1: ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) )
            {
            // InternalPureXbase.g:7472:1: ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) )
            // InternalPureXbase.g:7473:2: ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_0_0_0_1()); 
            }
            // InternalPureXbase.g:7474:2: ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 )
            // InternalPureXbase.g:7474:3: rule__XMemberFeatureCall__Alternatives_1_0_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Alternatives_1_0_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__2"
    // InternalPureXbase.g:7482:1: rule__XMemberFeatureCall__Group_1_0_0_0__2 : rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl rule__XMemberFeatureCall__Group_1_0_0_0__3 ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7486:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl rule__XMemberFeatureCall__Group_1_0_0_0__3 )
            // InternalPureXbase.g:7487:2: rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl rule__XMemberFeatureCall__Group_1_0_0_0__3
            {
            pushFollow(FOLLOW_16);
            rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl"
    // InternalPureXbase.g:7494:1: rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl : ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7498:1: ( ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) ) )
            // InternalPureXbase.g:7499:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) )
            {
            // InternalPureXbase.g:7499:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) )
            // InternalPureXbase.g:7500:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_0_0_0_2()); 
            }
            // InternalPureXbase.g:7501:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 )
            // InternalPureXbase.g:7501:3: rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_0_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__3"
    // InternalPureXbase.g:7509:1: rule__XMemberFeatureCall__Group_1_0_0_0__3 : rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7513:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl )
            // InternalPureXbase.g:7514:2: rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__3"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl"
    // InternalPureXbase.g:7520:1: rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl : ( ruleOpSingleAssign ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7524:1: ( ( ruleOpSingleAssign ) )
            // InternalPureXbase.g:7525:1: ( ruleOpSingleAssign )
            {
            // InternalPureXbase.g:7525:1: ( ruleOpSingleAssign )
            // InternalPureXbase.g:7526:2: ruleOpSingleAssign
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getOpSingleAssignParserRuleCall_1_0_0_0_3()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getOpSingleAssignParserRuleCall_1_0_0_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__0"
    // InternalPureXbase.g:7536:1: rule__XMemberFeatureCall__Group_1_1__0 : rule__XMemberFeatureCall__Group_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7540:1: ( rule__XMemberFeatureCall__Group_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1__1 )
            // InternalPureXbase.g:7541:2: rule__XMemberFeatureCall__Group_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1__1
            {
            pushFollow(FOLLOW_48);
            rule__XMemberFeatureCall__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__0__Impl"
    // InternalPureXbase.g:7548:1: rule__XMemberFeatureCall__Group_1_1__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7552:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) ) )
            // InternalPureXbase.g:7553:1: ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) )
            {
            // InternalPureXbase.g:7553:1: ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) )
            // InternalPureXbase.g:7554:2: ( rule__XMemberFeatureCall__Group_1_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0()); 
            }
            // InternalPureXbase.g:7555:2: ( rule__XMemberFeatureCall__Group_1_1_0__0 )
            // InternalPureXbase.g:7555:3: rule__XMemberFeatureCall__Group_1_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__1"
    // InternalPureXbase.g:7563:1: rule__XMemberFeatureCall__Group_1_1__1 : rule__XMemberFeatureCall__Group_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1__2 ;
    public final void rule__XMemberFeatureCall__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7567:1: ( rule__XMemberFeatureCall__Group_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1__2 )
            // InternalPureXbase.g:7568:2: rule__XMemberFeatureCall__Group_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1__2
            {
            pushFollow(FOLLOW_48);
            rule__XMemberFeatureCall__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__1__Impl"
    // InternalPureXbase.g:7575:1: rule__XMemberFeatureCall__Group_1_1__1__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7579:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? ) )
            // InternalPureXbase.g:7580:1: ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? )
            {
            // InternalPureXbase.g:7580:1: ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? )
            // InternalPureXbase.g:7581:2: ( rule__XMemberFeatureCall__Group_1_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1()); 
            }
            // InternalPureXbase.g:7582:2: ( rule__XMemberFeatureCall__Group_1_1_1__0 )?
            int alt69=2;
            int LA69_0 = input.LA(1);

            if ( (LA69_0==28) ) {
                alt69=1;
            }
            switch (alt69) {
                case 1 :
                    // InternalPureXbase.g:7582:3: rule__XMemberFeatureCall__Group_1_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__2"
    // InternalPureXbase.g:7590:1: rule__XMemberFeatureCall__Group_1_1__2 : rule__XMemberFeatureCall__Group_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1__3 ;
    public final void rule__XMemberFeatureCall__Group_1_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7594:1: ( rule__XMemberFeatureCall__Group_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1__3 )
            // InternalPureXbase.g:7595:2: rule__XMemberFeatureCall__Group_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1__3
            {
            pushFollow(FOLLOW_49);
            rule__XMemberFeatureCall__Group_1_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__2__Impl"
    // InternalPureXbase.g:7602:1: rule__XMemberFeatureCall__Group_1_1__2__Impl : ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7606:1: ( ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) ) )
            // InternalPureXbase.g:7607:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) )
            {
            // InternalPureXbase.g:7607:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) )
            // InternalPureXbase.g:7608:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_1_2()); 
            }
            // InternalPureXbase.g:7609:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 )
            // InternalPureXbase.g:7609:3: rule__XMemberFeatureCall__FeatureAssignment_1_1_2
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__FeatureAssignment_1_1_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__3"
    // InternalPureXbase.g:7617:1: rule__XMemberFeatureCall__Group_1_1__3 : rule__XMemberFeatureCall__Group_1_1__3__Impl rule__XMemberFeatureCall__Group_1_1__4 ;
    public final void rule__XMemberFeatureCall__Group_1_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7621:1: ( rule__XMemberFeatureCall__Group_1_1__3__Impl rule__XMemberFeatureCall__Group_1_1__4 )
            // InternalPureXbase.g:7622:2: rule__XMemberFeatureCall__Group_1_1__3__Impl rule__XMemberFeatureCall__Group_1_1__4
            {
            pushFollow(FOLLOW_49);
            rule__XMemberFeatureCall__Group_1_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__3"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__3__Impl"
    // InternalPureXbase.g:7629:1: rule__XMemberFeatureCall__Group_1_1__3__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7633:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? ) )
            // InternalPureXbase.g:7634:1: ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? )
            {
            // InternalPureXbase.g:7634:1: ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? )
            // InternalPureXbase.g:7635:2: ( rule__XMemberFeatureCall__Group_1_1_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3()); 
            }
            // InternalPureXbase.g:7636:2: ( rule__XMemberFeatureCall__Group_1_1_3__0 )?
            int alt70=2;
            alt70 = dfa70.predict(input);
            switch (alt70) {
                case 1 :
                    // InternalPureXbase.g:7636:3: rule__XMemberFeatureCall__Group_1_1_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__3__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__4"
    // InternalPureXbase.g:7644:1: rule__XMemberFeatureCall__Group_1_1__4 : rule__XMemberFeatureCall__Group_1_1__4__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7648:1: ( rule__XMemberFeatureCall__Group_1_1__4__Impl )
            // InternalPureXbase.g:7649:2: rule__XMemberFeatureCall__Group_1_1__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__4"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__4__Impl"
    // InternalPureXbase.g:7655:1: rule__XMemberFeatureCall__Group_1_1__4__Impl : ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7659:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? ) )
            // InternalPureXbase.g:7660:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? )
            {
            // InternalPureXbase.g:7660:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? )
            // InternalPureXbase.g:7661:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_4()); 
            }
            // InternalPureXbase.g:7662:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )?
            int alt71=2;
            alt71 = dfa71.predict(input);
            switch (alt71) {
                case 1 :
                    // InternalPureXbase.g:7662:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__4__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0__0"
    // InternalPureXbase.g:7671:1: rule__XMemberFeatureCall__Group_1_1_0__0 : rule__XMemberFeatureCall__Group_1_1_0__0__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7675:1: ( rule__XMemberFeatureCall__Group_1_1_0__0__Impl )
            // InternalPureXbase.g:7676:2: rule__XMemberFeatureCall__Group_1_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0__0__Impl"
    // InternalPureXbase.g:7682:1: rule__XMemberFeatureCall__Group_1_1_0__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7686:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) ) )
            // InternalPureXbase.g:7687:1: ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) )
            {
            // InternalPureXbase.g:7687:1: ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) )
            // InternalPureXbase.g:7688:2: ( rule__XMemberFeatureCall__Group_1_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0_0()); 
            }
            // InternalPureXbase.g:7689:2: ( rule__XMemberFeatureCall__Group_1_1_0_0__0 )
            // InternalPureXbase.g:7689:3: rule__XMemberFeatureCall__Group_1_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__0"
    // InternalPureXbase.g:7698:1: rule__XMemberFeatureCall__Group_1_1_0_0__0 : rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl rule__XMemberFeatureCall__Group_1_1_0_0__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7702:1: ( rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl rule__XMemberFeatureCall__Group_1_1_0_0__1 )
            // InternalPureXbase.g:7703:2: rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl rule__XMemberFeatureCall__Group_1_1_0_0__1
            {
            pushFollow(FOLLOW_45);
            rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl"
    // InternalPureXbase.g:7710:1: rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl : ( () ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7714:1: ( ( () ) )
            // InternalPureXbase.g:7715:1: ( () )
            {
            // InternalPureXbase.g:7715:1: ( () )
            // InternalPureXbase.g:7716:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getXMemberFeatureCallMemberCallTargetAction_1_1_0_0_0()); 
            }
            // InternalPureXbase.g:7717:2: ()
            // InternalPureXbase.g:7717:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getXMemberFeatureCallMemberCallTargetAction_1_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__1"
    // InternalPureXbase.g:7725:1: rule__XMemberFeatureCall__Group_1_1_0_0__1 : rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7729:1: ( rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl )
            // InternalPureXbase.g:7730:2: rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl"
    // InternalPureXbase.g:7736:1: rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7740:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) ) )
            // InternalPureXbase.g:7741:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) )
            {
            // InternalPureXbase.g:7741:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) )
            // InternalPureXbase.g:7742:2: ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_0_0_1()); 
            }
            // InternalPureXbase.g:7743:2: ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 )
            // InternalPureXbase.g:7743:3: rule__XMemberFeatureCall__Alternatives_1_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Alternatives_1_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__0"
    // InternalPureXbase.g:7752:1: rule__XMemberFeatureCall__Group_1_1_1__0 : rule__XMemberFeatureCall__Group_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7756:1: ( rule__XMemberFeatureCall__Group_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_1__1 )
            // InternalPureXbase.g:7757:2: rule__XMemberFeatureCall__Group_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_1__1
            {
            pushFollow(FOLLOW_50);
            rule__XMemberFeatureCall__Group_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__0__Impl"
    // InternalPureXbase.g:7764:1: rule__XMemberFeatureCall__Group_1_1_1__0__Impl : ( '<' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7768:1: ( ( '<' ) )
            // InternalPureXbase.g:7769:1: ( '<' )
            {
            // InternalPureXbase.g:7769:1: ( '<' )
            // InternalPureXbase.g:7770:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getLessThanSignKeyword_1_1_1_0()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getLessThanSignKeyword_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__1"
    // InternalPureXbase.g:7779:1: rule__XMemberFeatureCall__Group_1_1_1__1 : rule__XMemberFeatureCall__Group_1_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1_1__2 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7783:1: ( rule__XMemberFeatureCall__Group_1_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1_1__2 )
            // InternalPureXbase.g:7784:2: rule__XMemberFeatureCall__Group_1_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1_1__2
            {
            pushFollow(FOLLOW_51);
            rule__XMemberFeatureCall__Group_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__1__Impl"
    // InternalPureXbase.g:7791:1: rule__XMemberFeatureCall__Group_1_1_1__1__Impl : ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7795:1: ( ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) ) )
            // InternalPureXbase.g:7796:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) )
            {
            // InternalPureXbase.g:7796:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) )
            // InternalPureXbase.g:7797:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_1()); 
            }
            // InternalPureXbase.g:7798:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 )
            // InternalPureXbase.g:7798:3: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__2"
    // InternalPureXbase.g:7806:1: rule__XMemberFeatureCall__Group_1_1_1__2 : rule__XMemberFeatureCall__Group_1_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1_1__3 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7810:1: ( rule__XMemberFeatureCall__Group_1_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1_1__3 )
            // InternalPureXbase.g:7811:2: rule__XMemberFeatureCall__Group_1_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1_1__3
            {
            pushFollow(FOLLOW_51);
            rule__XMemberFeatureCall__Group_1_1_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__2__Impl"
    // InternalPureXbase.g:7818:1: rule__XMemberFeatureCall__Group_1_1_1__2__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7822:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* ) )
            // InternalPureXbase.g:7823:1: ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* )
            {
            // InternalPureXbase.g:7823:1: ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* )
            // InternalPureXbase.g:7824:2: ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1_2()); 
            }
            // InternalPureXbase.g:7825:2: ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )*
            loop72:
            do {
                int alt72=2;
                int LA72_0 = input.LA(1);

                if ( (LA72_0==55) ) {
                    alt72=1;
                }


                switch (alt72) {
            	case 1 :
            	    // InternalPureXbase.g:7825:3: rule__XMemberFeatureCall__Group_1_1_1_2__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XMemberFeatureCall__Group_1_1_1_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop72;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__3"
    // InternalPureXbase.g:7833:1: rule__XMemberFeatureCall__Group_1_1_1__3 : rule__XMemberFeatureCall__Group_1_1_1__3__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7837:1: ( rule__XMemberFeatureCall__Group_1_1_1__3__Impl )
            // InternalPureXbase.g:7838:2: rule__XMemberFeatureCall__Group_1_1_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__3"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__3__Impl"
    // InternalPureXbase.g:7844:1: rule__XMemberFeatureCall__Group_1_1_1__3__Impl : ( '>' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7848:1: ( ( '>' ) )
            // InternalPureXbase.g:7849:1: ( '>' )
            {
            // InternalPureXbase.g:7849:1: ( '>' )
            // InternalPureXbase.g:7850:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGreaterThanSignKeyword_1_1_1_3()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGreaterThanSignKeyword_1_1_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__3__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__0"
    // InternalPureXbase.g:7860:1: rule__XMemberFeatureCall__Group_1_1_1_2__0 : rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl rule__XMemberFeatureCall__Group_1_1_1_2__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7864:1: ( rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl rule__XMemberFeatureCall__Group_1_1_1_2__1 )
            // InternalPureXbase.g:7865:2: rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl rule__XMemberFeatureCall__Group_1_1_1_2__1
            {
            pushFollow(FOLLOW_50);
            rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl"
    // InternalPureXbase.g:7872:1: rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl : ( ',' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7876:1: ( ( ',' ) )
            // InternalPureXbase.g:7877:1: ( ',' )
            {
            // InternalPureXbase.g:7877:1: ( ',' )
            // InternalPureXbase.g:7878:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_1_2_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__1"
    // InternalPureXbase.g:7887:1: rule__XMemberFeatureCall__Group_1_1_1_2__1 : rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7891:1: ( rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl )
            // InternalPureXbase.g:7892:2: rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl"
    // InternalPureXbase.g:7898:1: rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl : ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7902:1: ( ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) ) )
            // InternalPureXbase.g:7903:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) )
            {
            // InternalPureXbase.g:7903:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) )
            // InternalPureXbase.g:7904:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_2_1()); 
            }
            // InternalPureXbase.g:7905:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 )
            // InternalPureXbase.g:7905:3: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__0"
    // InternalPureXbase.g:7914:1: rule__XMemberFeatureCall__Group_1_1_3__0 : rule__XMemberFeatureCall__Group_1_1_3__0__Impl rule__XMemberFeatureCall__Group_1_1_3__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7918:1: ( rule__XMemberFeatureCall__Group_1_1_3__0__Impl rule__XMemberFeatureCall__Group_1_1_3__1 )
            // InternalPureXbase.g:7919:2: rule__XMemberFeatureCall__Group_1_1_3__0__Impl rule__XMemberFeatureCall__Group_1_1_3__1
            {
            pushFollow(FOLLOW_53);
            rule__XMemberFeatureCall__Group_1_1_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__0__Impl"
    // InternalPureXbase.g:7926:1: rule__XMemberFeatureCall__Group_1_1_3__0__Impl : ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7930:1: ( ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) ) )
            // InternalPureXbase.g:7931:1: ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) )
            {
            // InternalPureXbase.g:7931:1: ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) )
            // InternalPureXbase.g:7932:2: ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallAssignment_1_1_3_0()); 
            }
            // InternalPureXbase.g:7933:2: ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 )
            // InternalPureXbase.g:7933:3: rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallAssignment_1_1_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__1"
    // InternalPureXbase.g:7941:1: rule__XMemberFeatureCall__Group_1_1_3__1 : rule__XMemberFeatureCall__Group_1_1_3__1__Impl rule__XMemberFeatureCall__Group_1_1_3__2 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7945:1: ( rule__XMemberFeatureCall__Group_1_1_3__1__Impl rule__XMemberFeatureCall__Group_1_1_3__2 )
            // InternalPureXbase.g:7946:2: rule__XMemberFeatureCall__Group_1_1_3__1__Impl rule__XMemberFeatureCall__Group_1_1_3__2
            {
            pushFollow(FOLLOW_53);
            rule__XMemberFeatureCall__Group_1_1_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__1__Impl"
    // InternalPureXbase.g:7953:1: rule__XMemberFeatureCall__Group_1_1_3__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7957:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? ) )
            // InternalPureXbase.g:7958:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? )
            {
            // InternalPureXbase.g:7958:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? )
            // InternalPureXbase.g:7959:2: ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_3_1()); 
            }
            // InternalPureXbase.g:7960:2: ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )?
            int alt73=2;
            int LA73_0 = input.LA(1);

            if ( ((LA73_0>=RULE_ID && LA73_0<=RULE_STRING)||LA73_0==28||LA73_0==32||(LA73_0>=35 && LA73_0<=36)||LA73_0==41||(LA73_0>=45 && LA73_0<=46)||(LA73_0>=48 && LA73_0<=49)||(LA73_0>=56 && LA73_0<=57)||LA73_0==59||LA73_0==61||LA73_0==63||(LA73_0>=66 && LA73_0<=74)||(LA73_0>=83 && LA73_0<=84)) ) {
                alt73=1;
            }
            switch (alt73) {
                case 1 :
                    // InternalPureXbase.g:7960:3: rule__XMemberFeatureCall__Alternatives_1_1_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Alternatives_1_1_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__2"
    // InternalPureXbase.g:7968:1: rule__XMemberFeatureCall__Group_1_1_3__2 : rule__XMemberFeatureCall__Group_1_1_3__2__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7972:1: ( rule__XMemberFeatureCall__Group_1_1_3__2__Impl )
            // InternalPureXbase.g:7973:2: rule__XMemberFeatureCall__Group_1_1_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__2__Impl"
    // InternalPureXbase.g:7979:1: rule__XMemberFeatureCall__Group_1_1_3__2__Impl : ( ')' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7983:1: ( ( ')' ) )
            // InternalPureXbase.g:7984:1: ( ')' )
            {
            // InternalPureXbase.g:7984:1: ( ')' )
            // InternalPureXbase.g:7985:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getRightParenthesisKeyword_1_1_3_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getRightParenthesisKeyword_1_1_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__0"
    // InternalPureXbase.g:7995:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__0 : rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:7999:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1__1 )
            // InternalPureXbase.g:8000:2: rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1__1
            {
            pushFollow(FOLLOW_54);
            rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl"
    // InternalPureXbase.g:8007:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl : ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8011:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) ) )
            // InternalPureXbase.g:8012:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) )
            {
            // InternalPureXbase.g:8012:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) )
            // InternalPureXbase.g:8013:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_0()); 
            }
            // InternalPureXbase.g:8014:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 )
            // InternalPureXbase.g:8014:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__1"
    // InternalPureXbase.g:8022:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__1 : rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8026:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl )
            // InternalPureXbase.g:8027:2: rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl"
    // InternalPureXbase.g:8033:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8037:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* ) )
            // InternalPureXbase.g:8038:1: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* )
            {
            // InternalPureXbase.g:8038:1: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* )
            // InternalPureXbase.g:8039:2: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1_1()); 
            }
            // InternalPureXbase.g:8040:2: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )*
            loop74:
            do {
                int alt74=2;
                int LA74_0 = input.LA(1);

                if ( (LA74_0==55) ) {
                    alt74=1;
                }


                switch (alt74) {
            	case 1 :
            	    // InternalPureXbase.g:8040:3: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop74;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0"
    // InternalPureXbase.g:8049:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 : rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8053:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1 )
            // InternalPureXbase.g:8054:2: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl"
    // InternalPureXbase.g:8061:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8065:1: ( ( ',' ) )
            // InternalPureXbase.g:8066:1: ( ',' )
            {
            // InternalPureXbase.g:8066:1: ( ',' )
            // InternalPureXbase.g:8067:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_3_1_1_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_3_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1"
    // InternalPureXbase.g:8076:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1 : rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8080:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl )
            // InternalPureXbase.g:8081:2: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl"
    // InternalPureXbase.g:8087:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl : ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8091:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) ) )
            // InternalPureXbase.g:8092:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) )
            {
            // InternalPureXbase.g:8092:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) )
            // InternalPureXbase.g:8093:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_1_1()); 
            }
            // InternalPureXbase.g:8094:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 )
            // InternalPureXbase.g:8094:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__0"
    // InternalPureXbase.g:8103:1: rule__XSetLiteral__Group__0 : rule__XSetLiteral__Group__0__Impl rule__XSetLiteral__Group__1 ;
    public final void rule__XSetLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8107:1: ( rule__XSetLiteral__Group__0__Impl rule__XSetLiteral__Group__1 )
            // InternalPureXbase.g:8108:2: rule__XSetLiteral__Group__0__Impl rule__XSetLiteral__Group__1
            {
            pushFollow(FOLLOW_55);
            rule__XSetLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__0"


    // $ANTLR start "rule__XSetLiteral__Group__0__Impl"
    // InternalPureXbase.g:8115:1: rule__XSetLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XSetLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8119:1: ( ( () ) )
            // InternalPureXbase.g:8120:1: ( () )
            {
            // InternalPureXbase.g:8120:1: ( () )
            // InternalPureXbase.g:8121:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getXSetLiteralAction_0()); 
            }
            // InternalPureXbase.g:8122:2: ()
            // InternalPureXbase.g:8122:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getXSetLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__0__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__1"
    // InternalPureXbase.g:8130:1: rule__XSetLiteral__Group__1 : rule__XSetLiteral__Group__1__Impl rule__XSetLiteral__Group__2 ;
    public final void rule__XSetLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8134:1: ( rule__XSetLiteral__Group__1__Impl rule__XSetLiteral__Group__2 )
            // InternalPureXbase.g:8135:2: rule__XSetLiteral__Group__1__Impl rule__XSetLiteral__Group__2
            {
            pushFollow(FOLLOW_56);
            rule__XSetLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__1"


    // $ANTLR start "rule__XSetLiteral__Group__1__Impl"
    // InternalPureXbase.g:8142:1: rule__XSetLiteral__Group__1__Impl : ( '#' ) ;
    public final void rule__XSetLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8146:1: ( ( '#' ) )
            // InternalPureXbase.g:8147:1: ( '#' )
            {
            // InternalPureXbase.g:8147:1: ( '#' )
            // InternalPureXbase.g:8148:2: '#'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getNumberSignKeyword_1()); 
            }
            match(input,56,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getNumberSignKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__1__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__2"
    // InternalPureXbase.g:8157:1: rule__XSetLiteral__Group__2 : rule__XSetLiteral__Group__2__Impl rule__XSetLiteral__Group__3 ;
    public final void rule__XSetLiteral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8161:1: ( rule__XSetLiteral__Group__2__Impl rule__XSetLiteral__Group__3 )
            // InternalPureXbase.g:8162:2: rule__XSetLiteral__Group__2__Impl rule__XSetLiteral__Group__3
            {
            pushFollow(FOLLOW_57);
            rule__XSetLiteral__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__2"


    // $ANTLR start "rule__XSetLiteral__Group__2__Impl"
    // InternalPureXbase.g:8169:1: rule__XSetLiteral__Group__2__Impl : ( '{' ) ;
    public final void rule__XSetLiteral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8173:1: ( ( '{' ) )
            // InternalPureXbase.g:8174:1: ( '{' )
            {
            // InternalPureXbase.g:8174:1: ( '{' )
            // InternalPureXbase.g:8175:2: '{'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getLeftCurlyBracketKeyword_2()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getLeftCurlyBracketKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__2__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__3"
    // InternalPureXbase.g:8184:1: rule__XSetLiteral__Group__3 : rule__XSetLiteral__Group__3__Impl rule__XSetLiteral__Group__4 ;
    public final void rule__XSetLiteral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8188:1: ( rule__XSetLiteral__Group__3__Impl rule__XSetLiteral__Group__4 )
            // InternalPureXbase.g:8189:2: rule__XSetLiteral__Group__3__Impl rule__XSetLiteral__Group__4
            {
            pushFollow(FOLLOW_57);
            rule__XSetLiteral__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__3"


    // $ANTLR start "rule__XSetLiteral__Group__3__Impl"
    // InternalPureXbase.g:8196:1: rule__XSetLiteral__Group__3__Impl : ( ( rule__XSetLiteral__Group_3__0 )? ) ;
    public final void rule__XSetLiteral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8200:1: ( ( ( rule__XSetLiteral__Group_3__0 )? ) )
            // InternalPureXbase.g:8201:1: ( ( rule__XSetLiteral__Group_3__0 )? )
            {
            // InternalPureXbase.g:8201:1: ( ( rule__XSetLiteral__Group_3__0 )? )
            // InternalPureXbase.g:8202:2: ( rule__XSetLiteral__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getGroup_3()); 
            }
            // InternalPureXbase.g:8203:2: ( rule__XSetLiteral__Group_3__0 )?
            int alt75=2;
            int LA75_0 = input.LA(1);

            if ( ((LA75_0>=RULE_ID && LA75_0<=RULE_STRING)||LA75_0==28||(LA75_0>=35 && LA75_0<=36)||LA75_0==41||(LA75_0>=45 && LA75_0<=46)||(LA75_0>=48 && LA75_0<=49)||(LA75_0>=56 && LA75_0<=57)||LA75_0==59||LA75_0==61||LA75_0==63||(LA75_0>=66 && LA75_0<=74)||LA75_0==84) ) {
                alt75=1;
            }
            switch (alt75) {
                case 1 :
                    // InternalPureXbase.g:8203:3: rule__XSetLiteral__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSetLiteral__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__3__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__4"
    // InternalPureXbase.g:8211:1: rule__XSetLiteral__Group__4 : rule__XSetLiteral__Group__4__Impl ;
    public final void rule__XSetLiteral__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8215:1: ( rule__XSetLiteral__Group__4__Impl )
            // InternalPureXbase.g:8216:2: rule__XSetLiteral__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__4"


    // $ANTLR start "rule__XSetLiteral__Group__4__Impl"
    // InternalPureXbase.g:8222:1: rule__XSetLiteral__Group__4__Impl : ( '}' ) ;
    public final void rule__XSetLiteral__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8226:1: ( ( '}' ) )
            // InternalPureXbase.g:8227:1: ( '}' )
            {
            // InternalPureXbase.g:8227:1: ( '}' )
            // InternalPureXbase.g:8228:2: '}'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getRightCurlyBracketKeyword_4()); 
            }
            match(input,58,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getRightCurlyBracketKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__4__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3__0"
    // InternalPureXbase.g:8238:1: rule__XSetLiteral__Group_3__0 : rule__XSetLiteral__Group_3__0__Impl rule__XSetLiteral__Group_3__1 ;
    public final void rule__XSetLiteral__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8242:1: ( rule__XSetLiteral__Group_3__0__Impl rule__XSetLiteral__Group_3__1 )
            // InternalPureXbase.g:8243:2: rule__XSetLiteral__Group_3__0__Impl rule__XSetLiteral__Group_3__1
            {
            pushFollow(FOLLOW_54);
            rule__XSetLiteral__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__0"


    // $ANTLR start "rule__XSetLiteral__Group_3__0__Impl"
    // InternalPureXbase.g:8250:1: rule__XSetLiteral__Group_3__0__Impl : ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) ) ;
    public final void rule__XSetLiteral__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8254:1: ( ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) ) )
            // InternalPureXbase.g:8255:1: ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) )
            {
            // InternalPureXbase.g:8255:1: ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) )
            // InternalPureXbase.g:8256:2: ( rule__XSetLiteral__ElementsAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_0()); 
            }
            // InternalPureXbase.g:8257:2: ( rule__XSetLiteral__ElementsAssignment_3_0 )
            // InternalPureXbase.g:8257:3: rule__XSetLiteral__ElementsAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__ElementsAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__0__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3__1"
    // InternalPureXbase.g:8265:1: rule__XSetLiteral__Group_3__1 : rule__XSetLiteral__Group_3__1__Impl ;
    public final void rule__XSetLiteral__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8269:1: ( rule__XSetLiteral__Group_3__1__Impl )
            // InternalPureXbase.g:8270:2: rule__XSetLiteral__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__1"


    // $ANTLR start "rule__XSetLiteral__Group_3__1__Impl"
    // InternalPureXbase.g:8276:1: rule__XSetLiteral__Group_3__1__Impl : ( ( rule__XSetLiteral__Group_3_1__0 )* ) ;
    public final void rule__XSetLiteral__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8280:1: ( ( ( rule__XSetLiteral__Group_3_1__0 )* ) )
            // InternalPureXbase.g:8281:1: ( ( rule__XSetLiteral__Group_3_1__0 )* )
            {
            // InternalPureXbase.g:8281:1: ( ( rule__XSetLiteral__Group_3_1__0 )* )
            // InternalPureXbase.g:8282:2: ( rule__XSetLiteral__Group_3_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getGroup_3_1()); 
            }
            // InternalPureXbase.g:8283:2: ( rule__XSetLiteral__Group_3_1__0 )*
            loop76:
            do {
                int alt76=2;
                int LA76_0 = input.LA(1);

                if ( (LA76_0==55) ) {
                    alt76=1;
                }


                switch (alt76) {
            	case 1 :
            	    // InternalPureXbase.g:8283:3: rule__XSetLiteral__Group_3_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XSetLiteral__Group_3_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop76;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getGroup_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__1__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__0"
    // InternalPureXbase.g:8292:1: rule__XSetLiteral__Group_3_1__0 : rule__XSetLiteral__Group_3_1__0__Impl rule__XSetLiteral__Group_3_1__1 ;
    public final void rule__XSetLiteral__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8296:1: ( rule__XSetLiteral__Group_3_1__0__Impl rule__XSetLiteral__Group_3_1__1 )
            // InternalPureXbase.g:8297:2: rule__XSetLiteral__Group_3_1__0__Impl rule__XSetLiteral__Group_3_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XSetLiteral__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__0"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__0__Impl"
    // InternalPureXbase.g:8304:1: rule__XSetLiteral__Group_3_1__0__Impl : ( ',' ) ;
    public final void rule__XSetLiteral__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8308:1: ( ( ',' ) )
            // InternalPureXbase.g:8309:1: ( ',' )
            {
            // InternalPureXbase.g:8309:1: ( ',' )
            // InternalPureXbase.g:8310:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getCommaKeyword_3_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__0__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__1"
    // InternalPureXbase.g:8319:1: rule__XSetLiteral__Group_3_1__1 : rule__XSetLiteral__Group_3_1__1__Impl ;
    public final void rule__XSetLiteral__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8323:1: ( rule__XSetLiteral__Group_3_1__1__Impl )
            // InternalPureXbase.g:8324:2: rule__XSetLiteral__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__1"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__1__Impl"
    // InternalPureXbase.g:8330:1: rule__XSetLiteral__Group_3_1__1__Impl : ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) ) ;
    public final void rule__XSetLiteral__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8334:1: ( ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) ) )
            // InternalPureXbase.g:8335:1: ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) )
            {
            // InternalPureXbase.g:8335:1: ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) )
            // InternalPureXbase.g:8336:2: ( rule__XSetLiteral__ElementsAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_1_1()); 
            }
            // InternalPureXbase.g:8337:2: ( rule__XSetLiteral__ElementsAssignment_3_1_1 )
            // InternalPureXbase.g:8337:3: rule__XSetLiteral__ElementsAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__ElementsAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__1__Impl"


    // $ANTLR start "rule__XListLiteral__Group__0"
    // InternalPureXbase.g:8346:1: rule__XListLiteral__Group__0 : rule__XListLiteral__Group__0__Impl rule__XListLiteral__Group__1 ;
    public final void rule__XListLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8350:1: ( rule__XListLiteral__Group__0__Impl rule__XListLiteral__Group__1 )
            // InternalPureXbase.g:8351:2: rule__XListLiteral__Group__0__Impl rule__XListLiteral__Group__1
            {
            pushFollow(FOLLOW_55);
            rule__XListLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__0"


    // $ANTLR start "rule__XListLiteral__Group__0__Impl"
    // InternalPureXbase.g:8358:1: rule__XListLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XListLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8362:1: ( ( () ) )
            // InternalPureXbase.g:8363:1: ( () )
            {
            // InternalPureXbase.g:8363:1: ( () )
            // InternalPureXbase.g:8364:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getXListLiteralAction_0()); 
            }
            // InternalPureXbase.g:8365:2: ()
            // InternalPureXbase.g:8365:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getXListLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__0__Impl"


    // $ANTLR start "rule__XListLiteral__Group__1"
    // InternalPureXbase.g:8373:1: rule__XListLiteral__Group__1 : rule__XListLiteral__Group__1__Impl rule__XListLiteral__Group__2 ;
    public final void rule__XListLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8377:1: ( rule__XListLiteral__Group__1__Impl rule__XListLiteral__Group__2 )
            // InternalPureXbase.g:8378:2: rule__XListLiteral__Group__1__Impl rule__XListLiteral__Group__2
            {
            pushFollow(FOLLOW_58);
            rule__XListLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__1"


    // $ANTLR start "rule__XListLiteral__Group__1__Impl"
    // InternalPureXbase.g:8385:1: rule__XListLiteral__Group__1__Impl : ( '#' ) ;
    public final void rule__XListLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8389:1: ( ( '#' ) )
            // InternalPureXbase.g:8390:1: ( '#' )
            {
            // InternalPureXbase.g:8390:1: ( '#' )
            // InternalPureXbase.g:8391:2: '#'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getNumberSignKeyword_1()); 
            }
            match(input,56,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getNumberSignKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__1__Impl"


    // $ANTLR start "rule__XListLiteral__Group__2"
    // InternalPureXbase.g:8400:1: rule__XListLiteral__Group__2 : rule__XListLiteral__Group__2__Impl rule__XListLiteral__Group__3 ;
    public final void rule__XListLiteral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8404:1: ( rule__XListLiteral__Group__2__Impl rule__XListLiteral__Group__3 )
            // InternalPureXbase.g:8405:2: rule__XListLiteral__Group__2__Impl rule__XListLiteral__Group__3
            {
            pushFollow(FOLLOW_59);
            rule__XListLiteral__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__2"


    // $ANTLR start "rule__XListLiteral__Group__2__Impl"
    // InternalPureXbase.g:8412:1: rule__XListLiteral__Group__2__Impl : ( '[' ) ;
    public final void rule__XListLiteral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8416:1: ( ( '[' ) )
            // InternalPureXbase.g:8417:1: ( '[' )
            {
            // InternalPureXbase.g:8417:1: ( '[' )
            // InternalPureXbase.g:8418:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getLeftSquareBracketKeyword_2()); 
            }
            match(input,59,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getLeftSquareBracketKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__2__Impl"


    // $ANTLR start "rule__XListLiteral__Group__3"
    // InternalPureXbase.g:8427:1: rule__XListLiteral__Group__3 : rule__XListLiteral__Group__3__Impl rule__XListLiteral__Group__4 ;
    public final void rule__XListLiteral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8431:1: ( rule__XListLiteral__Group__3__Impl rule__XListLiteral__Group__4 )
            // InternalPureXbase.g:8432:2: rule__XListLiteral__Group__3__Impl rule__XListLiteral__Group__4
            {
            pushFollow(FOLLOW_59);
            rule__XListLiteral__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__3"


    // $ANTLR start "rule__XListLiteral__Group__3__Impl"
    // InternalPureXbase.g:8439:1: rule__XListLiteral__Group__3__Impl : ( ( rule__XListLiteral__Group_3__0 )? ) ;
    public final void rule__XListLiteral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8443:1: ( ( ( rule__XListLiteral__Group_3__0 )? ) )
            // InternalPureXbase.g:8444:1: ( ( rule__XListLiteral__Group_3__0 )? )
            {
            // InternalPureXbase.g:8444:1: ( ( rule__XListLiteral__Group_3__0 )? )
            // InternalPureXbase.g:8445:2: ( rule__XListLiteral__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getGroup_3()); 
            }
            // InternalPureXbase.g:8446:2: ( rule__XListLiteral__Group_3__0 )?
            int alt77=2;
            int LA77_0 = input.LA(1);

            if ( ((LA77_0>=RULE_ID && LA77_0<=RULE_STRING)||LA77_0==28||(LA77_0>=35 && LA77_0<=36)||LA77_0==41||(LA77_0>=45 && LA77_0<=46)||(LA77_0>=48 && LA77_0<=49)||(LA77_0>=56 && LA77_0<=57)||LA77_0==59||LA77_0==61||LA77_0==63||(LA77_0>=66 && LA77_0<=74)||LA77_0==84) ) {
                alt77=1;
            }
            switch (alt77) {
                case 1 :
                    // InternalPureXbase.g:8446:3: rule__XListLiteral__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XListLiteral__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__3__Impl"


    // $ANTLR start "rule__XListLiteral__Group__4"
    // InternalPureXbase.g:8454:1: rule__XListLiteral__Group__4 : rule__XListLiteral__Group__4__Impl ;
    public final void rule__XListLiteral__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8458:1: ( rule__XListLiteral__Group__4__Impl )
            // InternalPureXbase.g:8459:2: rule__XListLiteral__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__4"


    // $ANTLR start "rule__XListLiteral__Group__4__Impl"
    // InternalPureXbase.g:8465:1: rule__XListLiteral__Group__4__Impl : ( ']' ) ;
    public final void rule__XListLiteral__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8469:1: ( ( ']' ) )
            // InternalPureXbase.g:8470:1: ( ']' )
            {
            // InternalPureXbase.g:8470:1: ( ']' )
            // InternalPureXbase.g:8471:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getRightSquareBracketKeyword_4()); 
            }
            match(input,60,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getRightSquareBracketKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__4__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3__0"
    // InternalPureXbase.g:8481:1: rule__XListLiteral__Group_3__0 : rule__XListLiteral__Group_3__0__Impl rule__XListLiteral__Group_3__1 ;
    public final void rule__XListLiteral__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8485:1: ( rule__XListLiteral__Group_3__0__Impl rule__XListLiteral__Group_3__1 )
            // InternalPureXbase.g:8486:2: rule__XListLiteral__Group_3__0__Impl rule__XListLiteral__Group_3__1
            {
            pushFollow(FOLLOW_54);
            rule__XListLiteral__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__0"


    // $ANTLR start "rule__XListLiteral__Group_3__0__Impl"
    // InternalPureXbase.g:8493:1: rule__XListLiteral__Group_3__0__Impl : ( ( rule__XListLiteral__ElementsAssignment_3_0 ) ) ;
    public final void rule__XListLiteral__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8497:1: ( ( ( rule__XListLiteral__ElementsAssignment_3_0 ) ) )
            // InternalPureXbase.g:8498:1: ( ( rule__XListLiteral__ElementsAssignment_3_0 ) )
            {
            // InternalPureXbase.g:8498:1: ( ( rule__XListLiteral__ElementsAssignment_3_0 ) )
            // InternalPureXbase.g:8499:2: ( rule__XListLiteral__ElementsAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_0()); 
            }
            // InternalPureXbase.g:8500:2: ( rule__XListLiteral__ElementsAssignment_3_0 )
            // InternalPureXbase.g:8500:3: rule__XListLiteral__ElementsAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__ElementsAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__0__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3__1"
    // InternalPureXbase.g:8508:1: rule__XListLiteral__Group_3__1 : rule__XListLiteral__Group_3__1__Impl ;
    public final void rule__XListLiteral__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8512:1: ( rule__XListLiteral__Group_3__1__Impl )
            // InternalPureXbase.g:8513:2: rule__XListLiteral__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__1"


    // $ANTLR start "rule__XListLiteral__Group_3__1__Impl"
    // InternalPureXbase.g:8519:1: rule__XListLiteral__Group_3__1__Impl : ( ( rule__XListLiteral__Group_3_1__0 )* ) ;
    public final void rule__XListLiteral__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8523:1: ( ( ( rule__XListLiteral__Group_3_1__0 )* ) )
            // InternalPureXbase.g:8524:1: ( ( rule__XListLiteral__Group_3_1__0 )* )
            {
            // InternalPureXbase.g:8524:1: ( ( rule__XListLiteral__Group_3_1__0 )* )
            // InternalPureXbase.g:8525:2: ( rule__XListLiteral__Group_3_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getGroup_3_1()); 
            }
            // InternalPureXbase.g:8526:2: ( rule__XListLiteral__Group_3_1__0 )*
            loop78:
            do {
                int alt78=2;
                int LA78_0 = input.LA(1);

                if ( (LA78_0==55) ) {
                    alt78=1;
                }


                switch (alt78) {
            	case 1 :
            	    // InternalPureXbase.g:8526:3: rule__XListLiteral__Group_3_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XListLiteral__Group_3_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop78;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getGroup_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__1__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3_1__0"
    // InternalPureXbase.g:8535:1: rule__XListLiteral__Group_3_1__0 : rule__XListLiteral__Group_3_1__0__Impl rule__XListLiteral__Group_3_1__1 ;
    public final void rule__XListLiteral__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8539:1: ( rule__XListLiteral__Group_3_1__0__Impl rule__XListLiteral__Group_3_1__1 )
            // InternalPureXbase.g:8540:2: rule__XListLiteral__Group_3_1__0__Impl rule__XListLiteral__Group_3_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XListLiteral__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__0"


    // $ANTLR start "rule__XListLiteral__Group_3_1__0__Impl"
    // InternalPureXbase.g:8547:1: rule__XListLiteral__Group_3_1__0__Impl : ( ',' ) ;
    public final void rule__XListLiteral__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8551:1: ( ( ',' ) )
            // InternalPureXbase.g:8552:1: ( ',' )
            {
            // InternalPureXbase.g:8552:1: ( ',' )
            // InternalPureXbase.g:8553:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getCommaKeyword_3_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__0__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3_1__1"
    // InternalPureXbase.g:8562:1: rule__XListLiteral__Group_3_1__1 : rule__XListLiteral__Group_3_1__1__Impl ;
    public final void rule__XListLiteral__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8566:1: ( rule__XListLiteral__Group_3_1__1__Impl )
            // InternalPureXbase.g:8567:2: rule__XListLiteral__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__1"


    // $ANTLR start "rule__XListLiteral__Group_3_1__1__Impl"
    // InternalPureXbase.g:8573:1: rule__XListLiteral__Group_3_1__1__Impl : ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) ) ;
    public final void rule__XListLiteral__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8577:1: ( ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) ) )
            // InternalPureXbase.g:8578:1: ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) )
            {
            // InternalPureXbase.g:8578:1: ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) )
            // InternalPureXbase.g:8579:2: ( rule__XListLiteral__ElementsAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_1_1()); 
            }
            // InternalPureXbase.g:8580:2: ( rule__XListLiteral__ElementsAssignment_3_1_1 )
            // InternalPureXbase.g:8580:3: rule__XListLiteral__ElementsAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__ElementsAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__1__Impl"


    // $ANTLR start "rule__XClosure__Group__0"
    // InternalPureXbase.g:8589:1: rule__XClosure__Group__0 : rule__XClosure__Group__0__Impl rule__XClosure__Group__1 ;
    public final void rule__XClosure__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8593:1: ( rule__XClosure__Group__0__Impl rule__XClosure__Group__1 )
            // InternalPureXbase.g:8594:2: rule__XClosure__Group__0__Impl rule__XClosure__Group__1
            {
            pushFollow(FOLLOW_60);
            rule__XClosure__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__0"


    // $ANTLR start "rule__XClosure__Group__0__Impl"
    // InternalPureXbase.g:8601:1: rule__XClosure__Group__0__Impl : ( ( rule__XClosure__Group_0__0 ) ) ;
    public final void rule__XClosure__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8605:1: ( ( ( rule__XClosure__Group_0__0 ) ) )
            // InternalPureXbase.g:8606:1: ( ( rule__XClosure__Group_0__0 ) )
            {
            // InternalPureXbase.g:8606:1: ( ( rule__XClosure__Group_0__0 ) )
            // InternalPureXbase.g:8607:2: ( rule__XClosure__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_0()); 
            }
            // InternalPureXbase.g:8608:2: ( rule__XClosure__Group_0__0 )
            // InternalPureXbase.g:8608:3: rule__XClosure__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__0__Impl"


    // $ANTLR start "rule__XClosure__Group__1"
    // InternalPureXbase.g:8616:1: rule__XClosure__Group__1 : rule__XClosure__Group__1__Impl rule__XClosure__Group__2 ;
    public final void rule__XClosure__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8620:1: ( rule__XClosure__Group__1__Impl rule__XClosure__Group__2 )
            // InternalPureXbase.g:8621:2: rule__XClosure__Group__1__Impl rule__XClosure__Group__2
            {
            pushFollow(FOLLOW_60);
            rule__XClosure__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__1"


    // $ANTLR start "rule__XClosure__Group__1__Impl"
    // InternalPureXbase.g:8628:1: rule__XClosure__Group__1__Impl : ( ( rule__XClosure__Group_1__0 )? ) ;
    public final void rule__XClosure__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8632:1: ( ( ( rule__XClosure__Group_1__0 )? ) )
            // InternalPureXbase.g:8633:1: ( ( rule__XClosure__Group_1__0 )? )
            {
            // InternalPureXbase.g:8633:1: ( ( rule__XClosure__Group_1__0 )? )
            // InternalPureXbase.g:8634:2: ( rule__XClosure__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:8635:2: ( rule__XClosure__Group_1__0 )?
            int alt79=2;
            alt79 = dfa79.predict(input);
            switch (alt79) {
                case 1 :
                    // InternalPureXbase.g:8635:3: rule__XClosure__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XClosure__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__1__Impl"


    // $ANTLR start "rule__XClosure__Group__2"
    // InternalPureXbase.g:8643:1: rule__XClosure__Group__2 : rule__XClosure__Group__2__Impl rule__XClosure__Group__3 ;
    public final void rule__XClosure__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8647:1: ( rule__XClosure__Group__2__Impl rule__XClosure__Group__3 )
            // InternalPureXbase.g:8648:2: rule__XClosure__Group__2__Impl rule__XClosure__Group__3
            {
            pushFollow(FOLLOW_61);
            rule__XClosure__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__2"


    // $ANTLR start "rule__XClosure__Group__2__Impl"
    // InternalPureXbase.g:8655:1: rule__XClosure__Group__2__Impl : ( ( rule__XClosure__ExpressionAssignment_2 ) ) ;
    public final void rule__XClosure__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8659:1: ( ( ( rule__XClosure__ExpressionAssignment_2 ) ) )
            // InternalPureXbase.g:8660:1: ( ( rule__XClosure__ExpressionAssignment_2 ) )
            {
            // InternalPureXbase.g:8660:1: ( ( rule__XClosure__ExpressionAssignment_2 ) )
            // InternalPureXbase.g:8661:2: ( rule__XClosure__ExpressionAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExpressionAssignment_2()); 
            }
            // InternalPureXbase.g:8662:2: ( rule__XClosure__ExpressionAssignment_2 )
            // InternalPureXbase.g:8662:3: rule__XClosure__ExpressionAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__ExpressionAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__2__Impl"


    // $ANTLR start "rule__XClosure__Group__3"
    // InternalPureXbase.g:8670:1: rule__XClosure__Group__3 : rule__XClosure__Group__3__Impl ;
    public final void rule__XClosure__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8674:1: ( rule__XClosure__Group__3__Impl )
            // InternalPureXbase.g:8675:2: rule__XClosure__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__3"


    // $ANTLR start "rule__XClosure__Group__3__Impl"
    // InternalPureXbase.g:8681:1: rule__XClosure__Group__3__Impl : ( ']' ) ;
    public final void rule__XClosure__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8685:1: ( ( ']' ) )
            // InternalPureXbase.g:8686:1: ( ']' )
            {
            // InternalPureXbase.g:8686:1: ( ']' )
            // InternalPureXbase.g:8687:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getRightSquareBracketKeyword_3()); 
            }
            match(input,60,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getRightSquareBracketKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__3__Impl"


    // $ANTLR start "rule__XClosure__Group_0__0"
    // InternalPureXbase.g:8697:1: rule__XClosure__Group_0__0 : rule__XClosure__Group_0__0__Impl ;
    public final void rule__XClosure__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8701:1: ( rule__XClosure__Group_0__0__Impl )
            // InternalPureXbase.g:8702:2: rule__XClosure__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0__0"


    // $ANTLR start "rule__XClosure__Group_0__0__Impl"
    // InternalPureXbase.g:8708:1: rule__XClosure__Group_0__0__Impl : ( ( rule__XClosure__Group_0_0__0 ) ) ;
    public final void rule__XClosure__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8712:1: ( ( ( rule__XClosure__Group_0_0__0 ) ) )
            // InternalPureXbase.g:8713:1: ( ( rule__XClosure__Group_0_0__0 ) )
            {
            // InternalPureXbase.g:8713:1: ( ( rule__XClosure__Group_0_0__0 ) )
            // InternalPureXbase.g:8714:2: ( rule__XClosure__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_0_0()); 
            }
            // InternalPureXbase.g:8715:2: ( rule__XClosure__Group_0_0__0 )
            // InternalPureXbase.g:8715:3: rule__XClosure__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_0_0__0"
    // InternalPureXbase.g:8724:1: rule__XClosure__Group_0_0__0 : rule__XClosure__Group_0_0__0__Impl rule__XClosure__Group_0_0__1 ;
    public final void rule__XClosure__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8728:1: ( rule__XClosure__Group_0_0__0__Impl rule__XClosure__Group_0_0__1 )
            // InternalPureXbase.g:8729:2: rule__XClosure__Group_0_0__0__Impl rule__XClosure__Group_0_0__1
            {
            pushFollow(FOLLOW_58);
            rule__XClosure__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__0"


    // $ANTLR start "rule__XClosure__Group_0_0__0__Impl"
    // InternalPureXbase.g:8736:1: rule__XClosure__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XClosure__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8740:1: ( ( () ) )
            // InternalPureXbase.g:8741:1: ( () )
            {
            // InternalPureXbase.g:8741:1: ( () )
            // InternalPureXbase.g:8742:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getXClosureAction_0_0_0()); 
            }
            // InternalPureXbase.g:8743:2: ()
            // InternalPureXbase.g:8743:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getXClosureAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_0_0__1"
    // InternalPureXbase.g:8751:1: rule__XClosure__Group_0_0__1 : rule__XClosure__Group_0_0__1__Impl ;
    public final void rule__XClosure__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8755:1: ( rule__XClosure__Group_0_0__1__Impl )
            // InternalPureXbase.g:8756:2: rule__XClosure__Group_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__1"


    // $ANTLR start "rule__XClosure__Group_0_0__1__Impl"
    // InternalPureXbase.g:8762:1: rule__XClosure__Group_0_0__1__Impl : ( '[' ) ;
    public final void rule__XClosure__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8766:1: ( ( '[' ) )
            // InternalPureXbase.g:8767:1: ( '[' )
            {
            // InternalPureXbase.g:8767:1: ( '[' )
            // InternalPureXbase.g:8768:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getLeftSquareBracketKeyword_0_0_1()); 
            }
            match(input,59,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getLeftSquareBracketKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__1__Impl"


    // $ANTLR start "rule__XClosure__Group_1__0"
    // InternalPureXbase.g:8778:1: rule__XClosure__Group_1__0 : rule__XClosure__Group_1__0__Impl ;
    public final void rule__XClosure__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8782:1: ( rule__XClosure__Group_1__0__Impl )
            // InternalPureXbase.g:8783:2: rule__XClosure__Group_1__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1__0"


    // $ANTLR start "rule__XClosure__Group_1__0__Impl"
    // InternalPureXbase.g:8789:1: rule__XClosure__Group_1__0__Impl : ( ( rule__XClosure__Group_1_0__0 ) ) ;
    public final void rule__XClosure__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8793:1: ( ( ( rule__XClosure__Group_1_0__0 ) ) )
            // InternalPureXbase.g:8794:1: ( ( rule__XClosure__Group_1_0__0 ) )
            {
            // InternalPureXbase.g:8794:1: ( ( rule__XClosure__Group_1_0__0 ) )
            // InternalPureXbase.g:8795:2: ( rule__XClosure__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1_0()); 
            }
            // InternalPureXbase.g:8796:2: ( rule__XClosure__Group_1_0__0 )
            // InternalPureXbase.g:8796:3: rule__XClosure__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0__0"
    // InternalPureXbase.g:8805:1: rule__XClosure__Group_1_0__0 : rule__XClosure__Group_1_0__0__Impl rule__XClosure__Group_1_0__1 ;
    public final void rule__XClosure__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8809:1: ( rule__XClosure__Group_1_0__0__Impl rule__XClosure__Group_1_0__1 )
            // InternalPureXbase.g:8810:2: rule__XClosure__Group_1_0__0__Impl rule__XClosure__Group_1_0__1
            {
            pushFollow(FOLLOW_62);
            rule__XClosure__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__0"


    // $ANTLR start "rule__XClosure__Group_1_0__0__Impl"
    // InternalPureXbase.g:8817:1: rule__XClosure__Group_1_0__0__Impl : ( ( rule__XClosure__Group_1_0_0__0 )? ) ;
    public final void rule__XClosure__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8821:1: ( ( ( rule__XClosure__Group_1_0_0__0 )? ) )
            // InternalPureXbase.g:8822:1: ( ( rule__XClosure__Group_1_0_0__0 )? )
            {
            // InternalPureXbase.g:8822:1: ( ( rule__XClosure__Group_1_0_0__0 )? )
            // InternalPureXbase.g:8823:2: ( rule__XClosure__Group_1_0_0__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1_0_0()); 
            }
            // InternalPureXbase.g:8824:2: ( rule__XClosure__Group_1_0_0__0 )?
            int alt80=2;
            int LA80_0 = input.LA(1);

            if ( (LA80_0==RULE_ID||LA80_0==32||LA80_0==49) ) {
                alt80=1;
            }
            switch (alt80) {
                case 1 :
                    // InternalPureXbase.g:8824:3: rule__XClosure__Group_1_0_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XClosure__Group_1_0_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0__1"
    // InternalPureXbase.g:8832:1: rule__XClosure__Group_1_0__1 : rule__XClosure__Group_1_0__1__Impl ;
    public final void rule__XClosure__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8836:1: ( rule__XClosure__Group_1_0__1__Impl )
            // InternalPureXbase.g:8837:2: rule__XClosure__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__1"


    // $ANTLR start "rule__XClosure__Group_1_0__1__Impl"
    // InternalPureXbase.g:8843:1: rule__XClosure__Group_1_0__1__Impl : ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) ) ;
    public final void rule__XClosure__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8847:1: ( ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) ) )
            // InternalPureXbase.g:8848:1: ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) )
            {
            // InternalPureXbase.g:8848:1: ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) )
            // InternalPureXbase.g:8849:2: ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExplicitSyntaxAssignment_1_0_1()); 
            }
            // InternalPureXbase.g:8850:2: ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 )
            // InternalPureXbase.g:8850:3: rule__XClosure__ExplicitSyntaxAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__ExplicitSyntaxAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExplicitSyntaxAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__1__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0__0"
    // InternalPureXbase.g:8859:1: rule__XClosure__Group_1_0_0__0 : rule__XClosure__Group_1_0_0__0__Impl rule__XClosure__Group_1_0_0__1 ;
    public final void rule__XClosure__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8863:1: ( rule__XClosure__Group_1_0_0__0__Impl rule__XClosure__Group_1_0_0__1 )
            // InternalPureXbase.g:8864:2: rule__XClosure__Group_1_0_0__0__Impl rule__XClosure__Group_1_0_0__1
            {
            pushFollow(FOLLOW_54);
            rule__XClosure__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__0"


    // $ANTLR start "rule__XClosure__Group_1_0_0__0__Impl"
    // InternalPureXbase.g:8871:1: rule__XClosure__Group_1_0_0__0__Impl : ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) ) ;
    public final void rule__XClosure__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8875:1: ( ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) ) )
            // InternalPureXbase.g:8876:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) )
            {
            // InternalPureXbase.g:8876:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) )
            // InternalPureXbase.g:8877:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_0()); 
            }
            // InternalPureXbase.g:8878:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 )
            // InternalPureXbase.g:8878:3: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0__1"
    // InternalPureXbase.g:8886:1: rule__XClosure__Group_1_0_0__1 : rule__XClosure__Group_1_0_0__1__Impl ;
    public final void rule__XClosure__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8890:1: ( rule__XClosure__Group_1_0_0__1__Impl )
            // InternalPureXbase.g:8891:2: rule__XClosure__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__1"


    // $ANTLR start "rule__XClosure__Group_1_0_0__1__Impl"
    // InternalPureXbase.g:8897:1: rule__XClosure__Group_1_0_0__1__Impl : ( ( rule__XClosure__Group_1_0_0_1__0 )* ) ;
    public final void rule__XClosure__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8901:1: ( ( ( rule__XClosure__Group_1_0_0_1__0 )* ) )
            // InternalPureXbase.g:8902:1: ( ( rule__XClosure__Group_1_0_0_1__0 )* )
            {
            // InternalPureXbase.g:8902:1: ( ( rule__XClosure__Group_1_0_0_1__0 )* )
            // InternalPureXbase.g:8903:2: ( rule__XClosure__Group_1_0_0_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1_0_0_1()); 
            }
            // InternalPureXbase.g:8904:2: ( rule__XClosure__Group_1_0_0_1__0 )*
            loop81:
            do {
                int alt81=2;
                int LA81_0 = input.LA(1);

                if ( (LA81_0==55) ) {
                    alt81=1;
                }


                switch (alt81) {
            	case 1 :
            	    // InternalPureXbase.g:8904:3: rule__XClosure__Group_1_0_0_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XClosure__Group_1_0_0_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop81;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__0"
    // InternalPureXbase.g:8913:1: rule__XClosure__Group_1_0_0_1__0 : rule__XClosure__Group_1_0_0_1__0__Impl rule__XClosure__Group_1_0_0_1__1 ;
    public final void rule__XClosure__Group_1_0_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8917:1: ( rule__XClosure__Group_1_0_0_1__0__Impl rule__XClosure__Group_1_0_0_1__1 )
            // InternalPureXbase.g:8918:2: rule__XClosure__Group_1_0_0_1__0__Impl rule__XClosure__Group_1_0_0_1__1
            {
            pushFollow(FOLLOW_15);
            rule__XClosure__Group_1_0_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__0"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__0__Impl"
    // InternalPureXbase.g:8925:1: rule__XClosure__Group_1_0_0_1__0__Impl : ( ',' ) ;
    public final void rule__XClosure__Group_1_0_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8929:1: ( ( ',' ) )
            // InternalPureXbase.g:8930:1: ( ',' )
            {
            // InternalPureXbase.g:8930:1: ( ',' )
            // InternalPureXbase.g:8931:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getCommaKeyword_1_0_0_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getCommaKeyword_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__1"
    // InternalPureXbase.g:8940:1: rule__XClosure__Group_1_0_0_1__1 : rule__XClosure__Group_1_0_0_1__1__Impl ;
    public final void rule__XClosure__Group_1_0_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8944:1: ( rule__XClosure__Group_1_0_0_1__1__Impl )
            // InternalPureXbase.g:8945:2: rule__XClosure__Group_1_0_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__1"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__1__Impl"
    // InternalPureXbase.g:8951:1: rule__XClosure__Group_1_0_0_1__1__Impl : ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) ) ;
    public final void rule__XClosure__Group_1_0_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8955:1: ( ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) ) )
            // InternalPureXbase.g:8956:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) )
            {
            // InternalPureXbase.g:8956:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) )
            // InternalPureXbase.g:8957:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_1_1()); 
            }
            // InternalPureXbase.g:8958:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 )
            // InternalPureXbase.g:8958:3: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__1__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group__0"
    // InternalPureXbase.g:8967:1: rule__XExpressionInClosure__Group__0 : rule__XExpressionInClosure__Group__0__Impl rule__XExpressionInClosure__Group__1 ;
    public final void rule__XExpressionInClosure__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8971:1: ( rule__XExpressionInClosure__Group__0__Impl rule__XExpressionInClosure__Group__1 )
            // InternalPureXbase.g:8972:2: rule__XExpressionInClosure__Group__0__Impl rule__XExpressionInClosure__Group__1
            {
            pushFollow(FOLLOW_60);
            rule__XExpressionInClosure__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__0"


    // $ANTLR start "rule__XExpressionInClosure__Group__0__Impl"
    // InternalPureXbase.g:8979:1: rule__XExpressionInClosure__Group__0__Impl : ( () ) ;
    public final void rule__XExpressionInClosure__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8983:1: ( ( () ) )
            // InternalPureXbase.g:8984:1: ( () )
            {
            // InternalPureXbase.g:8984:1: ( () )
            // InternalPureXbase.g:8985:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getXBlockExpressionAction_0()); 
            }
            // InternalPureXbase.g:8986:2: ()
            // InternalPureXbase.g:8986:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getXBlockExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__0__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group__1"
    // InternalPureXbase.g:8994:1: rule__XExpressionInClosure__Group__1 : rule__XExpressionInClosure__Group__1__Impl ;
    public final void rule__XExpressionInClosure__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:8998:1: ( rule__XExpressionInClosure__Group__1__Impl )
            // InternalPureXbase.g:8999:2: rule__XExpressionInClosure__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__1"


    // $ANTLR start "rule__XExpressionInClosure__Group__1__Impl"
    // InternalPureXbase.g:9005:1: rule__XExpressionInClosure__Group__1__Impl : ( ( rule__XExpressionInClosure__Group_1__0 )* ) ;
    public final void rule__XExpressionInClosure__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9009:1: ( ( ( rule__XExpressionInClosure__Group_1__0 )* ) )
            // InternalPureXbase.g:9010:1: ( ( rule__XExpressionInClosure__Group_1__0 )* )
            {
            // InternalPureXbase.g:9010:1: ( ( rule__XExpressionInClosure__Group_1__0 )* )
            // InternalPureXbase.g:9011:2: ( rule__XExpressionInClosure__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:9012:2: ( rule__XExpressionInClosure__Group_1__0 )*
            loop82:
            do {
                int alt82=2;
                int LA82_0 = input.LA(1);

                if ( ((LA82_0>=RULE_ID && LA82_0<=RULE_STRING)||LA82_0==16||LA82_0==28||(LA82_0>=35 && LA82_0<=36)||LA82_0==41||(LA82_0>=45 && LA82_0<=46)||(LA82_0>=48 && LA82_0<=49)||(LA82_0>=56 && LA82_0<=57)||LA82_0==59||LA82_0==61||LA82_0==63||(LA82_0>=66 && LA82_0<=74)||LA82_0==80||LA82_0==84) ) {
                    alt82=1;
                }


                switch (alt82) {
            	case 1 :
            	    // InternalPureXbase.g:9012:3: rule__XExpressionInClosure__Group_1__0
            	    {
            	    pushFollow(FOLLOW_6);
            	    rule__XExpressionInClosure__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop82;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__1__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__0"
    // InternalPureXbase.g:9021:1: rule__XExpressionInClosure__Group_1__0 : rule__XExpressionInClosure__Group_1__0__Impl rule__XExpressionInClosure__Group_1__1 ;
    public final void rule__XExpressionInClosure__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9025:1: ( rule__XExpressionInClosure__Group_1__0__Impl rule__XExpressionInClosure__Group_1__1 )
            // InternalPureXbase.g:9026:2: rule__XExpressionInClosure__Group_1__0__Impl rule__XExpressionInClosure__Group_1__1
            {
            pushFollow(FOLLOW_7);
            rule__XExpressionInClosure__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__0"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__0__Impl"
    // InternalPureXbase.g:9033:1: rule__XExpressionInClosure__Group_1__0__Impl : ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) ) ;
    public final void rule__XExpressionInClosure__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9037:1: ( ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) ) )
            // InternalPureXbase.g:9038:1: ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) )
            {
            // InternalPureXbase.g:9038:1: ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) )
            // InternalPureXbase.g:9039:2: ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getExpressionsAssignment_1_0()); 
            }
            // InternalPureXbase.g:9040:2: ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 )
            // InternalPureXbase.g:9040:3: rule__XExpressionInClosure__ExpressionsAssignment_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__ExpressionsAssignment_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getExpressionsAssignment_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__0__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__1"
    // InternalPureXbase.g:9048:1: rule__XExpressionInClosure__Group_1__1 : rule__XExpressionInClosure__Group_1__1__Impl ;
    public final void rule__XExpressionInClosure__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9052:1: ( rule__XExpressionInClosure__Group_1__1__Impl )
            // InternalPureXbase.g:9053:2: rule__XExpressionInClosure__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__1"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__1__Impl"
    // InternalPureXbase.g:9059:1: rule__XExpressionInClosure__Group_1__1__Impl : ( ( ';' )? ) ;
    public final void rule__XExpressionInClosure__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9063:1: ( ( ( ';' )? ) )
            // InternalPureXbase.g:9064:1: ( ( ';' )? )
            {
            // InternalPureXbase.g:9064:1: ( ( ';' )? )
            // InternalPureXbase.g:9065:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getSemicolonKeyword_1_1()); 
            }
            // InternalPureXbase.g:9066:2: ( ';' )?
            int alt83=2;
            int LA83_0 = input.LA(1);

            if ( (LA83_0==47) ) {
                alt83=1;
            }
            switch (alt83) {
                case 1 :
                    // InternalPureXbase.g:9066:3: ';'
                    {
                    match(input,47,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getSemicolonKeyword_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group__0"
    // InternalPureXbase.g:9075:1: rule__XShortClosure__Group__0 : rule__XShortClosure__Group__0__Impl rule__XShortClosure__Group__1 ;
    public final void rule__XShortClosure__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9079:1: ( rule__XShortClosure__Group__0__Impl rule__XShortClosure__Group__1 )
            // InternalPureXbase.g:9080:2: rule__XShortClosure__Group__0__Impl rule__XShortClosure__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__XShortClosure__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__0"


    // $ANTLR start "rule__XShortClosure__Group__0__Impl"
    // InternalPureXbase.g:9087:1: rule__XShortClosure__Group__0__Impl : ( ( rule__XShortClosure__Group_0__0 ) ) ;
    public final void rule__XShortClosure__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9091:1: ( ( ( rule__XShortClosure__Group_0__0 ) ) )
            // InternalPureXbase.g:9092:1: ( ( rule__XShortClosure__Group_0__0 ) )
            {
            // InternalPureXbase.g:9092:1: ( ( rule__XShortClosure__Group_0__0 ) )
            // InternalPureXbase.g:9093:2: ( rule__XShortClosure__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0()); 
            }
            // InternalPureXbase.g:9094:2: ( rule__XShortClosure__Group_0__0 )
            // InternalPureXbase.g:9094:3: rule__XShortClosure__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group__1"
    // InternalPureXbase.g:9102:1: rule__XShortClosure__Group__1 : rule__XShortClosure__Group__1__Impl ;
    public final void rule__XShortClosure__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9106:1: ( rule__XShortClosure__Group__1__Impl )
            // InternalPureXbase.g:9107:2: rule__XShortClosure__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__1"


    // $ANTLR start "rule__XShortClosure__Group__1__Impl"
    // InternalPureXbase.g:9113:1: rule__XShortClosure__Group__1__Impl : ( ( rule__XShortClosure__ExpressionAssignment_1 ) ) ;
    public final void rule__XShortClosure__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9117:1: ( ( ( rule__XShortClosure__ExpressionAssignment_1 ) ) )
            // InternalPureXbase.g:9118:1: ( ( rule__XShortClosure__ExpressionAssignment_1 ) )
            {
            // InternalPureXbase.g:9118:1: ( ( rule__XShortClosure__ExpressionAssignment_1 ) )
            // InternalPureXbase.g:9119:2: ( rule__XShortClosure__ExpressionAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExpressionAssignment_1()); 
            }
            // InternalPureXbase.g:9120:2: ( rule__XShortClosure__ExpressionAssignment_1 )
            // InternalPureXbase.g:9120:3: rule__XShortClosure__ExpressionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__ExpressionAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExpressionAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0__0"
    // InternalPureXbase.g:9129:1: rule__XShortClosure__Group_0__0 : rule__XShortClosure__Group_0__0__Impl ;
    public final void rule__XShortClosure__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9133:1: ( rule__XShortClosure__Group_0__0__Impl )
            // InternalPureXbase.g:9134:2: rule__XShortClosure__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0__0"


    // $ANTLR start "rule__XShortClosure__Group_0__0__Impl"
    // InternalPureXbase.g:9140:1: rule__XShortClosure__Group_0__0__Impl : ( ( rule__XShortClosure__Group_0_0__0 ) ) ;
    public final void rule__XShortClosure__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9144:1: ( ( ( rule__XShortClosure__Group_0_0__0 ) ) )
            // InternalPureXbase.g:9145:1: ( ( rule__XShortClosure__Group_0_0__0 ) )
            {
            // InternalPureXbase.g:9145:1: ( ( rule__XShortClosure__Group_0_0__0 ) )
            // InternalPureXbase.g:9146:2: ( rule__XShortClosure__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0_0()); 
            }
            // InternalPureXbase.g:9147:2: ( rule__XShortClosure__Group_0_0__0 )
            // InternalPureXbase.g:9147:3: rule__XShortClosure__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0__0"
    // InternalPureXbase.g:9156:1: rule__XShortClosure__Group_0_0__0 : rule__XShortClosure__Group_0_0__0__Impl rule__XShortClosure__Group_0_0__1 ;
    public final void rule__XShortClosure__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9160:1: ( rule__XShortClosure__Group_0_0__0__Impl rule__XShortClosure__Group_0_0__1 )
            // InternalPureXbase.g:9161:2: rule__XShortClosure__Group_0_0__0__Impl rule__XShortClosure__Group_0_0__1
            {
            pushFollow(FOLLOW_62);
            rule__XShortClosure__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__0"


    // $ANTLR start "rule__XShortClosure__Group_0_0__0__Impl"
    // InternalPureXbase.g:9168:1: rule__XShortClosure__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XShortClosure__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9172:1: ( ( () ) )
            // InternalPureXbase.g:9173:1: ( () )
            {
            // InternalPureXbase.g:9173:1: ( () )
            // InternalPureXbase.g:9174:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getXClosureAction_0_0_0()); 
            }
            // InternalPureXbase.g:9175:2: ()
            // InternalPureXbase.g:9175:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getXClosureAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0__1"
    // InternalPureXbase.g:9183:1: rule__XShortClosure__Group_0_0__1 : rule__XShortClosure__Group_0_0__1__Impl rule__XShortClosure__Group_0_0__2 ;
    public final void rule__XShortClosure__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9187:1: ( rule__XShortClosure__Group_0_0__1__Impl rule__XShortClosure__Group_0_0__2 )
            // InternalPureXbase.g:9188:2: rule__XShortClosure__Group_0_0__1__Impl rule__XShortClosure__Group_0_0__2
            {
            pushFollow(FOLLOW_62);
            rule__XShortClosure__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__1"


    // $ANTLR start "rule__XShortClosure__Group_0_0__1__Impl"
    // InternalPureXbase.g:9195:1: rule__XShortClosure__Group_0_0__1__Impl : ( ( rule__XShortClosure__Group_0_0_1__0 )? ) ;
    public final void rule__XShortClosure__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9199:1: ( ( ( rule__XShortClosure__Group_0_0_1__0 )? ) )
            // InternalPureXbase.g:9200:1: ( ( rule__XShortClosure__Group_0_0_1__0 )? )
            {
            // InternalPureXbase.g:9200:1: ( ( rule__XShortClosure__Group_0_0_1__0 )? )
            // InternalPureXbase.g:9201:2: ( rule__XShortClosure__Group_0_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0_0_1()); 
            }
            // InternalPureXbase.g:9202:2: ( rule__XShortClosure__Group_0_0_1__0 )?
            int alt84=2;
            int LA84_0 = input.LA(1);

            if ( (LA84_0==RULE_ID||LA84_0==32||LA84_0==49) ) {
                alt84=1;
            }
            switch (alt84) {
                case 1 :
                    // InternalPureXbase.g:9202:3: rule__XShortClosure__Group_0_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XShortClosure__Group_0_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0__2"
    // InternalPureXbase.g:9210:1: rule__XShortClosure__Group_0_0__2 : rule__XShortClosure__Group_0_0__2__Impl ;
    public final void rule__XShortClosure__Group_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9214:1: ( rule__XShortClosure__Group_0_0__2__Impl )
            // InternalPureXbase.g:9215:2: rule__XShortClosure__Group_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__2"


    // $ANTLR start "rule__XShortClosure__Group_0_0__2__Impl"
    // InternalPureXbase.g:9221:1: rule__XShortClosure__Group_0_0__2__Impl : ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) ) ;
    public final void rule__XShortClosure__Group_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9225:1: ( ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) ) )
            // InternalPureXbase.g:9226:1: ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) )
            {
            // InternalPureXbase.g:9226:1: ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) )
            // InternalPureXbase.g:9227:2: ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExplicitSyntaxAssignment_0_0_2()); 
            }
            // InternalPureXbase.g:9228:2: ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 )
            // InternalPureXbase.g:9228:3: rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExplicitSyntaxAssignment_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__2__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__0"
    // InternalPureXbase.g:9237:1: rule__XShortClosure__Group_0_0_1__0 : rule__XShortClosure__Group_0_0_1__0__Impl rule__XShortClosure__Group_0_0_1__1 ;
    public final void rule__XShortClosure__Group_0_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9241:1: ( rule__XShortClosure__Group_0_0_1__0__Impl rule__XShortClosure__Group_0_0_1__1 )
            // InternalPureXbase.g:9242:2: rule__XShortClosure__Group_0_0_1__0__Impl rule__XShortClosure__Group_0_0_1__1
            {
            pushFollow(FOLLOW_54);
            rule__XShortClosure__Group_0_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__0"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__0__Impl"
    // InternalPureXbase.g:9249:1: rule__XShortClosure__Group_0_0_1__0__Impl : ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) ) ;
    public final void rule__XShortClosure__Group_0_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9253:1: ( ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) ) )
            // InternalPureXbase.g:9254:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) )
            {
            // InternalPureXbase.g:9254:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) )
            // InternalPureXbase.g:9255:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_0()); 
            }
            // InternalPureXbase.g:9256:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 )
            // InternalPureXbase.g:9256:3: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__1"
    // InternalPureXbase.g:9264:1: rule__XShortClosure__Group_0_0_1__1 : rule__XShortClosure__Group_0_0_1__1__Impl ;
    public final void rule__XShortClosure__Group_0_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9268:1: ( rule__XShortClosure__Group_0_0_1__1__Impl )
            // InternalPureXbase.g:9269:2: rule__XShortClosure__Group_0_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__1"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__1__Impl"
    // InternalPureXbase.g:9275:1: rule__XShortClosure__Group_0_0_1__1__Impl : ( ( rule__XShortClosure__Group_0_0_1_1__0 )* ) ;
    public final void rule__XShortClosure__Group_0_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9279:1: ( ( ( rule__XShortClosure__Group_0_0_1_1__0 )* ) )
            // InternalPureXbase.g:9280:1: ( ( rule__XShortClosure__Group_0_0_1_1__0 )* )
            {
            // InternalPureXbase.g:9280:1: ( ( rule__XShortClosure__Group_0_0_1_1__0 )* )
            // InternalPureXbase.g:9281:2: ( rule__XShortClosure__Group_0_0_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0_0_1_1()); 
            }
            // InternalPureXbase.g:9282:2: ( rule__XShortClosure__Group_0_0_1_1__0 )*
            loop85:
            do {
                int alt85=2;
                int LA85_0 = input.LA(1);

                if ( (LA85_0==55) ) {
                    alt85=1;
                }


                switch (alt85) {
            	case 1 :
            	    // InternalPureXbase.g:9282:3: rule__XShortClosure__Group_0_0_1_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XShortClosure__Group_0_0_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop85;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__0"
    // InternalPureXbase.g:9291:1: rule__XShortClosure__Group_0_0_1_1__0 : rule__XShortClosure__Group_0_0_1_1__0__Impl rule__XShortClosure__Group_0_0_1_1__1 ;
    public final void rule__XShortClosure__Group_0_0_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9295:1: ( rule__XShortClosure__Group_0_0_1_1__0__Impl rule__XShortClosure__Group_0_0_1_1__1 )
            // InternalPureXbase.g:9296:2: rule__XShortClosure__Group_0_0_1_1__0__Impl rule__XShortClosure__Group_0_0_1_1__1
            {
            pushFollow(FOLLOW_15);
            rule__XShortClosure__Group_0_0_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__0"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__0__Impl"
    // InternalPureXbase.g:9303:1: rule__XShortClosure__Group_0_0_1_1__0__Impl : ( ',' ) ;
    public final void rule__XShortClosure__Group_0_0_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9307:1: ( ( ',' ) )
            // InternalPureXbase.g:9308:1: ( ',' )
            {
            // InternalPureXbase.g:9308:1: ( ',' )
            // InternalPureXbase.g:9309:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getCommaKeyword_0_0_1_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getCommaKeyword_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__1"
    // InternalPureXbase.g:9318:1: rule__XShortClosure__Group_0_0_1_1__1 : rule__XShortClosure__Group_0_0_1_1__1__Impl ;
    public final void rule__XShortClosure__Group_0_0_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9322:1: ( rule__XShortClosure__Group_0_0_1_1__1__Impl )
            // InternalPureXbase.g:9323:2: rule__XShortClosure__Group_0_0_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__1"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__1__Impl"
    // InternalPureXbase.g:9329:1: rule__XShortClosure__Group_0_0_1_1__1__Impl : ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) ) ;
    public final void rule__XShortClosure__Group_0_0_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9333:1: ( ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) ) )
            // InternalPureXbase.g:9334:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) )
            {
            // InternalPureXbase.g:9334:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) )
            // InternalPureXbase.g:9335:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_1_1()); 
            }
            // InternalPureXbase.g:9336:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 )
            // InternalPureXbase.g:9336:3: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__1__Impl"


    // $ANTLR start "rule__XParenthesizedExpression__Group__0"
    // InternalPureXbase.g:9345:1: rule__XParenthesizedExpression__Group__0 : rule__XParenthesizedExpression__Group__0__Impl rule__XParenthesizedExpression__Group__1 ;
    public final void rule__XParenthesizedExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9349:1: ( rule__XParenthesizedExpression__Group__0__Impl rule__XParenthesizedExpression__Group__1 )
            // InternalPureXbase.g:9350:2: rule__XParenthesizedExpression__Group__0__Impl rule__XParenthesizedExpression__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__XParenthesizedExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__0"


    // $ANTLR start "rule__XParenthesizedExpression__Group__0__Impl"
    // InternalPureXbase.g:9357:1: rule__XParenthesizedExpression__Group__0__Impl : ( '(' ) ;
    public final void rule__XParenthesizedExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9361:1: ( ( '(' ) )
            // InternalPureXbase.g:9362:1: ( '(' )
            {
            // InternalPureXbase.g:9362:1: ( '(' )
            // InternalPureXbase.g:9363:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getLeftParenthesisKeyword_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getLeftParenthesisKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__0__Impl"


    // $ANTLR start "rule__XParenthesizedExpression__Group__1"
    // InternalPureXbase.g:9372:1: rule__XParenthesizedExpression__Group__1 : rule__XParenthesizedExpression__Group__1__Impl rule__XParenthesizedExpression__Group__2 ;
    public final void rule__XParenthesizedExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9376:1: ( rule__XParenthesizedExpression__Group__1__Impl rule__XParenthesizedExpression__Group__2 )
            // InternalPureXbase.g:9377:2: rule__XParenthesizedExpression__Group__1__Impl rule__XParenthesizedExpression__Group__2
            {
            pushFollow(FOLLOW_63);
            rule__XParenthesizedExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__1"


    // $ANTLR start "rule__XParenthesizedExpression__Group__1__Impl"
    // InternalPureXbase.g:9384:1: rule__XParenthesizedExpression__Group__1__Impl : ( ruleXExpression ) ;
    public final void rule__XParenthesizedExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9388:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:9389:1: ( ruleXExpression )
            {
            // InternalPureXbase.g:9389:1: ( ruleXExpression )
            // InternalPureXbase.g:9390:2: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getXExpressionParserRuleCall_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getXExpressionParserRuleCall_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__1__Impl"


    // $ANTLR start "rule__XParenthesizedExpression__Group__2"
    // InternalPureXbase.g:9399:1: rule__XParenthesizedExpression__Group__2 : rule__XParenthesizedExpression__Group__2__Impl ;
    public final void rule__XParenthesizedExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9403:1: ( rule__XParenthesizedExpression__Group__2__Impl )
            // InternalPureXbase.g:9404:2: rule__XParenthesizedExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__2"


    // $ANTLR start "rule__XParenthesizedExpression__Group__2__Impl"
    // InternalPureXbase.g:9410:1: rule__XParenthesizedExpression__Group__2__Impl : ( ')' ) ;
    public final void rule__XParenthesizedExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9414:1: ( ( ')' ) )
            // InternalPureXbase.g:9415:1: ( ')' )
            {
            // InternalPureXbase.g:9415:1: ( ')' )
            // InternalPureXbase.g:9416:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__2__Impl"


    // $ANTLR start "rule__XIfExpression__Group__0"
    // InternalPureXbase.g:9426:1: rule__XIfExpression__Group__0 : rule__XIfExpression__Group__0__Impl rule__XIfExpression__Group__1 ;
    public final void rule__XIfExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9430:1: ( rule__XIfExpression__Group__0__Impl rule__XIfExpression__Group__1 )
            // InternalPureXbase.g:9431:2: rule__XIfExpression__Group__0__Impl rule__XIfExpression__Group__1
            {
            pushFollow(FOLLOW_64);
            rule__XIfExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__0"


    // $ANTLR start "rule__XIfExpression__Group__0__Impl"
    // InternalPureXbase.g:9438:1: rule__XIfExpression__Group__0__Impl : ( () ) ;
    public final void rule__XIfExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9442:1: ( ( () ) )
            // InternalPureXbase.g:9443:1: ( () )
            {
            // InternalPureXbase.g:9443:1: ( () )
            // InternalPureXbase.g:9444:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getXIfExpressionAction_0()); 
            }
            // InternalPureXbase.g:9445:2: ()
            // InternalPureXbase.g:9445:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getXIfExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__0__Impl"


    // $ANTLR start "rule__XIfExpression__Group__1"
    // InternalPureXbase.g:9453:1: rule__XIfExpression__Group__1 : rule__XIfExpression__Group__1__Impl rule__XIfExpression__Group__2 ;
    public final void rule__XIfExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9457:1: ( rule__XIfExpression__Group__1__Impl rule__XIfExpression__Group__2 )
            // InternalPureXbase.g:9458:2: rule__XIfExpression__Group__1__Impl rule__XIfExpression__Group__2
            {
            pushFollow(FOLLOW_65);
            rule__XIfExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__1"


    // $ANTLR start "rule__XIfExpression__Group__1__Impl"
    // InternalPureXbase.g:9465:1: rule__XIfExpression__Group__1__Impl : ( 'if' ) ;
    public final void rule__XIfExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9469:1: ( ( 'if' ) )
            // InternalPureXbase.g:9470:1: ( 'if' )
            {
            // InternalPureXbase.g:9470:1: ( 'if' )
            // InternalPureXbase.g:9471:2: 'if'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getIfKeyword_1()); 
            }
            match(input,61,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getIfKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__1__Impl"


    // $ANTLR start "rule__XIfExpression__Group__2"
    // InternalPureXbase.g:9480:1: rule__XIfExpression__Group__2 : rule__XIfExpression__Group__2__Impl rule__XIfExpression__Group__3 ;
    public final void rule__XIfExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9484:1: ( rule__XIfExpression__Group__2__Impl rule__XIfExpression__Group__3 )
            // InternalPureXbase.g:9485:2: rule__XIfExpression__Group__2__Impl rule__XIfExpression__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__XIfExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__2"


    // $ANTLR start "rule__XIfExpression__Group__2__Impl"
    // InternalPureXbase.g:9492:1: rule__XIfExpression__Group__2__Impl : ( '(' ) ;
    public final void rule__XIfExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9496:1: ( ( '(' ) )
            // InternalPureXbase.g:9497:1: ( '(' )
            {
            // InternalPureXbase.g:9497:1: ( '(' )
            // InternalPureXbase.g:9498:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__2__Impl"


    // $ANTLR start "rule__XIfExpression__Group__3"
    // InternalPureXbase.g:9507:1: rule__XIfExpression__Group__3 : rule__XIfExpression__Group__3__Impl rule__XIfExpression__Group__4 ;
    public final void rule__XIfExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9511:1: ( rule__XIfExpression__Group__3__Impl rule__XIfExpression__Group__4 )
            // InternalPureXbase.g:9512:2: rule__XIfExpression__Group__3__Impl rule__XIfExpression__Group__4
            {
            pushFollow(FOLLOW_63);
            rule__XIfExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__3"


    // $ANTLR start "rule__XIfExpression__Group__3__Impl"
    // InternalPureXbase.g:9519:1: rule__XIfExpression__Group__3__Impl : ( ( rule__XIfExpression__IfAssignment_3 ) ) ;
    public final void rule__XIfExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9523:1: ( ( ( rule__XIfExpression__IfAssignment_3 ) ) )
            // InternalPureXbase.g:9524:1: ( ( rule__XIfExpression__IfAssignment_3 ) )
            {
            // InternalPureXbase.g:9524:1: ( ( rule__XIfExpression__IfAssignment_3 ) )
            // InternalPureXbase.g:9525:2: ( rule__XIfExpression__IfAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getIfAssignment_3()); 
            }
            // InternalPureXbase.g:9526:2: ( rule__XIfExpression__IfAssignment_3 )
            // InternalPureXbase.g:9526:3: rule__XIfExpression__IfAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__IfAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getIfAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__3__Impl"


    // $ANTLR start "rule__XIfExpression__Group__4"
    // InternalPureXbase.g:9534:1: rule__XIfExpression__Group__4 : rule__XIfExpression__Group__4__Impl rule__XIfExpression__Group__5 ;
    public final void rule__XIfExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9538:1: ( rule__XIfExpression__Group__4__Impl rule__XIfExpression__Group__5 )
            // InternalPureXbase.g:9539:2: rule__XIfExpression__Group__4__Impl rule__XIfExpression__Group__5
            {
            pushFollow(FOLLOW_5);
            rule__XIfExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__4"


    // $ANTLR start "rule__XIfExpression__Group__4__Impl"
    // InternalPureXbase.g:9546:1: rule__XIfExpression__Group__4__Impl : ( ')' ) ;
    public final void rule__XIfExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9550:1: ( ( ')' ) )
            // InternalPureXbase.g:9551:1: ( ')' )
            {
            // InternalPureXbase.g:9551:1: ( ')' )
            // InternalPureXbase.g:9552:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getRightParenthesisKeyword_4()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getRightParenthesisKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__4__Impl"


    // $ANTLR start "rule__XIfExpression__Group__5"
    // InternalPureXbase.g:9561:1: rule__XIfExpression__Group__5 : rule__XIfExpression__Group__5__Impl rule__XIfExpression__Group__6 ;
    public final void rule__XIfExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9565:1: ( rule__XIfExpression__Group__5__Impl rule__XIfExpression__Group__6 )
            // InternalPureXbase.g:9566:2: rule__XIfExpression__Group__5__Impl rule__XIfExpression__Group__6
            {
            pushFollow(FOLLOW_66);
            rule__XIfExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__5"


    // $ANTLR start "rule__XIfExpression__Group__5__Impl"
    // InternalPureXbase.g:9573:1: rule__XIfExpression__Group__5__Impl : ( ( rule__XIfExpression__ThenAssignment_5 ) ) ;
    public final void rule__XIfExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9577:1: ( ( ( rule__XIfExpression__ThenAssignment_5 ) ) )
            // InternalPureXbase.g:9578:1: ( ( rule__XIfExpression__ThenAssignment_5 ) )
            {
            // InternalPureXbase.g:9578:1: ( ( rule__XIfExpression__ThenAssignment_5 ) )
            // InternalPureXbase.g:9579:2: ( rule__XIfExpression__ThenAssignment_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getThenAssignment_5()); 
            }
            // InternalPureXbase.g:9580:2: ( rule__XIfExpression__ThenAssignment_5 )
            // InternalPureXbase.g:9580:3: rule__XIfExpression__ThenAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__ThenAssignment_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getThenAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__5__Impl"


    // $ANTLR start "rule__XIfExpression__Group__6"
    // InternalPureXbase.g:9588:1: rule__XIfExpression__Group__6 : rule__XIfExpression__Group__6__Impl ;
    public final void rule__XIfExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9592:1: ( rule__XIfExpression__Group__6__Impl )
            // InternalPureXbase.g:9593:2: rule__XIfExpression__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__6"


    // $ANTLR start "rule__XIfExpression__Group__6__Impl"
    // InternalPureXbase.g:9599:1: rule__XIfExpression__Group__6__Impl : ( ( rule__XIfExpression__Group_6__0 )? ) ;
    public final void rule__XIfExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9603:1: ( ( ( rule__XIfExpression__Group_6__0 )? ) )
            // InternalPureXbase.g:9604:1: ( ( rule__XIfExpression__Group_6__0 )? )
            {
            // InternalPureXbase.g:9604:1: ( ( rule__XIfExpression__Group_6__0 )? )
            // InternalPureXbase.g:9605:2: ( rule__XIfExpression__Group_6__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getGroup_6()); 
            }
            // InternalPureXbase.g:9606:2: ( rule__XIfExpression__Group_6__0 )?
            int alt86=2;
            int LA86_0 = input.LA(1);

            if ( (LA86_0==62) ) {
                int LA86_1 = input.LA(2);

                if ( (synpred126_InternalPureXbase()) ) {
                    alt86=1;
                }
            }
            switch (alt86) {
                case 1 :
                    // InternalPureXbase.g:9606:3: rule__XIfExpression__Group_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XIfExpression__Group_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getGroup_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__6__Impl"


    // $ANTLR start "rule__XIfExpression__Group_6__0"
    // InternalPureXbase.g:9615:1: rule__XIfExpression__Group_6__0 : rule__XIfExpression__Group_6__0__Impl rule__XIfExpression__Group_6__1 ;
    public final void rule__XIfExpression__Group_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9619:1: ( rule__XIfExpression__Group_6__0__Impl rule__XIfExpression__Group_6__1 )
            // InternalPureXbase.g:9620:2: rule__XIfExpression__Group_6__0__Impl rule__XIfExpression__Group_6__1
            {
            pushFollow(FOLLOW_5);
            rule__XIfExpression__Group_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group_6__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__0"


    // $ANTLR start "rule__XIfExpression__Group_6__0__Impl"
    // InternalPureXbase.g:9627:1: rule__XIfExpression__Group_6__0__Impl : ( ( 'else' ) ) ;
    public final void rule__XIfExpression__Group_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9631:1: ( ( ( 'else' ) ) )
            // InternalPureXbase.g:9632:1: ( ( 'else' ) )
            {
            // InternalPureXbase.g:9632:1: ( ( 'else' ) )
            // InternalPureXbase.g:9633:2: ( 'else' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getElseKeyword_6_0()); 
            }
            // InternalPureXbase.g:9634:2: ( 'else' )
            // InternalPureXbase.g:9634:3: 'else'
            {
            match(input,62,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getElseKeyword_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__0__Impl"


    // $ANTLR start "rule__XIfExpression__Group_6__1"
    // InternalPureXbase.g:9642:1: rule__XIfExpression__Group_6__1 : rule__XIfExpression__Group_6__1__Impl ;
    public final void rule__XIfExpression__Group_6__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9646:1: ( rule__XIfExpression__Group_6__1__Impl )
            // InternalPureXbase.g:9647:2: rule__XIfExpression__Group_6__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group_6__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__1"


    // $ANTLR start "rule__XIfExpression__Group_6__1__Impl"
    // InternalPureXbase.g:9653:1: rule__XIfExpression__Group_6__1__Impl : ( ( rule__XIfExpression__ElseAssignment_6_1 ) ) ;
    public final void rule__XIfExpression__Group_6__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9657:1: ( ( ( rule__XIfExpression__ElseAssignment_6_1 ) ) )
            // InternalPureXbase.g:9658:1: ( ( rule__XIfExpression__ElseAssignment_6_1 ) )
            {
            // InternalPureXbase.g:9658:1: ( ( rule__XIfExpression__ElseAssignment_6_1 ) )
            // InternalPureXbase.g:9659:2: ( rule__XIfExpression__ElseAssignment_6_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getElseAssignment_6_1()); 
            }
            // InternalPureXbase.g:9660:2: ( rule__XIfExpression__ElseAssignment_6_1 )
            // InternalPureXbase.g:9660:3: rule__XIfExpression__ElseAssignment_6_1
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__ElseAssignment_6_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getElseAssignment_6_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__0"
    // InternalPureXbase.g:9669:1: rule__XSwitchExpression__Group__0 : rule__XSwitchExpression__Group__0__Impl rule__XSwitchExpression__Group__1 ;
    public final void rule__XSwitchExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9673:1: ( rule__XSwitchExpression__Group__0__Impl rule__XSwitchExpression__Group__1 )
            // InternalPureXbase.g:9674:2: rule__XSwitchExpression__Group__0__Impl rule__XSwitchExpression__Group__1
            {
            pushFollow(FOLLOW_67);
            rule__XSwitchExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__0"


    // $ANTLR start "rule__XSwitchExpression__Group__0__Impl"
    // InternalPureXbase.g:9681:1: rule__XSwitchExpression__Group__0__Impl : ( () ) ;
    public final void rule__XSwitchExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9685:1: ( ( () ) )
            // InternalPureXbase.g:9686:1: ( () )
            {
            // InternalPureXbase.g:9686:1: ( () )
            // InternalPureXbase.g:9687:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getXSwitchExpressionAction_0()); 
            }
            // InternalPureXbase.g:9688:2: ()
            // InternalPureXbase.g:9688:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getXSwitchExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__1"
    // InternalPureXbase.g:9696:1: rule__XSwitchExpression__Group__1 : rule__XSwitchExpression__Group__1__Impl rule__XSwitchExpression__Group__2 ;
    public final void rule__XSwitchExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9700:1: ( rule__XSwitchExpression__Group__1__Impl rule__XSwitchExpression__Group__2 )
            // InternalPureXbase.g:9701:2: rule__XSwitchExpression__Group__1__Impl rule__XSwitchExpression__Group__2
            {
            pushFollow(FOLLOW_68);
            rule__XSwitchExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__1"


    // $ANTLR start "rule__XSwitchExpression__Group__1__Impl"
    // InternalPureXbase.g:9708:1: rule__XSwitchExpression__Group__1__Impl : ( 'switch' ) ;
    public final void rule__XSwitchExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9712:1: ( ( 'switch' ) )
            // InternalPureXbase.g:9713:1: ( 'switch' )
            {
            // InternalPureXbase.g:9713:1: ( 'switch' )
            // InternalPureXbase.g:9714:2: 'switch'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchKeyword_1()); 
            }
            match(input,63,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__2"
    // InternalPureXbase.g:9723:1: rule__XSwitchExpression__Group__2 : rule__XSwitchExpression__Group__2__Impl rule__XSwitchExpression__Group__3 ;
    public final void rule__XSwitchExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9727:1: ( rule__XSwitchExpression__Group__2__Impl rule__XSwitchExpression__Group__3 )
            // InternalPureXbase.g:9728:2: rule__XSwitchExpression__Group__2__Impl rule__XSwitchExpression__Group__3
            {
            pushFollow(FOLLOW_56);
            rule__XSwitchExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__2"


    // $ANTLR start "rule__XSwitchExpression__Group__2__Impl"
    // InternalPureXbase.g:9735:1: rule__XSwitchExpression__Group__2__Impl : ( ( rule__XSwitchExpression__Alternatives_2 ) ) ;
    public final void rule__XSwitchExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9739:1: ( ( ( rule__XSwitchExpression__Alternatives_2 ) ) )
            // InternalPureXbase.g:9740:1: ( ( rule__XSwitchExpression__Alternatives_2 ) )
            {
            // InternalPureXbase.g:9740:1: ( ( rule__XSwitchExpression__Alternatives_2 ) )
            // InternalPureXbase.g:9741:2: ( rule__XSwitchExpression__Alternatives_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getAlternatives_2()); 
            }
            // InternalPureXbase.g:9742:2: ( rule__XSwitchExpression__Alternatives_2 )
            // InternalPureXbase.g:9742:3: rule__XSwitchExpression__Alternatives_2
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Alternatives_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__2__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__3"
    // InternalPureXbase.g:9750:1: rule__XSwitchExpression__Group__3 : rule__XSwitchExpression__Group__3__Impl rule__XSwitchExpression__Group__4 ;
    public final void rule__XSwitchExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9754:1: ( rule__XSwitchExpression__Group__3__Impl rule__XSwitchExpression__Group__4 )
            // InternalPureXbase.g:9755:2: rule__XSwitchExpression__Group__3__Impl rule__XSwitchExpression__Group__4
            {
            pushFollow(FOLLOW_69);
            rule__XSwitchExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__3"


    // $ANTLR start "rule__XSwitchExpression__Group__3__Impl"
    // InternalPureXbase.g:9762:1: rule__XSwitchExpression__Group__3__Impl : ( '{' ) ;
    public final void rule__XSwitchExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9766:1: ( ( '{' ) )
            // InternalPureXbase.g:9767:1: ( '{' )
            {
            // InternalPureXbase.g:9767:1: ( '{' )
            // InternalPureXbase.g:9768:2: '{'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getLeftCurlyBracketKeyword_3()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getLeftCurlyBracketKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__3__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__4"
    // InternalPureXbase.g:9777:1: rule__XSwitchExpression__Group__4 : rule__XSwitchExpression__Group__4__Impl rule__XSwitchExpression__Group__5 ;
    public final void rule__XSwitchExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9781:1: ( rule__XSwitchExpression__Group__4__Impl rule__XSwitchExpression__Group__5 )
            // InternalPureXbase.g:9782:2: rule__XSwitchExpression__Group__4__Impl rule__XSwitchExpression__Group__5
            {
            pushFollow(FOLLOW_69);
            rule__XSwitchExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__4"


    // $ANTLR start "rule__XSwitchExpression__Group__4__Impl"
    // InternalPureXbase.g:9789:1: rule__XSwitchExpression__Group__4__Impl : ( ( rule__XSwitchExpression__CasesAssignment_4 )* ) ;
    public final void rule__XSwitchExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9793:1: ( ( ( rule__XSwitchExpression__CasesAssignment_4 )* ) )
            // InternalPureXbase.g:9794:1: ( ( rule__XSwitchExpression__CasesAssignment_4 )* )
            {
            // InternalPureXbase.g:9794:1: ( ( rule__XSwitchExpression__CasesAssignment_4 )* )
            // InternalPureXbase.g:9795:2: ( rule__XSwitchExpression__CasesAssignment_4 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getCasesAssignment_4()); 
            }
            // InternalPureXbase.g:9796:2: ( rule__XSwitchExpression__CasesAssignment_4 )*
            loop87:
            do {
                int alt87=2;
                int LA87_0 = input.LA(1);

                if ( (LA87_0==RULE_ID||LA87_0==32||LA87_0==49||LA87_0==52||LA87_0==55||LA87_0==65) ) {
                    alt87=1;
                }


                switch (alt87) {
            	case 1 :
            	    // InternalPureXbase.g:9796:3: rule__XSwitchExpression__CasesAssignment_4
            	    {
            	    pushFollow(FOLLOW_70);
            	    rule__XSwitchExpression__CasesAssignment_4();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop87;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getCasesAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__4__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__5"
    // InternalPureXbase.g:9804:1: rule__XSwitchExpression__Group__5 : rule__XSwitchExpression__Group__5__Impl rule__XSwitchExpression__Group__6 ;
    public final void rule__XSwitchExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9808:1: ( rule__XSwitchExpression__Group__5__Impl rule__XSwitchExpression__Group__6 )
            // InternalPureXbase.g:9809:2: rule__XSwitchExpression__Group__5__Impl rule__XSwitchExpression__Group__6
            {
            pushFollow(FOLLOW_69);
            rule__XSwitchExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__5"


    // $ANTLR start "rule__XSwitchExpression__Group__5__Impl"
    // InternalPureXbase.g:9816:1: rule__XSwitchExpression__Group__5__Impl : ( ( rule__XSwitchExpression__Group_5__0 )? ) ;
    public final void rule__XSwitchExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9820:1: ( ( ( rule__XSwitchExpression__Group_5__0 )? ) )
            // InternalPureXbase.g:9821:1: ( ( rule__XSwitchExpression__Group_5__0 )? )
            {
            // InternalPureXbase.g:9821:1: ( ( rule__XSwitchExpression__Group_5__0 )? )
            // InternalPureXbase.g:9822:2: ( rule__XSwitchExpression__Group_5__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_5()); 
            }
            // InternalPureXbase.g:9823:2: ( rule__XSwitchExpression__Group_5__0 )?
            int alt88=2;
            int LA88_0 = input.LA(1);

            if ( (LA88_0==64) ) {
                alt88=1;
            }
            switch (alt88) {
                case 1 :
                    // InternalPureXbase.g:9823:3: rule__XSwitchExpression__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_5__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__5__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__6"
    // InternalPureXbase.g:9831:1: rule__XSwitchExpression__Group__6 : rule__XSwitchExpression__Group__6__Impl ;
    public final void rule__XSwitchExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9835:1: ( rule__XSwitchExpression__Group__6__Impl )
            // InternalPureXbase.g:9836:2: rule__XSwitchExpression__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__6"


    // $ANTLR start "rule__XSwitchExpression__Group__6__Impl"
    // InternalPureXbase.g:9842:1: rule__XSwitchExpression__Group__6__Impl : ( '}' ) ;
    public final void rule__XSwitchExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9846:1: ( ( '}' ) )
            // InternalPureXbase.g:9847:1: ( '}' )
            {
            // InternalPureXbase.g:9847:1: ( '}' )
            // InternalPureXbase.g:9848:2: '}'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getRightCurlyBracketKeyword_6()); 
            }
            match(input,58,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getRightCurlyBracketKeyword_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__6__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__0"
    // InternalPureXbase.g:9858:1: rule__XSwitchExpression__Group_2_0__0 : rule__XSwitchExpression__Group_2_0__0__Impl rule__XSwitchExpression__Group_2_0__1 ;
    public final void rule__XSwitchExpression__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9862:1: ( rule__XSwitchExpression__Group_2_0__0__Impl rule__XSwitchExpression__Group_2_0__1 )
            // InternalPureXbase.g:9863:2: rule__XSwitchExpression__Group_2_0__0__Impl rule__XSwitchExpression__Group_2_0__1
            {
            pushFollow(FOLLOW_5);
            rule__XSwitchExpression__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__0__Impl"
    // InternalPureXbase.g:9870:1: rule__XSwitchExpression__Group_2_0__0__Impl : ( ( rule__XSwitchExpression__Group_2_0_0__0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9874:1: ( ( ( rule__XSwitchExpression__Group_2_0_0__0 ) ) )
            // InternalPureXbase.g:9875:1: ( ( rule__XSwitchExpression__Group_2_0_0__0 ) )
            {
            // InternalPureXbase.g:9875:1: ( ( rule__XSwitchExpression__Group_2_0_0__0 ) )
            // InternalPureXbase.g:9876:2: ( rule__XSwitchExpression__Group_2_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0()); 
            }
            // InternalPureXbase.g:9877:2: ( rule__XSwitchExpression__Group_2_0_0__0 )
            // InternalPureXbase.g:9877:3: rule__XSwitchExpression__Group_2_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__1"
    // InternalPureXbase.g:9885:1: rule__XSwitchExpression__Group_2_0__1 : rule__XSwitchExpression__Group_2_0__1__Impl rule__XSwitchExpression__Group_2_0__2 ;
    public final void rule__XSwitchExpression__Group_2_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9889:1: ( rule__XSwitchExpression__Group_2_0__1__Impl rule__XSwitchExpression__Group_2_0__2 )
            // InternalPureXbase.g:9890:2: rule__XSwitchExpression__Group_2_0__1__Impl rule__XSwitchExpression__Group_2_0__2
            {
            pushFollow(FOLLOW_63);
            rule__XSwitchExpression__Group_2_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__1__Impl"
    // InternalPureXbase.g:9897:1: rule__XSwitchExpression__Group_2_0__1__Impl : ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9901:1: ( ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) ) )
            // InternalPureXbase.g:9902:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) )
            {
            // InternalPureXbase.g:9902:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) )
            // InternalPureXbase.g:9903:2: ( rule__XSwitchExpression__SwitchAssignment_2_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_0_1()); 
            }
            // InternalPureXbase.g:9904:2: ( rule__XSwitchExpression__SwitchAssignment_2_0_1 )
            // InternalPureXbase.g:9904:3: rule__XSwitchExpression__SwitchAssignment_2_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__SwitchAssignment_2_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__2"
    // InternalPureXbase.g:9912:1: rule__XSwitchExpression__Group_2_0__2 : rule__XSwitchExpression__Group_2_0__2__Impl ;
    public final void rule__XSwitchExpression__Group_2_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9916:1: ( rule__XSwitchExpression__Group_2_0__2__Impl )
            // InternalPureXbase.g:9917:2: rule__XSwitchExpression__Group_2_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__2"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__2__Impl"
    // InternalPureXbase.g:9923:1: rule__XSwitchExpression__Group_2_0__2__Impl : ( ')' ) ;
    public final void rule__XSwitchExpression__Group_2_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9927:1: ( ( ')' ) )
            // InternalPureXbase.g:9928:1: ( ')' )
            {
            // InternalPureXbase.g:9928:1: ( ')' )
            // InternalPureXbase.g:9929:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getRightParenthesisKeyword_2_0_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getRightParenthesisKeyword_2_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__2__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0__0"
    // InternalPureXbase.g:9939:1: rule__XSwitchExpression__Group_2_0_0__0 : rule__XSwitchExpression__Group_2_0_0__0__Impl ;
    public final void rule__XSwitchExpression__Group_2_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9943:1: ( rule__XSwitchExpression__Group_2_0_0__0__Impl )
            // InternalPureXbase.g:9944:2: rule__XSwitchExpression__Group_2_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0__0__Impl"
    // InternalPureXbase.g:9950:1: rule__XSwitchExpression__Group_2_0_0__0__Impl : ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9954:1: ( ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) ) )
            // InternalPureXbase.g:9955:1: ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) )
            {
            // InternalPureXbase.g:9955:1: ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) )
            // InternalPureXbase.g:9956:2: ( rule__XSwitchExpression__Group_2_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0_0()); 
            }
            // InternalPureXbase.g:9957:2: ( rule__XSwitchExpression__Group_2_0_0_0__0 )
            // InternalPureXbase.g:9957:3: rule__XSwitchExpression__Group_2_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__0"
    // InternalPureXbase.g:9966:1: rule__XSwitchExpression__Group_2_0_0_0__0 : rule__XSwitchExpression__Group_2_0_0_0__0__Impl rule__XSwitchExpression__Group_2_0_0_0__1 ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9970:1: ( rule__XSwitchExpression__Group_2_0_0_0__0__Impl rule__XSwitchExpression__Group_2_0_0_0__1 )
            // InternalPureXbase.g:9971:2: rule__XSwitchExpression__Group_2_0_0_0__0__Impl rule__XSwitchExpression__Group_2_0_0_0__1
            {
            pushFollow(FOLLOW_15);
            rule__XSwitchExpression__Group_2_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__0__Impl"
    // InternalPureXbase.g:9978:1: rule__XSwitchExpression__Group_2_0_0_0__0__Impl : ( '(' ) ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9982:1: ( ( '(' ) )
            // InternalPureXbase.g:9983:1: ( '(' )
            {
            // InternalPureXbase.g:9983:1: ( '(' )
            // InternalPureXbase.g:9984:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getLeftParenthesisKeyword_2_0_0_0_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getLeftParenthesisKeyword_2_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__1"
    // InternalPureXbase.g:9993:1: rule__XSwitchExpression__Group_2_0_0_0__1 : rule__XSwitchExpression__Group_2_0_0_0__1__Impl rule__XSwitchExpression__Group_2_0_0_0__2 ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:9997:1: ( rule__XSwitchExpression__Group_2_0_0_0__1__Impl rule__XSwitchExpression__Group_2_0_0_0__2 )
            // InternalPureXbase.g:9998:2: rule__XSwitchExpression__Group_2_0_0_0__1__Impl rule__XSwitchExpression__Group_2_0_0_0__2
            {
            pushFollow(FOLLOW_20);
            rule__XSwitchExpression__Group_2_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__1__Impl"
    // InternalPureXbase.g:10005:1: rule__XSwitchExpression__Group_2_0_0_0__1__Impl : ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10009:1: ( ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) ) )
            // InternalPureXbase.g:10010:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) )
            {
            // InternalPureXbase.g:10010:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) )
            // InternalPureXbase.g:10011:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_0_0_0_1()); 
            }
            // InternalPureXbase.g:10012:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 )
            // InternalPureXbase.g:10012:3: rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__2"
    // InternalPureXbase.g:10020:1: rule__XSwitchExpression__Group_2_0_0_0__2 : rule__XSwitchExpression__Group_2_0_0_0__2__Impl ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10024:1: ( rule__XSwitchExpression__Group_2_0_0_0__2__Impl )
            // InternalPureXbase.g:10025:2: rule__XSwitchExpression__Group_2_0_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__2"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__2__Impl"
    // InternalPureXbase.g:10031:1: rule__XSwitchExpression__Group_2_0_0_0__2__Impl : ( ':' ) ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10035:1: ( ( ':' ) )
            // InternalPureXbase.g:10036:1: ( ':' )
            {
            // InternalPureXbase.g:10036:1: ( ':' )
            // InternalPureXbase.g:10037:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_0_0_0_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_0_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__2__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__0"
    // InternalPureXbase.g:10047:1: rule__XSwitchExpression__Group_2_1__0 : rule__XSwitchExpression__Group_2_1__0__Impl rule__XSwitchExpression__Group_2_1__1 ;
    public final void rule__XSwitchExpression__Group_2_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10051:1: ( rule__XSwitchExpression__Group_2_1__0__Impl rule__XSwitchExpression__Group_2_1__1 )
            // InternalPureXbase.g:10052:2: rule__XSwitchExpression__Group_2_1__0__Impl rule__XSwitchExpression__Group_2_1__1
            {
            pushFollow(FOLLOW_68);
            rule__XSwitchExpression__Group_2_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__0__Impl"
    // InternalPureXbase.g:10059:1: rule__XSwitchExpression__Group_2_1__0__Impl : ( ( rule__XSwitchExpression__Group_2_1_0__0 )? ) ;
    public final void rule__XSwitchExpression__Group_2_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10063:1: ( ( ( rule__XSwitchExpression__Group_2_1_0__0 )? ) )
            // InternalPureXbase.g:10064:1: ( ( rule__XSwitchExpression__Group_2_1_0__0 )? )
            {
            // InternalPureXbase.g:10064:1: ( ( rule__XSwitchExpression__Group_2_1_0__0 )? )
            // InternalPureXbase.g:10065:2: ( rule__XSwitchExpression__Group_2_1_0__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0()); 
            }
            // InternalPureXbase.g:10066:2: ( rule__XSwitchExpression__Group_2_1_0__0 )?
            int alt89=2;
            alt89 = dfa89.predict(input);
            switch (alt89) {
                case 1 :
                    // InternalPureXbase.g:10066:3: rule__XSwitchExpression__Group_2_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_2_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__1"
    // InternalPureXbase.g:10074:1: rule__XSwitchExpression__Group_2_1__1 : rule__XSwitchExpression__Group_2_1__1__Impl ;
    public final void rule__XSwitchExpression__Group_2_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10078:1: ( rule__XSwitchExpression__Group_2_1__1__Impl )
            // InternalPureXbase.g:10079:2: rule__XSwitchExpression__Group_2_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__1__Impl"
    // InternalPureXbase.g:10085:1: rule__XSwitchExpression__Group_2_1__1__Impl : ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) ) ;
    public final void rule__XSwitchExpression__Group_2_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10089:1: ( ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) ) )
            // InternalPureXbase.g:10090:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) )
            {
            // InternalPureXbase.g:10090:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) )
            // InternalPureXbase.g:10091:2: ( rule__XSwitchExpression__SwitchAssignment_2_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_1_1()); 
            }
            // InternalPureXbase.g:10092:2: ( rule__XSwitchExpression__SwitchAssignment_2_1_1 )
            // InternalPureXbase.g:10092:3: rule__XSwitchExpression__SwitchAssignment_2_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__SwitchAssignment_2_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0__0"
    // InternalPureXbase.g:10101:1: rule__XSwitchExpression__Group_2_1_0__0 : rule__XSwitchExpression__Group_2_1_0__0__Impl ;
    public final void rule__XSwitchExpression__Group_2_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10105:1: ( rule__XSwitchExpression__Group_2_1_0__0__Impl )
            // InternalPureXbase.g:10106:2: rule__XSwitchExpression__Group_2_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0__0__Impl"
    // InternalPureXbase.g:10112:1: rule__XSwitchExpression__Group_2_1_0__0__Impl : ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10116:1: ( ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) ) )
            // InternalPureXbase.g:10117:1: ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) )
            {
            // InternalPureXbase.g:10117:1: ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) )
            // InternalPureXbase.g:10118:2: ( rule__XSwitchExpression__Group_2_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0_0()); 
            }
            // InternalPureXbase.g:10119:2: ( rule__XSwitchExpression__Group_2_1_0_0__0 )
            // InternalPureXbase.g:10119:3: rule__XSwitchExpression__Group_2_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__0"
    // InternalPureXbase.g:10128:1: rule__XSwitchExpression__Group_2_1_0_0__0 : rule__XSwitchExpression__Group_2_1_0_0__0__Impl rule__XSwitchExpression__Group_2_1_0_0__1 ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10132:1: ( rule__XSwitchExpression__Group_2_1_0_0__0__Impl rule__XSwitchExpression__Group_2_1_0_0__1 )
            // InternalPureXbase.g:10133:2: rule__XSwitchExpression__Group_2_1_0_0__0__Impl rule__XSwitchExpression__Group_2_1_0_0__1
            {
            pushFollow(FOLLOW_20);
            rule__XSwitchExpression__Group_2_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__0__Impl"
    // InternalPureXbase.g:10140:1: rule__XSwitchExpression__Group_2_1_0_0__0__Impl : ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10144:1: ( ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) ) )
            // InternalPureXbase.g:10145:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) )
            {
            // InternalPureXbase.g:10145:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) )
            // InternalPureXbase.g:10146:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_1_0_0_0()); 
            }
            // InternalPureXbase.g:10147:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 )
            // InternalPureXbase.g:10147:3: rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__1"
    // InternalPureXbase.g:10155:1: rule__XSwitchExpression__Group_2_1_0_0__1 : rule__XSwitchExpression__Group_2_1_0_0__1__Impl ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10159:1: ( rule__XSwitchExpression__Group_2_1_0_0__1__Impl )
            // InternalPureXbase.g:10160:2: rule__XSwitchExpression__Group_2_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__1__Impl"
    // InternalPureXbase.g:10166:1: rule__XSwitchExpression__Group_2_1_0_0__1__Impl : ( ':' ) ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10170:1: ( ( ':' ) )
            // InternalPureXbase.g:10171:1: ( ':' )
            {
            // InternalPureXbase.g:10171:1: ( ':' )
            // InternalPureXbase.g:10172:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_1_0_0_1()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_5__0"
    // InternalPureXbase.g:10182:1: rule__XSwitchExpression__Group_5__0 : rule__XSwitchExpression__Group_5__0__Impl rule__XSwitchExpression__Group_5__1 ;
    public final void rule__XSwitchExpression__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10186:1: ( rule__XSwitchExpression__Group_5__0__Impl rule__XSwitchExpression__Group_5__1 )
            // InternalPureXbase.g:10187:2: rule__XSwitchExpression__Group_5__0__Impl rule__XSwitchExpression__Group_5__1
            {
            pushFollow(FOLLOW_20);
            rule__XSwitchExpression__Group_5__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_5__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__0"


    // $ANTLR start "rule__XSwitchExpression__Group_5__0__Impl"
    // InternalPureXbase.g:10194:1: rule__XSwitchExpression__Group_5__0__Impl : ( 'default' ) ;
    public final void rule__XSwitchExpression__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10198:1: ( ( 'default' ) )
            // InternalPureXbase.g:10199:1: ( 'default' )
            {
            // InternalPureXbase.g:10199:1: ( 'default' )
            // InternalPureXbase.g:10200:2: 'default'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDefaultKeyword_5_0()); 
            }
            match(input,64,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDefaultKeyword_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_5__1"
    // InternalPureXbase.g:10209:1: rule__XSwitchExpression__Group_5__1 : rule__XSwitchExpression__Group_5__1__Impl rule__XSwitchExpression__Group_5__2 ;
    public final void rule__XSwitchExpression__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10213:1: ( rule__XSwitchExpression__Group_5__1__Impl rule__XSwitchExpression__Group_5__2 )
            // InternalPureXbase.g:10214:2: rule__XSwitchExpression__Group_5__1__Impl rule__XSwitchExpression__Group_5__2
            {
            pushFollow(FOLLOW_5);
            rule__XSwitchExpression__Group_5__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_5__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__1"


    // $ANTLR start "rule__XSwitchExpression__Group_5__1__Impl"
    // InternalPureXbase.g:10221:1: rule__XSwitchExpression__Group_5__1__Impl : ( ':' ) ;
    public final void rule__XSwitchExpression__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10225:1: ( ( ':' ) )
            // InternalPureXbase.g:10226:1: ( ':' )
            {
            // InternalPureXbase.g:10226:1: ( ':' )
            // InternalPureXbase.g:10227:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_5_1()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_5_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_5__2"
    // InternalPureXbase.g:10236:1: rule__XSwitchExpression__Group_5__2 : rule__XSwitchExpression__Group_5__2__Impl ;
    public final void rule__XSwitchExpression__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10240:1: ( rule__XSwitchExpression__Group_5__2__Impl )
            // InternalPureXbase.g:10241:2: rule__XSwitchExpression__Group_5__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_5__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__2"


    // $ANTLR start "rule__XSwitchExpression__Group_5__2__Impl"
    // InternalPureXbase.g:10247:1: rule__XSwitchExpression__Group_5__2__Impl : ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) ) ;
    public final void rule__XSwitchExpression__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10251:1: ( ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) ) )
            // InternalPureXbase.g:10252:1: ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) )
            {
            // InternalPureXbase.g:10252:1: ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) )
            // InternalPureXbase.g:10253:2: ( rule__XSwitchExpression__DefaultAssignment_5_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDefaultAssignment_5_2()); 
            }
            // InternalPureXbase.g:10254:2: ( rule__XSwitchExpression__DefaultAssignment_5_2 )
            // InternalPureXbase.g:10254:3: rule__XSwitchExpression__DefaultAssignment_5_2
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__DefaultAssignment_5_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDefaultAssignment_5_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__2__Impl"


    // $ANTLR start "rule__XCasePart__Group__0"
    // InternalPureXbase.g:10263:1: rule__XCasePart__Group__0 : rule__XCasePart__Group__0__Impl rule__XCasePart__Group__1 ;
    public final void rule__XCasePart__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10267:1: ( rule__XCasePart__Group__0__Impl rule__XCasePart__Group__1 )
            // InternalPureXbase.g:10268:2: rule__XCasePart__Group__0__Impl rule__XCasePart__Group__1
            {
            pushFollow(FOLLOW_71);
            rule__XCasePart__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__0"


    // $ANTLR start "rule__XCasePart__Group__0__Impl"
    // InternalPureXbase.g:10275:1: rule__XCasePart__Group__0__Impl : ( () ) ;
    public final void rule__XCasePart__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10279:1: ( ( () ) )
            // InternalPureXbase.g:10280:1: ( () )
            {
            // InternalPureXbase.g:10280:1: ( () )
            // InternalPureXbase.g:10281:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getXCasePartAction_0()); 
            }
            // InternalPureXbase.g:10282:2: ()
            // InternalPureXbase.g:10282:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getXCasePartAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__0__Impl"


    // $ANTLR start "rule__XCasePart__Group__1"
    // InternalPureXbase.g:10290:1: rule__XCasePart__Group__1 : rule__XCasePart__Group__1__Impl rule__XCasePart__Group__2 ;
    public final void rule__XCasePart__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10294:1: ( rule__XCasePart__Group__1__Impl rule__XCasePart__Group__2 )
            // InternalPureXbase.g:10295:2: rule__XCasePart__Group__1__Impl rule__XCasePart__Group__2
            {
            pushFollow(FOLLOW_71);
            rule__XCasePart__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__1"


    // $ANTLR start "rule__XCasePart__Group__1__Impl"
    // InternalPureXbase.g:10302:1: rule__XCasePart__Group__1__Impl : ( ( rule__XCasePart__TypeGuardAssignment_1 )? ) ;
    public final void rule__XCasePart__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10306:1: ( ( ( rule__XCasePart__TypeGuardAssignment_1 )? ) )
            // InternalPureXbase.g:10307:1: ( ( rule__XCasePart__TypeGuardAssignment_1 )? )
            {
            // InternalPureXbase.g:10307:1: ( ( rule__XCasePart__TypeGuardAssignment_1 )? )
            // InternalPureXbase.g:10308:2: ( rule__XCasePart__TypeGuardAssignment_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getTypeGuardAssignment_1()); 
            }
            // InternalPureXbase.g:10309:2: ( rule__XCasePart__TypeGuardAssignment_1 )?
            int alt90=2;
            int LA90_0 = input.LA(1);

            if ( (LA90_0==RULE_ID||LA90_0==32||LA90_0==49) ) {
                alt90=1;
            }
            switch (alt90) {
                case 1 :
                    // InternalPureXbase.g:10309:3: rule__XCasePart__TypeGuardAssignment_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__TypeGuardAssignment_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getTypeGuardAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__1__Impl"


    // $ANTLR start "rule__XCasePart__Group__2"
    // InternalPureXbase.g:10317:1: rule__XCasePart__Group__2 : rule__XCasePart__Group__2__Impl rule__XCasePart__Group__3 ;
    public final void rule__XCasePart__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10321:1: ( rule__XCasePart__Group__2__Impl rule__XCasePart__Group__3 )
            // InternalPureXbase.g:10322:2: rule__XCasePart__Group__2__Impl rule__XCasePart__Group__3
            {
            pushFollow(FOLLOW_71);
            rule__XCasePart__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__2"


    // $ANTLR start "rule__XCasePart__Group__2__Impl"
    // InternalPureXbase.g:10329:1: rule__XCasePart__Group__2__Impl : ( ( rule__XCasePart__Group_2__0 )? ) ;
    public final void rule__XCasePart__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10333:1: ( ( ( rule__XCasePart__Group_2__0 )? ) )
            // InternalPureXbase.g:10334:1: ( ( rule__XCasePart__Group_2__0 )? )
            {
            // InternalPureXbase.g:10334:1: ( ( rule__XCasePart__Group_2__0 )? )
            // InternalPureXbase.g:10335:2: ( rule__XCasePart__Group_2__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getGroup_2()); 
            }
            // InternalPureXbase.g:10336:2: ( rule__XCasePart__Group_2__0 )?
            int alt91=2;
            int LA91_0 = input.LA(1);

            if ( (LA91_0==65) ) {
                alt91=1;
            }
            switch (alt91) {
                case 1 :
                    // InternalPureXbase.g:10336:3: rule__XCasePart__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__Group_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getGroup_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__2__Impl"


    // $ANTLR start "rule__XCasePart__Group__3"
    // InternalPureXbase.g:10344:1: rule__XCasePart__Group__3 : rule__XCasePart__Group__3__Impl ;
    public final void rule__XCasePart__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10348:1: ( rule__XCasePart__Group__3__Impl )
            // InternalPureXbase.g:10349:2: rule__XCasePart__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__3"


    // $ANTLR start "rule__XCasePart__Group__3__Impl"
    // InternalPureXbase.g:10355:1: rule__XCasePart__Group__3__Impl : ( ( rule__XCasePart__Alternatives_3 ) ) ;
    public final void rule__XCasePart__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10359:1: ( ( ( rule__XCasePart__Alternatives_3 ) ) )
            // InternalPureXbase.g:10360:1: ( ( rule__XCasePart__Alternatives_3 ) )
            {
            // InternalPureXbase.g:10360:1: ( ( rule__XCasePart__Alternatives_3 ) )
            // InternalPureXbase.g:10361:2: ( rule__XCasePart__Alternatives_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getAlternatives_3()); 
            }
            // InternalPureXbase.g:10362:2: ( rule__XCasePart__Alternatives_3 )
            // InternalPureXbase.g:10362:3: rule__XCasePart__Alternatives_3
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Alternatives_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getAlternatives_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__3__Impl"


    // $ANTLR start "rule__XCasePart__Group_2__0"
    // InternalPureXbase.g:10371:1: rule__XCasePart__Group_2__0 : rule__XCasePart__Group_2__0__Impl rule__XCasePart__Group_2__1 ;
    public final void rule__XCasePart__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10375:1: ( rule__XCasePart__Group_2__0__Impl rule__XCasePart__Group_2__1 )
            // InternalPureXbase.g:10376:2: rule__XCasePart__Group_2__0__Impl rule__XCasePart__Group_2__1
            {
            pushFollow(FOLLOW_5);
            rule__XCasePart__Group_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__0"


    // $ANTLR start "rule__XCasePart__Group_2__0__Impl"
    // InternalPureXbase.g:10383:1: rule__XCasePart__Group_2__0__Impl : ( 'case' ) ;
    public final void rule__XCasePart__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10387:1: ( ( 'case' ) )
            // InternalPureXbase.g:10388:1: ( 'case' )
            {
            // InternalPureXbase.g:10388:1: ( 'case' )
            // InternalPureXbase.g:10389:2: 'case'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getCaseKeyword_2_0()); 
            }
            match(input,65,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getCaseKeyword_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__0__Impl"


    // $ANTLR start "rule__XCasePart__Group_2__1"
    // InternalPureXbase.g:10398:1: rule__XCasePart__Group_2__1 : rule__XCasePart__Group_2__1__Impl ;
    public final void rule__XCasePart__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10402:1: ( rule__XCasePart__Group_2__1__Impl )
            // InternalPureXbase.g:10403:2: rule__XCasePart__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__1"


    // $ANTLR start "rule__XCasePart__Group_2__1__Impl"
    // InternalPureXbase.g:10409:1: rule__XCasePart__Group_2__1__Impl : ( ( rule__XCasePart__CaseAssignment_2_1 ) ) ;
    public final void rule__XCasePart__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10413:1: ( ( ( rule__XCasePart__CaseAssignment_2_1 ) ) )
            // InternalPureXbase.g:10414:1: ( ( rule__XCasePart__CaseAssignment_2_1 ) )
            {
            // InternalPureXbase.g:10414:1: ( ( rule__XCasePart__CaseAssignment_2_1 ) )
            // InternalPureXbase.g:10415:2: ( rule__XCasePart__CaseAssignment_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getCaseAssignment_2_1()); 
            }
            // InternalPureXbase.g:10416:2: ( rule__XCasePart__CaseAssignment_2_1 )
            // InternalPureXbase.g:10416:3: rule__XCasePart__CaseAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__CaseAssignment_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getCaseAssignment_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__1__Impl"


    // $ANTLR start "rule__XCasePart__Group_3_0__0"
    // InternalPureXbase.g:10425:1: rule__XCasePart__Group_3_0__0 : rule__XCasePart__Group_3_0__0__Impl rule__XCasePart__Group_3_0__1 ;
    public final void rule__XCasePart__Group_3_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10429:1: ( rule__XCasePart__Group_3_0__0__Impl rule__XCasePart__Group_3_0__1 )
            // InternalPureXbase.g:10430:2: rule__XCasePart__Group_3_0__0__Impl rule__XCasePart__Group_3_0__1
            {
            pushFollow(FOLLOW_5);
            rule__XCasePart__Group_3_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_3_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__0"


    // $ANTLR start "rule__XCasePart__Group_3_0__0__Impl"
    // InternalPureXbase.g:10437:1: rule__XCasePart__Group_3_0__0__Impl : ( ':' ) ;
    public final void rule__XCasePart__Group_3_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10441:1: ( ( ':' ) )
            // InternalPureXbase.g:10442:1: ( ':' )
            {
            // InternalPureXbase.g:10442:1: ( ':' )
            // InternalPureXbase.g:10443:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getColonKeyword_3_0_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getColonKeyword_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__0__Impl"


    // $ANTLR start "rule__XCasePart__Group_3_0__1"
    // InternalPureXbase.g:10452:1: rule__XCasePart__Group_3_0__1 : rule__XCasePart__Group_3_0__1__Impl ;
    public final void rule__XCasePart__Group_3_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10456:1: ( rule__XCasePart__Group_3_0__1__Impl )
            // InternalPureXbase.g:10457:2: rule__XCasePart__Group_3_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_3_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__1"


    // $ANTLR start "rule__XCasePart__Group_3_0__1__Impl"
    // InternalPureXbase.g:10463:1: rule__XCasePart__Group_3_0__1__Impl : ( ( rule__XCasePart__ThenAssignment_3_0_1 ) ) ;
    public final void rule__XCasePart__Group_3_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10467:1: ( ( ( rule__XCasePart__ThenAssignment_3_0_1 ) ) )
            // InternalPureXbase.g:10468:1: ( ( rule__XCasePart__ThenAssignment_3_0_1 ) )
            {
            // InternalPureXbase.g:10468:1: ( ( rule__XCasePart__ThenAssignment_3_0_1 ) )
            // InternalPureXbase.g:10469:2: ( rule__XCasePart__ThenAssignment_3_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getThenAssignment_3_0_1()); 
            }
            // InternalPureXbase.g:10470:2: ( rule__XCasePart__ThenAssignment_3_0_1 )
            // InternalPureXbase.g:10470:3: rule__XCasePart__ThenAssignment_3_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__ThenAssignment_3_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getThenAssignment_3_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__1__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__0"
    // InternalPureXbase.g:10479:1: rule__XForLoopExpression__Group__0 : rule__XForLoopExpression__Group__0__Impl rule__XForLoopExpression__Group__1 ;
    public final void rule__XForLoopExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10483:1: ( rule__XForLoopExpression__Group__0__Impl rule__XForLoopExpression__Group__1 )
            // InternalPureXbase.g:10484:2: rule__XForLoopExpression__Group__0__Impl rule__XForLoopExpression__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__XForLoopExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__0"


    // $ANTLR start "rule__XForLoopExpression__Group__0__Impl"
    // InternalPureXbase.g:10491:1: rule__XForLoopExpression__Group__0__Impl : ( ( rule__XForLoopExpression__Group_0__0 ) ) ;
    public final void rule__XForLoopExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10495:1: ( ( ( rule__XForLoopExpression__Group_0__0 ) ) )
            // InternalPureXbase.g:10496:1: ( ( rule__XForLoopExpression__Group_0__0 ) )
            {
            // InternalPureXbase.g:10496:1: ( ( rule__XForLoopExpression__Group_0__0 ) )
            // InternalPureXbase.g:10497:2: ( rule__XForLoopExpression__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getGroup_0()); 
            }
            // InternalPureXbase.g:10498:2: ( rule__XForLoopExpression__Group_0__0 )
            // InternalPureXbase.g:10498:3: rule__XForLoopExpression__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__0__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__1"
    // InternalPureXbase.g:10506:1: rule__XForLoopExpression__Group__1 : rule__XForLoopExpression__Group__1__Impl rule__XForLoopExpression__Group__2 ;
    public final void rule__XForLoopExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10510:1: ( rule__XForLoopExpression__Group__1__Impl rule__XForLoopExpression__Group__2 )
            // InternalPureXbase.g:10511:2: rule__XForLoopExpression__Group__1__Impl rule__XForLoopExpression__Group__2
            {
            pushFollow(FOLLOW_63);
            rule__XForLoopExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__1"


    // $ANTLR start "rule__XForLoopExpression__Group__1__Impl"
    // InternalPureXbase.g:10518:1: rule__XForLoopExpression__Group__1__Impl : ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) ) ;
    public final void rule__XForLoopExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10522:1: ( ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) ) )
            // InternalPureXbase.g:10523:1: ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) )
            {
            // InternalPureXbase.g:10523:1: ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) )
            // InternalPureXbase.g:10524:2: ( rule__XForLoopExpression__ForExpressionAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getForExpressionAssignment_1()); 
            }
            // InternalPureXbase.g:10525:2: ( rule__XForLoopExpression__ForExpressionAssignment_1 )
            // InternalPureXbase.g:10525:3: rule__XForLoopExpression__ForExpressionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__ForExpressionAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getForExpressionAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__1__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__2"
    // InternalPureXbase.g:10533:1: rule__XForLoopExpression__Group__2 : rule__XForLoopExpression__Group__2__Impl rule__XForLoopExpression__Group__3 ;
    public final void rule__XForLoopExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10537:1: ( rule__XForLoopExpression__Group__2__Impl rule__XForLoopExpression__Group__3 )
            // InternalPureXbase.g:10538:2: rule__XForLoopExpression__Group__2__Impl rule__XForLoopExpression__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__XForLoopExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__2"


    // $ANTLR start "rule__XForLoopExpression__Group__2__Impl"
    // InternalPureXbase.g:10545:1: rule__XForLoopExpression__Group__2__Impl : ( ')' ) ;
    public final void rule__XForLoopExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10549:1: ( ( ')' ) )
            // InternalPureXbase.g:10550:1: ( ')' )
            {
            // InternalPureXbase.g:10550:1: ( ')' )
            // InternalPureXbase.g:10551:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getRightParenthesisKeyword_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getRightParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__2__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__3"
    // InternalPureXbase.g:10560:1: rule__XForLoopExpression__Group__3 : rule__XForLoopExpression__Group__3__Impl ;
    public final void rule__XForLoopExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10564:1: ( rule__XForLoopExpression__Group__3__Impl )
            // InternalPureXbase.g:10565:2: rule__XForLoopExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__3"


    // $ANTLR start "rule__XForLoopExpression__Group__3__Impl"
    // InternalPureXbase.g:10571:1: rule__XForLoopExpression__Group__3__Impl : ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) ) ;
    public final void rule__XForLoopExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10575:1: ( ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) ) )
            // InternalPureXbase.g:10576:1: ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) )
            {
            // InternalPureXbase.g:10576:1: ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) )
            // InternalPureXbase.g:10577:2: ( rule__XForLoopExpression__EachExpressionAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getEachExpressionAssignment_3()); 
            }
            // InternalPureXbase.g:10578:2: ( rule__XForLoopExpression__EachExpressionAssignment_3 )
            // InternalPureXbase.g:10578:3: rule__XForLoopExpression__EachExpressionAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__EachExpressionAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getEachExpressionAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__3__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0__0"
    // InternalPureXbase.g:10587:1: rule__XForLoopExpression__Group_0__0 : rule__XForLoopExpression__Group_0__0__Impl ;
    public final void rule__XForLoopExpression__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10591:1: ( rule__XForLoopExpression__Group_0__0__Impl )
            // InternalPureXbase.g:10592:2: rule__XForLoopExpression__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0__0"


    // $ANTLR start "rule__XForLoopExpression__Group_0__0__Impl"
    // InternalPureXbase.g:10598:1: rule__XForLoopExpression__Group_0__0__Impl : ( ( rule__XForLoopExpression__Group_0_0__0 ) ) ;
    public final void rule__XForLoopExpression__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10602:1: ( ( ( rule__XForLoopExpression__Group_0_0__0 ) ) )
            // InternalPureXbase.g:10603:1: ( ( rule__XForLoopExpression__Group_0_0__0 ) )
            {
            // InternalPureXbase.g:10603:1: ( ( rule__XForLoopExpression__Group_0_0__0 ) )
            // InternalPureXbase.g:10604:2: ( rule__XForLoopExpression__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getGroup_0_0()); 
            }
            // InternalPureXbase.g:10605:2: ( rule__XForLoopExpression__Group_0_0__0 )
            // InternalPureXbase.g:10605:3: rule__XForLoopExpression__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0__0__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__0"
    // InternalPureXbase.g:10614:1: rule__XForLoopExpression__Group_0_0__0 : rule__XForLoopExpression__Group_0_0__0__Impl rule__XForLoopExpression__Group_0_0__1 ;
    public final void rule__XForLoopExpression__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10618:1: ( rule__XForLoopExpression__Group_0_0__0__Impl rule__XForLoopExpression__Group_0_0__1 )
            // InternalPureXbase.g:10619:2: rule__XForLoopExpression__Group_0_0__0__Impl rule__XForLoopExpression__Group_0_0__1
            {
            pushFollow(FOLLOW_72);
            rule__XForLoopExpression__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__0"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__0__Impl"
    // InternalPureXbase.g:10626:1: rule__XForLoopExpression__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XForLoopExpression__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10630:1: ( ( () ) )
            // InternalPureXbase.g:10631:1: ( () )
            {
            // InternalPureXbase.g:10631:1: ( () )
            // InternalPureXbase.g:10632:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getXForLoopExpressionAction_0_0_0()); 
            }
            // InternalPureXbase.g:10633:2: ()
            // InternalPureXbase.g:10633:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getXForLoopExpressionAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__0__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__1"
    // InternalPureXbase.g:10641:1: rule__XForLoopExpression__Group_0_0__1 : rule__XForLoopExpression__Group_0_0__1__Impl rule__XForLoopExpression__Group_0_0__2 ;
    public final void rule__XForLoopExpression__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10645:1: ( rule__XForLoopExpression__Group_0_0__1__Impl rule__XForLoopExpression__Group_0_0__2 )
            // InternalPureXbase.g:10646:2: rule__XForLoopExpression__Group_0_0__1__Impl rule__XForLoopExpression__Group_0_0__2
            {
            pushFollow(FOLLOW_65);
            rule__XForLoopExpression__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__1"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__1__Impl"
    // InternalPureXbase.g:10653:1: rule__XForLoopExpression__Group_0_0__1__Impl : ( 'for' ) ;
    public final void rule__XForLoopExpression__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10657:1: ( ( 'for' ) )
            // InternalPureXbase.g:10658:1: ( 'for' )
            {
            // InternalPureXbase.g:10658:1: ( 'for' )
            // InternalPureXbase.g:10659:2: 'for'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getForKeyword_0_0_1()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getForKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__1__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__2"
    // InternalPureXbase.g:10668:1: rule__XForLoopExpression__Group_0_0__2 : rule__XForLoopExpression__Group_0_0__2__Impl rule__XForLoopExpression__Group_0_0__3 ;
    public final void rule__XForLoopExpression__Group_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10672:1: ( rule__XForLoopExpression__Group_0_0__2__Impl rule__XForLoopExpression__Group_0_0__3 )
            // InternalPureXbase.g:10673:2: rule__XForLoopExpression__Group_0_0__2__Impl rule__XForLoopExpression__Group_0_0__3
            {
            pushFollow(FOLLOW_15);
            rule__XForLoopExpression__Group_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__2"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__2__Impl"
    // InternalPureXbase.g:10680:1: rule__XForLoopExpression__Group_0_0__2__Impl : ( '(' ) ;
    public final void rule__XForLoopExpression__Group_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10684:1: ( ( '(' ) )
            // InternalPureXbase.g:10685:1: ( '(' )
            {
            // InternalPureXbase.g:10685:1: ( '(' )
            // InternalPureXbase.g:10686:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__2__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__3"
    // InternalPureXbase.g:10695:1: rule__XForLoopExpression__Group_0_0__3 : rule__XForLoopExpression__Group_0_0__3__Impl rule__XForLoopExpression__Group_0_0__4 ;
    public final void rule__XForLoopExpression__Group_0_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10699:1: ( rule__XForLoopExpression__Group_0_0__3__Impl rule__XForLoopExpression__Group_0_0__4 )
            // InternalPureXbase.g:10700:2: rule__XForLoopExpression__Group_0_0__3__Impl rule__XForLoopExpression__Group_0_0__4
            {
            pushFollow(FOLLOW_20);
            rule__XForLoopExpression__Group_0_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__3"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__3__Impl"
    // InternalPureXbase.g:10707:1: rule__XForLoopExpression__Group_0_0__3__Impl : ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) ) ;
    public final void rule__XForLoopExpression__Group_0_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10711:1: ( ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) ) )
            // InternalPureXbase.g:10712:1: ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) )
            {
            // InternalPureXbase.g:10712:1: ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) )
            // InternalPureXbase.g:10713:2: ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamAssignment_0_0_3()); 
            }
            // InternalPureXbase.g:10714:2: ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 )
            // InternalPureXbase.g:10714:3: rule__XForLoopExpression__DeclaredParamAssignment_0_0_3
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__DeclaredParamAssignment_0_0_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamAssignment_0_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__3__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__4"
    // InternalPureXbase.g:10722:1: rule__XForLoopExpression__Group_0_0__4 : rule__XForLoopExpression__Group_0_0__4__Impl ;
    public final void rule__XForLoopExpression__Group_0_0__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10726:1: ( rule__XForLoopExpression__Group_0_0__4__Impl )
            // InternalPureXbase.g:10727:2: rule__XForLoopExpression__Group_0_0__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__4"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__4__Impl"
    // InternalPureXbase.g:10733:1: rule__XForLoopExpression__Group_0_0__4__Impl : ( ':' ) ;
    public final void rule__XForLoopExpression__Group_0_0__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10737:1: ( ( ':' ) )
            // InternalPureXbase.g:10738:1: ( ':' )
            {
            // InternalPureXbase.g:10738:1: ( ':' )
            // InternalPureXbase.g:10739:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getColonKeyword_0_0_4()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getColonKeyword_0_0_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__4__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__0"
    // InternalPureXbase.g:10749:1: rule__XBasicForLoopExpression__Group__0 : rule__XBasicForLoopExpression__Group__0__Impl rule__XBasicForLoopExpression__Group__1 ;
    public final void rule__XBasicForLoopExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10753:1: ( rule__XBasicForLoopExpression__Group__0__Impl rule__XBasicForLoopExpression__Group__1 )
            // InternalPureXbase.g:10754:2: rule__XBasicForLoopExpression__Group__0__Impl rule__XBasicForLoopExpression__Group__1
            {
            pushFollow(FOLLOW_72);
            rule__XBasicForLoopExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__0__Impl"
    // InternalPureXbase.g:10761:1: rule__XBasicForLoopExpression__Group__0__Impl : ( () ) ;
    public final void rule__XBasicForLoopExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10765:1: ( ( () ) )
            // InternalPureXbase.g:10766:1: ( () )
            {
            // InternalPureXbase.g:10766:1: ( () )
            // InternalPureXbase.g:10767:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getXBasicForLoopExpressionAction_0()); 
            }
            // InternalPureXbase.g:10768:2: ()
            // InternalPureXbase.g:10768:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getXBasicForLoopExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__1"
    // InternalPureXbase.g:10776:1: rule__XBasicForLoopExpression__Group__1 : rule__XBasicForLoopExpression__Group__1__Impl rule__XBasicForLoopExpression__Group__2 ;
    public final void rule__XBasicForLoopExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10780:1: ( rule__XBasicForLoopExpression__Group__1__Impl rule__XBasicForLoopExpression__Group__2 )
            // InternalPureXbase.g:10781:2: rule__XBasicForLoopExpression__Group__1__Impl rule__XBasicForLoopExpression__Group__2
            {
            pushFollow(FOLLOW_65);
            rule__XBasicForLoopExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__1__Impl"
    // InternalPureXbase.g:10788:1: rule__XBasicForLoopExpression__Group__1__Impl : ( 'for' ) ;
    public final void rule__XBasicForLoopExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10792:1: ( ( 'for' ) )
            // InternalPureXbase.g:10793:1: ( 'for' )
            {
            // InternalPureXbase.g:10793:1: ( 'for' )
            // InternalPureXbase.g:10794:2: 'for'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getForKeyword_1()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getForKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__2"
    // InternalPureXbase.g:10803:1: rule__XBasicForLoopExpression__Group__2 : rule__XBasicForLoopExpression__Group__2__Impl rule__XBasicForLoopExpression__Group__3 ;
    public final void rule__XBasicForLoopExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10807:1: ( rule__XBasicForLoopExpression__Group__2__Impl rule__XBasicForLoopExpression__Group__3 )
            // InternalPureXbase.g:10808:2: rule__XBasicForLoopExpression__Group__2__Impl rule__XBasicForLoopExpression__Group__3
            {
            pushFollow(FOLLOW_73);
            rule__XBasicForLoopExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__2"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__2__Impl"
    // InternalPureXbase.g:10815:1: rule__XBasicForLoopExpression__Group__2__Impl : ( '(' ) ;
    public final void rule__XBasicForLoopExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10819:1: ( ( '(' ) )
            // InternalPureXbase.g:10820:1: ( '(' )
            {
            // InternalPureXbase.g:10820:1: ( '(' )
            // InternalPureXbase.g:10821:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__2__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__3"
    // InternalPureXbase.g:10830:1: rule__XBasicForLoopExpression__Group__3 : rule__XBasicForLoopExpression__Group__3__Impl rule__XBasicForLoopExpression__Group__4 ;
    public final void rule__XBasicForLoopExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10834:1: ( rule__XBasicForLoopExpression__Group__3__Impl rule__XBasicForLoopExpression__Group__4 )
            // InternalPureXbase.g:10835:2: rule__XBasicForLoopExpression__Group__3__Impl rule__XBasicForLoopExpression__Group__4
            {
            pushFollow(FOLLOW_73);
            rule__XBasicForLoopExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__3"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__3__Impl"
    // InternalPureXbase.g:10842:1: rule__XBasicForLoopExpression__Group__3__Impl : ( ( rule__XBasicForLoopExpression__Group_3__0 )? ) ;
    public final void rule__XBasicForLoopExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10846:1: ( ( ( rule__XBasicForLoopExpression__Group_3__0 )? ) )
            // InternalPureXbase.g:10847:1: ( ( rule__XBasicForLoopExpression__Group_3__0 )? )
            {
            // InternalPureXbase.g:10847:1: ( ( rule__XBasicForLoopExpression__Group_3__0 )? )
            // InternalPureXbase.g:10848:2: ( rule__XBasicForLoopExpression__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3()); 
            }
            // InternalPureXbase.g:10849:2: ( rule__XBasicForLoopExpression__Group_3__0 )?
            int alt92=2;
            int LA92_0 = input.LA(1);

            if ( ((LA92_0>=RULE_ID && LA92_0<=RULE_STRING)||LA92_0==16||LA92_0==28||(LA92_0>=35 && LA92_0<=36)||LA92_0==41||(LA92_0>=45 && LA92_0<=46)||(LA92_0>=48 && LA92_0<=49)||(LA92_0>=56 && LA92_0<=57)||LA92_0==59||LA92_0==61||LA92_0==63||(LA92_0>=66 && LA92_0<=74)||LA92_0==80||LA92_0==84) ) {
                alt92=1;
            }
            switch (alt92) {
                case 1 :
                    // InternalPureXbase.g:10849:3: rule__XBasicForLoopExpression__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBasicForLoopExpression__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__3__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__4"
    // InternalPureXbase.g:10857:1: rule__XBasicForLoopExpression__Group__4 : rule__XBasicForLoopExpression__Group__4__Impl rule__XBasicForLoopExpression__Group__5 ;
    public final void rule__XBasicForLoopExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10861:1: ( rule__XBasicForLoopExpression__Group__4__Impl rule__XBasicForLoopExpression__Group__5 )
            // InternalPureXbase.g:10862:2: rule__XBasicForLoopExpression__Group__4__Impl rule__XBasicForLoopExpression__Group__5
            {
            pushFollow(FOLLOW_73);
            rule__XBasicForLoopExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__4"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__4__Impl"
    // InternalPureXbase.g:10869:1: rule__XBasicForLoopExpression__Group__4__Impl : ( ';' ) ;
    public final void rule__XBasicForLoopExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10873:1: ( ( ';' ) )
            // InternalPureXbase.g:10874:1: ( ';' )
            {
            // InternalPureXbase.g:10874:1: ( ';' )
            // InternalPureXbase.g:10875:2: ';'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_4()); 
            }
            match(input,47,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__4__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__5"
    // InternalPureXbase.g:10884:1: rule__XBasicForLoopExpression__Group__5 : rule__XBasicForLoopExpression__Group__5__Impl rule__XBasicForLoopExpression__Group__6 ;
    public final void rule__XBasicForLoopExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10888:1: ( rule__XBasicForLoopExpression__Group__5__Impl rule__XBasicForLoopExpression__Group__6 )
            // InternalPureXbase.g:10889:2: rule__XBasicForLoopExpression__Group__5__Impl rule__XBasicForLoopExpression__Group__6
            {
            pushFollow(FOLLOW_73);
            rule__XBasicForLoopExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__5"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__5__Impl"
    // InternalPureXbase.g:10896:1: rule__XBasicForLoopExpression__Group__5__Impl : ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? ) ;
    public final void rule__XBasicForLoopExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10900:1: ( ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? ) )
            // InternalPureXbase.g:10901:1: ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? )
            {
            // InternalPureXbase.g:10901:1: ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? )
            // InternalPureXbase.g:10902:2: ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionAssignment_5()); 
            }
            // InternalPureXbase.g:10903:2: ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )?
            int alt93=2;
            int LA93_0 = input.LA(1);

            if ( ((LA93_0>=RULE_ID && LA93_0<=RULE_STRING)||LA93_0==28||(LA93_0>=35 && LA93_0<=36)||LA93_0==41||(LA93_0>=45 && LA93_0<=46)||(LA93_0>=48 && LA93_0<=49)||(LA93_0>=56 && LA93_0<=57)||LA93_0==59||LA93_0==61||LA93_0==63||(LA93_0>=66 && LA93_0<=74)||LA93_0==84) ) {
                alt93=1;
            }
            switch (alt93) {
                case 1 :
                    // InternalPureXbase.g:10903:3: rule__XBasicForLoopExpression__ExpressionAssignment_5
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBasicForLoopExpression__ExpressionAssignment_5();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__5__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__6"
    // InternalPureXbase.g:10911:1: rule__XBasicForLoopExpression__Group__6 : rule__XBasicForLoopExpression__Group__6__Impl rule__XBasicForLoopExpression__Group__7 ;
    public final void rule__XBasicForLoopExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10915:1: ( rule__XBasicForLoopExpression__Group__6__Impl rule__XBasicForLoopExpression__Group__7 )
            // InternalPureXbase.g:10916:2: rule__XBasicForLoopExpression__Group__6__Impl rule__XBasicForLoopExpression__Group__7
            {
            pushFollow(FOLLOW_74);
            rule__XBasicForLoopExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__7();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__6"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__6__Impl"
    // InternalPureXbase.g:10923:1: rule__XBasicForLoopExpression__Group__6__Impl : ( ';' ) ;
    public final void rule__XBasicForLoopExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10927:1: ( ( ';' ) )
            // InternalPureXbase.g:10928:1: ( ';' )
            {
            // InternalPureXbase.g:10928:1: ( ';' )
            // InternalPureXbase.g:10929:2: ';'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_6()); 
            }
            match(input,47,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__6__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__7"
    // InternalPureXbase.g:10938:1: rule__XBasicForLoopExpression__Group__7 : rule__XBasicForLoopExpression__Group__7__Impl rule__XBasicForLoopExpression__Group__8 ;
    public final void rule__XBasicForLoopExpression__Group__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10942:1: ( rule__XBasicForLoopExpression__Group__7__Impl rule__XBasicForLoopExpression__Group__8 )
            // InternalPureXbase.g:10943:2: rule__XBasicForLoopExpression__Group__7__Impl rule__XBasicForLoopExpression__Group__8
            {
            pushFollow(FOLLOW_74);
            rule__XBasicForLoopExpression__Group__7__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__8();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__7"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__7__Impl"
    // InternalPureXbase.g:10950:1: rule__XBasicForLoopExpression__Group__7__Impl : ( ( rule__XBasicForLoopExpression__Group_7__0 )? ) ;
    public final void rule__XBasicForLoopExpression__Group__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10954:1: ( ( ( rule__XBasicForLoopExpression__Group_7__0 )? ) )
            // InternalPureXbase.g:10955:1: ( ( rule__XBasicForLoopExpression__Group_7__0 )? )
            {
            // InternalPureXbase.g:10955:1: ( ( rule__XBasicForLoopExpression__Group_7__0 )? )
            // InternalPureXbase.g:10956:2: ( rule__XBasicForLoopExpression__Group_7__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7()); 
            }
            // InternalPureXbase.g:10957:2: ( rule__XBasicForLoopExpression__Group_7__0 )?
            int alt94=2;
            int LA94_0 = input.LA(1);

            if ( ((LA94_0>=RULE_ID && LA94_0<=RULE_STRING)||LA94_0==28||(LA94_0>=35 && LA94_0<=36)||LA94_0==41||(LA94_0>=45 && LA94_0<=46)||(LA94_0>=48 && LA94_0<=49)||(LA94_0>=56 && LA94_0<=57)||LA94_0==59||LA94_0==61||LA94_0==63||(LA94_0>=66 && LA94_0<=74)||LA94_0==84) ) {
                alt94=1;
            }
            switch (alt94) {
                case 1 :
                    // InternalPureXbase.g:10957:3: rule__XBasicForLoopExpression__Group_7__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBasicForLoopExpression__Group_7__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__7__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__8"
    // InternalPureXbase.g:10965:1: rule__XBasicForLoopExpression__Group__8 : rule__XBasicForLoopExpression__Group__8__Impl rule__XBasicForLoopExpression__Group__9 ;
    public final void rule__XBasicForLoopExpression__Group__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10969:1: ( rule__XBasicForLoopExpression__Group__8__Impl rule__XBasicForLoopExpression__Group__9 )
            // InternalPureXbase.g:10970:2: rule__XBasicForLoopExpression__Group__8__Impl rule__XBasicForLoopExpression__Group__9
            {
            pushFollow(FOLLOW_5);
            rule__XBasicForLoopExpression__Group__8__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__9();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__8"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__8__Impl"
    // InternalPureXbase.g:10977:1: rule__XBasicForLoopExpression__Group__8__Impl : ( ')' ) ;
    public final void rule__XBasicForLoopExpression__Group__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10981:1: ( ( ')' ) )
            // InternalPureXbase.g:10982:1: ( ')' )
            {
            // InternalPureXbase.g:10982:1: ( ')' )
            // InternalPureXbase.g:10983:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getRightParenthesisKeyword_8()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getRightParenthesisKeyword_8()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__8__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__9"
    // InternalPureXbase.g:10992:1: rule__XBasicForLoopExpression__Group__9 : rule__XBasicForLoopExpression__Group__9__Impl ;
    public final void rule__XBasicForLoopExpression__Group__9() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:10996:1: ( rule__XBasicForLoopExpression__Group__9__Impl )
            // InternalPureXbase.g:10997:2: rule__XBasicForLoopExpression__Group__9__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__9__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__9"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__9__Impl"
    // InternalPureXbase.g:11003:1: rule__XBasicForLoopExpression__Group__9__Impl : ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) ) ;
    public final void rule__XBasicForLoopExpression__Group__9__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11007:1: ( ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) ) )
            // InternalPureXbase.g:11008:1: ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) )
            {
            // InternalPureXbase.g:11008:1: ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) )
            // InternalPureXbase.g:11009:2: ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionAssignment_9()); 
            }
            // InternalPureXbase.g:11010:2: ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 )
            // InternalPureXbase.g:11010:3: rule__XBasicForLoopExpression__EachExpressionAssignment_9
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__EachExpressionAssignment_9();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionAssignment_9()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__9__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__0"
    // InternalPureXbase.g:11019:1: rule__XBasicForLoopExpression__Group_3__0 : rule__XBasicForLoopExpression__Group_3__0__Impl rule__XBasicForLoopExpression__Group_3__1 ;
    public final void rule__XBasicForLoopExpression__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11023:1: ( rule__XBasicForLoopExpression__Group_3__0__Impl rule__XBasicForLoopExpression__Group_3__1 )
            // InternalPureXbase.g:11024:2: rule__XBasicForLoopExpression__Group_3__0__Impl rule__XBasicForLoopExpression__Group_3__1
            {
            pushFollow(FOLLOW_54);
            rule__XBasicForLoopExpression__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__0__Impl"
    // InternalPureXbase.g:11031:1: rule__XBasicForLoopExpression__Group_3__0__Impl : ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11035:1: ( ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) ) )
            // InternalPureXbase.g:11036:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) )
            {
            // InternalPureXbase.g:11036:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) )
            // InternalPureXbase.g:11037:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_0()); 
            }
            // InternalPureXbase.g:11038:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 )
            // InternalPureXbase.g:11038:3: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__1"
    // InternalPureXbase.g:11046:1: rule__XBasicForLoopExpression__Group_3__1 : rule__XBasicForLoopExpression__Group_3__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11050:1: ( rule__XBasicForLoopExpression__Group_3__1__Impl )
            // InternalPureXbase.g:11051:2: rule__XBasicForLoopExpression__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__1__Impl"
    // InternalPureXbase.g:11057:1: rule__XBasicForLoopExpression__Group_3__1__Impl : ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* ) ;
    public final void rule__XBasicForLoopExpression__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11061:1: ( ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* ) )
            // InternalPureXbase.g:11062:1: ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* )
            {
            // InternalPureXbase.g:11062:1: ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* )
            // InternalPureXbase.g:11063:2: ( rule__XBasicForLoopExpression__Group_3_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3_1()); 
            }
            // InternalPureXbase.g:11064:2: ( rule__XBasicForLoopExpression__Group_3_1__0 )*
            loop95:
            do {
                int alt95=2;
                int LA95_0 = input.LA(1);

                if ( (LA95_0==55) ) {
                    alt95=1;
                }


                switch (alt95) {
            	case 1 :
            	    // InternalPureXbase.g:11064:3: rule__XBasicForLoopExpression__Group_3_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XBasicForLoopExpression__Group_3_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop95;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__0"
    // InternalPureXbase.g:11073:1: rule__XBasicForLoopExpression__Group_3_1__0 : rule__XBasicForLoopExpression__Group_3_1__0__Impl rule__XBasicForLoopExpression__Group_3_1__1 ;
    public final void rule__XBasicForLoopExpression__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11077:1: ( rule__XBasicForLoopExpression__Group_3_1__0__Impl rule__XBasicForLoopExpression__Group_3_1__1 )
            // InternalPureXbase.g:11078:2: rule__XBasicForLoopExpression__Group_3_1__0__Impl rule__XBasicForLoopExpression__Group_3_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XBasicForLoopExpression__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__0__Impl"
    // InternalPureXbase.g:11085:1: rule__XBasicForLoopExpression__Group_3_1__0__Impl : ( ',' ) ;
    public final void rule__XBasicForLoopExpression__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11089:1: ( ( ',' ) )
            // InternalPureXbase.g:11090:1: ( ',' )
            {
            // InternalPureXbase.g:11090:1: ( ',' )
            // InternalPureXbase.g:11091:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_3_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__1"
    // InternalPureXbase.g:11100:1: rule__XBasicForLoopExpression__Group_3_1__1 : rule__XBasicForLoopExpression__Group_3_1__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11104:1: ( rule__XBasicForLoopExpression__Group_3_1__1__Impl )
            // InternalPureXbase.g:11105:2: rule__XBasicForLoopExpression__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__1__Impl"
    // InternalPureXbase.g:11111:1: rule__XBasicForLoopExpression__Group_3_1__1__Impl : ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11115:1: ( ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) ) )
            // InternalPureXbase.g:11116:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) )
            {
            // InternalPureXbase.g:11116:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) )
            // InternalPureXbase.g:11117:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_1_1()); 
            }
            // InternalPureXbase.g:11118:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 )
            // InternalPureXbase.g:11118:3: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__0"
    // InternalPureXbase.g:11127:1: rule__XBasicForLoopExpression__Group_7__0 : rule__XBasicForLoopExpression__Group_7__0__Impl rule__XBasicForLoopExpression__Group_7__1 ;
    public final void rule__XBasicForLoopExpression__Group_7__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11131:1: ( rule__XBasicForLoopExpression__Group_7__0__Impl rule__XBasicForLoopExpression__Group_7__1 )
            // InternalPureXbase.g:11132:2: rule__XBasicForLoopExpression__Group_7__0__Impl rule__XBasicForLoopExpression__Group_7__1
            {
            pushFollow(FOLLOW_54);
            rule__XBasicForLoopExpression__Group_7__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__0__Impl"
    // InternalPureXbase.g:11139:1: rule__XBasicForLoopExpression__Group_7__0__Impl : ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_7__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11143:1: ( ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) ) )
            // InternalPureXbase.g:11144:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) )
            {
            // InternalPureXbase.g:11144:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) )
            // InternalPureXbase.g:11145:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_0()); 
            }
            // InternalPureXbase.g:11146:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 )
            // InternalPureXbase.g:11146:3: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__1"
    // InternalPureXbase.g:11154:1: rule__XBasicForLoopExpression__Group_7__1 : rule__XBasicForLoopExpression__Group_7__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_7__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11158:1: ( rule__XBasicForLoopExpression__Group_7__1__Impl )
            // InternalPureXbase.g:11159:2: rule__XBasicForLoopExpression__Group_7__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__1__Impl"
    // InternalPureXbase.g:11165:1: rule__XBasicForLoopExpression__Group_7__1__Impl : ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* ) ;
    public final void rule__XBasicForLoopExpression__Group_7__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11169:1: ( ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* ) )
            // InternalPureXbase.g:11170:1: ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* )
            {
            // InternalPureXbase.g:11170:1: ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* )
            // InternalPureXbase.g:11171:2: ( rule__XBasicForLoopExpression__Group_7_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7_1()); 
            }
            // InternalPureXbase.g:11172:2: ( rule__XBasicForLoopExpression__Group_7_1__0 )*
            loop96:
            do {
                int alt96=2;
                int LA96_0 = input.LA(1);

                if ( (LA96_0==55) ) {
                    alt96=1;
                }


                switch (alt96) {
            	case 1 :
            	    // InternalPureXbase.g:11172:3: rule__XBasicForLoopExpression__Group_7_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XBasicForLoopExpression__Group_7_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop96;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__0"
    // InternalPureXbase.g:11181:1: rule__XBasicForLoopExpression__Group_7_1__0 : rule__XBasicForLoopExpression__Group_7_1__0__Impl rule__XBasicForLoopExpression__Group_7_1__1 ;
    public final void rule__XBasicForLoopExpression__Group_7_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11185:1: ( rule__XBasicForLoopExpression__Group_7_1__0__Impl rule__XBasicForLoopExpression__Group_7_1__1 )
            // InternalPureXbase.g:11186:2: rule__XBasicForLoopExpression__Group_7_1__0__Impl rule__XBasicForLoopExpression__Group_7_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XBasicForLoopExpression__Group_7_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__0__Impl"
    // InternalPureXbase.g:11193:1: rule__XBasicForLoopExpression__Group_7_1__0__Impl : ( ',' ) ;
    public final void rule__XBasicForLoopExpression__Group_7_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11197:1: ( ( ',' ) )
            // InternalPureXbase.g:11198:1: ( ',' )
            {
            // InternalPureXbase.g:11198:1: ( ',' )
            // InternalPureXbase.g:11199:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_7_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_7_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__1"
    // InternalPureXbase.g:11208:1: rule__XBasicForLoopExpression__Group_7_1__1 : rule__XBasicForLoopExpression__Group_7_1__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_7_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11212:1: ( rule__XBasicForLoopExpression__Group_7_1__1__Impl )
            // InternalPureXbase.g:11213:2: rule__XBasicForLoopExpression__Group_7_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__1__Impl"
    // InternalPureXbase.g:11219:1: rule__XBasicForLoopExpression__Group_7_1__1__Impl : ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_7_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11223:1: ( ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) ) )
            // InternalPureXbase.g:11224:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) )
            {
            // InternalPureXbase.g:11224:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) )
            // InternalPureXbase.g:11225:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_1_1()); 
            }
            // InternalPureXbase.g:11226:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 )
            // InternalPureXbase.g:11226:3: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__1__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__0"
    // InternalPureXbase.g:11235:1: rule__XWhileExpression__Group__0 : rule__XWhileExpression__Group__0__Impl rule__XWhileExpression__Group__1 ;
    public final void rule__XWhileExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11239:1: ( rule__XWhileExpression__Group__0__Impl rule__XWhileExpression__Group__1 )
            // InternalPureXbase.g:11240:2: rule__XWhileExpression__Group__0__Impl rule__XWhileExpression__Group__1
            {
            pushFollow(FOLLOW_75);
            rule__XWhileExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__0"


    // $ANTLR start "rule__XWhileExpression__Group__0__Impl"
    // InternalPureXbase.g:11247:1: rule__XWhileExpression__Group__0__Impl : ( () ) ;
    public final void rule__XWhileExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11251:1: ( ( () ) )
            // InternalPureXbase.g:11252:1: ( () )
            {
            // InternalPureXbase.g:11252:1: ( () )
            // InternalPureXbase.g:11253:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getXWhileExpressionAction_0()); 
            }
            // InternalPureXbase.g:11254:2: ()
            // InternalPureXbase.g:11254:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getXWhileExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__0__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__1"
    // InternalPureXbase.g:11262:1: rule__XWhileExpression__Group__1 : rule__XWhileExpression__Group__1__Impl rule__XWhileExpression__Group__2 ;
    public final void rule__XWhileExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11266:1: ( rule__XWhileExpression__Group__1__Impl rule__XWhileExpression__Group__2 )
            // InternalPureXbase.g:11267:2: rule__XWhileExpression__Group__1__Impl rule__XWhileExpression__Group__2
            {
            pushFollow(FOLLOW_65);
            rule__XWhileExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__1"


    // $ANTLR start "rule__XWhileExpression__Group__1__Impl"
    // InternalPureXbase.g:11274:1: rule__XWhileExpression__Group__1__Impl : ( 'while' ) ;
    public final void rule__XWhileExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11278:1: ( ( 'while' ) )
            // InternalPureXbase.g:11279:1: ( 'while' )
            {
            // InternalPureXbase.g:11279:1: ( 'while' )
            // InternalPureXbase.g:11280:2: 'while'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getWhileKeyword_1()); 
            }
            match(input,67,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getWhileKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__1__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__2"
    // InternalPureXbase.g:11289:1: rule__XWhileExpression__Group__2 : rule__XWhileExpression__Group__2__Impl rule__XWhileExpression__Group__3 ;
    public final void rule__XWhileExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11293:1: ( rule__XWhileExpression__Group__2__Impl rule__XWhileExpression__Group__3 )
            // InternalPureXbase.g:11294:2: rule__XWhileExpression__Group__2__Impl rule__XWhileExpression__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__XWhileExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__2"


    // $ANTLR start "rule__XWhileExpression__Group__2__Impl"
    // InternalPureXbase.g:11301:1: rule__XWhileExpression__Group__2__Impl : ( '(' ) ;
    public final void rule__XWhileExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11305:1: ( ( '(' ) )
            // InternalPureXbase.g:11306:1: ( '(' )
            {
            // InternalPureXbase.g:11306:1: ( '(' )
            // InternalPureXbase.g:11307:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__2__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__3"
    // InternalPureXbase.g:11316:1: rule__XWhileExpression__Group__3 : rule__XWhileExpression__Group__3__Impl rule__XWhileExpression__Group__4 ;
    public final void rule__XWhileExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11320:1: ( rule__XWhileExpression__Group__3__Impl rule__XWhileExpression__Group__4 )
            // InternalPureXbase.g:11321:2: rule__XWhileExpression__Group__3__Impl rule__XWhileExpression__Group__4
            {
            pushFollow(FOLLOW_63);
            rule__XWhileExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__3"


    // $ANTLR start "rule__XWhileExpression__Group__3__Impl"
    // InternalPureXbase.g:11328:1: rule__XWhileExpression__Group__3__Impl : ( ( rule__XWhileExpression__PredicateAssignment_3 ) ) ;
    public final void rule__XWhileExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11332:1: ( ( ( rule__XWhileExpression__PredicateAssignment_3 ) ) )
            // InternalPureXbase.g:11333:1: ( ( rule__XWhileExpression__PredicateAssignment_3 ) )
            {
            // InternalPureXbase.g:11333:1: ( ( rule__XWhileExpression__PredicateAssignment_3 ) )
            // InternalPureXbase.g:11334:2: ( rule__XWhileExpression__PredicateAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getPredicateAssignment_3()); 
            }
            // InternalPureXbase.g:11335:2: ( rule__XWhileExpression__PredicateAssignment_3 )
            // InternalPureXbase.g:11335:3: rule__XWhileExpression__PredicateAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__PredicateAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getPredicateAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__3__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__4"
    // InternalPureXbase.g:11343:1: rule__XWhileExpression__Group__4 : rule__XWhileExpression__Group__4__Impl rule__XWhileExpression__Group__5 ;
    public final void rule__XWhileExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11347:1: ( rule__XWhileExpression__Group__4__Impl rule__XWhileExpression__Group__5 )
            // InternalPureXbase.g:11348:2: rule__XWhileExpression__Group__4__Impl rule__XWhileExpression__Group__5
            {
            pushFollow(FOLLOW_5);
            rule__XWhileExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__4"


    // $ANTLR start "rule__XWhileExpression__Group__4__Impl"
    // InternalPureXbase.g:11355:1: rule__XWhileExpression__Group__4__Impl : ( ')' ) ;
    public final void rule__XWhileExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11359:1: ( ( ')' ) )
            // InternalPureXbase.g:11360:1: ( ')' )
            {
            // InternalPureXbase.g:11360:1: ( ')' )
            // InternalPureXbase.g:11361:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getRightParenthesisKeyword_4()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getRightParenthesisKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__4__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__5"
    // InternalPureXbase.g:11370:1: rule__XWhileExpression__Group__5 : rule__XWhileExpression__Group__5__Impl ;
    public final void rule__XWhileExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11374:1: ( rule__XWhileExpression__Group__5__Impl )
            // InternalPureXbase.g:11375:2: rule__XWhileExpression__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__5"


    // $ANTLR start "rule__XWhileExpression__Group__5__Impl"
    // InternalPureXbase.g:11381:1: rule__XWhileExpression__Group__5__Impl : ( ( rule__XWhileExpression__BodyAssignment_5 ) ) ;
    public final void rule__XWhileExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11385:1: ( ( ( rule__XWhileExpression__BodyAssignment_5 ) ) )
            // InternalPureXbase.g:11386:1: ( ( rule__XWhileExpression__BodyAssignment_5 ) )
            {
            // InternalPureXbase.g:11386:1: ( ( rule__XWhileExpression__BodyAssignment_5 ) )
            // InternalPureXbase.g:11387:2: ( rule__XWhileExpression__BodyAssignment_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getBodyAssignment_5()); 
            }
            // InternalPureXbase.g:11388:2: ( rule__XWhileExpression__BodyAssignment_5 )
            // InternalPureXbase.g:11388:3: rule__XWhileExpression__BodyAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__BodyAssignment_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getBodyAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__5__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__0"
    // InternalPureXbase.g:11397:1: rule__XDoWhileExpression__Group__0 : rule__XDoWhileExpression__Group__0__Impl rule__XDoWhileExpression__Group__1 ;
    public final void rule__XDoWhileExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11401:1: ( rule__XDoWhileExpression__Group__0__Impl rule__XDoWhileExpression__Group__1 )
            // InternalPureXbase.g:11402:2: rule__XDoWhileExpression__Group__0__Impl rule__XDoWhileExpression__Group__1
            {
            pushFollow(FOLLOW_76);
            rule__XDoWhileExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__0"


    // $ANTLR start "rule__XDoWhileExpression__Group__0__Impl"
    // InternalPureXbase.g:11409:1: rule__XDoWhileExpression__Group__0__Impl : ( () ) ;
    public final void rule__XDoWhileExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11413:1: ( ( () ) )
            // InternalPureXbase.g:11414:1: ( () )
            {
            // InternalPureXbase.g:11414:1: ( () )
            // InternalPureXbase.g:11415:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getXDoWhileExpressionAction_0()); 
            }
            // InternalPureXbase.g:11416:2: ()
            // InternalPureXbase.g:11416:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getXDoWhileExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__0__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__1"
    // InternalPureXbase.g:11424:1: rule__XDoWhileExpression__Group__1 : rule__XDoWhileExpression__Group__1__Impl rule__XDoWhileExpression__Group__2 ;
    public final void rule__XDoWhileExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11428:1: ( rule__XDoWhileExpression__Group__1__Impl rule__XDoWhileExpression__Group__2 )
            // InternalPureXbase.g:11429:2: rule__XDoWhileExpression__Group__1__Impl rule__XDoWhileExpression__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__XDoWhileExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__1"


    // $ANTLR start "rule__XDoWhileExpression__Group__1__Impl"
    // InternalPureXbase.g:11436:1: rule__XDoWhileExpression__Group__1__Impl : ( 'do' ) ;
    public final void rule__XDoWhileExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11440:1: ( ( 'do' ) )
            // InternalPureXbase.g:11441:1: ( 'do' )
            {
            // InternalPureXbase.g:11441:1: ( 'do' )
            // InternalPureXbase.g:11442:2: 'do'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getDoKeyword_1()); 
            }
            match(input,68,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getDoKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__1__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__2"
    // InternalPureXbase.g:11451:1: rule__XDoWhileExpression__Group__2 : rule__XDoWhileExpression__Group__2__Impl rule__XDoWhileExpression__Group__3 ;
    public final void rule__XDoWhileExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11455:1: ( rule__XDoWhileExpression__Group__2__Impl rule__XDoWhileExpression__Group__3 )
            // InternalPureXbase.g:11456:2: rule__XDoWhileExpression__Group__2__Impl rule__XDoWhileExpression__Group__3
            {
            pushFollow(FOLLOW_75);
            rule__XDoWhileExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__2"


    // $ANTLR start "rule__XDoWhileExpression__Group__2__Impl"
    // InternalPureXbase.g:11463:1: rule__XDoWhileExpression__Group__2__Impl : ( ( rule__XDoWhileExpression__BodyAssignment_2 ) ) ;
    public final void rule__XDoWhileExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11467:1: ( ( ( rule__XDoWhileExpression__BodyAssignment_2 ) ) )
            // InternalPureXbase.g:11468:1: ( ( rule__XDoWhileExpression__BodyAssignment_2 ) )
            {
            // InternalPureXbase.g:11468:1: ( ( rule__XDoWhileExpression__BodyAssignment_2 ) )
            // InternalPureXbase.g:11469:2: ( rule__XDoWhileExpression__BodyAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getBodyAssignment_2()); 
            }
            // InternalPureXbase.g:11470:2: ( rule__XDoWhileExpression__BodyAssignment_2 )
            // InternalPureXbase.g:11470:3: rule__XDoWhileExpression__BodyAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__BodyAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getBodyAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__2__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__3"
    // InternalPureXbase.g:11478:1: rule__XDoWhileExpression__Group__3 : rule__XDoWhileExpression__Group__3__Impl rule__XDoWhileExpression__Group__4 ;
    public final void rule__XDoWhileExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11482:1: ( rule__XDoWhileExpression__Group__3__Impl rule__XDoWhileExpression__Group__4 )
            // InternalPureXbase.g:11483:2: rule__XDoWhileExpression__Group__3__Impl rule__XDoWhileExpression__Group__4
            {
            pushFollow(FOLLOW_65);
            rule__XDoWhileExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__3"


    // $ANTLR start "rule__XDoWhileExpression__Group__3__Impl"
    // InternalPureXbase.g:11490:1: rule__XDoWhileExpression__Group__3__Impl : ( 'while' ) ;
    public final void rule__XDoWhileExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11494:1: ( ( 'while' ) )
            // InternalPureXbase.g:11495:1: ( 'while' )
            {
            // InternalPureXbase.g:11495:1: ( 'while' )
            // InternalPureXbase.g:11496:2: 'while'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getWhileKeyword_3()); 
            }
            match(input,67,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getWhileKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__3__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__4"
    // InternalPureXbase.g:11505:1: rule__XDoWhileExpression__Group__4 : rule__XDoWhileExpression__Group__4__Impl rule__XDoWhileExpression__Group__5 ;
    public final void rule__XDoWhileExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11509:1: ( rule__XDoWhileExpression__Group__4__Impl rule__XDoWhileExpression__Group__5 )
            // InternalPureXbase.g:11510:2: rule__XDoWhileExpression__Group__4__Impl rule__XDoWhileExpression__Group__5
            {
            pushFollow(FOLLOW_5);
            rule__XDoWhileExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__4"


    // $ANTLR start "rule__XDoWhileExpression__Group__4__Impl"
    // InternalPureXbase.g:11517:1: rule__XDoWhileExpression__Group__4__Impl : ( '(' ) ;
    public final void rule__XDoWhileExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11521:1: ( ( '(' ) )
            // InternalPureXbase.g:11522:1: ( '(' )
            {
            // InternalPureXbase.g:11522:1: ( '(' )
            // InternalPureXbase.g:11523:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getLeftParenthesisKeyword_4()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getLeftParenthesisKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__4__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__5"
    // InternalPureXbase.g:11532:1: rule__XDoWhileExpression__Group__5 : rule__XDoWhileExpression__Group__5__Impl rule__XDoWhileExpression__Group__6 ;
    public final void rule__XDoWhileExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11536:1: ( rule__XDoWhileExpression__Group__5__Impl rule__XDoWhileExpression__Group__6 )
            // InternalPureXbase.g:11537:2: rule__XDoWhileExpression__Group__5__Impl rule__XDoWhileExpression__Group__6
            {
            pushFollow(FOLLOW_63);
            rule__XDoWhileExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__5"


    // $ANTLR start "rule__XDoWhileExpression__Group__5__Impl"
    // InternalPureXbase.g:11544:1: rule__XDoWhileExpression__Group__5__Impl : ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) ) ;
    public final void rule__XDoWhileExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11548:1: ( ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) ) )
            // InternalPureXbase.g:11549:1: ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) )
            {
            // InternalPureXbase.g:11549:1: ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) )
            // InternalPureXbase.g:11550:2: ( rule__XDoWhileExpression__PredicateAssignment_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getPredicateAssignment_5()); 
            }
            // InternalPureXbase.g:11551:2: ( rule__XDoWhileExpression__PredicateAssignment_5 )
            // InternalPureXbase.g:11551:3: rule__XDoWhileExpression__PredicateAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__PredicateAssignment_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getPredicateAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__5__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__6"
    // InternalPureXbase.g:11559:1: rule__XDoWhileExpression__Group__6 : rule__XDoWhileExpression__Group__6__Impl ;
    public final void rule__XDoWhileExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11563:1: ( rule__XDoWhileExpression__Group__6__Impl )
            // InternalPureXbase.g:11564:2: rule__XDoWhileExpression__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__6"


    // $ANTLR start "rule__XDoWhileExpression__Group__6__Impl"
    // InternalPureXbase.g:11570:1: rule__XDoWhileExpression__Group__6__Impl : ( ')' ) ;
    public final void rule__XDoWhileExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11574:1: ( ( ')' ) )
            // InternalPureXbase.g:11575:1: ( ')' )
            {
            // InternalPureXbase.g:11575:1: ( ')' )
            // InternalPureXbase.g:11576:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getRightParenthesisKeyword_6()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getRightParenthesisKeyword_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__6__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__0"
    // InternalPureXbase.g:11586:1: rule__XBlockExpression__Group__0 : rule__XBlockExpression__Group__0__Impl rule__XBlockExpression__Group__1 ;
    public final void rule__XBlockExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11590:1: ( rule__XBlockExpression__Group__0__Impl rule__XBlockExpression__Group__1 )
            // InternalPureXbase.g:11591:2: rule__XBlockExpression__Group__0__Impl rule__XBlockExpression__Group__1
            {
            pushFollow(FOLLOW_56);
            rule__XBlockExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__0"


    // $ANTLR start "rule__XBlockExpression__Group__0__Impl"
    // InternalPureXbase.g:11598:1: rule__XBlockExpression__Group__0__Impl : ( () ) ;
    public final void rule__XBlockExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11602:1: ( ( () ) )
            // InternalPureXbase.g:11603:1: ( () )
            {
            // InternalPureXbase.g:11603:1: ( () )
            // InternalPureXbase.g:11604:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getXBlockExpressionAction_0()); 
            }
            // InternalPureXbase.g:11605:2: ()
            // InternalPureXbase.g:11605:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getXBlockExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__0__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__1"
    // InternalPureXbase.g:11613:1: rule__XBlockExpression__Group__1 : rule__XBlockExpression__Group__1__Impl rule__XBlockExpression__Group__2 ;
    public final void rule__XBlockExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11617:1: ( rule__XBlockExpression__Group__1__Impl rule__XBlockExpression__Group__2 )
            // InternalPureXbase.g:11618:2: rule__XBlockExpression__Group__1__Impl rule__XBlockExpression__Group__2
            {
            pushFollow(FOLLOW_57);
            rule__XBlockExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__1"


    // $ANTLR start "rule__XBlockExpression__Group__1__Impl"
    // InternalPureXbase.g:11625:1: rule__XBlockExpression__Group__1__Impl : ( '{' ) ;
    public final void rule__XBlockExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11629:1: ( ( '{' ) )
            // InternalPureXbase.g:11630:1: ( '{' )
            {
            // InternalPureXbase.g:11630:1: ( '{' )
            // InternalPureXbase.g:11631:2: '{'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getLeftCurlyBracketKeyword_1()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getLeftCurlyBracketKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__1__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__2"
    // InternalPureXbase.g:11640:1: rule__XBlockExpression__Group__2 : rule__XBlockExpression__Group__2__Impl rule__XBlockExpression__Group__3 ;
    public final void rule__XBlockExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11644:1: ( rule__XBlockExpression__Group__2__Impl rule__XBlockExpression__Group__3 )
            // InternalPureXbase.g:11645:2: rule__XBlockExpression__Group__2__Impl rule__XBlockExpression__Group__3
            {
            pushFollow(FOLLOW_57);
            rule__XBlockExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__2"


    // $ANTLR start "rule__XBlockExpression__Group__2__Impl"
    // InternalPureXbase.g:11652:1: rule__XBlockExpression__Group__2__Impl : ( ( rule__XBlockExpression__Group_2__0 )* ) ;
    public final void rule__XBlockExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11656:1: ( ( ( rule__XBlockExpression__Group_2__0 )* ) )
            // InternalPureXbase.g:11657:1: ( ( rule__XBlockExpression__Group_2__0 )* )
            {
            // InternalPureXbase.g:11657:1: ( ( rule__XBlockExpression__Group_2__0 )* )
            // InternalPureXbase.g:11658:2: ( rule__XBlockExpression__Group_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getGroup_2()); 
            }
            // InternalPureXbase.g:11659:2: ( rule__XBlockExpression__Group_2__0 )*
            loop97:
            do {
                int alt97=2;
                int LA97_0 = input.LA(1);

                if ( ((LA97_0>=RULE_ID && LA97_0<=RULE_STRING)||LA97_0==16||LA97_0==28||(LA97_0>=35 && LA97_0<=36)||LA97_0==41||(LA97_0>=45 && LA97_0<=46)||(LA97_0>=48 && LA97_0<=49)||(LA97_0>=56 && LA97_0<=57)||LA97_0==59||LA97_0==61||LA97_0==63||(LA97_0>=66 && LA97_0<=74)||LA97_0==80||LA97_0==84) ) {
                    alt97=1;
                }


                switch (alt97) {
            	case 1 :
            	    // InternalPureXbase.g:11659:3: rule__XBlockExpression__Group_2__0
            	    {
            	    pushFollow(FOLLOW_6);
            	    rule__XBlockExpression__Group_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop97;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getGroup_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__2__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__3"
    // InternalPureXbase.g:11667:1: rule__XBlockExpression__Group__3 : rule__XBlockExpression__Group__3__Impl ;
    public final void rule__XBlockExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11671:1: ( rule__XBlockExpression__Group__3__Impl )
            // InternalPureXbase.g:11672:2: rule__XBlockExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__3"


    // $ANTLR start "rule__XBlockExpression__Group__3__Impl"
    // InternalPureXbase.g:11678:1: rule__XBlockExpression__Group__3__Impl : ( '}' ) ;
    public final void rule__XBlockExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11682:1: ( ( '}' ) )
            // InternalPureXbase.g:11683:1: ( '}' )
            {
            // InternalPureXbase.g:11683:1: ( '}' )
            // InternalPureXbase.g:11684:2: '}'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getRightCurlyBracketKeyword_3()); 
            }
            match(input,58,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getRightCurlyBracketKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__3__Impl"


    // $ANTLR start "rule__XBlockExpression__Group_2__0"
    // InternalPureXbase.g:11694:1: rule__XBlockExpression__Group_2__0 : rule__XBlockExpression__Group_2__0__Impl rule__XBlockExpression__Group_2__1 ;
    public final void rule__XBlockExpression__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11698:1: ( rule__XBlockExpression__Group_2__0__Impl rule__XBlockExpression__Group_2__1 )
            // InternalPureXbase.g:11699:2: rule__XBlockExpression__Group_2__0__Impl rule__XBlockExpression__Group_2__1
            {
            pushFollow(FOLLOW_7);
            rule__XBlockExpression__Group_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__0"


    // $ANTLR start "rule__XBlockExpression__Group_2__0__Impl"
    // InternalPureXbase.g:11706:1: rule__XBlockExpression__Group_2__0__Impl : ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) ) ;
    public final void rule__XBlockExpression__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11710:1: ( ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) ) )
            // InternalPureXbase.g:11711:1: ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) )
            {
            // InternalPureXbase.g:11711:1: ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) )
            // InternalPureXbase.g:11712:2: ( rule__XBlockExpression__ExpressionsAssignment_2_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getExpressionsAssignment_2_0()); 
            }
            // InternalPureXbase.g:11713:2: ( rule__XBlockExpression__ExpressionsAssignment_2_0 )
            // InternalPureXbase.g:11713:3: rule__XBlockExpression__ExpressionsAssignment_2_0
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__ExpressionsAssignment_2_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getExpressionsAssignment_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__0__Impl"


    // $ANTLR start "rule__XBlockExpression__Group_2__1"
    // InternalPureXbase.g:11721:1: rule__XBlockExpression__Group_2__1 : rule__XBlockExpression__Group_2__1__Impl ;
    public final void rule__XBlockExpression__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11725:1: ( rule__XBlockExpression__Group_2__1__Impl )
            // InternalPureXbase.g:11726:2: rule__XBlockExpression__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__1"


    // $ANTLR start "rule__XBlockExpression__Group_2__1__Impl"
    // InternalPureXbase.g:11732:1: rule__XBlockExpression__Group_2__1__Impl : ( ( ';' )? ) ;
    public final void rule__XBlockExpression__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11736:1: ( ( ( ';' )? ) )
            // InternalPureXbase.g:11737:1: ( ( ';' )? )
            {
            // InternalPureXbase.g:11737:1: ( ( ';' )? )
            // InternalPureXbase.g:11738:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getSemicolonKeyword_2_1()); 
            }
            // InternalPureXbase.g:11739:2: ( ';' )?
            int alt98=2;
            int LA98_0 = input.LA(1);

            if ( (LA98_0==47) ) {
                alt98=1;
            }
            switch (alt98) {
                case 1 :
                    // InternalPureXbase.g:11739:3: ';'
                    {
                    match(input,47,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getSemicolonKeyword_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__1__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__0"
    // InternalPureXbase.g:11748:1: rule__XVariableDeclaration__Group__0 : rule__XVariableDeclaration__Group__0__Impl rule__XVariableDeclaration__Group__1 ;
    public final void rule__XVariableDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11752:1: ( rule__XVariableDeclaration__Group__0__Impl rule__XVariableDeclaration__Group__1 )
            // InternalPureXbase.g:11753:2: rule__XVariableDeclaration__Group__0__Impl rule__XVariableDeclaration__Group__1
            {
            pushFollow(FOLLOW_9);
            rule__XVariableDeclaration__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__0"


    // $ANTLR start "rule__XVariableDeclaration__Group__0__Impl"
    // InternalPureXbase.g:11760:1: rule__XVariableDeclaration__Group__0__Impl : ( () ) ;
    public final void rule__XVariableDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11764:1: ( ( () ) )
            // InternalPureXbase.g:11765:1: ( () )
            {
            // InternalPureXbase.g:11765:1: ( () )
            // InternalPureXbase.g:11766:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getXVariableDeclarationAction_0()); 
            }
            // InternalPureXbase.g:11767:2: ()
            // InternalPureXbase.g:11767:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getXVariableDeclarationAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__1"
    // InternalPureXbase.g:11775:1: rule__XVariableDeclaration__Group__1 : rule__XVariableDeclaration__Group__1__Impl rule__XVariableDeclaration__Group__2 ;
    public final void rule__XVariableDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11779:1: ( rule__XVariableDeclaration__Group__1__Impl rule__XVariableDeclaration__Group__2 )
            // InternalPureXbase.g:11780:2: rule__XVariableDeclaration__Group__1__Impl rule__XVariableDeclaration__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__XVariableDeclaration__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__1"


    // $ANTLR start "rule__XVariableDeclaration__Group__1__Impl"
    // InternalPureXbase.g:11787:1: rule__XVariableDeclaration__Group__1__Impl : ( ( rule__XVariableDeclaration__Alternatives_1 ) ) ;
    public final void rule__XVariableDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11791:1: ( ( ( rule__XVariableDeclaration__Alternatives_1 ) ) )
            // InternalPureXbase.g:11792:1: ( ( rule__XVariableDeclaration__Alternatives_1 ) )
            {
            // InternalPureXbase.g:11792:1: ( ( rule__XVariableDeclaration__Alternatives_1 ) )
            // InternalPureXbase.g:11793:2: ( rule__XVariableDeclaration__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getAlternatives_1()); 
            }
            // InternalPureXbase.g:11794:2: ( rule__XVariableDeclaration__Alternatives_1 )
            // InternalPureXbase.g:11794:3: rule__XVariableDeclaration__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__1__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__2"
    // InternalPureXbase.g:11802:1: rule__XVariableDeclaration__Group__2 : rule__XVariableDeclaration__Group__2__Impl rule__XVariableDeclaration__Group__3 ;
    public final void rule__XVariableDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11806:1: ( rule__XVariableDeclaration__Group__2__Impl rule__XVariableDeclaration__Group__3 )
            // InternalPureXbase.g:11807:2: rule__XVariableDeclaration__Group__2__Impl rule__XVariableDeclaration__Group__3
            {
            pushFollow(FOLLOW_16);
            rule__XVariableDeclaration__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__2"


    // $ANTLR start "rule__XVariableDeclaration__Group__2__Impl"
    // InternalPureXbase.g:11814:1: rule__XVariableDeclaration__Group__2__Impl : ( ( rule__XVariableDeclaration__Alternatives_2 ) ) ;
    public final void rule__XVariableDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11818:1: ( ( ( rule__XVariableDeclaration__Alternatives_2 ) ) )
            // InternalPureXbase.g:11819:1: ( ( rule__XVariableDeclaration__Alternatives_2 ) )
            {
            // InternalPureXbase.g:11819:1: ( ( rule__XVariableDeclaration__Alternatives_2 ) )
            // InternalPureXbase.g:11820:2: ( rule__XVariableDeclaration__Alternatives_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getAlternatives_2()); 
            }
            // InternalPureXbase.g:11821:2: ( rule__XVariableDeclaration__Alternatives_2 )
            // InternalPureXbase.g:11821:3: rule__XVariableDeclaration__Alternatives_2
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Alternatives_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__2__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__3"
    // InternalPureXbase.g:11829:1: rule__XVariableDeclaration__Group__3 : rule__XVariableDeclaration__Group__3__Impl ;
    public final void rule__XVariableDeclaration__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11833:1: ( rule__XVariableDeclaration__Group__3__Impl )
            // InternalPureXbase.g:11834:2: rule__XVariableDeclaration__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__3"


    // $ANTLR start "rule__XVariableDeclaration__Group__3__Impl"
    // InternalPureXbase.g:11840:1: rule__XVariableDeclaration__Group__3__Impl : ( ( rule__XVariableDeclaration__Group_3__0 )? ) ;
    public final void rule__XVariableDeclaration__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11844:1: ( ( ( rule__XVariableDeclaration__Group_3__0 )? ) )
            // InternalPureXbase.g:11845:1: ( ( rule__XVariableDeclaration__Group_3__0 )? )
            {
            // InternalPureXbase.g:11845:1: ( ( rule__XVariableDeclaration__Group_3__0 )? )
            // InternalPureXbase.g:11846:2: ( rule__XVariableDeclaration__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getGroup_3()); 
            }
            // InternalPureXbase.g:11847:2: ( rule__XVariableDeclaration__Group_3__0 )?
            int alt99=2;
            int LA99_0 = input.LA(1);

            if ( (LA99_0==13) ) {
                alt99=1;
            }
            switch (alt99) {
                case 1 :
                    // InternalPureXbase.g:11847:3: rule__XVariableDeclaration__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__3__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0__0"
    // InternalPureXbase.g:11856:1: rule__XVariableDeclaration__Group_2_0__0 : rule__XVariableDeclaration__Group_2_0__0__Impl ;
    public final void rule__XVariableDeclaration__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11860:1: ( rule__XVariableDeclaration__Group_2_0__0__Impl )
            // InternalPureXbase.g:11861:2: rule__XVariableDeclaration__Group_2_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0__0"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0__0__Impl"
    // InternalPureXbase.g:11867:1: rule__XVariableDeclaration__Group_2_0__0__Impl : ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) ) ;
    public final void rule__XVariableDeclaration__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11871:1: ( ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) ) )
            // InternalPureXbase.g:11872:1: ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) )
            {
            // InternalPureXbase.g:11872:1: ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) )
            // InternalPureXbase.g:11873:2: ( rule__XVariableDeclaration__Group_2_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0_0()); 
            }
            // InternalPureXbase.g:11874:2: ( rule__XVariableDeclaration__Group_2_0_0__0 )
            // InternalPureXbase.g:11874:3: rule__XVariableDeclaration__Group_2_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__0"
    // InternalPureXbase.g:11883:1: rule__XVariableDeclaration__Group_2_0_0__0 : rule__XVariableDeclaration__Group_2_0_0__0__Impl rule__XVariableDeclaration__Group_2_0_0__1 ;
    public final void rule__XVariableDeclaration__Group_2_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11887:1: ( rule__XVariableDeclaration__Group_2_0_0__0__Impl rule__XVariableDeclaration__Group_2_0_0__1 )
            // InternalPureXbase.g:11888:2: rule__XVariableDeclaration__Group_2_0_0__0__Impl rule__XVariableDeclaration__Group_2_0_0__1
            {
            pushFollow(FOLLOW_17);
            rule__XVariableDeclaration__Group_2_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__0"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__0__Impl"
    // InternalPureXbase.g:11895:1: rule__XVariableDeclaration__Group_2_0_0__0__Impl : ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) ) ;
    public final void rule__XVariableDeclaration__Group_2_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11899:1: ( ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) ) )
            // InternalPureXbase.g:11900:1: ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) )
            {
            // InternalPureXbase.g:11900:1: ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) )
            // InternalPureXbase.g:11901:2: ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getTypeAssignment_2_0_0_0()); 
            }
            // InternalPureXbase.g:11902:2: ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 )
            // InternalPureXbase.g:11902:3: rule__XVariableDeclaration__TypeAssignment_2_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__TypeAssignment_2_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getTypeAssignment_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__1"
    // InternalPureXbase.g:11910:1: rule__XVariableDeclaration__Group_2_0_0__1 : rule__XVariableDeclaration__Group_2_0_0__1__Impl ;
    public final void rule__XVariableDeclaration__Group_2_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11914:1: ( rule__XVariableDeclaration__Group_2_0_0__1__Impl )
            // InternalPureXbase.g:11915:2: rule__XVariableDeclaration__Group_2_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__1"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__1__Impl"
    // InternalPureXbase.g:11921:1: rule__XVariableDeclaration__Group_2_0_0__1__Impl : ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) ) ;
    public final void rule__XVariableDeclaration__Group_2_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11925:1: ( ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) ) )
            // InternalPureXbase.g:11926:1: ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) )
            {
            // InternalPureXbase.g:11926:1: ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) )
            // InternalPureXbase.g:11927:2: ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_0_0_1()); 
            }
            // InternalPureXbase.g:11928:2: ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 )
            // InternalPureXbase.g:11928:3: rule__XVariableDeclaration__NameAssignment_2_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__NameAssignment_2_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__1__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__0"
    // InternalPureXbase.g:11937:1: rule__XVariableDeclaration__Group_3__0 : rule__XVariableDeclaration__Group_3__0__Impl rule__XVariableDeclaration__Group_3__1 ;
    public final void rule__XVariableDeclaration__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11941:1: ( rule__XVariableDeclaration__Group_3__0__Impl rule__XVariableDeclaration__Group_3__1 )
            // InternalPureXbase.g:11942:2: rule__XVariableDeclaration__Group_3__0__Impl rule__XVariableDeclaration__Group_3__1
            {
            pushFollow(FOLLOW_5);
            rule__XVariableDeclaration__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__0"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__0__Impl"
    // InternalPureXbase.g:11949:1: rule__XVariableDeclaration__Group_3__0__Impl : ( '=' ) ;
    public final void rule__XVariableDeclaration__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11953:1: ( ( '=' ) )
            // InternalPureXbase.g:11954:1: ( '=' )
            {
            // InternalPureXbase.g:11954:1: ( '=' )
            // InternalPureXbase.g:11955:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getEqualsSignKeyword_3_0()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getEqualsSignKeyword_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__1"
    // InternalPureXbase.g:11964:1: rule__XVariableDeclaration__Group_3__1 : rule__XVariableDeclaration__Group_3__1__Impl ;
    public final void rule__XVariableDeclaration__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11968:1: ( rule__XVariableDeclaration__Group_3__1__Impl )
            // InternalPureXbase.g:11969:2: rule__XVariableDeclaration__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__1"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__1__Impl"
    // InternalPureXbase.g:11975:1: rule__XVariableDeclaration__Group_3__1__Impl : ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) ) ;
    public final void rule__XVariableDeclaration__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11979:1: ( ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) ) )
            // InternalPureXbase.g:11980:1: ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) )
            {
            // InternalPureXbase.g:11980:1: ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) )
            // InternalPureXbase.g:11981:2: ( rule__XVariableDeclaration__RightAssignment_3_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getRightAssignment_3_1()); 
            }
            // InternalPureXbase.g:11982:2: ( rule__XVariableDeclaration__RightAssignment_3_1 )
            // InternalPureXbase.g:11982:3: rule__XVariableDeclaration__RightAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__RightAssignment_3_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getRightAssignment_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__1__Impl"


    // $ANTLR start "rule__JvmFormalParameter__Group__0"
    // InternalPureXbase.g:11991:1: rule__JvmFormalParameter__Group__0 : rule__JvmFormalParameter__Group__0__Impl rule__JvmFormalParameter__Group__1 ;
    public final void rule__JvmFormalParameter__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:11995:1: ( rule__JvmFormalParameter__Group__0__Impl rule__JvmFormalParameter__Group__1 )
            // InternalPureXbase.g:11996:2: rule__JvmFormalParameter__Group__0__Impl rule__JvmFormalParameter__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__JvmFormalParameter__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__0"


    // $ANTLR start "rule__JvmFormalParameter__Group__0__Impl"
    // InternalPureXbase.g:12003:1: rule__JvmFormalParameter__Group__0__Impl : ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? ) ;
    public final void rule__JvmFormalParameter__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12007:1: ( ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? ) )
            // InternalPureXbase.g:12008:1: ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? )
            {
            // InternalPureXbase.g:12008:1: ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? )
            // InternalPureXbase.g:12009:2: ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }
            // InternalPureXbase.g:12010:2: ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )?
            int alt100=2;
            int LA100_0 = input.LA(1);

            if ( (LA100_0==RULE_ID) ) {
                int LA100_1 = input.LA(2);

                if ( (LA100_1==RULE_ID||LA100_1==28||LA100_1==44||LA100_1==59) ) {
                    alt100=1;
                }
            }
            else if ( (LA100_0==32||LA100_0==49) ) {
                alt100=1;
            }
            switch (alt100) {
                case 1 :
                    // InternalPureXbase.g:12010:3: rule__JvmFormalParameter__ParameterTypeAssignment_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmFormalParameter__ParameterTypeAssignment_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__0__Impl"


    // $ANTLR start "rule__JvmFormalParameter__Group__1"
    // InternalPureXbase.g:12018:1: rule__JvmFormalParameter__Group__1 : rule__JvmFormalParameter__Group__1__Impl ;
    public final void rule__JvmFormalParameter__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12022:1: ( rule__JvmFormalParameter__Group__1__Impl )
            // InternalPureXbase.g:12023:2: rule__JvmFormalParameter__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__1"


    // $ANTLR start "rule__JvmFormalParameter__Group__1__Impl"
    // InternalPureXbase.g:12029:1: rule__JvmFormalParameter__Group__1__Impl : ( ( rule__JvmFormalParameter__NameAssignment_1 ) ) ;
    public final void rule__JvmFormalParameter__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12033:1: ( ( ( rule__JvmFormalParameter__NameAssignment_1 ) ) )
            // InternalPureXbase.g:12034:1: ( ( rule__JvmFormalParameter__NameAssignment_1 ) )
            {
            // InternalPureXbase.g:12034:1: ( ( rule__JvmFormalParameter__NameAssignment_1 ) )
            // InternalPureXbase.g:12035:2: ( rule__JvmFormalParameter__NameAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getNameAssignment_1()); 
            }
            // InternalPureXbase.g:12036:2: ( rule__JvmFormalParameter__NameAssignment_1 )
            // InternalPureXbase.g:12036:3: rule__JvmFormalParameter__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__NameAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getNameAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__1__Impl"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__0"
    // InternalPureXbase.g:12045:1: rule__FullJvmFormalParameter__Group__0 : rule__FullJvmFormalParameter__Group__0__Impl rule__FullJvmFormalParameter__Group__1 ;
    public final void rule__FullJvmFormalParameter__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12049:1: ( rule__FullJvmFormalParameter__Group__0__Impl rule__FullJvmFormalParameter__Group__1 )
            // InternalPureXbase.g:12050:2: rule__FullJvmFormalParameter__Group__0__Impl rule__FullJvmFormalParameter__Group__1
            {
            pushFollow(FOLLOW_17);
            rule__FullJvmFormalParameter__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__0"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__0__Impl"
    // InternalPureXbase.g:12057:1: rule__FullJvmFormalParameter__Group__0__Impl : ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) ) ;
    public final void rule__FullJvmFormalParameter__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12061:1: ( ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) ) )
            // InternalPureXbase.g:12062:1: ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) )
            {
            // InternalPureXbase.g:12062:1: ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) )
            // InternalPureXbase.g:12063:2: ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }
            // InternalPureXbase.g:12064:2: ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 )
            // InternalPureXbase.g:12064:3: rule__FullJvmFormalParameter__ParameterTypeAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__ParameterTypeAssignment_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__0__Impl"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__1"
    // InternalPureXbase.g:12072:1: rule__FullJvmFormalParameter__Group__1 : rule__FullJvmFormalParameter__Group__1__Impl ;
    public final void rule__FullJvmFormalParameter__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12076:1: ( rule__FullJvmFormalParameter__Group__1__Impl )
            // InternalPureXbase.g:12077:2: rule__FullJvmFormalParameter__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__1"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__1__Impl"
    // InternalPureXbase.g:12083:1: rule__FullJvmFormalParameter__Group__1__Impl : ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) ) ;
    public final void rule__FullJvmFormalParameter__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12087:1: ( ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) ) )
            // InternalPureXbase.g:12088:1: ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) )
            {
            // InternalPureXbase.g:12088:1: ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) )
            // InternalPureXbase.g:12089:2: ( rule__FullJvmFormalParameter__NameAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getNameAssignment_1()); 
            }
            // InternalPureXbase.g:12090:2: ( rule__FullJvmFormalParameter__NameAssignment_1 )
            // InternalPureXbase.g:12090:3: rule__FullJvmFormalParameter__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__NameAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getNameAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__0"
    // InternalPureXbase.g:12099:1: rule__XFeatureCall__Group__0 : rule__XFeatureCall__Group__0__Impl rule__XFeatureCall__Group__1 ;
    public final void rule__XFeatureCall__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12103:1: ( rule__XFeatureCall__Group__0__Impl rule__XFeatureCall__Group__1 )
            // InternalPureXbase.g:12104:2: rule__XFeatureCall__Group__0__Impl rule__XFeatureCall__Group__1
            {
            pushFollow(FOLLOW_48);
            rule__XFeatureCall__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__0"


    // $ANTLR start "rule__XFeatureCall__Group__0__Impl"
    // InternalPureXbase.g:12111:1: rule__XFeatureCall__Group__0__Impl : ( () ) ;
    public final void rule__XFeatureCall__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12115:1: ( ( () ) )
            // InternalPureXbase.g:12116:1: ( () )
            {
            // InternalPureXbase.g:12116:1: ( () )
            // InternalPureXbase.g:12117:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getXFeatureCallAction_0()); 
            }
            // InternalPureXbase.g:12118:2: ()
            // InternalPureXbase.g:12118:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getXFeatureCallAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__1"
    // InternalPureXbase.g:12126:1: rule__XFeatureCall__Group__1 : rule__XFeatureCall__Group__1__Impl rule__XFeatureCall__Group__2 ;
    public final void rule__XFeatureCall__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12130:1: ( rule__XFeatureCall__Group__1__Impl rule__XFeatureCall__Group__2 )
            // InternalPureXbase.g:12131:2: rule__XFeatureCall__Group__1__Impl rule__XFeatureCall__Group__2
            {
            pushFollow(FOLLOW_48);
            rule__XFeatureCall__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__1"


    // $ANTLR start "rule__XFeatureCall__Group__1__Impl"
    // InternalPureXbase.g:12138:1: rule__XFeatureCall__Group__1__Impl : ( ( rule__XFeatureCall__Group_1__0 )? ) ;
    public final void rule__XFeatureCall__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12142:1: ( ( ( rule__XFeatureCall__Group_1__0 )? ) )
            // InternalPureXbase.g:12143:1: ( ( rule__XFeatureCall__Group_1__0 )? )
            {
            // InternalPureXbase.g:12143:1: ( ( rule__XFeatureCall__Group_1__0 )? )
            // InternalPureXbase.g:12144:2: ( rule__XFeatureCall__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:12145:2: ( rule__XFeatureCall__Group_1__0 )?
            int alt101=2;
            int LA101_0 = input.LA(1);

            if ( (LA101_0==28) ) {
                alt101=1;
            }
            switch (alt101) {
                case 1 :
                    // InternalPureXbase.g:12145:3: rule__XFeatureCall__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__2"
    // InternalPureXbase.g:12153:1: rule__XFeatureCall__Group__2 : rule__XFeatureCall__Group__2__Impl rule__XFeatureCall__Group__3 ;
    public final void rule__XFeatureCall__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12157:1: ( rule__XFeatureCall__Group__2__Impl rule__XFeatureCall__Group__3 )
            // InternalPureXbase.g:12158:2: rule__XFeatureCall__Group__2__Impl rule__XFeatureCall__Group__3
            {
            pushFollow(FOLLOW_49);
            rule__XFeatureCall__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__2"


    // $ANTLR start "rule__XFeatureCall__Group__2__Impl"
    // InternalPureXbase.g:12165:1: rule__XFeatureCall__Group__2__Impl : ( ( rule__XFeatureCall__FeatureAssignment_2 ) ) ;
    public final void rule__XFeatureCall__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12169:1: ( ( ( rule__XFeatureCall__FeatureAssignment_2 ) ) )
            // InternalPureXbase.g:12170:1: ( ( rule__XFeatureCall__FeatureAssignment_2 ) )
            {
            // InternalPureXbase.g:12170:1: ( ( rule__XFeatureCall__FeatureAssignment_2 ) )
            // InternalPureXbase.g:12171:2: ( rule__XFeatureCall__FeatureAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureAssignment_2()); 
            }
            // InternalPureXbase.g:12172:2: ( rule__XFeatureCall__FeatureAssignment_2 )
            // InternalPureXbase.g:12172:3: rule__XFeatureCall__FeatureAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__FeatureAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__2__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__3"
    // InternalPureXbase.g:12180:1: rule__XFeatureCall__Group__3 : rule__XFeatureCall__Group__3__Impl rule__XFeatureCall__Group__4 ;
    public final void rule__XFeatureCall__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12184:1: ( rule__XFeatureCall__Group__3__Impl rule__XFeatureCall__Group__4 )
            // InternalPureXbase.g:12185:2: rule__XFeatureCall__Group__3__Impl rule__XFeatureCall__Group__4
            {
            pushFollow(FOLLOW_49);
            rule__XFeatureCall__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__3"


    // $ANTLR start "rule__XFeatureCall__Group__3__Impl"
    // InternalPureXbase.g:12192:1: rule__XFeatureCall__Group__3__Impl : ( ( rule__XFeatureCall__Group_3__0 )? ) ;
    public final void rule__XFeatureCall__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12196:1: ( ( ( rule__XFeatureCall__Group_3__0 )? ) )
            // InternalPureXbase.g:12197:1: ( ( rule__XFeatureCall__Group_3__0 )? )
            {
            // InternalPureXbase.g:12197:1: ( ( rule__XFeatureCall__Group_3__0 )? )
            // InternalPureXbase.g:12198:2: ( rule__XFeatureCall__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_3()); 
            }
            // InternalPureXbase.g:12199:2: ( rule__XFeatureCall__Group_3__0 )?
            int alt102=2;
            alt102 = dfa102.predict(input);
            switch (alt102) {
                case 1 :
                    // InternalPureXbase.g:12199:3: rule__XFeatureCall__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__3__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__4"
    // InternalPureXbase.g:12207:1: rule__XFeatureCall__Group__4 : rule__XFeatureCall__Group__4__Impl ;
    public final void rule__XFeatureCall__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12211:1: ( rule__XFeatureCall__Group__4__Impl )
            // InternalPureXbase.g:12212:2: rule__XFeatureCall__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__4"


    // $ANTLR start "rule__XFeatureCall__Group__4__Impl"
    // InternalPureXbase.g:12218:1: rule__XFeatureCall__Group__4__Impl : ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? ) ;
    public final void rule__XFeatureCall__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12222:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? ) )
            // InternalPureXbase.g:12223:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? )
            {
            // InternalPureXbase.g:12223:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? )
            // InternalPureXbase.g:12224:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_4()); 
            }
            // InternalPureXbase.g:12225:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )?
            int alt103=2;
            alt103 = dfa103.predict(input);
            switch (alt103) {
                case 1 :
                    // InternalPureXbase.g:12225:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_4
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__FeatureCallArgumentsAssignment_4();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__4__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__0"
    // InternalPureXbase.g:12234:1: rule__XFeatureCall__Group_1__0 : rule__XFeatureCall__Group_1__0__Impl rule__XFeatureCall__Group_1__1 ;
    public final void rule__XFeatureCall__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12238:1: ( rule__XFeatureCall__Group_1__0__Impl rule__XFeatureCall__Group_1__1 )
            // InternalPureXbase.g:12239:2: rule__XFeatureCall__Group_1__0__Impl rule__XFeatureCall__Group_1__1
            {
            pushFollow(FOLLOW_50);
            rule__XFeatureCall__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__0"


    // $ANTLR start "rule__XFeatureCall__Group_1__0__Impl"
    // InternalPureXbase.g:12246:1: rule__XFeatureCall__Group_1__0__Impl : ( '<' ) ;
    public final void rule__XFeatureCall__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12250:1: ( ( '<' ) )
            // InternalPureXbase.g:12251:1: ( '<' )
            {
            // InternalPureXbase.g:12251:1: ( '<' )
            // InternalPureXbase.g:12252:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getLessThanSignKeyword_1_0()); 
            }
            match(input,28,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getLessThanSignKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__1"
    // InternalPureXbase.g:12261:1: rule__XFeatureCall__Group_1__1 : rule__XFeatureCall__Group_1__1__Impl rule__XFeatureCall__Group_1__2 ;
    public final void rule__XFeatureCall__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12265:1: ( rule__XFeatureCall__Group_1__1__Impl rule__XFeatureCall__Group_1__2 )
            // InternalPureXbase.g:12266:2: rule__XFeatureCall__Group_1__1__Impl rule__XFeatureCall__Group_1__2
            {
            pushFollow(FOLLOW_51);
            rule__XFeatureCall__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__1"


    // $ANTLR start "rule__XFeatureCall__Group_1__1__Impl"
    // InternalPureXbase.g:12273:1: rule__XFeatureCall__Group_1__1__Impl : ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) ) ;
    public final void rule__XFeatureCall__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12277:1: ( ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) ) )
            // InternalPureXbase.g:12278:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) )
            {
            // InternalPureXbase.g:12278:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) )
            // InternalPureXbase.g:12279:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_1()); 
            }
            // InternalPureXbase.g:12280:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 )
            // InternalPureXbase.g:12280:3: rule__XFeatureCall__TypeArgumentsAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__TypeArgumentsAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__2"
    // InternalPureXbase.g:12288:1: rule__XFeatureCall__Group_1__2 : rule__XFeatureCall__Group_1__2__Impl rule__XFeatureCall__Group_1__3 ;
    public final void rule__XFeatureCall__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12292:1: ( rule__XFeatureCall__Group_1__2__Impl rule__XFeatureCall__Group_1__3 )
            // InternalPureXbase.g:12293:2: rule__XFeatureCall__Group_1__2__Impl rule__XFeatureCall__Group_1__3
            {
            pushFollow(FOLLOW_51);
            rule__XFeatureCall__Group_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__2"


    // $ANTLR start "rule__XFeatureCall__Group_1__2__Impl"
    // InternalPureXbase.g:12300:1: rule__XFeatureCall__Group_1__2__Impl : ( ( rule__XFeatureCall__Group_1_2__0 )* ) ;
    public final void rule__XFeatureCall__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12304:1: ( ( ( rule__XFeatureCall__Group_1_2__0 )* ) )
            // InternalPureXbase.g:12305:1: ( ( rule__XFeatureCall__Group_1_2__0 )* )
            {
            // InternalPureXbase.g:12305:1: ( ( rule__XFeatureCall__Group_1_2__0 )* )
            // InternalPureXbase.g:12306:2: ( rule__XFeatureCall__Group_1_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_1_2()); 
            }
            // InternalPureXbase.g:12307:2: ( rule__XFeatureCall__Group_1_2__0 )*
            loop104:
            do {
                int alt104=2;
                int LA104_0 = input.LA(1);

                if ( (LA104_0==55) ) {
                    alt104=1;
                }


                switch (alt104) {
            	case 1 :
            	    // InternalPureXbase.g:12307:3: rule__XFeatureCall__Group_1_2__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XFeatureCall__Group_1_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop104;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__2__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__3"
    // InternalPureXbase.g:12315:1: rule__XFeatureCall__Group_1__3 : rule__XFeatureCall__Group_1__3__Impl ;
    public final void rule__XFeatureCall__Group_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12319:1: ( rule__XFeatureCall__Group_1__3__Impl )
            // InternalPureXbase.g:12320:2: rule__XFeatureCall__Group_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__3"


    // $ANTLR start "rule__XFeatureCall__Group_1__3__Impl"
    // InternalPureXbase.g:12326:1: rule__XFeatureCall__Group_1__3__Impl : ( '>' ) ;
    public final void rule__XFeatureCall__Group_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12330:1: ( ( '>' ) )
            // InternalPureXbase.g:12331:1: ( '>' )
            {
            // InternalPureXbase.g:12331:1: ( '>' )
            // InternalPureXbase.g:12332:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGreaterThanSignKeyword_1_3()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGreaterThanSignKeyword_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__3__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__0"
    // InternalPureXbase.g:12342:1: rule__XFeatureCall__Group_1_2__0 : rule__XFeatureCall__Group_1_2__0__Impl rule__XFeatureCall__Group_1_2__1 ;
    public final void rule__XFeatureCall__Group_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12346:1: ( rule__XFeatureCall__Group_1_2__0__Impl rule__XFeatureCall__Group_1_2__1 )
            // InternalPureXbase.g:12347:2: rule__XFeatureCall__Group_1_2__0__Impl rule__XFeatureCall__Group_1_2__1
            {
            pushFollow(FOLLOW_50);
            rule__XFeatureCall__Group_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__0"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__0__Impl"
    // InternalPureXbase.g:12354:1: rule__XFeatureCall__Group_1_2__0__Impl : ( ',' ) ;
    public final void rule__XFeatureCall__Group_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12358:1: ( ( ',' ) )
            // InternalPureXbase.g:12359:1: ( ',' )
            {
            // InternalPureXbase.g:12359:1: ( ',' )
            // InternalPureXbase.g:12360:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getCommaKeyword_1_2_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getCommaKeyword_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__1"
    // InternalPureXbase.g:12369:1: rule__XFeatureCall__Group_1_2__1 : rule__XFeatureCall__Group_1_2__1__Impl ;
    public final void rule__XFeatureCall__Group_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12373:1: ( rule__XFeatureCall__Group_1_2__1__Impl )
            // InternalPureXbase.g:12374:2: rule__XFeatureCall__Group_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__1"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__1__Impl"
    // InternalPureXbase.g:12380:1: rule__XFeatureCall__Group_1_2__1__Impl : ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) ) ;
    public final void rule__XFeatureCall__Group_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12384:1: ( ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) ) )
            // InternalPureXbase.g:12385:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) )
            {
            // InternalPureXbase.g:12385:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) )
            // InternalPureXbase.g:12386:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_2_1()); 
            }
            // InternalPureXbase.g:12387:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 )
            // InternalPureXbase.g:12387:3: rule__XFeatureCall__TypeArgumentsAssignment_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__TypeArgumentsAssignment_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3__0"
    // InternalPureXbase.g:12396:1: rule__XFeatureCall__Group_3__0 : rule__XFeatureCall__Group_3__0__Impl rule__XFeatureCall__Group_3__1 ;
    public final void rule__XFeatureCall__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12400:1: ( rule__XFeatureCall__Group_3__0__Impl rule__XFeatureCall__Group_3__1 )
            // InternalPureXbase.g:12401:2: rule__XFeatureCall__Group_3__0__Impl rule__XFeatureCall__Group_3__1
            {
            pushFollow(FOLLOW_53);
            rule__XFeatureCall__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__0"


    // $ANTLR start "rule__XFeatureCall__Group_3__0__Impl"
    // InternalPureXbase.g:12408:1: rule__XFeatureCall__Group_3__0__Impl : ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) ) ;
    public final void rule__XFeatureCall__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12412:1: ( ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) ) )
            // InternalPureXbase.g:12413:1: ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) )
            {
            // InternalPureXbase.g:12413:1: ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) )
            // InternalPureXbase.g:12414:2: ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallAssignment_3_0()); 
            }
            // InternalPureXbase.g:12415:2: ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 )
            // InternalPureXbase.g:12415:3: rule__XFeatureCall__ExplicitOperationCallAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__ExplicitOperationCallAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3__1"
    // InternalPureXbase.g:12423:1: rule__XFeatureCall__Group_3__1 : rule__XFeatureCall__Group_3__1__Impl rule__XFeatureCall__Group_3__2 ;
    public final void rule__XFeatureCall__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12427:1: ( rule__XFeatureCall__Group_3__1__Impl rule__XFeatureCall__Group_3__2 )
            // InternalPureXbase.g:12428:2: rule__XFeatureCall__Group_3__1__Impl rule__XFeatureCall__Group_3__2
            {
            pushFollow(FOLLOW_53);
            rule__XFeatureCall__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__1"


    // $ANTLR start "rule__XFeatureCall__Group_3__1__Impl"
    // InternalPureXbase.g:12435:1: rule__XFeatureCall__Group_3__1__Impl : ( ( rule__XFeatureCall__Alternatives_3_1 )? ) ;
    public final void rule__XFeatureCall__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12439:1: ( ( ( rule__XFeatureCall__Alternatives_3_1 )? ) )
            // InternalPureXbase.g:12440:1: ( ( rule__XFeatureCall__Alternatives_3_1 )? )
            {
            // InternalPureXbase.g:12440:1: ( ( rule__XFeatureCall__Alternatives_3_1 )? )
            // InternalPureXbase.g:12441:2: ( rule__XFeatureCall__Alternatives_3_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getAlternatives_3_1()); 
            }
            // InternalPureXbase.g:12442:2: ( rule__XFeatureCall__Alternatives_3_1 )?
            int alt105=2;
            int LA105_0 = input.LA(1);

            if ( ((LA105_0>=RULE_ID && LA105_0<=RULE_STRING)||LA105_0==28||LA105_0==32||(LA105_0>=35 && LA105_0<=36)||LA105_0==41||(LA105_0>=45 && LA105_0<=46)||(LA105_0>=48 && LA105_0<=49)||(LA105_0>=56 && LA105_0<=57)||LA105_0==59||LA105_0==61||LA105_0==63||(LA105_0>=66 && LA105_0<=74)||(LA105_0>=83 && LA105_0<=84)) ) {
                alt105=1;
            }
            switch (alt105) {
                case 1 :
                    // InternalPureXbase.g:12442:3: rule__XFeatureCall__Alternatives_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Alternatives_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getAlternatives_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3__2"
    // InternalPureXbase.g:12450:1: rule__XFeatureCall__Group_3__2 : rule__XFeatureCall__Group_3__2__Impl ;
    public final void rule__XFeatureCall__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12454:1: ( rule__XFeatureCall__Group_3__2__Impl )
            // InternalPureXbase.g:12455:2: rule__XFeatureCall__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__2"


    // $ANTLR start "rule__XFeatureCall__Group_3__2__Impl"
    // InternalPureXbase.g:12461:1: rule__XFeatureCall__Group_3__2__Impl : ( ')' ) ;
    public final void rule__XFeatureCall__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12465:1: ( ( ')' ) )
            // InternalPureXbase.g:12466:1: ( ')' )
            {
            // InternalPureXbase.g:12466:1: ( ')' )
            // InternalPureXbase.g:12467:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getRightParenthesisKeyword_3_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getRightParenthesisKeyword_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__2__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__0"
    // InternalPureXbase.g:12477:1: rule__XFeatureCall__Group_3_1_1__0 : rule__XFeatureCall__Group_3_1_1__0__Impl rule__XFeatureCall__Group_3_1_1__1 ;
    public final void rule__XFeatureCall__Group_3_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12481:1: ( rule__XFeatureCall__Group_3_1_1__0__Impl rule__XFeatureCall__Group_3_1_1__1 )
            // InternalPureXbase.g:12482:2: rule__XFeatureCall__Group_3_1_1__0__Impl rule__XFeatureCall__Group_3_1_1__1
            {
            pushFollow(FOLLOW_54);
            rule__XFeatureCall__Group_3_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__0"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__0__Impl"
    // InternalPureXbase.g:12489:1: rule__XFeatureCall__Group_3_1_1__0__Impl : ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) ) ;
    public final void rule__XFeatureCall__Group_3_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12493:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) ) )
            // InternalPureXbase.g:12494:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) )
            {
            // InternalPureXbase.g:12494:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) )
            // InternalPureXbase.g:12495:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_0()); 
            }
            // InternalPureXbase.g:12496:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 )
            // InternalPureXbase.g:12496:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__1"
    // InternalPureXbase.g:12504:1: rule__XFeatureCall__Group_3_1_1__1 : rule__XFeatureCall__Group_3_1_1__1__Impl ;
    public final void rule__XFeatureCall__Group_3_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12508:1: ( rule__XFeatureCall__Group_3_1_1__1__Impl )
            // InternalPureXbase.g:12509:2: rule__XFeatureCall__Group_3_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__1"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__1__Impl"
    // InternalPureXbase.g:12515:1: rule__XFeatureCall__Group_3_1_1__1__Impl : ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* ) ;
    public final void rule__XFeatureCall__Group_3_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12519:1: ( ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* ) )
            // InternalPureXbase.g:12520:1: ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* )
            {
            // InternalPureXbase.g:12520:1: ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* )
            // InternalPureXbase.g:12521:2: ( rule__XFeatureCall__Group_3_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1_1()); 
            }
            // InternalPureXbase.g:12522:2: ( rule__XFeatureCall__Group_3_1_1_1__0 )*
            loop106:
            do {
                int alt106=2;
                int LA106_0 = input.LA(1);

                if ( (LA106_0==55) ) {
                    alt106=1;
                }


                switch (alt106) {
            	case 1 :
            	    // InternalPureXbase.g:12522:3: rule__XFeatureCall__Group_3_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XFeatureCall__Group_3_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop106;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__0"
    // InternalPureXbase.g:12531:1: rule__XFeatureCall__Group_3_1_1_1__0 : rule__XFeatureCall__Group_3_1_1_1__0__Impl rule__XFeatureCall__Group_3_1_1_1__1 ;
    public final void rule__XFeatureCall__Group_3_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12535:1: ( rule__XFeatureCall__Group_3_1_1_1__0__Impl rule__XFeatureCall__Group_3_1_1_1__1 )
            // InternalPureXbase.g:12536:2: rule__XFeatureCall__Group_3_1_1_1__0__Impl rule__XFeatureCall__Group_3_1_1_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XFeatureCall__Group_3_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__0"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__0__Impl"
    // InternalPureXbase.g:12543:1: rule__XFeatureCall__Group_3_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XFeatureCall__Group_3_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12547:1: ( ( ',' ) )
            // InternalPureXbase.g:12548:1: ( ',' )
            {
            // InternalPureXbase.g:12548:1: ( ',' )
            // InternalPureXbase.g:12549:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getCommaKeyword_3_1_1_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getCommaKeyword_3_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__1"
    // InternalPureXbase.g:12558:1: rule__XFeatureCall__Group_3_1_1_1__1 : rule__XFeatureCall__Group_3_1_1_1__1__Impl ;
    public final void rule__XFeatureCall__Group_3_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12562:1: ( rule__XFeatureCall__Group_3_1_1_1__1__Impl )
            // InternalPureXbase.g:12563:2: rule__XFeatureCall__Group_3_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__1"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__1__Impl"
    // InternalPureXbase.g:12569:1: rule__XFeatureCall__Group_3_1_1_1__1__Impl : ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) ) ;
    public final void rule__XFeatureCall__Group_3_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12573:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) ) )
            // InternalPureXbase.g:12574:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) )
            {
            // InternalPureXbase.g:12574:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) )
            // InternalPureXbase.g:12575:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_1_1()); 
            }
            // InternalPureXbase.g:12576:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 )
            // InternalPureXbase.g:12576:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__0"
    // InternalPureXbase.g:12585:1: rule__XConstructorCall__Group__0 : rule__XConstructorCall__Group__0__Impl rule__XConstructorCall__Group__1 ;
    public final void rule__XConstructorCall__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12589:1: ( rule__XConstructorCall__Group__0__Impl rule__XConstructorCall__Group__1 )
            // InternalPureXbase.g:12590:2: rule__XConstructorCall__Group__0__Impl rule__XConstructorCall__Group__1
            {
            pushFollow(FOLLOW_77);
            rule__XConstructorCall__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__0"


    // $ANTLR start "rule__XConstructorCall__Group__0__Impl"
    // InternalPureXbase.g:12597:1: rule__XConstructorCall__Group__0__Impl : ( () ) ;
    public final void rule__XConstructorCall__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12601:1: ( ( () ) )
            // InternalPureXbase.g:12602:1: ( () )
            {
            // InternalPureXbase.g:12602:1: ( () )
            // InternalPureXbase.g:12603:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getXConstructorCallAction_0()); 
            }
            // InternalPureXbase.g:12604:2: ()
            // InternalPureXbase.g:12604:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getXConstructorCallAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__1"
    // InternalPureXbase.g:12612:1: rule__XConstructorCall__Group__1 : rule__XConstructorCall__Group__1__Impl rule__XConstructorCall__Group__2 ;
    public final void rule__XConstructorCall__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12616:1: ( rule__XConstructorCall__Group__1__Impl rule__XConstructorCall__Group__2 )
            // InternalPureXbase.g:12617:2: rule__XConstructorCall__Group__1__Impl rule__XConstructorCall__Group__2
            {
            pushFollow(FOLLOW_17);
            rule__XConstructorCall__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__1"


    // $ANTLR start "rule__XConstructorCall__Group__1__Impl"
    // InternalPureXbase.g:12624:1: rule__XConstructorCall__Group__1__Impl : ( 'new' ) ;
    public final void rule__XConstructorCall__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12628:1: ( ( 'new' ) )
            // InternalPureXbase.g:12629:1: ( 'new' )
            {
            // InternalPureXbase.g:12629:1: ( 'new' )
            // InternalPureXbase.g:12630:2: 'new'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getNewKeyword_1()); 
            }
            match(input,69,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getNewKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__2"
    // InternalPureXbase.g:12639:1: rule__XConstructorCall__Group__2 : rule__XConstructorCall__Group__2__Impl rule__XConstructorCall__Group__3 ;
    public final void rule__XConstructorCall__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12643:1: ( rule__XConstructorCall__Group__2__Impl rule__XConstructorCall__Group__3 )
            // InternalPureXbase.g:12644:2: rule__XConstructorCall__Group__2__Impl rule__XConstructorCall__Group__3
            {
            pushFollow(FOLLOW_78);
            rule__XConstructorCall__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__2"


    // $ANTLR start "rule__XConstructorCall__Group__2__Impl"
    // InternalPureXbase.g:12651:1: rule__XConstructorCall__Group__2__Impl : ( ( rule__XConstructorCall__ConstructorAssignment_2 ) ) ;
    public final void rule__XConstructorCall__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12655:1: ( ( ( rule__XConstructorCall__ConstructorAssignment_2 ) ) )
            // InternalPureXbase.g:12656:1: ( ( rule__XConstructorCall__ConstructorAssignment_2 ) )
            {
            // InternalPureXbase.g:12656:1: ( ( rule__XConstructorCall__ConstructorAssignment_2 ) )
            // InternalPureXbase.g:12657:2: ( rule__XConstructorCall__ConstructorAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getConstructorAssignment_2()); 
            }
            // InternalPureXbase.g:12658:2: ( rule__XConstructorCall__ConstructorAssignment_2 )
            // InternalPureXbase.g:12658:3: rule__XConstructorCall__ConstructorAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ConstructorAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getConstructorAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__2__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__3"
    // InternalPureXbase.g:12666:1: rule__XConstructorCall__Group__3 : rule__XConstructorCall__Group__3__Impl rule__XConstructorCall__Group__4 ;
    public final void rule__XConstructorCall__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12670:1: ( rule__XConstructorCall__Group__3__Impl rule__XConstructorCall__Group__4 )
            // InternalPureXbase.g:12671:2: rule__XConstructorCall__Group__3__Impl rule__XConstructorCall__Group__4
            {
            pushFollow(FOLLOW_78);
            rule__XConstructorCall__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__3"


    // $ANTLR start "rule__XConstructorCall__Group__3__Impl"
    // InternalPureXbase.g:12678:1: rule__XConstructorCall__Group__3__Impl : ( ( rule__XConstructorCall__Group_3__0 )? ) ;
    public final void rule__XConstructorCall__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12682:1: ( ( ( rule__XConstructorCall__Group_3__0 )? ) )
            // InternalPureXbase.g:12683:1: ( ( rule__XConstructorCall__Group_3__0 )? )
            {
            // InternalPureXbase.g:12683:1: ( ( rule__XConstructorCall__Group_3__0 )? )
            // InternalPureXbase.g:12684:2: ( rule__XConstructorCall__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_3()); 
            }
            // InternalPureXbase.g:12685:2: ( rule__XConstructorCall__Group_3__0 )?
            int alt107=2;
            alt107 = dfa107.predict(input);
            switch (alt107) {
                case 1 :
                    // InternalPureXbase.g:12685:3: rule__XConstructorCall__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__3__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__4"
    // InternalPureXbase.g:12693:1: rule__XConstructorCall__Group__4 : rule__XConstructorCall__Group__4__Impl rule__XConstructorCall__Group__5 ;
    public final void rule__XConstructorCall__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12697:1: ( rule__XConstructorCall__Group__4__Impl rule__XConstructorCall__Group__5 )
            // InternalPureXbase.g:12698:2: rule__XConstructorCall__Group__4__Impl rule__XConstructorCall__Group__5
            {
            pushFollow(FOLLOW_78);
            rule__XConstructorCall__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__4"


    // $ANTLR start "rule__XConstructorCall__Group__4__Impl"
    // InternalPureXbase.g:12705:1: rule__XConstructorCall__Group__4__Impl : ( ( rule__XConstructorCall__Group_4__0 )? ) ;
    public final void rule__XConstructorCall__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12709:1: ( ( ( rule__XConstructorCall__Group_4__0 )? ) )
            // InternalPureXbase.g:12710:1: ( ( rule__XConstructorCall__Group_4__0 )? )
            {
            // InternalPureXbase.g:12710:1: ( ( rule__XConstructorCall__Group_4__0 )? )
            // InternalPureXbase.g:12711:2: ( rule__XConstructorCall__Group_4__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_4()); 
            }
            // InternalPureXbase.g:12712:2: ( rule__XConstructorCall__Group_4__0 )?
            int alt108=2;
            alt108 = dfa108.predict(input);
            switch (alt108) {
                case 1 :
                    // InternalPureXbase.g:12712:3: rule__XConstructorCall__Group_4__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Group_4__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__4__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__5"
    // InternalPureXbase.g:12720:1: rule__XConstructorCall__Group__5 : rule__XConstructorCall__Group__5__Impl ;
    public final void rule__XConstructorCall__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12724:1: ( rule__XConstructorCall__Group__5__Impl )
            // InternalPureXbase.g:12725:2: rule__XConstructorCall__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__5"


    // $ANTLR start "rule__XConstructorCall__Group__5__Impl"
    // InternalPureXbase.g:12731:1: rule__XConstructorCall__Group__5__Impl : ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? ) ;
    public final void rule__XConstructorCall__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12735:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? ) )
            // InternalPureXbase.g:12736:1: ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? )
            {
            // InternalPureXbase.g:12736:1: ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? )
            // InternalPureXbase.g:12737:2: ( rule__XConstructorCall__ArgumentsAssignment_5 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_5()); 
            }
            // InternalPureXbase.g:12738:2: ( rule__XConstructorCall__ArgumentsAssignment_5 )?
            int alt109=2;
            alt109 = dfa109.predict(input);
            switch (alt109) {
                case 1 :
                    // InternalPureXbase.g:12738:3: rule__XConstructorCall__ArgumentsAssignment_5
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__ArgumentsAssignment_5();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__5__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__0"
    // InternalPureXbase.g:12747:1: rule__XConstructorCall__Group_3__0 : rule__XConstructorCall__Group_3__0__Impl rule__XConstructorCall__Group_3__1 ;
    public final void rule__XConstructorCall__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12751:1: ( rule__XConstructorCall__Group_3__0__Impl rule__XConstructorCall__Group_3__1 )
            // InternalPureXbase.g:12752:2: rule__XConstructorCall__Group_3__0__Impl rule__XConstructorCall__Group_3__1
            {
            pushFollow(FOLLOW_50);
            rule__XConstructorCall__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__0"


    // $ANTLR start "rule__XConstructorCall__Group_3__0__Impl"
    // InternalPureXbase.g:12759:1: rule__XConstructorCall__Group_3__0__Impl : ( ( '<' ) ) ;
    public final void rule__XConstructorCall__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12763:1: ( ( ( '<' ) ) )
            // InternalPureXbase.g:12764:1: ( ( '<' ) )
            {
            // InternalPureXbase.g:12764:1: ( ( '<' ) )
            // InternalPureXbase.g:12765:2: ( '<' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getLessThanSignKeyword_3_0()); 
            }
            // InternalPureXbase.g:12766:2: ( '<' )
            // InternalPureXbase.g:12766:3: '<'
            {
            match(input,28,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getLessThanSignKeyword_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__1"
    // InternalPureXbase.g:12774:1: rule__XConstructorCall__Group_3__1 : rule__XConstructorCall__Group_3__1__Impl rule__XConstructorCall__Group_3__2 ;
    public final void rule__XConstructorCall__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12778:1: ( rule__XConstructorCall__Group_3__1__Impl rule__XConstructorCall__Group_3__2 )
            // InternalPureXbase.g:12779:2: rule__XConstructorCall__Group_3__1__Impl rule__XConstructorCall__Group_3__2
            {
            pushFollow(FOLLOW_51);
            rule__XConstructorCall__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__1"


    // $ANTLR start "rule__XConstructorCall__Group_3__1__Impl"
    // InternalPureXbase.g:12786:1: rule__XConstructorCall__Group_3__1__Impl : ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) ) ;
    public final void rule__XConstructorCall__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12790:1: ( ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) ) )
            // InternalPureXbase.g:12791:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) )
            {
            // InternalPureXbase.g:12791:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) )
            // InternalPureXbase.g:12792:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_1()); 
            }
            // InternalPureXbase.g:12793:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 )
            // InternalPureXbase.g:12793:3: rule__XConstructorCall__TypeArgumentsAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__TypeArgumentsAssignment_3_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__2"
    // InternalPureXbase.g:12801:1: rule__XConstructorCall__Group_3__2 : rule__XConstructorCall__Group_3__2__Impl rule__XConstructorCall__Group_3__3 ;
    public final void rule__XConstructorCall__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12805:1: ( rule__XConstructorCall__Group_3__2__Impl rule__XConstructorCall__Group_3__3 )
            // InternalPureXbase.g:12806:2: rule__XConstructorCall__Group_3__2__Impl rule__XConstructorCall__Group_3__3
            {
            pushFollow(FOLLOW_51);
            rule__XConstructorCall__Group_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__2"


    // $ANTLR start "rule__XConstructorCall__Group_3__2__Impl"
    // InternalPureXbase.g:12813:1: rule__XConstructorCall__Group_3__2__Impl : ( ( rule__XConstructorCall__Group_3_2__0 )* ) ;
    public final void rule__XConstructorCall__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12817:1: ( ( ( rule__XConstructorCall__Group_3_2__0 )* ) )
            // InternalPureXbase.g:12818:1: ( ( rule__XConstructorCall__Group_3_2__0 )* )
            {
            // InternalPureXbase.g:12818:1: ( ( rule__XConstructorCall__Group_3_2__0 )* )
            // InternalPureXbase.g:12819:2: ( rule__XConstructorCall__Group_3_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_3_2()); 
            }
            // InternalPureXbase.g:12820:2: ( rule__XConstructorCall__Group_3_2__0 )*
            loop110:
            do {
                int alt110=2;
                int LA110_0 = input.LA(1);

                if ( (LA110_0==55) ) {
                    alt110=1;
                }


                switch (alt110) {
            	case 1 :
            	    // InternalPureXbase.g:12820:3: rule__XConstructorCall__Group_3_2__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XConstructorCall__Group_3_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop110;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__2__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__3"
    // InternalPureXbase.g:12828:1: rule__XConstructorCall__Group_3__3 : rule__XConstructorCall__Group_3__3__Impl ;
    public final void rule__XConstructorCall__Group_3__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12832:1: ( rule__XConstructorCall__Group_3__3__Impl )
            // InternalPureXbase.g:12833:2: rule__XConstructorCall__Group_3__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__3"


    // $ANTLR start "rule__XConstructorCall__Group_3__3__Impl"
    // InternalPureXbase.g:12839:1: rule__XConstructorCall__Group_3__3__Impl : ( '>' ) ;
    public final void rule__XConstructorCall__Group_3__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12843:1: ( ( '>' ) )
            // InternalPureXbase.g:12844:1: ( '>' )
            {
            // InternalPureXbase.g:12844:1: ( '>' )
            // InternalPureXbase.g:12845:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGreaterThanSignKeyword_3_3()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGreaterThanSignKeyword_3_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__3__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__0"
    // InternalPureXbase.g:12855:1: rule__XConstructorCall__Group_3_2__0 : rule__XConstructorCall__Group_3_2__0__Impl rule__XConstructorCall__Group_3_2__1 ;
    public final void rule__XConstructorCall__Group_3_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12859:1: ( rule__XConstructorCall__Group_3_2__0__Impl rule__XConstructorCall__Group_3_2__1 )
            // InternalPureXbase.g:12860:2: rule__XConstructorCall__Group_3_2__0__Impl rule__XConstructorCall__Group_3_2__1
            {
            pushFollow(FOLLOW_50);
            rule__XConstructorCall__Group_3_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__0"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__0__Impl"
    // InternalPureXbase.g:12867:1: rule__XConstructorCall__Group_3_2__0__Impl : ( ',' ) ;
    public final void rule__XConstructorCall__Group_3_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12871:1: ( ( ',' ) )
            // InternalPureXbase.g:12872:1: ( ',' )
            {
            // InternalPureXbase.g:12872:1: ( ',' )
            // InternalPureXbase.g:12873:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getCommaKeyword_3_2_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getCommaKeyword_3_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__1"
    // InternalPureXbase.g:12882:1: rule__XConstructorCall__Group_3_2__1 : rule__XConstructorCall__Group_3_2__1__Impl ;
    public final void rule__XConstructorCall__Group_3_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12886:1: ( rule__XConstructorCall__Group_3_2__1__Impl )
            // InternalPureXbase.g:12887:2: rule__XConstructorCall__Group_3_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__1"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__1__Impl"
    // InternalPureXbase.g:12893:1: rule__XConstructorCall__Group_3_2__1__Impl : ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) ) ;
    public final void rule__XConstructorCall__Group_3_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12897:1: ( ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) ) )
            // InternalPureXbase.g:12898:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) )
            {
            // InternalPureXbase.g:12898:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) )
            // InternalPureXbase.g:12899:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_2_1()); 
            }
            // InternalPureXbase.g:12900:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 )
            // InternalPureXbase.g:12900:3: rule__XConstructorCall__TypeArgumentsAssignment_3_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__TypeArgumentsAssignment_3_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4__0"
    // InternalPureXbase.g:12909:1: rule__XConstructorCall__Group_4__0 : rule__XConstructorCall__Group_4__0__Impl rule__XConstructorCall__Group_4__1 ;
    public final void rule__XConstructorCall__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12913:1: ( rule__XConstructorCall__Group_4__0__Impl rule__XConstructorCall__Group_4__1 )
            // InternalPureXbase.g:12914:2: rule__XConstructorCall__Group_4__0__Impl rule__XConstructorCall__Group_4__1
            {
            pushFollow(FOLLOW_53);
            rule__XConstructorCall__Group_4__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__0"


    // $ANTLR start "rule__XConstructorCall__Group_4__0__Impl"
    // InternalPureXbase.g:12921:1: rule__XConstructorCall__Group_4__0__Impl : ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) ) ;
    public final void rule__XConstructorCall__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12925:1: ( ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) ) )
            // InternalPureXbase.g:12926:1: ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) )
            {
            // InternalPureXbase.g:12926:1: ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) )
            // InternalPureXbase.g:12927:2: ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallAssignment_4_0()); 
            }
            // InternalPureXbase.g:12928:2: ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 )
            // InternalPureXbase.g:12928:3: rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallAssignment_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4__1"
    // InternalPureXbase.g:12936:1: rule__XConstructorCall__Group_4__1 : rule__XConstructorCall__Group_4__1__Impl rule__XConstructorCall__Group_4__2 ;
    public final void rule__XConstructorCall__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12940:1: ( rule__XConstructorCall__Group_4__1__Impl rule__XConstructorCall__Group_4__2 )
            // InternalPureXbase.g:12941:2: rule__XConstructorCall__Group_4__1__Impl rule__XConstructorCall__Group_4__2
            {
            pushFollow(FOLLOW_53);
            rule__XConstructorCall__Group_4__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__1"


    // $ANTLR start "rule__XConstructorCall__Group_4__1__Impl"
    // InternalPureXbase.g:12948:1: rule__XConstructorCall__Group_4__1__Impl : ( ( rule__XConstructorCall__Alternatives_4_1 )? ) ;
    public final void rule__XConstructorCall__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12952:1: ( ( ( rule__XConstructorCall__Alternatives_4_1 )? ) )
            // InternalPureXbase.g:12953:1: ( ( rule__XConstructorCall__Alternatives_4_1 )? )
            {
            // InternalPureXbase.g:12953:1: ( ( rule__XConstructorCall__Alternatives_4_1 )? )
            // InternalPureXbase.g:12954:2: ( rule__XConstructorCall__Alternatives_4_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getAlternatives_4_1()); 
            }
            // InternalPureXbase.g:12955:2: ( rule__XConstructorCall__Alternatives_4_1 )?
            int alt111=2;
            int LA111_0 = input.LA(1);

            if ( ((LA111_0>=RULE_ID && LA111_0<=RULE_STRING)||LA111_0==28||LA111_0==32||(LA111_0>=35 && LA111_0<=36)||LA111_0==41||(LA111_0>=45 && LA111_0<=46)||(LA111_0>=48 && LA111_0<=49)||(LA111_0>=56 && LA111_0<=57)||LA111_0==59||LA111_0==61||LA111_0==63||(LA111_0>=66 && LA111_0<=74)||(LA111_0>=83 && LA111_0<=84)) ) {
                alt111=1;
            }
            switch (alt111) {
                case 1 :
                    // InternalPureXbase.g:12955:3: rule__XConstructorCall__Alternatives_4_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Alternatives_4_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getAlternatives_4_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4__2"
    // InternalPureXbase.g:12963:1: rule__XConstructorCall__Group_4__2 : rule__XConstructorCall__Group_4__2__Impl ;
    public final void rule__XConstructorCall__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12967:1: ( rule__XConstructorCall__Group_4__2__Impl )
            // InternalPureXbase.g:12968:2: rule__XConstructorCall__Group_4__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__2"


    // $ANTLR start "rule__XConstructorCall__Group_4__2__Impl"
    // InternalPureXbase.g:12974:1: rule__XConstructorCall__Group_4__2__Impl : ( ')' ) ;
    public final void rule__XConstructorCall__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12978:1: ( ( ')' ) )
            // InternalPureXbase.g:12979:1: ( ')' )
            {
            // InternalPureXbase.g:12979:1: ( ')' )
            // InternalPureXbase.g:12980:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getRightParenthesisKeyword_4_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getRightParenthesisKeyword_4_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__2__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__0"
    // InternalPureXbase.g:12990:1: rule__XConstructorCall__Group_4_1_1__0 : rule__XConstructorCall__Group_4_1_1__0__Impl rule__XConstructorCall__Group_4_1_1__1 ;
    public final void rule__XConstructorCall__Group_4_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:12994:1: ( rule__XConstructorCall__Group_4_1_1__0__Impl rule__XConstructorCall__Group_4_1_1__1 )
            // InternalPureXbase.g:12995:2: rule__XConstructorCall__Group_4_1_1__0__Impl rule__XConstructorCall__Group_4_1_1__1
            {
            pushFollow(FOLLOW_54);
            rule__XConstructorCall__Group_4_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__0"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__0__Impl"
    // InternalPureXbase.g:13002:1: rule__XConstructorCall__Group_4_1_1__0__Impl : ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) ) ;
    public final void rule__XConstructorCall__Group_4_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13006:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) ) )
            // InternalPureXbase.g:13007:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) )
            {
            // InternalPureXbase.g:13007:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) )
            // InternalPureXbase.g:13008:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_0()); 
            }
            // InternalPureXbase.g:13009:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 )
            // InternalPureXbase.g:13009:3: rule__XConstructorCall__ArgumentsAssignment_4_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ArgumentsAssignment_4_1_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__1"
    // InternalPureXbase.g:13017:1: rule__XConstructorCall__Group_4_1_1__1 : rule__XConstructorCall__Group_4_1_1__1__Impl ;
    public final void rule__XConstructorCall__Group_4_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13021:1: ( rule__XConstructorCall__Group_4_1_1__1__Impl )
            // InternalPureXbase.g:13022:2: rule__XConstructorCall__Group_4_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__1"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__1__Impl"
    // InternalPureXbase.g:13028:1: rule__XConstructorCall__Group_4_1_1__1__Impl : ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* ) ;
    public final void rule__XConstructorCall__Group_4_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13032:1: ( ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* ) )
            // InternalPureXbase.g:13033:1: ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* )
            {
            // InternalPureXbase.g:13033:1: ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* )
            // InternalPureXbase.g:13034:2: ( rule__XConstructorCall__Group_4_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1_1()); 
            }
            // InternalPureXbase.g:13035:2: ( rule__XConstructorCall__Group_4_1_1_1__0 )*
            loop112:
            do {
                int alt112=2;
                int LA112_0 = input.LA(1);

                if ( (LA112_0==55) ) {
                    alt112=1;
                }


                switch (alt112) {
            	case 1 :
            	    // InternalPureXbase.g:13035:3: rule__XConstructorCall__Group_4_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XConstructorCall__Group_4_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop112;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__0"
    // InternalPureXbase.g:13044:1: rule__XConstructorCall__Group_4_1_1_1__0 : rule__XConstructorCall__Group_4_1_1_1__0__Impl rule__XConstructorCall__Group_4_1_1_1__1 ;
    public final void rule__XConstructorCall__Group_4_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13048:1: ( rule__XConstructorCall__Group_4_1_1_1__0__Impl rule__XConstructorCall__Group_4_1_1_1__1 )
            // InternalPureXbase.g:13049:2: rule__XConstructorCall__Group_4_1_1_1__0__Impl rule__XConstructorCall__Group_4_1_1_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XConstructorCall__Group_4_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__0"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__0__Impl"
    // InternalPureXbase.g:13056:1: rule__XConstructorCall__Group_4_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XConstructorCall__Group_4_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13060:1: ( ( ',' ) )
            // InternalPureXbase.g:13061:1: ( ',' )
            {
            // InternalPureXbase.g:13061:1: ( ',' )
            // InternalPureXbase.g:13062:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getCommaKeyword_4_1_1_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getCommaKeyword_4_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__1"
    // InternalPureXbase.g:13071:1: rule__XConstructorCall__Group_4_1_1_1__1 : rule__XConstructorCall__Group_4_1_1_1__1__Impl ;
    public final void rule__XConstructorCall__Group_4_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13075:1: ( rule__XConstructorCall__Group_4_1_1_1__1__Impl )
            // InternalPureXbase.g:13076:2: rule__XConstructorCall__Group_4_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__1"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__1__Impl"
    // InternalPureXbase.g:13082:1: rule__XConstructorCall__Group_4_1_1_1__1__Impl : ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) ) ;
    public final void rule__XConstructorCall__Group_4_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13086:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) ) )
            // InternalPureXbase.g:13087:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) )
            {
            // InternalPureXbase.g:13087:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) )
            // InternalPureXbase.g:13088:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_1_1()); 
            }
            // InternalPureXbase.g:13089:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 )
            // InternalPureXbase.g:13089:3: rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__1__Impl"


    // $ANTLR start "rule__XBooleanLiteral__Group__0"
    // InternalPureXbase.g:13098:1: rule__XBooleanLiteral__Group__0 : rule__XBooleanLiteral__Group__0__Impl rule__XBooleanLiteral__Group__1 ;
    public final void rule__XBooleanLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13102:1: ( rule__XBooleanLiteral__Group__0__Impl rule__XBooleanLiteral__Group__1 )
            // InternalPureXbase.g:13103:2: rule__XBooleanLiteral__Group__0__Impl rule__XBooleanLiteral__Group__1
            {
            pushFollow(FOLLOW_79);
            rule__XBooleanLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__0"


    // $ANTLR start "rule__XBooleanLiteral__Group__0__Impl"
    // InternalPureXbase.g:13110:1: rule__XBooleanLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XBooleanLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13114:1: ( ( () ) )
            // InternalPureXbase.g:13115:1: ( () )
            {
            // InternalPureXbase.g:13115:1: ( () )
            // InternalPureXbase.g:13116:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getXBooleanLiteralAction_0()); 
            }
            // InternalPureXbase.g:13117:2: ()
            // InternalPureXbase.g:13117:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getXBooleanLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__0__Impl"


    // $ANTLR start "rule__XBooleanLiteral__Group__1"
    // InternalPureXbase.g:13125:1: rule__XBooleanLiteral__Group__1 : rule__XBooleanLiteral__Group__1__Impl ;
    public final void rule__XBooleanLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13129:1: ( rule__XBooleanLiteral__Group__1__Impl )
            // InternalPureXbase.g:13130:2: rule__XBooleanLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__1"


    // $ANTLR start "rule__XBooleanLiteral__Group__1__Impl"
    // InternalPureXbase.g:13136:1: rule__XBooleanLiteral__Group__1__Impl : ( ( rule__XBooleanLiteral__Alternatives_1 ) ) ;
    public final void rule__XBooleanLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13140:1: ( ( ( rule__XBooleanLiteral__Alternatives_1 ) ) )
            // InternalPureXbase.g:13141:1: ( ( rule__XBooleanLiteral__Alternatives_1 ) )
            {
            // InternalPureXbase.g:13141:1: ( ( rule__XBooleanLiteral__Alternatives_1 ) )
            // InternalPureXbase.g:13142:2: ( rule__XBooleanLiteral__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getAlternatives_1()); 
            }
            // InternalPureXbase.g:13143:2: ( rule__XBooleanLiteral__Alternatives_1 )
            // InternalPureXbase.g:13143:3: rule__XBooleanLiteral__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__1__Impl"


    // $ANTLR start "rule__XNullLiteral__Group__0"
    // InternalPureXbase.g:13152:1: rule__XNullLiteral__Group__0 : rule__XNullLiteral__Group__0__Impl rule__XNullLiteral__Group__1 ;
    public final void rule__XNullLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13156:1: ( rule__XNullLiteral__Group__0__Impl rule__XNullLiteral__Group__1 )
            // InternalPureXbase.g:13157:2: rule__XNullLiteral__Group__0__Impl rule__XNullLiteral__Group__1
            {
            pushFollow(FOLLOW_80);
            rule__XNullLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XNullLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__0"


    // $ANTLR start "rule__XNullLiteral__Group__0__Impl"
    // InternalPureXbase.g:13164:1: rule__XNullLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XNullLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13168:1: ( ( () ) )
            // InternalPureXbase.g:13169:1: ( () )
            {
            // InternalPureXbase.g:13169:1: ( () )
            // InternalPureXbase.g:13170:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralAccess().getXNullLiteralAction_0()); 
            }
            // InternalPureXbase.g:13171:2: ()
            // InternalPureXbase.g:13171:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralAccess().getXNullLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__0__Impl"


    // $ANTLR start "rule__XNullLiteral__Group__1"
    // InternalPureXbase.g:13179:1: rule__XNullLiteral__Group__1 : rule__XNullLiteral__Group__1__Impl ;
    public final void rule__XNullLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13183:1: ( rule__XNullLiteral__Group__1__Impl )
            // InternalPureXbase.g:13184:2: rule__XNullLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XNullLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__1"


    // $ANTLR start "rule__XNullLiteral__Group__1__Impl"
    // InternalPureXbase.g:13190:1: rule__XNullLiteral__Group__1__Impl : ( 'null' ) ;
    public final void rule__XNullLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13194:1: ( ( 'null' ) )
            // InternalPureXbase.g:13195:1: ( 'null' )
            {
            // InternalPureXbase.g:13195:1: ( 'null' )
            // InternalPureXbase.g:13196:2: 'null'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralAccess().getNullKeyword_1()); 
            }
            match(input,70,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralAccess().getNullKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__1__Impl"


    // $ANTLR start "rule__XNumberLiteral__Group__0"
    // InternalPureXbase.g:13206:1: rule__XNumberLiteral__Group__0 : rule__XNumberLiteral__Group__0__Impl rule__XNumberLiteral__Group__1 ;
    public final void rule__XNumberLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13210:1: ( rule__XNumberLiteral__Group__0__Impl rule__XNumberLiteral__Group__1 )
            // InternalPureXbase.g:13211:2: rule__XNumberLiteral__Group__0__Impl rule__XNumberLiteral__Group__1
            {
            pushFollow(FOLLOW_81);
            rule__XNumberLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__0"


    // $ANTLR start "rule__XNumberLiteral__Group__0__Impl"
    // InternalPureXbase.g:13218:1: rule__XNumberLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XNumberLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13222:1: ( ( () ) )
            // InternalPureXbase.g:13223:1: ( () )
            {
            // InternalPureXbase.g:13223:1: ( () )
            // InternalPureXbase.g:13224:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getXNumberLiteralAction_0()); 
            }
            // InternalPureXbase.g:13225:2: ()
            // InternalPureXbase.g:13225:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getXNumberLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__0__Impl"


    // $ANTLR start "rule__XNumberLiteral__Group__1"
    // InternalPureXbase.g:13233:1: rule__XNumberLiteral__Group__1 : rule__XNumberLiteral__Group__1__Impl ;
    public final void rule__XNumberLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13237:1: ( rule__XNumberLiteral__Group__1__Impl )
            // InternalPureXbase.g:13238:2: rule__XNumberLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__1"


    // $ANTLR start "rule__XNumberLiteral__Group__1__Impl"
    // InternalPureXbase.g:13244:1: rule__XNumberLiteral__Group__1__Impl : ( ( rule__XNumberLiteral__ValueAssignment_1 ) ) ;
    public final void rule__XNumberLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13248:1: ( ( ( rule__XNumberLiteral__ValueAssignment_1 ) ) )
            // InternalPureXbase.g:13249:1: ( ( rule__XNumberLiteral__ValueAssignment_1 ) )
            {
            // InternalPureXbase.g:13249:1: ( ( rule__XNumberLiteral__ValueAssignment_1 ) )
            // InternalPureXbase.g:13250:2: ( rule__XNumberLiteral__ValueAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getValueAssignment_1()); 
            }
            // InternalPureXbase.g:13251:2: ( rule__XNumberLiteral__ValueAssignment_1 )
            // InternalPureXbase.g:13251:3: rule__XNumberLiteral__ValueAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__ValueAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getValueAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__1__Impl"


    // $ANTLR start "rule__XStringLiteral__Group__0"
    // InternalPureXbase.g:13260:1: rule__XStringLiteral__Group__0 : rule__XStringLiteral__Group__0__Impl rule__XStringLiteral__Group__1 ;
    public final void rule__XStringLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13264:1: ( rule__XStringLiteral__Group__0__Impl rule__XStringLiteral__Group__1 )
            // InternalPureXbase.g:13265:2: rule__XStringLiteral__Group__0__Impl rule__XStringLiteral__Group__1
            {
            pushFollow(FOLLOW_82);
            rule__XStringLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__0"


    // $ANTLR start "rule__XStringLiteral__Group__0__Impl"
    // InternalPureXbase.g:13272:1: rule__XStringLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XStringLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13276:1: ( ( () ) )
            // InternalPureXbase.g:13277:1: ( () )
            {
            // InternalPureXbase.g:13277:1: ( () )
            // InternalPureXbase.g:13278:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getXStringLiteralAction_0()); 
            }
            // InternalPureXbase.g:13279:2: ()
            // InternalPureXbase.g:13279:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getXStringLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__0__Impl"


    // $ANTLR start "rule__XStringLiteral__Group__1"
    // InternalPureXbase.g:13287:1: rule__XStringLiteral__Group__1 : rule__XStringLiteral__Group__1__Impl ;
    public final void rule__XStringLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13291:1: ( rule__XStringLiteral__Group__1__Impl )
            // InternalPureXbase.g:13292:2: rule__XStringLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__1"


    // $ANTLR start "rule__XStringLiteral__Group__1__Impl"
    // InternalPureXbase.g:13298:1: rule__XStringLiteral__Group__1__Impl : ( ( rule__XStringLiteral__ValueAssignment_1 ) ) ;
    public final void rule__XStringLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13302:1: ( ( ( rule__XStringLiteral__ValueAssignment_1 ) ) )
            // InternalPureXbase.g:13303:1: ( ( rule__XStringLiteral__ValueAssignment_1 ) )
            {
            // InternalPureXbase.g:13303:1: ( ( rule__XStringLiteral__ValueAssignment_1 ) )
            // InternalPureXbase.g:13304:2: ( rule__XStringLiteral__ValueAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getValueAssignment_1()); 
            }
            // InternalPureXbase.g:13305:2: ( rule__XStringLiteral__ValueAssignment_1 )
            // InternalPureXbase.g:13305:3: rule__XStringLiteral__ValueAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__ValueAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getValueAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__1__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__0"
    // InternalPureXbase.g:13314:1: rule__XTypeLiteral__Group__0 : rule__XTypeLiteral__Group__0__Impl rule__XTypeLiteral__Group__1 ;
    public final void rule__XTypeLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13318:1: ( rule__XTypeLiteral__Group__0__Impl rule__XTypeLiteral__Group__1 )
            // InternalPureXbase.g:13319:2: rule__XTypeLiteral__Group__0__Impl rule__XTypeLiteral__Group__1
            {
            pushFollow(FOLLOW_83);
            rule__XTypeLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__0"


    // $ANTLR start "rule__XTypeLiteral__Group__0__Impl"
    // InternalPureXbase.g:13326:1: rule__XTypeLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XTypeLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13330:1: ( ( () ) )
            // InternalPureXbase.g:13331:1: ( () )
            {
            // InternalPureXbase.g:13331:1: ( () )
            // InternalPureXbase.g:13332:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getXTypeLiteralAction_0()); 
            }
            // InternalPureXbase.g:13333:2: ()
            // InternalPureXbase.g:13333:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getXTypeLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__0__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__1"
    // InternalPureXbase.g:13341:1: rule__XTypeLiteral__Group__1 : rule__XTypeLiteral__Group__1__Impl rule__XTypeLiteral__Group__2 ;
    public final void rule__XTypeLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13345:1: ( rule__XTypeLiteral__Group__1__Impl rule__XTypeLiteral__Group__2 )
            // InternalPureXbase.g:13346:2: rule__XTypeLiteral__Group__1__Impl rule__XTypeLiteral__Group__2
            {
            pushFollow(FOLLOW_65);
            rule__XTypeLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__1"


    // $ANTLR start "rule__XTypeLiteral__Group__1__Impl"
    // InternalPureXbase.g:13353:1: rule__XTypeLiteral__Group__1__Impl : ( 'typeof' ) ;
    public final void rule__XTypeLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13357:1: ( ( 'typeof' ) )
            // InternalPureXbase.g:13358:1: ( 'typeof' )
            {
            // InternalPureXbase.g:13358:1: ( 'typeof' )
            // InternalPureXbase.g:13359:2: 'typeof'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeofKeyword_1()); 
            }
            match(input,71,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeofKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__1__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__2"
    // InternalPureXbase.g:13368:1: rule__XTypeLiteral__Group__2 : rule__XTypeLiteral__Group__2__Impl rule__XTypeLiteral__Group__3 ;
    public final void rule__XTypeLiteral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13372:1: ( rule__XTypeLiteral__Group__2__Impl rule__XTypeLiteral__Group__3 )
            // InternalPureXbase.g:13373:2: rule__XTypeLiteral__Group__2__Impl rule__XTypeLiteral__Group__3
            {
            pushFollow(FOLLOW_17);
            rule__XTypeLiteral__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__2"


    // $ANTLR start "rule__XTypeLiteral__Group__2__Impl"
    // InternalPureXbase.g:13380:1: rule__XTypeLiteral__Group__2__Impl : ( '(' ) ;
    public final void rule__XTypeLiteral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13384:1: ( ( '(' ) )
            // InternalPureXbase.g:13385:1: ( '(' )
            {
            // InternalPureXbase.g:13385:1: ( '(' )
            // InternalPureXbase.g:13386:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__2__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__3"
    // InternalPureXbase.g:13395:1: rule__XTypeLiteral__Group__3 : rule__XTypeLiteral__Group__3__Impl rule__XTypeLiteral__Group__4 ;
    public final void rule__XTypeLiteral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13399:1: ( rule__XTypeLiteral__Group__3__Impl rule__XTypeLiteral__Group__4 )
            // InternalPureXbase.g:13400:2: rule__XTypeLiteral__Group__3__Impl rule__XTypeLiteral__Group__4
            {
            pushFollow(FOLLOW_84);
            rule__XTypeLiteral__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__3"


    // $ANTLR start "rule__XTypeLiteral__Group__3__Impl"
    // InternalPureXbase.g:13407:1: rule__XTypeLiteral__Group__3__Impl : ( ( rule__XTypeLiteral__TypeAssignment_3 ) ) ;
    public final void rule__XTypeLiteral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13411:1: ( ( ( rule__XTypeLiteral__TypeAssignment_3 ) ) )
            // InternalPureXbase.g:13412:1: ( ( rule__XTypeLiteral__TypeAssignment_3 ) )
            {
            // InternalPureXbase.g:13412:1: ( ( rule__XTypeLiteral__TypeAssignment_3 ) )
            // InternalPureXbase.g:13413:2: ( rule__XTypeLiteral__TypeAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeAssignment_3()); 
            }
            // InternalPureXbase.g:13414:2: ( rule__XTypeLiteral__TypeAssignment_3 )
            // InternalPureXbase.g:13414:3: rule__XTypeLiteral__TypeAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__TypeAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__3__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__4"
    // InternalPureXbase.g:13422:1: rule__XTypeLiteral__Group__4 : rule__XTypeLiteral__Group__4__Impl rule__XTypeLiteral__Group__5 ;
    public final void rule__XTypeLiteral__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13426:1: ( rule__XTypeLiteral__Group__4__Impl rule__XTypeLiteral__Group__5 )
            // InternalPureXbase.g:13427:2: rule__XTypeLiteral__Group__4__Impl rule__XTypeLiteral__Group__5
            {
            pushFollow(FOLLOW_84);
            rule__XTypeLiteral__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__4"


    // $ANTLR start "rule__XTypeLiteral__Group__4__Impl"
    // InternalPureXbase.g:13434:1: rule__XTypeLiteral__Group__4__Impl : ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* ) ;
    public final void rule__XTypeLiteral__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13438:1: ( ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* ) )
            // InternalPureXbase.g:13439:1: ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* )
            {
            // InternalPureXbase.g:13439:1: ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* )
            // InternalPureXbase.g:13440:2: ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsAssignment_4()); 
            }
            // InternalPureXbase.g:13441:2: ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )*
            loop113:
            do {
                int alt113=2;
                int LA113_0 = input.LA(1);

                if ( (LA113_0==59) ) {
                    alt113=1;
                }


                switch (alt113) {
            	case 1 :
            	    // InternalPureXbase.g:13441:3: rule__XTypeLiteral__ArrayDimensionsAssignment_4
            	    {
            	    pushFollow(FOLLOW_85);
            	    rule__XTypeLiteral__ArrayDimensionsAssignment_4();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop113;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__4__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__5"
    // InternalPureXbase.g:13449:1: rule__XTypeLiteral__Group__5 : rule__XTypeLiteral__Group__5__Impl ;
    public final void rule__XTypeLiteral__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13453:1: ( rule__XTypeLiteral__Group__5__Impl )
            // InternalPureXbase.g:13454:2: rule__XTypeLiteral__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__5"


    // $ANTLR start "rule__XTypeLiteral__Group__5__Impl"
    // InternalPureXbase.g:13460:1: rule__XTypeLiteral__Group__5__Impl : ( ')' ) ;
    public final void rule__XTypeLiteral__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13464:1: ( ( ')' ) )
            // InternalPureXbase.g:13465:1: ( ')' )
            {
            // InternalPureXbase.g:13465:1: ( ')' )
            // InternalPureXbase.g:13466:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getRightParenthesisKeyword_5()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getRightParenthesisKeyword_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__5__Impl"


    // $ANTLR start "rule__XThrowExpression__Group__0"
    // InternalPureXbase.g:13476:1: rule__XThrowExpression__Group__0 : rule__XThrowExpression__Group__0__Impl rule__XThrowExpression__Group__1 ;
    public final void rule__XThrowExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13480:1: ( rule__XThrowExpression__Group__0__Impl rule__XThrowExpression__Group__1 )
            // InternalPureXbase.g:13481:2: rule__XThrowExpression__Group__0__Impl rule__XThrowExpression__Group__1
            {
            pushFollow(FOLLOW_86);
            rule__XThrowExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__0"


    // $ANTLR start "rule__XThrowExpression__Group__0__Impl"
    // InternalPureXbase.g:13488:1: rule__XThrowExpression__Group__0__Impl : ( () ) ;
    public final void rule__XThrowExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13492:1: ( ( () ) )
            // InternalPureXbase.g:13493:1: ( () )
            {
            // InternalPureXbase.g:13493:1: ( () )
            // InternalPureXbase.g:13494:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getXThrowExpressionAction_0()); 
            }
            // InternalPureXbase.g:13495:2: ()
            // InternalPureXbase.g:13495:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getXThrowExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__0__Impl"


    // $ANTLR start "rule__XThrowExpression__Group__1"
    // InternalPureXbase.g:13503:1: rule__XThrowExpression__Group__1 : rule__XThrowExpression__Group__1__Impl rule__XThrowExpression__Group__2 ;
    public final void rule__XThrowExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13507:1: ( rule__XThrowExpression__Group__1__Impl rule__XThrowExpression__Group__2 )
            // InternalPureXbase.g:13508:2: rule__XThrowExpression__Group__1__Impl rule__XThrowExpression__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__XThrowExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__1"


    // $ANTLR start "rule__XThrowExpression__Group__1__Impl"
    // InternalPureXbase.g:13515:1: rule__XThrowExpression__Group__1__Impl : ( 'throw' ) ;
    public final void rule__XThrowExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13519:1: ( ( 'throw' ) )
            // InternalPureXbase.g:13520:1: ( 'throw' )
            {
            // InternalPureXbase.g:13520:1: ( 'throw' )
            // InternalPureXbase.g:13521:2: 'throw'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getThrowKeyword_1()); 
            }
            match(input,72,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getThrowKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__1__Impl"


    // $ANTLR start "rule__XThrowExpression__Group__2"
    // InternalPureXbase.g:13530:1: rule__XThrowExpression__Group__2 : rule__XThrowExpression__Group__2__Impl ;
    public final void rule__XThrowExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13534:1: ( rule__XThrowExpression__Group__2__Impl )
            // InternalPureXbase.g:13535:2: rule__XThrowExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__2"


    // $ANTLR start "rule__XThrowExpression__Group__2__Impl"
    // InternalPureXbase.g:13541:1: rule__XThrowExpression__Group__2__Impl : ( ( rule__XThrowExpression__ExpressionAssignment_2 ) ) ;
    public final void rule__XThrowExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13545:1: ( ( ( rule__XThrowExpression__ExpressionAssignment_2 ) ) )
            // InternalPureXbase.g:13546:1: ( ( rule__XThrowExpression__ExpressionAssignment_2 ) )
            {
            // InternalPureXbase.g:13546:1: ( ( rule__XThrowExpression__ExpressionAssignment_2 ) )
            // InternalPureXbase.g:13547:2: ( rule__XThrowExpression__ExpressionAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getExpressionAssignment_2()); 
            }
            // InternalPureXbase.g:13548:2: ( rule__XThrowExpression__ExpressionAssignment_2 )
            // InternalPureXbase.g:13548:3: rule__XThrowExpression__ExpressionAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__ExpressionAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__2__Impl"


    // $ANTLR start "rule__XReturnExpression__Group__0"
    // InternalPureXbase.g:13557:1: rule__XReturnExpression__Group__0 : rule__XReturnExpression__Group__0__Impl rule__XReturnExpression__Group__1 ;
    public final void rule__XReturnExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13561:1: ( rule__XReturnExpression__Group__0__Impl rule__XReturnExpression__Group__1 )
            // InternalPureXbase.g:13562:2: rule__XReturnExpression__Group__0__Impl rule__XReturnExpression__Group__1
            {
            pushFollow(FOLLOW_87);
            rule__XReturnExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__0"


    // $ANTLR start "rule__XReturnExpression__Group__0__Impl"
    // InternalPureXbase.g:13569:1: rule__XReturnExpression__Group__0__Impl : ( () ) ;
    public final void rule__XReturnExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13573:1: ( ( () ) )
            // InternalPureXbase.g:13574:1: ( () )
            {
            // InternalPureXbase.g:13574:1: ( () )
            // InternalPureXbase.g:13575:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getXReturnExpressionAction_0()); 
            }
            // InternalPureXbase.g:13576:2: ()
            // InternalPureXbase.g:13576:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getXReturnExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__0__Impl"


    // $ANTLR start "rule__XReturnExpression__Group__1"
    // InternalPureXbase.g:13584:1: rule__XReturnExpression__Group__1 : rule__XReturnExpression__Group__1__Impl rule__XReturnExpression__Group__2 ;
    public final void rule__XReturnExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13588:1: ( rule__XReturnExpression__Group__1__Impl rule__XReturnExpression__Group__2 )
            // InternalPureXbase.g:13589:2: rule__XReturnExpression__Group__1__Impl rule__XReturnExpression__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__XReturnExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__1"


    // $ANTLR start "rule__XReturnExpression__Group__1__Impl"
    // InternalPureXbase.g:13596:1: rule__XReturnExpression__Group__1__Impl : ( 'return' ) ;
    public final void rule__XReturnExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13600:1: ( ( 'return' ) )
            // InternalPureXbase.g:13601:1: ( 'return' )
            {
            // InternalPureXbase.g:13601:1: ( 'return' )
            // InternalPureXbase.g:13602:2: 'return'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getReturnKeyword_1()); 
            }
            match(input,73,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getReturnKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__1__Impl"


    // $ANTLR start "rule__XReturnExpression__Group__2"
    // InternalPureXbase.g:13611:1: rule__XReturnExpression__Group__2 : rule__XReturnExpression__Group__2__Impl ;
    public final void rule__XReturnExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13615:1: ( rule__XReturnExpression__Group__2__Impl )
            // InternalPureXbase.g:13616:2: rule__XReturnExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__2"


    // $ANTLR start "rule__XReturnExpression__Group__2__Impl"
    // InternalPureXbase.g:13622:1: rule__XReturnExpression__Group__2__Impl : ( ( rule__XReturnExpression__ExpressionAssignment_2 )? ) ;
    public final void rule__XReturnExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13626:1: ( ( ( rule__XReturnExpression__ExpressionAssignment_2 )? ) )
            // InternalPureXbase.g:13627:1: ( ( rule__XReturnExpression__ExpressionAssignment_2 )? )
            {
            // InternalPureXbase.g:13627:1: ( ( rule__XReturnExpression__ExpressionAssignment_2 )? )
            // InternalPureXbase.g:13628:2: ( rule__XReturnExpression__ExpressionAssignment_2 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getExpressionAssignment_2()); 
            }
            // InternalPureXbase.g:13629:2: ( rule__XReturnExpression__ExpressionAssignment_2 )?
            int alt114=2;
            alt114 = dfa114.predict(input);
            switch (alt114) {
                case 1 :
                    // InternalPureXbase.g:13629:3: rule__XReturnExpression__ExpressionAssignment_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__XReturnExpression__ExpressionAssignment_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__2__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__0"
    // InternalPureXbase.g:13638:1: rule__XSynchronizedExpression__Group__0 : rule__XSynchronizedExpression__Group__0__Impl rule__XSynchronizedExpression__Group__1 ;
    public final void rule__XSynchronizedExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13642:1: ( rule__XSynchronizedExpression__Group__0__Impl rule__XSynchronizedExpression__Group__1 )
            // InternalPureXbase.g:13643:2: rule__XSynchronizedExpression__Group__0__Impl rule__XSynchronizedExpression__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__XSynchronizedExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__0"


    // $ANTLR start "rule__XSynchronizedExpression__Group__0__Impl"
    // InternalPureXbase.g:13650:1: rule__XSynchronizedExpression__Group__0__Impl : ( ( rule__XSynchronizedExpression__Group_0__0 ) ) ;
    public final void rule__XSynchronizedExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13654:1: ( ( ( rule__XSynchronizedExpression__Group_0__0 ) ) )
            // InternalPureXbase.g:13655:1: ( ( rule__XSynchronizedExpression__Group_0__0 ) )
            {
            // InternalPureXbase.g:13655:1: ( ( rule__XSynchronizedExpression__Group_0__0 ) )
            // InternalPureXbase.g:13656:2: ( rule__XSynchronizedExpression__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0()); 
            }
            // InternalPureXbase.g:13657:2: ( rule__XSynchronizedExpression__Group_0__0 )
            // InternalPureXbase.g:13657:3: rule__XSynchronizedExpression__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__0__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__1"
    // InternalPureXbase.g:13665:1: rule__XSynchronizedExpression__Group__1 : rule__XSynchronizedExpression__Group__1__Impl rule__XSynchronizedExpression__Group__2 ;
    public final void rule__XSynchronizedExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13669:1: ( rule__XSynchronizedExpression__Group__1__Impl rule__XSynchronizedExpression__Group__2 )
            // InternalPureXbase.g:13670:2: rule__XSynchronizedExpression__Group__1__Impl rule__XSynchronizedExpression__Group__2
            {
            pushFollow(FOLLOW_63);
            rule__XSynchronizedExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__1"


    // $ANTLR start "rule__XSynchronizedExpression__Group__1__Impl"
    // InternalPureXbase.g:13677:1: rule__XSynchronizedExpression__Group__1__Impl : ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) ) ;
    public final void rule__XSynchronizedExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13681:1: ( ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) ) )
            // InternalPureXbase.g:13682:1: ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) )
            {
            // InternalPureXbase.g:13682:1: ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) )
            // InternalPureXbase.g:13683:2: ( rule__XSynchronizedExpression__ParamAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getParamAssignment_1()); 
            }
            // InternalPureXbase.g:13684:2: ( rule__XSynchronizedExpression__ParamAssignment_1 )
            // InternalPureXbase.g:13684:3: rule__XSynchronizedExpression__ParamAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__ParamAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getParamAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__1__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__2"
    // InternalPureXbase.g:13692:1: rule__XSynchronizedExpression__Group__2 : rule__XSynchronizedExpression__Group__2__Impl rule__XSynchronizedExpression__Group__3 ;
    public final void rule__XSynchronizedExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13696:1: ( rule__XSynchronizedExpression__Group__2__Impl rule__XSynchronizedExpression__Group__3 )
            // InternalPureXbase.g:13697:2: rule__XSynchronizedExpression__Group__2__Impl rule__XSynchronizedExpression__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__XSynchronizedExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__2"


    // $ANTLR start "rule__XSynchronizedExpression__Group__2__Impl"
    // InternalPureXbase.g:13704:1: rule__XSynchronizedExpression__Group__2__Impl : ( ')' ) ;
    public final void rule__XSynchronizedExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13708:1: ( ( ')' ) )
            // InternalPureXbase.g:13709:1: ( ')' )
            {
            // InternalPureXbase.g:13709:1: ( ')' )
            // InternalPureXbase.g:13710:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__2__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__3"
    // InternalPureXbase.g:13719:1: rule__XSynchronizedExpression__Group__3 : rule__XSynchronizedExpression__Group__3__Impl ;
    public final void rule__XSynchronizedExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13723:1: ( rule__XSynchronizedExpression__Group__3__Impl )
            // InternalPureXbase.g:13724:2: rule__XSynchronizedExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__3"


    // $ANTLR start "rule__XSynchronizedExpression__Group__3__Impl"
    // InternalPureXbase.g:13730:1: rule__XSynchronizedExpression__Group__3__Impl : ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) ) ;
    public final void rule__XSynchronizedExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13734:1: ( ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) ) )
            // InternalPureXbase.g:13735:1: ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) )
            {
            // InternalPureXbase.g:13735:1: ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) )
            // InternalPureXbase.g:13736:2: ( rule__XSynchronizedExpression__ExpressionAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getExpressionAssignment_3()); 
            }
            // InternalPureXbase.g:13737:2: ( rule__XSynchronizedExpression__ExpressionAssignment_3 )
            // InternalPureXbase.g:13737:3: rule__XSynchronizedExpression__ExpressionAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__ExpressionAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getExpressionAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__3__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0__0"
    // InternalPureXbase.g:13746:1: rule__XSynchronizedExpression__Group_0__0 : rule__XSynchronizedExpression__Group_0__0__Impl ;
    public final void rule__XSynchronizedExpression__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13750:1: ( rule__XSynchronizedExpression__Group_0__0__Impl )
            // InternalPureXbase.g:13751:2: rule__XSynchronizedExpression__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0__0"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0__0__Impl"
    // InternalPureXbase.g:13757:1: rule__XSynchronizedExpression__Group_0__0__Impl : ( ( rule__XSynchronizedExpression__Group_0_0__0 ) ) ;
    public final void rule__XSynchronizedExpression__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13761:1: ( ( ( rule__XSynchronizedExpression__Group_0_0__0 ) ) )
            // InternalPureXbase.g:13762:1: ( ( rule__XSynchronizedExpression__Group_0_0__0 ) )
            {
            // InternalPureXbase.g:13762:1: ( ( rule__XSynchronizedExpression__Group_0_0__0 ) )
            // InternalPureXbase.g:13763:2: ( rule__XSynchronizedExpression__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0_0()); 
            }
            // InternalPureXbase.g:13764:2: ( rule__XSynchronizedExpression__Group_0_0__0 )
            // InternalPureXbase.g:13764:3: rule__XSynchronizedExpression__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0__0__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__0"
    // InternalPureXbase.g:13773:1: rule__XSynchronizedExpression__Group_0_0__0 : rule__XSynchronizedExpression__Group_0_0__0__Impl rule__XSynchronizedExpression__Group_0_0__1 ;
    public final void rule__XSynchronizedExpression__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13777:1: ( rule__XSynchronizedExpression__Group_0_0__0__Impl rule__XSynchronizedExpression__Group_0_0__1 )
            // InternalPureXbase.g:13778:2: rule__XSynchronizedExpression__Group_0_0__0__Impl rule__XSynchronizedExpression__Group_0_0__1
            {
            pushFollow(FOLLOW_88);
            rule__XSynchronizedExpression__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__0"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__0__Impl"
    // InternalPureXbase.g:13785:1: rule__XSynchronizedExpression__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XSynchronizedExpression__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13789:1: ( ( () ) )
            // InternalPureXbase.g:13790:1: ( () )
            {
            // InternalPureXbase.g:13790:1: ( () )
            // InternalPureXbase.g:13791:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getXSynchronizedExpressionAction_0_0_0()); 
            }
            // InternalPureXbase.g:13792:2: ()
            // InternalPureXbase.g:13792:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getXSynchronizedExpressionAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__0__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__1"
    // InternalPureXbase.g:13800:1: rule__XSynchronizedExpression__Group_0_0__1 : rule__XSynchronizedExpression__Group_0_0__1__Impl rule__XSynchronizedExpression__Group_0_0__2 ;
    public final void rule__XSynchronizedExpression__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13804:1: ( rule__XSynchronizedExpression__Group_0_0__1__Impl rule__XSynchronizedExpression__Group_0_0__2 )
            // InternalPureXbase.g:13805:2: rule__XSynchronizedExpression__Group_0_0__1__Impl rule__XSynchronizedExpression__Group_0_0__2
            {
            pushFollow(FOLLOW_65);
            rule__XSynchronizedExpression__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__1"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__1__Impl"
    // InternalPureXbase.g:13812:1: rule__XSynchronizedExpression__Group_0_0__1__Impl : ( 'synchronized' ) ;
    public final void rule__XSynchronizedExpression__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13816:1: ( ( 'synchronized' ) )
            // InternalPureXbase.g:13817:1: ( 'synchronized' )
            {
            // InternalPureXbase.g:13817:1: ( 'synchronized' )
            // InternalPureXbase.g:13818:2: 'synchronized'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getSynchronizedKeyword_0_0_1()); 
            }
            match(input,74,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getSynchronizedKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__1__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__2"
    // InternalPureXbase.g:13827:1: rule__XSynchronizedExpression__Group_0_0__2 : rule__XSynchronizedExpression__Group_0_0__2__Impl ;
    public final void rule__XSynchronizedExpression__Group_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13831:1: ( rule__XSynchronizedExpression__Group_0_0__2__Impl )
            // InternalPureXbase.g:13832:2: rule__XSynchronizedExpression__Group_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__2"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__2__Impl"
    // InternalPureXbase.g:13838:1: rule__XSynchronizedExpression__Group_0_0__2__Impl : ( '(' ) ;
    public final void rule__XSynchronizedExpression__Group_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13842:1: ( ( '(' ) )
            // InternalPureXbase.g:13843:1: ( '(' )
            {
            // InternalPureXbase.g:13843:1: ( '(' )
            // InternalPureXbase.g:13844:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__2__Impl"


    // $ANTLR start "rule__XCatchClause__Group__0"
    // InternalPureXbase.g:13854:1: rule__XCatchClause__Group__0 : rule__XCatchClause__Group__0__Impl rule__XCatchClause__Group__1 ;
    public final void rule__XCatchClause__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13858:1: ( rule__XCatchClause__Group__0__Impl rule__XCatchClause__Group__1 )
            // InternalPureXbase.g:13859:2: rule__XCatchClause__Group__0__Impl rule__XCatchClause__Group__1
            {
            pushFollow(FOLLOW_65);
            rule__XCatchClause__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__0"


    // $ANTLR start "rule__XCatchClause__Group__0__Impl"
    // InternalPureXbase.g:13866:1: rule__XCatchClause__Group__0__Impl : ( ( 'catch' ) ) ;
    public final void rule__XCatchClause__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13870:1: ( ( ( 'catch' ) ) )
            // InternalPureXbase.g:13871:1: ( ( 'catch' ) )
            {
            // InternalPureXbase.g:13871:1: ( ( 'catch' ) )
            // InternalPureXbase.g:13872:2: ( 'catch' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getCatchKeyword_0()); 
            }
            // InternalPureXbase.g:13873:2: ( 'catch' )
            // InternalPureXbase.g:13873:3: 'catch'
            {
            match(input,75,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getCatchKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__0__Impl"


    // $ANTLR start "rule__XCatchClause__Group__1"
    // InternalPureXbase.g:13881:1: rule__XCatchClause__Group__1 : rule__XCatchClause__Group__1__Impl rule__XCatchClause__Group__2 ;
    public final void rule__XCatchClause__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13885:1: ( rule__XCatchClause__Group__1__Impl rule__XCatchClause__Group__2 )
            // InternalPureXbase.g:13886:2: rule__XCatchClause__Group__1__Impl rule__XCatchClause__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__XCatchClause__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__1"


    // $ANTLR start "rule__XCatchClause__Group__1__Impl"
    // InternalPureXbase.g:13893:1: rule__XCatchClause__Group__1__Impl : ( '(' ) ;
    public final void rule__XCatchClause__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13897:1: ( ( '(' ) )
            // InternalPureXbase.g:13898:1: ( '(' )
            {
            // InternalPureXbase.g:13898:1: ( '(' )
            // InternalPureXbase.g:13899:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getLeftParenthesisKeyword_1()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getLeftParenthesisKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__1__Impl"


    // $ANTLR start "rule__XCatchClause__Group__2"
    // InternalPureXbase.g:13908:1: rule__XCatchClause__Group__2 : rule__XCatchClause__Group__2__Impl rule__XCatchClause__Group__3 ;
    public final void rule__XCatchClause__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13912:1: ( rule__XCatchClause__Group__2__Impl rule__XCatchClause__Group__3 )
            // InternalPureXbase.g:13913:2: rule__XCatchClause__Group__2__Impl rule__XCatchClause__Group__3
            {
            pushFollow(FOLLOW_63);
            rule__XCatchClause__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__2"


    // $ANTLR start "rule__XCatchClause__Group__2__Impl"
    // InternalPureXbase.g:13920:1: rule__XCatchClause__Group__2__Impl : ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) ) ;
    public final void rule__XCatchClause__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13924:1: ( ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) ) )
            // InternalPureXbase.g:13925:1: ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) )
            {
            // InternalPureXbase.g:13925:1: ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) )
            // InternalPureXbase.g:13926:2: ( rule__XCatchClause__DeclaredParamAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getDeclaredParamAssignment_2()); 
            }
            // InternalPureXbase.g:13927:2: ( rule__XCatchClause__DeclaredParamAssignment_2 )
            // InternalPureXbase.g:13927:3: rule__XCatchClause__DeclaredParamAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__DeclaredParamAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getDeclaredParamAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__2__Impl"


    // $ANTLR start "rule__XCatchClause__Group__3"
    // InternalPureXbase.g:13935:1: rule__XCatchClause__Group__3 : rule__XCatchClause__Group__3__Impl rule__XCatchClause__Group__4 ;
    public final void rule__XCatchClause__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13939:1: ( rule__XCatchClause__Group__3__Impl rule__XCatchClause__Group__4 )
            // InternalPureXbase.g:13940:2: rule__XCatchClause__Group__3__Impl rule__XCatchClause__Group__4
            {
            pushFollow(FOLLOW_5);
            rule__XCatchClause__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__3"


    // $ANTLR start "rule__XCatchClause__Group__3__Impl"
    // InternalPureXbase.g:13947:1: rule__XCatchClause__Group__3__Impl : ( ')' ) ;
    public final void rule__XCatchClause__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13951:1: ( ( ')' ) )
            // InternalPureXbase.g:13952:1: ( ')' )
            {
            // InternalPureXbase.g:13952:1: ( ')' )
            // InternalPureXbase.g:13953:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getRightParenthesisKeyword_3()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getRightParenthesisKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__3__Impl"


    // $ANTLR start "rule__XCatchClause__Group__4"
    // InternalPureXbase.g:13962:1: rule__XCatchClause__Group__4 : rule__XCatchClause__Group__4__Impl ;
    public final void rule__XCatchClause__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13966:1: ( rule__XCatchClause__Group__4__Impl )
            // InternalPureXbase.g:13967:2: rule__XCatchClause__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__4"


    // $ANTLR start "rule__XCatchClause__Group__4__Impl"
    // InternalPureXbase.g:13973:1: rule__XCatchClause__Group__4__Impl : ( ( rule__XCatchClause__ExpressionAssignment_4 ) ) ;
    public final void rule__XCatchClause__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13977:1: ( ( ( rule__XCatchClause__ExpressionAssignment_4 ) ) )
            // InternalPureXbase.g:13978:1: ( ( rule__XCatchClause__ExpressionAssignment_4 ) )
            {
            // InternalPureXbase.g:13978:1: ( ( rule__XCatchClause__ExpressionAssignment_4 ) )
            // InternalPureXbase.g:13979:2: ( rule__XCatchClause__ExpressionAssignment_4 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getExpressionAssignment_4()); 
            }
            // InternalPureXbase.g:13980:2: ( rule__XCatchClause__ExpressionAssignment_4 )
            // InternalPureXbase.g:13980:3: rule__XCatchClause__ExpressionAssignment_4
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__ExpressionAssignment_4();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getExpressionAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__4__Impl"


    // $ANTLR start "rule__QualifiedName__Group__0"
    // InternalPureXbase.g:13989:1: rule__QualifiedName__Group__0 : rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 ;
    public final void rule__QualifiedName__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:13993:1: ( rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 )
            // InternalPureXbase.g:13994:2: rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1
            {
            pushFollow(FOLLOW_89);
            rule__QualifiedName__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0"


    // $ANTLR start "rule__QualifiedName__Group__0__Impl"
    // InternalPureXbase.g:14001:1: rule__QualifiedName__Group__0__Impl : ( ruleValidID ) ;
    public final void rule__QualifiedName__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14005:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:14006:1: ( ruleValidID )
            {
            // InternalPureXbase.g:14006:1: ( ruleValidID )
            // InternalPureXbase.g:14007:2: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group__1"
    // InternalPureXbase.g:14016:1: rule__QualifiedName__Group__1 : rule__QualifiedName__Group__1__Impl ;
    public final void rule__QualifiedName__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14020:1: ( rule__QualifiedName__Group__1__Impl )
            // InternalPureXbase.g:14021:2: rule__QualifiedName__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1"


    // $ANTLR start "rule__QualifiedName__Group__1__Impl"
    // InternalPureXbase.g:14027:1: rule__QualifiedName__Group__1__Impl : ( ( rule__QualifiedName__Group_1__0 )* ) ;
    public final void rule__QualifiedName__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14031:1: ( ( ( rule__QualifiedName__Group_1__0 )* ) )
            // InternalPureXbase.g:14032:1: ( ( rule__QualifiedName__Group_1__0 )* )
            {
            // InternalPureXbase.g:14032:1: ( ( rule__QualifiedName__Group_1__0 )* )
            // InternalPureXbase.g:14033:2: ( rule__QualifiedName__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:14034:2: ( rule__QualifiedName__Group_1__0 )*
            loop115:
            do {
                int alt115=2;
                int LA115_0 = input.LA(1);

                if ( (LA115_0==44) ) {
                    int LA115_2 = input.LA(2);

                    if ( (LA115_2==RULE_ID) ) {
                        int LA115_3 = input.LA(3);

                        if ( (synpred155_InternalPureXbase()) ) {
                            alt115=1;
                        }


                    }


                }


                switch (alt115) {
            	case 1 :
            	    // InternalPureXbase.g:14034:3: rule__QualifiedName__Group_1__0
            	    {
            	    pushFollow(FOLLOW_90);
            	    rule__QualifiedName__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop115;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__0"
    // InternalPureXbase.g:14043:1: rule__QualifiedName__Group_1__0 : rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 ;
    public final void rule__QualifiedName__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14047:1: ( rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 )
            // InternalPureXbase.g:14048:2: rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1
            {
            pushFollow(FOLLOW_17);
            rule__QualifiedName__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0"


    // $ANTLR start "rule__QualifiedName__Group_1__0__Impl"
    // InternalPureXbase.g:14055:1: rule__QualifiedName__Group_1__0__Impl : ( ( '.' ) ) ;
    public final void rule__QualifiedName__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14059:1: ( ( ( '.' ) ) )
            // InternalPureXbase.g:14060:1: ( ( '.' ) )
            {
            // InternalPureXbase.g:14060:1: ( ( '.' ) )
            // InternalPureXbase.g:14061:2: ( '.' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            }
            // InternalPureXbase.g:14062:2: ( '.' )
            // InternalPureXbase.g:14062:3: '.'
            {
            match(input,44,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__1"
    // InternalPureXbase.g:14070:1: rule__QualifiedName__Group_1__1 : rule__QualifiedName__Group_1__1__Impl ;
    public final void rule__QualifiedName__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14074:1: ( rule__QualifiedName__Group_1__1__Impl )
            // InternalPureXbase.g:14075:2: rule__QualifiedName__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1"


    // $ANTLR start "rule__QualifiedName__Group_1__1__Impl"
    // InternalPureXbase.g:14081:1: rule__QualifiedName__Group_1__1__Impl : ( ruleValidID ) ;
    public final void rule__QualifiedName__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14085:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:14086:1: ( ruleValidID )
            {
            // InternalPureXbase.g:14086:1: ( ruleValidID )
            // InternalPureXbase.g:14087:2: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_1_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1__Impl"


    // $ANTLR start "rule__Number__Group_1__0"
    // InternalPureXbase.g:14097:1: rule__Number__Group_1__0 : rule__Number__Group_1__0__Impl rule__Number__Group_1__1 ;
    public final void rule__Number__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14101:1: ( rule__Number__Group_1__0__Impl rule__Number__Group_1__1 )
            // InternalPureXbase.g:14102:2: rule__Number__Group_1__0__Impl rule__Number__Group_1__1
            {
            pushFollow(FOLLOW_89);
            rule__Number__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__Number__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__0"


    // $ANTLR start "rule__Number__Group_1__0__Impl"
    // InternalPureXbase.g:14109:1: rule__Number__Group_1__0__Impl : ( ( rule__Number__Alternatives_1_0 ) ) ;
    public final void rule__Number__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14113:1: ( ( ( rule__Number__Alternatives_1_0 ) ) )
            // InternalPureXbase.g:14114:1: ( ( rule__Number__Alternatives_1_0 ) )
            {
            // InternalPureXbase.g:14114:1: ( ( rule__Number__Alternatives_1_0 ) )
            // InternalPureXbase.g:14115:2: ( rule__Number__Alternatives_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getAlternatives_1_0()); 
            }
            // InternalPureXbase.g:14116:2: ( rule__Number__Alternatives_1_0 )
            // InternalPureXbase.g:14116:3: rule__Number__Alternatives_1_0
            {
            pushFollow(FOLLOW_2);
            rule__Number__Alternatives_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getAlternatives_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__0__Impl"


    // $ANTLR start "rule__Number__Group_1__1"
    // InternalPureXbase.g:14124:1: rule__Number__Group_1__1 : rule__Number__Group_1__1__Impl ;
    public final void rule__Number__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14128:1: ( rule__Number__Group_1__1__Impl )
            // InternalPureXbase.g:14129:2: rule__Number__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Number__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__1"


    // $ANTLR start "rule__Number__Group_1__1__Impl"
    // InternalPureXbase.g:14135:1: rule__Number__Group_1__1__Impl : ( ( rule__Number__Group_1_1__0 )? ) ;
    public final void rule__Number__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14139:1: ( ( ( rule__Number__Group_1_1__0 )? ) )
            // InternalPureXbase.g:14140:1: ( ( rule__Number__Group_1_1__0 )? )
            {
            // InternalPureXbase.g:14140:1: ( ( rule__Number__Group_1_1__0 )? )
            // InternalPureXbase.g:14141:2: ( rule__Number__Group_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getGroup_1_1()); 
            }
            // InternalPureXbase.g:14142:2: ( rule__Number__Group_1_1__0 )?
            int alt116=2;
            int LA116_0 = input.LA(1);

            if ( (LA116_0==44) ) {
                int LA116_1 = input.LA(2);

                if ( ((LA116_1>=RULE_INT && LA116_1<=RULE_DECIMAL)) ) {
                    alt116=1;
                }
            }
            switch (alt116) {
                case 1 :
                    // InternalPureXbase.g:14142:3: rule__Number__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Number__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getGroup_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__1__Impl"


    // $ANTLR start "rule__Number__Group_1_1__0"
    // InternalPureXbase.g:14151:1: rule__Number__Group_1_1__0 : rule__Number__Group_1_1__0__Impl rule__Number__Group_1_1__1 ;
    public final void rule__Number__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14155:1: ( rule__Number__Group_1_1__0__Impl rule__Number__Group_1_1__1 )
            // InternalPureXbase.g:14156:2: rule__Number__Group_1_1__0__Impl rule__Number__Group_1_1__1
            {
            pushFollow(FOLLOW_91);
            rule__Number__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__Number__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__0"


    // $ANTLR start "rule__Number__Group_1_1__0__Impl"
    // InternalPureXbase.g:14163:1: rule__Number__Group_1_1__0__Impl : ( '.' ) ;
    public final void rule__Number__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14167:1: ( ( '.' ) )
            // InternalPureXbase.g:14168:1: ( '.' )
            {
            // InternalPureXbase.g:14168:1: ( '.' )
            // InternalPureXbase.g:14169:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getFullStopKeyword_1_1_0()); 
            }
            match(input,44,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getFullStopKeyword_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__0__Impl"


    // $ANTLR start "rule__Number__Group_1_1__1"
    // InternalPureXbase.g:14178:1: rule__Number__Group_1_1__1 : rule__Number__Group_1_1__1__Impl ;
    public final void rule__Number__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14182:1: ( rule__Number__Group_1_1__1__Impl )
            // InternalPureXbase.g:14183:2: rule__Number__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Number__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__1"


    // $ANTLR start "rule__Number__Group_1_1__1__Impl"
    // InternalPureXbase.g:14189:1: rule__Number__Group_1_1__1__Impl : ( ( rule__Number__Alternatives_1_1_1 ) ) ;
    public final void rule__Number__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14193:1: ( ( ( rule__Number__Alternatives_1_1_1 ) ) )
            // InternalPureXbase.g:14194:1: ( ( rule__Number__Alternatives_1_1_1 ) )
            {
            // InternalPureXbase.g:14194:1: ( ( rule__Number__Alternatives_1_1_1 ) )
            // InternalPureXbase.g:14195:2: ( rule__Number__Alternatives_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getAlternatives_1_1_1()); 
            }
            // InternalPureXbase.g:14196:2: ( rule__Number__Alternatives_1_1_1 )
            // InternalPureXbase.g:14196:3: rule__Number__Alternatives_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__Number__Alternatives_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getAlternatives_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__1__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0__0"
    // InternalPureXbase.g:14205:1: rule__JvmTypeReference__Group_0__0 : rule__JvmTypeReference__Group_0__0__Impl rule__JvmTypeReference__Group_0__1 ;
    public final void rule__JvmTypeReference__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14209:1: ( rule__JvmTypeReference__Group_0__0__Impl rule__JvmTypeReference__Group_0__1 )
            // InternalPureXbase.g:14210:2: rule__JvmTypeReference__Group_0__0__Impl rule__JvmTypeReference__Group_0__1
            {
            pushFollow(FOLLOW_58);
            rule__JvmTypeReference__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__0"


    // $ANTLR start "rule__JvmTypeReference__Group_0__0__Impl"
    // InternalPureXbase.g:14217:1: rule__JvmTypeReference__Group_0__0__Impl : ( ruleJvmParameterizedTypeReference ) ;
    public final void rule__JvmTypeReference__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14221:1: ( ( ruleJvmParameterizedTypeReference ) )
            // InternalPureXbase.g:14222:1: ( ruleJvmParameterizedTypeReference )
            {
            // InternalPureXbase.g:14222:1: ( ruleJvmParameterizedTypeReference )
            // InternalPureXbase.g:14223:2: ruleJvmParameterizedTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getJvmParameterizedTypeReferenceParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmParameterizedTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getJvmParameterizedTypeReferenceParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__0__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0__1"
    // InternalPureXbase.g:14232:1: rule__JvmTypeReference__Group_0__1 : rule__JvmTypeReference__Group_0__1__Impl ;
    public final void rule__JvmTypeReference__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14236:1: ( rule__JvmTypeReference__Group_0__1__Impl )
            // InternalPureXbase.g:14237:2: rule__JvmTypeReference__Group_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__1"


    // $ANTLR start "rule__JvmTypeReference__Group_0__1__Impl"
    // InternalPureXbase.g:14243:1: rule__JvmTypeReference__Group_0__1__Impl : ( ( rule__JvmTypeReference__Group_0_1__0 )* ) ;
    public final void rule__JvmTypeReference__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14247:1: ( ( ( rule__JvmTypeReference__Group_0_1__0 )* ) )
            // InternalPureXbase.g:14248:1: ( ( rule__JvmTypeReference__Group_0_1__0 )* )
            {
            // InternalPureXbase.g:14248:1: ( ( rule__JvmTypeReference__Group_0_1__0 )* )
            // InternalPureXbase.g:14249:2: ( rule__JvmTypeReference__Group_0_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1()); 
            }
            // InternalPureXbase.g:14250:2: ( rule__JvmTypeReference__Group_0_1__0 )*
            loop117:
            do {
                int alt117=2;
                int LA117_0 = input.LA(1);

                if ( (LA117_0==59) ) {
                    int LA117_2 = input.LA(2);

                    if ( (LA117_2==60) ) {
                        int LA117_3 = input.LA(3);

                        if ( (synpred157_InternalPureXbase()) ) {
                            alt117=1;
                        }


                    }


                }


                switch (alt117) {
            	case 1 :
            	    // InternalPureXbase.g:14250:3: rule__JvmTypeReference__Group_0_1__0
            	    {
            	    pushFollow(FOLLOW_85);
            	    rule__JvmTypeReference__Group_0_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop117;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__1__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1__0"
    // InternalPureXbase.g:14259:1: rule__JvmTypeReference__Group_0_1__0 : rule__JvmTypeReference__Group_0_1__0__Impl ;
    public final void rule__JvmTypeReference__Group_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14263:1: ( rule__JvmTypeReference__Group_0_1__0__Impl )
            // InternalPureXbase.g:14264:2: rule__JvmTypeReference__Group_0_1__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1__0"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1__0__Impl"
    // InternalPureXbase.g:14270:1: rule__JvmTypeReference__Group_0_1__0__Impl : ( ( rule__JvmTypeReference__Group_0_1_0__0 ) ) ;
    public final void rule__JvmTypeReference__Group_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14274:1: ( ( ( rule__JvmTypeReference__Group_0_1_0__0 ) ) )
            // InternalPureXbase.g:14275:1: ( ( rule__JvmTypeReference__Group_0_1_0__0 ) )
            {
            // InternalPureXbase.g:14275:1: ( ( rule__JvmTypeReference__Group_0_1_0__0 ) )
            // InternalPureXbase.g:14276:2: ( rule__JvmTypeReference__Group_0_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1_0()); 
            }
            // InternalPureXbase.g:14277:2: ( rule__JvmTypeReference__Group_0_1_0__0 )
            // InternalPureXbase.g:14277:3: rule__JvmTypeReference__Group_0_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1__0__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__0"
    // InternalPureXbase.g:14286:1: rule__JvmTypeReference__Group_0_1_0__0 : rule__JvmTypeReference__Group_0_1_0__0__Impl rule__JvmTypeReference__Group_0_1_0__1 ;
    public final void rule__JvmTypeReference__Group_0_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14290:1: ( rule__JvmTypeReference__Group_0_1_0__0__Impl rule__JvmTypeReference__Group_0_1_0__1 )
            // InternalPureXbase.g:14291:2: rule__JvmTypeReference__Group_0_1_0__0__Impl rule__JvmTypeReference__Group_0_1_0__1
            {
            pushFollow(FOLLOW_58);
            rule__JvmTypeReference__Group_0_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__0"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__0__Impl"
    // InternalPureXbase.g:14298:1: rule__JvmTypeReference__Group_0_1_0__0__Impl : ( () ) ;
    public final void rule__JvmTypeReference__Group_0_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14302:1: ( ( () ) )
            // InternalPureXbase.g:14303:1: ( () )
            {
            // InternalPureXbase.g:14303:1: ( () )
            // InternalPureXbase.g:14304:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_0_1_0_0()); 
            }
            // InternalPureXbase.g:14305:2: ()
            // InternalPureXbase.g:14305:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_0_1_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__0__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__1"
    // InternalPureXbase.g:14313:1: rule__JvmTypeReference__Group_0_1_0__1 : rule__JvmTypeReference__Group_0_1_0__1__Impl ;
    public final void rule__JvmTypeReference__Group_0_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14317:1: ( rule__JvmTypeReference__Group_0_1_0__1__Impl )
            // InternalPureXbase.g:14318:2: rule__JvmTypeReference__Group_0_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__1"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__1__Impl"
    // InternalPureXbase.g:14324:1: rule__JvmTypeReference__Group_0_1_0__1__Impl : ( ruleArrayBrackets ) ;
    public final void rule__JvmTypeReference__Group_0_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14328:1: ( ( ruleArrayBrackets ) )
            // InternalPureXbase.g:14329:1: ( ruleArrayBrackets )
            {
            // InternalPureXbase.g:14329:1: ( ruleArrayBrackets )
            // InternalPureXbase.g:14330:2: ruleArrayBrackets
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getArrayBracketsParserRuleCall_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getArrayBracketsParserRuleCall_0_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__1__Impl"


    // $ANTLR start "rule__ArrayBrackets__Group__0"
    // InternalPureXbase.g:14340:1: rule__ArrayBrackets__Group__0 : rule__ArrayBrackets__Group__0__Impl rule__ArrayBrackets__Group__1 ;
    public final void rule__ArrayBrackets__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14344:1: ( rule__ArrayBrackets__Group__0__Impl rule__ArrayBrackets__Group__1 )
            // InternalPureXbase.g:14345:2: rule__ArrayBrackets__Group__0__Impl rule__ArrayBrackets__Group__1
            {
            pushFollow(FOLLOW_61);
            rule__ArrayBrackets__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__ArrayBrackets__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__0"


    // $ANTLR start "rule__ArrayBrackets__Group__0__Impl"
    // InternalPureXbase.g:14352:1: rule__ArrayBrackets__Group__0__Impl : ( '[' ) ;
    public final void rule__ArrayBrackets__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14356:1: ( ( '[' ) )
            // InternalPureXbase.g:14357:1: ( '[' )
            {
            // InternalPureXbase.g:14357:1: ( '[' )
            // InternalPureXbase.g:14358:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsAccess().getLeftSquareBracketKeyword_0()); 
            }
            match(input,59,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsAccess().getLeftSquareBracketKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__0__Impl"


    // $ANTLR start "rule__ArrayBrackets__Group__1"
    // InternalPureXbase.g:14367:1: rule__ArrayBrackets__Group__1 : rule__ArrayBrackets__Group__1__Impl ;
    public final void rule__ArrayBrackets__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14371:1: ( rule__ArrayBrackets__Group__1__Impl )
            // InternalPureXbase.g:14372:2: rule__ArrayBrackets__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ArrayBrackets__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__1"


    // $ANTLR start "rule__ArrayBrackets__Group__1__Impl"
    // InternalPureXbase.g:14378:1: rule__ArrayBrackets__Group__1__Impl : ( ']' ) ;
    public final void rule__ArrayBrackets__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14382:1: ( ( ']' ) )
            // InternalPureXbase.g:14383:1: ( ']' )
            {
            // InternalPureXbase.g:14383:1: ( ']' )
            // InternalPureXbase.g:14384:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsAccess().getRightSquareBracketKeyword_1()); 
            }
            match(input,60,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsAccess().getRightSquareBracketKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group__0"
    // InternalPureXbase.g:14394:1: rule__XFunctionTypeRef__Group__0 : rule__XFunctionTypeRef__Group__0__Impl rule__XFunctionTypeRef__Group__1 ;
    public final void rule__XFunctionTypeRef__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14398:1: ( rule__XFunctionTypeRef__Group__0__Impl rule__XFunctionTypeRef__Group__1 )
            // InternalPureXbase.g:14399:2: rule__XFunctionTypeRef__Group__0__Impl rule__XFunctionTypeRef__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__XFunctionTypeRef__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group__0__Impl"
    // InternalPureXbase.g:14406:1: rule__XFunctionTypeRef__Group__0__Impl : ( ( rule__XFunctionTypeRef__Group_0__0 )? ) ;
    public final void rule__XFunctionTypeRef__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14410:1: ( ( ( rule__XFunctionTypeRef__Group_0__0 )? ) )
            // InternalPureXbase.g:14411:1: ( ( rule__XFunctionTypeRef__Group_0__0 )? )
            {
            // InternalPureXbase.g:14411:1: ( ( rule__XFunctionTypeRef__Group_0__0 )? )
            // InternalPureXbase.g:14412:2: ( rule__XFunctionTypeRef__Group_0__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup_0()); 
            }
            // InternalPureXbase.g:14413:2: ( rule__XFunctionTypeRef__Group_0__0 )?
            int alt118=2;
            int LA118_0 = input.LA(1);

            if ( (LA118_0==49) ) {
                alt118=1;
            }
            switch (alt118) {
                case 1 :
                    // InternalPureXbase.g:14413:3: rule__XFunctionTypeRef__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFunctionTypeRef__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group__1"
    // InternalPureXbase.g:14421:1: rule__XFunctionTypeRef__Group__1 : rule__XFunctionTypeRef__Group__1__Impl rule__XFunctionTypeRef__Group__2 ;
    public final void rule__XFunctionTypeRef__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14425:1: ( rule__XFunctionTypeRef__Group__1__Impl rule__XFunctionTypeRef__Group__2 )
            // InternalPureXbase.g:14426:2: rule__XFunctionTypeRef__Group__1__Impl rule__XFunctionTypeRef__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__XFunctionTypeRef__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group__1__Impl"
    // InternalPureXbase.g:14433:1: rule__XFunctionTypeRef__Group__1__Impl : ( '=>' ) ;
    public final void rule__XFunctionTypeRef__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14437:1: ( ( '=>' ) )
            // InternalPureXbase.g:14438:1: ( '=>' )
            {
            // InternalPureXbase.g:14438:1: ( '=>' )
            // InternalPureXbase.g:14439:2: '=>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getEqualsSignGreaterThanSignKeyword_1()); 
            }
            match(input,32,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getEqualsSignGreaterThanSignKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group__2"
    // InternalPureXbase.g:14448:1: rule__XFunctionTypeRef__Group__2 : rule__XFunctionTypeRef__Group__2__Impl ;
    public final void rule__XFunctionTypeRef__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14452:1: ( rule__XFunctionTypeRef__Group__2__Impl )
            // InternalPureXbase.g:14453:2: rule__XFunctionTypeRef__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__2"


    // $ANTLR start "rule__XFunctionTypeRef__Group__2__Impl"
    // InternalPureXbase.g:14459:1: rule__XFunctionTypeRef__Group__2__Impl : ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) ) ;
    public final void rule__XFunctionTypeRef__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14463:1: ( ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) ) )
            // InternalPureXbase.g:14464:1: ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) )
            {
            // InternalPureXbase.g:14464:1: ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) )
            // InternalPureXbase.g:14465:2: ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeAssignment_2()); 
            }
            // InternalPureXbase.g:14466:2: ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 )
            // InternalPureXbase.g:14466:3: rule__XFunctionTypeRef__ReturnTypeAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__ReturnTypeAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__2__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__0"
    // InternalPureXbase.g:14475:1: rule__XFunctionTypeRef__Group_0__0 : rule__XFunctionTypeRef__Group_0__0__Impl rule__XFunctionTypeRef__Group_0__1 ;
    public final void rule__XFunctionTypeRef__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14479:1: ( rule__XFunctionTypeRef__Group_0__0__Impl rule__XFunctionTypeRef__Group_0__1 )
            // InternalPureXbase.g:14480:2: rule__XFunctionTypeRef__Group_0__0__Impl rule__XFunctionTypeRef__Group_0__1
            {
            pushFollow(FOLLOW_92);
            rule__XFunctionTypeRef__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__0__Impl"
    // InternalPureXbase.g:14487:1: rule__XFunctionTypeRef__Group_0__0__Impl : ( '(' ) ;
    public final void rule__XFunctionTypeRef__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14491:1: ( ( '(' ) )
            // InternalPureXbase.g:14492:1: ( '(' )
            {
            // InternalPureXbase.g:14492:1: ( '(' )
            // InternalPureXbase.g:14493:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getLeftParenthesisKeyword_0_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getLeftParenthesisKeyword_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__1"
    // InternalPureXbase.g:14502:1: rule__XFunctionTypeRef__Group_0__1 : rule__XFunctionTypeRef__Group_0__1__Impl rule__XFunctionTypeRef__Group_0__2 ;
    public final void rule__XFunctionTypeRef__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14506:1: ( rule__XFunctionTypeRef__Group_0__1__Impl rule__XFunctionTypeRef__Group_0__2 )
            // InternalPureXbase.g:14507:2: rule__XFunctionTypeRef__Group_0__1__Impl rule__XFunctionTypeRef__Group_0__2
            {
            pushFollow(FOLLOW_92);
            rule__XFunctionTypeRef__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__1__Impl"
    // InternalPureXbase.g:14514:1: rule__XFunctionTypeRef__Group_0__1__Impl : ( ( rule__XFunctionTypeRef__Group_0_1__0 )? ) ;
    public final void rule__XFunctionTypeRef__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14518:1: ( ( ( rule__XFunctionTypeRef__Group_0_1__0 )? ) )
            // InternalPureXbase.g:14519:1: ( ( rule__XFunctionTypeRef__Group_0_1__0 )? )
            {
            // InternalPureXbase.g:14519:1: ( ( rule__XFunctionTypeRef__Group_0_1__0 )? )
            // InternalPureXbase.g:14520:2: ( rule__XFunctionTypeRef__Group_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1()); 
            }
            // InternalPureXbase.g:14521:2: ( rule__XFunctionTypeRef__Group_0_1__0 )?
            int alt119=2;
            int LA119_0 = input.LA(1);

            if ( (LA119_0==RULE_ID||LA119_0==32||LA119_0==49) ) {
                alt119=1;
            }
            switch (alt119) {
                case 1 :
                    // InternalPureXbase.g:14521:3: rule__XFunctionTypeRef__Group_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFunctionTypeRef__Group_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__2"
    // InternalPureXbase.g:14529:1: rule__XFunctionTypeRef__Group_0__2 : rule__XFunctionTypeRef__Group_0__2__Impl ;
    public final void rule__XFunctionTypeRef__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14533:1: ( rule__XFunctionTypeRef__Group_0__2__Impl )
            // InternalPureXbase.g:14534:2: rule__XFunctionTypeRef__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__2"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__2__Impl"
    // InternalPureXbase.g:14540:1: rule__XFunctionTypeRef__Group_0__2__Impl : ( ')' ) ;
    public final void rule__XFunctionTypeRef__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14544:1: ( ( ')' ) )
            // InternalPureXbase.g:14545:1: ( ')' )
            {
            // InternalPureXbase.g:14545:1: ( ')' )
            // InternalPureXbase.g:14546:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getRightParenthesisKeyword_0_2()); 
            }
            match(input,50,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getRightParenthesisKeyword_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__2__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__0"
    // InternalPureXbase.g:14556:1: rule__XFunctionTypeRef__Group_0_1__0 : rule__XFunctionTypeRef__Group_0_1__0__Impl rule__XFunctionTypeRef__Group_0_1__1 ;
    public final void rule__XFunctionTypeRef__Group_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14560:1: ( rule__XFunctionTypeRef__Group_0_1__0__Impl rule__XFunctionTypeRef__Group_0_1__1 )
            // InternalPureXbase.g:14561:2: rule__XFunctionTypeRef__Group_0_1__0__Impl rule__XFunctionTypeRef__Group_0_1__1
            {
            pushFollow(FOLLOW_54);
            rule__XFunctionTypeRef__Group_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__0__Impl"
    // InternalPureXbase.g:14568:1: rule__XFunctionTypeRef__Group_0_1__0__Impl : ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) ) ;
    public final void rule__XFunctionTypeRef__Group_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14572:1: ( ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) ) )
            // InternalPureXbase.g:14573:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) )
            {
            // InternalPureXbase.g:14573:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) )
            // InternalPureXbase.g:14574:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_0()); 
            }
            // InternalPureXbase.g:14575:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 )
            // InternalPureXbase.g:14575:3: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__1"
    // InternalPureXbase.g:14583:1: rule__XFunctionTypeRef__Group_0_1__1 : rule__XFunctionTypeRef__Group_0_1__1__Impl ;
    public final void rule__XFunctionTypeRef__Group_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14587:1: ( rule__XFunctionTypeRef__Group_0_1__1__Impl )
            // InternalPureXbase.g:14588:2: rule__XFunctionTypeRef__Group_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__1__Impl"
    // InternalPureXbase.g:14594:1: rule__XFunctionTypeRef__Group_0_1__1__Impl : ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* ) ;
    public final void rule__XFunctionTypeRef__Group_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14598:1: ( ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* ) )
            // InternalPureXbase.g:14599:1: ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* )
            {
            // InternalPureXbase.g:14599:1: ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* )
            // InternalPureXbase.g:14600:2: ( rule__XFunctionTypeRef__Group_0_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1_1()); 
            }
            // InternalPureXbase.g:14601:2: ( rule__XFunctionTypeRef__Group_0_1_1__0 )*
            loop120:
            do {
                int alt120=2;
                int LA120_0 = input.LA(1);

                if ( (LA120_0==55) ) {
                    alt120=1;
                }


                switch (alt120) {
            	case 1 :
            	    // InternalPureXbase.g:14601:3: rule__XFunctionTypeRef__Group_0_1_1__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__XFunctionTypeRef__Group_0_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop120;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__0"
    // InternalPureXbase.g:14610:1: rule__XFunctionTypeRef__Group_0_1_1__0 : rule__XFunctionTypeRef__Group_0_1_1__0__Impl rule__XFunctionTypeRef__Group_0_1_1__1 ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14614:1: ( rule__XFunctionTypeRef__Group_0_1_1__0__Impl rule__XFunctionTypeRef__Group_0_1_1__1 )
            // InternalPureXbase.g:14615:2: rule__XFunctionTypeRef__Group_0_1_1__0__Impl rule__XFunctionTypeRef__Group_0_1_1__1
            {
            pushFollow(FOLLOW_15);
            rule__XFunctionTypeRef__Group_0_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__0__Impl"
    // InternalPureXbase.g:14622:1: rule__XFunctionTypeRef__Group_0_1_1__0__Impl : ( ',' ) ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14626:1: ( ( ',' ) )
            // InternalPureXbase.g:14627:1: ( ',' )
            {
            // InternalPureXbase.g:14627:1: ( ',' )
            // InternalPureXbase.g:14628:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getCommaKeyword_0_1_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getCommaKeyword_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__1"
    // InternalPureXbase.g:14637:1: rule__XFunctionTypeRef__Group_0_1_1__1 : rule__XFunctionTypeRef__Group_0_1_1__1__Impl ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14641:1: ( rule__XFunctionTypeRef__Group_0_1_1__1__Impl )
            // InternalPureXbase.g:14642:2: rule__XFunctionTypeRef__Group_0_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__1__Impl"
    // InternalPureXbase.g:14648:1: rule__XFunctionTypeRef__Group_0_1_1__1__Impl : ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) ) ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14652:1: ( ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) ) )
            // InternalPureXbase.g:14653:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) )
            {
            // InternalPureXbase.g:14653:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) )
            // InternalPureXbase.g:14654:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_1_1()); 
            }
            // InternalPureXbase.g:14655:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 )
            // InternalPureXbase.g:14655:3: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__0"
    // InternalPureXbase.g:14664:1: rule__JvmParameterizedTypeReference__Group__0 : rule__JvmParameterizedTypeReference__Group__0__Impl rule__JvmParameterizedTypeReference__Group__1 ;
    public final void rule__JvmParameterizedTypeReference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14668:1: ( rule__JvmParameterizedTypeReference__Group__0__Impl rule__JvmParameterizedTypeReference__Group__1 )
            // InternalPureXbase.g:14669:2: rule__JvmParameterizedTypeReference__Group__0__Impl rule__JvmParameterizedTypeReference__Group__1
            {
            pushFollow(FOLLOW_21);
            rule__JvmParameterizedTypeReference__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__0__Impl"
    // InternalPureXbase.g:14676:1: rule__JvmParameterizedTypeReference__Group__0__Impl : ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14680:1: ( ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) ) )
            // InternalPureXbase.g:14681:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) )
            {
            // InternalPureXbase.g:14681:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) )
            // InternalPureXbase.g:14682:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_0()); 
            }
            // InternalPureXbase.g:14683:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_0 )
            // InternalPureXbase.g:14683:3: rule__JvmParameterizedTypeReference__TypeAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__TypeAssignment_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__1"
    // InternalPureXbase.g:14691:1: rule__JvmParameterizedTypeReference__Group__1 : rule__JvmParameterizedTypeReference__Group__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14695:1: ( rule__JvmParameterizedTypeReference__Group__1__Impl )
            // InternalPureXbase.g:14696:2: rule__JvmParameterizedTypeReference__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__1__Impl"
    // InternalPureXbase.g:14702:1: rule__JvmParameterizedTypeReference__Group__1__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? ) ;
    public final void rule__JvmParameterizedTypeReference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14706:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? ) )
            // InternalPureXbase.g:14707:1: ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? )
            {
            // InternalPureXbase.g:14707:1: ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? )
            // InternalPureXbase.g:14708:2: ( rule__JvmParameterizedTypeReference__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1()); 
            }
            // InternalPureXbase.g:14709:2: ( rule__JvmParameterizedTypeReference__Group_1__0 )?
            int alt121=2;
            alt121 = dfa121.predict(input);
            switch (alt121) {
                case 1 :
                    // InternalPureXbase.g:14709:3: rule__JvmParameterizedTypeReference__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmParameterizedTypeReference__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__0"
    // InternalPureXbase.g:14718:1: rule__JvmParameterizedTypeReference__Group_1__0 : rule__JvmParameterizedTypeReference__Group_1__0__Impl rule__JvmParameterizedTypeReference__Group_1__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14722:1: ( rule__JvmParameterizedTypeReference__Group_1__0__Impl rule__JvmParameterizedTypeReference__Group_1__1 )
            // InternalPureXbase.g:14723:2: rule__JvmParameterizedTypeReference__Group_1__0__Impl rule__JvmParameterizedTypeReference__Group_1__1
            {
            pushFollow(FOLLOW_50);
            rule__JvmParameterizedTypeReference__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__0__Impl"
    // InternalPureXbase.g:14730:1: rule__JvmParameterizedTypeReference__Group_1__0__Impl : ( ( '<' ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14734:1: ( ( ( '<' ) ) )
            // InternalPureXbase.g:14735:1: ( ( '<' ) )
            {
            // InternalPureXbase.g:14735:1: ( ( '<' ) )
            // InternalPureXbase.g:14736:2: ( '<' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_0()); 
            }
            // InternalPureXbase.g:14737:2: ( '<' )
            // InternalPureXbase.g:14737:3: '<'
            {
            match(input,28,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__1"
    // InternalPureXbase.g:14745:1: rule__JvmParameterizedTypeReference__Group_1__1 : rule__JvmParameterizedTypeReference__Group_1__1__Impl rule__JvmParameterizedTypeReference__Group_1__2 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14749:1: ( rule__JvmParameterizedTypeReference__Group_1__1__Impl rule__JvmParameterizedTypeReference__Group_1__2 )
            // InternalPureXbase.g:14750:2: rule__JvmParameterizedTypeReference__Group_1__1__Impl rule__JvmParameterizedTypeReference__Group_1__2
            {
            pushFollow(FOLLOW_51);
            rule__JvmParameterizedTypeReference__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__1__Impl"
    // InternalPureXbase.g:14757:1: rule__JvmParameterizedTypeReference__Group_1__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14761:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) ) )
            // InternalPureXbase.g:14762:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) )
            {
            // InternalPureXbase.g:14762:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) )
            // InternalPureXbase.g:14763:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_1()); 
            }
            // InternalPureXbase.g:14764:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 )
            // InternalPureXbase.g:14764:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__2"
    // InternalPureXbase.g:14772:1: rule__JvmParameterizedTypeReference__Group_1__2 : rule__JvmParameterizedTypeReference__Group_1__2__Impl rule__JvmParameterizedTypeReference__Group_1__3 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14776:1: ( rule__JvmParameterizedTypeReference__Group_1__2__Impl rule__JvmParameterizedTypeReference__Group_1__3 )
            // InternalPureXbase.g:14777:2: rule__JvmParameterizedTypeReference__Group_1__2__Impl rule__JvmParameterizedTypeReference__Group_1__3
            {
            pushFollow(FOLLOW_51);
            rule__JvmParameterizedTypeReference__Group_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__2__Impl"
    // InternalPureXbase.g:14784:1: rule__JvmParameterizedTypeReference__Group_1__2__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14788:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* ) )
            // InternalPureXbase.g:14789:1: ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* )
            {
            // InternalPureXbase.g:14789:1: ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* )
            // InternalPureXbase.g:14790:2: ( rule__JvmParameterizedTypeReference__Group_1_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_2()); 
            }
            // InternalPureXbase.g:14791:2: ( rule__JvmParameterizedTypeReference__Group_1_2__0 )*
            loop122:
            do {
                int alt122=2;
                int LA122_0 = input.LA(1);

                if ( (LA122_0==55) ) {
                    alt122=1;
                }


                switch (alt122) {
            	case 1 :
            	    // InternalPureXbase.g:14791:3: rule__JvmParameterizedTypeReference__Group_1_2__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__JvmParameterizedTypeReference__Group_1_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop122;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__2__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__3"
    // InternalPureXbase.g:14799:1: rule__JvmParameterizedTypeReference__Group_1__3 : rule__JvmParameterizedTypeReference__Group_1__3__Impl rule__JvmParameterizedTypeReference__Group_1__4 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14803:1: ( rule__JvmParameterizedTypeReference__Group_1__3__Impl rule__JvmParameterizedTypeReference__Group_1__4 )
            // InternalPureXbase.g:14804:2: rule__JvmParameterizedTypeReference__Group_1__3__Impl rule__JvmParameterizedTypeReference__Group_1__4
            {
            pushFollow(FOLLOW_89);
            rule__JvmParameterizedTypeReference__Group_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__3"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__3__Impl"
    // InternalPureXbase.g:14811:1: rule__JvmParameterizedTypeReference__Group_1__3__Impl : ( '>' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14815:1: ( ( '>' ) )
            // InternalPureXbase.g:14816:1: ( '>' )
            {
            // InternalPureXbase.g:14816:1: ( '>' )
            // InternalPureXbase.g:14817:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_3()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__3__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__4"
    // InternalPureXbase.g:14826:1: rule__JvmParameterizedTypeReference__Group_1__4 : rule__JvmParameterizedTypeReference__Group_1__4__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14830:1: ( rule__JvmParameterizedTypeReference__Group_1__4__Impl )
            // InternalPureXbase.g:14831:2: rule__JvmParameterizedTypeReference__Group_1__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__4"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__4__Impl"
    // InternalPureXbase.g:14837:1: rule__JvmParameterizedTypeReference__Group_1__4__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14841:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* ) )
            // InternalPureXbase.g:14842:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* )
            {
            // InternalPureXbase.g:14842:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* )
            // InternalPureXbase.g:14843:2: ( rule__JvmParameterizedTypeReference__Group_1_4__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4()); 
            }
            // InternalPureXbase.g:14844:2: ( rule__JvmParameterizedTypeReference__Group_1_4__0 )*
            loop123:
            do {
                int alt123=2;
                int LA123_0 = input.LA(1);

                if ( (LA123_0==44) ) {
                    int LA123_2 = input.LA(2);

                    if ( (LA123_2==RULE_ID) ) {
                        int LA123_3 = input.LA(3);

                        if ( (synpred163_InternalPureXbase()) ) {
                            alt123=1;
                        }


                    }


                }


                switch (alt123) {
            	case 1 :
            	    // InternalPureXbase.g:14844:3: rule__JvmParameterizedTypeReference__Group_1_4__0
            	    {
            	    pushFollow(FOLLOW_90);
            	    rule__JvmParameterizedTypeReference__Group_1_4__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop123;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__4__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__0"
    // InternalPureXbase.g:14853:1: rule__JvmParameterizedTypeReference__Group_1_2__0 : rule__JvmParameterizedTypeReference__Group_1_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_2__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14857:1: ( rule__JvmParameterizedTypeReference__Group_1_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_2__1 )
            // InternalPureXbase.g:14858:2: rule__JvmParameterizedTypeReference__Group_1_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_2__1
            {
            pushFollow(FOLLOW_50);
            rule__JvmParameterizedTypeReference__Group_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__0__Impl"
    // InternalPureXbase.g:14865:1: rule__JvmParameterizedTypeReference__Group_1_2__0__Impl : ( ',' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14869:1: ( ( ',' ) )
            // InternalPureXbase.g:14870:1: ( ',' )
            {
            // InternalPureXbase.g:14870:1: ( ',' )
            // InternalPureXbase.g:14871:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_2_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__1"
    // InternalPureXbase.g:14880:1: rule__JvmParameterizedTypeReference__Group_1_2__1 : rule__JvmParameterizedTypeReference__Group_1_2__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14884:1: ( rule__JvmParameterizedTypeReference__Group_1_2__1__Impl )
            // InternalPureXbase.g:14885:2: rule__JvmParameterizedTypeReference__Group_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__1__Impl"
    // InternalPureXbase.g:14891:1: rule__JvmParameterizedTypeReference__Group_1_2__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14895:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) ) )
            // InternalPureXbase.g:14896:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) )
            {
            // InternalPureXbase.g:14896:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) )
            // InternalPureXbase.g:14897:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_2_1()); 
            }
            // InternalPureXbase.g:14898:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 )
            // InternalPureXbase.g:14898:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__0"
    // InternalPureXbase.g:14907:1: rule__JvmParameterizedTypeReference__Group_1_4__0 : rule__JvmParameterizedTypeReference__Group_1_4__0__Impl rule__JvmParameterizedTypeReference__Group_1_4__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14911:1: ( rule__JvmParameterizedTypeReference__Group_1_4__0__Impl rule__JvmParameterizedTypeReference__Group_1_4__1 )
            // InternalPureXbase.g:14912:2: rule__JvmParameterizedTypeReference__Group_1_4__0__Impl rule__JvmParameterizedTypeReference__Group_1_4__1
            {
            pushFollow(FOLLOW_17);
            rule__JvmParameterizedTypeReference__Group_1_4__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__0__Impl"
    // InternalPureXbase.g:14919:1: rule__JvmParameterizedTypeReference__Group_1_4__0__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14923:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) ) )
            // InternalPureXbase.g:14924:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) )
            {
            // InternalPureXbase.g:14924:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) )
            // InternalPureXbase.g:14925:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0()); 
            }
            // InternalPureXbase.g:14926:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 )
            // InternalPureXbase.g:14926:3: rule__JvmParameterizedTypeReference__Group_1_4_0__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__1"
    // InternalPureXbase.g:14934:1: rule__JvmParameterizedTypeReference__Group_1_4__1 : rule__JvmParameterizedTypeReference__Group_1_4__1__Impl rule__JvmParameterizedTypeReference__Group_1_4__2 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14938:1: ( rule__JvmParameterizedTypeReference__Group_1_4__1__Impl rule__JvmParameterizedTypeReference__Group_1_4__2 )
            // InternalPureXbase.g:14939:2: rule__JvmParameterizedTypeReference__Group_1_4__1__Impl rule__JvmParameterizedTypeReference__Group_1_4__2
            {
            pushFollow(FOLLOW_21);
            rule__JvmParameterizedTypeReference__Group_1_4__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__1__Impl"
    // InternalPureXbase.g:14946:1: rule__JvmParameterizedTypeReference__Group_1_4__1__Impl : ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14950:1: ( ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) ) )
            // InternalPureXbase.g:14951:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) )
            {
            // InternalPureXbase.g:14951:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) )
            // InternalPureXbase.g:14952:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_1_4_1()); 
            }
            // InternalPureXbase.g:14953:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 )
            // InternalPureXbase.g:14953:3: rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_1_4_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__2"
    // InternalPureXbase.g:14961:1: rule__JvmParameterizedTypeReference__Group_1_4__2 : rule__JvmParameterizedTypeReference__Group_1_4__2__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14965:1: ( rule__JvmParameterizedTypeReference__Group_1_4__2__Impl )
            // InternalPureXbase.g:14966:2: rule__JvmParameterizedTypeReference__Group_1_4__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__2__Impl"
    // InternalPureXbase.g:14972:1: rule__JvmParameterizedTypeReference__Group_1_4__2__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14976:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? ) )
            // InternalPureXbase.g:14977:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? )
            {
            // InternalPureXbase.g:14977:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? )
            // InternalPureXbase.g:14978:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2()); 
            }
            // InternalPureXbase.g:14979:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )?
            int alt124=2;
            alt124 = dfa124.predict(input);
            switch (alt124) {
                case 1 :
                    // InternalPureXbase.g:14979:3: rule__JvmParameterizedTypeReference__Group_1_4_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmParameterizedTypeReference__Group_1_4_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__2__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0__0"
    // InternalPureXbase.g:14988:1: rule__JvmParameterizedTypeReference__Group_1_4_0__0 : rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:14992:1: ( rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl )
            // InternalPureXbase.g:14993:2: rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl"
    // InternalPureXbase.g:14999:1: rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15003:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) ) )
            // InternalPureXbase.g:15004:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) )
            {
            // InternalPureXbase.g:15004:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) )
            // InternalPureXbase.g:15005:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0_0()); 
            }
            // InternalPureXbase.g:15006:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 )
            // InternalPureXbase.g:15006:3: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0"
    // InternalPureXbase.g:15015:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 : rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_0_0__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15019:1: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_0_0__1 )
            // InternalPureXbase.g:15020:2: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_0_0__1
            {
            pushFollow(FOLLOW_89);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl"
    // InternalPureXbase.g:15027:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl : ( () ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15031:1: ( ( () ) )
            // InternalPureXbase.g:15032:1: ( () )
            {
            // InternalPureXbase.g:15032:1: ( () )
            // InternalPureXbase.g:15033:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getJvmInnerTypeReferenceOuterAction_1_4_0_0_0()); 
            }
            // InternalPureXbase.g:15034:2: ()
            // InternalPureXbase.g:15034:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getJvmInnerTypeReferenceOuterAction_1_4_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1"
    // InternalPureXbase.g:15042:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__1 : rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15046:1: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl )
            // InternalPureXbase.g:15047:2: rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl"
    // InternalPureXbase.g:15053:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl : ( '.' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15057:1: ( ( '.' ) )
            // InternalPureXbase.g:15058:1: ( '.' )
            {
            // InternalPureXbase.g:15058:1: ( '.' )
            // InternalPureXbase.g:15059:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getFullStopKeyword_1_4_0_0_1()); 
            }
            match(input,44,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getFullStopKeyword_1_4_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__0"
    // InternalPureXbase.g:15069:1: rule__JvmParameterizedTypeReference__Group_1_4_2__0 : rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15073:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__1 )
            // InternalPureXbase.g:15074:2: rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__1
            {
            pushFollow(FOLLOW_50);
            rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl"
    // InternalPureXbase.g:15081:1: rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl : ( ( '<' ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15085:1: ( ( ( '<' ) ) )
            // InternalPureXbase.g:15086:1: ( ( '<' ) )
            {
            // InternalPureXbase.g:15086:1: ( ( '<' ) )
            // InternalPureXbase.g:15087:2: ( '<' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_4_2_0()); 
            }
            // InternalPureXbase.g:15088:2: ( '<' )
            // InternalPureXbase.g:15088:3: '<'
            {
            match(input,28,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_4_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__1"
    // InternalPureXbase.g:15096:1: rule__JvmParameterizedTypeReference__Group_1_4_2__1 : rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__2 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15100:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__2 )
            // InternalPureXbase.g:15101:2: rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__2
            {
            pushFollow(FOLLOW_51);
            rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl"
    // InternalPureXbase.g:15108:1: rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15112:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) ) )
            // InternalPureXbase.g:15113:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) )
            {
            // InternalPureXbase.g:15113:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) )
            // InternalPureXbase.g:15114:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_1()); 
            }
            // InternalPureXbase.g:15115:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 )
            // InternalPureXbase.g:15115:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__2"
    // InternalPureXbase.g:15123:1: rule__JvmParameterizedTypeReference__Group_1_4_2__2 : rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__3 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15127:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__3 )
            // InternalPureXbase.g:15128:2: rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__3
            {
            pushFollow(FOLLOW_51);
            rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl"
    // InternalPureXbase.g:15135:1: rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15139:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* ) )
            // InternalPureXbase.g:15140:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* )
            {
            // InternalPureXbase.g:15140:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* )
            // InternalPureXbase.g:15141:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2_2()); 
            }
            // InternalPureXbase.g:15142:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )*
            loop125:
            do {
                int alt125=2;
                int LA125_0 = input.LA(1);

                if ( (LA125_0==55) ) {
                    alt125=1;
                }


                switch (alt125) {
            	case 1 :
            	    // InternalPureXbase.g:15142:3: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0
            	    {
            	    pushFollow(FOLLOW_52);
            	    rule__JvmParameterizedTypeReference__Group_1_4_2_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop125;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__3"
    // InternalPureXbase.g:15150:1: rule__JvmParameterizedTypeReference__Group_1_4_2__3 : rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15154:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl )
            // InternalPureXbase.g:15155:2: rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__3"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl"
    // InternalPureXbase.g:15161:1: rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl : ( '>' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15165:1: ( ( '>' ) )
            // InternalPureXbase.g:15166:1: ( '>' )
            {
            // InternalPureXbase.g:15166:1: ( '>' )
            // InternalPureXbase.g:15167:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_4_2_3()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_4_2_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0"
    // InternalPureXbase.g:15177:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 : rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2_2__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15181:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2_2__1 )
            // InternalPureXbase.g:15182:2: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2_2__1
            {
            pushFollow(FOLLOW_50);
            rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl"
    // InternalPureXbase.g:15189:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl : ( ',' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15193:1: ( ( ',' ) )
            // InternalPureXbase.g:15194:1: ( ',' )
            {
            // InternalPureXbase.g:15194:1: ( ',' )
            // InternalPureXbase.g:15195:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_4_2_2_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_4_2_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1"
    // InternalPureXbase.g:15204:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__1 : rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15208:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl )
            // InternalPureXbase.g:15209:2: rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl"
    // InternalPureXbase.g:15215:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15219:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) ) )
            // InternalPureXbase.g:15220:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) )
            {
            // InternalPureXbase.g:15220:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) )
            // InternalPureXbase.g:15221:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_2_1()); 
            }
            // InternalPureXbase.g:15222:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 )
            // InternalPureXbase.g:15222:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__0"
    // InternalPureXbase.g:15231:1: rule__JvmWildcardTypeReference__Group__0 : rule__JvmWildcardTypeReference__Group__0__Impl rule__JvmWildcardTypeReference__Group__1 ;
    public final void rule__JvmWildcardTypeReference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15235:1: ( rule__JvmWildcardTypeReference__Group__0__Impl rule__JvmWildcardTypeReference__Group__1 )
            // InternalPureXbase.g:15236:2: rule__JvmWildcardTypeReference__Group__0__Impl rule__JvmWildcardTypeReference__Group__1
            {
            pushFollow(FOLLOW_50);
            rule__JvmWildcardTypeReference__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__0"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__0__Impl"
    // InternalPureXbase.g:15243:1: rule__JvmWildcardTypeReference__Group__0__Impl : ( () ) ;
    public final void rule__JvmWildcardTypeReference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15247:1: ( ( () ) )
            // InternalPureXbase.g:15248:1: ( () )
            {
            // InternalPureXbase.g:15248:1: ( () )
            // InternalPureXbase.g:15249:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getJvmWildcardTypeReferenceAction_0()); 
            }
            // InternalPureXbase.g:15250:2: ()
            // InternalPureXbase.g:15250:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getJvmWildcardTypeReferenceAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__0__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__1"
    // InternalPureXbase.g:15258:1: rule__JvmWildcardTypeReference__Group__1 : rule__JvmWildcardTypeReference__Group__1__Impl rule__JvmWildcardTypeReference__Group__2 ;
    public final void rule__JvmWildcardTypeReference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15262:1: ( rule__JvmWildcardTypeReference__Group__1__Impl rule__JvmWildcardTypeReference__Group__2 )
            // InternalPureXbase.g:15263:2: rule__JvmWildcardTypeReference__Group__1__Impl rule__JvmWildcardTypeReference__Group__2
            {
            pushFollow(FOLLOW_93);
            rule__JvmWildcardTypeReference__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__1"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__1__Impl"
    // InternalPureXbase.g:15270:1: rule__JvmWildcardTypeReference__Group__1__Impl : ( '?' ) ;
    public final void rule__JvmWildcardTypeReference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15274:1: ( ( '?' ) )
            // InternalPureXbase.g:15275:1: ( '?' )
            {
            // InternalPureXbase.g:15275:1: ( '?' )
            // InternalPureXbase.g:15276:2: '?'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getQuestionMarkKeyword_1()); 
            }
            match(input,76,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getQuestionMarkKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__1__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__2"
    // InternalPureXbase.g:15285:1: rule__JvmWildcardTypeReference__Group__2 : rule__JvmWildcardTypeReference__Group__2__Impl ;
    public final void rule__JvmWildcardTypeReference__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15289:1: ( rule__JvmWildcardTypeReference__Group__2__Impl )
            // InternalPureXbase.g:15290:2: rule__JvmWildcardTypeReference__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__2"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__2__Impl"
    // InternalPureXbase.g:15296:1: rule__JvmWildcardTypeReference__Group__2__Impl : ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? ) ;
    public final void rule__JvmWildcardTypeReference__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15300:1: ( ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? ) )
            // InternalPureXbase.g:15301:1: ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? )
            {
            // InternalPureXbase.g:15301:1: ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? )
            // InternalPureXbase.g:15302:2: ( rule__JvmWildcardTypeReference__Alternatives_2 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getAlternatives_2()); 
            }
            // InternalPureXbase.g:15303:2: ( rule__JvmWildcardTypeReference__Alternatives_2 )?
            int alt126=2;
            int LA126_0 = input.LA(1);

            if ( (LA126_0==45||LA126_0==77) ) {
                alt126=1;
            }
            switch (alt126) {
                case 1 :
                    // InternalPureXbase.g:15303:3: rule__JvmWildcardTypeReference__Alternatives_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmWildcardTypeReference__Alternatives_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__2__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__0"
    // InternalPureXbase.g:15312:1: rule__JvmWildcardTypeReference__Group_2_0__0 : rule__JvmWildcardTypeReference__Group_2_0__0__Impl rule__JvmWildcardTypeReference__Group_2_0__1 ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15316:1: ( rule__JvmWildcardTypeReference__Group_2_0__0__Impl rule__JvmWildcardTypeReference__Group_2_0__1 )
            // InternalPureXbase.g:15317:2: rule__JvmWildcardTypeReference__Group_2_0__0__Impl rule__JvmWildcardTypeReference__Group_2_0__1
            {
            pushFollow(FOLLOW_94);
            rule__JvmWildcardTypeReference__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__0"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__0__Impl"
    // InternalPureXbase.g:15324:1: rule__JvmWildcardTypeReference__Group_2_0__0__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15328:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) ) )
            // InternalPureXbase.g:15329:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) )
            {
            // InternalPureXbase.g:15329:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) )
            // InternalPureXbase.g:15330:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_0()); 
            }
            // InternalPureXbase.g:15331:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 )
            // InternalPureXbase.g:15331:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__0__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__1"
    // InternalPureXbase.g:15339:1: rule__JvmWildcardTypeReference__Group_2_0__1 : rule__JvmWildcardTypeReference__Group_2_0__1__Impl ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15343:1: ( rule__JvmWildcardTypeReference__Group_2_0__1__Impl )
            // InternalPureXbase.g:15344:2: rule__JvmWildcardTypeReference__Group_2_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__1"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__1__Impl"
    // InternalPureXbase.g:15350:1: rule__JvmWildcardTypeReference__Group_2_0__1__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15354:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* ) )
            // InternalPureXbase.g:15355:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* )
            {
            // InternalPureXbase.g:15355:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* )
            // InternalPureXbase.g:15356:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_1()); 
            }
            // InternalPureXbase.g:15357:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )*
            loop127:
            do {
                int alt127=2;
                int LA127_0 = input.LA(1);

                if ( (LA127_0==78) ) {
                    alt127=1;
                }


                switch (alt127) {
            	case 1 :
            	    // InternalPureXbase.g:15357:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1
            	    {
            	    pushFollow(FOLLOW_95);
            	    rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop127;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__1__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__0"
    // InternalPureXbase.g:15366:1: rule__JvmWildcardTypeReference__Group_2_1__0 : rule__JvmWildcardTypeReference__Group_2_1__0__Impl rule__JvmWildcardTypeReference__Group_2_1__1 ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15370:1: ( rule__JvmWildcardTypeReference__Group_2_1__0__Impl rule__JvmWildcardTypeReference__Group_2_1__1 )
            // InternalPureXbase.g:15371:2: rule__JvmWildcardTypeReference__Group_2_1__0__Impl rule__JvmWildcardTypeReference__Group_2_1__1
            {
            pushFollow(FOLLOW_94);
            rule__JvmWildcardTypeReference__Group_2_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__0"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__0__Impl"
    // InternalPureXbase.g:15378:1: rule__JvmWildcardTypeReference__Group_2_1__0__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15382:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) ) )
            // InternalPureXbase.g:15383:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) )
            {
            // InternalPureXbase.g:15383:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) )
            // InternalPureXbase.g:15384:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_0()); 
            }
            // InternalPureXbase.g:15385:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 )
            // InternalPureXbase.g:15385:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__0__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__1"
    // InternalPureXbase.g:15393:1: rule__JvmWildcardTypeReference__Group_2_1__1 : rule__JvmWildcardTypeReference__Group_2_1__1__Impl ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15397:1: ( rule__JvmWildcardTypeReference__Group_2_1__1__Impl )
            // InternalPureXbase.g:15398:2: rule__JvmWildcardTypeReference__Group_2_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__1"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__1__Impl"
    // InternalPureXbase.g:15404:1: rule__JvmWildcardTypeReference__Group_2_1__1__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15408:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* ) )
            // InternalPureXbase.g:15409:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* )
            {
            // InternalPureXbase.g:15409:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* )
            // InternalPureXbase.g:15410:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_1()); 
            }
            // InternalPureXbase.g:15411:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )*
            loop128:
            do {
                int alt128=2;
                int LA128_0 = input.LA(1);

                if ( (LA128_0==78) ) {
                    alt128=1;
                }


                switch (alt128) {
            	case 1 :
            	    // InternalPureXbase.g:15411:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1
            	    {
            	    pushFollow(FOLLOW_95);
            	    rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop128;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__1__Impl"


    // $ANTLR start "rule__JvmUpperBound__Group__0"
    // InternalPureXbase.g:15420:1: rule__JvmUpperBound__Group__0 : rule__JvmUpperBound__Group__0__Impl rule__JvmUpperBound__Group__1 ;
    public final void rule__JvmUpperBound__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15424:1: ( rule__JvmUpperBound__Group__0__Impl rule__JvmUpperBound__Group__1 )
            // InternalPureXbase.g:15425:2: rule__JvmUpperBound__Group__0__Impl rule__JvmUpperBound__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__JvmUpperBound__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__0"


    // $ANTLR start "rule__JvmUpperBound__Group__0__Impl"
    // InternalPureXbase.g:15432:1: rule__JvmUpperBound__Group__0__Impl : ( 'extends' ) ;
    public final void rule__JvmUpperBound__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15436:1: ( ( 'extends' ) )
            // InternalPureXbase.g:15437:1: ( 'extends' )
            {
            // InternalPureXbase.g:15437:1: ( 'extends' )
            // InternalPureXbase.g:15438:2: 'extends'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getExtendsKeyword_0()); 
            }
            match(input,77,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getExtendsKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__0__Impl"


    // $ANTLR start "rule__JvmUpperBound__Group__1"
    // InternalPureXbase.g:15447:1: rule__JvmUpperBound__Group__1 : rule__JvmUpperBound__Group__1__Impl ;
    public final void rule__JvmUpperBound__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15451:1: ( rule__JvmUpperBound__Group__1__Impl )
            // InternalPureXbase.g:15452:2: rule__JvmUpperBound__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__1"


    // $ANTLR start "rule__JvmUpperBound__Group__1__Impl"
    // InternalPureXbase.g:15458:1: rule__JvmUpperBound__Group__1__Impl : ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmUpperBound__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15462:1: ( ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) ) )
            // InternalPureXbase.g:15463:1: ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) )
            {
            // InternalPureXbase.g:15463:1: ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) )
            // InternalPureXbase.g:15464:2: ( rule__JvmUpperBound__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalPureXbase.g:15465:2: ( rule__JvmUpperBound__TypeReferenceAssignment_1 )
            // InternalPureXbase.g:15465:3: rule__JvmUpperBound__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__1__Impl"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__0"
    // InternalPureXbase.g:15474:1: rule__JvmUpperBoundAnded__Group__0 : rule__JvmUpperBoundAnded__Group__0__Impl rule__JvmUpperBoundAnded__Group__1 ;
    public final void rule__JvmUpperBoundAnded__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15478:1: ( rule__JvmUpperBoundAnded__Group__0__Impl rule__JvmUpperBoundAnded__Group__1 )
            // InternalPureXbase.g:15479:2: rule__JvmUpperBoundAnded__Group__0__Impl rule__JvmUpperBoundAnded__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__JvmUpperBoundAnded__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__0"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__0__Impl"
    // InternalPureXbase.g:15486:1: rule__JvmUpperBoundAnded__Group__0__Impl : ( '&' ) ;
    public final void rule__JvmUpperBoundAnded__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15490:1: ( ( '&' ) )
            // InternalPureXbase.g:15491:1: ( '&' )
            {
            // InternalPureXbase.g:15491:1: ( '&' )
            // InternalPureXbase.g:15492:2: '&'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getAmpersandKeyword_0()); 
            }
            match(input,78,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getAmpersandKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__0__Impl"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__1"
    // InternalPureXbase.g:15501:1: rule__JvmUpperBoundAnded__Group__1 : rule__JvmUpperBoundAnded__Group__1__Impl ;
    public final void rule__JvmUpperBoundAnded__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15505:1: ( rule__JvmUpperBoundAnded__Group__1__Impl )
            // InternalPureXbase.g:15506:2: rule__JvmUpperBoundAnded__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__1"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__1__Impl"
    // InternalPureXbase.g:15512:1: rule__JvmUpperBoundAnded__Group__1__Impl : ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmUpperBoundAnded__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15516:1: ( ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) ) )
            // InternalPureXbase.g:15517:1: ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) )
            {
            // InternalPureXbase.g:15517:1: ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) )
            // InternalPureXbase.g:15518:2: ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalPureXbase.g:15519:2: ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 )
            // InternalPureXbase.g:15519:3: rule__JvmUpperBoundAnded__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__1__Impl"


    // $ANTLR start "rule__JvmLowerBound__Group__0"
    // InternalPureXbase.g:15528:1: rule__JvmLowerBound__Group__0 : rule__JvmLowerBound__Group__0__Impl rule__JvmLowerBound__Group__1 ;
    public final void rule__JvmLowerBound__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15532:1: ( rule__JvmLowerBound__Group__0__Impl rule__JvmLowerBound__Group__1 )
            // InternalPureXbase.g:15533:2: rule__JvmLowerBound__Group__0__Impl rule__JvmLowerBound__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__JvmLowerBound__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__0"


    // $ANTLR start "rule__JvmLowerBound__Group__0__Impl"
    // InternalPureXbase.g:15540:1: rule__JvmLowerBound__Group__0__Impl : ( 'super' ) ;
    public final void rule__JvmLowerBound__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15544:1: ( ( 'super' ) )
            // InternalPureXbase.g:15545:1: ( 'super' )
            {
            // InternalPureXbase.g:15545:1: ( 'super' )
            // InternalPureXbase.g:15546:2: 'super'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getSuperKeyword_0()); 
            }
            match(input,45,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getSuperKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__0__Impl"


    // $ANTLR start "rule__JvmLowerBound__Group__1"
    // InternalPureXbase.g:15555:1: rule__JvmLowerBound__Group__1 : rule__JvmLowerBound__Group__1__Impl ;
    public final void rule__JvmLowerBound__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15559:1: ( rule__JvmLowerBound__Group__1__Impl )
            // InternalPureXbase.g:15560:2: rule__JvmLowerBound__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__1"


    // $ANTLR start "rule__JvmLowerBound__Group__1__Impl"
    // InternalPureXbase.g:15566:1: rule__JvmLowerBound__Group__1__Impl : ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmLowerBound__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15570:1: ( ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) ) )
            // InternalPureXbase.g:15571:1: ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) )
            {
            // InternalPureXbase.g:15571:1: ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) )
            // InternalPureXbase.g:15572:2: ( rule__JvmLowerBound__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalPureXbase.g:15573:2: ( rule__JvmLowerBound__TypeReferenceAssignment_1 )
            // InternalPureXbase.g:15573:3: rule__JvmLowerBound__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__1__Impl"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__0"
    // InternalPureXbase.g:15582:1: rule__JvmLowerBoundAnded__Group__0 : rule__JvmLowerBoundAnded__Group__0__Impl rule__JvmLowerBoundAnded__Group__1 ;
    public final void rule__JvmLowerBoundAnded__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15586:1: ( rule__JvmLowerBoundAnded__Group__0__Impl rule__JvmLowerBoundAnded__Group__1 )
            // InternalPureXbase.g:15587:2: rule__JvmLowerBoundAnded__Group__0__Impl rule__JvmLowerBoundAnded__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__JvmLowerBoundAnded__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__0"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__0__Impl"
    // InternalPureXbase.g:15594:1: rule__JvmLowerBoundAnded__Group__0__Impl : ( '&' ) ;
    public final void rule__JvmLowerBoundAnded__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15598:1: ( ( '&' ) )
            // InternalPureXbase.g:15599:1: ( '&' )
            {
            // InternalPureXbase.g:15599:1: ( '&' )
            // InternalPureXbase.g:15600:2: '&'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getAmpersandKeyword_0()); 
            }
            match(input,78,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getAmpersandKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__0__Impl"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__1"
    // InternalPureXbase.g:15609:1: rule__JvmLowerBoundAnded__Group__1 : rule__JvmLowerBoundAnded__Group__1__Impl ;
    public final void rule__JvmLowerBoundAnded__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15613:1: ( rule__JvmLowerBoundAnded__Group__1__Impl )
            // InternalPureXbase.g:15614:2: rule__JvmLowerBoundAnded__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__1"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__1__Impl"
    // InternalPureXbase.g:15620:1: rule__JvmLowerBoundAnded__Group__1__Impl : ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmLowerBoundAnded__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15624:1: ( ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) ) )
            // InternalPureXbase.g:15625:1: ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) )
            {
            // InternalPureXbase.g:15625:1: ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) )
            // InternalPureXbase.g:15626:2: ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalPureXbase.g:15627:2: ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 )
            // InternalPureXbase.g:15627:3: rule__JvmLowerBoundAnded__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0"
    // InternalPureXbase.g:15636:1: rule__QualifiedNameWithWildcard__Group__0 : rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 ;
    public final void rule__QualifiedNameWithWildcard__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15640:1: ( rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 )
            // InternalPureXbase.g:15641:2: rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1
            {
            pushFollow(FOLLOW_89);
            rule__QualifiedNameWithWildcard__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0__Impl"
    // InternalPureXbase.g:15648:1: rule__QualifiedNameWithWildcard__Group__0__Impl : ( ruleQualifiedName ) ;
    public final void rule__QualifiedNameWithWildcard__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15652:1: ( ( ruleQualifiedName ) )
            // InternalPureXbase.g:15653:1: ( ruleQualifiedName )
            {
            // InternalPureXbase.g:15653:1: ( ruleQualifiedName )
            // InternalPureXbase.g:15654:2: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1"
    // InternalPureXbase.g:15663:1: rule__QualifiedNameWithWildcard__Group__1 : rule__QualifiedNameWithWildcard__Group__1__Impl rule__QualifiedNameWithWildcard__Group__2 ;
    public final void rule__QualifiedNameWithWildcard__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15667:1: ( rule__QualifiedNameWithWildcard__Group__1__Impl rule__QualifiedNameWithWildcard__Group__2 )
            // InternalPureXbase.g:15668:2: rule__QualifiedNameWithWildcard__Group__1__Impl rule__QualifiedNameWithWildcard__Group__2
            {
            pushFollow(FOLLOW_96);
            rule__QualifiedNameWithWildcard__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1__Impl"
    // InternalPureXbase.g:15675:1: rule__QualifiedNameWithWildcard__Group__1__Impl : ( '.' ) ;
    public final void rule__QualifiedNameWithWildcard__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15679:1: ( ( '.' ) )
            // InternalPureXbase.g:15680:1: ( '.' )
            {
            // InternalPureXbase.g:15680:1: ( '.' )
            // InternalPureXbase.g:15681:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopKeyword_1()); 
            }
            match(input,44,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__2"
    // InternalPureXbase.g:15690:1: rule__QualifiedNameWithWildcard__Group__2 : rule__QualifiedNameWithWildcard__Group__2__Impl ;
    public final void rule__QualifiedNameWithWildcard__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15694:1: ( rule__QualifiedNameWithWildcard__Group__2__Impl )
            // InternalPureXbase.g:15695:2: rule__QualifiedNameWithWildcard__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__2"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__2__Impl"
    // InternalPureXbase.g:15701:1: rule__QualifiedNameWithWildcard__Group__2__Impl : ( '*' ) ;
    public final void rule__QualifiedNameWithWildcard__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15705:1: ( ( '*' ) )
            // InternalPureXbase.g:15706:1: ( '*' )
            {
            // InternalPureXbase.g:15706:1: ( '*' )
            // InternalPureXbase.g:15707:2: '*'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getAsteriskKeyword_2()); 
            }
            match(input,37,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getAsteriskKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__2__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group__0"
    // InternalPureXbase.g:15717:1: rule__XImportDeclaration__Group__0 : rule__XImportDeclaration__Group__0__Impl rule__XImportDeclaration__Group__1 ;
    public final void rule__XImportDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15721:1: ( rule__XImportDeclaration__Group__0__Impl rule__XImportDeclaration__Group__1 )
            // InternalPureXbase.g:15722:2: rule__XImportDeclaration__Group__0__Impl rule__XImportDeclaration__Group__1
            {
            pushFollow(FOLLOW_97);
            rule__XImportDeclaration__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__0"


    // $ANTLR start "rule__XImportDeclaration__Group__0__Impl"
    // InternalPureXbase.g:15729:1: rule__XImportDeclaration__Group__0__Impl : ( 'import' ) ;
    public final void rule__XImportDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15733:1: ( ( 'import' ) )
            // InternalPureXbase.g:15734:1: ( 'import' )
            {
            // InternalPureXbase.g:15734:1: ( 'import' )
            // InternalPureXbase.g:15735:2: 'import'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportKeyword_0()); 
            }
            match(input,79,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__0__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group__1"
    // InternalPureXbase.g:15744:1: rule__XImportDeclaration__Group__1 : rule__XImportDeclaration__Group__1__Impl rule__XImportDeclaration__Group__2 ;
    public final void rule__XImportDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15748:1: ( rule__XImportDeclaration__Group__1__Impl rule__XImportDeclaration__Group__2 )
            // InternalPureXbase.g:15749:2: rule__XImportDeclaration__Group__1__Impl rule__XImportDeclaration__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__XImportDeclaration__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__1"


    // $ANTLR start "rule__XImportDeclaration__Group__1__Impl"
    // InternalPureXbase.g:15756:1: rule__XImportDeclaration__Group__1__Impl : ( ( rule__XImportDeclaration__Alternatives_1 ) ) ;
    public final void rule__XImportDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15760:1: ( ( ( rule__XImportDeclaration__Alternatives_1 ) ) )
            // InternalPureXbase.g:15761:1: ( ( rule__XImportDeclaration__Alternatives_1 ) )
            {
            // InternalPureXbase.g:15761:1: ( ( rule__XImportDeclaration__Alternatives_1 ) )
            // InternalPureXbase.g:15762:2: ( rule__XImportDeclaration__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getAlternatives_1()); 
            }
            // InternalPureXbase.g:15763:2: ( rule__XImportDeclaration__Alternatives_1 )
            // InternalPureXbase.g:15763:3: rule__XImportDeclaration__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__1__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group__2"
    // InternalPureXbase.g:15771:1: rule__XImportDeclaration__Group__2 : rule__XImportDeclaration__Group__2__Impl ;
    public final void rule__XImportDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15775:1: ( rule__XImportDeclaration__Group__2__Impl )
            // InternalPureXbase.g:15776:2: rule__XImportDeclaration__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__2"


    // $ANTLR start "rule__XImportDeclaration__Group__2__Impl"
    // InternalPureXbase.g:15782:1: rule__XImportDeclaration__Group__2__Impl : ( ( ';' )? ) ;
    public final void rule__XImportDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15786:1: ( ( ( ';' )? ) )
            // InternalPureXbase.g:15787:1: ( ( ';' )? )
            {
            // InternalPureXbase.g:15787:1: ( ( ';' )? )
            // InternalPureXbase.g:15788:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getSemicolonKeyword_2()); 
            }
            // InternalPureXbase.g:15789:2: ( ';' )?
            int alt129=2;
            int LA129_0 = input.LA(1);

            if ( (LA129_0==47) ) {
                alt129=1;
            }
            switch (alt129) {
                case 1 :
                    // InternalPureXbase.g:15789:3: ';'
                    {
                    match(input,47,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getSemicolonKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__2__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__0"
    // InternalPureXbase.g:15798:1: rule__XImportDeclaration__Group_1_0__0 : rule__XImportDeclaration__Group_1_0__0__Impl rule__XImportDeclaration__Group_1_0__1 ;
    public final void rule__XImportDeclaration__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15802:1: ( rule__XImportDeclaration__Group_1_0__0__Impl rule__XImportDeclaration__Group_1_0__1 )
            // InternalPureXbase.g:15803:2: rule__XImportDeclaration__Group_1_0__0__Impl rule__XImportDeclaration__Group_1_0__1
            {
            pushFollow(FOLLOW_98);
            rule__XImportDeclaration__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__0"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__0__Impl"
    // InternalPureXbase.g:15810:1: rule__XImportDeclaration__Group_1_0__0__Impl : ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) ) ;
    public final void rule__XImportDeclaration__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15814:1: ( ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) ) )
            // InternalPureXbase.g:15815:1: ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) )
            {
            // InternalPureXbase.g:15815:1: ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) )
            // InternalPureXbase.g:15816:2: ( rule__XImportDeclaration__StaticAssignment_1_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getStaticAssignment_1_0_0()); 
            }
            // InternalPureXbase.g:15817:2: ( rule__XImportDeclaration__StaticAssignment_1_0_0 )
            // InternalPureXbase.g:15817:3: rule__XImportDeclaration__StaticAssignment_1_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__StaticAssignment_1_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getStaticAssignment_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__0__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__1"
    // InternalPureXbase.g:15825:1: rule__XImportDeclaration__Group_1_0__1 : rule__XImportDeclaration__Group_1_0__1__Impl rule__XImportDeclaration__Group_1_0__2 ;
    public final void rule__XImportDeclaration__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15829:1: ( rule__XImportDeclaration__Group_1_0__1__Impl rule__XImportDeclaration__Group_1_0__2 )
            // InternalPureXbase.g:15830:2: rule__XImportDeclaration__Group_1_0__1__Impl rule__XImportDeclaration__Group_1_0__2
            {
            pushFollow(FOLLOW_98);
            rule__XImportDeclaration__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__1"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__1__Impl"
    // InternalPureXbase.g:15837:1: rule__XImportDeclaration__Group_1_0__1__Impl : ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? ) ;
    public final void rule__XImportDeclaration__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15841:1: ( ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? ) )
            // InternalPureXbase.g:15842:1: ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? )
            {
            // InternalPureXbase.g:15842:1: ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? )
            // InternalPureXbase.g:15843:2: ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getExtensionAssignment_1_0_1()); 
            }
            // InternalPureXbase.g:15844:2: ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )?
            int alt130=2;
            int LA130_0 = input.LA(1);

            if ( (LA130_0==86) ) {
                alt130=1;
            }
            switch (alt130) {
                case 1 :
                    // InternalPureXbase.g:15844:3: rule__XImportDeclaration__ExtensionAssignment_1_0_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__ExtensionAssignment_1_0_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getExtensionAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__1__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__2"
    // InternalPureXbase.g:15852:1: rule__XImportDeclaration__Group_1_0__2 : rule__XImportDeclaration__Group_1_0__2__Impl rule__XImportDeclaration__Group_1_0__3 ;
    public final void rule__XImportDeclaration__Group_1_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15856:1: ( rule__XImportDeclaration__Group_1_0__2__Impl rule__XImportDeclaration__Group_1_0__3 )
            // InternalPureXbase.g:15857:2: rule__XImportDeclaration__Group_1_0__2__Impl rule__XImportDeclaration__Group_1_0__3
            {
            pushFollow(FOLLOW_99);
            rule__XImportDeclaration__Group_1_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__2"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__2__Impl"
    // InternalPureXbase.g:15864:1: rule__XImportDeclaration__Group_1_0__2__Impl : ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) ) ;
    public final void rule__XImportDeclaration__Group_1_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15868:1: ( ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) ) )
            // InternalPureXbase.g:15869:1: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) )
            {
            // InternalPureXbase.g:15869:1: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) )
            // InternalPureXbase.g:15870:2: ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_0_2()); 
            }
            // InternalPureXbase.g:15871:2: ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 )
            // InternalPureXbase.g:15871:3: rule__XImportDeclaration__ImportedTypeAssignment_1_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__ImportedTypeAssignment_1_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__2__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__3"
    // InternalPureXbase.g:15879:1: rule__XImportDeclaration__Group_1_0__3 : rule__XImportDeclaration__Group_1_0__3__Impl ;
    public final void rule__XImportDeclaration__Group_1_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15883:1: ( rule__XImportDeclaration__Group_1_0__3__Impl )
            // InternalPureXbase.g:15884:2: rule__XImportDeclaration__Group_1_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__3"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__3__Impl"
    // InternalPureXbase.g:15890:1: rule__XImportDeclaration__Group_1_0__3__Impl : ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) ) ;
    public final void rule__XImportDeclaration__Group_1_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15894:1: ( ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) ) )
            // InternalPureXbase.g:15895:1: ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) )
            {
            // InternalPureXbase.g:15895:1: ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) )
            // InternalPureXbase.g:15896:2: ( rule__XImportDeclaration__Alternatives_1_0_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getAlternatives_1_0_3()); 
            }
            // InternalPureXbase.g:15897:2: ( rule__XImportDeclaration__Alternatives_1_0_3 )
            // InternalPureXbase.g:15897:3: rule__XImportDeclaration__Alternatives_1_0_3
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Alternatives_1_0_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getAlternatives_1_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__3__Impl"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__0"
    // InternalPureXbase.g:15906:1: rule__QualifiedNameInStaticImport__Group__0 : rule__QualifiedNameInStaticImport__Group__0__Impl rule__QualifiedNameInStaticImport__Group__1 ;
    public final void rule__QualifiedNameInStaticImport__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15910:1: ( rule__QualifiedNameInStaticImport__Group__0__Impl rule__QualifiedNameInStaticImport__Group__1 )
            // InternalPureXbase.g:15911:2: rule__QualifiedNameInStaticImport__Group__0__Impl rule__QualifiedNameInStaticImport__Group__1
            {
            pushFollow(FOLLOW_89);
            rule__QualifiedNameInStaticImport__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedNameInStaticImport__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__0"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__0__Impl"
    // InternalPureXbase.g:15918:1: rule__QualifiedNameInStaticImport__Group__0__Impl : ( ruleValidID ) ;
    public final void rule__QualifiedNameInStaticImport__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15922:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:15923:1: ( ruleValidID )
            {
            // InternalPureXbase.g:15923:1: ( ruleValidID )
            // InternalPureXbase.g:15924:2: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getValidIDParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getValidIDParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__1"
    // InternalPureXbase.g:15933:1: rule__QualifiedNameInStaticImport__Group__1 : rule__QualifiedNameInStaticImport__Group__1__Impl ;
    public final void rule__QualifiedNameInStaticImport__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15937:1: ( rule__QualifiedNameInStaticImport__Group__1__Impl )
            // InternalPureXbase.g:15938:2: rule__QualifiedNameInStaticImport__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameInStaticImport__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__1"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__1__Impl"
    // InternalPureXbase.g:15944:1: rule__QualifiedNameInStaticImport__Group__1__Impl : ( '.' ) ;
    public final void rule__QualifiedNameInStaticImport__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15948:1: ( ( '.' ) )
            // InternalPureXbase.g:15949:1: ( '.' )
            {
            // InternalPureXbase.g:15949:1: ( '.' )
            // InternalPureXbase.g:15950:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getFullStopKeyword_1()); 
            }
            match(input,44,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getFullStopKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__1__Impl"


    // $ANTLR start "rule__Model__ImportSectionAssignment_0"
    // InternalPureXbase.g:15960:1: rule__Model__ImportSectionAssignment_0 : ( ruleXImportSection ) ;
    public final void rule__Model__ImportSectionAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15964:1: ( ( ruleXImportSection ) )
            // InternalPureXbase.g:15965:2: ( ruleXImportSection )
            {
            // InternalPureXbase.g:15965:2: ( ruleXImportSection )
            // InternalPureXbase.g:15966:3: ruleXImportSection
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getModelAccess().getImportSectionXImportSectionParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXImportSection();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getModelAccess().getImportSectionXImportSectionParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__ImportSectionAssignment_0"


    // $ANTLR start "rule__Model__BlockAssignment_1"
    // InternalPureXbase.g:15975:1: rule__Model__BlockAssignment_1 : ( ruleSpecialBlockExpression ) ;
    public final void rule__Model__BlockAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15979:1: ( ( ruleSpecialBlockExpression ) )
            // InternalPureXbase.g:15980:2: ( ruleSpecialBlockExpression )
            {
            // InternalPureXbase.g:15980:2: ( ruleSpecialBlockExpression )
            // InternalPureXbase.g:15981:3: ruleSpecialBlockExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getModelAccess().getBlockSpecialBlockExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleSpecialBlockExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getModelAccess().getBlockSpecialBlockExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__BlockAssignment_1"


    // $ANTLR start "rule__SpecialBlockExpression__ExpressionsAssignment_1_0"
    // InternalPureXbase.g:15990:1: rule__SpecialBlockExpression__ExpressionsAssignment_1_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__SpecialBlockExpression__ExpressionsAssignment_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:15994:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalPureXbase.g:15995:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalPureXbase.g:15995:2: ( ruleXExpressionOrVarDeclaration )
            // InternalPureXbase.g:15996:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getSpecialBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getSpecialBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SpecialBlockExpression__ExpressionsAssignment_1_0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1"
    // InternalPureXbase.g:16005:1: rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1 : ( ruleInitialisedVariableDeclaration ) ;
    public final void rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16009:1: ( ( ruleInitialisedVariableDeclaration ) )
            // InternalPureXbase.g:16010:2: ( ruleInitialisedVariableDeclaration )
            {
            // InternalPureXbase.g:16010:2: ( ruleInitialisedVariableDeclaration )
            // InternalPureXbase.g:16011:3: ruleInitialisedVariableDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesInitialisedVariableDeclarationParserRuleCall_2_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleInitialisedVariableDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesInitialisedVariableDeclarationParserRuleCall_2_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1"
    // InternalPureXbase.g:16020:1: rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1 : ( ruleInitialisedVariableDeclaration ) ;
    public final void rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16024:1: ( ( ruleInitialisedVariableDeclaration ) )
            // InternalPureXbase.g:16025:2: ( ruleInitialisedVariableDeclaration )
            {
            // InternalPureXbase.g:16025:2: ( ruleInitialisedVariableDeclaration )
            // InternalPureXbase.g:16026:3: ruleInitialisedVariableDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesInitialisedVariableDeclarationParserRuleCall_2_0_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleInitialisedVariableDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getResourcesInitialisedVariableDeclarationParserRuleCall_2_0_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__ResourcesAssignment_2_0_2_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5"
    // InternalPureXbase.g:16035:1: rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16039:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16040:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16040:2: ( ruleXExpression )
            // InternalPureXbase.g:16041:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_0_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_0_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__ExpressionAssignment_2_0_5"


    // $ANTLR start "rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0"
    // InternalPureXbase.g:16050:1: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 : ( ruleXCatchClause ) ;
    public final void rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16054:1: ( ( ruleXCatchClause ) )
            // InternalPureXbase.g:16055:2: ( ruleXCatchClause )
            {
            // InternalPureXbase.g:16055:2: ( ruleXCatchClause )
            // InternalPureXbase.g:16056:3: ruleXCatchClause
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_2_0_6_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXCatchClause();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_2_0_6_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1"
    // InternalPureXbase.g:16065:1: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16069:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16070:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16070:2: ( ruleXExpression )
            // InternalPureXbase.g:16071:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_0_6_0_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_0_6_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_0_1_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1"
    // InternalPureXbase.g:16080:1: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16084:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16085:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16085:2: ( ruleXExpression )
            // InternalPureXbase.g:16086:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_0_6_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_0_6_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_0_6_0_1_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0"
    // InternalPureXbase.g:16095:1: rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16099:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16100:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16100:2: ( ruleXExpression )
            // InternalPureXbase.g:16101:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__ExpressionAssignment_2_1_0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0"
    // InternalPureXbase.g:16110:1: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 : ( ruleXCatchClause ) ;
    public final void rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16114:1: ( ( ruleXCatchClause ) )
            // InternalPureXbase.g:16115:2: ( ruleXCatchClause )
            {
            // InternalPureXbase.g:16115:2: ( ruleXCatchClause )
            // InternalPureXbase.g:16116:3: ruleXCatchClause
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_2_1_1_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXCatchClause();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_2_1_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1"
    // InternalPureXbase.g:16125:1: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16129:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16130:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16130:2: ( ruleXExpression )
            // InternalPureXbase.g:16131:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_1_1_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_1_1_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_0_1_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1"
    // InternalPureXbase.g:16140:1: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16144:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16145:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16145:2: ( ruleXExpression )
            // InternalPureXbase.g:16146:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_2_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_2_1_1_1_1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__WriteableAssignment_1_0"
    // InternalPureXbase.g:16155:1: rule__InitialisedVariableDeclaration__WriteableAssignment_1_0 : ( ( 'var' ) ) ;
    public final void rule__InitialisedVariableDeclaration__WriteableAssignment_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16159:1: ( ( ( 'var' ) ) )
            // InternalPureXbase.g:16160:2: ( ( 'var' ) )
            {
            // InternalPureXbase.g:16160:2: ( ( 'var' ) )
            // InternalPureXbase.g:16161:3: ( 'var' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }
            // InternalPureXbase.g:16162:3: ( 'var' )
            // InternalPureXbase.g:16163:4: 'var'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }
            match(input,80,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__WriteableAssignment_1_0"


    // $ANTLR start "rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0"
    // InternalPureXbase.g:16174:1: rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0 : ( ruleJvmTypeReference ) ;
    public final void rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16178:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:16179:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:16179:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:16180:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__TypeAssignment_2_0_0_0"


    // $ANTLR start "rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1"
    // InternalPureXbase.g:16189:1: rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1 : ( ruleValidID ) ;
    public final void rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16193:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:16194:2: ( ruleValidID )
            {
            // InternalPureXbase.g:16194:2: ( ruleValidID )
            // InternalPureXbase.g:16195:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getNameValidIDParserRuleCall_2_0_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getNameValidIDParserRuleCall_2_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__NameAssignment_2_0_0_1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__NameAssignment_2_1"
    // InternalPureXbase.g:16204:1: rule__InitialisedVariableDeclaration__NameAssignment_2_1 : ( ruleValidID ) ;
    public final void rule__InitialisedVariableDeclaration__NameAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16208:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:16209:2: ( ruleValidID )
            {
            // InternalPureXbase.g:16209:2: ( ruleValidID )
            // InternalPureXbase.g:16210:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getNameValidIDParserRuleCall_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getNameValidIDParserRuleCall_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__NameAssignment_2_1"


    // $ANTLR start "rule__InitialisedVariableDeclaration__RightAssignment_4"
    // InternalPureXbase.g:16219:1: rule__InitialisedVariableDeclaration__RightAssignment_4 : ( ruleXExpression ) ;
    public final void rule__InitialisedVariableDeclaration__RightAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16223:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16224:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16224:2: ( ruleXExpression )
            // InternalPureXbase.g:16225:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getInitialisedVariableDeclarationAccess().getRightXExpressionParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getInitialisedVariableDeclarationAccess().getRightXExpressionParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__InitialisedVariableDeclaration__RightAssignment_4"


    // $ANTLR start "rule__XAssignment__FeatureAssignment_0_1"
    // InternalPureXbase.g:16234:1: rule__XAssignment__FeatureAssignment_0_1 : ( ( ruleFeatureCallID ) ) ;
    public final void rule__XAssignment__FeatureAssignment_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16238:1: ( ( ( ruleFeatureCallID ) ) )
            // InternalPureXbase.g:16239:2: ( ( ruleFeatureCallID ) )
            {
            // InternalPureXbase.g:16239:2: ( ( ruleFeatureCallID ) )
            // InternalPureXbase.g:16240:3: ( ruleFeatureCallID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }
            // InternalPureXbase.g:16241:3: ( ruleFeatureCallID )
            // InternalPureXbase.g:16242:4: ruleFeatureCallID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__FeatureAssignment_0_1"


    // $ANTLR start "rule__XAssignment__ValueAssignment_0_3"
    // InternalPureXbase.g:16253:1: rule__XAssignment__ValueAssignment_0_3 : ( ruleXAssignment ) ;
    public final void rule__XAssignment__ValueAssignment_0_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16257:1: ( ( ruleXAssignment ) )
            // InternalPureXbase.g:16258:2: ( ruleXAssignment )
            {
            // InternalPureXbase.g:16258:2: ( ruleXAssignment )
            // InternalPureXbase.g:16259:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getValueXAssignmentParserRuleCall_0_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getValueXAssignmentParserRuleCall_0_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__ValueAssignment_0_3"


    // $ANTLR start "rule__XAssignment__FeatureAssignment_1_1_0_0_1"
    // InternalPureXbase.g:16268:1: rule__XAssignment__FeatureAssignment_1_1_0_0_1 : ( ( ruleOpMultiAssign ) ) ;
    public final void rule__XAssignment__FeatureAssignment_1_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16272:1: ( ( ( ruleOpMultiAssign ) ) )
            // InternalPureXbase.g:16273:2: ( ( ruleOpMultiAssign ) )
            {
            // InternalPureXbase.g:16273:2: ( ( ruleOpMultiAssign ) )
            // InternalPureXbase.g:16274:3: ( ruleOpMultiAssign )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16275:3: ( ruleOpMultiAssign )
            // InternalPureXbase.g:16276:4: ruleOpMultiAssign
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementOpMultiAssignParserRuleCall_1_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpMultiAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementOpMultiAssignParserRuleCall_1_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__FeatureAssignment_1_1_0_0_1"


    // $ANTLR start "rule__XAssignment__RightOperandAssignment_1_1_1"
    // InternalPureXbase.g:16287:1: rule__XAssignment__RightOperandAssignment_1_1_1 : ( ruleXAssignment ) ;
    public final void rule__XAssignment__RightOperandAssignment_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16291:1: ( ( ruleXAssignment ) )
            // InternalPureXbase.g:16292:2: ( ruleXAssignment )
            {
            // InternalPureXbase.g:16292:2: ( ruleXAssignment )
            // InternalPureXbase.g:16293:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getRightOperandXAssignmentParserRuleCall_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getRightOperandXAssignmentParserRuleCall_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__RightOperandAssignment_1_1_1"


    // $ANTLR start "rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1"
    // InternalPureXbase.g:16302:1: rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1 : ( ( '?' ) ) ;
    public final void rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16306:1: ( ( ( '?' ) ) )
            // InternalPureXbase.g:16307:2: ( ( '?' ) )
            {
            // InternalPureXbase.g:16307:2: ( ( '?' ) )
            // InternalPureXbase.g:16308:3: ( '?' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getConditionalExpressionQuestionMarkKeyword_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16309:3: ( '?' )
            // InternalPureXbase.g:16310:4: '?'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getConditionalExpressionQuestionMarkKeyword_1_0_0_1_0()); 
            }
            match(input,76,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getConditionalExpressionQuestionMarkKeyword_1_0_0_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getConditionalExpressionQuestionMarkKeyword_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__ConditionalExpressionAssignment_1_0_0_1"


    // $ANTLR start "rule__XConditionalExpression__ThenAssignment_1_1"
    // InternalPureXbase.g:16321:1: rule__XConditionalExpression__ThenAssignment_1_1 : ( ruleXExpression ) ;
    public final void rule__XConditionalExpression__ThenAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16325:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16326:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16326:2: ( ruleXExpression )
            // InternalPureXbase.g:16327:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getThenXExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getThenXExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__ThenAssignment_1_1"


    // $ANTLR start "rule__XConditionalExpression__ElseAssignment_1_2_1"
    // InternalPureXbase.g:16336:1: rule__XConditionalExpression__ElseAssignment_1_2_1 : ( ruleXExpression ) ;
    public final void rule__XConditionalExpression__ElseAssignment_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16340:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16341:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16341:2: ( ruleXExpression )
            // InternalPureXbase.g:16342:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConditionalExpressionAccess().getElseXExpressionParserRuleCall_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConditionalExpressionAccess().getElseXExpressionParserRuleCall_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConditionalExpression__ElseAssignment_1_2_1"


    // $ANTLR start "rule__XOrExpression__FeatureAssignment_1_0_0_1"
    // InternalPureXbase.g:16351:1: rule__XOrExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpOr ) ) ;
    public final void rule__XOrExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16355:1: ( ( ( ruleOpOr ) ) )
            // InternalPureXbase.g:16356:2: ( ( ruleOpOr ) )
            {
            // InternalPureXbase.g:16356:2: ( ( ruleOpOr ) )
            // InternalPureXbase.g:16357:3: ( ruleOpOr )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16358:3: ( ruleOpOr )
            // InternalPureXbase.g:16359:4: ruleOpOr
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementOpOrParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpOr();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementOpOrParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XOrExpression__RightOperandAssignment_1_1"
    // InternalPureXbase.g:16370:1: rule__XOrExpression__RightOperandAssignment_1_1 : ( ruleXAndExpression ) ;
    public final void rule__XOrExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16374:1: ( ( ruleXAndExpression ) )
            // InternalPureXbase.g:16375:2: ( ruleXAndExpression )
            {
            // InternalPureXbase.g:16375:2: ( ruleXAndExpression )
            // InternalPureXbase.g:16376:3: ruleXAndExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getRightOperandXAndExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAndExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getRightOperandXAndExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XAndExpression__FeatureAssignment_1_0_0_1"
    // InternalPureXbase.g:16385:1: rule__XAndExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpAnd ) ) ;
    public final void rule__XAndExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16389:1: ( ( ( ruleOpAnd ) ) )
            // InternalPureXbase.g:16390:2: ( ( ruleOpAnd ) )
            {
            // InternalPureXbase.g:16390:2: ( ( ruleOpAnd ) )
            // InternalPureXbase.g:16391:3: ( ruleOpAnd )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16392:3: ( ruleOpAnd )
            // InternalPureXbase.g:16393:4: ruleOpAnd
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementOpAndParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpAnd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementOpAndParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XAndExpression__RightOperandAssignment_1_1"
    // InternalPureXbase.g:16404:1: rule__XAndExpression__RightOperandAssignment_1_1 : ( ruleXEqualityExpression ) ;
    public final void rule__XAndExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16408:1: ( ( ruleXEqualityExpression ) )
            // InternalPureXbase.g:16409:2: ( ruleXEqualityExpression )
            {
            // InternalPureXbase.g:16409:2: ( ruleXEqualityExpression )
            // InternalPureXbase.g:16410:3: ruleXEqualityExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getRightOperandXEqualityExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getRightOperandXEqualityExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XEqualityExpression__FeatureAssignment_1_0_0_1"
    // InternalPureXbase.g:16419:1: rule__XEqualityExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpEquality ) ) ;
    public final void rule__XEqualityExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16423:1: ( ( ( ruleOpEquality ) ) )
            // InternalPureXbase.g:16424:2: ( ( ruleOpEquality ) )
            {
            // InternalPureXbase.g:16424:2: ( ( ruleOpEquality ) )
            // InternalPureXbase.g:16425:3: ( ruleOpEquality )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16426:3: ( ruleOpEquality )
            // InternalPureXbase.g:16427:4: ruleOpEquality
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementOpEqualityParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpEquality();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementOpEqualityParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XEqualityExpression__RightOperandAssignment_1_1"
    // InternalPureXbase.g:16438:1: rule__XEqualityExpression__RightOperandAssignment_1_1 : ( ruleXRelationalExpression ) ;
    public final void rule__XEqualityExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16442:1: ( ( ruleXRelationalExpression ) )
            // InternalPureXbase.g:16443:2: ( ruleXRelationalExpression )
            {
            // InternalPureXbase.g:16443:2: ( ruleXRelationalExpression )
            // InternalPureXbase.g:16444:3: ruleXRelationalExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getRightOperandXRelationalExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getRightOperandXRelationalExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XRelationalExpression__TypeAssignment_1_0_1"
    // InternalPureXbase.g:16453:1: rule__XRelationalExpression__TypeAssignment_1_0_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XRelationalExpression__TypeAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16457:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:16458:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:16458:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:16459:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__TypeAssignment_1_0_1"


    // $ANTLR start "rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1"
    // InternalPureXbase.g:16468:1: rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 : ( ( ruleOpCompare ) ) ;
    public final void rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16472:1: ( ( ( ruleOpCompare ) ) )
            // InternalPureXbase.g:16473:2: ( ( ruleOpCompare ) )
            {
            // InternalPureXbase.g:16473:2: ( ( ruleOpCompare ) )
            // InternalPureXbase.g:16474:3: ( ruleOpCompare )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16475:3: ( ruleOpCompare )
            // InternalPureXbase.g:16476:4: ruleOpCompare
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementOpCompareParserRuleCall_1_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpCompare();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementOpCompareParserRuleCall_1_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1"


    // $ANTLR start "rule__XRelationalExpression__RightOperandAssignment_1_1_1"
    // InternalPureXbase.g:16487:1: rule__XRelationalExpression__RightOperandAssignment_1_1_1 : ( ruleXOtherOperatorExpression ) ;
    public final void rule__XRelationalExpression__RightOperandAssignment_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16491:1: ( ( ruleXOtherOperatorExpression ) )
            // InternalPureXbase.g:16492:2: ( ruleXOtherOperatorExpression )
            {
            // InternalPureXbase.g:16492:2: ( ruleXOtherOperatorExpression )
            // InternalPureXbase.g:16493:3: ruleXOtherOperatorExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getRightOperandXOtherOperatorExpressionParserRuleCall_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getRightOperandXOtherOperatorExpressionParserRuleCall_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__RightOperandAssignment_1_1_1"


    // $ANTLR start "rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1"
    // InternalPureXbase.g:16502:1: rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpOther ) ) ;
    public final void rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16506:1: ( ( ( ruleOpOther ) ) )
            // InternalPureXbase.g:16507:2: ( ( ruleOpOther ) )
            {
            // InternalPureXbase.g:16507:2: ( ( ruleOpOther ) )
            // InternalPureXbase.g:16508:3: ( ruleOpOther )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16509:3: ( ruleOpOther )
            // InternalPureXbase.g:16510:4: ruleOpOther
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementOpOtherParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpOther();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementOpOtherParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XOtherOperatorExpression__RightOperandAssignment_1_1"
    // InternalPureXbase.g:16521:1: rule__XOtherOperatorExpression__RightOperandAssignment_1_1 : ( ruleXAdditiveExpression ) ;
    public final void rule__XOtherOperatorExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16525:1: ( ( ruleXAdditiveExpression ) )
            // InternalPureXbase.g:16526:2: ( ruleXAdditiveExpression )
            {
            // InternalPureXbase.g:16526:2: ( ruleXAdditiveExpression )
            // InternalPureXbase.g:16527:3: ruleXAdditiveExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandXAdditiveExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandXAdditiveExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XAdditiveExpression__FeatureAssignment_1_0_0_1"
    // InternalPureXbase.g:16536:1: rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpAdd ) ) ;
    public final void rule__XAdditiveExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16540:1: ( ( ( ruleOpAdd ) ) )
            // InternalPureXbase.g:16541:2: ( ( ruleOpAdd ) )
            {
            // InternalPureXbase.g:16541:2: ( ( ruleOpAdd ) )
            // InternalPureXbase.g:16542:3: ( ruleOpAdd )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16543:3: ( ruleOpAdd )
            // InternalPureXbase.g:16544:4: ruleOpAdd
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementOpAddParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpAdd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementOpAddParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XAdditiveExpression__RightOperandAssignment_1_1"
    // InternalPureXbase.g:16555:1: rule__XAdditiveExpression__RightOperandAssignment_1_1 : ( ruleXMultiplicativeExpression ) ;
    public final void rule__XAdditiveExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16559:1: ( ( ruleXMultiplicativeExpression ) )
            // InternalPureXbase.g:16560:2: ( ruleXMultiplicativeExpression )
            {
            // InternalPureXbase.g:16560:2: ( ruleXMultiplicativeExpression )
            // InternalPureXbase.g:16561:3: ruleXMultiplicativeExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getRightOperandXMultiplicativeExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getRightOperandXMultiplicativeExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1"
    // InternalPureXbase.g:16570:1: rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpMulti ) ) ;
    public final void rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16574:1: ( ( ( ruleOpMulti ) ) )
            // InternalPureXbase.g:16575:2: ( ( ruleOpMulti ) )
            {
            // InternalPureXbase.g:16575:2: ( ( ruleOpMulti ) )
            // InternalPureXbase.g:16576:3: ( ruleOpMulti )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalPureXbase.g:16577:3: ( ruleOpMulti )
            // InternalPureXbase.g:16578:4: ruleOpMulti
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementOpMultiParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpMulti();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementOpMultiParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XMultiplicativeExpression__RightOperandAssignment_1_1"
    // InternalPureXbase.g:16589:1: rule__XMultiplicativeExpression__RightOperandAssignment_1_1 : ( ruleXUnaryOperation ) ;
    public final void rule__XMultiplicativeExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16593:1: ( ( ruleXUnaryOperation ) )
            // InternalPureXbase.g:16594:2: ( ruleXUnaryOperation )
            {
            // InternalPureXbase.g:16594:2: ( ruleXUnaryOperation )
            // InternalPureXbase.g:16595:3: ruleXUnaryOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandXUnaryOperationParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandXUnaryOperationParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XUnaryOperation__FeatureAssignment_0_1"
    // InternalPureXbase.g:16604:1: rule__XUnaryOperation__FeatureAssignment_0_1 : ( ( ruleOpUnary ) ) ;
    public final void rule__XUnaryOperation__FeatureAssignment_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16608:1: ( ( ( ruleOpUnary ) ) )
            // InternalPureXbase.g:16609:2: ( ( ruleOpUnary ) )
            {
            // InternalPureXbase.g:16609:2: ( ( ruleOpUnary ) )
            // InternalPureXbase.g:16610:3: ( ruleOpUnary )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }
            // InternalPureXbase.g:16611:3: ( ruleOpUnary )
            // InternalPureXbase.g:16612:4: ruleOpUnary
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementOpUnaryParserRuleCall_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpUnary();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementOpUnaryParserRuleCall_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__FeatureAssignment_0_1"


    // $ANTLR start "rule__XUnaryOperation__OperandAssignment_0_2"
    // InternalPureXbase.g:16623:1: rule__XUnaryOperation__OperandAssignment_0_2 : ( ruleXUnaryOperation ) ;
    public final void rule__XUnaryOperation__OperandAssignment_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16627:1: ( ( ruleXUnaryOperation ) )
            // InternalPureXbase.g:16628:2: ( ruleXUnaryOperation )
            {
            // InternalPureXbase.g:16628:2: ( ruleXUnaryOperation )
            // InternalPureXbase.g:16629:3: ruleXUnaryOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getOperandXUnaryOperationParserRuleCall_0_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getOperandXUnaryOperationParserRuleCall_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__OperandAssignment_0_2"


    // $ANTLR start "rule__XCastedExpression__TypeAssignment_1_1"
    // InternalPureXbase.g:16638:1: rule__XCastedExpression__TypeAssignment_1_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XCastedExpression__TypeAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16642:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:16643:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:16643:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:16644:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__TypeAssignment_1_1"


    // $ANTLR start "rule__XPostfixOperation__FeatureAssignment_1_0_1"
    // InternalPureXbase.g:16653:1: rule__XPostfixOperation__FeatureAssignment_1_0_1 : ( ( ruleOpPostfix ) ) ;
    public final void rule__XPostfixOperation__FeatureAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16657:1: ( ( ( ruleOpPostfix ) ) )
            // InternalPureXbase.g:16658:2: ( ( ruleOpPostfix ) )
            {
            // InternalPureXbase.g:16658:2: ( ( ruleOpPostfix ) )
            // InternalPureXbase.g:16659:3: ( ruleOpPostfix )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_1_0()); 
            }
            // InternalPureXbase.g:16660:3: ( ruleOpPostfix )
            // InternalPureXbase.g:16661:4: ruleOpPostfix
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementOpPostfixParserRuleCall_1_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpPostfix();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementOpPostfixParserRuleCall_1_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__FeatureAssignment_1_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1"
    // InternalPureXbase.g:16672:1: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 : ( ( '::' ) ) ;
    public final void rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16676:1: ( ( ( '::' ) ) )
            // InternalPureXbase.g:16677:2: ( ( '::' ) )
            {
            // InternalPureXbase.g:16677:2: ( ( '::' ) )
            // InternalPureXbase.g:16678:3: ( '::' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }
            // InternalPureXbase.g:16679:3: ( '::' )
            // InternalPureXbase.g:16680:4: '::'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }
            match(input,81,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2"
    // InternalPureXbase.g:16691:1: rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 : ( ( ruleFeatureCallID ) ) ;
    public final void rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16695:1: ( ( ( ruleFeatureCallID ) ) )
            // InternalPureXbase.g:16696:2: ( ( ruleFeatureCallID ) )
            {
            // InternalPureXbase.g:16696:2: ( ( ruleFeatureCallID ) )
            // InternalPureXbase.g:16697:3: ( ruleFeatureCallID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_0_2_0()); 
            }
            // InternalPureXbase.g:16698:3: ( ruleFeatureCallID )
            // InternalPureXbase.g:16699:4: ruleFeatureCallID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_1_0_0_0_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_1_0_0_0_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2"


    // $ANTLR start "rule__XMemberFeatureCall__ValueAssignment_1_0_1"
    // InternalPureXbase.g:16710:1: rule__XMemberFeatureCall__ValueAssignment_1_0_1 : ( ruleXAssignment ) ;
    public final void rule__XMemberFeatureCall__ValueAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16714:1: ( ( ruleXAssignment ) )
            // InternalPureXbase.g:16715:2: ( ruleXAssignment )
            {
            // InternalPureXbase.g:16715:2: ( ruleXAssignment )
            // InternalPureXbase.g:16716:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getValueXAssignmentParserRuleCall_1_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getValueXAssignmentParserRuleCall_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ValueAssignment_1_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1"
    // InternalPureXbase.g:16725:1: rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 : ( ( '?.' ) ) ;
    public final void rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16729:1: ( ( ( '?.' ) ) )
            // InternalPureXbase.g:16730:2: ( ( '?.' ) )
            {
            // InternalPureXbase.g:16730:2: ( ( '?.' ) )
            // InternalPureXbase.g:16731:3: ( '?.' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }
            // InternalPureXbase.g:16732:3: ( '?.' )
            // InternalPureXbase.g:16733:4: '?.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }
            match(input,82,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2"
    // InternalPureXbase.g:16744:1: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 : ( ( '::' ) ) ;
    public final void rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16748:1: ( ( ( '::' ) ) )
            // InternalPureXbase.g:16749:2: ( ( '::' ) )
            {
            // InternalPureXbase.g:16749:2: ( ( '::' ) )
            // InternalPureXbase.g:16750:3: ( '::' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }
            // InternalPureXbase.g:16751:3: ( '::' )
            // InternalPureXbase.g:16752:4: '::'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }
            match(input,81,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2"


    // $ANTLR start "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1"
    // InternalPureXbase.g:16763:1: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16767:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:16768:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:16768:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:16769:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1"
    // InternalPureXbase.g:16778:1: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16782:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:16783:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:16783:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:16784:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1"


    // $ANTLR start "rule__XMemberFeatureCall__FeatureAssignment_1_1_2"
    // InternalPureXbase.g:16793:1: rule__XMemberFeatureCall__FeatureAssignment_1_1_2 : ( ( ruleIdOrSuper ) ) ;
    public final void rule__XMemberFeatureCall__FeatureAssignment_1_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16797:1: ( ( ( ruleIdOrSuper ) ) )
            // InternalPureXbase.g:16798:2: ( ( ruleIdOrSuper ) )
            {
            // InternalPureXbase.g:16798:2: ( ( ruleIdOrSuper ) )
            // InternalPureXbase.g:16799:3: ( ruleIdOrSuper )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_2_0()); 
            }
            // InternalPureXbase.g:16800:3: ( ruleIdOrSuper )
            // InternalPureXbase.g:16801:4: ruleIdOrSuper
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_1_1_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_1_1_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__FeatureAssignment_1_1_2"


    // $ANTLR start "rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0"
    // InternalPureXbase.g:16812:1: rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 : ( ( '(' ) ) ;
    public final void rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16816:1: ( ( ( '(' ) ) )
            // InternalPureXbase.g:16817:2: ( ( '(' ) )
            {
            // InternalPureXbase.g:16817:2: ( ( '(' ) )
            // InternalPureXbase.g:16818:3: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }
            // InternalPureXbase.g:16819:3: ( '(' )
            // InternalPureXbase.g:16820:4: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0"
    // InternalPureXbase.g:16831:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 : ( ruleXShortClosure ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16835:1: ( ( ruleXShortClosure ) )
            // InternalPureXbase.g:16836:2: ( ruleXShortClosure )
            {
            // InternalPureXbase.g:16836:2: ( ruleXShortClosure )
            // InternalPureXbase.g:16837:3: ruleXShortClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXShortClosureParserRuleCall_1_1_3_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXShortClosureParserRuleCall_1_1_3_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0"
    // InternalPureXbase.g:16846:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 : ( ruleXExpression ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16850:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16851:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16851:2: ( ruleXExpression )
            // InternalPureXbase.g:16852:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1"
    // InternalPureXbase.g:16861:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16865:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16866:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16866:2: ( ruleXExpression )
            // InternalPureXbase.g:16867:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4"
    // InternalPureXbase.g:16876:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 : ( ruleXClosure ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16880:1: ( ( ruleXClosure ) )
            // InternalPureXbase.g:16881:2: ( ruleXClosure )
            {
            // InternalPureXbase.g:16881:2: ( ruleXClosure )
            // InternalPureXbase.g:16882:3: ruleXClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXClosureParserRuleCall_1_1_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXClosureParserRuleCall_1_1_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4"


    // $ANTLR start "rule__XSetLiteral__ElementsAssignment_3_0"
    // InternalPureXbase.g:16891:1: rule__XSetLiteral__ElementsAssignment_3_0 : ( ruleXExpression ) ;
    public final void rule__XSetLiteral__ElementsAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16895:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16896:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16896:2: ( ruleXExpression )
            // InternalPureXbase.g:16897:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__ElementsAssignment_3_0"


    // $ANTLR start "rule__XSetLiteral__ElementsAssignment_3_1_1"
    // InternalPureXbase.g:16906:1: rule__XSetLiteral__ElementsAssignment_3_1_1 : ( ruleXExpression ) ;
    public final void rule__XSetLiteral__ElementsAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16910:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16911:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16911:2: ( ruleXExpression )
            // InternalPureXbase.g:16912:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__ElementsAssignment_3_1_1"


    // $ANTLR start "rule__XListLiteral__ElementsAssignment_3_0"
    // InternalPureXbase.g:16921:1: rule__XListLiteral__ElementsAssignment_3_0 : ( ruleXExpression ) ;
    public final void rule__XListLiteral__ElementsAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16925:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16926:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16926:2: ( ruleXExpression )
            // InternalPureXbase.g:16927:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__ElementsAssignment_3_0"


    // $ANTLR start "rule__XListLiteral__ElementsAssignment_3_1_1"
    // InternalPureXbase.g:16936:1: rule__XListLiteral__ElementsAssignment_3_1_1 : ( ruleXExpression ) ;
    public final void rule__XListLiteral__ElementsAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16940:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:16941:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:16941:2: ( ruleXExpression )
            // InternalPureXbase.g:16942:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__ElementsAssignment_3_1_1"


    // $ANTLR start "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0"
    // InternalPureXbase.g:16951:1: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 : ( ruleJvmFormalParameter ) ;
    public final void rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16955:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:16956:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:16956:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:16957:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0"


    // $ANTLR start "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1"
    // InternalPureXbase.g:16966:1: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 : ( ruleJvmFormalParameter ) ;
    public final void rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16970:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:16971:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:16971:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:16972:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1"


    // $ANTLR start "rule__XClosure__ExplicitSyntaxAssignment_1_0_1"
    // InternalPureXbase.g:16981:1: rule__XClosure__ExplicitSyntaxAssignment_1_0_1 : ( ( '|' ) ) ;
    public final void rule__XClosure__ExplicitSyntaxAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:16985:1: ( ( ( '|' ) ) )
            // InternalPureXbase.g:16986:2: ( ( '|' ) )
            {
            // InternalPureXbase.g:16986:2: ( ( '|' ) )
            // InternalPureXbase.g:16987:3: ( '|' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }
            // InternalPureXbase.g:16988:3: ( '|' )
            // InternalPureXbase.g:16989:4: '|'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }
            match(input,83,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__ExplicitSyntaxAssignment_1_0_1"


    // $ANTLR start "rule__XClosure__ExpressionAssignment_2"
    // InternalPureXbase.g:17000:1: rule__XClosure__ExpressionAssignment_2 : ( ruleXExpressionInClosure ) ;
    public final void rule__XClosure__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17004:1: ( ( ruleXExpressionInClosure ) )
            // InternalPureXbase.g:17005:2: ( ruleXExpressionInClosure )
            {
            // InternalPureXbase.g:17005:2: ( ruleXExpressionInClosure )
            // InternalPureXbase.g:17006:3: ruleXExpressionInClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExpressionXExpressionInClosureParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionInClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExpressionXExpressionInClosureParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__ExpressionAssignment_2"


    // $ANTLR start "rule__XExpressionInClosure__ExpressionsAssignment_1_0"
    // InternalPureXbase.g:17015:1: rule__XExpressionInClosure__ExpressionsAssignment_1_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XExpressionInClosure__ExpressionsAssignment_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17019:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalPureXbase.g:17020:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalPureXbase.g:17020:2: ( ruleXExpressionOrVarDeclaration )
            // InternalPureXbase.g:17021:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__ExpressionsAssignment_1_0"


    // $ANTLR start "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0"
    // InternalPureXbase.g:17030:1: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 : ( ruleJvmFormalParameter ) ;
    public final void rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17034:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:17035:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:17035:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:17036:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0"


    // $ANTLR start "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1"
    // InternalPureXbase.g:17045:1: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 : ( ruleJvmFormalParameter ) ;
    public final void rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17049:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:17050:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:17050:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:17051:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1"


    // $ANTLR start "rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2"
    // InternalPureXbase.g:17060:1: rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 : ( ( '|' ) ) ;
    public final void rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17064:1: ( ( ( '|' ) ) )
            // InternalPureXbase.g:17065:2: ( ( '|' ) )
            {
            // InternalPureXbase.g:17065:2: ( ( '|' ) )
            // InternalPureXbase.g:17066:3: ( '|' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }
            // InternalPureXbase.g:17067:3: ( '|' )
            // InternalPureXbase.g:17068:4: '|'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }
            match(input,83,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2"


    // $ANTLR start "rule__XShortClosure__ExpressionAssignment_1"
    // InternalPureXbase.g:17079:1: rule__XShortClosure__ExpressionAssignment_1 : ( ruleXExpression ) ;
    public final void rule__XShortClosure__ExpressionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17083:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17084:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17084:2: ( ruleXExpression )
            // InternalPureXbase.g:17085:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExpressionXExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExpressionXExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__ExpressionAssignment_1"


    // $ANTLR start "rule__XIfExpression__IfAssignment_3"
    // InternalPureXbase.g:17094:1: rule__XIfExpression__IfAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XIfExpression__IfAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17098:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17099:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17099:2: ( ruleXExpression )
            // InternalPureXbase.g:17100:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getIfXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getIfXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__IfAssignment_3"


    // $ANTLR start "rule__XIfExpression__ThenAssignment_5"
    // InternalPureXbase.g:17109:1: rule__XIfExpression__ThenAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XIfExpression__ThenAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17113:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17114:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17114:2: ( ruleXExpression )
            // InternalPureXbase.g:17115:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getThenXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getThenXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__ThenAssignment_5"


    // $ANTLR start "rule__XIfExpression__ElseAssignment_6_1"
    // InternalPureXbase.g:17124:1: rule__XIfExpression__ElseAssignment_6_1 : ( ruleXExpression ) ;
    public final void rule__XIfExpression__ElseAssignment_6_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17128:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17129:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17129:2: ( ruleXExpression )
            // InternalPureXbase.g:17130:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getElseXExpressionParserRuleCall_6_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getElseXExpressionParserRuleCall_6_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__ElseAssignment_6_1"


    // $ANTLR start "rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1"
    // InternalPureXbase.g:17139:1: rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 : ( ruleJvmFormalParameter ) ;
    public final void rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17143:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:17144:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:17144:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:17145:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_0_0_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_0_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1"


    // $ANTLR start "rule__XSwitchExpression__SwitchAssignment_2_0_1"
    // InternalPureXbase.g:17154:1: rule__XSwitchExpression__SwitchAssignment_2_0_1 : ( ruleXExpression ) ;
    public final void rule__XSwitchExpression__SwitchAssignment_2_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17158:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17159:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17159:2: ( ruleXExpression )
            // InternalPureXbase.g:17160:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__SwitchAssignment_2_0_1"


    // $ANTLR start "rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0"
    // InternalPureXbase.g:17169:1: rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 : ( ruleJvmFormalParameter ) ;
    public final void rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17173:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:17174:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:17174:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:17175:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_1_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_1_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0"


    // $ANTLR start "rule__XSwitchExpression__SwitchAssignment_2_1_1"
    // InternalPureXbase.g:17184:1: rule__XSwitchExpression__SwitchAssignment_2_1_1 : ( ruleXExpression ) ;
    public final void rule__XSwitchExpression__SwitchAssignment_2_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17188:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17189:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17189:2: ( ruleXExpression )
            // InternalPureXbase.g:17190:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__SwitchAssignment_2_1_1"


    // $ANTLR start "rule__XSwitchExpression__CasesAssignment_4"
    // InternalPureXbase.g:17199:1: rule__XSwitchExpression__CasesAssignment_4 : ( ruleXCasePart ) ;
    public final void rule__XSwitchExpression__CasesAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17203:1: ( ( ruleXCasePart ) )
            // InternalPureXbase.g:17204:2: ( ruleXCasePart )
            {
            // InternalPureXbase.g:17204:2: ( ruleXCasePart )
            // InternalPureXbase.g:17205:3: ruleXCasePart
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getCasesXCasePartParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXCasePart();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getCasesXCasePartParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__CasesAssignment_4"


    // $ANTLR start "rule__XSwitchExpression__DefaultAssignment_5_2"
    // InternalPureXbase.g:17214:1: rule__XSwitchExpression__DefaultAssignment_5_2 : ( ruleXExpression ) ;
    public final void rule__XSwitchExpression__DefaultAssignment_5_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17218:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17219:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17219:2: ( ruleXExpression )
            // InternalPureXbase.g:17220:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDefaultXExpressionParserRuleCall_5_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDefaultXExpressionParserRuleCall_5_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__DefaultAssignment_5_2"


    // $ANTLR start "rule__XCasePart__TypeGuardAssignment_1"
    // InternalPureXbase.g:17229:1: rule__XCasePart__TypeGuardAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XCasePart__TypeGuardAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17233:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:17234:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:17234:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:17235:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getTypeGuardJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getTypeGuardJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__TypeGuardAssignment_1"


    // $ANTLR start "rule__XCasePart__CaseAssignment_2_1"
    // InternalPureXbase.g:17244:1: rule__XCasePart__CaseAssignment_2_1 : ( ruleXExpression ) ;
    public final void rule__XCasePart__CaseAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17248:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17249:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17249:2: ( ruleXExpression )
            // InternalPureXbase.g:17250:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getCaseXExpressionParserRuleCall_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getCaseXExpressionParserRuleCall_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__CaseAssignment_2_1"


    // $ANTLR start "rule__XCasePart__ThenAssignment_3_0_1"
    // InternalPureXbase.g:17259:1: rule__XCasePart__ThenAssignment_3_0_1 : ( ruleXExpression ) ;
    public final void rule__XCasePart__ThenAssignment_3_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17263:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17264:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17264:2: ( ruleXExpression )
            // InternalPureXbase.g:17265:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getThenXExpressionParserRuleCall_3_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getThenXExpressionParserRuleCall_3_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__ThenAssignment_3_0_1"


    // $ANTLR start "rule__XCasePart__FallThroughAssignment_3_1"
    // InternalPureXbase.g:17274:1: rule__XCasePart__FallThroughAssignment_3_1 : ( ( ',' ) ) ;
    public final void rule__XCasePart__FallThroughAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17278:1: ( ( ( ',' ) ) )
            // InternalPureXbase.g:17279:2: ( ( ',' ) )
            {
            // InternalPureXbase.g:17279:2: ( ( ',' ) )
            // InternalPureXbase.g:17280:3: ( ',' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }
            // InternalPureXbase.g:17281:3: ( ',' )
            // InternalPureXbase.g:17282:4: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__FallThroughAssignment_3_1"


    // $ANTLR start "rule__XForLoopExpression__DeclaredParamAssignment_0_0_3"
    // InternalPureXbase.g:17293:1: rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 : ( ruleJvmFormalParameter ) ;
    public final void rule__XForLoopExpression__DeclaredParamAssignment_0_0_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17297:1: ( ( ruleJvmFormalParameter ) )
            // InternalPureXbase.g:17298:2: ( ruleJvmFormalParameter )
            {
            // InternalPureXbase.g:17298:2: ( ruleJvmFormalParameter )
            // InternalPureXbase.g:17299:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_0_0_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_0_0_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__DeclaredParamAssignment_0_0_3"


    // $ANTLR start "rule__XForLoopExpression__ForExpressionAssignment_1"
    // InternalPureXbase.g:17308:1: rule__XForLoopExpression__ForExpressionAssignment_1 : ( ruleXExpression ) ;
    public final void rule__XForLoopExpression__ForExpressionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17312:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17313:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17313:2: ( ruleXExpression )
            // InternalPureXbase.g:17314:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getForExpressionXExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getForExpressionXExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__ForExpressionAssignment_1"


    // $ANTLR start "rule__XForLoopExpression__EachExpressionAssignment_3"
    // InternalPureXbase.g:17323:1: rule__XForLoopExpression__EachExpressionAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XForLoopExpression__EachExpressionAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17327:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17328:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17328:2: ( ruleXExpression )
            // InternalPureXbase.g:17329:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__EachExpressionAssignment_3"


    // $ANTLR start "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0"
    // InternalPureXbase.g:17338:1: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17342:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalPureXbase.g:17343:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalPureXbase.g:17343:2: ( ruleXExpressionOrVarDeclaration )
            // InternalPureXbase.g:17344:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0"


    // $ANTLR start "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1"
    // InternalPureXbase.g:17353:1: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17357:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalPureXbase.g:17358:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalPureXbase.g:17358:2: ( ruleXExpressionOrVarDeclaration )
            // InternalPureXbase.g:17359:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1"


    // $ANTLR start "rule__XBasicForLoopExpression__ExpressionAssignment_5"
    // InternalPureXbase.g:17368:1: rule__XBasicForLoopExpression__ExpressionAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__ExpressionAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17372:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17373:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17373:2: ( ruleXExpression )
            // InternalPureXbase.g:17374:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__ExpressionAssignment_5"


    // $ANTLR start "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0"
    // InternalPureXbase.g:17383:1: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17387:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17388:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17388:2: ( ruleXExpression )
            // InternalPureXbase.g:17389:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0"


    // $ANTLR start "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1"
    // InternalPureXbase.g:17398:1: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17402:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17403:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17403:2: ( ruleXExpression )
            // InternalPureXbase.g:17404:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1"


    // $ANTLR start "rule__XBasicForLoopExpression__EachExpressionAssignment_9"
    // InternalPureXbase.g:17413:1: rule__XBasicForLoopExpression__EachExpressionAssignment_9 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__EachExpressionAssignment_9() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17417:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17418:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17418:2: ( ruleXExpression )
            // InternalPureXbase.g:17419:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_9_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_9_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__EachExpressionAssignment_9"


    // $ANTLR start "rule__XWhileExpression__PredicateAssignment_3"
    // InternalPureXbase.g:17428:1: rule__XWhileExpression__PredicateAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XWhileExpression__PredicateAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17432:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17433:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17433:2: ( ruleXExpression )
            // InternalPureXbase.g:17434:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getPredicateXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getPredicateXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__PredicateAssignment_3"


    // $ANTLR start "rule__XWhileExpression__BodyAssignment_5"
    // InternalPureXbase.g:17443:1: rule__XWhileExpression__BodyAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XWhileExpression__BodyAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17447:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17448:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17448:2: ( ruleXExpression )
            // InternalPureXbase.g:17449:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getBodyXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getBodyXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__BodyAssignment_5"


    // $ANTLR start "rule__XDoWhileExpression__BodyAssignment_2"
    // InternalPureXbase.g:17458:1: rule__XDoWhileExpression__BodyAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XDoWhileExpression__BodyAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17462:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17463:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17463:2: ( ruleXExpression )
            // InternalPureXbase.g:17464:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getBodyXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getBodyXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__BodyAssignment_2"


    // $ANTLR start "rule__XDoWhileExpression__PredicateAssignment_5"
    // InternalPureXbase.g:17473:1: rule__XDoWhileExpression__PredicateAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XDoWhileExpression__PredicateAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17477:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17478:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17478:2: ( ruleXExpression )
            // InternalPureXbase.g:17479:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getPredicateXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getPredicateXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__PredicateAssignment_5"


    // $ANTLR start "rule__XBlockExpression__ExpressionsAssignment_2_0"
    // InternalPureXbase.g:17488:1: rule__XBlockExpression__ExpressionsAssignment_2_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XBlockExpression__ExpressionsAssignment_2_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17492:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalPureXbase.g:17493:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalPureXbase.g:17493:2: ( ruleXExpressionOrVarDeclaration )
            // InternalPureXbase.g:17494:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_2_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__ExpressionsAssignment_2_0"


    // $ANTLR start "rule__XVariableDeclaration__WriteableAssignment_1_0"
    // InternalPureXbase.g:17503:1: rule__XVariableDeclaration__WriteableAssignment_1_0 : ( ( 'var' ) ) ;
    public final void rule__XVariableDeclaration__WriteableAssignment_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17507:1: ( ( ( 'var' ) ) )
            // InternalPureXbase.g:17508:2: ( ( 'var' ) )
            {
            // InternalPureXbase.g:17508:2: ( ( 'var' ) )
            // InternalPureXbase.g:17509:3: ( 'var' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }
            // InternalPureXbase.g:17510:3: ( 'var' )
            // InternalPureXbase.g:17511:4: 'var'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }
            match(input,80,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__WriteableAssignment_1_0"


    // $ANTLR start "rule__XVariableDeclaration__TypeAssignment_2_0_0_0"
    // InternalPureXbase.g:17522:1: rule__XVariableDeclaration__TypeAssignment_2_0_0_0 : ( ruleJvmTypeReference ) ;
    public final void rule__XVariableDeclaration__TypeAssignment_2_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17526:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:17527:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:17527:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:17528:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__TypeAssignment_2_0_0_0"


    // $ANTLR start "rule__XVariableDeclaration__NameAssignment_2_0_0_1"
    // InternalPureXbase.g:17537:1: rule__XVariableDeclaration__NameAssignment_2_0_0_1 : ( ruleValidID ) ;
    public final void rule__XVariableDeclaration__NameAssignment_2_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17541:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:17542:2: ( ruleValidID )
            {
            // InternalPureXbase.g:17542:2: ( ruleValidID )
            // InternalPureXbase.g:17543:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_0_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__NameAssignment_2_0_0_1"


    // $ANTLR start "rule__XVariableDeclaration__NameAssignment_2_1"
    // InternalPureXbase.g:17552:1: rule__XVariableDeclaration__NameAssignment_2_1 : ( ruleValidID ) ;
    public final void rule__XVariableDeclaration__NameAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17556:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:17557:2: ( ruleValidID )
            {
            // InternalPureXbase.g:17557:2: ( ruleValidID )
            // InternalPureXbase.g:17558:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__NameAssignment_2_1"


    // $ANTLR start "rule__XVariableDeclaration__RightAssignment_3_1"
    // InternalPureXbase.g:17567:1: rule__XVariableDeclaration__RightAssignment_3_1 : ( ruleXExpression ) ;
    public final void rule__XVariableDeclaration__RightAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17571:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17572:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17572:2: ( ruleXExpression )
            // InternalPureXbase.g:17573:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getRightXExpressionParserRuleCall_3_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getRightXExpressionParserRuleCall_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__RightAssignment_3_1"


    // $ANTLR start "rule__JvmFormalParameter__ParameterTypeAssignment_0"
    // InternalPureXbase.g:17582:1: rule__JvmFormalParameter__ParameterTypeAssignment_0 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmFormalParameter__ParameterTypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17586:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:17587:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:17587:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:17588:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__ParameterTypeAssignment_0"


    // $ANTLR start "rule__JvmFormalParameter__NameAssignment_1"
    // InternalPureXbase.g:17597:1: rule__JvmFormalParameter__NameAssignment_1 : ( ruleValidID ) ;
    public final void rule__JvmFormalParameter__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17601:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:17602:2: ( ruleValidID )
            {
            // InternalPureXbase.g:17602:2: ( ruleValidID )
            // InternalPureXbase.g:17603:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__NameAssignment_1"


    // $ANTLR start "rule__FullJvmFormalParameter__ParameterTypeAssignment_0"
    // InternalPureXbase.g:17612:1: rule__FullJvmFormalParameter__ParameterTypeAssignment_0 : ( ruleJvmTypeReference ) ;
    public final void rule__FullJvmFormalParameter__ParameterTypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17616:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:17617:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:17617:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:17618:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__ParameterTypeAssignment_0"


    // $ANTLR start "rule__FullJvmFormalParameter__NameAssignment_1"
    // InternalPureXbase.g:17627:1: rule__FullJvmFormalParameter__NameAssignment_1 : ( ruleValidID ) ;
    public final void rule__FullJvmFormalParameter__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17631:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:17632:2: ( ruleValidID )
            {
            // InternalPureXbase.g:17632:2: ( ruleValidID )
            // InternalPureXbase.g:17633:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__NameAssignment_1"


    // $ANTLR start "rule__XFeatureCall__TypeArgumentsAssignment_1_1"
    // InternalPureXbase.g:17642:1: rule__XFeatureCall__TypeArgumentsAssignment_1_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XFeatureCall__TypeArgumentsAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17646:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:17647:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:17647:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:17648:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__TypeArgumentsAssignment_1_1"


    // $ANTLR start "rule__XFeatureCall__TypeArgumentsAssignment_1_2_1"
    // InternalPureXbase.g:17657:1: rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XFeatureCall__TypeArgumentsAssignment_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17661:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:17662:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:17662:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:17663:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__TypeArgumentsAssignment_1_2_1"


    // $ANTLR start "rule__XFeatureCall__FeatureAssignment_2"
    // InternalPureXbase.g:17672:1: rule__XFeatureCall__FeatureAssignment_2 : ( ( ruleIdOrSuper ) ) ;
    public final void rule__XFeatureCall__FeatureAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17676:1: ( ( ( ruleIdOrSuper ) ) )
            // InternalPureXbase.g:17677:2: ( ( ruleIdOrSuper ) )
            {
            // InternalPureXbase.g:17677:2: ( ( ruleIdOrSuper ) )
            // InternalPureXbase.g:17678:3: ( ruleIdOrSuper )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_2_0()); 
            }
            // InternalPureXbase.g:17679:3: ( ruleIdOrSuper )
            // InternalPureXbase.g:17680:4: ruleIdOrSuper
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureAssignment_2"


    // $ANTLR start "rule__XFeatureCall__ExplicitOperationCallAssignment_3_0"
    // InternalPureXbase.g:17691:1: rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 : ( ( '(' ) ) ;
    public final void rule__XFeatureCall__ExplicitOperationCallAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17695:1: ( ( ( '(' ) ) )
            // InternalPureXbase.g:17696:2: ( ( '(' ) )
            {
            // InternalPureXbase.g:17696:2: ( ( '(' ) )
            // InternalPureXbase.g:17697:3: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }
            // InternalPureXbase.g:17698:3: ( '(' )
            // InternalPureXbase.g:17699:4: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__ExplicitOperationCallAssignment_3_0"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0"
    // InternalPureXbase.g:17710:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 : ( ruleXShortClosure ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17714:1: ( ( ruleXShortClosure ) )
            // InternalPureXbase.g:17715:2: ( ruleXShortClosure )
            {
            // InternalPureXbase.g:17715:2: ( ruleXShortClosure )
            // InternalPureXbase.g:17716:3: ruleXShortClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXShortClosureParserRuleCall_3_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXShortClosureParserRuleCall_3_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0"
    // InternalPureXbase.g:17725:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 : ( ruleXExpression ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17729:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17730:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17730:2: ( ruleXExpression )
            // InternalPureXbase.g:17731:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1"
    // InternalPureXbase.g:17740:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17744:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17745:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17745:2: ( ruleXExpression )
            // InternalPureXbase.g:17746:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_4"
    // InternalPureXbase.g:17755:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_4 : ( ruleXClosure ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17759:1: ( ( ruleXClosure ) )
            // InternalPureXbase.g:17760:2: ( ruleXClosure )
            {
            // InternalPureXbase.g:17760:2: ( ruleXClosure )
            // InternalPureXbase.g:17761:3: ruleXClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXClosureParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXClosureParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_4"


    // $ANTLR start "rule__XConstructorCall__ConstructorAssignment_2"
    // InternalPureXbase.g:17770:1: rule__XConstructorCall__ConstructorAssignment_2 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XConstructorCall__ConstructorAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17774:1: ( ( ( ruleQualifiedName ) ) )
            // InternalPureXbase.g:17775:2: ( ( ruleQualifiedName ) )
            {
            // InternalPureXbase.g:17775:2: ( ( ruleQualifiedName ) )
            // InternalPureXbase.g:17776:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorCrossReference_2_0()); 
            }
            // InternalPureXbase.g:17777:3: ( ruleQualifiedName )
            // InternalPureXbase.g:17778:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorQualifiedNameParserRuleCall_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorQualifiedNameParserRuleCall_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorCrossReference_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ConstructorAssignment_2"


    // $ANTLR start "rule__XConstructorCall__TypeArgumentsAssignment_3_1"
    // InternalPureXbase.g:17789:1: rule__XConstructorCall__TypeArgumentsAssignment_3_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XConstructorCall__TypeArgumentsAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17793:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:17794:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:17794:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:17795:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__TypeArgumentsAssignment_3_1"


    // $ANTLR start "rule__XConstructorCall__TypeArgumentsAssignment_3_2_1"
    // InternalPureXbase.g:17804:1: rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XConstructorCall__TypeArgumentsAssignment_3_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17808:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:17809:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:17809:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:17810:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__TypeArgumentsAssignment_3_2_1"


    // $ANTLR start "rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0"
    // InternalPureXbase.g:17819:1: rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 : ( ( '(' ) ) ;
    public final void rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17823:1: ( ( ( '(' ) ) )
            // InternalPureXbase.g:17824:2: ( ( '(' ) )
            {
            // InternalPureXbase.g:17824:2: ( ( '(' ) )
            // InternalPureXbase.g:17825:3: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }
            // InternalPureXbase.g:17826:3: ( '(' )
            // InternalPureXbase.g:17827:4: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_4_1_0"
    // InternalPureXbase.g:17838:1: rule__XConstructorCall__ArgumentsAssignment_4_1_0 : ( ruleXShortClosure ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_4_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17842:1: ( ( ruleXShortClosure ) )
            // InternalPureXbase.g:17843:2: ( ruleXShortClosure )
            {
            // InternalPureXbase.g:17843:2: ( ruleXShortClosure )
            // InternalPureXbase.g:17844:3: ruleXShortClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXShortClosureParserRuleCall_4_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXShortClosureParserRuleCall_4_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_4_1_0"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_4_1_1_0"
    // InternalPureXbase.g:17853:1: rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 : ( ruleXExpression ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_4_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17857:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17858:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17858:2: ( ruleXExpression )
            // InternalPureXbase.g:17859:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_4_1_1_0"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1"
    // InternalPureXbase.g:17868:1: rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17872:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17873:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17873:2: ( ruleXExpression )
            // InternalPureXbase.g:17874:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_5"
    // InternalPureXbase.g:17883:1: rule__XConstructorCall__ArgumentsAssignment_5 : ( ruleXClosure ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17887:1: ( ( ruleXClosure ) )
            // InternalPureXbase.g:17888:2: ( ruleXClosure )
            {
            // InternalPureXbase.g:17888:2: ( ruleXClosure )
            // InternalPureXbase.g:17889:3: ruleXClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXClosureParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXClosureParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_5"


    // $ANTLR start "rule__XBooleanLiteral__IsTrueAssignment_1_1"
    // InternalPureXbase.g:17898:1: rule__XBooleanLiteral__IsTrueAssignment_1_1 : ( ( 'true' ) ) ;
    public final void rule__XBooleanLiteral__IsTrueAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17902:1: ( ( ( 'true' ) ) )
            // InternalPureXbase.g:17903:2: ( ( 'true' ) )
            {
            // InternalPureXbase.g:17903:2: ( ( 'true' ) )
            // InternalPureXbase.g:17904:3: ( 'true' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }
            // InternalPureXbase.g:17905:3: ( 'true' )
            // InternalPureXbase.g:17906:4: 'true'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }
            match(input,84,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__IsTrueAssignment_1_1"


    // $ANTLR start "rule__XNumberLiteral__ValueAssignment_1"
    // InternalPureXbase.g:17917:1: rule__XNumberLiteral__ValueAssignment_1 : ( ruleNumber ) ;
    public final void rule__XNumberLiteral__ValueAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17921:1: ( ( ruleNumber ) )
            // InternalPureXbase.g:17922:2: ( ruleNumber )
            {
            // InternalPureXbase.g:17922:2: ( ruleNumber )
            // InternalPureXbase.g:17923:3: ruleNumber
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getValueNumberParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleNumber();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getValueNumberParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__ValueAssignment_1"


    // $ANTLR start "rule__XStringLiteral__ValueAssignment_1"
    // InternalPureXbase.g:17932:1: rule__XStringLiteral__ValueAssignment_1 : ( RULE_STRING ) ;
    public final void rule__XStringLiteral__ValueAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17936:1: ( ( RULE_STRING ) )
            // InternalPureXbase.g:17937:2: ( RULE_STRING )
            {
            // InternalPureXbase.g:17937:2: ( RULE_STRING )
            // InternalPureXbase.g:17938:3: RULE_STRING
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getValueSTRINGTerminalRuleCall_1_0()); 
            }
            match(input,RULE_STRING,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getValueSTRINGTerminalRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__ValueAssignment_1"


    // $ANTLR start "rule__XTypeLiteral__TypeAssignment_3"
    // InternalPureXbase.g:17947:1: rule__XTypeLiteral__TypeAssignment_3 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XTypeLiteral__TypeAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17951:1: ( ( ( ruleQualifiedName ) ) )
            // InternalPureXbase.g:17952:2: ( ( ruleQualifiedName ) )
            {
            // InternalPureXbase.g:17952:2: ( ( ruleQualifiedName ) )
            // InternalPureXbase.g:17953:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeCrossReference_3_0()); 
            }
            // InternalPureXbase.g:17954:3: ( ruleQualifiedName )
            // InternalPureXbase.g:17955:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeQualifiedNameParserRuleCall_3_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeQualifiedNameParserRuleCall_3_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeCrossReference_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__TypeAssignment_3"


    // $ANTLR start "rule__XTypeLiteral__ArrayDimensionsAssignment_4"
    // InternalPureXbase.g:17966:1: rule__XTypeLiteral__ArrayDimensionsAssignment_4 : ( ruleArrayBrackets ) ;
    public final void rule__XTypeLiteral__ArrayDimensionsAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17970:1: ( ( ruleArrayBrackets ) )
            // InternalPureXbase.g:17971:2: ( ruleArrayBrackets )
            {
            // InternalPureXbase.g:17971:2: ( ruleArrayBrackets )
            // InternalPureXbase.g:17972:3: ruleArrayBrackets
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsArrayBracketsParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsArrayBracketsParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__ArrayDimensionsAssignment_4"


    // $ANTLR start "rule__XThrowExpression__ExpressionAssignment_2"
    // InternalPureXbase.g:17981:1: rule__XThrowExpression__ExpressionAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XThrowExpression__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:17985:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:17986:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:17986:2: ( ruleXExpression )
            // InternalPureXbase.g:17987:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__ExpressionAssignment_2"


    // $ANTLR start "rule__XReturnExpression__ExpressionAssignment_2"
    // InternalPureXbase.g:17996:1: rule__XReturnExpression__ExpressionAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XReturnExpression__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18000:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:18001:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:18001:2: ( ruleXExpression )
            // InternalPureXbase.g:18002:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__ExpressionAssignment_2"


    // $ANTLR start "rule__XSynchronizedExpression__ParamAssignment_1"
    // InternalPureXbase.g:18011:1: rule__XSynchronizedExpression__ParamAssignment_1 : ( ruleXExpression ) ;
    public final void rule__XSynchronizedExpression__ParamAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18015:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:18016:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:18016:2: ( ruleXExpression )
            // InternalPureXbase.g:18017:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getParamXExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getParamXExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__ParamAssignment_1"


    // $ANTLR start "rule__XSynchronizedExpression__ExpressionAssignment_3"
    // InternalPureXbase.g:18026:1: rule__XSynchronizedExpression__ExpressionAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XSynchronizedExpression__ExpressionAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18030:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:18031:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:18031:2: ( ruleXExpression )
            // InternalPureXbase.g:18032:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getExpressionXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getExpressionXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__ExpressionAssignment_3"


    // $ANTLR start "rule__XCatchClause__DeclaredParamAssignment_2"
    // InternalPureXbase.g:18041:1: rule__XCatchClause__DeclaredParamAssignment_2 : ( ruleFullJvmFormalParameter ) ;
    public final void rule__XCatchClause__DeclaredParamAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18045:1: ( ( ruleFullJvmFormalParameter ) )
            // InternalPureXbase.g:18046:2: ( ruleFullJvmFormalParameter )
            {
            // InternalPureXbase.g:18046:2: ( ruleFullJvmFormalParameter )
            // InternalPureXbase.g:18047:3: ruleFullJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getDeclaredParamFullJvmFormalParameterParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleFullJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getDeclaredParamFullJvmFormalParameterParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__DeclaredParamAssignment_2"


    // $ANTLR start "rule__XCatchClause__ExpressionAssignment_4"
    // InternalPureXbase.g:18056:1: rule__XCatchClause__ExpressionAssignment_4 : ( ruleXExpression ) ;
    public final void rule__XCatchClause__ExpressionAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18060:1: ( ( ruleXExpression ) )
            // InternalPureXbase.g:18061:2: ( ruleXExpression )
            {
            // InternalPureXbase.g:18061:2: ( ruleXExpression )
            // InternalPureXbase.g:18062:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getExpressionXExpressionParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getExpressionXExpressionParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__ExpressionAssignment_4"


    // $ANTLR start "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0"
    // InternalPureXbase.g:18071:1: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 : ( ruleJvmTypeReference ) ;
    public final void rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18075:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18076:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18076:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18077:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0"


    // $ANTLR start "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1"
    // InternalPureXbase.g:18086:1: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18090:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18091:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18091:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18092:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1"


    // $ANTLR start "rule__XFunctionTypeRef__ReturnTypeAssignment_2"
    // InternalPureXbase.g:18101:1: rule__XFunctionTypeRef__ReturnTypeAssignment_2 : ( ruleJvmTypeReference ) ;
    public final void rule__XFunctionTypeRef__ReturnTypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18105:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18106:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18106:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18107:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__ReturnTypeAssignment_2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__TypeAssignment_0"
    // InternalPureXbase.g:18116:1: rule__JvmParameterizedTypeReference__TypeAssignment_0 : ( ( ruleQualifiedName ) ) ;
    public final void rule__JvmParameterizedTypeReference__TypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18120:1: ( ( ( ruleQualifiedName ) ) )
            // InternalPureXbase.g:18121:2: ( ( ruleQualifiedName ) )
            {
            // InternalPureXbase.g:18121:2: ( ( ruleQualifiedName ) )
            // InternalPureXbase.g:18122:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_0_0()); 
            }
            // InternalPureXbase.g:18123:3: ( ruleQualifiedName )
            // InternalPureXbase.g:18124:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeQualifiedNameParserRuleCall_0_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeQualifiedNameParserRuleCall_0_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__TypeAssignment_0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1"
    // InternalPureXbase.g:18135:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18139:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:18140:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:18140:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:18141:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1"
    // InternalPureXbase.g:18150:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18154:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:18155:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:18155:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:18156:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1"
    // InternalPureXbase.g:18165:1: rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 : ( ( ruleValidID ) ) ;
    public final void rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18169:1: ( ( ( ruleValidID ) ) )
            // InternalPureXbase.g:18170:2: ( ( ruleValidID ) )
            {
            // InternalPureXbase.g:18170:2: ( ( ruleValidID ) )
            // InternalPureXbase.g:18171:3: ( ruleValidID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_1_4_1_0()); 
            }
            // InternalPureXbase.g:18172:3: ( ruleValidID )
            // InternalPureXbase.g:18173:4: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeValidIDParserRuleCall_1_4_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeValidIDParserRuleCall_1_4_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_1_4_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1"
    // InternalPureXbase.g:18184:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18188:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:18189:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:18189:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:18190:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1"
    // InternalPureXbase.g:18199:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18203:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalPureXbase.g:18204:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalPureXbase.g:18204:2: ( ruleJvmArgumentTypeReference )
            // InternalPureXbase.g:18205:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0"
    // InternalPureXbase.g:18214:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 : ( ruleJvmUpperBound ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18218:1: ( ( ruleJvmUpperBound ) )
            // InternalPureXbase.g:18219:2: ( ruleJvmUpperBound )
            {
            // InternalPureXbase.g:18219:2: ( ruleJvmUpperBound )
            // InternalPureXbase.g:18220:3: ruleJvmUpperBound
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundParserRuleCall_2_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmUpperBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundParserRuleCall_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1"
    // InternalPureXbase.g:18229:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 : ( ruleJvmUpperBoundAnded ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18233:1: ( ( ruleJvmUpperBoundAnded ) )
            // InternalPureXbase.g:18234:2: ( ruleJvmUpperBoundAnded )
            {
            // InternalPureXbase.g:18234:2: ( ruleJvmUpperBoundAnded )
            // InternalPureXbase.g:18235:3: ruleJvmUpperBoundAnded
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundAndedParserRuleCall_2_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmUpperBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundAndedParserRuleCall_2_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0"
    // InternalPureXbase.g:18244:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 : ( ruleJvmLowerBound ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18248:1: ( ( ruleJvmLowerBound ) )
            // InternalPureXbase.g:18249:2: ( ruleJvmLowerBound )
            {
            // InternalPureXbase.g:18249:2: ( ruleJvmLowerBound )
            // InternalPureXbase.g:18250:3: ruleJvmLowerBound
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundParserRuleCall_2_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmLowerBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundParserRuleCall_2_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1"
    // InternalPureXbase.g:18259:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 : ( ruleJvmLowerBoundAnded ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18263:1: ( ( ruleJvmLowerBoundAnded ) )
            // InternalPureXbase.g:18264:2: ( ruleJvmLowerBoundAnded )
            {
            // InternalPureXbase.g:18264:2: ( ruleJvmLowerBoundAnded )
            // InternalPureXbase.g:18265:3: ruleJvmLowerBoundAnded
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundAndedParserRuleCall_2_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmLowerBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundAndedParserRuleCall_2_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1"


    // $ANTLR start "rule__JvmUpperBound__TypeReferenceAssignment_1"
    // InternalPureXbase.g:18274:1: rule__JvmUpperBound__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmUpperBound__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18278:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18279:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18279:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18280:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__TypeReferenceAssignment_1"


    // $ANTLR start "rule__JvmUpperBoundAnded__TypeReferenceAssignment_1"
    // InternalPureXbase.g:18289:1: rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmUpperBoundAnded__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18293:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18294:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18294:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18295:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__TypeReferenceAssignment_1"


    // $ANTLR start "rule__JvmLowerBound__TypeReferenceAssignment_1"
    // InternalPureXbase.g:18304:1: rule__JvmLowerBound__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmLowerBound__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18308:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18309:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18309:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18310:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__TypeReferenceAssignment_1"


    // $ANTLR start "rule__JvmLowerBoundAnded__TypeReferenceAssignment_1"
    // InternalPureXbase.g:18319:1: rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmLowerBoundAnded__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18323:1: ( ( ruleJvmTypeReference ) )
            // InternalPureXbase.g:18324:2: ( ruleJvmTypeReference )
            {
            // InternalPureXbase.g:18324:2: ( ruleJvmTypeReference )
            // InternalPureXbase.g:18325:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__TypeReferenceAssignment_1"


    // $ANTLR start "rule__XImportSection__ImportDeclarationsAssignment"
    // InternalPureXbase.g:18334:1: rule__XImportSection__ImportDeclarationsAssignment : ( ruleXImportDeclaration ) ;
    public final void rule__XImportSection__ImportDeclarationsAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18338:1: ( ( ruleXImportDeclaration ) )
            // InternalPureXbase.g:18339:2: ( ruleXImportDeclaration )
            {
            // InternalPureXbase.g:18339:2: ( ruleXImportDeclaration )
            // InternalPureXbase.g:18340:3: ruleXImportDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportSectionAccess().getImportDeclarationsXImportDeclarationParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXImportDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportSectionAccess().getImportDeclarationsXImportDeclarationParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportSection__ImportDeclarationsAssignment"


    // $ANTLR start "rule__XImportDeclaration__StaticAssignment_1_0_0"
    // InternalPureXbase.g:18349:1: rule__XImportDeclaration__StaticAssignment_1_0_0 : ( ( 'static' ) ) ;
    public final void rule__XImportDeclaration__StaticAssignment_1_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18353:1: ( ( ( 'static' ) ) )
            // InternalPureXbase.g:18354:2: ( ( 'static' ) )
            {
            // InternalPureXbase.g:18354:2: ( ( 'static' ) )
            // InternalPureXbase.g:18355:3: ( 'static' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }
            // InternalPureXbase.g:18356:3: ( 'static' )
            // InternalPureXbase.g:18357:4: 'static'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }
            match(input,85,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__StaticAssignment_1_0_0"


    // $ANTLR start "rule__XImportDeclaration__ExtensionAssignment_1_0_1"
    // InternalPureXbase.g:18368:1: rule__XImportDeclaration__ExtensionAssignment_1_0_1 : ( ( 'extension' ) ) ;
    public final void rule__XImportDeclaration__ExtensionAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18372:1: ( ( ( 'extension' ) ) )
            // InternalPureXbase.g:18373:2: ( ( 'extension' ) )
            {
            // InternalPureXbase.g:18373:2: ( ( 'extension' ) )
            // InternalPureXbase.g:18374:3: ( 'extension' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }
            // InternalPureXbase.g:18375:3: ( 'extension' )
            // InternalPureXbase.g:18376:4: 'extension'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }
            match(input,86,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ExtensionAssignment_1_0_1"


    // $ANTLR start "rule__XImportDeclaration__ImportedTypeAssignment_1_0_2"
    // InternalPureXbase.g:18387:1: rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 : ( ( ruleQualifiedNameInStaticImport ) ) ;
    public final void rule__XImportDeclaration__ImportedTypeAssignment_1_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18391:1: ( ( ( ruleQualifiedNameInStaticImport ) ) )
            // InternalPureXbase.g:18392:2: ( ( ruleQualifiedNameInStaticImport ) )
            {
            // InternalPureXbase.g:18392:2: ( ( ruleQualifiedNameInStaticImport ) )
            // InternalPureXbase.g:18393:3: ( ruleQualifiedNameInStaticImport )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_0_2_0()); 
            }
            // InternalPureXbase.g:18394:3: ( ruleQualifiedNameInStaticImport )
            // InternalPureXbase.g:18395:4: ruleQualifiedNameInStaticImport
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameInStaticImportParserRuleCall_1_0_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedNameInStaticImport();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameInStaticImportParserRuleCall_1_0_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ImportedTypeAssignment_1_0_2"


    // $ANTLR start "rule__XImportDeclaration__WildcardAssignment_1_0_3_0"
    // InternalPureXbase.g:18406:1: rule__XImportDeclaration__WildcardAssignment_1_0_3_0 : ( ( '*' ) ) ;
    public final void rule__XImportDeclaration__WildcardAssignment_1_0_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18410:1: ( ( ( '*' ) ) )
            // InternalPureXbase.g:18411:2: ( ( '*' ) )
            {
            // InternalPureXbase.g:18411:2: ( ( '*' ) )
            // InternalPureXbase.g:18412:3: ( '*' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }
            // InternalPureXbase.g:18413:3: ( '*' )
            // InternalPureXbase.g:18414:4: '*'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }
            match(input,37,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__WildcardAssignment_1_0_3_0"


    // $ANTLR start "rule__XImportDeclaration__MemberNameAssignment_1_0_3_1"
    // InternalPureXbase.g:18425:1: rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 : ( ruleValidID ) ;
    public final void rule__XImportDeclaration__MemberNameAssignment_1_0_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18429:1: ( ( ruleValidID ) )
            // InternalPureXbase.g:18430:2: ( ruleValidID )
            {
            // InternalPureXbase.g:18430:2: ( ruleValidID )
            // InternalPureXbase.g:18431:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getMemberNameValidIDParserRuleCall_1_0_3_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getMemberNameValidIDParserRuleCall_1_0_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__MemberNameAssignment_1_0_3_1"


    // $ANTLR start "rule__XImportDeclaration__ImportedTypeAssignment_1_1"
    // InternalPureXbase.g:18440:1: rule__XImportDeclaration__ImportedTypeAssignment_1_1 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XImportDeclaration__ImportedTypeAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18444:1: ( ( ( ruleQualifiedName ) ) )
            // InternalPureXbase.g:18445:2: ( ( ruleQualifiedName ) )
            {
            // InternalPureXbase.g:18445:2: ( ( ruleQualifiedName ) )
            // InternalPureXbase.g:18446:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_1_0()); 
            }
            // InternalPureXbase.g:18447:3: ( ruleQualifiedName )
            // InternalPureXbase.g:18448:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameParserRuleCall_1_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameParserRuleCall_1_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ImportedTypeAssignment_1_1"


    // $ANTLR start "rule__XImportDeclaration__ImportedNamespaceAssignment_1_2"
    // InternalPureXbase.g:18459:1: rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 : ( ruleQualifiedNameWithWildcard ) ;
    public final void rule__XImportDeclaration__ImportedNamespaceAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalPureXbase.g:18463:1: ( ( ruleQualifiedNameWithWildcard ) )
            // InternalPureXbase.g:18464:2: ( ruleQualifiedNameWithWildcard )
            {
            // InternalPureXbase.g:18464:2: ( ruleQualifiedNameWithWildcard )
            // InternalPureXbase.g:18465:3: ruleQualifiedNameWithWildcard
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedNameWithWildcard();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ImportedNamespaceAssignment_1_2"

    // $ANTLR start synpred31_InternalPureXbase
    public final void synpred31_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2433:2: ( ( ( rule__OpOther__Group_6_1_0__0 ) ) )
        // InternalPureXbase.g:2433:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
        {
        // InternalPureXbase.g:2433:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
        // InternalPureXbase.g:2434:3: ( rule__OpOther__Group_6_1_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getOpOtherAccess().getGroup_6_1_0()); 
        }
        // InternalPureXbase.g:2435:3: ( rule__OpOther__Group_6_1_0__0 )
        // InternalPureXbase.g:2435:4: rule__OpOther__Group_6_1_0__0
        {
        pushFollow(FOLLOW_2);
        rule__OpOther__Group_6_1_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred31_InternalPureXbase

    // $ANTLR start synpred32_InternalPureXbase
    public final void synpred32_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2439:2: ( ( '<' ) )
        // InternalPureXbase.g:2439:2: ( '<' )
        {
        // InternalPureXbase.g:2439:2: ( '<' )
        // InternalPureXbase.g:2440:3: '<'
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1()); 
        }
        match(input,28,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred32_InternalPureXbase

    // $ANTLR start synpred45_InternalPureXbase
    public final void synpred45_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2652:2: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) )
        // InternalPureXbase.g:2652:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
        {
        // InternalPureXbase.g:2652:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
        // InternalPureXbase.g:2653:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_0()); 
        }
        // InternalPureXbase.g:2654:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
        // InternalPureXbase.g:2654:4: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred45_InternalPureXbase

    // $ANTLR start synpred53_InternalPureXbase
    public final void synpred53_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2715:2: ( ( ( ruleXForLoopExpression ) ) )
        // InternalPureXbase.g:2715:2: ( ( ruleXForLoopExpression ) )
        {
        // InternalPureXbase.g:2715:2: ( ( ruleXForLoopExpression ) )
        // InternalPureXbase.g:2716:3: ( ruleXForLoopExpression )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7()); 
        }
        // InternalPureXbase.g:2717:3: ( ruleXForLoopExpression )
        // InternalPureXbase.g:2717:4: ruleXForLoopExpression
        {
        pushFollow(FOLLOW_2);
        ruleXForLoopExpression();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred53_InternalPureXbase

    // $ANTLR start synpred54_InternalPureXbase
    public final void synpred54_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2721:2: ( ( ruleXBasicForLoopExpression ) )
        // InternalPureXbase.g:2721:2: ( ruleXBasicForLoopExpression )
        {
        // InternalPureXbase.g:2721:2: ( ruleXBasicForLoopExpression )
        // InternalPureXbase.g:2722:3: ruleXBasicForLoopExpression
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8()); 
        }
        pushFollow(FOLLOW_2);
        ruleXBasicForLoopExpression();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred54_InternalPureXbase

    // $ANTLR start synpred67_InternalPureXbase
    public final void synpred67_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2844:2: ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) )
        // InternalPureXbase.g:2844:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
        {
        // InternalPureXbase.g:2844:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
        // InternalPureXbase.g:2845:3: ( rule__XSwitchExpression__Group_2_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0()); 
        }
        // InternalPureXbase.g:2846:3: ( rule__XSwitchExpression__Group_2_0__0 )
        // InternalPureXbase.g:2846:4: rule__XSwitchExpression__Group_2_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XSwitchExpression__Group_2_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred67_InternalPureXbase

    // $ANTLR start synpred71_InternalPureXbase
    public final void synpred71_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2928:2: ( ( ( rule__XVariableDeclaration__Group_2_0__0 ) ) )
        // InternalPureXbase.g:2928:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
        {
        // InternalPureXbase.g:2928:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
        // InternalPureXbase.g:2929:3: ( rule__XVariableDeclaration__Group_2_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0()); 
        }
        // InternalPureXbase.g:2930:3: ( rule__XVariableDeclaration__Group_2_0__0 )
        // InternalPureXbase.g:2930:4: rule__XVariableDeclaration__Group_2_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XVariableDeclaration__Group_2_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred71_InternalPureXbase

    // $ANTLR start synpred72_InternalPureXbase
    public final void synpred72_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2949:2: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) )
        // InternalPureXbase.g:2949:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
        {
        // InternalPureXbase.g:2949:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
        // InternalPureXbase.g:2950:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_0()); 
        }
        // InternalPureXbase.g:2951:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
        // InternalPureXbase.g:2951:4: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0
        {
        pushFollow(FOLLOW_2);
        rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred72_InternalPureXbase

    // $ANTLR start synpred74_InternalPureXbase
    public final void synpred74_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:2991:2: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) )
        // InternalPureXbase.g:2991:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
        {
        // InternalPureXbase.g:2991:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
        // InternalPureXbase.g:2992:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_0()); 
        }
        // InternalPureXbase.g:2993:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
        // InternalPureXbase.g:2993:4: rule__XConstructorCall__ArgumentsAssignment_4_1_0
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__ArgumentsAssignment_4_1_0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred74_InternalPureXbase

    // $ANTLR start synpred90_InternalPureXbase
    public final void synpred90_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:3625:3: ( rule__XTryCatchFinallyExpression__Group_2_0_6__0 )
        // InternalPureXbase.g:3625:3: rule__XTryCatchFinallyExpression__Group_2_0_6__0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__Group_2_0_6__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred90_InternalPureXbase

    // $ANTLR start synpred91_InternalPureXbase
    public final void synpred91_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:3740:4: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0 )
        // InternalPureXbase.g:3740:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_0_6_0_0_0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred91_InternalPureXbase

    // $ANTLR start synpred92_InternalPureXbase
    public final void synpred92_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:3767:3: ( rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0 )
        // InternalPureXbase.g:3767:3: rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__Group_2_0_6_0_0_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred92_InternalPureXbase

    // $ANTLR start synpred93_InternalPureXbase
    public final void synpred93_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:3963:4: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0 )
        // InternalPureXbase.g:3963:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__CatchClausesAssignment_2_1_1_0_0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred93_InternalPureXbase

    // $ANTLR start synpred94_InternalPureXbase
    public final void synpred94_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:3990:3: ( rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0 )
        // InternalPureXbase.g:3990:3: rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__Group_2_1_1_0_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred94_InternalPureXbase

    // $ANTLR start synpred95_InternalPureXbase
    public final void synpred95_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:4476:3: ( rule__XAssignment__Group_1_1__0 )
        // InternalPureXbase.g:4476:3: rule__XAssignment__Group_1_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XAssignment__Group_1_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred95_InternalPureXbase

    // $ANTLR start synpred96_InternalPureXbase
    public final void synpred96_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:4665:3: ( rule__XConditionalExpression__Group_1__0 )
        // InternalPureXbase.g:4665:3: rule__XConditionalExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XConditionalExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred96_InternalPureXbase

    // $ANTLR start synpred97_InternalPureXbase
    public final void synpred97_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:4746:3: ( rule__XConditionalExpression__Group_1_2__0 )
        // InternalPureXbase.g:4746:3: rule__XConditionalExpression__Group_1_2__0
        {
        pushFollow(FOLLOW_2);
        rule__XConditionalExpression__Group_1_2__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred97_InternalPureXbase

    // $ANTLR start synpred99_InternalPureXbase
    public final void synpred99_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:5097:3: ( rule__XOrExpression__Group_1__0 )
        // InternalPureXbase.g:5097:3: rule__XOrExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XOrExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred99_InternalPureXbase

    // $ANTLR start synpred100_InternalPureXbase
    public final void synpred100_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:5286:3: ( rule__XAndExpression__Group_1__0 )
        // InternalPureXbase.g:5286:3: rule__XAndExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XAndExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred100_InternalPureXbase

    // $ANTLR start synpred101_InternalPureXbase
    public final void synpred101_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:5475:3: ( rule__XEqualityExpression__Group_1__0 )
        // InternalPureXbase.g:5475:3: rule__XEqualityExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XEqualityExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred101_InternalPureXbase

    // $ANTLR start synpred102_InternalPureXbase
    public final void synpred102_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:5664:3: ( rule__XRelationalExpression__Alternatives_1 )
        // InternalPureXbase.g:5664:3: rule__XRelationalExpression__Alternatives_1
        {
        pushFollow(FOLLOW_2);
        rule__XRelationalExpression__Alternatives_1();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred102_InternalPureXbase

    // $ANTLR start synpred103_InternalPureXbase
    public final void synpred103_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:6042:3: ( rule__XOtherOperatorExpression__Group_1__0 )
        // InternalPureXbase.g:6042:3: rule__XOtherOperatorExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XOtherOperatorExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred103_InternalPureXbase

    // $ANTLR start synpred104_InternalPureXbase
    public final void synpred104_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:6555:3: ( rule__XAdditiveExpression__Group_1__0 )
        // InternalPureXbase.g:6555:3: rule__XAdditiveExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XAdditiveExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred104_InternalPureXbase

    // $ANTLR start synpred105_InternalPureXbase
    public final void synpred105_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:6744:3: ( rule__XMultiplicativeExpression__Group_1__0 )
        // InternalPureXbase.g:6744:3: rule__XMultiplicativeExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XMultiplicativeExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred105_InternalPureXbase

    // $ANTLR start synpred106_InternalPureXbase
    public final void synpred106_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:7014:3: ( rule__XCastedExpression__Group_1__0 )
        // InternalPureXbase.g:7014:3: rule__XCastedExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XCastedExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred106_InternalPureXbase

    // $ANTLR start synpred107_InternalPureXbase
    public final void synpred107_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:7203:3: ( rule__XPostfixOperation__Group_1__0 )
        // InternalPureXbase.g:7203:3: rule__XPostfixOperation__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XPostfixOperation__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred107_InternalPureXbase

    // $ANTLR start synpred108_InternalPureXbase
    public final void synpred108_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:7338:3: ( rule__XMemberFeatureCall__Alternatives_1 )
        // InternalPureXbase.g:7338:3: rule__XMemberFeatureCall__Alternatives_1
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__Alternatives_1();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred108_InternalPureXbase

    // $ANTLR start synpred110_InternalPureXbase
    public final void synpred110_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:7636:3: ( rule__XMemberFeatureCall__Group_1_1_3__0 )
        // InternalPureXbase.g:7636:3: rule__XMemberFeatureCall__Group_1_1_3__0
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__Group_1_1_3__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred110_InternalPureXbase

    // $ANTLR start synpred111_InternalPureXbase
    public final void synpred111_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:7662:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )
        // InternalPureXbase.g:7662:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred111_InternalPureXbase

    // $ANTLR start synpred119_InternalPureXbase
    public final void synpred119_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:8635:3: ( rule__XClosure__Group_1__0 )
        // InternalPureXbase.g:8635:3: rule__XClosure__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XClosure__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred119_InternalPureXbase

    // $ANTLR start synpred126_InternalPureXbase
    public final void synpred126_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:9606:3: ( rule__XIfExpression__Group_6__0 )
        // InternalPureXbase.g:9606:3: rule__XIfExpression__Group_6__0
        {
        pushFollow(FOLLOW_2);
        rule__XIfExpression__Group_6__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred126_InternalPureXbase

    // $ANTLR start synpred129_InternalPureXbase
    public final void synpred129_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:10066:3: ( rule__XSwitchExpression__Group_2_1_0__0 )
        // InternalPureXbase.g:10066:3: rule__XSwitchExpression__Group_2_1_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XSwitchExpression__Group_2_1_0__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred129_InternalPureXbase

    // $ANTLR start synpred142_InternalPureXbase
    public final void synpred142_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:12199:3: ( rule__XFeatureCall__Group_3__0 )
        // InternalPureXbase.g:12199:3: rule__XFeatureCall__Group_3__0
        {
        pushFollow(FOLLOW_2);
        rule__XFeatureCall__Group_3__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred142_InternalPureXbase

    // $ANTLR start synpred143_InternalPureXbase
    public final void synpred143_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:12225:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )
        // InternalPureXbase.g:12225:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_4
        {
        pushFollow(FOLLOW_2);
        rule__XFeatureCall__FeatureCallArgumentsAssignment_4();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred143_InternalPureXbase

    // $ANTLR start synpred147_InternalPureXbase
    public final void synpred147_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:12685:3: ( rule__XConstructorCall__Group_3__0 )
        // InternalPureXbase.g:12685:3: rule__XConstructorCall__Group_3__0
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__Group_3__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred147_InternalPureXbase

    // $ANTLR start synpred148_InternalPureXbase
    public final void synpred148_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:12712:3: ( rule__XConstructorCall__Group_4__0 )
        // InternalPureXbase.g:12712:3: rule__XConstructorCall__Group_4__0
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__Group_4__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred148_InternalPureXbase

    // $ANTLR start synpred149_InternalPureXbase
    public final void synpred149_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:12738:3: ( rule__XConstructorCall__ArgumentsAssignment_5 )
        // InternalPureXbase.g:12738:3: rule__XConstructorCall__ArgumentsAssignment_5
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__ArgumentsAssignment_5();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred149_InternalPureXbase

    // $ANTLR start synpred154_InternalPureXbase
    public final void synpred154_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:13629:3: ( rule__XReturnExpression__ExpressionAssignment_2 )
        // InternalPureXbase.g:13629:3: rule__XReturnExpression__ExpressionAssignment_2
        {
        pushFollow(FOLLOW_2);
        rule__XReturnExpression__ExpressionAssignment_2();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred154_InternalPureXbase

    // $ANTLR start synpred155_InternalPureXbase
    public final void synpred155_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:14034:3: ( rule__QualifiedName__Group_1__0 )
        // InternalPureXbase.g:14034:3: rule__QualifiedName__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__QualifiedName__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred155_InternalPureXbase

    // $ANTLR start synpred157_InternalPureXbase
    public final void synpred157_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:14250:3: ( rule__JvmTypeReference__Group_0_1__0 )
        // InternalPureXbase.g:14250:3: rule__JvmTypeReference__Group_0_1__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmTypeReference__Group_0_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred157_InternalPureXbase

    // $ANTLR start synpred161_InternalPureXbase
    public final void synpred161_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:14709:3: ( rule__JvmParameterizedTypeReference__Group_1__0 )
        // InternalPureXbase.g:14709:3: rule__JvmParameterizedTypeReference__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmParameterizedTypeReference__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred161_InternalPureXbase

    // $ANTLR start synpred163_InternalPureXbase
    public final void synpred163_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:14844:3: ( rule__JvmParameterizedTypeReference__Group_1_4__0 )
        // InternalPureXbase.g:14844:3: rule__JvmParameterizedTypeReference__Group_1_4__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmParameterizedTypeReference__Group_1_4__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred163_InternalPureXbase

    // $ANTLR start synpred164_InternalPureXbase
    public final void synpred164_InternalPureXbase_fragment() throws RecognitionException {   
        // InternalPureXbase.g:14979:3: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )
        // InternalPureXbase.g:14979:3: rule__JvmParameterizedTypeReference__Group_1_4_2__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmParameterizedTypeReference__Group_1_4_2__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred164_InternalPureXbase

    // Delegated rules

    public final boolean synpred100_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred100_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred90_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred90_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred110_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred110_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred149_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred149_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred99_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred99_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred108_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred108_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred161_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred161_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred164_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred164_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred93_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred93_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred96_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred96_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred157_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred157_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred53_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred53_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred105_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred105_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred154_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred154_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred111_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred111_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred148_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred148_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred91_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred91_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred94_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred94_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred101_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred101_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred107_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred107_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred142_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred142_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred97_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred97_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred54_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred54_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred67_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred67_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred71_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred71_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred74_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred74_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred104_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred104_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred155_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred155_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred31_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred31_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred147_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred147_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred102_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred102_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred95_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred95_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred72_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred72_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred106_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred106_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred119_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred119_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred129_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred129_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred92_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred92_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred103_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred103_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred32_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred32_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred163_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred163_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred45_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred45_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred126_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred126_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred143_InternalPureXbase() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred143_InternalPureXbase_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA13 dfa13 = new DFA13(this);
    protected DFA24 dfa24 = new DFA24(this);
    protected DFA25 dfa25 = new DFA25(this);
    protected DFA28 dfa28 = new DFA28(this);
    protected DFA33 dfa33 = new DFA33(this);
    protected DFA35 dfa35 = new DFA35(this);
    protected DFA43 dfa43 = new DFA43(this);
    protected DFA55 dfa55 = new DFA55(this);
    protected DFA63 dfa63 = new DFA63(this);
    protected DFA70 dfa70 = new DFA70(this);
    protected DFA71 dfa71 = new DFA71(this);
    protected DFA79 dfa79 = new DFA79(this);
    protected DFA89 dfa89 = new DFA89(this);
    protected DFA102 dfa102 = new DFA102(this);
    protected DFA103 dfa103 = new DFA103(this);
    protected DFA107 dfa107 = new DFA107(this);
    protected DFA108 dfa108 = new DFA108(this);
    protected DFA109 dfa109 = new DFA109(this);
    protected DFA114 dfa114 = new DFA114(this);
    protected DFA121 dfa121 = new DFA121(this);
    protected DFA124 dfa124 = new DFA124(this);
    static final String dfa_1s = "\13\uffff";
    static final String dfa_2s = "\1\33\2\uffff\1\33\7\uffff";
    static final String dfa_3s = "\1\42\2\uffff\1\37\7\uffff";
    static final String dfa_4s = "\1\uffff\1\1\1\2\1\uffff\1\4\1\5\1\7\1\10\1\11\1\6\1\3";
    static final String dfa_5s = "\13\uffff}>";
    static final String[] dfa_6s = {
            "\1\3\1\6\1\1\1\2\1\4\1\5\1\7\1\10",
            "",
            "",
            "\1\11\3\uffff\1\12",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_1 = DFA.unpackEncodedString(dfa_1s);
    static final char[] dfa_2 = DFA.unpackEncodedStringToUnsignedChars(dfa_2s);
    static final char[] dfa_3 = DFA.unpackEncodedStringToUnsignedChars(dfa_3s);
    static final short[] dfa_4 = DFA.unpackEncodedString(dfa_4s);
    static final short[] dfa_5 = DFA.unpackEncodedString(dfa_5s);
    static final short[][] dfa_6 = unpackEncodedStringArray(dfa_6s);

    class DFA13 extends DFA {

        public DFA13(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 13;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_6;
        }
        public String getDescription() {
            return "2344:1: rule__OpOther__Alternatives : ( ( '->' ) | ( '..<' ) | ( ( rule__OpOther__Group_2__0 ) ) | ( '..' ) | ( '=>' ) | ( ( rule__OpOther__Group_5__0 ) ) | ( ( rule__OpOther__Group_6__0 ) ) | ( '<>' ) | ( '?:' ) );";
        }
    }
    static final String dfa_7s = "\37\uffff";
    static final String dfa_8s = "\1\4\2\0\34\uffff";
    static final String dfa_9s = "\1\124\2\0\34\uffff";
    static final String dfa_10s = "\3\uffff\1\1\1\uffff\1\2\31\uffff";
    static final String dfa_11s = "\1\uffff\1\0\1\1\34\uffff}>";
    static final String[] dfa_12s = {
            "\1\1\4\5\23\uffff\1\5\3\uffff\1\3\2\uffff\2\5\4\uffff\1\5\3\uffff\2\5\1\uffff\1\5\1\2\6\uffff\2\5\1\uffff\1\5\1\uffff\1\5\1\uffff\1\5\2\uffff\11\5\10\uffff\1\3\1\5",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_7 = DFA.unpackEncodedString(dfa_7s);
    static final char[] dfa_8 = DFA.unpackEncodedStringToUnsignedChars(dfa_8s);
    static final char[] dfa_9 = DFA.unpackEncodedStringToUnsignedChars(dfa_9s);
    static final short[] dfa_10 = DFA.unpackEncodedString(dfa_10s);
    static final short[] dfa_11 = DFA.unpackEncodedString(dfa_11s);
    static final short[][] dfa_12 = unpackEncodedStringArray(dfa_12s);

    class DFA24 extends DFA {

        public DFA24(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 24;
            this.eot = dfa_7;
            this.eof = dfa_7;
            this.min = dfa_8;
            this.max = dfa_9;
            this.accept = dfa_10;
            this.special = dfa_11;
            this.transition = dfa_12;
        }
        public String getDescription() {
            return "2647:1: rule__XMemberFeatureCall__Alternatives_1_1_3_1 : ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA24_1 = input.LA(1);

                         
                        int index24_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred45_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index24_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA24_2 = input.LA(1);

                         
                        int index24_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred45_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index24_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 24, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_13s = "\34\uffff";
    static final String dfa_14s = "\1\4\22\uffff\1\0\10\uffff";
    static final String dfa_15s = "\1\124\22\uffff\1\0\10\uffff";
    static final String dfa_16s = "\1\uffff\1\1\1\2\1\3\1\4\1\5\2\uffff\1\6\11\uffff\1\7\1\uffff\1\12\1\13\1\14\1\15\1\16\1\17\1\10\1\11";
    static final String dfa_17s = "\23\uffff\1\0\10\uffff}>";
    static final String[] dfa_18s = {
            "\1\5\4\10\23\uffff\1\5\20\uffff\1\5\1\10\1\uffff\1\30\1\31\6\uffff\1\10\1\2\1\uffff\1\10\1\uffff\1\22\1\uffff\1\3\2\uffff\1\23\1\24\1\25\1\1\2\10\1\26\1\27\1\4\11\uffff\1\10",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_13 = DFA.unpackEncodedString(dfa_13s);
    static final char[] dfa_14 = DFA.unpackEncodedStringToUnsignedChars(dfa_14s);
    static final char[] dfa_15 = DFA.unpackEncodedStringToUnsignedChars(dfa_15s);
    static final short[] dfa_16 = DFA.unpackEncodedString(dfa_16s);
    static final short[] dfa_17 = DFA.unpackEncodedString(dfa_17s);
    static final short[][] dfa_18 = unpackEncodedStringArray(dfa_18s);

    class DFA25 extends DFA {

        public DFA25(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 25;
            this.eot = dfa_13;
            this.eof = dfa_13;
            this.min = dfa_14;
            this.max = dfa_15;
            this.accept = dfa_16;
            this.special = dfa_17;
            this.transition = dfa_18;
        }
        public String getDescription() {
            return "2668:1: rule__XPrimaryExpression__Alternatives : ( ( ruleXConstructorCall ) | ( ruleXBlockExpression ) | ( ruleXSwitchExpression ) | ( ( ruleXSynchronizedExpression ) ) | ( ruleXFeatureCall ) | ( ruleXLiteral ) | ( ruleXIfExpression ) | ( ( ruleXForLoopExpression ) ) | ( ruleXBasicForLoopExpression ) | ( ruleXWhileExpression ) | ( ruleXDoWhileExpression ) | ( ruleXThrowExpression ) | ( ruleXReturnExpression ) | ( ruleXTryCatchFinallyExpression ) | ( ruleXParenthesizedExpression ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA25_19 = input.LA(1);

                         
                        int index25_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalPureXbase()) ) {s = 26;}

                        else if ( (synpred54_InternalPureXbase()) ) {s = 27;}

                         
                        input.seek(index25_19);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 25, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_19s = "\1\4\1\0\35\uffff";
    static final String dfa_20s = "\1\124\1\0\35\uffff";
    static final String dfa_21s = "\2\uffff\1\2\33\uffff\1\1";
    static final String dfa_22s = "\1\uffff\1\0\35\uffff}>";
    static final String[] dfa_23s = {
            "\5\2\23\uffff\1\2\3\uffff\1\2\2\uffff\2\2\4\uffff\1\2\3\uffff\2\2\1\uffff\1\2\1\1\6\uffff\2\2\1\uffff\1\2\1\uffff\1\2\1\uffff\1\2\2\uffff\11\2\11\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final char[] dfa_19 = DFA.unpackEncodedStringToUnsignedChars(dfa_19s);
    static final char[] dfa_20 = DFA.unpackEncodedStringToUnsignedChars(dfa_20s);
    static final short[] dfa_21 = DFA.unpackEncodedString(dfa_21s);
    static final short[] dfa_22 = DFA.unpackEncodedString(dfa_22s);
    static final short[][] dfa_23 = unpackEncodedStringArray(dfa_23s);

    class DFA28 extends DFA {

        public DFA28(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 28;
            this.eot = dfa_7;
            this.eof = dfa_7;
            this.min = dfa_19;
            this.max = dfa_20;
            this.accept = dfa_21;
            this.special = dfa_22;
            this.transition = dfa_23;
        }
        public String getDescription() {
            return "2839:1: rule__XSwitchExpression__Alternatives_2 : ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) | ( ( rule__XSwitchExpression__Group_2_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA28_1 = input.LA(1);

                         
                        int index28_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred67_InternalPureXbase()) ) {s = 30;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index28_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 28, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA33 extends DFA {

        public DFA33(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 33;
            this.eot = dfa_7;
            this.eof = dfa_7;
            this.min = dfa_8;
            this.max = dfa_9;
            this.accept = dfa_10;
            this.special = dfa_11;
            this.transition = dfa_12;
        }
        public String getDescription() {
            return "2944:1: rule__XFeatureCall__Alternatives_3_1 : ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) | ( ( rule__XFeatureCall__Group_3_1_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA33_1 = input.LA(1);

                         
                        int index33_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred72_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index33_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA33_2 = input.LA(1);

                         
                        int index33_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred72_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index33_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 33, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA35 extends DFA {

        public DFA35(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 35;
            this.eot = dfa_7;
            this.eof = dfa_7;
            this.min = dfa_8;
            this.max = dfa_9;
            this.accept = dfa_10;
            this.special = dfa_11;
            this.transition = dfa_12;
        }
        public String getDescription() {
            return "2986:1: rule__XConstructorCall__Alternatives_4_1 : ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) | ( ( rule__XConstructorCall__Group_4_1_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA35_1 = input.LA(1);

                         
                        int index35_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index35_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA35_2 = input.LA(1);

                         
                        int index35_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index35_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 35, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_24s = "\7\uffff";
    static final String dfa_25s = "\2\uffff\1\4\2\uffff\1\4\1\uffff";
    static final String dfa_26s = "\1\4\1\uffff\2\4\1\uffff\1\4\1\uffff";
    static final String dfa_27s = "\1\125\1\uffff\1\124\1\45\1\uffff\1\124\1\uffff";
    static final String dfa_28s = "\1\uffff\1\1\2\uffff\1\2\1\uffff\1\3";
    static final String dfa_29s = "\7\uffff}>";
    static final String[] dfa_30s = {
            "\1\2\120\uffff\1\1",
            "",
            "\5\4\7\uffff\1\4\13\uffff\1\4\6\uffff\2\4\4\uffff\1\4\2\uffff\1\3\5\4\6\uffff\2\4\1\uffff\1\4\1\uffff\1\4\1\uffff\1\4\2\uffff\11\4\4\uffff\2\4\3\uffff\1\4",
            "\1\5\40\uffff\1\6",
            "",
            "\5\4\7\uffff\1\4\13\uffff\1\4\6\uffff\2\4\4\uffff\1\4\2\uffff\1\3\5\4\6\uffff\2\4\1\uffff\1\4\1\uffff\1\4\1\uffff\1\4\2\uffff\11\4\4\uffff\2\4\3\uffff\1\4",
            ""
    };

    static final short[] dfa_24 = DFA.unpackEncodedString(dfa_24s);
    static final short[] dfa_25 = DFA.unpackEncodedString(dfa_25s);
    static final char[] dfa_26 = DFA.unpackEncodedStringToUnsignedChars(dfa_26s);
    static final char[] dfa_27 = DFA.unpackEncodedStringToUnsignedChars(dfa_27s);
    static final short[] dfa_28 = DFA.unpackEncodedString(dfa_28s);
    static final short[] dfa_29 = DFA.unpackEncodedString(dfa_29s);
    static final short[][] dfa_30 = unpackEncodedStringArray(dfa_30s);

    class DFA43 extends DFA {

        public DFA43(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 43;
            this.eot = dfa_24;
            this.eof = dfa_25;
            this.min = dfa_26;
            this.max = dfa_27;
            this.accept = dfa_28;
            this.special = dfa_29;
            this.transition = dfa_30;
        }
        public String getDescription() {
            return "3154:1: rule__XImportDeclaration__Alternatives_1 : ( ( ( rule__XImportDeclaration__Group_1_0__0 ) ) | ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) ) | ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) ) );";
        }
    }
    static final String dfa_31s = "\12\uffff";
    static final String dfa_32s = "\1\10\11\uffff";
    static final String dfa_33s = "\1\4\7\0\2\uffff";
    static final String dfa_34s = "\1\124\7\0\2\uffff";
    static final String dfa_35s = "\10\uffff\1\2\1\1";
    static final String dfa_36s = "\1\uffff\1\3\1\2\1\6\1\5\1\4\1\0\1\1\2\uffff}>";
    static final String[] dfa_37s = {
            "\5\10\5\uffff\3\10\1\1\1\2\1\3\1\4\1\5\5\10\1\7\1\6\60\10\3\uffff\3\10\1\uffff\1\10",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            ""
    };

    static final short[] dfa_31 = DFA.unpackEncodedString(dfa_31s);
    static final short[] dfa_32 = DFA.unpackEncodedString(dfa_32s);
    static final char[] dfa_33 = DFA.unpackEncodedStringToUnsignedChars(dfa_33s);
    static final char[] dfa_34 = DFA.unpackEncodedStringToUnsignedChars(dfa_34s);
    static final short[] dfa_35 = DFA.unpackEncodedString(dfa_35s);
    static final short[] dfa_36 = DFA.unpackEncodedString(dfa_36s);
    static final short[][] dfa_37 = unpackEncodedStringArray(dfa_37s);

    class DFA55 extends DFA {

        public DFA55(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 55;
            this.eot = dfa_31;
            this.eof = dfa_32;
            this.min = dfa_33;
            this.max = dfa_34;
            this.accept = dfa_35;
            this.special = dfa_36;
            this.transition = dfa_37;
        }
        public String getDescription() {
            return "4476:2: ( rule__XAssignment__Group_1_1__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA55_6 = input.LA(1);

                         
                        int index55_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_6);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA55_7 = input.LA(1);

                         
                        int index55_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_7);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA55_2 = input.LA(1);

                         
                        int index55_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA55_1 = input.LA(1);

                         
                        int index55_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_1);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA55_5 = input.LA(1);

                         
                        int index55_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA55_4 = input.LA(1);

                         
                        int index55_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_4);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA55_3 = input.LA(1);

                         
                        int index55_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred95_InternalPureXbase()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index55_3);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 55, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_38s = "\1\1\12\uffff";
    static final String dfa_39s = "\1\4\1\uffff\10\0\1\uffff";
    static final String dfa_40s = "\1\124\1\uffff\10\0\1\uffff";
    static final String dfa_41s = "\1\uffff\1\2\10\uffff\1\1";
    static final String dfa_42s = "\2\uffff\1\6\1\7\1\5\1\1\1\0\1\2\1\4\1\3\1\uffff}>";
    static final String[] dfa_43s = {
            "\5\1\5\uffff\15\1\1\3\1\2\1\4\1\5\1\6\1\7\1\10\1\11\52\1\3\uffff\3\1\1\uffff\1\1",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };
    static final short[] dfa_38 = DFA.unpackEncodedString(dfa_38s);
    static final char[] dfa_39 = DFA.unpackEncodedStringToUnsignedChars(dfa_39s);
    static final char[] dfa_40 = DFA.unpackEncodedStringToUnsignedChars(dfa_40s);
    static final short[] dfa_41 = DFA.unpackEncodedString(dfa_41s);
    static final short[] dfa_42 = DFA.unpackEncodedString(dfa_42s);
    static final short[][] dfa_43 = unpackEncodedStringArray(dfa_43s);

    class DFA63 extends DFA {

        public DFA63(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 63;
            this.eot = dfa_1;
            this.eof = dfa_38;
            this.min = dfa_39;
            this.max = dfa_40;
            this.accept = dfa_41;
            this.special = dfa_42;
            this.transition = dfa_43;
        }
        public String getDescription() {
            return "()* loopback of 6042:2: ( rule__XOtherOperatorExpression__Group_1__0 )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA63_6 = input.LA(1);

                         
                        int index63_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_6);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA63_5 = input.LA(1);

                         
                        int index63_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_5);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA63_7 = input.LA(1);

                         
                        int index63_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_7);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA63_9 = input.LA(1);

                         
                        int index63_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_9);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA63_8 = input.LA(1);

                         
                        int index63_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_8);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA63_4 = input.LA(1);

                         
                        int index63_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_4);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA63_2 = input.LA(1);

                         
                        int index63_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_2);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA63_3 = input.LA(1);

                         
                        int index63_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalPureXbase()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index63_3);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 63, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_44s = "\113\uffff";
    static final String dfa_45s = "\1\2\112\uffff";
    static final String dfa_46s = "\1\4\1\0\111\uffff";
    static final String dfa_47s = "\1\124\1\0\111\uffff";
    static final String dfa_48s = "\2\uffff\1\2\107\uffff\1\1";
    static final String dfa_49s = "\1\uffff\1\0\111\uffff}>";
    static final String[] dfa_50s = {
            "\5\2\5\uffff\43\2\1\1\33\2\3\uffff\3\2\1\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_44 = DFA.unpackEncodedString(dfa_44s);
    static final short[] dfa_45 = DFA.unpackEncodedString(dfa_45s);
    static final char[] dfa_46 = DFA.unpackEncodedStringToUnsignedChars(dfa_46s);
    static final char[] dfa_47 = DFA.unpackEncodedStringToUnsignedChars(dfa_47s);
    static final short[] dfa_48 = DFA.unpackEncodedString(dfa_48s);
    static final short[] dfa_49 = DFA.unpackEncodedString(dfa_49s);
    static final short[][] dfa_50 = unpackEncodedStringArray(dfa_50s);

    class DFA70 extends DFA {

        public DFA70(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 70;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_50;
        }
        public String getDescription() {
            return "7636:2: ( rule__XMemberFeatureCall__Group_1_1_3__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA70_1 = input.LA(1);

                         
                        int index70_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred110_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index70_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 70, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_51s = {
            "\5\2\5\uffff\55\2\1\1\21\2\3\uffff\3\2\1\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_51 = unpackEncodedStringArray(dfa_51s);

    class DFA71 extends DFA {

        public DFA71(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 71;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_51;
        }
        public String getDescription() {
            return "7662:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA71_1 = input.LA(1);

                         
                        int index71_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred111_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index71_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 71, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_52s = "\42\uffff";
    static final String dfa_53s = "\1\4\2\0\37\uffff";
    static final String dfa_54s = "\1\124\2\0\37\uffff";
    static final String dfa_55s = "\3\uffff\1\1\1\uffff\1\2\34\uffff";
    static final String dfa_56s = "\1\uffff\1\0\1\1\37\uffff}>";
    static final String[] dfa_57s = {
            "\1\1\4\5\7\uffff\1\5\13\uffff\1\5\3\uffff\1\3\2\uffff\2\5\4\uffff\1\5\3\uffff\2\5\1\uffff\1\5\1\2\6\uffff\2\5\1\uffff\3\5\1\uffff\1\5\2\uffff\11\5\5\uffff\1\5\2\uffff\1\3\1\5",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_52 = DFA.unpackEncodedString(dfa_52s);
    static final char[] dfa_53 = DFA.unpackEncodedStringToUnsignedChars(dfa_53s);
    static final char[] dfa_54 = DFA.unpackEncodedStringToUnsignedChars(dfa_54s);
    static final short[] dfa_55 = DFA.unpackEncodedString(dfa_55s);
    static final short[] dfa_56 = DFA.unpackEncodedString(dfa_56s);
    static final short[][] dfa_57 = unpackEncodedStringArray(dfa_57s);

    class DFA79 extends DFA {

        public DFA79(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 79;
            this.eot = dfa_52;
            this.eof = dfa_52;
            this.min = dfa_53;
            this.max = dfa_54;
            this.accept = dfa_55;
            this.special = dfa_56;
            this.transition = dfa_57;
        }
        public String getDescription() {
            return "8635:2: ( rule__XClosure__Group_1__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA79_1 = input.LA(1);

                         
                        int index79_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred119_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index79_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA79_2 = input.LA(1);

                         
                        int index79_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred119_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index79_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 79, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_58s = "\36\uffff";
    static final String dfa_59s = "\1\4\2\0\33\uffff";
    static final String dfa_60s = "\1\124\2\0\33\uffff";
    static final String dfa_61s = "\3\uffff\1\1\1\2\31\uffff";
    static final String dfa_62s = "\1\uffff\1\0\1\1\33\uffff}>";
    static final String[] dfa_63s = {
            "\1\1\4\4\23\uffff\1\4\3\uffff\1\3\2\uffff\2\4\4\uffff\1\4\3\uffff\2\4\1\uffff\1\4\1\2\6\uffff\2\4\1\uffff\1\4\1\uffff\1\4\1\uffff\1\4\2\uffff\11\4\11\uffff\1\4",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_58 = DFA.unpackEncodedString(dfa_58s);
    static final char[] dfa_59 = DFA.unpackEncodedStringToUnsignedChars(dfa_59s);
    static final char[] dfa_60 = DFA.unpackEncodedStringToUnsignedChars(dfa_60s);
    static final short[] dfa_61 = DFA.unpackEncodedString(dfa_61s);
    static final short[] dfa_62 = DFA.unpackEncodedString(dfa_62s);
    static final short[][] dfa_63 = unpackEncodedStringArray(dfa_63s);

    class DFA89 extends DFA {

        public DFA89(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 89;
            this.eot = dfa_58;
            this.eof = dfa_58;
            this.min = dfa_59;
            this.max = dfa_60;
            this.accept = dfa_61;
            this.special = dfa_62;
            this.transition = dfa_63;
        }
        public String getDescription() {
            return "10066:2: ( rule__XSwitchExpression__Group_2_1_0__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA89_1 = input.LA(1);

                         
                        int index89_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred129_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index89_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA89_2 = input.LA(1);

                         
                        int index89_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred129_InternalPureXbase()) ) {s = 3;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index89_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 89, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA102 extends DFA {

        public DFA102(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 102;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_50;
        }
        public String getDescription() {
            return "12199:2: ( rule__XFeatureCall__Group_3__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA102_1 = input.LA(1);

                         
                        int index102_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred142_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index102_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 102, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA103 extends DFA {

        public DFA103(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 103;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_51;
        }
        public String getDescription() {
            return "12225:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA103_1 = input.LA(1);

                         
                        int index103_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred143_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index103_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 103, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_64s = {
            "\5\2\5\uffff\16\2\1\1\60\2\3\uffff\3\2\1\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_64 = unpackEncodedStringArray(dfa_64s);

    class DFA107 extends DFA {

        public DFA107(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 107;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_64;
        }
        public String getDescription() {
            return "12685:2: ( rule__XConstructorCall__Group_3__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA107_1 = input.LA(1);

                         
                        int index107_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred147_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index107_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 107, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA108 extends DFA {

        public DFA108(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 108;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_50;
        }
        public String getDescription() {
            return "12712:2: ( rule__XConstructorCall__Group_4__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA108_1 = input.LA(1);

                         
                        int index108_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred148_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index108_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 108, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA109 extends DFA {

        public DFA109(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 109;
            this.eot = dfa_44;
            this.eof = dfa_45;
            this.min = dfa_46;
            this.max = dfa_47;
            this.accept = dfa_48;
            this.special = dfa_49;
            this.transition = dfa_51;
        }
        public String getDescription() {
            return "12738:2: ( rule__XConstructorCall__ArgumentsAssignment_5 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA109_1 = input.LA(1);

                         
                        int index109_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred149_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index109_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 109, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_65s = "\1\35\112\uffff";
    static final String dfa_66s = "\1\4\34\0\56\uffff";
    static final String dfa_67s = "\1\124\34\0\56\uffff";
    static final String dfa_68s = "\35\uffff\1\2\54\uffff\1\1";
    static final String dfa_69s = "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33\56\uffff}>";
    static final String[] dfa_70s = {
            "\1\1\1\17\1\20\1\21\1\23\5\uffff\16\35\1\11\6\35\1\4\1\3\4\35\1\2\3\35\1\12\1\15\1\35\1\33\1\34\6\35\1\13\1\6\1\35\1\14\1\35\1\25\1\35\1\7\2\35\1\26\1\27\1\30\1\5\1\22\1\24\1\31\1\32\1\10\2\35\3\uffff\3\35\1\uffff\1\16",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[] dfa_65 = DFA.unpackEncodedString(dfa_65s);
    static final char[] dfa_66 = DFA.unpackEncodedStringToUnsignedChars(dfa_66s);
    static final char[] dfa_67 = DFA.unpackEncodedStringToUnsignedChars(dfa_67s);
    static final short[] dfa_68 = DFA.unpackEncodedString(dfa_68s);
    static final short[] dfa_69 = DFA.unpackEncodedString(dfa_69s);
    static final short[][] dfa_70 = unpackEncodedStringArray(dfa_70s);

    class DFA114 extends DFA {

        public DFA114(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 114;
            this.eot = dfa_44;
            this.eof = dfa_65;
            this.min = dfa_66;
            this.max = dfa_67;
            this.accept = dfa_68;
            this.special = dfa_69;
            this.transition = dfa_70;
        }
        public String getDescription() {
            return "13629:2: ( rule__XReturnExpression__ExpressionAssignment_2 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA114_1 = input.LA(1);

                         
                        int index114_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA114_2 = input.LA(1);

                         
                        int index114_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA114_3 = input.LA(1);

                         
                        int index114_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA114_4 = input.LA(1);

                         
                        int index114_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA114_5 = input.LA(1);

                         
                        int index114_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA114_6 = input.LA(1);

                         
                        int index114_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_6);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA114_7 = input.LA(1);

                         
                        int index114_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_7);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA114_8 = input.LA(1);

                         
                        int index114_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_8);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA114_9 = input.LA(1);

                         
                        int index114_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_9);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA114_10 = input.LA(1);

                         
                        int index114_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA114_11 = input.LA(1);

                         
                        int index114_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA114_12 = input.LA(1);

                         
                        int index114_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA114_13 = input.LA(1);

                         
                        int index114_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA114_14 = input.LA(1);

                         
                        int index114_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA114_15 = input.LA(1);

                         
                        int index114_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA114_16 = input.LA(1);

                         
                        int index114_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA114_17 = input.LA(1);

                         
                        int index114_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA114_18 = input.LA(1);

                         
                        int index114_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA114_19 = input.LA(1);

                         
                        int index114_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA114_20 = input.LA(1);

                         
                        int index114_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA114_21 = input.LA(1);

                         
                        int index114_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA114_22 = input.LA(1);

                         
                        int index114_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA114_23 = input.LA(1);

                         
                        int index114_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA114_24 = input.LA(1);

                         
                        int index114_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA114_25 = input.LA(1);

                         
                        int index114_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA114_26 = input.LA(1);

                         
                        int index114_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA114_27 = input.LA(1);

                         
                        int index114_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA114_28 = input.LA(1);

                         
                        int index114_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalPureXbase()) ) {s = 74;}

                        else if ( (true) ) {s = 29;}

                         
                        input.seek(index114_28);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 114, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_71s = "\114\uffff";
    static final String dfa_72s = "\1\2\113\uffff";
    static final String dfa_73s = "\1\4\1\0\112\uffff";
    static final String dfa_74s = "\1\124\1\0\112\uffff";
    static final String dfa_75s = "\2\uffff\1\2\110\uffff\1\1";
    static final String dfa_76s = "\1\uffff\1\0\112\uffff}>";
    static final String[] dfa_77s = {
            "\5\2\5\uffff\16\2\1\1\60\2\1\uffff\1\2\1\uffff\3\2\1\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_71 = DFA.unpackEncodedString(dfa_71s);
    static final short[] dfa_72 = DFA.unpackEncodedString(dfa_72s);
    static final char[] dfa_73 = DFA.unpackEncodedStringToUnsignedChars(dfa_73s);
    static final char[] dfa_74 = DFA.unpackEncodedStringToUnsignedChars(dfa_74s);
    static final short[] dfa_75 = DFA.unpackEncodedString(dfa_75s);
    static final short[] dfa_76 = DFA.unpackEncodedString(dfa_76s);
    static final short[][] dfa_77 = unpackEncodedStringArray(dfa_77s);

    class DFA121 extends DFA {

        public DFA121(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 121;
            this.eot = dfa_71;
            this.eof = dfa_72;
            this.min = dfa_73;
            this.max = dfa_74;
            this.accept = dfa_75;
            this.special = dfa_76;
            this.transition = dfa_77;
        }
        public String getDescription() {
            return "14709:2: ( rule__JvmParameterizedTypeReference__Group_1__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA121_1 = input.LA(1);

                         
                        int index121_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred161_InternalPureXbase()) ) {s = 75;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index121_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 121, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA124 extends DFA {

        public DFA124(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 124;
            this.eot = dfa_71;
            this.eof = dfa_72;
            this.min = dfa_73;
            this.max = dfa_74;
            this.accept = dfa_75;
            this.special = dfa_76;
            this.transition = dfa_77;
        }
        public String getDescription() {
            return "14979:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA124_1 = input.LA(1);

                         
                        int index124_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred164_InternalPureXbase()) ) {s = 75;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index124_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 124, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000002L,0x0000000000008000L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0xAB036218100101F0L,0x00000000001107FCL});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0xAB036218100101F2L,0x00000000001107FCL});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000800000000000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0001000000000000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000010000L,0x0000000000010000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0004800000000000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000800000000002L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0008000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000800L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0002000100000010L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x00000000183E0000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0010000000000000L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x000000000C000000L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000003C00000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000000003C00002L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x002000001C000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x002000001C000002L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x00000007F8000000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x00000007F8000002L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000000110000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0000001800000000L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000001800000002L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x000001E000000000L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0x000001E000000002L});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x0000021800000000L});
    public static final BitSet FOLLOW_42 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_43 = new BitSet(new long[]{0x0040000000000002L});
    public static final BitSet FOLLOW_44 = new BitSet(new long[]{0x00000C0000000000L});
    public static final BitSet FOLLOW_45 = new BitSet(new long[]{0x0000100000000000L,0x0000000000060000L});
    public static final BitSet FOLLOW_46 = new BitSet(new long[]{0x0000100000000002L,0x0000000000060000L});
    public static final BitSet FOLLOW_47 = new BitSet(new long[]{0x0000100000000000L,0x0000000000020000L});
    public static final BitSet FOLLOW_48 = new BitSet(new long[]{0x0000200010000010L});
    public static final BitSet FOLLOW_49 = new BitSet(new long[]{0x0802000000000000L});
    public static final BitSet FOLLOW_50 = new BitSet(new long[]{0x0002000100000010L,0x0000000000001000L});
    public static final BitSet FOLLOW_51 = new BitSet(new long[]{0x0080000008000000L});
    public static final BitSet FOLLOW_52 = new BitSet(new long[]{0x0080000000000002L});
    public static final BitSet FOLLOW_53 = new BitSet(new long[]{0xAB076219100101F0L,0x00000000001907FCL});
    public static final BitSet FOLLOW_54 = new BitSet(new long[]{0x0080000000000000L});
    public static final BitSet FOLLOW_55 = new BitSet(new long[]{0x0100000000000000L});
    public static final BitSet FOLLOW_56 = new BitSet(new long[]{0x0200000000000000L});
    public static final BitSet FOLLOW_57 = new BitSet(new long[]{0xAF036218100101F0L,0x00000000001107FCL});
    public static final BitSet FOLLOW_58 = new BitSet(new long[]{0x0800000000000000L});
    public static final BitSet FOLLOW_59 = new BitSet(new long[]{0xBB036218100101F0L,0x00000000001107FCL});
    public static final BitSet FOLLOW_60 = new BitSet(new long[]{0xAB036219100101F0L,0x00000000001907FCL});
    public static final BitSet FOLLOW_61 = new BitSet(new long[]{0x1000000000000000L});
    public static final BitSet FOLLOW_62 = new BitSet(new long[]{0x0002000100000010L,0x0000000000080000L});
    public static final BitSet FOLLOW_63 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_64 = new BitSet(new long[]{0x2000000000000000L});
    public static final BitSet FOLLOW_65 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_66 = new BitSet(new long[]{0x4000000000000000L});
    public static final BitSet FOLLOW_67 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_68 = new BitSet(new long[]{0xAB036219100101F0L,0x00000000001107FCL});
    public static final BitSet FOLLOW_69 = new BitSet(new long[]{0x0492000100000010L,0x0000000000000003L});
    public static final BitSet FOLLOW_70 = new BitSet(new long[]{0x0092000100000012L,0x0000000000000002L});
    public static final BitSet FOLLOW_71 = new BitSet(new long[]{0x0092000100000010L,0x0000000000000002L});
    public static final BitSet FOLLOW_72 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_73 = new BitSet(new long[]{0xAB03E218100101F0L,0x00000000001107FCL});
    public static final BitSet FOLLOW_74 = new BitSet(new long[]{0xAB076218100101F0L,0x00000000001107FCL});
    public static final BitSet FOLLOW_75 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_76 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_77 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_78 = new BitSet(new long[]{0x0802000010000000L});
    public static final BitSet FOLLOW_79 = new BitSet(new long[]{0x0000400000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_80 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_81 = new BitSet(new long[]{0x00000000000000E0L});
    public static final BitSet FOLLOW_82 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_83 = new BitSet(new long[]{0x09004000000001E0L,0x00000000001000C0L});
    public static final BitSet FOLLOW_84 = new BitSet(new long[]{0x0804000000000000L});
    public static final BitSet FOLLOW_85 = new BitSet(new long[]{0x0800000000000002L});
    public static final BitSet FOLLOW_86 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_87 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000200L});
    public static final BitSet FOLLOW_88 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_89 = new BitSet(new long[]{0x0000100000000000L});
    public static final BitSet FOLLOW_90 = new BitSet(new long[]{0x0000100000000002L});
    public static final BitSet FOLLOW_91 = new BitSet(new long[]{0x00000000000000C0L});
    public static final BitSet FOLLOW_92 = new BitSet(new long[]{0x0006000100000010L});
    public static final BitSet FOLLOW_93 = new BitSet(new long[]{0x0000200000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_94 = new BitSet(new long[]{0x0000000000000000L,0x0000000000004000L});
    public static final BitSet FOLLOW_95 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
    public static final BitSet FOLLOW_96 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_97 = new BitSet(new long[]{0x0000000000000010L,0x0000000000200000L});
    public static final BitSet FOLLOW_98 = new BitSet(new long[]{0x0000000000000010L,0x0000000000400000L});
    public static final BitSet FOLLOW_99 = new BitSet(new long[]{0x0000002000000010L});

}